The Les Houche Accord Parton Density Function library - LHAPDF
==============================================================

Introdution.
===========
The Les Houches Accord Parton Density Function interface originated at the 
Les Houches 2001 workshop [1] in the PDF working group to enable the usage 
of Parton Density Functions with uncertainties in a uniform manner. 
When PDFs with uncertainties are considered, a ``fit'' to the data no longer 
is described by a single PDF. Instead in its most flexible implementation, 
a fit is represented by a PDF set consisting of many individual members. 
Calculating the observable for all the PDF members enables one to reconstruct 
the uncertainty on the observable. The LHAPDF interface was made with this 
in mind and manipulates PDF sets.

The LHAPDF interface can be viewed as a successor to PDFLIB [2]. 

Many improvements were added, to list some of the features:
    * The handling of PDF sets to enable PDF fits that include uncertainties.
    * All PDF sets are defined through external files in either parameterized or 
      grid form. The parameterized files are compact compared to the grid files, 
      but the latter allow faster usage when multiple PDF sets are called frequently 
      and also allow older PDF sets to be made available in LHAPDF. New PDF sets can 
      be defined by constructing the PDF defining parameter or grid files. The actual 
      LHAPDF code does not have to be changed unless, in the grid file case, the 
      authors of the PDFs use new interpolation methods.
    * The LHAPDF code is modular and default choices can be easily altered.

Note that the current ``best fit'' PDFs can be viewed as sets with one member 
PDF and can be easily defined through the PDF set external file definition. 
Alternatively one can group these ``fits'' is single sets (e.g. MRST98 set) as 
they often represent best fits given different model assumptions and as such 
reflect theoretical modeling uncertainties. 

Mailing List.
=============
A mailing list 'lhapdf-announce' has been set up to inform users of any 
changes and new versions of the LHAPDF library. If you would like to be on 
this list then please send a message to majordomo@cedar.ac.uk with the 
following words in the body of the message: 'subscribe lhapdf-announce'

You will receive by reply a message containing a subscribe string with a 
password which you should resend to majordomo@cedar.ac.uk to confirm the 
request.

(If you wish to subscribe a different mail address then use: 
'subscribe lhapdf-announce email@address ')

Downloading LHAPDF.
==================

From the LHAPDF web site ....http://projects.hepforge.org/lhapdf/

Installing LHAPDF.
=================

See the manual on the web site or the file INSTALL 
Simplest way is:

configure --prefix=/where/you/want/it/to/go/
make
make install

Interfacing LHAPDF with your code.
=================================

LHAPDF is written is standard Fortran77 with double precision variables and v5.3.0 
has been tested with the g77, f95 and gfortran compilers, and also with MacOSX. 

Interfacing can be done in one of two ways:

1) directly using the LHAPDF routines
2) using the LHAGLUE interace to LHAPDF which provides a PDFLIB type access.

The main LHAPDF routines are:

call InitPDFset(name)
call InitPDF(mem)
call evolvePDF(x,Q,f)
call evolvePDFp(x,Q2,P2,IP2,f)
function alphasPDF(Q)
call GetLam4(mem,qcdl4)
call GetLam5(mem,qcdl5)

The main LHAGLUE routines are:

call PDFSET(parm,value)
call STRUCTM(X,Q,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU)
call STRUCTP(X,Q2,P2,IP2,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU)
call PDFSTA

Details of how to use these and many others are available in the on line manual
on the LHAPDF web site -  http://projects.hepforge.org/lhapdf/


Interfacing LHAPDF with C++ code.
=================================

There is code within LHAPDF to interface with C++ programmes in the form of 
a wrapper LHAPDFWrap. The code is downloaded in the tarball and built into
a wrapper library in the make install procedure.  The wrapper code is also
available separately from the lhapdf web site http://projects.hepforge.org/lhapdf/

LHAPDFWrap 

FREE SOFTWARE. USE AT YOUR OWN RISK.

A C++ wrapper for the LHAPDF package.  Works with LHAPDFv2, v3.
Requires the gnu gcc compiler.

Adapted for LHAPDFv4 by Mike Whalley

INSTALLATION: 
- Unpack in a directory
- edit Makefile:
  LHAPDFDIR = "your path to libLHAPDF.a"
- edit test.cc and add the path to the member pdfs as distributed eg 
  ../PDFsets
- make
- ./test should give you some sample output for some pdf set

if all this works, you may just use the Makefile and test.cc as
templates in your own C++ programs.

WARNING!  Currently, the class is working fine if you work with only one
pdfset at a time.  Using two different sets via two different instances
of the LHAPDFWrap class is dangerous as they both point to the same
FORTRAN library in memory.

WHAT YOU HAVE TO DO: You have to reinitialise the pdfset all the time in
your code whenever you switch pdfsets.  That is cumbersome and may waste
computing time.


Stefan Gieseke (January 2005)

version 0: 	fairly cleaned up version.  Basic documentation.  Seen to
	     	work with LHAPDFv2, LHAPDFv3

version 0.1: 	Comment concerning two instances added to README

version 0.2:    Adapted by Mike Whalley for LHAPDFv4 

version 0.3:    Adapted by Craig Group/Mike Whalley for LHAPDFv5 

! -*- F90 -*-


      function eksarp(x,v2,x1,x116,ptm,indpi) 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      dimension ptm(10) 
                                                                        
      z=v2 
      xx=x-x1 
      if (x.le.x116) then 
         eksarp=ptm(1)+ptm(2)*z+ptm(3)*z**2+ptm(4)*xx+ptm(5)*xx**2 
         else 
            z1= log(x116/x1) 
            xx1=x116-x1 
            ff0=ptm(1)+ptm(2)*z1+ptm(3)*z1**2+ptm(4)*xx1+ptm(5)*xx1**2 
            xx16=x-x116 
            z16= log(x/x116) 
            qexp=19.d0+(indpi-1)*(indpi-2)*8.d0/2.d0 
            eksarp=ff0+ptm(6)*xx16+ptm(7)*xx16**2+ptm(8)*xx16**3        &
     &             +ptm(9)*xx16**qexp+ptm(10)*z16                       
      endif 
   11 return 
      END                                           

program example6

  ! Using lhaglue to do example 1
  implicit double precision (a-h,o-z)
  character*20 parm(20)
  !character name*64
  double precision value(20),df(-6:6)
  integer inset(3)
  !data inset/20200,391,231/ 
  data inset/20200,20201,231/ 
  character*20 lhaparm(20)
  double precision lhavalue(20)
  common/lhacontrol/lhaparm,lhavalue
  common/W50513/xmin,xmax,q2min,q2max
  !open(7,file='/home/whalley/lhapdf/lhanames')
  parm(1)='DEFAULT'
  lhaparm(19)='SILENT'
      
  ip2 = 0
  p2 = 0.0d0
  do ntimes=1,3
     do j=1,3
        value(1)=inset(j)
        write(*,*) '---------------------------------------------'
        call pdfset(parm,value)
        qmz = 91.187d0
        a = alphasPDF(qmz)
        call getlam4m(j,0,xlam4)
        call getlam5m(j,0,xlam5)
        print *,value(1),a,xmin,xmax,q2min,q2max,xlam4,xlam5
        !write(*,*) 'x*Gluon'
        !write(*,*) '   x     Q2=10 GeV     Q=100 GeV    Q=1000 GeV'
        do ix=10,95,10
           x = dfloat(ix)*1.0d-03
           Q=100.0d0
           if (value(1).ge.300.and.value(1).le.399) then
              call structp(x,q,p2,ip2,upv,dnv,usea,dsea,str,chm,bot,top,glu)
              g1=glu
           else
              ! call structm(x,q,upv,dnv,usea,dsea,str,chm,bot,top,glu)
              call pftopdg(x,q,df)
              g1=df(0)
           endif
           
           write(*,*) x,g1
        enddo
     enddo
  enddo

end program example6

!-----------------------------------------------------------------------
      SUBROUTINE DVZERO (A,N) 
!                                                                       
! CERN PROGLIB# F121    VZERO           .VERSION KERNFOR  4.40  940929  
! ORIG. 01/07/71, modif. 24/05/87 to set integer zero                   
!                 modif. 25/05/94 to depend on QINTZERO                 
!                                                                       
      implicit real*8 (a-h,o-z) 
      DIMENSION A(*) 
      IF (N.LE.0)  RETURN 
      DO 9 I= 1,N 
    9 A(I)= 0d0 
      RETURN 
      END                                           

! -*- F90 -*-


      subroutine ABFKWPevolve(xin,qin,pdf) 
      include 'parmsetup.inc' 
      PARAMETER(NX=50) 
      PARAMETER(NQ=19) 
      real*8 xin,qin,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      real*8 calcpi(8,20,25,3),calcpio(8,20,25),parpi(40,3) 
      common /ABFKWP/ CALCPI,CALCPIO,PARPI,lastmem 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
      save 
                                                                        
      iimem = imem 
      if(iimem.eq.0) iimem = 1 
      if(iimem.le.3) then 
       call ABFKWxx(iimem,xin,qin,upv,dnv,usea,dsea, str,chm,glu) 
      endif 
                                                                        
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= 0.0d0 
      pdf(5 )= 0.0d0 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv+usea 
      pdf(-1)= dsea 
      pdf(1 )= dnv+dsea 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ABFKWPread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
!      print *,nmem,ndef                                                
      lastmem = -999 
      do j=1,3 
        read(1,*)(parpi(k,j),k=1,4) 
        read(1,*)(parpi(k,j),k=5,8) 
        read(1,*)(parpi(k,j),k=9,12) 
        read(1,*)(parpi(k,j),k=13,16) 
        read(1,*)(parpi(k,j),k=17,20) 
        read(1,*)(parpi(k,j),k=21,24) 
        read(1,*)(parpi(k,j),k=25,28) 
        read(1,*)(parpi(k,j),k=29,32) 
        read(1,*)(parpi(k,j),k=33,36) 
        read(1,*)(parpi(k,j),k=37,40) 
        do l=1,25 
          do k=1,20 
            read(1,*)(CALCPI(m,k,l,j),m=1,4) 
            read(1,*)(CALCPI(m,k,l,j),m=5,8) 
          enddo 
        enddo 
      enddo 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ABFKWPalfa(alfas,qalfa) 
        call getnset(iset) 
        call GetOrderAsM(iset,iord) 
        call Getlam4M(iset,imem,qcdl4) 
        call Getlam5M(iset,imem,qcdl5) 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ABFKWPinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ABFKWPpdf(mem) 
      imem = mem 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!                                                                       
! $Id: wrapabfkwpi.f 443 2009-02-10 15:39:06Z buckley $                 
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:27:26  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:28:53  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
      SUBROUTINE ABFKWxx(imem,DX,DQ,DUPV,DDNV,DUSEA,DDSEA,DSTR,DCHM,DGL) 
      double precision                                                  &
     &       PARPI(40,3),CALCPI(8,20,25,3),CALCPIO(8,20,25),ZEROD,      &
     &       DX,DQ,DUPV,DDNV,DUSEA,DDSEA,DSTR,DCHM,DGL                  
      REAL    X, Q, UPV, DNV, USEA, DSEA, STR, CHM, GL 
                                                                        
      common /ABFKWP/CALCPI,CALCPIO,PARPI,lastmem 
                                                                        
!      COMMON/W5051Ixx/CALCPIO                                          
      REAL   XPDF(7) 
      DATA ZEROD/0.D0/ 
!---------------------------------------------------------------------- 
       DATA ISTART/0/ 
       SAVE ISTART,OWLAM2,Q02PI 
!                                                                       
      if(imem.ne.lastmem) then 
         istart = 0 
         lastmem = imem 
      endif 
      IF (ISTART.EQ.0) THEN 
        ISTART=1 
        DO 11 K=1,25 
        DO 11 I=1,20 
        DO 11 M=1,8 
   11   CALCPIO(M,I,K) = CALCPI(M,I,K,imem) 
           OWLAM=PARPI(1,imem) 
           OWLAM2=OWLAM**2 
           Q02PI=PARPI(39,imem) 
           Q2MAX=PARPI(40,imem) 
         ENDIF 
!                                                                       
! the conventions are : q(1)=x*u, q(2)=x*d, q(3)=x*str, q(4)=x*usea,    
!                       q(5)=x*dsea, q(6)=x*charm, q(7)=x*gluon         
!                                                                       
      X = DX 
      Q = DQ 
      Q2 = Q*Q 
      IDQ2=2 
      SB=0. 
      IF((Q2-Q02PI).LE.0) THEN 
        GOTO 1 
      ELSE 
        GOTO 2 
      ENDIF 
    2 IF((IDQ2-1).LE.0) THEN 
        GOTO 1 
      ELSE 
        GOTO 3 
      ENDIF 
    3 SB= LOG( LOG( MAX(Q02PI,Q2)/OWLAM2)/ LOG(Q02PI/OWLAM2)) 
    1 CALL AURPIx(1,0,X,SB,XPDF(1)) 
      CALL AURPIx(2,0,X,SB,XPDF(2)) 
      CALL AURPIx(3,0,X,SB,XPDF(3)) 
      CALL AURPIx(4,0,X,SB,XPDF(4)) 
      CALL AURPIx(5,0,X,SB,XPDF(5)) 
      CALL AURPIx(8,0,X,SB,XPDF(6)) 
      CALL AURPIx(7,0,X,SB,XPDF(7)) 
!                                                                       
      DUPV=XPDF(1) - XPDF(4) 
      DDNV=XPDF(2) - XPDF(5) 
      DUSEA=XPDF(4) 
      DDSEA=XPDF(5) 
      DSTR=XPDF(3) 
      DCHM=XPDF(6) 
      DGL =XPDF(7) 
!                                                                       
      RETURN 
      END                                           
!==============================================================         
!                                                                       
! $Id: wrapabfkwpi.f 443 2009-02-10 15:39:06Z buckley $                 
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:27:36  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:29:03  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
!                                                                       
      SUBROUTINE AURPIx(I,NDRV,X,S,ANS) 
      double precision                                                  &
     &       CALCPI(8,20,25,3),CALCPIO(8,20,25),parpi(40,3)             
      common /ABFKWP/CALCPI,CALCPIO,parpi,lastmem 
!      COMMON/W5051I4/CALCPIO                                           
      REAL   F1(25),F2(25) 
      DATA DELTA/.10/ 
      ANS=0. 
      IF(X.GT.0.9985) RETURN 
      IF(I.EQ.3.AND.X.GT.0.95) RETURN 
      IF(I.EQ.8.AND.X.GT.0.95) RETURN 
      IS=S/DELTA+1 
      IS1=IS+1 
      DO 1 L=1,25 
      KL=L+NDRV*25 
      F1(L)=CALCPIO(I,IS,KL) 
      F2(L)=CALCPIO(I,IS1,KL) 
    1 END DO 
      A1=AUGETFV(X,F1) 
      A2=AUGETFV(X,F2) 
      S1=(IS-1)*DELTA 
      S2=S1+DELTA 
      ANS=A1*(S-S2)/(S1-S2)+A2*(S-S1)/(S2-S1) 
      RETURN 
      END                                           
!===============================================================        
!                                                                       
! $Id: wrapabfkwpi.f 443 2009-02-10 15:39:06Z buckley $                 
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:27:34  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:29:02  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
!                                                                       
      FUNCTION AUGETFV(X,FVL) 
!  LOGARITHMIC INTERPOLATOR - WATCH OUT FOR NEGATIVE                    
!  FUNCTIONS AND/OR X VALUES OUTSIDE THE RANGE 0 TO 1.                  
!  NOTE: DIMENSION OF FVL IS OVERWRITTEN BY VALUE USED                  
!  IN MAIN ROUTINE.                                                     
      DIMENSION FVL(25),XGRID(25) 
      DATA NX,XGRID/25,.001,.002,.004,.008,.016,.032,.064,.1,.15,       &
     &.2,.25,.3,.35,.4,.45,.5,.55,.6,.65,.7,.75,.8,.85,.9,.95/          
      AUGETFV=0. 
      DO 1 I=1,NX 
      IF(X.LT.XGRID(I)) GOTO 2 
    1 END DO 
    2 I=I-1 
      IF(I.EQ.0) THEN 
         I=I+1 
      ELSE IF(I.GT.23) THEN 
         I=23 
      ENDIF 
      J=I+1 
      K=J+1 
      AXI= LOG(XGRID(I)) 
      BXI= LOG(1.-XGRID(I)) 
      AXJ= LOG(XGRID(J)) 
      BXJ= LOG(1.-XGRID(J)) 
      AXK= LOG(XGRID(K)) 
      BXK= LOG(1.-XGRID(K)) 
      FI= LOG(ABS(FVL(I)) +1.E-15) 
      FJ= LOG(ABS(FVL(J)) +1.E-16) 
      FK= LOG(ABS(FVL(K)) +1.E-17) 
      DET=AXI*(BXJ-BXK)+AXJ*(BXK-BXI)+AXK*(BXI-BXJ) 
      ALOGA=(FI*(AXJ*BXK-AXK*BXJ)+FJ*(AXK*BXI-AXI*BXK)+FK*(AXI*BXJ-AXJ* &
     & BXI))/DET                                                        
      ALPHA=(FI*(BXJ-BXK)+FJ*(BXK-BXI)+FK*(BXI-BXJ))/DET 
      BETA=(FI*(AXK-AXJ)+FJ*(AXI-AXK)+FK*(AXJ-AXI))/DET 
      IF(ABS(ALPHA).GT.99..OR.ABS(BETA).GT.99..OR.ABS(ALOGA).GT.99.)    &
     &RETURN                                                            
!      IF(ALPHA.GT.50..OR.BETA.GT.50.) THEN                             
!         WRITE(6,2001) X,FVL                                           
! 2001    FORMAT(8E12.4)                                                
!         WRITE(6,2001) ALPHA,BETA,ALOGA,DET                            
!      ENDIF                                                            
      AUGETFV=EXP(ALOGA)*X**ALPHA*(1.-X)**BETA 
      RETURN 
      END                                           

!****************************************************************************
!
!           EPS09.f
!
! An interface for the scale dependent nuclear modifications
!       R_f^A(x,Q) = f_A(x,Q)/f_p(x,Q) 
! where f_A is the distribution of the parton flavour f for a PROTON in a
! nucleus A, and f_p is the corresponding parton distribution in the 
! free proton.
!  
! When using this interface, please refer to:
!  
! K.J. Eskola, H. Paukkunen and C.A. Salgado,
! "EPS09 - a New Generation of NLO and LO Nuclear Parton Distribution Functions,"
! Published as JHEP04(2009) 065.
! Eprint: arXiv:0902.4154 [hep-ph].
!
! Questions & comments to:
!   hannu.paukkunen@phys.jyu.fi
!   kari.eskola@phys.jyu.fi
!   carlos.salgado@usc.es
! 
! ***************************************************************************
! Instructions:
!
! For given input values of
!
!     order: 1=LO, 2=NLO   ; integer
!     pset : 1...31        ; integer
!            1     = central fit
!            2,3   = error sets S{+1}, S{-1}
!            4,5   = error sets S{+2}, S{-2}
!            ...   ...
!            30,31 = error sets {S+15}, {S-15}
!     A    : atomic number ; integer
!     x    : Bjorken-x     ; double precision
!     Q    : scale in GeV  ; double precision
!
! the command 
!
!   Call EPS09(order, pset, A, x, Q, ruv, rdv, ru, rd, rs, rc, rb, rg)
!
! returns the bound proton nuclear corrections R_f^A(x,Q)
! (in double precision) for
!   
!   ruv = up valence
!   rdv = down valence
!   ru  = up sea
!   rd  = down sea
!   rs  = strange
!   rc  = charm
!   rb  = bottom
!   rg  = gluons
!
! The nuclear corrections for bound neutrons can be obtained
! by the isospin symmetry, e.g. the total up quark distribution
! per nucleon in a nucleus A with Z protons is
!
!  u_A(x,Q) =    Z/A * [ruv*uV_p(x,Q) + ru*uSea_p(x,Q)] +
!            (A-Z)/A * [rdv*dV_p(x,Q) + rd*dSea_p(x,Q)]
!
! Note that the parametrization should only be applied at the
! kinematical domain
!
!             1e-6 <= x <= 1
!              1.3 <= Q <= 1000 GeV.
!
! No warning message is displayed if these limits are
! exceeded, and outside these boundaries the modifications
! are frozen to the boundary values, i.e
!
!   for Q > 1000, the modifications at Q=1000 are returned,
!   for Q < 1.3,  the modifications at Q=1.3 are returned,
!   for x > 1,    the modifications at x=1 are returned
!   for x < 1e-6, the modifications at x=1e-6 are returned,
!
! The data used by the program for required order
! and atomic number A, are stored in separate files
!
!   LO : EPS09LOR_A
!   NLO: EPS09NLOR_A
!
! which must be located in the working directory.
!
! The error bands for absolute cross-sections and for
! their nuclear ratios should be computed as explained
! in Secs. 2.5 and 4 of arXiv:0902.4154 [hep-ph]. For
! the absolute cross sections, both the errors in the
! free-proton PDFs f_p(x,Q) and the errors in
! the modifications R_f^A(x,Q) should be accounted for.
! For the nuclear ratios, it is sufficient to account only
! for the errors in the modifications R_f^A(x,Q).
!
! *********************************************************
! *********************************************************



      Subroutine EPS09(order, pset, AAA, xxx, QQQ,ruv, rdv, ru, rd, rs, rc, rb, rg)

      Implicit none
      Double precision :: ruv, rdv, ru, rd, rs, rc, rb, rg, QQQ, xxx
      Double precision :: LSTEP, x, Q, Q2, allvalues(1:31,1:8,0:50,0:50)
      Double precision :: x_i=0.000001, arg(4), fu(4), res, fg(3)
      Double precision :: result(9), dummy
      Double precision :: realQ, Q2min=1.69, Q2max=1000000.0, Qsteps=50.0
      Double precision :: n_x, zero=0.0

      Character (Len=50) filenimi

      Integer :: xlinsteps=25, xlogsteps=25, startline, lineno
      Integer :: k, p, t, Qpoint, xpoint, pset, iovar
      Integer :: setnumber,j, A, openchannel, order, AAA
      Integer :: psetlast = -10, Alast = -10, orderlast = -10
 
      character*512 dirpath,setpath

      save Alast
      save psetlast
      save orderlast
      save allvalues

! *********************************************
! Stop if the set specifications are wrong ones
! *********************************************

      If (order .NE. 1 .and. order .NE. 2) then
      Write(*,*) 'Wrong order!'
      Write(*,*) 'LO : order = 1'
      Write(*,*) 'NLO: order = 2'
      Stop
      End If

      If (pset .LT. 1 .or. pset .GT. 31) then
      Write(*,*) 'Wrong set!'
      Write(*,*) 'Central set: pset = 1'
      Write(*,*) 'Error sets : pset = 2...31'
      Stop
      End If

! ********************************
! Make sure not to change any
! specifications given by the user
! ********************************

      A  = AAA
      x  = xxx
      Q  = QQQ
      Q2 = Q*Q 

! *******************************
! Freeze x if it's < 10E-6 or > 1
! *******************************

      If (x .LT. x_i) Then
      x = x_i
      End If
      If (x .GT. 1) Then
      x = 1.0
      End If

! ************************************
! Freeze Q^2 if it's < 1.69 or > 10E+6
! ************************************

      If (Q2 .LT. Q2min) Then
      Q2 = Q2min
      End If
      If (Q2 .GT. Q2max) Then
      Q2 = Q2max
      End If

! If the set specifications have been changed, read the tables again

      If (A .NE. Alast .or. order .NE. orderlast) Then

!      Write(*,*) 'Set changed!'

! Read the table1

      If (order .EQ. 1) then

        If (A < 10) Then
        Write(filenimi,'("EPS09LOR_", I1)'), A
        Else If (A < 100) Then
        Write(filenimi,'("EPS09LOR_", I2)'), A
        Else If (A < 1000) Then
        Write(filenimi,'("EPS09LOR_", I3)'), A
        End If

      Else

        If (A < 10) Then
        Write(filenimi,'("EPS09NLOR_", I1)'), A
        Else If (A < 100) Then
        Write(filenimi,'("EPS09NLOR_", I2)'), A
        Else If (A < 1000) Then
        Write(filenimi,'("EPS09NLOR_", I3)'), A
        End If

      End If

      call getdirpath(dirpath) 
      setpath=dirpath(:LEN_TRIM(dirpath))//"/"//filenimi(:LEN_TRIM(filenimi))//".LHgrid"
      print *,setpath(:LEN_TRIM(setpath))
      OPEN (11, file = setpath(:LEN_TRIM(setpath)), status='OLD', IOSTAT=iovar)

      If (iovar .NE. 0) Then
      Write(*,*) 'Missing file: ',filenimi
      stop
      End If

      Do setnumber = 1, 31

      Do k = 0,50

      Read(11,*) dummy

      Do t = 0,50

      Read(11,*) (allvalues(setnumber,p,k,t), p=1,8)

      End Do
      End Do

      End Do

      Close(11)

      psetlast  = pset
      Alast     = A
      orderlast = order

      End If

! Find out the position in the loglog Q^2-grid

      realQ  = Qsteps * (log(log(Q2)/log(Q2min)))/(log(log(Q2max)/log(Q2min)))
      Qpoint = Aint(realQ)

      If (Qpoint .LE. 0) Then
         Qpoint = 1
      End If
      If (Qpoint .GE. Anint(Qsteps)-1) Then
         Qpoint = Anint(Qsteps)-1
      End If

      LSTEP = (1.0/(xlogsteps)) * LOG(0.1/x_i)

! *********************
! Interpolate the grids 
! *********************

      Do t=1,8

! Find the position in the x-grid

      If (x .LE. 0.1) then
         n_x  = ((1.0/LSTEP) * Log(x/x_i))
       xpoint = Aint(n_x)
      Else
       n_x    = ((x-0.1)*xlinsteps/(1.0-0.1) + xlogsteps)
       xpoint = Aint(n_x)
      End If

      If (xpoint .LE. 0) Then
        xpoint = 1
      End If

      If (t .EQ. 1 .or. t .EQ. 2) Then
         If (xpoint .GE. (xlinsteps+xlogsteps)-4) Then
         xpoint = (xlinsteps+xlogsteps)-4
         End If
      End If

      If (t .EQ. 3 .or. t .EQ. 4 .or. t .EQ. 5 .or. t .EQ. 6 .or. t .EQ. 7) Then
        If (xpoint .GE. (xlinsteps+xlogsteps)-7) Then
        xpoint = (xlinsteps+xlogsteps)-7
        End If
      End If
	
      If (t .EQ. 8) Then
        If (xpoint .GE. (xlinsteps+xlogsteps)-4) Then
        xpoint = (xlinsteps+xlogsteps)-4
        End If
      End If

      Do k = 1, 4
      If (xpoint-2+k .LT. xlogsteps) Then
      arg(k) = (x_i) * exp(LSTEP * (xpoint-2+k))
      Else
      arg(k) = 0.1 + (xpoint-2+k-xlogsteps) * (1-0.1)/xlinsteps
      End If
      End Do
 
      Do j=1,3

      fu(1) = allvalues(pset,t,Qpoint-2+j,xpoint-1)
      fu(2) = allvalues(pset,t,Qpoint-2+j,xpoint)
      fu(3) = allvalues(pset,t,Qpoint-2+j,xpoint+1)
      fu(4) = allvalues(pset,t,Qpoint-2+j,xpoint+2)
      Call luovi(fu,arg,4,x,res)
      fg(j) = res

! *****************************************
! *****************************************

      End Do

      arg(1) = Qpoint-1
      arg(2) = Qpoint
      arg(3) = Qpoint+1

      Call luovi(fg,arg,3,realQ,res)
  
      result(t) = res

      End Do

      ruv = max(result(1),zero)
      rdv = max(result(2),zero)
      ru  = max(result(3),zero)
      rd  = max(result(4),zero)
      rs  = max(result(5),zero)
      rc  = max(result(6),zero)
      rb  = max(result(7),zero)
      rg  = max(result(8),zero)

200   Continue

      End Subroutine EPS09

! ********************************
! Modified version of Cern Library
! interpolation routine E100
! ********************************

      SUBROUTINE luovi(F,ARG,MMM,Z,SUM)

      Implicit none
      INTEGER :: MMM
      Double precision  :: F(MMM), ARG(MMM), COF(MMM), SUM, Z
      INTEGER :: M, MM, I, J, JNDEX, INDEX

      MM = MIN(MMM, 20)
      M = MM - 1
      DO 1780 I= 1, MM
      COF(I) = F(I)
 1780 Continue
      DO 1800 I= 1, M
      DO 1790 J= I, M
         JNDEX = MM - J
         INDEX = JNDEX + I
         COF(INDEX) = (COF(INDEX)-COF(INDEX-1))/(ARG(INDEX)-ARG(JNDEX))
 1790 CONTINUE
 1800 CONTINUE
      SUM = COF(MM)
      DO 1810 I= 1, M
         INDEX = MM - I
         SUM = (Z-ARG(INDEX))*SUM + COF(INDEX)
 1810 CONTINUE

      End SUBROUTINE luovi

program example1
  implicit double precision (a-h,o-z)
  character name*64
  double precision f(-6:6)
  character*20 lparm
  logical has_photon
  Dimension Z(10), XX(10)
  Data (Z(I), I=1,10) /.05, .1, .2, .3, .4, .5, .6, .7, .8, .9/

  Do I = 1, 10
     XX(I) = Z(I) **3
  EndDo

  name='CT10nlo.LHgrid'
  ! name='cteq6.LHgrid'
  ! name='cteq65.LHgrid'
  ! name='cteq66.LHgrid'
  ! name='MRST2006nnlo.LHgrid'
  ! name='MRST2001E.LHgrid'
  ! name='H12000ms.LHgrid'
  call InitPDFsetByName(name)

  QMZ=91.18d0
  write(*,*)
  call numberPDF(N)
  print *,'There are ',N,' PDF sets'
  do i=0,N
     write(*,*) '---------------------------------------------'
     call InitPDF(i)
     write(*,*) 'PDF set ',i
     call GetXmin(i,xmin)
     call GetXmax(i,xmax)
     call GetQ2min(i,q2min)
     call GetQ2max(i,q2max)
     print *,'xmin=',xmin,' xmax=',xmax,' Q2min=',q2min,' Q2max=',q2max
     call GetMinMax(i,xmin,xmax,q2min,q2max)
     print *,'xmin=',xmin,' xmax=',xmax,' Q2min=',q2min,' Q2max=',q2max
     call setlhaparm('EXTRAPOLATE') !< These work, but have no effect
     call getlhaparm(18,lparm) !< These work, but have no effect
     print *,'lhaparm(18)=',lparm
     write(*,*)
     a=alphasPDF(QMZ)
     write(*,*) 'alpha_S(M_Z) = ',a
     call getLam4M(1,i,xlam4)
     call getLam5M(1,i,xlam5)
     print *,' lambda5: ',xlam5, ' lambda4: ',xlam4
     write(*,*)
     write(*,*) 'x*up'
     write(*,*) '   x     Q=10 GeV     Q=100 GeV    Q=1000 GeV'
     ! q2 = 10.0d0
     ! q = dsqrt(q2)
     q = 50.0d0
     print *,q
     do ix=1,10
        ! x = (ix-0.5d0)/10.0d0
        x = xx(ix)
        ! x = z(ix)
        if(has_photon()) then
          print *,"This set has a photon"
          call evolvePDFphoton(x,Q,f,photon)
        else
          call evolvePDF(x,Q,f)
        endif
        g = f(0)
        u = f(2)
        d = f(1)
        s = f(3)
        c = f(4)
        b = f(5)
        ubar = f(-2)
        dbar = f(-1)
        sbar = f(-3)
        cbar = f(-4)
        bbar = f(-5)
        write(*,'(F7.4,13(1pE10.3))') x,u,d,ubar,Dbar,s,sbar,c,cbar,b,bbar,g,photon
     enddo
  enddo

end program example1

!***********************************************                        
!                                                                       
!                                                                       
!     wrapNNPDFgrid-lite.f 
!     Special low-memory version with only single fit ....                                                  
!     Routine called by LHAPDF package for calculating                  
!     the value of all xpdfs at x and Q from replica KREP               
!     in a (x,Q) point as called by NNPDF.LHgrid file.                  
!                                                                       
!     In 'wrapevolve.f' the package calls:                              
!     IF(NAME(NSET).EQ.'NNPDFint') call NNPDFINTevolve(x,Q,f)           
!     IF(NAME(NSET).EQ.'NNPDFint') call NNPDFINTread(nset)              
!     IF(NAME(NSET).EQ.'NNPDFint') call NNPDFINTalfa(alfas,Q)           
!     IF(NAME(NSET).EQ.'NNPDFint') call NNPDFINTinit(nset,Eorder,Q2fit)*
!                                                                       
!***********************************************                        
                                                                        
                                                                        
      subroutine NNPDFINTevolve(X,Q,XPDF) 
      IMPLICIT none 
!                                                                       
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      character*80 line 
      character*512 setpath 
      integer nmem(nmxset),ndef(nmxset),mmem,mem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset,iset,pdfmem 
      real*8 parm(nopmax) 
      real*8 tmp(13)
!                                                                       
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
!                                                                       
      INTEGER order 
      REAL*8 alfas,alphaNNPDF 
      REAL*8 Eorder,Q2fit,mass 
!                                                                       
      INTEGER MXREP 
      PARAMETER(MXREP=nmxset-1) 
      INTEGER NREP 
      common/nnpdf10CNREP/NREP 
!                                                                       
      INTEGER NX,NQ2,NPL 
      PARAMETER(NX=60,NQ2=50) 
      PARAMETER(NPL=3000) 
      INTEGER NXX,NQQ2 
      REAL*8 Q2MIN,Q2MAX,XPDFMIN,XPDFMAX 
      REAL*8 XG(NX,nmxset),Q2G(NQ2,nmxset),XPDFEV(NX,NQ2,-6:6,0:MXREP) 
      INTEGER IX,IQ2 
      common/nnpdf10CPDFGR/XPDFEV,XG,Q2G,IX,IQ2 
!                                                                       
      INTEGER ipt,imodev,ivfn,itmc 
      COMMON/NNPDF10EVFLAGS/ipt,imodev,ivfn,itmc 
      REAL*8 q0,alfas0 
      REAL*8 q20,qth(4:6) 
      COMMON/nnpdf10EVSCALE/q20,q2 
      REAL*8 q2th(4:6),asref,q2ref 
      COMMON/nnpdf10vfns/q2th,asref,q2ref 
!                                                                       
      INTEGER I,J,K 
      INTEGER IPDF,KREP,LH_JISEARCH,IINTERP 
      INTEGER IDUM,JDUM 
      REAL*8 X,Q,QQ,Q2,QQ2,XPDF(-6:6) 
      REAL*8 AXB(NX,NQ2,-6:6), BXB(NX,NQ2,-6:6) 
      REAL*8 CXB(NX,NQ2,-6:6),TQ,DX 
      REAL*8 XPDF1(-6:6),XPDF2(-6:6) 
      REAL*8 XCH 
      PARAMETER(XCH=1D-1) 
!                                                                       
      integer m,n,nmax,mmax 
                                ! order of pol. interpolation           
      parameter(m=4,n=4) 
      parameter(nmax=1e3,mmax=1e3) 
      double precision dy,x1,x2,y,x1a(mmax),x2a(nmax),ya(mmax,nmax) 
      integer ix1a(m),ix2a(n) 
!                                                                       
!
!      KREP = mmem 
! always use the 0 element in this lite version
      KREP = 0 
!     Set correct scale                                                 
      Q2=Q**2d0 
                                      
      call getnset(iset)
                                                                        
!     Check kinematic point is within allowed range                     
                                                                        
      call GetXminM(iset,KREP,XPDFMIN) 
      call GetXmaxM(iset,KREP,XPDFMAX) 
      call GetQ2maxM(iset,KREP,Q2MAX) 
      call GetQ2minM(iset,KREP,Q2MIN) 
!                                                                       
      IF ( X.LT.XPDFMIN .OR. X.GT.XPDFMAX ) THEN 
         WRITE(6,2000) 
 2000    FORMAT (2X,'PARTON INTERPOLATION: X OUT OF RANGE -- STOP') 
         write(6,*) "X= ",X," XMAX, XMIN = ",XPDFMAX,XPDFMIN 
      ENDIF 
!                                                                       
      IF ( Q2.LT.Q2MIN .OR. Q2.GT.Q2MAX ) THEN 
         WRITE(6,2001) 
 2001    FORMAT (2X,'PARTON INTERPOLATION: Q2 OUT OF RANGE -- STOP') 
         write(6,*) "Q2 ,Q2MIN, Q2MAX = ",Q2,Q2MIN,Q2MAX 
      ENDIF 
                                                                        
!     Select higher-order polynomial interpolation                      
                                                                        
      IINTERP = 1 
!                                                                       
      if(IINTERP.eq.0) then 
!                                                                       
!     CUBIC SPLINE INTERPOLATION, LOG(Q2): LINEAR INTERPOLATION         
!                                                                       
!     spline coefficients                                               
         DO IPDF = -6,6,1 
            DO IQ2 = 1,NQ2 
!               CALL LH_JSPLINE(AXB,BXB,CXB,IPDF,IQ2,KREP) 
               CALL LH_JSPLINE(AXB,BXB,CXB,IPDF,IQ2,KREP+iset-1) 
            ENDDO 
         ENDDO 
                                                                        
!     Binary search of points in grid                                   
         IQ2 = LH_JISEARCH(NQ2,Q2G(1,iset),Q2) 
         IF (IQ2 .EQ. NQ2) IQ2 = NQ2-1 
         IX = LH_JISEARCH(NX,XG(1,iset),X) 
         DX = X - XG(IX,iset) 
                                                                        
!     Compute the values of xpdfs for two neighbouring values of Q2     
!     using splines of order 3                                          
                                                                        
         DO IPDF = -6,6,1 
            XPDF1(IPDF) = XPDFEV(IX,IQ2,IPDF,KREP+iset-1)                      &
     &           + DX*(AXB(IX,IQ2,IPDF) + DX*(BXB(IX,IQ2,IPDF)          &
     &           + DX*CXB(IX,IQ2,IPDF)) )                               
            XPDF2(IPDF) = XPDFEV(IX,IQ2+1,IPDF,KREP+iset-1)                    &
     &           + DX*(AXB(IX,IQ2+1,IPDF) + DX*(BXB(IX,IQ2+1,IPDF)      &
     &        + DX*CXB(IX,IQ2+1,IPDF)) )                                
         ENDDO 
                                                                        
!     Linear interpolation in log Q2                                    
                                                                        
         TQ = (DLOG(Q2)-DLOG(Q2G(IQ2,iset)))                                 &
     &        / (DLOG(Q2G(IQ2+1,iset))-DLOG(Q2G(IQ2,iset)))                       
!                                                                       
         DO IPDF = -6,6,1 
            XPDF(IPDF)  = (1.0D0-TQ)*XPDF1(IPDF) + TQ*XPDF2(IPDF) 
         ENDDO 
                                                                        
                                                                        
      elseif(IINTERP.eq.1) then 
!                                                                       
         IQ2 = LH_JISEARCH(NQ2,Q2G(1,iset),Q2) 
         IF (IQ2 .EQ. NQ2) IQ2 = NQ2-1 
         IX = LH_JISEARCH(NX,XG(1,iset),X) 
                                                                        
!     Assign grid for interpolation. M, N -> order of polyN interpolatio
                                                                        
         do I=1,M 
            if(IX.ge.M/2.and.IX.le.(NX-M/2)) IX1A(I) = IX - M/2 + I 
            if(IX.lt.M/2) IX1A(I) = I 
            if(IX.gt.(NX-M/2)) IX1A(I) = (NX - M) + I 
                                                                        
!     Check grids                                                       
            if(IX1A(I).le.0.or.IX1A(I).gt.NX) then 
               write(6,*) "Error in grids" 
               write(6,*) "I, IXIA(I) = ",I, IX1A(I) 
               call exit(-10) 
            endif 
         enddo 
                                                                        
         do J=1,N 
            if(IQ2.ge.N/2.and.IQ2.le.(NQ2-N/2)) IX2A(J) = IQ2 - N/2 + J 
            if(IQ2.lt.N/2) IX2A(J) = J 
            if(IQ2.gt.(NQ2-N/2)) IX2A(J) = (NQ2 - N) + J 
!     Check grids                                                       
            if(IX2A(J).le.0.or.IX2A(J).gt.NQ2) then 
               write(6,*) "Error in grids" 
               write(6,*) "J, IXIA(J) = ",J,IX2A(J) 
               call exit(-10) 
            endif 
         enddo 
                                                                        
!     uncomment for 3rd order interp.                                   
                                                                        
!         IQ2 = LH_JISEARCH(NQ2,Q2G,Q2)                                 
!         IX  = LH_JISEARCH(NX,XG,X)                                    
!         IF((IX+(M-1)/2).GT.NX) IX = NX - (M-1)/2                      
!         IF((IX-(M-1)/2).LT.1) IX = (M+1)/2                            
!         IDUM = 0                                                      
!         DO I = -(M-1)/2,(M-1)/2,1                                     
!            IDUM = IDUM +1                                             
!            IX1A(IDUM) = IX + I                                        
!         ENDDO                                                         
                                                                        
!         IF((IQ2+(N-1)/2).GT.NQ2) IQ2 = NQ2 - (N-1)/2                  
!         IF((IQ2-(N-1)/2).LT.1) IQ2 = (N+1)/2                          
                                                                        
!         JDUM = 0                                                      
!         DO J = -(N-1)/2,(N-1)/2,1                                     
!            JDUM = JDUM +1                                             
!            IX2A(JDUM) = IQ2 + J                                       
!         ENDDO                                                         
!                                                                       
!     Define points where to evaluate interpolation                     
!     Choose between linear or logarithmic (x,Q2) interpolation         
                                                                        
         IF(X.LT.XCH)THEN 
            X1=dlog(X) 
         ELSE 
            X1=X 
         ENDIF 
         X2=dlog(Q2) 
                                                                        
         DO IPDF = -6,6,1 
                                                                        
!     Choose between linear or logarithmic (x,Q2) interpolation         
                                                                        
            DO I=1,M 
               IF(X.LT.XCH)THEN 
                  X1A(I)= dlog(XG(IX1A(I),iset)) 
               ELSE 
                  X1A(I)= XG(IX1A(I),iset) 
               ENDIF 
               DO J=1,N 
                  X2A(J) = dlog(Q2G(IX2A(J),iset)) 
                  YA(I,J) = XPDFEV(IX1A(I),IX2A(J),IPDF,KREP+iset-1) 
               enddo 
            enddo 
                                                                        
!     2D polynomial interpolation                                       
            call lh_polin2(x1a,x2a,ya,m,n,x1,x2,y,dy) 
            XPDF(IPDF) = y 
                                                                        
         enddo 
      endif 
!                                                                       
      RETURN 
                                                                        
!********************************************************               
      entry NNPDFINTgetgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=1,nx
          gridx(jx)=xg(jx,nset)
      enddo
      do jq=1,nq2
          gridq(jq)=q2g(jq,nset)
      enddo
      ngridx=nx
      ngridq=nq2        
      return
!********************************************************               
                                                                        
      ENTRY NNPDFINTread(nset) 
!                                                                       
      READ(1,*)nmem(nset),ndef(nset) 
                                                                        
!     Set number of members                                             
      call setnmem(nset,nmem) 
                                                                        
!     Read the grid in x                                                
      READ(1,*) nxx 
      IF(NXX.NE.NX)WRITE(*,*)"WARNING CHANGE NX ACCORDING TO .LHgrid"
      DO ix = 1,nxx 
         READ(1,*) xg(ix,nset) 
      ENDDO 
                                                                        
!     Read the grid in Q2                                               
      READ(1,*) nqq2 
      IF(NQQ2.NE.NQ2)WRITE(*,*)"WARNING CHANGE NQ2 ACCORDING TO .LHgrid"
      READ(1,*) q2min 
      DO iq2 = 1,nqq2 
         READ(1,*) q2g(iq2,nset) 
      ENDDO 
                                                                        
!     Read the number of replicas                                       
      READ(1,*) NREP 
                                                                        
! - dummy read in to get to End: (stream 1 is still open)               
      DO K=0,NREP 
         DO IX=1,NX 
            DO IQ2=1,NQ2 
               READ(1,'(a)') line 
            ENDDO 
         ENDDO 
      ENDDO 
!                                                                       
      RETURN 
                                                                        
!********************************************************               
                                                                        
      ENTRY NNPDFINTalfa(alfas,Q) 
!                                                                       
      QQ = Q 
      alfas =  alphaNNPDF(QQ) 
!                                                                       
      RETURN 
                                                                        
!********************************************************               
                                                                        
      ENTRY NNPDFINTinit(nset,Eorder,Q2fit) 
!                                                                       
      IMODEV = 0 
      IVFN = 1 
      ITMC = 1 
!                                                                       
      CALL GetOrderPDFM(nset,order) 
      IPT = order 
!                                                                       
      CALL GetQ2fitM(nset,QQ2) 
      Q2fit = QQ2 
      Q20   = QQ2 
!                                                                       
      call GetQmassM(nset,4,mass) 
      QTH(4) = mass 
      call GetQmassM(nset,5,mass) 
      QTH(5) = mass 
      call GetQmassM(nset,6,mass) 
      QTH(6) = mass 
!                                                                       
      DO i = 4,6 
         q2th(i) = qth(i)**2d0 
      ENDDO 
!                                                                       
                                    ! added for filling Fparm->asref    
      call initEVOLVEpdf(nset,mmem) 
      CALL GetAlfas(nset,alfas0,Q0) 
      asref = alfas0 
      q2ref = q0**2d0 
!                                                                       
      RETURN 
                                                                        
!********************************************************               
!                                                                       
      entry NNPDFINTpdf(mem)
! have to reopen stream 1
        call getnset(iset)                                               
        call setnmem(iset,mem) 
   
        call getsetpath(setpath) 
        open(1,file=setpath(1:len_trim(setpath)),action='READ') 
        line = '' 
	
        do while (line(3:12).ne.'Evolution:') 
           read(1,'(a)')line
        enddo 
        read(1,'(a)')line 
        read(1,'(a)')line 
!                                                                       
      READ(1,*)nmem(iset),ndef(iset) 
      pdfmem = mem 
      IF (pdfmem.LT.0) THEN 
         WRITE(*,*) 'NNPDF set:' 
         WRITE(*,*) 'PDF member out of range:' 
         WRITE(*,*) 'member = ',pdfmem 
         STOP 
      ENDIF 
                                                                        
!     Read the grid in x                                                
      READ(1,*) nxx 
      IF(NXX.NE.NX)WRITE(*,*)"WARNING CHANGE NX ACCORDING TO .LHgrid"
      DO ix = 1,nxx 
         READ(1,*) xg(ix,iset) 
      ENDDO 
                                                                        
!     Read the grid in Q2                                               
      READ(1,*) nqq2 
      IF(NQQ2.NE.NQ2)WRITE(*,*)"WARNING CHANGE NQ2 ACCORDING TO .LHgrid"
      READ(1,*) q2min 
      DO iq2 = 1,nqq2 
         READ(1,*) q2g(iq2,iset) 
      ENDDO 
                                                                        
!     Read the number of replicas                                       
      READ(1,*) NREP 
                                                                        
! - dummy read up rto the member requested               

      DO K=0,mem-1 
         DO IX=1,NX 
            DO IQ2=1,NQ2 
               READ(1,'(a)') line 
            ENDDO 
         ENDDO 
      ENDDO 


!- read in the data of the requested member 
      DO IX=1,NX 
         DO IQ2=1,NQ2 
            READ(1,*) tmp
            DO ipdf=-6,6,1
               xpdfev(ix,iq2,ipdf,iset-1) = tmp(ipdf+7)
            ENDDO
         ENDDO 
      ENDDO

!                                                                       
      close(1) 
      RETURN 
        
      END                                           
                                                                        
                                                                        
!****************************************************************       
!                                                                       
! CALCULATE THE COEFFICIENTS B,C,D IN A CUBIC SPLINE INTERPOLATION.     
! INTERPOLATION SUBROUTINES ARE TAKEN FROM                              
! G.E. FORSYTHE, M.A. MALCOLM AND C.B. MOLER,                           
! COMPUTER METHODS FOR MATHEMATICAL COMPUTATIONS (PRENTICE-HALL, 1977). 
!                                                                       
! SUBROUTINE TAKEN FROM AAC GROUP (KUMANO et al.)                       
!                                                                       
!*******************************************************************    
!                                                                       
      SUBROUTINE LH_JSPLINE(B,C,D,I,J,KREP) 
      IMPLICIT none 
      include 'parmsetup.inc' 
!                                                                       
      INTEGER MXREP 
      PARAMETER(MXREP=nmxset-1) 
      INTEGER NREP 
      common/nnpdf10CNREP/NREP 
!                                                                       
      INTEGER NX,NQ2,NPL,IX,IQ2 
      PARAMETER(NX=60,NQ2=50) 
      PARAMETER(NPL=3000) 
      REAL*8 XG(NX,nmxset),Q2G(NQ2,nmxset),XPDFEV(NX,NQ2,-6:6,0:MXREP) 
      common/nnpdf10CPDFGR/XPDFEV,XG,Q2G,IX,IQ2 
!                                                                       
      INTEGER I,J,NM1,K,IB,KREP 
      REAL*8 B,C,D,T 
      DIMENSION B(NX,NQ2,-6:6), C(NX,NQ2,-6:6), D(NX,NQ2,-6:6) 
      integer iset
!                                                                       
      call getnset(iset)
      NM1=NX-1 
      IF(NX.LT.2) RETURN 
      IF(NX.LT.3) GOTO 250 
      D(1,J,I)=XG(2,iset)-XG(1,iset) 
      C(2,J,I)=(XPDFEV(2,J,I,KREP)-XPDFEV(1,J,I,KREP))/D(1,J,I) 
      DO 210 K=2,NM1 
         D(K,J,I)=XG(K+1,iset)-XG(K,iset) 
         B(K,J,I)=2.0D0*(D(K-1,J,I)+D(K,J,I)) 
         C(K+1,J,I)=(XPDFEV(K+1,J,I,KREP)-XPDFEV(K,J,I,KREP))/D(K,J,I) 
         C(K,J,I)=C(K+1,J,I)-C(K,J,I) 
  210 END DO 
      B(1,J,I)=-D(1,J,I) 
      B(NX,J,I)=-D(NX-1,J,I) 
      C(1,J,I)=0.0D0 
      C(NX,J,I)=0.0D0 
      IF(NX.EQ.3) GOTO 215 
      C(1,J,I)=C(3,J,I)/(XG(4,iset)-XG(2,iset))-C(2,J,I)/(XG(3,iset)-XG(1,iset)) 
      C(NX,J,I)=C(NX-1,J,I)/(XG(NX,iset)-XG(NX-2,iset))                           &
     &     -C(NX-2,J,I)/(XG(NX-1,iset)-XG(NX-3,iset))                             
      C(1,J,I)=C(1,J,I)*D(1,J,I)**2.0D0/(XG(4,iset)-XG(1,iset)) 
      C(NX,J,I)=-C(NX,J,I)*D(NX-1,J,I)**2.0D0/(XG(NX,iset)-XG(NX-3,iset)) 
  215 CONTINUE 
      DO 220 K=2,NX 
         T=D(K-1,J,I)/B(K-1,J,I) 
         B(K,J,I)=B(K,J,I)-T*D(K-1,J,I) 
         C(K,J,I)=C(K,J,I)-T*C(K-1,J,I) 
  220 END DO 
      C(NX,J,I)=C(NX,J,I)/B(NX,J,I) 
      DO 230 IB=1,NM1 
         K=NX-IB 
         C(K,J,I)=(C(K,J,I)-D(K,J,I)*C(K+1,J,I))/B(K,J,I) 
  230 END DO 
      B(NX,J,I)=(XPDFEV(NX,J,I,KREP)-XPDFEV(NM1,J,I,KREP))/D(NM1,J,I)   &
     &     +D(NM1,J,I)*(C(NM1,J,I)+2.0D0*C(NX,J,I))                     
      DO 240 K=1,NM1 
         B(K,J,I)=(XPDFEV(K+1,J,I,KREP)-XPDFEV(K,J,I,KREP))/D(K,J,I)    &
     &        -D(K,J,I)*(C(K+1,J,I)+2.0D0*C(K,J,I))                     
         D(K,J,I)=(C(K+1,J,I)-C(K,J,I))/D(K,J,I) 
         C(K,J,I)=3.0D0*C(K,J,I) 
  240 END DO 
      C(NX,J,I)=3.0D0*C(NX,J,I) 
      D(NX,J,I)=D(NX-1,J,I) 
      RETURN 
  250 CONTINUE 
      B(1,J,I)=(XPDFEV(2,J,I,KREP)-XPDFEV(1,J,I,KREP))/(XG(2,iset)-XG(1,iset)) 
      C(1,J,I)=0.0D0 
      D(1,J,I)=0.0D0 
      B(2,J,I)=B(1,J,I) 
      C(2,J,I)=0.0D0 
      D(2,J,I)=0.0D0 
      RETURN 
      END                                           
!                                                                       
!***********************************************************************
!     THIS FUNCTION SEARCHES "I" WHICH SATISFIES THE RELATION           
!     X(I) <= Y < X(I+1) BY USING A BINARY SEARCH.                      
!                                                                       
!     FUNCTION TAKEN FROM AAC GROUP (KUMANO et al.)                     
!***********************************************************************
                                                                        
      INTEGER FUNCTION LH_JISEARCH(N,X,Y) 
!                                                                       
      IMPLICIT REAL*8(A-H,O-Z) 
!     Dynamical memory allocation                                       
      REAL*8 X(*) 
!                                                                       
      MIN=1 
      MAX=N+1 
!                                                                       
   10 CONTINUE 
      MID=(MIN+MAX)/2 
      IF(Y.LT.X(MID)) THEN 
        MAX=MID 
      ELSE 
        MIN=MID 
      END IF 
      IF((MAX-MIN).GT.1) GOTO 10 
!                                                                       
      LH_JISEARCH=MIN 
!                                                                       
      RETURN 
      END                                           
                                                                        
!****************************************************                   
!                                                                       
!     polin2.f                                                          
!                                                                       
!     2D interpolation of arbitrary polinomial order                    
!     Uses polint                                                       
!     Given arrays x1a(1:m) and x2a(1:n) of independent variables,      
!     and an m by n array of function values ya(1:m,1:n) tabulated      
!     at the grid points defined by x1a,x2a; and given values x1,x2     
!     of the independent variable, this routine returns                 
!     an interpolated function value y with error dy                    
!                                                                       
!     Taken from NR fortran                                             
!                                                                       
!****************************************************                   
                                                                        
      subroutine lh_polin2(x1a,x2a,ya,m,n,x1,x2,y,dy) 
      implicit none 
!                                                                       
      integer m,n,nmax,mmax 
      integer j,k 
      parameter(nmax=1e3,mmax=1e3) 
                                                                        
      real*8 dy,x1,x2,y,x1a(mmax),x2a(nmax),ya(mmax,nmax) 
      real*8 ymtmp(nmax),yntmp(nmax) 
                                                                        
      do j=1,m 
         do k=1,n 
            yntmp(k)=ya(j,k) 
         enddo 
         call lh_polint(x2a,yntmp,n,x2,ymtmp(j),dy) 
      enddo 
      call lh_polint(x1a,ymtmp,m,x1,y,dy) 
!                                                                       
      return 
      END                                           
                                                                        
!**********************************************                         
!                                                                       
!     polint.f                                                          
!                                                                       
!     Order N polynomial interpolation using Lagrange's formula         
!     as descrived in Numerical Recipees:                               
!     Given arrays xa and ya each of length n, and given a value        
!     x, this routine returns a value y and an error estimate dy.       
!     If P(x) is the polynomial of degree N-1 such that                 
!     P(xa_i)=ya_i,i=1,...,n, then the returned value is y=P(x)         
!     The algorithm used is Neville's algorithm                         
!                                                                       
!******************************************************                 
                                                                        
      subroutine LH_POLINT(xa,ya,n,x,y,dy) 
      implicit none 
!                                                                       
      integer n,NMAX 
!     Largest anticipated value of n                                    
      parameter(nmax=1e3) 
      real*8 dy,x,y,xa(nmax),ya(nmax) 
      integer i,m,ns 
      real*8 den,dif,dift,ho,hp,w,c(nmax),d(nmax) 
      ns=1 
      dif=abs(x-xa(1)) 
      do 11 i=1,n 
         dift=abs(x-xa(i)) 
         if(dift.lt.dif) then 
            ns=i 
            dif=dift 
         endif 
         c(i)=ya(i) 
         d(i)=ya(i) 
   11 enddo 
      y=ya(ns) 
      ns=ns-1 
      do m=1,n-1 
         do i=1,n-m 
            ho=xa(i)-x 
            hp=xa(i+m)-x 
            w=c(i+1)-d(i) 
            den=ho-hp 
            if(den.eq.0) then 
               write(*,*)'failure in polint' 
               stop 
            endif 
            den=w/den 
            d(i)=hp*den 
            c(i)=ho*den 
         enddo 
         if(2*ns.lt.(n-m)) then 
            dy=c(ns+1) 
         else 
            dy=d(ns) 
            ns=ns-1 
         endif 
         y=y+dy 
      enddo 
                                                                        
      return 
      END                                           

!********************************************************************** 
!                                                                       
!     TABLE OF CONTENTS                                                 
!                                                                       
!     1. evolinit -> Initializes the evolution code by filling the COMMO
!                    BLOCKS which contain the constants                 
!     2. alphasNNPDF,ffn,vfn,funcs -> Routines related to the computatio
!     3. evolfactx -> Computes the evolution kernels in x-space.        
!     4. xgrid  -> Gives the x pts for the convolution                  
!     5. gammax -> FT algorithm for Mellin inversion                    
!     6. gamma -> evaluates gamma coefficients                          
!     7. evolfactn -> N space quantities evaluation                     
!     8. evolint -> convolution routines                                
!     9. andim_IPT -> Evaluates an dimension                            
!     10.matutils.f, psi.f -> Matrix operation, special functions and dg
!                                                                       
!     NB: pdfin & NN are in wrapXNN.f                                   
!                                                                       
!********************************************************************** 
                                                                        
!****                                                                   
! 1 *-------------------------------------------------------------------
!****                                                                   
      SUBROUTINE LH_EVOLINIT 
      IMPLICIT none 
!                                                                       
      INTEGER ipt,imodev,ivfn,itmc 
      COMMON/nnpdf10EVFLAGS/ipt,imodev,ivfn,itmc 
!                                                                       
      REAL*8 ca,cf,tr 
      COMMON/NNPDF10COLFACT/ca,cf,tr 
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
!                                                                       
      REAL*8 beta0(3:6),beta1(3:6),beta2(3:6) 
      REAL*8 b1(3:6),b2(3:6) 
      COMMON /NNPDF10BETA/ beta0,beta1,beta2,b1,b2 
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON/nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      REAL*8 q20,q2 
      COMMON/NNPDF10EVSCALE/q20,q2 
!                                                                       
      INTEGER i, nff 
      REAL*8 alphas,LH_AlphaExactBeta,LH_AlphaMZ 
      EXTERNAL LH_AlphaExactBeta,LH_AlphaMZ 
!                                                                       
!     Color Factors                                                     
!                                                                       
      CA= 3D0 
      CF= 4D0/3D0 
      TR= 0.5D0 
!                                                                       
!     Constants                                                         
!                                                                       
      EMC   = 0.5772156649D0 
      ZETA2 = 1.644934067D0 
      ZETA3 = 1.2020569031D0 
      ZETA4 = 1.0823232337D0 
!                                                                       
!     Beta function coefficients                                        
!                                                                       
      DO I=3,6 
         BETA0(I) = (33d0-2d0*I)/3d0 
         BETA1(I) = 102d0-38d0/3d0*I 
         BETA2(I) = 2857d0/2d0-5033d0/18d0*I+325d0/54d0*I**2d0 
         B1(I) = BETA1(I)/BETA0(I) 
         B2(I) = BETA2(I)/BETA0(I) 
      ENDDO 
!                                                                       
      IF(IVFN.EQ.0) THEN 
         NFF = 3
         IF(IMODEV.EQ.1)THEN 
            CALL LH_FFN(q20,alphas,ipt,LH_AlphaExactBeta,NFF) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_FFN(q20,alphas,ipt,LH_AlphaMZ,NFF) 
         ENDIF 
         AS0 = ALPHAS/4d0/PI 
         IF(IMODEV.EQ.1)THEN 
            CALL LH_FFN(q2TH(4),alphas,ipt,LH_AlphaExactBeta,NFF) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_FFN(q2TH(4),alphas,ipt,LH_AlphaMZ,NFF) 
         ENDIF 
         ASC = ALPHAS/4d0/PI 
         IF(IMODEV.EQ.1)THEN 
            CALL LH_FFN(q2TH(5),alphas,ipt,LH_AlphaExactBeta,NFF) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_FFN(q2TH(5),alphas,ipt,LH_AlphaMZ,NFF) 
         ENDIF 
         ASB = ALPHAS/4d0/PI 
         IF(IMODEV.EQ.1)THEN 
            CALL LH_FFN(q2TH(6),alphas,ipt,LH_AlphaExactBeta,NFF) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_FFN(q2TH(6),alphas,ipt,LH_AlphaMZ,NFF) 
         ENDIF 
         AST = ALPHAS/4d0/PI 
      ELSE 
         IF(IMODEV.EQ.1)THEN 
            CALL LH_VFN(q20,alphas,ipt,LH_AlphaExactBeta) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_VFN(q20,alphas,ipt,LH_AlphaMZ) 
         ENDIF 
         AS0 = ALPHAS/4d0/PI 
         IF(IMODEV.EQ.1)THEN 
            CALL LH_VFN(q2TH(4),alphas,ipt,LH_AlphaExactBeta) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_VFN(q2TH(4),alphas,ipt,LH_AlphaMZ) 
         ENDIF 
         ASC = ALPHAS/4d0/PI 
         IF(IMODEV.EQ.1)THEN 
            CALL LH_VFN(q2TH(5),alphas,ipt,LH_AlphaExactBeta) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_VFN(q2TH(5),alphas,ipt,LH_AlphaMZ) 
         ENDIF 
         ASB = ALPHAS/4d0/PI 
         IF(IMODEV.EQ.1)THEN 
            CALL LH_VFN(q2TH(6),alphas,ipt,LH_AlphaExactBeta) 
         ELSEIF(IMODEV.EQ.0)THEN 
            CALL LH_VFN(q2TH(6),alphas,ipt,LH_AlphaMZ) 
         ENDIF 
         AST = ALPHAS/4d0/PI 
      ENDIF 
!                                                                       
      ASQ = 0.d0 
!                                                                       
      RETURN 
      END                                           
                                                                        
!****                                                                   
! 2 *-------------------------------------------------------------------
!****                                                                   
      FUNCTION alphaNNPDF(QQ) 
      IMPLICIT none 
!                                                                       
      INTEGER nff 
      INTEGER ipt,imodev,ivfn,itmc 
      COMMON/NNPDF10EVFLAGS/ipt,imodev,ivfn,itmc 
!                                                                       
      REAL*8 alphaNNPDF 
      REAL*8 qq,qq2 
      REAL*8 alphas,LH_AlphaExactBeta,LH_AlphaMZ 
      EXTERNAL LH_AlphaExactBeta,LH_AlphaMZ 
!                                                                       
      qq2 = qq**2. 
      CALL lh_evolinit 
!                                                                       
      IF(ivfn.eq.0)THEN
         WRITE(*,*)"FFN not available!"
         NFF = 3
         IF(imodev.eq.1)THEN 
            CALL LH_FFN(qq2,alphas,ipt,LH_AlphaExactBeta,NFF) 
         ELSEIF(imodev.eq.0)THEN 
            CALL LH_FFN(qq2,alphas,ipt,LH_AlphaMZ,NFF) 
         ENDIF 
      ELSEIF(ivfn.EQ.1)THEN 
         IF (imodev.EQ.1)THEN 
            CALL LH_VFN(qq2,alphas,ipt,LH_AlphaExactBeta) 
         ELSEIF(imodev.EQ.0)THEN 
            CALL LH_VFN(qq2,alphas,ipt,LH_AlphaMZ) 
         ENDIF 
      ENDIF 
!                                                                       
      alphaNNPDF = alphas 
!                                                                       
      RETURN 
      END                                           
                                                                        
!                                                                       
!     FFN: returns the value of alpha_s computed for Fixed              
!          Flavour Number.                                              
!     VFN: returns the value of alpha_s computed for Variable           
!          Flavour Number.                                              
!                                                                       
      SUBROUTINE LH_FFN(q2,alphas,ipt,FUNC,nf) 
      IMPLICIT none 
!                                                                       
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
!                                                                       
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON/nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      INTEGER nf 
      INTEGER ipt 
      REAL*8  q2,qq2 
      REAL*8  alphas,func,alphasref,qq2ref 
!                                                                       
      alphasref = asref 
      qq2ref    = q2ref 
      qq2       = q2 
                                                                        
      alphas = FUNC(nf,qq2ref,alphasref,qq2,ipt) 
                                                                        
      RETURN 
      END                                           
!                                                                       
!                                                                       
      SUBROUTINE LH_VFN(qq2,alphas,ipt,FUNC) 
      IMPLICIT none 
!
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 

      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON/nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!
      INTEGER nfi,nff,dnf,snf,ipt
      double precision q2,qq2,FUNC,alphasref,qq2ref
      double precision alphas,c2,asi
!     c2 is the same coefficient used in eq. 2.42
!     of hep-ph/0408244 and obtained in eq. 10 
!     of hep-ph/9706430. In the following it is divided
!     by (4*pi)^2 to match the notations
      parameter(c2=14d0/3d0)
      external FUNC

      q2=qq2

      if(q2.ge.q2th(6))then
         nff=6
      elseif(q2.ge.q2th(5))then
         nff=5
      elseif(q2.ge.q2th(4))then
         nff=4
      else
         nff=3
      endif
      if(q2ref.gt.q2th(6))then
         nfi=6
      elseif(q2ref.gt.q2th(5))then
         nfi=5
      elseif(q2ref.gt.q2th(4))then
         nfi=4
      else
         nfi=3
      endif
!
      alphasref = asref
      qq2ref = q2ref

 10   if(nff.eq.nfi) then
         alphas = FUNC(nfi,qq2ref,alphasref,q2,ipt)
         return
      else
         if(nff.gt.nfi)then
            dnf=1
            snf=1
         else
            dnf=-1
            snf=0
         endif
         asi = FUNC(nfi,qq2ref,alphasref,q2th(nfi+snf),ipt)
         if(ipt.ge.2)then
            if(nff.gt.nfi) asi=asi+(c2/(4d0*pi)**2d0)*asi**3d0
            if(nff.lt.nfi) asi=asi-(c2/(4d0*pi)**2d0)*asi**3d0
         endif
         alphasref = asi
         qq2ref = q2th(nfi+snf)
         nfi = nfi+dnf
         goto 10
      endif   
      end
!                                                                       
!     FUNCS for the computation of alpha_s with diff methods            
!     - AlphaMZ: computes alpha_s as function of alpha_s at a given     
!                refernce scale.                                        
!     - AlphaExactBeta: Exact solution of the QCD beta function         
!                       equation using fourth order Runge-Kutta         
!                       algorithm.                                      
!                                                                       
      FUNCTION LH_AlphaMZ(nfi,mz2,asz,q2,ipt) 
      IMPLICIT none 
!                                                                       
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
!                                                                       
      REAL*8 beta0(3:6),beta1(3:6),beta2(3:6) 
      REAL*8 b1(3:6),b2(3:6) 
      COMMON/nnpdf10BETA/beta0,beta1,beta2,b1,b2 
!                                                                       
      INTEGER nfi,ipt 
      REAL*8 q2ref,q2,asi,asref 
      REAL*8 alo,t,as,den,mz2,asz,LH_AlphaMZ 
                                                                        
      q2ref = mz2 
      asref = asz/4./pi 
      asi = asref 
      t   = log(q2/q2ref) 
      den = 1.+beta0(nfi)*asi*t 
      alo = asi/den 
                                                                        
!     LO                                                                
      as = alo 
                                                                        
!     NLO                                                               
      IF(ipt.GE.1) as = alo*(1-b1(nfi)*alo*log(den)) 
                                                                        
!     NNLO                                                              
      IF(ipt.GE.2)THEN 
         as = alo*(1.+(alo*(alo-asi)*(b2(nfi)-b1(nfi)**2.)              &
     &        +as*b1(nfi)*dlog(as/asi)))                                
      ENDIF 
!                                                                       
      LH_AlphaMZ = 4d0*pi*as 
!                                                                       
      RETURN 
      END                                           
!                                                                       
!                                                                       
      FUNCTION LH_AlphaExactBeta(nf,r20,as0,r2,ipt) 
!                                                                       
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
!                                                                       
      REAL*8 beta0(3:6),beta1(3:6),beta2(3:6) 
      REAL*8 b1(3:6),b2(3:6) 
      COMMON/nnpdf10BETA/beta0,beta1,beta2,b1,b2 
!                                                                       
      INTEGER NFMIN, NFMAX, NF, NSTEP, K1,ipt,nnf 
      REAL*8 LH_fbeta,LH_AlphaExactBeta 
      REAL*8 as,as0,r20,r2 
      REAL*8 dlr,lrrat,sxth 
      REAL*8 xk0,xk1,xk2,xk3 
                                                                        
      PARAMETER (NFMIN = 3, NFMAX = 6) 
      PARAMETER (NSTEP=50) 
      PARAMETER (SXTH = 0.166666666666666D0 ) 
!                                                                       
      NNF = NF 
      AS0 = AS0/4./pi 
      AS  = AS0 
      LRRAT = dLOG (R2/R20) 
      DLR   = LRRAT / NSTEP 
!                                                                       
!     ..Solution of the evolution equation depending on  NAORD          
!   (fourth-order Runge-Kutta beyond the leading order)                 
      IF (IPT.EQ.0) THEN 
         AS = AS0 / (1d0+ BETA0(NF) * AS0 * LRRAT) 
      ELSE IF (IPT.EQ.1) THEN 
         DO 2 K1 = 1, NSTEP 
            XK0 = DLR * LH_FBETA (AS,NNF,IPT) 
            XK1 = DLR * LH_FBETA (AS + 0.5d0 * XK0,NNF,IPT) 
            XK2 = DLR * LH_FBETA (AS + 0.5d0 * XK1,NNF,IPT) 
            XK3 = DLR * LH_FBETA (AS + XK2,NNF,IPT) 
            AS = AS + SXTH * (XK0 + 2d0* XK1 + 2d0* XK2 + XK3) 
    2     CONTINUE 
      ELSE IF (IPT.EQ.2) THEN 
         DO 3 K1 = 1, NSTEP 
            XK0 = DLR * LH_FBETA (AS,nnf,ipt) 
            XK1 = DLR * LH_FBETA (AS + 0.5d0 * XK0,nnf,ipt) 
            XK2 = DLR * LH_FBETA (AS + 0.5d0 * XK1,nnf,ipt) 
            XK3 = DLR * LH_FBETA (AS + XK2,nnf,ipt) 
            AS = AS + SXTH * (XK0 + 2d0* XK1 + 2d0* XK2 + XK3) 
    3    CONTINUE 
      END IF 
                                                                        
      LH_alphaexactbeta = as*(4d0*pi) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_fbeta(a,nf,ipt) 
      IMPLICIT none 
!                                                                       
      REAL*8 beta0(3:6),beta1(3:6),beta2(3:6) 
      REAL*8 b1(3:6),b2(3:6) 
      COMMON/nnpdf10BETA/beta0,beta1,beta2,b1,b2 
!                                                                       
      REAL*8 lh_fbeta,a 
      INTEGER nf,ipt 
                                                                        
      IF(ipt.EQ.1)THEN 
         LH_FBETA = - A**2d0 * ( BETA0(NF) + A * BETA1(NF) ) 
      ELSEIF(ipt.EQ.2)THEN 
         LH_FBETA = - A**2d0 * ( BETA0(NF) + A * ( BETA1(NF)            &
     &     + A * BETA2(NF) ) )                                          
      ENDIF 
                                                                        
      RETURN 
      END                                           
!                                                                       
!     Find \LambdaQCD(nf) from the reference scale                      
!     Needed for LHAPDF interface                                       
!                                                                       
      function LH_LAMBDAZ(NF) 
      implicit none 
!                                                                       
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
!                                                                       
      REAL*8 beta0(3:6),beta1(3:6),beta2(3:6) 
      REAL*8 b1(3:6),b2(3:6) 
      COMMON/nnpdf10BETA/beta0,beta1,beta2,b1,b2 
!                                                                       
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON/nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      INTEGER nf,i 
      REAL*8 LH_lambdaz 
      REAL*8 aref,lambda5sq,lambdaz5,qth(4:6) 
!                                                                       
      AREF = ASREF /(4.d0*PI) 
      DO I= 3,6 
         QTH(i) = dsqrt(Q2TH(I)) 
      ENDDO 
!                                                                       
      LAMBDA5SQ = Q2REF * DEXP(-1d0/(BETA0(5)*AREF)                     &
     &     - (BETA1(5)/BETA0(5)**2d0)                                   &
     &     * DLOG(BETA1(5)*AREF/(BETA0(5)+BETA1(5)*AREF)))              
      LAMBDAZ5 = DSQRT(LAMBDA5SQ) 
      IF(NF.EQ.5)THEN 
         LH_LAMBDAZ = LAMBDAZ5 
      ELSEIF(NF.EQ.6)THEN 
                               !!!!!! add formula!!!!                   
         LH_LAMBDAZ = LAMBDAZ5 
      ELSEIF(NF.LE.4)THEN 
         LH_LAMBDAZ = LAMBDAZ5 * ((QTH(5)/LAMBDAZ5)**(2d0/25d0))        &
     &        * dLOG(Q2TH(5)/LAMBDA5SQ)**(963d0/14375d0)                
      ENDIF 
                                                                        
!                                                                       
      RETURN 
      END                                           
!****                                                                   
! 3 *-------------------------------------------------------------------
!****                                                                   
!                                                                       
!     evolfactx: Computes the ev. kernels in x-space.(DIFF FROM CODE!! N
!                                                                       
      SUBROUTINE LH_EVOLFACTX(obs,x) 
      IMPLICIT none 
!                                                                       
      INTEGER npoints 
      PARAMETER(npoints=2**8) 
      INTEGER IPT,IMODEV,IVFN,ITMC 
      COMMON /NNPDF10EVFLAGS/ IPT,IMODEV,IVFN,ITMC 
      INTEGER ieval,niter,nmax 
      COMMON /nnpdf10NGRID/ ieval,niter,nmax 
      REAL*8 xmin,xm1,xm2,xmax 
      COMMON/nnpdf10GRID/xmin,xm1,xm2,xmax 
!                                                                       
                                             ! NO MORE FNCTS OF NDATA   
      REAL*8 gm2ns(4),gm2ns24(2),gm2sg(2,2) 
      COMMON /nnpdf10GM2/gm2ns,gm2ns24,gm2sg 
      REAL*8 xx(NPOINTS),wn(NPOINTS),evkns(4,NPOINTS),                  &
     &     evksg(2,2,NPOINTS),evkns24(2,NPOINTS)                        
      COMMON /nnpdf10XEVK/ xx,wn,evkns,evksg,evkns24 
!                                                                       
      REAL*8 q20,q2 
      COMMON/nnpdf10EVSCALE/q20,q2 
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON/nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      INTEGER j,obs 
      REAL*8 x 
      REAL*8 flx 
      REAL*8 LH_gamm2ns,LH_gamm2sg,LH_gamm2ns24 
      REAL*8 xxtmp(NPOINTS),wtmp(NPOINTS) 
      REAL*8 LH_gammax_nsp,LH_gammax_nsm,LH_gammax_nsvu,LH_gammax_nsvd 
      REAL*8 LH_gammax_ns24q,LH_gammax_ns24g 
      REAL*8 LH_gammax_qq, LH_gammax_qg, LH_gammax_gq, LH_gammax_gg 
!                                                                       
      flx=0.2d0 
      if(ipt.eq.2)flx=0.3d0 
!                                                                       
      do j=1,NPOINTS 
         xxtmp(j)=0.d0 
         wtmp(j)=0.d0 
      enddo 
!                                                                       
      call LH_xgrid(x,xm1,xm2,xmax,flx,niter,xxtmp,wtmp,nmax) 
!                                                                       
      DO j=1,NMAX 
         xx(j)          = xxtmp(j) 
         wn(j)          = wtmp(j) 
         evkns(1,j)     = LH_gammax_nsp(xx(j),Q20,Q2) 
         evkns(2,j)     = LH_gammax_nsm(xx(j),Q20,Q2) 
         evkns(3,j)     = LH_gammax_nsvu(xx(j),Q20,Q2) 
         evkns(4,j)     = LH_gammax_nsvd(xx(j),Q20,Q2) 
         evkns24(1,j)   = LH_gammax_ns24q(xx(j),Q20,Q2) 
         evkns24(2,j)   = LH_gammax_ns24g(xx(j),Q20,Q2) 
         evksg(1,1,j)   = LH_gammax_qq(xx(j),Q20,Q2) 
         evksg(1,2,j)   = LH_gammax_qg(xx(j),Q20,Q2) 
         evksg(2,1,j)   = LH_gammax_gq(xx(j),Q20,Q2) 
         evksg(2,2,j)   = LH_gammax_gg(xx(j),Q20,Q2) 
      ENDDO 
!                                                                       
      gm2ns(1)     = LH_gamm2ns(1,x,Q20,Q2) 
      gm2ns(2)     = LH_gamm2ns(2,x,Q20,Q2) 
      gm2ns(3)     = LH_gamm2ns(3,x,Q20,Q2) 
      gm2ns(4)     = LH_gamm2ns(4,x,Q20,Q2) 
      gm2ns24(1)   = LH_gamm2ns24(1,x,Q20,Q2) 
      gm2ns24(2)   = LH_gamm2ns24(2,x,Q20,Q2) 
      gm2sg(1,1)   = LH_gamm2sg(1,1,x,Q20,Q2) 
      gm2sg(1,2)   = LH_gamm2sg(1,2,x,Q20,Q2) 
      gm2sg(2,1)   = LH_gamm2sg(2,1,x,Q20,Q2) 
      gm2sg(2,2)   = LH_gamm2sg(2,2,x,Q20,Q2) 
!                                                                       
      RETURN 
      END                                           
!****                                                                   
! 4 *------------------------------------------------------------------ 
!****                                                                   
!                                                                       
!     Gives the pts in x for the convolution grid                       
!                                                                       
                                                                        
      SUBROUTINE LH_xgrid(xmin,xmm1,xmm2,xmax,flx,NITER,xx,wn,NMAX) 
!                                                                       
      IMPLICIT none 
!                                                                       
      INTEGER npoints 
      PARAMETER(npoints=2**8) 
      INTEGER NINT,NINT1,NINT2,NINT3 
      INTEGER ntmp,NITER,NGAUSS,NMAX 
      PARAMETER(NGAUSS=4) 
      INTEGER i,k,ii,k2,k3 
      REAL*8 xmin,xmax,xm1,rtmp,xdum,xm2,xmm2,flx,xmm1 
      REAL*8 sum,diff,z 
      REAL*8 xx(NPOINTS),wn(NPOINTS) 
      REAL*8 down(NPOINTS),up(NPOINTS) 
      REAL*8 ZS(NGAUSS),WZ(NGAUSS) 
!                                                                       
      DATA WZ                                                           &
     &       / 0.347854845137454D0,				      &
     &         0.652145154862546D0,				      &
     &         0.652145154862546D0,				      &
     &         0.347854845137454D0/				      
                                                                        
      DATA ZS                                                           &
     &       / -0.861136311594053D0,				      &
     &         -0.339981043584856D0,				      &
     &          0.339981043584856D0,				      &
     &          0.861136311594053D0 /				      
                                                                        
      k=0 
                                                                        
      xm1=xmm1 
                                                                        
      DO ii=0,NITER 
                                                                        
!     X < 0.99: 3 kind of division                                      
                                                                        
         IF(xmin.lt.xmm2)THEN 
                                                                        
            NINT=2**ii 
            NINT3=int(flx*NINT) 
            xm2=xmm2 
            if(NINT3.lt.1)xm2=xmax 
                                                                        
            if(xmin.lt.xm1)then 
               rtmp=abs((dlog(xm1-xmin))/(xm2-xmin)) 
               ntmp=int(NINT/rtmp) 
               NINT1=ntmp 
            else 
               NINT1=0 
            endif 
                                                                        
            NINT2=NINT-NINT1-NINT3 
                                                                        
            if(xmin.le.xm1)then 
               do i=1,NINT1 
                  xdum=xmin*(xm1/xmin)**(dble(i-1)/dble(NINT1)) 
                  down(i)=xdum 
               enddo 
            endif 
                                                                        
            if(xmin.gt.xm1)xm1=xmin 
            if(xmin.le.xm1)then 
               do i=1,NINT2 
                  xdum=xm1+(xm2-xm1)*(dble(i-1)/dble(NINT2)) 
                  down(i+NINT1)=xdum 
               enddo 
            endif 
                                                                        
            do i=1,NINT3 
               xdum=1.d0-(1.d0-xm2)*((1.d0-xmax)/                       &
     &              (1.d0-xm2))**(dble(i-1)/dble(NINT3))                
               down(i+NINT1+NINT2)=xdum 
            enddo 
                                                                        
!     X>= 0.99: only intervals logarithmic in log(1-x)                  
         ELSE 
!                                                                       
            NINT = 2**ii 
                                                                        
            DO i=1,NINT 
               xdum=1.d0-(1.d0-xmin)*((1.d0-xmax)/                      &
     &              (1.d0-xmin))**(dble(i-1)/dble(NINT))                
               down(i)=xdum 
            ENDDO 
                                                                        
         ENDIF 
                                                                        
         do i = 2, NINT 
            up(i-1) = down(i) 
         enddo 
         up(NINT)  = xmax 
                                                                        
         DO K2 = 1, NINT 
            SUM  = UP(K2) + DOWN(K2) 
            DIFF = UP(K2) - DOWN(K2) 
            DO K3 = 1, NGAUSS 
               K = K + 1 
               Z = (SUM + DIFF * ZS(K3)) * 0.5d0 
               WN(K) = DIFF * 0.5d0 * WZ(K3) 
               xx(K) = Z 
               IF(Z.LT.XMIN)WRITE(*,*)"WARNING",K,XX(K),k2,DOWN(K2),UP(K2)                                 
            ENDDO 
         ENDDO 
                                                                        
!                                                                       
      ENDDO 
!                                                                       
      NMAX=k 
!                                                                       
      RETURN 
      END                                           
!                                                                       
!****                                                                   
! 5 *-------------------------------------------------------------------
!****                                                                   
!                                                                       
!     File: gammax.f                                                    
!     Contains the functions to compute x*Gamma(x,Q2i,Q2f) as           
!     Mellin inversions of the evolution operators computed             
!     in N-space.                                                       
!                                                                       
      FUNCTION LH_gammax_nsp(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_nsp 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_nsp(evpdf,x,Q2i,Q2f) 
      LH_gammax_nsp = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_nsm(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_nsm 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_nsm(evpdf,x,Q2i,Q2f) 
      LH_gammax_nsm = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_nsvu(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_nsvu 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_nsvu(evpdf,x,Q2i,Q2f) 
      LH_gammax_nsvu = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_nsvd(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_nsvd 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_nsvd(evpdf,x,Q2i,Q2f) 
                                                                        
      LH_gammax_nsvd = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_ns24q(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_ns24q 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_ns24q(evpdf,x,Q2i,Q2f) 
                                                                        
      LH_gammax_ns24q = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_ns24g(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_ns24g 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_ns24g(evpdf,x,Q2i,Q2f) 
                                                                        
      LH_gammax_ns24g = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_qq(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_qq 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_qq(evpdf,x,Q2i,Q2f) 
                                                                        
      LH_gammax_qq = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_qg(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_qg 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_qg(evpdf,x,Q2i,Q2f) 
                                                                        
      LH_gammax_qg = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_gq(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_gq 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_gq(evpdf,x,Q2i,Q2f) 
                                                                        
      LH_gammax_gq = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_gg(x,Q2i,Q2f) 
      IMPLICIT none 
      REAL*8 LH_gammax_gg 
      REAL*8 x,Q2i,Q2f 
      REAL*8 evpdf 
                                                                        
      call LH_fixedtalbot_gg(evpdf,x,Q2i,Q2f) 
                                                                        
      LH_gammax_gg = x*evpdf 
                                                                        
      RETURN 
      END                                           
!                                                                       
!     Fixed Talbot algorithm                                            
                                                                        
      SUBROUTINE LH_fixedtalbot_nsp(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m = 16 
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_ZFUNC(s1,x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfns(1) 
         tmp=tmp+dreal(tmp2) 
      enddo 
                                                                        
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfns(1))) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_nsm(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m = 16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_zfunc(s1,x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfns(2) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfns(2))) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_nsvu(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m = 16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_zfunc(s1,x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfns(3) 
         tmp=tmp+dreal(tmp2) 
      enddo 
                                                                        
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfns(3))) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_nsvd(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m = 16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_zfunc(s1,x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfns(4) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfns(4))) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_ns24q(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m=16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_ZFUNC(s1,x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfns24(1) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfns24(1))) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_ns24g(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m=16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_ZFUNC(s1,x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfns24(2) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,ZPDFNS,ZPDFNS24,ZPDFSG) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfns24(2))) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_qq(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m=16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_zfunc(s1,x,q2i,q2f,zpdfns,ZPDFNS24,zpdfsg) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfsg(1,1) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,q2i,q2f,zpdfns,ZPDFNS24,zpdfsg) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfsg(1,1))) 
                                                                        
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_qg(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m=16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_zfunc(s1,x,q2i,q2f,zpdfns,ZPDFNS24,zpdfsg) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfsg(1,2) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,q2i,q2f,zpdfns,ZPDFNS24,zpdfsg) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfsg(1,2))) 
                                                                        
      return 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_gq(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m=16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_zfunc(s1,x,q2i,q2f,zpdfns,ZPDFNS24,zpdfsg) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfsg(2,1) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,zpdfns,ZPDFNS24,zpdfsg) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfsg(2,1))) 
                                                                        
      return 
      END                                           
!                                                                       
      SUBROUTINE LH_fixedtalbot_gg(xfunc,x,Q2i,Q2f) 
      IMPLICIT none 
                                                                        
      REAL*8 x,xfunc 
      REAL*8 Q2i,Q2f 
                                                                        
      integer m,j 
      REAL*8 theta,pi,sigma,t,tmp,r 
      COMPLEX*16 s,s1,tmp2,zpdfns(4),zpdfsg(2,2),ZPDFNS24(2) 
                                                                        
      pi=acos(-1d0) 
      m=16 
                                                                        
      t=-dlog(x) 
                                                                        
      tmp  = 0d0 
      tmp2 = 0d0 
                                                                        
      r=2d0*m/5d0/t 
                                                                        
      do j=1,m-1 
         theta = dble(j)*pi/dble(m) 
         sigma=theta+(theta/tan(theta)-1d0)/tan(theta) 
         s=r*theta*DCMPLX(1d0/tan(theta),1d0) 
         s1 = s + (1d0,0d0) 
         call LH_zfunc(s1,x,Q2i,Q2f,zpdfns,ZPDFNS24,zpdfsg) 
         tmp2=exp(t*s1)*DCMPLX(1d0,sigma)*zpdfsg(2,2) 
         tmp=tmp+dreal(tmp2) 
      enddo 
      call LH_zfunc(DCMPLX(r+1d0,0d0),x,Q2i,Q2f,zpdfns,ZPDFNS24,zpdfsg) 
                                                                        
      xfunc=r/m*(tmp+.5d0*exp((r+1d0)*t)*dreal(zpdfsg(2,2))) 
                                                                        
      return 
      END                                           
                                                                        
!****                                                                   
! 6 *-------------------------------------------------------------------
!****                                                                   
!     File: gamma.f                                                     
!     Function for computing Gamma(2), second moment                    
!     of the evolution factor, for the Singlet-Gluon                    
!     coupled evolution                                                 
!                                                                       
                                                                        
      FUNCTION LH_gamm2ns(nsflav,x,Q2i,Q2f) 
      IMPLICIT none 
!                                                                       
      REAL*8 Q2i,Q2f 
!                                                                       
      REAL*8 Q2it,Q2ft 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
!                                                                       
      integer nsflav 
      COMPLEX*16 zn 
      REAL*8 ain,afin,eps,x 
      REAL*8 LH_gamm2ns,LH_DGAUSS_INTERN 
      REAL*8 LH_gammax_nsp_wrp,LH_gammax_nsm_wrp,LH_gammax_nsvu_wrp,    &
     &     LH_gammax_nsvd_wrp,LH_gammax_nsvct_wrp,LH_gammax_nsvsb_wrp   
      external LH_gammax_nsp_wrp,LH_gammax_nsm_wrp,LH_gammax_nsvu_wrp,  &
     &     LH_gammax_nsvd_wrp,LH_gammax_nsvct_wrp,LH_gammax_nsvsb_wrp   
                                                                        
      parameter(eps=1d-8) 
      COMPLEX*16 efnns(4),efnns24(2),efnsg(2,2) 
                                                                        
!     NB: 2 moment                                                      
      zn = (2d0,0d0) 
!                                                                       
      call LH_ZFUNC(zn,x,Q2i,Q2f,EFNNS,EFNNS24,EFNSG) 
!                                                                       
!     Fill auxiliary variables needed by wrapper functions              
!                                                                       
      Q2it = Q2i 
      Q2ft = Q2f 
!                                                                       
      ain=0d0 
      afin=x 
!                                                                       
      IF(NSFLAV.EQ.1) THEN 
         LH_gamm2ns = DREAL(efnns(1))-                                  &
     &        LH_DGAUSS_INTERN(LH_gammax_nsp_wrp,ain,afin,eps)          
       ELSEIF(NSFLAV.EQ.2) THEN 
         LH_gamm2ns = DREAL(efnns(2))                                   &
     &         -LH_DGAUSS_INTERN(LH_gammax_nsm_wrp,ain,afin,eps)        
      ELSEIF(NSFLAV.EQ.3) THEN 
         LH_gamm2ns = DREAL(efnns(3))                                   &
     &        -LH_DGAUSS_INTERN(LH_gammax_nsvu_wrp,ain,afin,eps)        
      ELSEIF(NSFLAV.EQ.4) THEN 
         LH_gamm2ns = DREAL(efnns(4))                                   &
     &        -LH_DGAUSS_INTERN(LH_gammax_nsvd_wrp,ain,afin,eps)        
      ENDIF 
!                                                                       
      return 
      END                                           
!                                                                       
      FUNCTION LH_gamm2ns24(ns24flav,x,Q2i,Q2f) 
      IMPLICIT none 
!                                                                       
      REAL*8 Q2i,Q2f 
!                                                                       
      REAL*8 Q2it,Q2ft 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
!                                                                       
      integer ns24flav 
      COMPLEX*16 zn 
      REAL*8 ain,afin,eps,x 
      REAL*8 LH_gamm2ns24,LH_DGAUSS_INTERN 
      REAL*8 LH_gammax_ns24q_wrp,LH_gammax_ns24g_wrp 
      external LH_gammax_ns24q_wrp,LH_gammax_ns24g_wrp 
                                                                        
      parameter(eps=1d-8) 
      COMPLEX*16 efnns(4),efnns24(2),efnsg(2,2) 
                                                                        
!     NB: 2 moment                                                      
      zn = (2d0,0d0) 
!                                                                       
      call LH_ZFUNC(zn,x,Q2i,Q2f,EFNNS,EFNNS24,EFNSG) 
!                                                                       
!     Fill auxiliary variables needed by wrapper functions              
!                                                                       
      Q2it = Q2i 
      Q2ft = Q2f 
!                                                                       
      ain=0d0 
      afin=x 
!                                                                       
      IF(ns24flav.EQ.1) THEN 
         LH_gamm2ns24 = DREAL(efnns24(1))                               &
     &               -LH_DGAUSS_INTERN(LH_gammax_ns24q_wrp,ain,afin,eps)
      ELSEIF(ns24flav.EQ.2) THEN 
         LH_gamm2ns24 = DREAL(efnns24(2))                               &
     &               -LH_DGAUSS_INTERN(LH_gammax_ns24g_wrp,ain,afin,eps)
                                                                        
      ENDIF 
!                                                                       
      RETURN 
      END                                           
                                                                        
!                                                                       
      FUNCTION LH_gamm2sg(l,c,x,Q2i,Q2f) 
      IMPLICIT none 
!                                                                       
      REAL*8 Q2i,Q2f 
!                                                                       
      REAL*8 Q2it,Q2ft 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
!                                                                       
      integer l,c 
      COMPLEX*16 zn 
      REAL*8 ain,afin,eps,x 
      REAL*8 LH_gamm2sg,LH_DGAUSS_INTERN 
      REAL*8 LH_gammax_qq_wrp,LH_gammax_qg_wrp 
      REAL*8 LH_gammax_gq_wrp,LH_gammax_gg_wrp 
      external LH_gammax_qq_wrp,LH_gammax_qg_wrp 
      external LH_gammax_gq_wrp,LH_gammax_gg_wrp 
                                                                        
      parameter(eps=1d-8) 
      COMPLEX*16 efnns(4),efnns24(2),efnsg(2,2) 
                                                                        
!     NB: 2 moment                                                      
      zn=(2d0,0d0) 
!                                                                       
      call LH_ZFUNC(zn,x,Q2i,Q2f,EFNNS,EFNNS24,EFNSG) 
!                                                                       
!     Fill auxiliary variables needed by wrapper functions              
!                                                                       
      Q2it = Q2i 
      Q2ft = Q2f 
!                                                                       
      ain=0d0 
      afin=x 
!                                                                       
      IF(l.EQ.1.AND.c.EQ.1) THEN 
         LH_gamm2sg=DREAL(efnsg(1,1))-                                  &
     &        LH_DGAUSS_INTERN(LH_gammax_qq_wrp,ain,afin,eps)           
      ELSEIF(l.EQ.1.AND.c.EQ.2) THEN 
         LH_gamm2sg=DREAL(efnsg(1,2))                                   &
     &        -LH_DGAUSS_INTERN(LH_gammax_qg_wrp,ain,afin,eps)          
      ELSEIF(l.EQ.2.AND.c.EQ.1) THEN 
         LH_gamm2sg=DREAL(efnsg(2,1))                                   &
     &        -LH_DGAUSS_INTERN(LH_gammax_gq_wrp,ain,afin,eps)          
      ELSEIF(l.EQ.2.AND.c.EQ.2) THEN 
         LH_gamm2sg=DREAL(efnsg(2,2))                                   &
     &        -LH_DGAUSS_INTERN(LH_gammax_gg_wrp,ain,afin,eps)          
      ENDIF 
                                                                        
      RETURN 
      END                                           
!                                                                       
!     Internal Wrapper functions needed to perform x-integration        
!     of the Gamma functions using Dgauss_Intern.                       
!                                                                       
      FUNCTION LH_gammax_nsp_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_nsp_wrp 
      REAL*8 y 
      REAL*8 QQ2,QQ0 
      REAL*8 Q2it,Q2ft 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_nsp 
      EXTERNAL LH_gammax_nsp 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_nsp_wrp = LH_gammax_nsp(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
                                                                        
      FUNCTION LH_gammax_nsm_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_nsm_wrp 
      REAL*8 y 
      REAL*8 QQ2,QQ0 
      REAL*8 Q2it,Q2ft 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_nsm 
      EXTERNAL LH_gammax_nsm 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_nsm_wrp = LH_gammax_nsm(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_nsvu_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_nsvu_wrp 
      REAL*8 y 
      REAL*8 QQ2,QQ0 
      REAL*8 Q2it,Q2ft 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_nsvu 
      EXTERNAL LH_gammax_nsvu 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_nsvu_wrp = LH_gammax_nsvu(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_nsvd_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_nsvd_wrp 
      REAL*8 y 
      REAL*8 Q2it,Q2ft 
      REAL*8 QQ2,QQ0 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_nsvd 
      EXTERNAL LH_gammax_nsvd 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_nsvd_wrp = LH_gammax_nsvd(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_ns24q_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_ns24q_wrp 
      REAL*8 y 
      REAL*8 Q2it,Q2ft 
      REAL*8 QQ2,QQ0 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_ns24q 
      EXTERNAL LH_gammax_ns24q 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_ns24q_wrp = LH_gammax_ns24q(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_ns24g_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_ns24g_wrp 
      REAL*8 y 
      REAL*8 Q2it,Q2ft 
      REAL*8 QQ2,QQ0 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_ns24g 
      EXTERNAL LH_gammax_ns24g 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_ns24g_wrp = LH_gammax_ns24g(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_qq_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_qq_wrp 
      REAL*8 y 
      REAL*8 Q2it,Q2ft 
      REAL*8 QQ2,QQ0 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_qq 
      EXTERNAL LH_gammax_qq 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_qq_wrp = LH_gammax_qq(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_qg_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_qg_wrp 
      REAL*8 y 
      REAL*8 Q2it,Q2ft 
      REAL*8 QQ2,QQ0 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_qg 
      EXTERNAL LH_gammax_qg 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_qg_wrp = LH_gammax_qg(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_gq_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_gq_wrp 
      REAL*8 y 
      REAL*8 Q2it,Q2ft 
      REAL*8 QQ2,QQ0 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_gq 
      EXTERNAL LH_gammax_gq 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_gq_wrp = LH_gammax_gq(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_gammax_gg_wrp(y) 
      IMPLICIT none 
!                                                                       
      REAL*8 LH_gammax_gg_wrp 
      REAL*8 y 
      REAL*8 Q2it,Q2ft 
      REAL*8 QQ2,QQ0 
      COMMON / NNPDF10QTRANSFER / Q2it,Q2ft 
      REAL*8 LH_gammax_gg 
      EXTERNAL LH_gammax_qg 
!                                                                       
      QQ0 = Q2IT 
      QQ2 = Q2FT 
      LH_gammax_gg_wrp = LH_gammax_gg(y,QQ0,QQ2) 
!                                                                       
      RETURN 
      END                                           
                                                                        
!****                                                                   
! 7 *-------------------------------------------------------------------
!****                                                                   
!     File: evolfactn.f                                                 
!     Returns the evolution factors in N space                          
!      - Fixed Flavour Number Scheme (IVFN=0)                           
!      - Zero Mass-Variable Flavour Number Scheme (IVFN=1)              
!                                                                       
      SUBROUTINE LH_ZFUNC(ZN,X,Q20,Q2,ZFUNCNS,ZFUNCNS24,ZFUNCSG) 
      IMPLICIT none 
!                                                                       
      INTEGER IPT,IMODEV,IVFN,ITMC 
      COMMON /NNPDF10EVFLAGS/ IPT,IMODEV,IVFN,ITMC 
!                                                                       
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON /nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      INTEGER I,J 
      INTEGER NFI,NFF,STEP 
!                                                                       
      REAL*8 Q20,Q2 
      REAL*8 X 
!                                                                       
      COMPLEX*16 ZN 
      COMPLEX*16 EFNNS(4),EFNSG(2,2) 
      COMPLEX*16 EFNNS0(4),EFNSG0(2,2),EFNSG1(2,2) 
      COMPLEX*16 ZFUNCNS(4),ZFUNCNS24(2),ZFUNCSG(2,2) 
!                                                                       
      COMPLEX*16 EFNNSBQ(4),EFNNSCB(4),EFNNSBT(4),EFNNSTQ(4) 
      COMPLEX*16 EFNSGBQ(2,2),EFNSGCB(2,2),EFNSGBT(2,2),EFNSGTQ(2,2) 
!                                                                       
!     Allow backward evolution                                          
!                                                                       
      IF(Q20.LE.Q2) STEP =  1 
      IF(Q20.GT.Q2) STEP = -1 
!                                                                       
!     Determine # of active flavours at the initial (NFI) and           
!     final (NFF) scale.                                                
!                                                                       
      IF(Q20.GE.Q2TH(6)) THEN 
         NFI=6 
      ELSEIF(Q20.GE.Q2TH(5)) THEN 
         NFI=5 
      ELSEIF(Q20.GE.Q2TH(4)) THEN 
         NFI=4 
      ELSE 
         NFI=3 
      ENDIF 
!                                                                       
      IF(Q2.GT.Q2TH(6)) THEN 
         NFF=6 
      ELSEIF(Q2.GT.Q2TH(5)) THEN 
         NFF=5 
      ELSEIF(Q2.GT.Q2TH(4)) THEN 
         NFF=4 
      ELSE 
         NFF=3 
      ENDIF 
      IF(IVFN.EQ.0) NFF=4 
!                                                                       
!     No call to Coefficient Functions!                                 
!     Evolution Kernel                                                  
      DO I=1,4 
         EFNNS0(I) = (0d0,0d0) 
      ENDDO 
      DO I=1,2 
         DO J=1,2 
            EFNSG0(I,J) = (0.D0,0.D0) 
            EFNSG1(I,J) = (0.D0,0.D0) 
            EFNSG(I,J) = (0.D0,0.D0) 
         END DO 
      END DO 
!                                                                       
!     Fixed Flavour Number Scheme (NF=4)                                
      IF (IVFN.EQ.0) THEN 
         NFI = 4 
         CALL LH_EVOLFACTN(ZN,Q20,Q2,NFI,EFNNS,EFNSG1) 
         ZFUNCNS24(1) = EFNSG1(1,1) 
         ZFUNCNS24(2) = EFNSG1(1,2) 
!                                                                       
!     (Zero Mass-) Variable Flavour Number Scheme                       
      ELSEIF(IVFN.EQ.1) THEN 
         IF(NFF.EQ.NFI) THEN 
            CALL LH_EVOLFACTN(ZN,Q20,Q2,NFI,EFNNS,EFNSG1) 
         ELSE 
            CALL LH_EVOLFACTN(ZN,Q20,Q2TH(NFI+STEP),NFI,EFNNS0,EFNSG0) 
            DO I=1,4 
               EFNNS(I) = EFNNS0(I) 
            ENDDO 
            CALL LH_MEQUAL_C(EFNSG,EFNSG0,2,2) 
   10       NFI = NFI+STEP 
            IF(NFI.NE.NFF) THEN 
               CALL LH_EVOLFACTN(ZN,Q2TH(NFI),Q2TH(NFI+STEP),NFI,       &
     &              EFNNS0,EFNSG0)                                      
            ELSE 
               CALL LH_EVOLFACTN(ZN,Q2TH(NFI),Q2,NFI,EFNNS0,EFNSG0) 
            ENDIF 
            DO I=1,4 
               EFNNS(I) = EFNNS(I)*EFNNS0(I) 
            ENDDO 
            CALL LH_MMULT_C(EFNSG0,2,2,EFNSG,2,2,EFNSG1) 
                                                                        
            IF(NFI.NE.NFF) THEN 
               CALL LH_MEQUAL_C(EFNSG,EFNSG1,2,2) 
               GOTO 10 
            ENDIF 
         ENDIF 
!                                                                       
!     Evolution of T_24                                                 
         IF(Q2.LE.Q2TH(5))THEN 
            ZFUNCNS24(1) = EFNSG1(1,1) 
            ZFUNCNS24(2) = EFNSG1(1,2) 
         ELSEIF(Q2.LE.Q2TH(6)) THEN 
            CALL LH_EVOLFACTN(ZN,Q20,Q2TH(5),4,EFNNSCB,EFNSGCB) 
            CALL LH_EVOLFACTN(ZN,Q2TH(5),Q2 ,5,EFNNSBQ,EFNSGBQ) 
            ZFUNCNS24(1) = EFNNSBQ(1)*EFNSGCB(1,1) 
            ZFUNCNS24(2) = EFNNSBQ(1)*EFNSGCB(1,2) 
         ELSE 
            CALL LH_EVOLFACTN(ZN,Q20,Q2TH(5),4,EFNNSCB,EFNSGCB) 
            CALL LH_EVOLFACTN(ZN,Q2TH(5),Q2TH(6),5,EFNNSBT,EFNSGBT) 
            CALL LH_EVOLFACTN(ZN,Q2TH(6),Q2,6,EFNNSTQ,EFNSGTQ) 
            ZFUNCNS24(1) = EFNNSTQ(1)*EFNNSBT(1)*EFNSGCB(1,1) 
            ZFUNCNS24(2) = EFNNSTQ(1)*EFNNSBT(1)*EFNSGCB(1,2) 
         ENDIF 
      ENDIF 
!                                                                       
!     Output                                                            
      DO I=1,4 
         ZFUNCNS(I) =  EFNNS(I) 
      ENDDO 
                                                                        
      DO I=1,2 
         ZFUNCNS24(I)= ZFUNCNS24(I) 
      ENDDO 
                                                                        
      DO I=1,2 
         DO J=1,2 
            ZFUNCSG(I,J)= EFNSG1(I,J) 
         ENDDO 
      ENDDO 
                                                                        
      RETURN 
      END                                           
!                                                                       
!     Returns the evolution factors, in N space, from Q20 to Q2 with NF 
!     active flavours, for Non Singlet and Singlet-Gluon.               
!                                                                       
      SUBROUTINE LH_EVOLFACTN(ZN,Q2I,Q2F,NF,EFNNS,EFNSG) 
      IMPLICIT none 
!                                                                       
      INTEGER IPT,IMODEV,IVFN,ITMC 
      COMMON /NNPDF10EVFLAGS/ IPT,IMODEV,IVFN,ITMC 
!                                                                       
      REAL*8 q20,q2 
      COMMON/nnpdf10EVSCALE/q20,q2 
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON /nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      REAL*8 beta0(3:6),beta1(3:6),beta2(3:6) 
      REAL*8 b1(3:6),b2(3:6) 
      COMMON/nnpdf10BETA/beta0,beta1,beta2,b1,b2 
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
!                                                                       
      INTEGER NF 
      INTEGER I,J,K 
      REAL*8 Q2I,Q2F,ASI,ASF,T 
      REAL*8 TMP 
      COMPLEX*16 ZN 
      COMPLEX*16 EFNNS(4),EFNSG(2,2),EFNSGTMP(2,2) 
      COMPLEX*16 EXPNS,EXPM,EXPP 
      COMPLEX*16 UNS0,UNS1(3),LP,LM 
      COMPLEX*16 U(20,2,2) 
      COMPLEX*16 EM(2,2),EP(2,2) 
!                                                                       
      COMPLEX*16 U1(2,2) 
      COMPLEX*16 L(2,2),LU1(2,2),U1L(2,2) 
      COMPLEX*16 USUM(2,2),USUMTMP(2,2),UINV(2,2),USUML(2,2) 
      COMPLEX*16 DETINV 
!                                                                       
!     Compute alphas                                                    
      IF(Q2I.EQ.Q20) THEN 
         ASI = AS0 
      ELSEIF(Q2I.EQ.Q2TH(4)) THEN 
         ASI = ASC 
      ELSEIF(Q2I.EQ.Q2TH(5)) THEN 
         ASI = ASB 
      ELSEIF(Q2I.EQ.Q2TH(6)) THEN 
         ASI = AST 
      ENDIF 
                                                                        
      IF(Q2F.EQ.Q20) THEN 
         ASF = AS0 
      ELSEIF(Q2F.EQ.Q2TH(4)) THEN 
         ASF = ASC 
      ELSEIF(Q2F.EQ.Q2TH(5)) THEN 
         ASF = ASB 
      ELSEIF(Q2F.EQ.Q2TH(6)) THEN 
         ASF = AST 
      ELSE 
         ASF = ASQ 
      ENDIF 
!                                                                       
!     Evaluation of evolution factors                                   
      T = DLOG(ASF/ASI) 
      DO I=1,4 
         EFNNS(I) = (0d0,0d0) 
      ENDDO 
                                                                        
      DETINV=0.D0 
      DO I=1,2 
         DO J=1,2 
            UINV(I,J)=(0d0,0d0) 
            EFNSG(I,J) = (0d0,0d0) 
            EFNSGTMP(I,J) = (0d0,0d0) 
         ENDDO 
      ENDDO 
!                                                                       
!     U matrices                                                        
      CALL LH_UMATRIX(ZN,NF,LP,LM,EP,EM,U,UNS0,UNS1) 
!                                                                       
!     LO evolution factor                                               
!                                                                       
!     Non singlet                                                       
      EXPNS  = EXP ( - UNS0 * T ) 
!                                                                       
!     Singlet                                                           
      EXPM   = EXP ( - LM * T ) 
      EXPP   = EXP ( - LP * T ) 
                                                                        
      DO I=1,2 
        DO J=1,2 
                                                    ! eq.(22)           
           L(I,J) = EXPM * EM(I,J) + EXPP * EP(I,J) 
        ENDDO 
      ENDDO 
                                                                        
      IF(IPT.EQ.0)THEN 
!                                                                       
!     LO solution                                                       
         DO I= 1,4 
            EFNNS(I) = EXPNS 
         ENDDO 
         DO I=1,2 
            DO J=1,2 
               EFNSG(I,J) = L(I,J) 
            ENDDO 
         ENDDO 
                                                                        
      ELSEIF(IPT.EQ.1)THEN 
!                                                                       
!     NLO solution                                                      
         IF(IMODEV.EQ.0)THEN 
!                                                                       
!     Truncated solution IMODEV=0                                       
            DO I=1,3 
               EFNNS(I)= EXPNS * ((1D0,0D0) + UNS1(I) * (ASF-ASI)) 
            ENDDO 
            EFNNS(4)=EFNNS(3) 
                                                                        
            DO I=1,2 
               DO J=1,2 
                  U1(I,J)=U(1,I,J) 
               ENDDO 
            ENDDO 
                                                                        
            CALL LH_MMULT_C(U1,2,2,L,2,2,U1L) 
            CALL LH_MMULT_C(L,2,2,U1,2,2,LU1) 
            DO I=1,2 
               DO J=1,2 
                  EFNSG(I,J) = L(I,J) + ASF * U1L(I,J) - ASI * LU1(I,J) 
               ENDDO 
            ENDDO 
                                                                        
         ELSEIF(IMODEV.EQ.1)THEN 
!                                                                       
!     Iterated solution IMODEV=1                                        
            TMP = 0D0 
            TMP = DLOG(( 1D0 + B1(NF) * ASF )/(1D0 + B1(NF)*ASI))/B1(NF) 
            DO I=1,3 
               EFNNS(I) = EXPNS * EXP( TMP * UNS1(I)) 
            ENDDO 
            EFNNS(4)=EFNNS(3) 
!                                                                       
            USUM(1,1) = (1d0,0d0) 
            USUM(1,2) = (0d0,0d0) 
            USUM(2,1) = (0d0,0d0) 
            USUM(2,2) = (1d0,0d0) 
            USUMTMP(1,1) = (1d0,0d0) 
            USUMTMP(1,2) = (0d0,0d0) 
            USUMTMP(2,1) = (0d0,0d0) 
            USUMTMP(2,2) = (1d0,0d0) 
!                                                                       
            DO K=1,20 
               DO I=1,2 
                  DO J=1,2 
                     USUM(I,J) = USUM(I,J)+                             &
     &                    (ASF**(DBLE(K)) * U(K,I,J))                   
                     USUMTMP(I,J) = USUMTMP(I,J) +                      &
     &                    (ASI**(DBLE(K)) * U(K,I,J))                   
                   ENDDO 
               ENDDO 
            ENDDO 
!                                                                       
            DETINV = 1.D0 / ( USUMTMP(1,1) * USUMTMP(2,2)-              &
     &           USUMTMP(1,2) * USUMTMP(2,1) )                          
            UINV(1,1) = DETINV * USUMTMP(2,2) 
            UINV(1,2) = - DETINV * USUMTMP(1,2) 
            UINV(2,1) = - DETINV * USUMTMP(2,1) 
            UINV(2,2) = DETINV * USUMTMP(1,1) 
!                                                                       
            CALL LH_MMULT_C(USUM,2,2,L,2,2,USUML) 
            CALL LH_MMULT_C(USUML,2,2,UINV,2,2,EFNSGTMP) 
                                                                        
            DO I=1,2 
               DO J=1,2 
                  EFNSG(I,J)= EFNSGTMP(I,J) 
               ENDDO 
            ENDDO 
         ENDIF 
      ENDIF 
!                                                                       
      RETURN 
      END                                           
                                                                        
!                                                                       
!     File: umatrix.f                                                   
!                                                                       
!     Computes the matrices used for the singlet evolution.             
!     Equation numbers refer to the "Notes on PT evolution"             
!                                                                       
      SUBROUTINE LH_UMATRIX(ZN,NF,LP,LM,EP,EM,U,UNS0,UNS1) 
      IMPLICIT none 
!                                                                       
      INTEGER IPT,IMODEV,IVFN,ITMC 
      COMMON /NNPDF10EVFLAGS/ IPT,IMODEV,IVFN,ITMC 
!                                                                       
      REAL*8 beta0(3:6),beta1(3:6),beta2(3:6) 
      REAL*8 b1(3:6),b2(3:6) 
      COMMON/nnpdf10BETA/beta0,beta1,beta2,b1,b2 
!                                                                       
      INTEGER NF 
      COMPLEX*16 ZN 
      COMPLEX*16 UNS0,UNS1(3) 
      COMPLEX*16 U(20,2,2) 
      COMPLEX*16 LP,LM 
      COMPLEX*16 EP(2,2),EM(2,2) 
!                                                                       
      INTEGER I,J,K,JJ,KK,II 
      COMPLEX*16 QQ0,QG0,GQ0,GG0 
      COMPLEX*16 SQ,LDIFF 
      COMPLEX*16 DP(2,2),DM(2,2) 
      COMPLEX*16 G0(2,2),G1(2,2) 
      COMPLEX*16 G0NS(3),G1NS(3) 
      COMPLEX*16 R(20,2,2),RT(20,2,2) 
      COMPLEX*16 R0(2,2),R1(2,2) 
      COMPLEX*16 R1PP(2,2),R1PM(2,2),R1MP(2,2),R1MM(2,2) 
      COMPLEX*16 U1PP(2,2),U1PM(2,2),U1MP(2,2),U1MM(2,2) 
!                                                                       
      CALL LH_ANDIM_LO(ZN,NF,G0NS,G0) 
      UNS0 = G0NS(1) / BETA0(NF) 
!                                                                       
      DO K=1,20 
         DO I=1,2 
            DO J=1,2 
               R(K,I,J)=(0.D0,0.D0) 
               RT(K,I,J)=(0.D0,0.D0) 
               U(K,I,J)=(0.D0,0.D0) 
            ENDDO 
         ENDDO 
      ENDDO 
!                                                                       
      DO I=1,2 
         DO J=1,2 
                                          ! eq. (18)                    
            R0(I,J) = G0(I,J) / BETA0(NF) 
         END DO 
      END DO 
!                                                                       
      QQ0 = R0(1,1) 
      QG0 = R0(1,2) 
      GQ0 = R0(2,1) 
      GG0 = R0(2,2) 
!                                                                       
                                                 ! eq.(20)              
      SQ = SQRT((QQ0-GG0)**2d0 + 4.d0*QG0*GQ0) 
      LP = .5d0*(QQ0 + GG0 + SQ) 
      LM = .5d0*(QQ0 + GG0 - SQ) 
!                                                                       
                                               ! eq.(21)                
      EM(1,1) = (QQ0 - LP) / (LM - LP) 
      EM(1,2)= QG0 / (LM - LP) 
      EM(2,1) = GQ0 / (LM - LP) 
      EM(2,2) = (GG0 - LP) / (LM - LP) 
!                                                                       
      EP(1,1) = (QQ0 - LM) / (LP - LM) 
      EP(1,2) = QG0 / (LP - LM) 
      EP(2,1) = GQ0 / (LP - LM) 
      EP(2,2) = (GG0 - LM) / (LP - LM) 
!                                                                       
!     NLO coefficients                                                  
      IF (IPT.GE.1) THEN 
         CALL LH_ANDIM_NLO(ZN,NF,G1NS,G1) 
!                                                                       
!     NON SINGLET                                                       
         DO I=1,3 
            UNS1(I)= -(G1NS(I)/BETA0(NF)) + B1(NF)*UNS0 
         ENDDO 
!                                                                       
!     SINGLET                                                           
         DO I=1,2 
            DO J=1,2 
                                                              ! eq. (18)
               R(1,I,J)  = G1(I,J)/BETA0(NF) - B1(NF)*R0(I,J) 
                                                               ! R1_T=R1
               RT(1,I,J)  = G1(I,J)/BETA0(NF) - B1(NF)*R0(I,J) 
               R1(I,J) = R(1,I,J) 
           ENDDO 
         ENDDO 
!                                                                       
!     Computation of U1 according to eq.(25)                            
         CALL LH_MMULT_C(EP,2,2,R1,2,2,DP) 
         CALL LH_MMULT_C(EM,2,2,R1,2,2,DM) 
!                                                                       
         CALL LH_MMULT_C(DP,2,2,EP,2,2,R1PP) 
         CALL LH_MMULT_C(DP,2,2,EM,2,2,R1PM) 
         CALL LH_MMULT_C(DM,2,2,EP,2,2,R1MP) 
         CALL LH_MMULT_C(DM,2,2,EM,2,2,R1MM) 
!                                                                       
         DO I = 1,2 
            DO J = 1,2 
               U1PP(I,J) = R1PP(I,J) 
               U1PM(I,J) = R1PM(I,J)/(LM - LP - 1d0) 
               U1MP(I,J) = R1MP(I,J)/(LP - LM - 1d0) 
               U1MM(I,J) = R1MM(I,J) 
               U(1,I,J) = -(U1MM(I,J)+U1PP(I,J)) + U1PM(I,J) + U1MP(I,J) 
            ENDDO 
         ENDDO 
!                                                                       
         IF(IMODEV.EQ.0)THEN 
            DO K=2,20 
               DO I=1,2 
                  DO J=1,2 
                     U(K,I,J)=0.D0 
                  ENDDO 
               ENDDO 
            ENDDO 
                                                                        
         ELSEIF(IMODEV.EQ.1)THEN 
!                                                                       
!     Computation of U_k (k>=2) at NLO according to eqs (23,26,27)      
            LDIFF = LM - LP 
                                                                        
            DO K=2,20 
               DO I=1,2 
                  DO J=1,2 
                                                      ! eq (27)         
                     R(K,I,J) = - B1(NF) * R(K-1,I,J) 
                  ENDDO 
               ENDDO 
            ENDDO 
                                                                        
            DO K=2,20 
               DO I=1,2 
                  DO J=1,2 
                     RT(K,I,J) = R(K,I,J) 
                     DO JJ=1,K-1 
                        DO KK=1,2 
                           RT(K,I,J) = RT(K,I,J) +                      &
     &                          ( R(JJ,I,KK) * U(K-JJ,KK,J) )           
                                                              ! eq (26) 
                        ENDDO 
                     ENDDO 
                  ENDDO 
               ENDDO 
!                                                                       
               DO I=1,2 
                  DO J=1,2 
                     DO II=1,2 
                        DO JJ=1,2 
                                               ! eq(23)                 
                           U(K,I,J) = U(K,I,J)                          &
     &                          -(EM(I,II)*RT(K,II,JJ)*EM(JJ,J)/DBLE(K))&
     &                          -(EP(I,II)*RT(K,II,JJ)*EP(JJ,J)/DBLE(K))&
     &                          -(EM(I,II)*RT(K,II,JJ)* EP(JJ,J)/       &
     &                          ( DBLE(K) + LDIFF ))                    &
     &                          -(EP(I,II)*RT(K,II,JJ)                  &
     &                          * EM(JJ,J) / ( DBLE(K) - LDIFF ))       
                        ENDDO 
                     ENDDO 
                  ENDDO 
               ENDDO 
            ENDDO 
         ENDIF 
      ENDIF 
!                                                                       
      RETURN 
      END                                           
                                                                        
!****                                                                   
! 8 *-------------------------------------------------------------------
!****                                                                   
!                                                                       
!     EVOLINT.F Evaluate convolution in x space (DIFF FROM SRC CODE: NO 
!                                                                       
      SUBROUTINE LH_PDFEVOLX(x,pdftmp) 
      IMPLICIT none 
!                                                                       
      INTEGER IPT,IMODEV,IVFN,ITMC 
      COMMON /NNPDF10EVFLAGS/ IPT,IMODEV,IVFN,ITMC 
      REAL*8 EPSEVOL 
      COMMON /NNPDF10EVOLACC/ EPSEVOL 
!                                                                       
      REAL*8 gm2ns(4),gm2ns24(2),gm2sg(2,2) 
      COMMON /nnpdf10GM2/gm2ns,gm2ns24,gm2sg 
!                                                                       
      REAL*8 q20,q2 
      COMMON/nnpdf10EVSCALE/q20,q2 
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON /nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      INTEGER i,j,k 
!                                                                       
      REAL*8 x 
      REAL*8 pdfevolx1(13),pdf0(13),pdftmp(13) 
      REAL*8 pdfevolx24(2) 
      REAL*8 LH_pdfevolxint_ns,LH_pdfevolxint_sg,LH_pdfevolxint_ns24 
      EXTERNAL LH_pdfevolxint_ns,LH_pdfevolxint_ns24,LH_pdfevolxint_sg 
!                                                                       
      call LH_PDFIN(x,pdf0) 
!                                                                       
      do i=1,13 
         pdfevolx1(i)=0d0 
         pdftmp(i)=0d0 
      enddo 
!                                                                       
      DO k=1,2 
         DO j=1,2 
            pdfevolx1(j) = LH_pdfevolxint_sg(k,j,x) 
         ENDDO 
         pdftmp(k) = pdfevolx1(1)+gm2sg(k,1)*pdf0(1)+                   &
     &                    pdfevolx1(2)+gm2sg(k,2)*pdf0(2)               
      ENDDO 
!                                                                       
      pdfevolx1(3) = LH_pdfevolxint_ns(3,3,x) 
      pdftmp(3)    = pdfevolx1(3) + gm2ns(3)*pdf0(3) 
!                                                                       
      pdfevolx1(4) = LH_pdfevolxint_ns(4,4,x) 
      pdftmp(4)    = pdfevolx1(4) + gm2ns(4)*pdf0(4) 
!                                                                       
      pdfevolx1(5) = LH_pdfevolxint_ns(4,5,x) 
      pdftmp(5)    = pdfevolx1(5) + gm2ns(4)*pdf0(5) 
!                                                                       
      pdfevolx1(6) = LH_pdfevolxint_ns(3,6,x) 
      pdftmp(6)    = pdfevolx1(6) + gm2ns(3)*pdf0(6) 
!                                                                       
      pdfevolx1(7) = LH_pdfevolxint_ns(4,7,x) 
      pdftmp(7)    = pdfevolx1(7) + gm2ns(4)*pdf0(7) 
!                                                                       
      pdfevolx1(8) = LH_pdfevolxint_ns(3,8,x) 
      pdftmp(8)    = pdfevolx1(8) + gm2ns(3)*pdf0(8) 
!                                                                       
      DO k=9,11 
         pdfevolx1(k) = LH_pdfevolxint_ns(1,k,x) 
         pdftmp(k)    = pdfevolx1(k) + gm2ns(1)*pdf0(k) 
      ENDDO 
!                                                                       
      IF(IVFN.EQ.0) THEN 
         DO k=12,13 
            pdftmp(k)    = pdftmp(1) 
         ENDDO 
      ELSE 
         DO j=1,2 
            pdfevolx24(j) = LH_pdfevolxint_ns24(j,x) 
         ENDDO 
         pdftmp(12) = pdfevolx24(1) + gm2ns24(1)*pdf0(1)                &
     &        + pdfevolx24(2) + gm2ns24(2)*pdf0(2)                      
         pdftmp(13) = pdftmp(1) 
      ENDIF 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_pdfevolxint_sg(ll,cc,xc) 
      IMPLICIT none 
!                                                                       
      INTEGER npoints 
      PARAMETER(npoints=2**8) 
      INTEGER ieval,niter,nmax 
      COMMON /nnpdf10NGRID/ ieval,niter,nmax 
      REAL*8 EPSEVOL 
      COMMON /NNPDF10EVOLACC/ EPSEVOL 
!                                                                       
!  qnt ridefinite gm2ns(4,ndata)-> gm2ns(4)                             
      REAL*8 xx(NPOINTS),wn(NPOINTS),evkns(4,NPOINTS),                  &
     &     evksg(2,2,NPOINTS),evkns24(2,NPOINTS)                        
      COMMON /nnpdf10XEVK/ xx,wn,evkns,evksg,evkns24 
!                                                                       
      REAL*8 q20,q2 
      COMMON/nnpdf10EVSCALE/q20,q2 
      REAL*8 q2th(4:6),asref,q2ref 
      REAL*8 as0,asc,asb,ast,asq 
      COMMON/nnpdf10VFNS/ q2th,asref,q2ref 
      COMMON /NNPDF10AS/ as0,asc,asb,ast,asq 
!                                                                       
      REAL*8 LH_pdfevolxint_sg 
      INTEGER NGAUSS 
      PARAMETER(NGAUSS=4) 
      INTEGER ll,cc 
      INTEGER j,k,idum,kk 
      INTEGER nint 
      REAL*8 xc,EPSTMP 
      REAL*8 trap1,trap2 
      REAL*8 y,pdf0(13),pdf1(13) 
!                                                                       
      CALL LH_PDFIN(xc,pdf0) 
!                                                                       
      trap2=0.d0 
      idum=0 
      k=0 
      kk=0 
!                                                                       
  187 NINT=2**kk 
      kk=kk+1 
      trap1=trap2 
      trap2=0.d0 
!                                                                       
      DO j=1+k,NGAUSS*NINT+k 
         idum=idum+1 
         y=xx(j) 
         CALL LH_PDFIN(xc/y,pdf1) 
         trap2 = trap2                                                  &
     &          + wn(j)*evksg(ll,cc,j)*(pdf1(cc)/y-y*pdf0(cc))/y        
      ENDDO 
                                                                        
      k=idum 
!                                                                       
      EPSTMP=DABS((trap2-trap1)/trap2) 
      IF(EPSTMP.GT.EPSEVOL.and.idum.lt.NMAX)then 
         GOTO 187 
      ELSE 
         LH_pdfevolxint_sg=trap2 
      ENDIF 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_pdfevolxint_ns(nsflag,iflav,xc) 
      IMPLICIT none 
!                                                                       
      INTEGER npoints 
      PARAMETER(npoints=2**8) 
      INTEGER ieval,niter,nmax 
      COMMON /nnpdf10NGRID/ ieval,niter,nmax 
      REAL*8 EPSEVOL 
      COMMON /NNPDF10EVOLACC/ EPSEVOL 
!                                                                       
!  qnt ridefinite gm2ns(4,ndata)-> gm2ns(4)                             
      REAL*8 xx(NPOINTS),wn(NPOINTS),evkns(4,NPOINTS),                  &
     &     evksg(2,2,NPOINTS),evkns24(2,NPOINTS)                        
      COMMON /nnpdf10XEVK/ xx,wn,evkns,evksg,evkns24 
!                                                                       
      REAL*8 LH_PDFEVOLXINT_NS 
!                                                                       
      INTEGER nsflag,iflav 
      INTEGER j,k,idum,kk 
      INTEGER nint 
      REAL*8 xc,EPSTMP 
      REAL*8 trap1,trap2 
      REAL*8 y,pdf0(13),pdf1(13) 
      INTEGER NGAUSS 
      PARAMETER(NGAUSS=4) 
!                                                                       
      call LH_PDFIN(xc,pdf0) 
!                                                                       
      trap2=0.d0 
      idum=0 
      k=0 
      kk=0 
!                                                                       
  187 NINT=2**kk 
      kk=kk+1 
      trap1=trap2 
      trap2=0.d0 
!                                                                       
      do j=1+k,NGAUSS*NINT+k 
         idum=idum+1 
         y=xx(j) 
         call LH_PDFIN(xc/y,pdf1) 
                                                                        
         trap2 = trap2                                                  &
     &     + wn(j)*evkns(nsflag,j)*(pdf1(iflav)/y-y*pdf0(iflav))/y      
      enddo 
      k=idum 
!                                                                       
      EPSTMP=DABS((trap2-trap1)/trap2) 
      IF(EPSTMP.GT.EPSEVOL.and.idum.lt.NMAX)then 
         goto 187 
      else 
         LH_pdfevolxint_ns=trap2 
      endif 
!                                                                       
      RETURN 
      END                                           
!                                                                       
      FUNCTION LH_pdfevolxint_ns24(ns24flag,xc) 
      IMPLICIT none 
!                                                                       
      INTEGER npoints 
      PARAMETER(npoints=2**8) 
      INTEGER ieval,niter,nmax 
      COMMON /nnpdf10NGRID/ ieval,niter,nmax 
      REAL*8 EPSEVOL 
      COMMON /NNPDF10EVOLACC/ EPSEVOL 
!                                                                       
!  qnt ridefinite gm2ns(4,ndata)-> gm2ns(4)                             
      REAL*8 xx(NPOINTS),wn(NPOINTS),evkns(4,NPOINTS),                  &
     &     evksg(2,2,NPOINTS),evkns24(2,NPOINTS)                        
      COMMON /nnpdf10XEVK/ xx,wn,evkns,evksg,evkns24 
!                                                                       
      REAL*8 LH_pdfevolxint_ns24 
!                                                                       
      INTEGER ns24flag 
      INTEGER j,k,idum,kk 
      INTEGER nint 
      REAL*8 xc,epstmp 
      REAL*8 trap1,trap2 
      REAL*8 y,pdf0(13),pdf1(13) 
      INTEGER NGAUSS 
      PARAMETER(NGAUSS=4) 
!                                                                       
      call LH_PDFIN(xc,pdf0) 
!                                                                       
      trap2=0.d0 
      idum=0 
      k=0 
      kk=0 
!                                                                       
  187 NINT=2**kk 
      kk=kk+1 
      trap1=trap2 
      trap2=0.d0 
!                                                                       
      do j=1+k,NGAUSS*NINT+k 
         idum=idum+1 
         y=xx(j) 
         call LH_PDFIN(xc/y,pdf1) 
         trap2 = trap2                                                  &
     &        + wn(j)*evkns24(ns24flag,j)                               &
     &        *(pdf1(ns24flag)/y-y*pdf0(ns24flag))/y                    
      enddo 
      k=idum 
!                                                                       
      EPSTMP=DABS((trap2-trap1)/trap2) 
      IF(EPSTMP.GT.EPSEVOL.and.idum.lt.NMAX)then 
         goto 187 
      else 
         LH_pdfevolxint_ns24=trap2 
      endif 
!                                                                       
      RETURN 
      END                                           
                                                                        
!****                                                                   
! 9 *-------------------------------------------------------------------
!****                                                                   
!                                                                       
!     Change of basis from NN basis to pdfparam                         
!     based on Flavour Assumptions see eq. 86 of notes PTevol.pdf       
!                                                                       
!     Convert from the INPUTPARAMETRIZATION convention for PDF ordering:
!     to the  EVOLUTION convention:                                     
                                                                        
!       1    2   3   4   5   6   7   8    9    10   11    12    13      
!     Sigma  g  u_v d_v s_v c_v b_v t_v  T_3  T_8  T_15  T_24  T_35     
                                                                        
!     Convention for pdfs parametrized with nets                        
!     PDFIN(1) -> Singlet                                               
!     PDFIN(2) -> Gluon                                                 
!     PDFIN(3) -> Triplet T_3                                           
!     PDFIN(4) -> TotalValence V                                        
!     PDFIN(5) -> SeaAsymmetry Delta_S                                  
                                                                        
!     Convention for input PDFs to evolution equations                  
!     PDFOUT(1) = Singlet                                               
!     PDFOUT(2) = Gluon                                                 
!     PDFOUT(3) = u_v = ( V + T_3 + 2 Delta_S )/2                       
!     PDFOUT(4) = d_v = ( V - T_3 - 2 Delta_S )/2                       
!     PDFOUT(5) = s_v = 0                                               
!     PDFOUT(6) = c_v = 0                                               
!     PDFOUT(7) = b_v = 0                                               
!     PDFOUT(8) = t_v = 0                                               
!     PDFOUT(9) = T_3                                                   
!     PDFOUT(10)= T_8 = ( 1 / ( 2 + C ) ) * ( 3*C*V + 2(1-C)*Singlet )  
!     PDFOUT(11) = T_15 = Singlet                                       
!     PDFOUT(12) = T_24 = Singlet                                       
!     PDFOUT(13) = T_35 = Singlet                                       
                                                                        
!***************************                                            
!                                                                       
      SUBROUTINE LH_pdfinpar2evln(PDFIN,PDFOUT) 
      implicit none 
!                                                                       
      integer I,J 
      integer MXPDF 
      parameter(MXPDF=13) 
      integer NTOTPDF 
      parameter(NTOTPDF=5) 
!                                                                       
      REAL*8 PDFIN(NTOTPDF),PDFOUT(MXPDF) 
      REAL*8 par2evln(mxpdf,ntotpdf) 
      COMMON/nnpdf10PPAR2EVLN/PAR2EVLN 
!                                                                       
      CALL LH_initpar2evln 
!                                                                       
      DO I=1,MXPDF 
         PDFOUT(I) = 0D0 
         DO J=1,NTOTPDF 
            PDFOUT(I) = PDFOUT(I) + PAR2EVLN(I,J) * PDFIN(J) 
         ENDDO 
      ENDDO 
!                                                                       
      RETURN 
      END                                           
!                                                                       
!                                                                       
      SUBROUTINE LH_initpar2evln 
      IMPLICIT none 
!                                                                       
      integer I,J 
      integer MXPDF 
      parameter(MXPDF=13) 
      integer NTOTPDF 
      parameter(NTOTPDF=5) 
      integer MXPAR 
      parameter(MXPAR=2e2) 
      real*8 CS 
      parameter(CS = 0.5) 
!                                                                       
      REAL*8 par2evln(mxpdf,ntotpdf) 
      COMMON/nnpdf10PPAR2EVLN/PAR2EVLN 
!                                                                       
      do i = 1,mxpdf 
         do j = 1, ntotpdf 
            par2evln(i,j) = 0d0 
         enddo 
      enddo 
      PAR2EVLN(1,1) = 1d0 
      PAR2EVLN(2,2) = 1d0 
      PAR2EVLN(3,3) = 0.5d0 
      PAR2EVLN(3,4) = 0.5d0 
      PAR2EVLN(3,5) = 1d0 
      PAR2EVLN(4,3) = - 0.5d0 
      PAR2EVLN(4,4) = 0.5d0 
      PAR2EVLN(4,5) = - 1d0 
      PAR2EVLN(9,3) = 1d0 
      PAR2EVLN(10,1) = 2.d0*(1d0 - CS)/(2d0 + CS) 
      PAR2EVLN(10,4) = 3d0*CS/(2d0 + CS) 
      PAR2EVLN(11,1) = 1d0 
      PAR2EVLN(12,1) = 1d0 
      PAR2EVLN(13,1) = 1d0 
!                                                                       
      return 
      END                                           
!                                                                       
!     Change of basis from our basis to LHAPDF one:                     
!     Computes the PDFs of the single partons starting from the T_i and 
!     combinations which are used in the evolution.                     
!                                                                       
!     The combinations used in the evolution are numbered               
!     according to the following table:                                 
!                                                                       
!       1    2   3   4   5   6   7   8    9    10   11    12    13      
!     Sigma  g  u_v d_v s_v c_v b_v t_v  T_3  T_8  T_15  T_24  T_35     
!                                                                       
!     The output PDFs are numbered according to the Les Houches         
!     convention:                                                       
!                                                                       
!      -6   -5   -4   -3   -2   -1   0   1   2   3   4   5   6          
!     tbar bbar cbar sbar ubar dbar  g   d   u   s   c   b   t          
!                                                                       
!                                                                       
      SUBROUTINE LH_PDFEVLN2LHA(pdfin,pdfout) 
      IMPLICIT none 
!                                                                       
      INTEGER I,J 
      integer MXPDF 
      parameter(MXPDF=13) 
!                                                                       
      REAL*8 pdfin(MXPDF),pdfout(-6:6) 
      REAL*8 evln2lha(mxpdf,mxpdf) 
      COMMON/nnpdf10EEVLN2LHA/EVLN2LHA 
!                                                                       
      CALL LH_INITEVLN2LHA 
!                                                                       
      DO I = 1,MXPDF 
         PDFOUT(I-7)=0D0 
         DO J = 1,MXPDF 
            PDFOUT(I-7) = PDFOUT(I-7) + EVLN2LHA(I,J)*PDFIN(J) 
         ENDDO 
      ENDDO 
!                                                                       
      RETURN 
      END                                           
!                                                                       
!                                                                       
      SUBROUTINE LH_INITEVLN2LHA 
      IMPLICIT none 
!                                                                       
      INTEGER I,J 
!                                                                       
      INTEGER IPT,IMODEV,IVFN,ITMC 
      COMMON /NNPDF10EVFLAGS/ IPT,IMODEV,IVFN,ITMC 
      integer MXPDF 
      parameter(MXPDF=13) 
!                                                                       
      REAL*8 evln2lha(mxpdf,mxpdf) 
      COMMON/nnpdf10EEVLN2LHA/EVLN2LHA 
!                                                                       
!     Write it as a matrix for LHAPDF interface                         
!     PDFOUT(I-7) = EVLN2LHA(I,J) * PDFIN(J)                            
!                                                                       
      IF(IVFN.EQ.1) THEN 
!                                                                       
         do i = 1,mxpdf 
            do j = 1,mxpdf 
               evln2lha(i,j) = 0d0 
            enddo 
         enddo 
!                                                                       
         DO i=1,mxpdf 
            evln2lha(i,1) = 10d0 
         ENDDO 
         evln2lha(7,1)  = 0d0 
!                                                                       
         evln2lha(7,2)  = 120d0 
!                                                                       
         evln2lha(5,3)  = - 60d0 
         evln2lha(9,3)  = + 60d0 
!                                                                       
         evln2lha(6,4)  = - 60d0 
         evln2lha(8,4)  = + 60d0 
!                                                                       
         evln2lha(4,5)  = - 60d0 
         evln2lha(10,5) = + 60d0 
!                                                                       
         evln2lha(3,6)  = - 60d0 
         evln2lha(11,6) = + 60d0 
!                                                                       
         evln2lha(2,7)  = - 60d0 
         evln2lha(12,7) = + 60d0 
!                                                                       
         evln2lha(1,8)  = - 60d0 
         evln2lha(13,8) = + 60d0 
!                                                                       
         evln2lha(5,9)  = + 30d0 
         evln2lha(6,9)  = - 30d0 
         evln2lha(8,9)  = - 30d0 
         evln2lha(9,9)  = + 30d0 
!                                                                       
         evln2lha(4,10) = - 20d0 
         evln2lha(5,10) = + 10d0 
         evln2lha(6,10) = + 10d0 
         evln2lha(8,10) = + 10d0 
         evln2lha(9,10) = + 10d0 
         evln2lha(10,10)= - 20d0 
!                                                                       
         evln2lha(3,11) = - 15d0 
         evln2lha(4,11) = + 5d0 
         evln2lha(5,11) = + 5d0 
         evln2lha(6,11) = + 5d0 
         evln2lha(8,11) = + 5d0 
         evln2lha(9,11) = + 5d0 
         evln2lha(10,11)= + 5d0 
         evln2lha(11,11)= - 15d0 
!                                                                       
         evln2lha(2,12) = - 12d0 
         evln2lha(3,12) = + 3d0 
         evln2lha(4,12) = + 3d0 
         evln2lha(5,12) = + 3d0 
         evln2lha(6,12) = + 3d0 
         evln2lha(8,12) = + 3d0 
         evln2lha(9,12) = + 3d0 
         evln2lha(10,12)= + 3d0 
         evln2lha(11,12)= + 3d0 
         evln2lha(12,12)= - 12d0 
!                                                                       
         evln2lha(1,13) = - 10d0 
         evln2lha(2,13) = + 2d0 
         evln2lha(3,13) = + 2d0 
         evln2lha(4,13) = + 2d0 
         evln2lha(5,13) = + 2d0 
         evln2lha(6,13) = + 2d0 
         evln2lha(8,13) = + 2d0 
         evln2lha(9,13) = + 2d0 
         evln2lha(10,13)= + 2d0 
         evln2lha(11,13)= + 2d0 
         evln2lha(12,13)= + 2d0 
         evln2lha(13,13)= - 10d0 
!                                                                       
         do i = 1,mxpdf 
            do j = 1,mxpdf 
               evln2lha(i,j) = evln2lha(i,j) / 120d0 
            enddo 
         enddo 
                                                                        
      ELSE 
!                                                                       
         do i = 1,mxpdf 
            do j = 1,mxpdf 
               evln2lha(i,j) = 0d0 
            enddo 
         enddo 
!                                                                       
         DO i=1,mxpdf 
            evln2lha(i,1) = 3d0 
         ENDDO 
         evln2lha(7,1)  = 0d0 
!                                                                       
         evln2lha(7,2)  = 24d0 
!                                                                       
         evln2lha(5,3)  = - 12d0 
         evln2lha(9,3)  = + 12d0 
!                                                                       
         evln2lha(6,4)  = - 12d0 
         evln2lha(8,4)  = + 12d0 
!                                                                       
         evln2lha(4,5)  = - 12d0 
         evln2lha(10,5) = + 12d0 
!                                                                       
         evln2lha(3,6)  = - 12d0 
         evln2lha(11,6) = + 12d0 
!                                                                       
         evln2lha(5,9)  = + 6d0 
         evln2lha(6,9)  = - 6d0 
         evln2lha(8,9)  = - 6d0 
         evln2lha(9,9)  = + 6d0 
!                                                                       
         evln2lha(4,10) = - 4d0 
         evln2lha(5,10) = + 2d0 
         evln2lha(6,10) = + 2d0 
         evln2lha(8,10) = + 2d0 
         evln2lha(9,10) = + 2d0 
         evln2lha(10,10)= - 4d0 
!                                                                       
         evln2lha(3,11) = - 3d0 
         evln2lha(4,11) = + 1d0 
         evln2lha(5,11) = + 1d0 
         evln2lha(6,11) = + 1d0 
         evln2lha(8,11) = + 1d0 
         evln2lha(9,11) = + 1d0 
         evln2lha(10,11)= + 1d0 
         evln2lha(11,11)= - 3d0 
!                                                                       
         do i = 1,mxpdf 
            do j = 1,mxpdf 
               evln2lha(i,j) = evln2lha(i,j) / 24d0 
            enddo 
         enddo 
!                                                                       
      ENDIF 
!                                                                       
      RETURN 
      END                                           
                                                                        
!                                                                       
!     pdfevln2inpar.f                                                   
!                                                                       
!     Convert from the  EVOLUTION convention:                           
!       1    2   3   4   5   6   7   8    9    10   11    12    13      
!     Sigma  g  u_v d_v s_v c_v b_v t_v  T_3  T_8  T_15  T_24  T_35     
!                                                                       
!     to the INPUTPARAMETRIZATION convention for PDF ordering:          
!     based on Flavour Assumptions                                      
!                                                                       
                                                                        
      subroutine LH_PDFEVLN2INPAR(PDFIN,PDFOUT) 
      implicit none 
!                                                                       
      integer MXPDF 
      parameter(MXPDF=13) 
      integer NTOTPDF 
      parameter(NTOTPDF=5) 
      real*8 PDFIN(MXPDF),PDFOUT(NTOTPDF) 
                                                                        
!     JPDF=1 -> Singlet                                                 
      PDFOUT(1) = PDFIN(1) 
                                                                        
!     JPDF=2 -> Gluon                                                   
      PDFOUT(2) = PDFIN(2) 
                                                                        
!     JPDF=3 -> Triplet                                                 
      PDFOUT(3) = PDFIN(9) 
                                                                        
!     JPDF=4 -> Total Valence -> V_T = u_V + d_V                        
      PDFOUT(4) = PDFIN(3) + PDFIN(4) 
                                                                        
!     JPDF=5 -> Sea Asymmetry -> Delta_S = ( u_V - d_V - T_3 )/2        
      PDFOUT(5) = ( PDFIN(3) - PDFIN(4) - PDFIN(9) )/2d0 
                                                                        
      return 
      END                                           
                                                                        
!*****                                                                  
! 10 *------------------------------------------------------------------
!*****                                                                  
!                                                                       
!     File: andim_lo.f                                                  
!     Returns the LO anomalous dimensions in the                        
!                                                                       
       SUBROUTINE LH_ANDIM_LO(N,NF,P0NS,P0SG) 
       IMPLICIT none 
!                                                                       
       REAL*8 ca,cf,tr 
       COMMON/NNPDF10COLFACT/ca,cf,tr 
       REAL*8 emc,zeta2,zeta3,zeta4,pi 
       PARAMETER (pi    = 3.1415926535897932385) 
       COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
       COMPLEX*16 LH_PSI, S1 
!                                                                       
       COMPLEX*16 NS,N1,N2,NM 
       COMPLEX*16 PQQA,PQGA,PGQA,PGGA,PGGB 
       COMPLEX*16 N 
       INTEGER NF 
       COMPLEX*16 P0NS 
       COMPLEX*16 P0SG (2,2) 
!                                                                       
       NS = N * N 
       N1 = N + cmplx(1d0,0d0) 
       N2 = N + (2d0,0d0) 
       NM = N - (1d0,0d0) 
!                                                                       
       S1 = cmplx(EMC,0d0) + LH_PSI(N1) 
       PQQA = (3d0,0d0) - 4d0* S1 + 2d0/(N * N1) 
       PQGA = 4d0* (NS + N + 2d0) / (N * N1 * N2) 
       PGQA = 2d0 * (NS + N + 2d0) / (N * N1 * NM) 
       PGGA = 11d0/3D0 - 4d0* S1 + 4d0/(N * NM) + 4d0/(N1 * N2) 
       PGGB = - 4d0/3D0 
!                                                                       
!     Output to the array                                               
       P0NS      = CF * PQQA 
!                                                                       
       P0SG(1,1) = CF * PQQA 
       P0SG(1,2) = TR * dble(NF) * PQGA 
       P0SG(2,1) = CF * PGQA 
       P0SG(2,2) = CA * PGGA + TR *dble(NF) * PGGB 
!                                                                       
       RETURN 
      END                                           
!                                                                       
!     File: andim_nlo.f                                                 
!     Returns the NLO anomalous dimensions in the                       
!                                                                       
      SUBROUTINE LH_ANDIM_NLO(N,NF,P1NS,P1SG) 
      IMPLICIT none 
!                                                                       
      REAL*8 ca,cf,tr 
      COMMON/NNPDF10COLFACT/ca,cf,tr 
      REAL*8 emc,zeta2,zeta3,zeta4,pi 
      PARAMETER (pi    = 3.1415926535897932385) 
      COMMON /NNPDF10CONSTS/ emc,zeta2,zeta3,zeta4 
!                                                                       
      COMPLEX*16 LH_DPSI,LH_PSI, S1, S2 
      INTEGER I,J 
      COMPLEX*16 NS,NT,NFO,NFI,NSI,NSE,NE,NN 
      COMPLEX*16 N1,N2,NM,NMS,N1S,N1T,N2S,N2T 
      COMPLEX*16 N3,N4,N5,N6 
      COMPLEX*16 S11,S12,S13,S14,S15,S16 
      COMPLEX*16 SPMOM,SLC,SLV,SSCHLM,SSTR2M,SSTR3M,SSCHLP 
      COMPLEX*16 SSTR2P,SSTR3P 
      COMPLEX*16 PPSA,PQGA,PGQA,PGGA,PQGB,PGQB,PGGB,PGQC,PGGC 
      COMPLEX*16 PNPA,PNMA,PNSB,PNSC 
      COMPLEX*16 N 
      INTEGER NF 
      COMPLEX*16 P1NS(3) 
      COMPLEX*16 P1SG(2,2) 
!                                                                       
      S1 = EMC + LH_PSI(N+1d0) 
      S2 = ZETA2 - LH_DPSI(N+1d0,1) 
!                                                                       
      NS = N * N 
      NT = NS * N 
      NFO = NT * N 
      NFI = NFO * N 
      NSI = NFI * N 
      NSE = NSI * N 
      NE = NSE * N 
      NN = NE * N 
!                                                                       
      NM = N - 1d0 
      N1 = N + 1d0 
      N2 = N + 2d0 
      NMS = NM * NM 
      N1S = N1 * N1 
      N1T = N1S * N1 
      N2S = N2 * N2 
      N2T = N2S * N2 
                                                                        
! ..Analytic continuations of the occuring sums as given in GRV (1990)  
!   (with an improved parametrization of the moments of  Sp(x)/(1+x).)  
!                                                                       
       N3 = N + 3D0 
       N4 = N + 4D0 
       N5 = N + 5D0 
       N6 = N + 6D0 
       S11 = S1  + 1D0/N1 
       S12 = S11 + 1D0/N2 
       S13 = S12 + 1D0/N3 
       S14 = S13 + 1D0/N4 
       S15 = S14 + 1D0/N5 
       S16 = S15 + 1D0/N6 
       SPMOM = 1.0000D0 * (ZETA2 - S1 / N ) / N  -                      &
     &         0.9992D0 * (ZETA2 - S11/ N1) / N1 +                      &
     &         0.9851D0 * (ZETA2 - S12/ N2) / N2 -                      &
     &         0.9005D0 * (ZETA2 - S13/ N3) / N3 +                      &
     &         0.6621D0 * (ZETA2 - S14/ N4) / N4 -                      &
     &         0.3174D0 * (ZETA2 - S15/ N5) / N5 +                      &
     &         0.0699D0 * (ZETA2 - S16/ N6) / N6                        
!                                                                       
       SLC = - 5D0/8D0 * ZETA3 
       SLV = - ZETA2/2D0* (LH_PSI(N1/2D0) - LH_PSI(N/2D0))              &
     & + S1/NS + SPMOM                                                  
       SSCHLM = SLC - SLV 
       SSTR2M = ZETA2 - LH_DPSI (N1/2D0,1) 
       SSTR3M = 0.5D0 * LH_DPSI (N1/2D0,2) + ZETA3 
                                                                        
       SSCHLP = SLC + SLV 
       SSTR2P = ZETA2 - LH_DPSI(N2/2D0,1) 
       SSTR3P = 0.5D0 * LH_DPSI(N2/2D0,2) + ZETA3 
                                                                        
!                                                                       
! ..The contributions to P1NS as given in Gonzalez-Arroyo et al. (1979) 
!   (Note that the anomalous dimensions in the literature often differ  
!    from these moments of the splitting functions by factors -1 or -2, 
!    in addition to possible different normalizations of the coupling)  
!                                                                       
                                                                        
       PNMA = ( 16D0* S1 * (2D0* N + 1D0) / (NS * N1S) +                &
     &      16D0* (2D0* S1 - 1D0/(N * N1)) * ( S2 - SSTR2M ) +          &
     &      64D0* SSCHLM + 24D0* S2 - 3D0 - 8D0* SSTR3M -               &
     &      8D0* (3D0* NT + NS -1D0) / (NT * N1T) +                     &
     &      16D0* (2D0* NS + 2D0* N +1D0) / (NT * N1T) ) * (-0.5D0)     
       PNPA = ( 16D0* S1 * (2D0* N + 1D0) / (NS * N1S) +                &
     &      16D0* (2D0* S1 - 1D0/(N * N1)) * ( S2 - SSTR2P ) +          &
     &      64D0* SSCHLP + 24D0* S2 - 3D0 - 8D0* SSTR3P -               &
     &      8D0* (3D0* NT + NS -1D0) / (NT * N1T) -                     &
     &      16D0* (2D0* NS + 2D0* N +1D0)/(NT * N1T) ) * (-0.5D0)       
                                                                        
       PNSB = ( S1 * (536D0/9D0 + 8D0* (2D0* N + 1D0) / (NS * N1S)) -   &
     &      (16D0* S1 + 52D0/3D0- 8D0/(N * N1)) * S2 - 43D0/6D0 -       &
     &      (151D0* NFO + 263D0* NT + 97D0* NS + 3D0* N + 9D0) *        &
     &      4D0/ (9D0* NT * N1T) ) * (-0.5D0)                           
       PNSC = ( -160D0/9D0* S1 + 32D0/3.* S2 + 4D0/3D0 +                &
     &      16D0*(11D0*NS+5D0*N-3D0)/(9D0* NS * N1S))*(-0.5D0)          
!                                                                       
!     ..The contributions to P1SG as given in Floratos et al. (1981)    
!     ..Pure singlet (PS) and QG                                        
!                                                                       
       PPSA = (5d0* NFI + 32d0* NFO + 49d0* NT+38d0* NS + 28d0* N + 8d0)&
     &      / (NM * NT * N1T * N2S) * 2d0                               
!                                                                       
       PQGA = (-2d0* S1 * S1 + 2d0* S2 - 2d0* SSTR2P)                   &
     &      * (NS + N + 2d0) / (N * N1 * N2)                            &
     &      + (8d0* S1 * (2d0* N + 3d0)) / (N1S * N2S)                  &
     &      + 2d0* (NN + 6d0* NE + 15d0* NSE + 25d0* NSI + 36d0* NFI    &
     &      + 85d0* NFO + 128d0* NT + 104d0* NS + 64d0* N + 16d0)       &
     &      / (NM * NT * N1T * N2T)                                     
       PQGB = (2d0* S1 * S1 - 2d0* S2 + 5d0) * (NS + N + 2d0)           &
     &      / (N * N1 * N2) - 4d0* S1 / NS                              &
     &      + (11d0* NFO + 26d0* NT + 15d0* NS + 8d0* N + 4d0)          &
     &      / (NT * N1T * N2)                                           
                                                                        
!                                                                       
!     ..GQ and GG                                                       
       PGQA = (- S1 * S1 + 5d0* S1 - S2) * (NS + N + 2d0)               &
     &      / (NM * N * N1)  -  2d0* S1 / N1S                           &
     &      - (12d0* NSI + 30d0* NFI + 43d0* NFO + 28d0* NT - NS        &
     &      - 12d0* N - 4d0) / (2d0* NM * NT * N1T)                     
       PGQB = (S1*S1 + S2 - SSTR2P) * (NS + N + 2d0) / (NM * N * N1)    &
     &      - S1 * (17d0* NFO + 41d0* NS - 22d0* N - 12d0)              &
     &      / (3d0* NMS * NS * N1)                                      &
     &      + (109d0* NN + 621d0* NE + 1400d0* NSE + 1678d0* NSI        &
     &      + 695d0* NFI - 1031d0* NFO - 1304d0* NT - 152d0* NS         &
     &      + 432d0* N + 144d0) / (9d0* NMS * NT * N1T * N2S)           
       PGQC = (S1 - 8d0/3d0) * (NS + N + 2d0) / (NM * N * N1) + 1d0/ N1S 
       PGQC = 4d0/3d0* PGQC 
!                                                                       
       PGGA = - (2d0* NFI + 5d0* NFO + 8d0* NT + 7d0* NS- 2d0* N - 2d0) &
     &      * 8d0* S1 / (NMS * NS * N1S * N2S) -  67d0/9d0* S1 + 8d0/3d0&
     &      - 4d0* SSTR2P * (NS + N + 1d0) / (NM * N * N1 * N2)         &
     &      + 2d0* S1 * SSTR2P - 4d0* SSCHLP + 0.5d0 * SSTR3P           &
     &      + (457d0* NN + 2742d0* NE + 6040d0* NSE + 6098d0* NSI       &
     &      + 1567d0* NFI - 2344d0* NFO - 1632d0* NT + 560d0* NS        &
     &      + 1488d0* N + 576d0) / (18d0* NMS * NT * N1T * N2T)         
       PGGB = (38d0* NFO + 76d0* NT + 94d0* NS + 56d0* N + 12d0) *(-2d0)&
     &      / (9d0* NM * NS * N1S * N2)  +  20d0/9d0* S1  -  4d0/3d0    
       PGGC = (2d0* NSI + 4d0* NFI + NFO - 10d0* NT - 5d0* NS - 4d0* N  &
     &      - 4d0) * (-2d0) / (NM * NT * N1T * N2)  -  1d0              
!                                                                       
!     Output to the array                                               
       DO I=1,2 
          DO J=1,2 
             P1SG(I,J)=0d0 
          ENDDO 
       ENDDO 
                                                                        
       do I=1,3 
          P1NS(I)=0d0 
       enddo 
!                                                                       
!     NON SINGLET                                                       
!                                                                       
!     Plus                                                              
       P1NS(1) = CF *((CF-CA/2d0)* PNPA + CA* PNSB + TR*dble(NF)* PNSC) 
                                                                        
!     Minus=Valence                                                     
       P1NS(2) = CF *((CF-CA/2d0)* PNMA + CA* PNSB + TR*dble(NF)* PNSC) 
       P1NS(3) = P1NS(2) 
!                                                                       
!     SINGLET                                                           
       P1SG(1,1) = P1NS(1) + TR*dble(NF)*CF*PPSA*4d0 
       P1SG(1,2) = TR*dble(NF) * (CA * PQGA + CF * PQGB)*4d0 
       P1SG(2,1) = (CF*CF*PGQA + CF*CA*PGQB+TR*dble(NF)*CF*PGQC)*4d0 
       P1SG(2,2) = (CA*CA*PGGA + TR*dble(NF)*(CA*PGGB+CF*PGGC))*4d0 
!                                                                       
       RETURN 
      END                                           
!*****                                                                  
! 10 *------------------------------------------------------------------
!*****                                                                  
!                                                                       
!      matutils.f                                                       
!      A collection of Fortran utilities to deal with matrices:         
!        - multiplication (mmult_c, mmult_r).                           
!        - equating (mequal_c,mequal_r)                                 
!                                                                       
      SUBROUTINE LH_MMULT_C(A,ROWSA,COLSA,B,ROWSB,COLSB,C) 
      IMPLICIT none 
!                                                                       
      INTEGER ROWSA,COLSA,ROWSB,COLSB 
      COMPLEX*16 A(ROWSA,COLSA), B(ROWSB,COLSB), C(ROWSA,COLSB) 
      INTEGER I,J,K 
!                                                                       
!     Check that the matrices we would like to multiply have the        
!     correct dimensions                                                
!                                                                       
      IF (COLSA .NE. ROWSB) THEN 
          WRITE(*,*) 'Coglione... dimensioni delle matrici sbagliate!' 
          RETURN 
      ELSE 
!                                                                       
!     Initialize the output matrix to zero                              
!                                                                       
        DO I = 1,ROWSA 
          DO J = 1,COLSB 
            C(I,J) = (0.0d0,0.0d0) 
          ENDDO 
        ENDDO 
!                                                                       
!     Perform the multiplication according to:                          
!                          C[i,j] = Sum_k(A[i,k]*B[k,i])                
!                                                                       
        DO I = 1,ROWSA 
          DO J = 1,COLSB 
            DO K = 1,COLSA 
              C(I,J) = C(I,J) + A(I,K) * B(K,J) 
            ENDDO 
          ENDDO 
        ENDDO 
!                                                                       
      ENDIF 
      RETURN 
      END                                           
!                                                                       
!                                                                       
      SUBROUTINE LH_MMULT_R(A,ROWSA,COLSA,B,ROWSB,COLSB,C) 
      IMPLICIT none 
!                                                                       
      INTEGER ROWSA,COLSA,ROWSB,COLSB 
!                                                                       
      REAL*8 A(ROWSA,COLSA), B(ROWSB,COLSB), C(ROWSA,COLSB) 
!                                                                       
      INTEGER I,J,K 
!                                                                       
!     Check that the matrices we would like to multiply have the        
!     correct dimensions                                                
      IF (COLSA .NE. ROWSB) THEN 
          WRITE(*,*) 'wrong dimensions in matrix' 
          RETURN 
      ELSE 
!                                                                       
!     Initialize the output matrix to zero                              
        DO I = 1,ROWSA 
          DO J = 1,COLSB 
            C(I,J) = 0.0d0 
          ENDDO 
        ENDDO 
                                                                        
!                                                                       
!     Perform the multiplication according to:                          
!                          C[i,j] = Sum_k(A[i,k]*B[k,i])                
        DO I = 1,ROWSA 
          DO J = 1,COLSB 
            DO K = 1,COLSA 
              C(I,J) = C(I,J) + A(I,K) * B(K,J) 
            ENDDO 
          ENDDO 
        ENDDO 
!                                                                       
      ENDIF 
      RETURN 
      END                                           
!                                                                       
!                                                                       
      SUBROUTINE LH_MEQUAL_C(A,B,I,J) 
      IMPLICIT none 
!                                                                       
      INTEGER I,J 
      INTEGER K,L 
      COMPLEX*16 A(I,J), B(I,J) 
!                                                                       
      DO K=1,I 
         DO L=1,J 
            A(K,L) = B(K,L) 
         ENDDO 
      ENDDO 
      RETURN 
      END                                           
!                                                                       
!                                                                       
      SUBROUTINE LH_MEQUAL_R(A,B,I,J) 
      IMPLICIT none 
!                                                                       
      INTEGER I,J 
      INTEGER K,L 
      REAL*8 A(I,J), B(I,J) 
!                                                                       
      DO K=1,I 
         DO L=1,J 
            A(K,L) = B(K,L) 
         ENDDO 
      ENDDO 
      RETURN 
      END                                           
!                                                                       
!     psi.f                                                             
!     CalculATE complex psi function,  PZI(Z),  and its m'th derivatives
!     DPZI(Z,M) from the asymtotic expansions. The                      
!     functional equations are used for  |Im(Z)| < 10  to shift the     
!     argument to  Re(Z) >= 10  before applying the expansions.         
!                                                                       
       FUNCTION LH_PSI (Z) 
       IMPLICIT COMPLEX*16 (A-Z) 
       SUB = 0D0 
       ZZ = Z 
!                                                                       
       IF (DABS(DIMAG(ZZ)) .LT. 10.D0) THEN 
!                                                                       
    1    CONTINUE 
         IF (DBLE(ZZ) .LT. 10.D0) THEN 
           SUB = SUB - 1d0/ ZZ 
           ZZ = ZZ + 1d0 
           GOTO 1 
         END IF 
!                                                                       
       END IF 
!                                                                       
! ..Use of the asymtotic expansion (at the shifted argument)            
!     Abramowitz-Stegun eq. 6.3.18 plus one term                        
!                                                                       
       RZ = 1d0/ ZZ 
       DZ = RZ * RZ 
       LH_PSI = SUB + LOG(ZZ) - 0.5d0 * RZ - DZ/5040D0 * ( 420d0+ DZ *  &
     &       ( - 42d0 + DZ * (20d0 - 21d0 * DZ) ) )                     
!                                                                       
       RETURN 
      END                                           
!                                                                       
!                                                                       
       FUNCTION LH_DPSI (Z,M) 
       IMPLICIT COMPLEX*16 (A-Z) 
!                                                                       
       INTEGER M, K1, K2 
       SUB = 0D0 
       ZZ = Z 
!                                                                       
! ..Shift of the argument using the functional equations                
       IF (DABS(DIMAG(ZZ)) .LT. 10.D0) THEN 
!                                                                       
    1    CONTINUE 
         SUBM = -1d0/ZZ 
         DO 10 K1 = 1, M 
           SUBM = - SUBM * K1 / ZZ 
   10    CONTINUE 
!                                                                       
         IF (DBLE(ZZ) .LT. 10.D0) THEN 
           SUB = SUB + SUBM 
           ZZ = ZZ + 1d0 
           GOTO 1 
         END IF 
!                                                                       
       END IF 
!                                                                       
! ..Expansion (Bernoulli) coefficients for the first derivative         
       A1 =  1D0 
       A2 =  1d0/2D0 
       A3 =  1d0/6D0 
       A4 = -1d0/30D0 
       A5 =  1d0/42D0 
       A6 = -1d0/30D0 
       A7 =  5d0/66D0 
!                                                                       
! ..Expansion coefficients for the higher derivatives                   
       IF (M .EQ. 1) GOTO 2 
       DO 11 K2 = 2, M 
         A1 = A1 * (dble(K2)-1d0) 
         A2 = A2 *  dble(K2) 
         A3 = A3 * (dble(K2)+1d0) 
         A4 = A4 * (dble(K2)+3d0) 
         A5 = A5 * (dble(K2)+5d0) 
         A6 = A6 * (dble(K2)+7d0) 
         A7 = A7 * (dble(K2)+9d0) 
   11  CONTINUE 
    2  CONTINUE 
!                                                                       
! ..Use of the asymtotic expansion (at the shifted argument)            
!                                                                       
       RZ = 1d0/ ZZ 
       DZ = RZ * RZ 
       LH_DPSI = SUB + (-1)**(M+1d0) * RZ**M * ( A1 + RZ * (A2 + RZ *   &
     &        (A3 + DZ * (A4 + DZ * (A5 + DZ * (A6 + A7 * DZ ))))) )    
!                                                                       
       RETURN 
      END                                           
!                                                                       
!     dgauss_intern.f                                                   
!                                                                       
      DOUBLE PRECISION FUNCTION LH_DGAUSS_INTERN(F,A,B,EPS) 
      DOUBLE PRECISION W(12),X(12),A,B,EPS,DELTA,CONST,AA,BB,Y,C1,C2,S8,&
     &                 S16,U,F                                          
      DATA CONST /1.0D-25/ 
      DATA W                                                            &
     &       / 0.1012285362903762591525313543D0,		   &
     &         0.2223810344533744705443559944D0,		   &
     &         0.3137066458778872873379622020D0,		   &
     &         0.3626837833783619829651504493D0,		   &
     &         0.0271524594117540948517805725D0,		   &
     &         0.0622535239386478928628438370D0,		   &
     &         0.0951585116824927848099251076D0,		   &
     &         0.1246289712555338720524762822D0,		   &
     &         0.1495959888165767320815017305D0,		   &
     &         0.1691565193950025381893120790D0,		   &
     &         0.1826034150449235888667636680D0,		   &
     &         0.1894506104550684962853967232D0 /		   
      DATA X                         	        		   &
     &       / 0.9602898564975362316835608686D0,		   &
     &         0.7966664774136267395915539365D0,		   &
     &         0.5255324099163289858177390492D0,		   &
     &         0.1834346424956498049394761424D0,		   &
     &         0.9894009349916499325961541735D0,		   &
     &         0.9445750230732325760779884155D0,		   &
     &         0.8656312023878317438804678977D0,		   &
     &         0.7554044083550030338951011948D0,		   &
     &         0.6178762444026437484466717640D0,		   &
     &         0.4580167776572273863424194430D0,		   &
     &         0.2816035507792589132304605015D0,		   &
     &         0.0950125098376374401853193354D0 /		   
      DELTA=CONST*DABS(A-B) 
      LH_DGAUSS_INTERN=0. 
      AA=A 
    5 Y=B-AA 
      IF(DABS(Y) .LE. DELTA) RETURN 
    2 BB=AA+Y 
      C1=0.5D0*(AA+BB) 
      C2=C1-AA 
      S8=0. 
      S16=0. 
      DO 1 I = 1,4 
      U=X(I)*C2 
    1 S8=S8+W(I)*(F(C1+U)+F(C1-U)) 
      DO 3 I = 5,12 
      U=X(I)*C2 
    3 S16=S16+W(I)*(F(C1+U)+F(C1-U)) 
      S8=S8*C2 
      S16=S16*C2 
      IF(DABS(S16-S8) .GT. EPS*(1.0D0+DABS(S16))) GOTO 4 
      LH_DGAUSS_INTERN=LH_DGAUSS_INTERN+S16 
      AA=BB 
      GOTO 5 
    4 Y=0.5D0*Y 
      IF(DABS(Y) .GT. DELTA) GOTO 2 
      PRINT 7 
      LH_DGAUSS_INTERN=0. 
      RETURN 
    7 FORMAT(1X,'DGAUSS_INTERN ... TOO HIGH ACCURACY REQUIRED') 
      END                                           

! -*- F90 -*-


!   LHAGLUE Interface to LHAPDF library of modern parton
!    density functions (PDF) with uncertainties
! 
! Authors for v4: Dimitri Bourilkov, Craig Group, Mike Whalley
! 
! Authors for v3: Dimitri Bourilkov, Craig Group, Mike Whalley
! 
! Author for v1 and v2: Dimitri Bourilkov  bourilkov@mailaps.org
!                       University of Florida
! 
! HERWIG interface by Dimitri Bourilkov and Craig Group
! 
! New numbering scheme and upgrade for LHAPDF v2.1
! by Dimitri Bourilkov and Mike Whalley
! 
! For more information, or when you cite this interface, currently
! the official reference is:
! D.Bourilkov, "Study of Parton Density Function Uncertainties with
! LHAPDF and PYTHIA at LHC", hep-ph/0305126.
! 
! The official LHAPDF page is:
! 
!    http://durpdg.dur.ac.uk/lhapdf/index.html 
! 
! The interface contains four subroutines (similar to PDFLIB).
! It can be used seamlessly by Monte Carlo generators 
! interfaced to PDFLIB or in stand-alone mode.
! 
!     For initialization (called once)
! 
!     PDFSET(PARM,VALUE)
! 
!     For the proton/pion structure functions
! 
!     STRUCTM(X,Q,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU)
! 
!     For the photon structure functions
! 
!     STRUCTP(X,Q2,P2,IP2,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU)
! 
!     For statistics ON structure functions (under/over-flows)
! 
!     PDFSTA
! 
! This interface can be invoked in 3 ways depending
! on the value of PARM(1) provided by the user when
! calling PDFSET(PARM,VALUE):
! 
!     For PYTHIA:         PARM(1).EQ.'NPTYPE'
!       (this is set automatically by PYTHIA)
! 
!     For HERWIG:         PARM(1).EQ.'HWLHAPDF'
!       (set by the USER e.g. in the main program like this:
!           AUTPDF(1) = 'HWLHAPDF'
!           AUTPDF(2) = 'HWLHAPDF'                         )
! 
!     For Stand-alone:    PARM(1).EQ.'DEFAULT'
!       (can be used for PDF studies or when interfacing
!        new generators)
! 
! The LHAPDF set/member is selected depending on the value of:
! 
!         PYTHIA:   ABS(MSTP(51)) - proton
!                   ABS(MSTP(53)) - pion
!                   ABS(MSTP(55)) - photon
! 
!         HERWIG:   ABS(INT(VALUE(1)))
! 
!    STAND-ALONE:   ABS(INT(VALUE(1)))
! 
! 
!         CONTROL switches:
!        ==================
! 
!      THE LOCATION OF THE LHAPDF LIBRARY HAS TO BE SPECIFIED
!      AS DESCRIBED BELOW (the rest is optional)
! 
!      if the user does nothing, sensible defaults
!      are active; to change the behaviour, the corresponding
!      values of LHAPARM() should be set to the values given below
! 
!   Location of the LHAPDF library of PDFs (pathname):
!      uses common block /LHAPDFC/
! 
!    If the user does nothing => default = subdir PDFsets of the 
!                               current directory (can be real subdir
!                               OR a soft link to the real location)
!    If the user sets LHAPATH => supplied by the USER who defines the
!                         path in common block COMMON/LHAPDFC/LHAPATH
!                         BEFORE calling PDFSET
! 
!    Other controls:
!    ===============
!      use common block /LHACONTROL/
! 
!   Collect statistics on under/over-flow requests for PDFs
!   outside their validity ranges in X and Q**2
!   (call PDFSTA at end of run to print it out)
! 
!       LHAPARM(16).EQ.'NOSTAT' => No statistics (faster)
!       LHAPARM(16).NE.'NOSTAT' => Default: collect statistics
! 
!   Option to use the values for the strong coupling alpha_s
!   as computed in LHAPDF in the MC generator
!   (to ensure uniformity between the MC generator and the PDF set)
!   WARNING: implemented ONLY for PYTHIA in LHAPDFv4
! 
!       LHAPARM(17).EQ.'LHAPDF' => Use alpha_s from LHAPDF
!       LHAPARM(17).NE.'LHAPDF' => Default (same as LHAPDF v1/v3)
! 
!   Extrapolation of PDFs outside LHAPDF validity range given by
!   [Xmin,Xmax] and [Q2min,Q2max]; DEFAULT => PDFs "frozen" at the
!   boundaries
! 
!       LHAPARM(18).EQ.'EXTRAPOLATE' => Extrapolate PDFs on OWN RISK
!                           WARNING: Crazy values can be returned
! 
!   Printout of initialization information in PDFSET (by default)
! 
!       LHAPARM(19).EQ.'SILENT' => No printout (silent mode)
!       LHAPARM(19).EQ.'LOWKEY' => Print 5 times (almost silent mode)
! 
!
!*********************************************************************
!
! $Id: lhaglue.f 1448 2013-09-24 15:03:20Z whalley $
!
! $Log$
! Revision 1.7  2005/12/02 14:50:54  whalley
! Changes for new CTEQ code/AB sets
!
! Revision 1.6  2005/10/18 15:35:48  whalley
! fix to allow LHAPATH to be user defined as well as lhapdf-config
!
! Revision 1.5  2005/10/18 11:47:48  whalley
! Change to only set LHAPATH once per run
!
! Revision 1.1.1.2  1996/10/30 08:29:06  cernlib
! Version 7.04
!
! Revision 1.1.1.1  1996/04/12 15:29:26  plothow
! Version 7.01
!
! v5.0  06-Oct-2005  Major change to allow multiset-initializations 
! v4.0  28-Apr-2005  PDFSTA routine; option to use Alfa_s from LHAPDF
! v4.0  21-Mar-2005  Photon/pion/new p PDFs, updated for LHAPDF v4
! v3.1  26-Apr-2004  New numbering scheme, updated for LHAPDF v2/v3
! v3.0  23-Jan-2004  HERWIG interface added
! v2.0  20-Sep-2003  PDFLIB style adopted
! v1.0  05-Mar-2003  First working version from PYTHIA to LHAPDF v1
! 
! interface to LHAPDF library
!*********************************************************************


! PDFSET
! Initialization for use of parton distributions
!  according to the LHAPDF interface.
! 
! v4.0  28-Apr-2005  Option to use Alfa_s from LHAPDF
! v4.0  21-Mar-2005  Photon/pion/new p PDFs, updated for LHAPDF v4
! v3.1  26-Apr-2004  New numbering scheme
! v3.0  23-Jan-2004  HERWIG interface added
! 
! Interface to LHAPDF library
subroutine pdfset(parm,value)
  ! Double precision and integer declarations.
  implicit double precision(a-h, o-z)
  implicit integer(i-n)
  ! Common blocks
  include 'commonlhapdf.inc'
  include 'commonlhasets.inc'
  include 'commonlhapdfc.inc'
  include 'commonlhacontrol.inc'
  include 'commonlhaglsta.inc'
  ! additions for multiset use
  double precision xxmin(nmxset),xxmax(nmxset),qq2min(nmxset),qq2max(nmxset)
  save xxmin,xxmax,qq2min,qq2max
  ! Commonblocks.
  common/pydat1/mstu(200),paru(200),mstj(200),parj(200)
  save /pydat1/
  common/pypars/mstp(200),parp(200),msti(200),pari(200)
  save /pypars/
  ! following 2 for earlier Pythia versions
  common/ludat1/mstu5(200),paru5(200),mstj5(200),parj5(200)
  save /ludat1/
  ! Interface to LHAPDFLIB.
  double precision qcdlha4, qcdlha5
  integer nfllha
  common/lhapdfr/qcdlha4, qcdlha5, nfllha
  save /lhapdfr/
  integer lhaextrp
  common/lhapdfe/lhaextrp
  save /lhapdfe/
  integer lhasilent
  common/lhasilent/lhasilent
  save /lhasilent/
  ! Interface to PDFLIB.
  common/w50511/ nptypepdfl,ngrouppdfl,nsetpdfl,modepdfl,nflpdfl,lopdfl,tmaspdfl
  save /w50511/
  double precision tmaspdfl
  ! Interface to PDFLIB.
  common/w50512/qcdl4,qcdl5
  save /w50512/
  double precision qcdl4,qcdl5
  ! Interface to PDFLIB.
  common/w50513/xmin,xmax,q2min,q2max
  save /w50513/
  double precision xmin,xmax,q2min,q2max
  ! Local arrays and character variables (NOT USED here DB)
  character*20 parm(20)
  double precision value(20)
  integer lhapathlen
  integer :: lhainput = 1
  !integer lhaselect
  integer lhaprint
  integer lhaonce
  integer lhafive
  save lhaonce
  save lhafive
  data lhaonce/0/
  data lhafive/0/
  logical first
  data first/.true./
  character*512 dirpath
  save first

  ! Initialise common blocks  
  call commoninit()

  if (first) then
     call getdirpath(dirpath)
     first = .FALSE.
  endif

  ! Init
  lhaextrp = 0
  if(lhaparm(18).EQ.'EXTRAPOLATE') then  ! Extrapolate PDFs on own risk
     lhaextrp = 1
  endif
  lhasilent = 0
  if (lhaparm(19).EQ.'SILENT') then    !  No printout (silent MODE)
     lhasilent = 1
  elseif (lhaparm(19).EQ.'LOWKEY') then ! print 5 times (lowkey mode)
     if (lhafive .lt. 6) then
        lhafive = lhafive + 1
     else
        lhasilent = 1
     endif
  endif
  if (parm(1).EQ.'NPTYPE') then        !  pythia
     if(mstp(181).ge.6) then
        lhaprint = mstu(11)
     else
        lhaprint = mstu5(11)
     endif
     if(value(1) .eq. 1) then         !   nucleon
        lhainput = abs(mstp(51))
     elseif(value(1) .eq. 2) then     !   pion
        lhainput = abs(mstp(53))
     elseif(value(1) .eq. 3) then     !   photon
        lhainput = abs(mstp(55))
     endif
     if (lhasilent .ne. 1) print *,'==== PYTHIA WILL USE LHAPDF ===='
  elseif(parm(1).EQ.'HWLHAPDF') then  !  herwig
     lhainput = abs(int(value(1)))
     if(lhaonce.eq.lhainput) return
     if(lhasilent .ne. 1) print *,'==== HERWIG WILL USE LHAPDF ===='
     lhaprint = 6
     lhaonce = lhainput
  elseif(parm(1).EQ.'DEFAULT') then  !  stand-alone
     lhainput = abs(int(value(1)))
     if(lhaonce.eq.lhainput) return
     if(lhasilent .ne. 1) print *,'==== STAND-ALONE LHAGLUE MODE TO USE LHAPDF ===='
     lhaprint = 6
     lhaonce = lhainput
  else
     print *,'== UNKNOWN LHAPDF INTERFACE CALL! STOP EXECUTION! =='
     stop
  endif
  ! Initialize parton distributions: LHAPDFLIB.
  lhapathlen=index(lhapath,' ') - 1
  lhaset = lhainput
  xmin = 1.0D-6      ! X_min for current PDF set
  xmax = 1.0D0       ! X_max for current PDF set
  q2min = 1.0D0**2   ! Q**2_min scale for current PDF set [GeV]
  q2max = 1.0D5**2   ! Q**2_max scale for current PDF set [GeV]
  ! 
  ! Protons
  ! 
  ! CTEQ Family
  if (((lhainput.ge.10000).and.(lhainput .le. 10999)).or.((lhainput.ge.19000).and.(lhainput .le. 19999))) then
     q2max = 1.0d08
     if ((lhainput .ge. 10000) .and. (lhainput .le. 10040)) then
        lhaset = 10000
        lhaname=lhapath(1:lhapathlen)//'/cteq6.LHpdf'
        q2min = 1.69d0
     elseif((lhainput .ge. 10041) .and. (lhainput .le. 10041)) then
        lhaset = 10041
        lhaname=lhapath(1:lhapathlen)//'/cteq6l.LHpdf'
        q2min = 1.69d0
     elseif((lhainput .ge. 10042) .and. (lhainput .le. 10042)) then
        lhaset = 10042
        lhaname=lhapath(1:lhapathlen)//'/cteq6ll.LHpdf'
        q2min = 1.69d0
     elseif((lhainput .ge. 10050) .and. (lhainput .le. 10090)) then
        lhaset = 10050
        lhaname=lhapath(1:lhapathlen)//'/cteq6mE.LHgrid'
        q2min = 1.69d0
     elseif((lhainput .ge. 10100) .and. (lhainput .le. 10140)) then
        lhaset = 10100
        lhaname=lhapath(1:lhapathlen)//'/cteq61.LHpdf'
        q2min = 1.69d0
     elseif((lhainput .ge. 10150) .and. (lhainput .le. 10190)) then
        lhaset = 10150
        lhaname=lhapath(1:lhapathlen)//'/cteq61.LHgrid'
        q2min = 1.69d0
     elseif((lhainput .ge. 10250) .and. (lhainput .le. 10269)) then
        lhaset = 10250
        lhaname=lhapath(1:lhapathlen)//'/cteq6AB.LHgrid'
        q2min = 1.69d0
     elseif((lhainput .ge. 10350) .and. (lhainput .le. 10390)) then
        lhaset = 10350
        lhaname=lhapath(1:lhapathlen)//'/cteq65.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-7
     elseif((lhainput .ge. 10450) .and. (lhainput .le. 10456)) then
        lhaset = 10450
        lhaname=lhapath(1:lhapathlen)//'/cteq65c.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-7
     elseif((lhainput .ge. 10460) .and. (lhainput .le. 10467)) then
        lhaset = 10460
        lhaname=lhapath(1:lhapathlen)//'/cteq65s.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-7
     elseif((lhainput .ge. 10550) .and. (lhainput .le. 10594)) then
        lhaset = 10550
        lhaname=lhapath(1:lhapathlen)//'/cteq66.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10595) .and. (lhainput .le. 10599)) then
        lhaset = 10595
        lhaname=lhapath(1:lhapathlen)//'/cteq66alphas.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10650) .and. (lhainput .le. 10653)) then
        lhaset = 10650
        lhaname=lhapath(1:lhapathlen)//'/cteq66c.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10660) .and. (lhainput .le. 10660)) then
        lhaset = 10660
        lhaname=lhapath(1:lhapathlen)//'/cteq66a0.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10661) .and. (lhainput .le. 10661)) then
        lhaset = 10661
        lhaname=lhapath(1:lhapathlen)//'/cteq66a1.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10662) .and. (lhainput .le. 10662)) then
        lhaset = 10662
        lhaname=lhapath(1:lhapathlen)//'/cteq66a2.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10663) .and. (lhainput .le. 10663)) then
        lhaset = 10663
        lhaname=lhapath(1:lhapathlen)//'/cteq66a3.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10670) .and. (lhainput .le. 10677)) then
        lhaset = 10670
        lhaname=lhapath(1:lhapathlen)//'/cteq6lg.LHgrid'
        q2min = 1.69d0
     elseif((lhainput .ge. 10770) .and. (lhainput .le. 10770)) then
        lhaset = 10770
        lhaname=lhapath(1:lhapathlen)//'/CT09MCS.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10771) .and. (lhainput .le. 10771)) then
        lhaset = 10771
        lhaname=lhapath(1:lhapathlen)//'/CT09MC1.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10772) .and. (lhainput .le. 10772)) then
        lhaset = 10772
        lhaname=lhapath(1:lhapathlen)//'/CT09MC2.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10800) .and. (lhainput .le. 10852)) then
        lhaset = 10800
        lhaname=lhapath(1:lhapathlen)//'/CT10.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10860) .and. (lhainput .le. 10870)) then
        lhaset = 10860
        lhaname=lhapath(1:lhapathlen)//'/CT10as.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10900) .and. (lhainput .le. 10952)) then
        lhaset = 10900
        lhaname=lhapath(1:lhapathlen)//'/CT10w.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10960) .and. (lhainput .le. 10970)) then
        lhaset = 10960
        lhaname=lhapath(1:lhapathlen)//'/CT10was.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10980) .and. (lhainput .le. 10980)) then
        lhaset = 10980
        lhaname=lhapath(1:lhapathlen)//'/CT10f3.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10981) .and. (lhainput .le. 10981)) then
        lhaset = 10981
        lhaname=lhapath(1:lhapathlen)//'/CT10f4.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10982) .and. (lhainput .le. 10982)) then
        lhaset = 10982
        lhaname=lhapath(1:lhapathlen)//'/CT10wf3.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 10983) .and. (lhainput .le. 10983)) then
        lhaset = 10983
        lhaname=lhapath(1:lhapathlen)//'/CT10wf4.LHgrid'
        q2min = 1.69d0
        q2max = 1.0d10
        xmin =  1.0d-8
     elseif((lhainput .ge. 19050) .and. (lhainput .le. 19050)) then
        lhaset = 19050
        lhaname=lhapath(1:lhapathlen)//'/cteq5m.LHgrid'
        xmin=1.0d-5
     elseif((lhainput .ge. 19051) .and. (lhainput .le. 19051)) then
        lhaset = 19051
        lhaname=lhapath(1:lhapathlen)//'/cteq5m1.LHgrid'
        xmin=1.0d-5
     elseif((lhainput .ge. 19053) .and. (lhainput .le. 19053)) then
        lhaset = 19053
        lhaname=lhapath(1:lhapathlen)//'/cteq5f3.LHgrid'
        xmin=1.0d-5
     elseif((lhainput .ge. 19054) .and. (lhainput .le. 19054)) then
        lhaset = 19054
        lhaname=lhapath(1:lhapathlen)//'/cteq5f4.LHgrid'
        xmin=1.0d-5
     elseif((lhainput .ge. 19060) .and. (lhainput .le. 19060)) then
        lhaset = 19060
        lhaname=lhapath(1:lhapathlen)//'/cteq5d.LHgrid'
        xmin=1.0d-5
     elseif((lhainput .ge. 19070) .and. (lhainput .le. 19070)) then
        lhaset = 19070
        lhaname=lhapath(1:lhapathlen)//'/cteq5l.LHgrid'
        xmin=1.0d-5
     elseif((lhainput .ge. 19150) .and. (lhainput .le. 19150)) then
        lhaset = 19150
        lhaname=lhapath(1:lhapathlen)//'/cteq4m.LHgrid'
        q2min = 2.56d0
        xmin=1.0d-5
     elseif((lhainput .ge. 19160) .and. (lhainput .le. 19160)) then
        lhaset = 19160
        lhaname=lhapath(1:lhapathlen)//'/cteq4d.LHgrid'
        q2min = 2.56d0
        xmin=1.0d-5
     elseif((lhainput .ge. 19170) .and. (lhainput .le. 19170)) then
        lhaset = 19170
        lhaname=lhapath(1:lhapathlen)//'/cteq4l.LHgrid'
        q2min = 2.56d0
        xmin=1.0d-5
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     
   ! New CT10 (ct12 format) family)
  elseif((lhainput .ge. 11000) .and. (lhainput .le. 11280)) then 
     q2min = 1.69d0
     q2max = 1.0d10
     xmin =  1.0d-8
 !ct10nlo
     if ((lhainput .ge. 11000) .and. (lhainput .le. 11052)) then
        lhaset = 11000
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo.LHgrid'
 !ct10nlo_as_xxxx
     elseif ((lhainput .ge. 11062) .and. (lhainput .le. 11062)) then
        lhaset = 11062
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0112.LHgrid'
     elseif ((lhainput .ge. 11063) .and. (lhainput .le. 11063)) then
        lhaset = 11063
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0113.LHgrid'
     elseif ((lhainput .ge. 11064) .and. (lhainput .le. 11064)) then
        lhaset = 11064
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0114.LHgrid'
     elseif ((lhainput .ge. 11065) .and. (lhainput .le. 11065)) then
        lhaset = 11065
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0115.LHgrid'
     elseif ((lhainput .ge. 11066) .and. (lhainput .le. 11066)) then
        lhaset = 11066
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0116.LHgrid'
     elseif ((lhainput .ge. 11067) .and. (lhainput .le. 11067)) then
        lhaset = 11067
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0117.LHgrid'
     elseif ((lhainput .ge. 11068) .and. (lhainput .le. 11068)) then
        lhaset = 11068
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0118.LHgrid'
     elseif ((lhainput .ge. 11069) .and. (lhainput .le. 11069)) then
        lhaset = 11069
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0119.LHgrid'
     elseif ((lhainput .ge. 11070) .and. (lhainput .le. 11070)) then
        lhaset = 11070
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0120.LHgrid'
     elseif ((lhainput .ge. 11071) .and. (lhainput .le. 11071)) then
        lhaset = 11071
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0121.LHgrid'
     elseif ((lhainput .ge. 11072) .and. (lhainput .le. 11072)) then
        lhaset = 11072
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0122.LHgrid'
     elseif ((lhainput .ge. 11073) .and. (lhainput .le. 11073)) then
        lhaset = 11073
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0123.LHgrid'
     elseif ((lhainput .ge. 11074) .and. (lhainput .le. 11074)) then
        lhaset = 11074
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0124.LHgrid'
     elseif ((lhainput .ge. 11075) .and. (lhainput .le. 11075)) then
        lhaset = 11075
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0125.LHgrid'
     elseif ((lhainput .ge. 11076) .and. (lhainput .le. 11076)) then
        lhaset = 11076
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0126.LHgrid'
     elseif ((lhainput .ge. 11077) .and. (lhainput .le. 11077)) then
        lhaset = 11077
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_as_0127.LHgrid'
 !ct10nlo_nf3/4
     elseif ((lhainput .ge. 11080) .and. (lhainput .le. 11081)) then
        lhaset = 11080
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_nf3.LHgrid'
     elseif ((lhainput .ge. 11082) .and. (lhainput .le. 11083)) then
        lhaset = 11082
        lhaname=lhapath(1:lhapathlen)//'/CT10nlo_nf4.LHgrid'
 !ct10wnlo
     elseif ((lhainput .ge. 11100) .and. (lhainput .le. 11152)) then
        lhaset = 11100
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo.LHgrid'
 !ct10wnlo_as_xxxx
     elseif ((lhainput .ge. 11162) .and. (lhainput .le. 11162)) then
        lhaset = 11162
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0112.LHgrid'
     elseif ((lhainput .ge. 11163) .and. (lhainput .le. 11163)) then
        lhaset = 11163
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0113.LHgrid'
     elseif ((lhainput .ge. 11164) .and. (lhainput .le. 11164)) then
        lhaset = 11164
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0114.LHgrid'
     elseif ((lhainput .ge. 11165) .and. (lhainput .le. 11165)) then
        lhaset = 11165
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0115.LHgrid'
     elseif ((lhainput .ge. 11166) .and. (lhainput .le. 11166)) then
        lhaset = 11166
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0116.LHgrid'
     elseif ((lhainput .ge. 11167) .and. (lhainput .le. 11167)) then
        lhaset = 11167
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0117.LHgrid'
     elseif ((lhainput .ge. 11168) .and. (lhainput .le. 11168)) then
        lhaset = 11168
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0118.LHgrid'
     elseif ((lhainput .ge. 11169) .and. (lhainput .le. 11169)) then
        lhaset = 11169
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0119.LHgrid'
     elseif ((lhainput .ge. 11170) .and. (lhainput .le. 11170)) then
        lhaset = 11170
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0120.LHgrid'
     elseif ((lhainput .ge. 11171) .and. (lhainput .le. 11171)) then
        lhaset = 11171
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0121.LHgrid'
     elseif ((lhainput .ge. 11172) .and. (lhainput .le. 11172)) then
        lhaset = 11172
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0122.LHgrid'
     elseif ((lhainput .ge. 11173) .and. (lhainput .le. 11173)) then
        lhaset = 11173
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0123.LHgrid'
     elseif ((lhainput .ge. 11174) .and. (lhainput .le. 11174)) then
        lhaset = 11174
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0124.LHgrid'
     elseif ((lhainput .ge. 11175) .and. (lhainput .le. 11175)) then
        lhaset = 11175
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0125.LHgrid'
     elseif ((lhainput .ge. 11176) .and. (lhainput .le. 11176)) then
        lhaset = 11176
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0126.LHgrid'
     elseif ((lhainput .ge. 11177) .and. (lhainput .le. 11177)) then
        lhaset = 11177
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_as_0127.LHgrid'
 !ct10wnlo_nf3/4
     elseif ((lhainput .ge. 11180) .and. (lhainput .le. 11181)) then
        lhaset = 11180
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_nf3.LHgrid'
     elseif ((lhainput .ge. 11182) .and. (lhainput .le. 11183)) then
        lhaset = 11182
        lhaname=lhapath(1:lhapathlen)//'/CT10wnlo_nf4.LHgrid'
 !ct10nnlo
     elseif ((lhainput .ge. 11200) .and. (lhainput .le. 11250)) then
        lhaset = 11200
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo.LHgrid'
 !ct10nnlo_as_xxxx
     elseif ((lhainput .ge. 11260) .and. (lhainput .le. 11260)) then
        lhaset = 11260
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0110.LHgrid'
     elseif ((lhainput .ge. 11261) .and. (lhainput .le. 11261)) then
        lhaset = 11261
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0111.LHgrid'
     elseif ((lhainput .ge. 11262) .and. (lhainput .le. 11262)) then
        lhaset = 11262
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0112.LHgrid'
     elseif ((lhainput .ge. 11263) .and. (lhainput .le. 11263)) then
        lhaset = 11263
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0113.LHgrid'
     elseif ((lhainput .ge. 11264) .and. (lhainput .le. 11264)) then
        lhaset = 11264
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0114.LHgrid'
     elseif ((lhainput .ge. 11265) .and. (lhainput .le. 11265)) then
        lhaset = 11265
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0115.LHgrid'
     elseif ((lhainput .ge. 11266) .and. (lhainput .le. 11266)) then
        lhaset = 11266
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0116.LHgrid'
     elseif ((lhainput .ge. 11267) .and. (lhainput .le. 11267)) then
        lhaset = 11267
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0117.LHgrid'
     elseif ((lhainput .ge. 11268) .and. (lhainput .le. 11268)) then
        lhaset = 11268
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0118.LHgrid'
     elseif ((lhainput .ge. 11269) .and. (lhainput .le. 11269)) then
        lhaset = 11269
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0119.LHgrid'
     elseif ((lhainput .ge. 11270) .and. (lhainput .le. 11270)) then
        lhaset = 11270
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0120.LHgrid'
     elseif ((lhainput .ge. 11271) .and. (lhainput .le. 11271)) then
        lhaset = 11271
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0121.LHgrid'
     elseif ((lhainput .ge. 11272) .and. (lhainput .le. 11272)) then
        lhaset = 11272
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0122.LHgrid'
     elseif ((lhainput .ge. 11273) .and. (lhainput .le. 11273)) then
        lhaset = 11273
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0123.LHgrid'
     elseif ((lhainput .ge. 11274) .and. (lhainput .le. 11274)) then
        lhaset = 11274
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0124.LHgrid'
     elseif ((lhainput .ge. 11275) .and. (lhainput .le. 11275)) then
        lhaset = 11275
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0125.LHgrid'
     elseif ((lhainput .ge. 11276) .and. (lhainput .le. 11276)) then
        lhaset = 11276
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0126.LHgrid'
     elseif ((lhainput .ge. 11277) .and. (lhainput .le. 11277)) then
        lhaset = 11277
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0127.LHgrid'
     elseif ((lhainput .ge. 11278) .and. (lhainput .le. 11278)) then
        lhaset = 11278
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0128.LHgrid'
     elseif ((lhainput .ge. 11279) .and. (lhainput .le. 11279)) then
        lhaset = 11279
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0129.LHgrid'
     elseif ((lhainput .ge. 11280) .and. (lhainput .le. 11280)) then
        lhaset = 11280
        lhaname=lhapath(1:lhapathlen)//'/CT10nnlo_as_0130.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif

  ! CJ12  (family)
  elseif((lhainput .ge. 12000) .and. (lhainput .le. 12238)) then 
     q2min = 1.69d0
     q2max = 1.0d10
     xmin =  1.0d-6
 !cj12min
     if ((lhainput .ge. 12000) .and. (lhainput .le. 12038)) then
        lhaset = 12000
        lhaname=lhapath(1:lhapathlen)//'/CJ12min.LHgrid'
 !cj12mid
     elseif ((lhainput .ge. 12100) .and. (lhainput .le. 12138)) then
        lhaset = 12100
        lhaname=lhapath(1:lhapathlen)//'/CJ12mid.LHgrid'
 !cj12max
     elseif ((lhainput .ge. 12200) .and. (lhainput .le. 12238)) then
        lhaset = 12200
        lhaname=lhapath(1:lhapathlen)//'/CJ12max.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif

     ! MRST Family
  elseif((lhainput .ge. 20000) .and. (lhainput .le. 20999)) then
     q2min = 1.25d0
     q2max = 1.0d07
     xmin = 1.0d-5
     if((lhainput .ge. 20000) .and. (lhainput .le. 20004)) then
        lhaset = 20000
        lhaname=lhapath(1:lhapathlen)//'/MRST2001nlo.LHpdf'
     elseif((lhainput .ge. 20050) .and. (lhainput .le. 20054)) then
        lhaset = 20050
        lhaname=lhapath(1:lhapathlen)//'/MRST2001nlo.LHgrid'
     elseif((lhainput .ge. 20060) .and. (lhainput .le. 20061)) then
        lhaset = 20060
        lhaname=lhapath(1:lhapathlen)//'/MRST2001lo.LHgrid'
     elseif((lhainput .ge. 20070) .and. (lhainput .le. 20074)) then
        lhaset = 20070
        lhaname=lhapath(1:lhapathlen)//'/MRST2001nnlo.LHgrid'
     elseif((lhainput .ge. 20100) .and. (lhainput .le. 20130)) then
        lhaset = 20100
        lhaname=lhapath(1:lhapathlen)//'/MRST2001E.LHpdf'
     elseif((lhainput .ge. 20150) .and. (lhainput .le. 20180)) then
        lhaset = 20150
        lhaname=lhapath(1:lhapathlen)//'/MRST2001E.LHgrid'
     elseif((lhainput .ge. 20200) .and. (lhainput .le. 20201)) then
        lhaset = 20200
        lhaname=lhapath(1:lhapathlen)//'/MRST2002nlo.LHpdf'
     elseif((lhainput .ge. 20250) .and. (lhainput .le. 20251)) then
        lhaset = 20250
        lhaname=lhapath(1:lhapathlen)//'/MRST2002nlo.LHgrid'
     elseif((lhainput .ge. 20270) .and. (lhainput .le. 20271)) then
        lhaset = 20270
        lhaname=lhapath(1:lhapathlen)//'/MRST2002nnlo.LHgrid'
     elseif((lhainput .ge. 20300) .and. (lhainput .le. 20301)) then
        lhaset = 20300
        lhaname=lhapath(1:lhapathlen)//'/MRST2003cnlo.LHpdf'
        q2min = 10.0d0
        xmin = 1.0d-3
     elseif((lhainput .ge. 20350) .and. (lhainput .le. 20351)) then
        lhaset = 20350
        lhaname=lhapath(1:lhapathlen)//'/MRST2003cnlo.LHgrid'
        q2min = 10.0d0
        xmin = 1.0d-3
     elseif((lhainput .ge. 20370) .and. (lhainput .le. 20371)) then
        lhaset = 20370
        lhaname=lhapath(1:lhapathlen)//'/MRST2003cnnlo.LHgrid'
        q2min = 7.0d0
        xmin = 1.0d-3
     elseif((lhainput .ge. 20400) .and. (lhainput .le. 20401)) then
        lhaset = 20400
        lhaname=lhapath(1:lhapathlen)//'/MRST2004nlo.LHpdf'
     elseif((lhainput .ge. 20406) .and. (lhainput .le. 20407)) then
        lhaset = 20406
        lhaname=lhapath(1:lhapathlen)//'/MRST2004FF3nlo.LHpdf'
     elseif((lhainput .ge. 20408) .and. (lhainput .le. 20409)) then
        lhaset = 20408
        lhaname=lhapath(1:lhapathlen)//'/MRST2004FF4nlo.LHpdf'
     elseif((lhainput .ge. 20450) .and. (lhainput .le. 20451)) then
        lhaset = 20450
        lhaname=lhapath(1:lhapathlen)//'/MRST2004nlo.LHgrid'
     elseif((lhainput .ge. 20452) .and. (lhainput .le. 20453)) then
        lhaset = 20452
        lhaname=lhapath(1:lhapathlen)//'/MRST2004FF3lo.LHgrid'
     elseif((lhainput .ge. 20454) .and. (lhainput .le. 20455)) then
        lhaset = 20454
        lhaname=lhapath(1:lhapathlen)//'/MRST2004FF4lo.LHgrid'
     elseif((lhainput .ge. 20456) .and. (lhainput .le. 20457)) then
        lhaset = 20456
        lhaname=lhapath(1:lhapathlen)//'/MRST2004FF3nlo.LHgrid'
     elseif((lhainput .ge. 20458) .and. (lhainput .le. 20459)) then
        lhaset = 20458
        lhaname=lhapath(1:lhapathlen)//'/MRST2004FF4nlo.LHgrid'
     elseif((lhainput .ge. 20460) .and. (lhainput .le. 20462)) then
        lhaset = 20460
        lhaname=lhapath(1:lhapathlen)//'/MRST2004qed.LHgrid'
     elseif((lhainput .ge. 20470) .and. (lhainput .le. 20471)) then
        lhaset = 20470
        lhaname=lhapath(1:lhapathlen)//'/MRST2004nnlo.LHgrid'
     elseif((lhainput .ge. 20550) .and. (lhainput .le. 20580)) then
        lhaset = 20550
        lhaname=lhapath(1:lhapathlen)//'/MRST2006nnlo.LHgrid'
        q2min = 1.0d0
        q2max = 1.0d09
        xmin = 1.0d-6
     elseif((lhainput .ge. 20650) .and. (lhainput .le. 20650)) then
        lhaset = 20650
        lhaname=lhapath(1:lhapathlen)//'/MRST2007lomod.LHgrid'
     elseif((lhainput .ge. 20651) .and. (lhainput .le. 20651)) then
        lhaset = 20651
        lhaname=lhapath(1:lhapathlen)//'/MRSTMCal.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! next are MSTW
  elseif((lhainput .ge. 21000) .and. (lhainput .le. 23896)) then
     q2min = 1.0d0
     q2max = 1.0d09
     xmin = 1.0d-6
     if((lhainput .ge. 21000) .and. (lhainput .le. 21040)) then
        lhaset = 21000
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008lo68cl.LHgrid'
     elseif((lhainput .ge. 21041) .and. (lhainput .le. 21080)) then
        lhaset = 21040
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008lo90cl.LHgrid'
     elseif((lhainput .ge. 21100) .and. (lhainput .le. 21140)) then
        lhaset = 21100
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo68cl.LHgrid'
     elseif((lhainput .ge. 21141) .and. (lhainput .le. 21180)) then
         lhaset = 21140
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo90cl.LHgrid'
     elseif((lhainput .ge. 21200) .and. (lhainput .le. 21240)) then
        lhaset = 21200
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo68cl.LHgrid'
     elseif((lhainput .ge. 21241) .and. (lhainput .le. 21280)) then
        lhaset = 21240
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo90cl.LHgrid'
!
     elseif((lhainput .ge. 22000) .and. (lhainput .le. 22021)) then
        lhaset = 22000
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo_asmzrange.LHgrid'
     elseif((lhainput .ge. 22100) .and. (lhainput .le. 22140)) then
        lhaset = 22100
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo68cl_asmz+68cl.LHgrid'
     elseif((lhainput .ge. 22150) .and. (lhainput .le. 22190)) then
        lhaset = 22150
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo68cl_asmz-68cl.LHgrid'
     elseif((lhainput .ge. 22200) .and. (lhainput .le. 22240)) then
        lhaset = 22200
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo68cl_asmz+68clhalf.LHgrid'
     elseif((lhainput .ge. 22250) .and. (lhainput .le. 22290)) then
        lhaset = 22250
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo68cl_asmz-68clhalf.LHgrid'
     elseif((lhainput .ge. 22300) .and. (lhainput .le. 22340)) then
        lhaset = 22300
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo90cl_asmz+90cl.LHgrid'
     elseif((lhainput .ge. 22350) .and. (lhainput .le. 22390)) then
        lhaset = 22350
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo90cl_asmz-90cl.LHgrid'
     elseif((lhainput .ge. 22400) .and. (lhainput .le. 22440)) then
        lhaset = 22400
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo90cl_asmz+90clhalf.LHgrid'
     elseif((lhainput .ge. 22450) .and. (lhainput .le. 22490)) then
        lhaset = 22450
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo90cl_asmz-90clhalf.LHgrid'
!
     elseif((lhainput .ge. 22500) .and. (lhainput .le. 22521)) then
        lhaset = 22500
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo_asmzrange.LHgrid'
     elseif((lhainput .ge. 22600) .and. (lhainput .le. 22640)) then
        lhaset = 22600
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo68cl_asmz+68cl.LHgrid'
     elseif((lhainput .ge. 22650) .and. (lhainput .le. 22690)) then
        lhaset = 22650
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo68cl_asmz-68cl.LHgrid'
     elseif((lhainput .ge. 22700) .and. (lhainput .le. 22740)) then
        lhaset = 22700
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo68cl_asmz+68clhalf.LHgrid'
     elseif((lhainput .ge. 22750) .and. (lhainput .le. 22790)) then
        lhaset = 22750
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo68cl_asmz-68clhalf.LHgrid'
     elseif((lhainput .ge. 22800) .and. (lhainput .le. 22840)) then
        lhaset = 22800
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo90cl_asmz+90cl.LHgrid'
     elseif((lhainput .ge. 22850) .and. (lhainput .le. 22890)) then
        lhaset = 22850
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo90cl_asmz-90cl.LHgrid'
     elseif((lhainput .ge. 22900) .and. (lhainput .le. 22940)) then
        lhaset = 22900
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo90cl_asmz+90clhalf.LHgrid'
     elseif((lhainput .ge. 22950) .and. (lhainput .le. 22990)) then
        lhaset = 22950
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo90cl_asmz-90clhalf.LHgrid'
!
     elseif((lhainput .ge. 23000) .and. (lhainput .le. 23040)) then
        lhaset = 23000
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008lo68cl_nf3.LHgrid'
     elseif((lhainput .ge. 23041) .and. (lhainput .le. 23080)) then
        lhaset = 23041
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008lo90cl_nf3.LHgrid'
     elseif((lhainput .ge. 23100) .and. (lhainput .le. 23140)) then
        lhaset = 23100
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008lo68cl_nf4.LHgrid'
     elseif((lhainput .ge. 23141) .and. (lhainput .le. 23180)) then
        lhaset = 23141
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008lo90cl_nf4.LHgrid'
!
     elseif((lhainput .ge. 23200) .and. (lhainput .le. 23240)) then
        lhaset = 23200
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo68cl_nf3.LHgrid'
     elseif((lhainput .ge. 23241) .and. (lhainput .le. 23280)) then
        lhaset = 23241
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo90cl_nf3.LHgrid'
     elseif((lhainput .ge. 23300) .and. (lhainput .le. 23340)) then
        lhaset = 23300
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo68cl_nf4.LHgrid'
     elseif((lhainput .ge. 23341) .and. (lhainput .le. 23380)) then
        lhaset = 23341
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo90cl_nf4.LHgrid'
!
     elseif((lhainput .ge. 23400) .and. (lhainput .le. 23414)) then
        lhaset = 23400
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo_mcrange.LHgrid'
     elseif((lhainput .ge. 23420) .and. (lhainput .le. 23434)) then
        lhaset = 23420
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo_mcrange_nf3.LHgrid'
     elseif((lhainput .ge. 23440) .and. (lhainput .le. 23454)) then
        lhaset = 23440
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo_mcrange_fixasmz.LHgrid'
     elseif((lhainput .ge. 23460) .and. (lhainput .le. 23474)) then
        lhaset = 23460
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo_mcrange_fixasmz_nf3.LHgrid'
     elseif((lhainput .ge. 23480) .and. (lhainput .le. 23486)) then
        lhaset = 23480
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo_mbrange.LHgrid'
     elseif((lhainput .ge. 23490) .and. (lhainput .le. 23496)) then
        lhaset = 23490
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nlo_mbrange_nf4.LHgrid'
!
     elseif((lhainput .ge. 23500) .and. (lhainput .le. 23540)) then
        lhaset = 23500
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo68cl_nf3.LHgrid'
     elseif((lhainput .ge. 23541) .and. (lhainput .le. 23580)) then
        lhaset = 23541
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo90cl_nf3.LHgrid'
     elseif((lhainput .ge. 23600) .and. (lhainput .le. 23640)) then
        lhaset = 23600
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo68cl_nf4.LHgrid'
     elseif((lhainput .ge. 23641) .and. (lhainput .le. 23680)) then
        lhaset = 23641
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo90cl_nf4.LHgrid'
!
     elseif((lhainput .ge. 23700) .and. (lhainput .le. 23714)) then
        lhaset = 23700
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo_mcrange.LHgrid'
     elseif((lhainput .ge. 23720) .and. (lhainput .le. 23734)) then
        lhaset = 23720
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo_mcrange_nf3.LHgrid'
     elseif((lhainput .ge. 23740) .and. (lhainput .le. 23754)) then
        lhaset = 23740
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo_mcrange_fixasmz.LHgrid'
     elseif((lhainput .ge. 23760) .and. (lhainput .le. 23774)) then
        lhaset = 23760
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo_mcrange_fixasmz_nf3.LHgrid'
     elseif((lhainput .ge. 23780) .and. (lhainput .le. 23786)) then
        lhaset = 23780
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo_mbrange.LHgrid'
     elseif((lhainput .ge. 23790) .and. (lhainput .le. 23796)) then
        lhaset = 23790
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008nnlo_mbrange_nf4.LHgrid'
     elseif((lhainput .ge. 23800) .and. (lhainput .le. 23846)) then
        lhaset = 23800
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008CPdeutnlo68cl.LHgrid'
     elseif((lhainput .ge. 23850) .and. (lhainput .le. 23896)) then
        lhaset = 23850
        lhaname=lhapath(1:lhapathlen)//'/MSTW2008CPdeutnnlo68cl.LHgrid'
!
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! old MRST98 sets
  elseif((lhainput .ge. 29000) .and. (lhainput .le. 29999)) then
     q2min = 1.25d0
     q2max = 1.0d07
     xmin = 1.0d-5
     if((lhainput .ge. 29000) .and. (lhainput .le. 29003)) then
        lhaset = 29000
        lhaname=lhapath(1:lhapathlen)//'/MRST98.LHpdf'
     elseif((lhainput .ge. 29040) .and. (lhainput .le. 29045)) then
        lhaset = 29040
        lhaname=lhapath(1:lhapathlen)//'/MRST98lo.LHgrid'
     elseif((lhainput .ge. 29050) .and. (lhainput .le. 29055)) then
        lhaset = 29050
        lhaname=lhapath(1:lhapathlen)//'/MRST98nlo.LHgrid'
     elseif((lhainput .ge. 29060) .and. (lhainput .le. 29065)) then
        lhaset = 29060
        lhaname=lhapath(1:lhapathlen)//'/MRST98dis.LHgrid'
     elseif((lhainput .ge. 29070) .and. (lhainput .le. 29071)) then
        lhaset = 29070
        lhaname=lhapath(1:lhapathlen)//'/MRST98ht.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! Fermi Family
  elseif((lhainput .ge. 30000) .and. (lhainput .le. 39999)) then
     if((lhainput .ge. 30100) .and. (lhainput .le. 30200)) then
        lhaset = 30100
        lhaname=lhapath(1:lhapathlen)//'/Fermi2002_100.LHpdf'
     elseif((lhainput .ge. 31000) .and. (lhainput .le. 32000)) then
        lhaset = 31000
        lhaname=lhapath(1:lhapathlen)//'/Fermi2002_1000.LHpdf'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
   ! a02m Family 
  elseif((lhainput .ge. 40350) .and. (lhainput .le. 40567)) then
     xmin = 1.0d-7
     q2min = 0.8d0
     q2max = 2.0d08
     if((lhainput .ge. 40350) .and. (lhainput .le. 40367)) then
        lhaset = 40350
        lhaname=lhapath(1:lhapathlen)//'/a02m_lo.LHgrid'
     elseif((lhainput .ge. 40450) .and. (lhainput .le. 40467)) then
        lhaset = 40450
        lhaname=lhapath(1:lhapathlen)//'/a02m_nlo.LHgrid'
     elseif((lhainput .ge. 40550) .and. (lhainput .le. 40567)) then
        lhaset = 40550 
        lhaname=lhapath(1:lhapathlen)//'/a02m_nnlo.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
   ! abkm09 Family 
  elseif((lhainput .ge. 40650) .and. (lhainput .le. 40975)) then
     xmin = 1.0d-7
     q2min = 0.8d0
     q2max = 2.0d08
     if((lhainput .ge. 40650) .and. (lhainput .le. 40675)) then
        lhaset = 40650 
        lhaname=lhapath(1:lhapathlen)//'/abkm09_3_nlo.LHgrid'
     elseif((lhainput .ge. 40750) .and. (lhainput .le. 40775)) then
        lhaset = 40750 
        lhaname=lhapath(1:lhapathlen)//'/abkm09_3_nnlo.LHgrid'
     elseif((lhainput .ge. 40780) .and. (lhainput .le. 40805)) then
        lhaset = 40780 
        lhaname=lhapath(1:lhapathlen)//'/abkm09_4_nlo.LHgrid'
     elseif((lhainput .ge. 40810) .and. (lhainput .le. 40835)) then
        lhaset = 40810 
        lhaname=lhapath(1:lhapathlen)//'/abkm09_4_nnlo.LHgrid'
     elseif((lhainput .ge. 40850) .and. (lhainput .le. 40875)) then
        lhaset = 40850 
        lhaname=lhapath(1:lhapathlen)//'/abkm09_5_nlo.LHgrid'
     elseif((lhainput .ge. 40950) .and. (lhainput .le. 40975)) then
        lhaset = 40950 
        lhaname=lhapath(1:lhapathlen)//'/abkm09_5_nnlo.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
   ! abm11 Family 
  elseif((lhainput .ge. 42000) .and. (lhainput .le. 42246)) then
     xmin = 1.0d-7
     q2min = 0.8d0
     q2max = 2.0d08
     if((lhainput .ge. 42000) .and. (lhainput .le. 42028)) then
        lhaset = 42000 
        lhaname=lhapath(1:lhapathlen)//'/abm11_3n_nlo.LHgrid'
     elseif((lhainput .ge. 42030) .and. (lhainput .le. 42058)) then
        lhaset = 42030 
        lhaname=lhapath(1:lhapathlen)//'/abm11_4n_nlo.LHgrid'
     elseif((lhainput .ge. 42060) .and. (lhainput .le. 42088)) then
        lhaset = 42060 
        lhaname=lhapath(1:lhapathlen)//'/abm11_5n_nlo.LHgrid'
     elseif((lhainput .ge. 42100) .and. (lhainput .le. 42128)) then
        lhaset = 42100 
        lhaname=lhapath(1:lhapathlen)//'/abm11_3n_nnlo.LHgrid'
     elseif((lhainput .ge. 42130) .and. (lhainput .le. 42158)) then
        lhaset = 42130 
        lhaname=lhapath(1:lhapathlen)//'/abm11_4n_nnlo.LHgrid'
     elseif((lhainput .ge. 42160) .and. (lhainput .le. 42188)) then
        lhaset = 42160 
        lhaname=lhapath(1:lhapathlen)//'/abm11_5n_nnlo.LHgrid'
     elseif((lhainput .ge. 42200) .and. (lhainput .le. 42220)) then
        lhaset = 42200 
        lhaname=lhapath(1:lhapathlen)//'/abm11_5n_as_nlo.LHgrid'
     elseif((lhainput .ge. 42230) .and. (lhainput .le. 42246)) then
        lhaset = 42230 
        lhaname=lhapath(1:lhapathlen)//'/abm11_5n_as_nnlo.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! Alekhin Family
  elseif((lhainput .ge. 40000) .and. (lhainput .le. 41999)) then
     if((lhainput .ge. 40100) .and. (lhainput .le. 40200)) then
        lhaset = 40100
        lhaname=lhapath(1:lhapathlen)//'/Alekhin_100.LHpdf'
     elseif((lhainput .ge. 41000) .and. (lhainput .le. 41999)) then
        lhaset = 41000
        lhaname=lhapath(1:lhapathlen)//'/Alekhin_1000.LHpdf'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! Botje Family
  elseif((lhainput .ge. 50000) .and. (lhainput .le. 59999)) then
     if((lhainput .ge. 50100) .and. (lhainput .le. 50200)) then
        lhaset = 50100
        lhaname=lhapath(1:lhapathlen)//'/Botje_100.LHpdf'
     elseif((lhainput .ge. 51000) .and. (lhainput .le. 51999)) then
        lhaset = 51000
        lhaname=lhapath(1:lhapathlen)//'/Botje_1000.LHpdf'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! ZEUS (+ ATLAS) Family
  elseif((lhainput .ge. 60000) .and. (lhainput .le. 69999)) then
     q2min = 0.3d0
     q2max = 2.0d05
     if((lhainput .ge. 60000) .and. (lhainput .le. 60022)) then
        lhaset = 60000
        lhaname=lhapath(1:lhapathlen)//'/ZEUS2002_TR.LHpdf'
     elseif((lhainput .ge. 60100) .and. (lhainput .le. 60122)) then
        lhaset = 60100
        lhaname=lhapath(1:lhapathlen)//'/ZEUS2002_ZM.LHpdf'
     elseif((lhainput .ge. 60200) .and. (lhainput .le. 60222)) then
        lhaset = 60200
        lhaname=lhapath(1:lhapathlen)//'/ZEUS2002_FF.LHpdf'
     elseif((lhainput .ge. 60300) .and. (lhainput .le. 60322)) then
        lhaset = 60300
        lhaname=lhapath(1:lhapathlen)//'/ZEUS2005_ZJ.LHpdf'
     elseif((lhainput .ge. 60400) .and. (lhainput .le. 60422)) then
        xmin=1.0d-6
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60400
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF01.LHpdf'
     elseif((lhainput .ge. 60430) .and. (lhainput .le. 60444)) then
        xmin=1.0d-6
        xmax=1.0d0
        q2min=1.0d0
        q2max=2.0d08
        lhaset = 60430
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF01.LHgrid'
     elseif((lhainput .ge. 60500) .and. (lhainput .le. 60520)) then
        xmin=1.0d-6
        xmax=1.0d0
        q2min=1.0d0
        q2max=2.0d08
        lhaset = 60500
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF10_EIG.LHgrid'
     elseif((lhainput .ge. 60530) .and. (lhainput .le. 60543)) then
        xmin=1.0d-6
        xmax=1.0d0
        q2min=1.0d0
        q2max=2.0d08
        lhaset = 60530
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF10_VAR.LHgrid'
     elseif((lhainput .ge. 60550) .and. (lhainput .le. 60561)) then
        xmin=1.0d-6
        xmax=1.0d0
        q2min=1.0d0
        q2max=2.0d08
        lhaset = 60550
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF10_ALPHAS.LHgrid'
     elseif((lhainput .ge. 60600) .and. (lhainput .le. 60628)) then
        xmin=1.0d-8
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60600
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF15NNLO_EIG.LHgrid'
     elseif((lhainput .ge. 60630) .and. (lhainput .le. 60640)) then
        xmin=1.0d-8
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60630
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF15NNLO_VAR.LHgrid'
     elseif((lhainput .ge. 60650) .and. (lhainput .le. 60661)) then
        xmin=1.0d-8
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60650
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF15NNLO_ALPHAS.LHgrid'
     elseif((lhainput .ge. 60700) .and. (lhainput .le. 60720)) then
        xmin=1.0d-8
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60700
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF15NLO_EIG.LHgrid'
     elseif((lhainput .ge. 60730) .and. (lhainput .le. 60742)) then
        xmin=1.0d-8
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60730
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF15NLO_VAR.LHgrid'
     elseif((lhainput .ge. 60750) .and. (lhainput .le. 60761)) then
        xmin=1.0d-8
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60750
        lhaname=lhapath(1:lhapathlen)//'/HERAPDF15NLO_ALPHAS.LHgrid'
     elseif((lhainput .ge. 60800) .and. (lhainput .le. 60824)) then
        xmin=1.0d-8
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 60800
        lhaname=lhapath(1:lhapathlen)//'/LHECNLO_EIG.LHgrid'
     elseif((lhainput .ge. 65000) .and. (lhainput .le. 65030)) then
        xmin=1.0d-7
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 65000
        lhaname=lhapath(1:lhapathlen)//'/ATLAS-epWZ12-EIG.LHgrid'
     elseif((lhainput .ge. 65040) .and. (lhainput .le. 65051)) then
        xmin=1.0d-7
        xmax=1.0d0
        q2min=1.0d0
        q2max=1.0d09
        lhaset = 65040
        lhaname=lhapath(1:lhapathlen)//'/ATLAS-epWZ12-VAR.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! H1 Family
  elseif((lhainput .ge. 70000) .and. (lhainput .le. 79999)) then
     q2min = 1.5d0
     q2max = 3.5d04
     xmin = 5.7d-5
     if((lhainput .ge. 70050) .and. (lhainput .le. 70050)) then
        lhaset = 70050
        lhaname=lhapath(1:lhapathlen)//'/H12000ms.LHgrid'
     elseif((lhainput .ge. 70051) .and. (lhainput .le. 70070)) then
        lhaset = 70050
        lhaname=lhapath(1:lhapathlen)//'/H12000msE.LHgrid'
     elseif((lhainput .ge. 70150) .and. (lhainput .le. 70150)) then
        lhaset = 70150
        lhaname=lhapath(1:lhapathlen)//'/H12000dis.LHgrid'
     elseif((lhainput .ge. 70151) .and. (lhainput .le. 70170)) then
        lhaset = 70150
        lhaname=lhapath(1:lhapathlen)//'/H12000disE.LHgrid'
     elseif((lhainput .ge. 70250) .and. (lhainput .le. 70250)) then
        lhaset = 70250
        lhaname=lhapath(1:lhapathlen)//'/H12000lo.LHgrid'
     elseif((lhainput .ge. 70251) .and. (lhainput .le. 70270)) then
        lhaset = 70250
        lhaname=lhapath(1:lhapathlen)//'/H12000loE.LHgrid'
        ! Temporarily removed on returning to original H12000 files
        ! elseif((lhainput .ge. 70350) .and. (lhainput .le. 70350)) then
        ! lhaset = 70350
        ! lhaname=lhapath(1:lhapathlen)//'/H12000lo2.LHgrid'
        ! elseif((lhainput .ge. 70351) .and. (lhainput .le. 70370)) then
        ! lhaset = 70350
        ! lhaname=lhapath(1:lhapathlen)//'/H12000lo2E.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! GRV/GJR Family
  elseif((lhainput .ge. 80000) .and. (lhainput .le. 89999)) then
     q2min = 0.8d0
     q2max = 2.0d06
     xmin = 1.0d-9
     if((lhainput .ge. 80050) .and. (lhainput .le. 80051)) then
        lhaset = 80050
        lhaname=lhapath(1:lhapathlen)//'/GRV98nlo.LHgrid'
     elseif((lhainput .ge. 80060) .and. (lhainput .le. 80060)) then
        lhaset = 80060
        lhaname=lhapath(1:lhapathlen)//'/GRV98lo.LHgrid'
     elseif((lhainput .ge. 80150) .and. (lhainput .le. 80151)) then
        q2min = 0.3d0
        q2max = 1.0d08
        lhaset = 80150
        lhaname=lhapath(1:lhapathlen)//'/GJR08lo.LHgrid'
     elseif((lhainput .ge. 80152) .and. (lhainput .le. 80152)) then
        q2min = 0.5d0
        q2max = 1.0d08
        lhaset = 80152
        lhaname=lhapath(1:lhapathlen)//'/GJR08FFdis.LHgrid'
     elseif((lhainput .ge. 80160) .and. (lhainput .le. 80186)) then
        q2min = 0.5d0
        q2max = 1.0d08
        lhaset = 80160
        lhaname=lhapath(1:lhapathlen)//'/GJR08FFnloE.LHgrid'
     elseif((lhainput .ge. 80260) .and. (lhainput .le. 80286)) then
        q2min = 0.5d0
        q2max = 1.0d08
        lhaset = 80260
        lhaname=lhapath(1:lhapathlen)//'/GJR08VFnloE.LHgrid'
     elseif((lhainput .ge. 80360) .and. (lhainput .le. 80386)) then
        q2min = 0.55d0
        q2max = 1.0d08
        lhaset = 80360
        lhaname=lhapath(1:lhapathlen)//'/JR09FFnnloE.LHgrid'
     elseif((lhainput .ge. 80460) .and. (lhainput .le. 80486)) then
        q2min = 0.55d0
        q2max = 1.0d08
        lhaset = 80460
        lhaname=lhapath(1:lhapathlen)//'/JR09VFnnloE.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
!...NNPDF  Family
  ELSEIF((LHAINPUT .GE. 90000) .AND. (LHAINPUT .LE. 98000)) THEN
     XMIN = 1.0D-9 
     Q2MIN = 2.0D0 
     Q2MAX = 1.0D08  
     IF((LHAINPUT .GE. 90000) .AND. (LHAINPUT .LE. 90100)) THEN
     	LHASET = 90000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF10_100.LHpdf'
     ELSEIF((LHAINPUT .GE. 90200) .AND. (LHAINPUT .LE. 90300))THEN
     	LHASET = 90200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF10_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90400) .AND. (LHAINPUT .LE. 90500))THEN
     	LHASET = 90400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF11_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90600) .AND. (LHAINPUT .LE. 90700))THEN
     	LHASET = 90600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF12_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90800) .AND. (LHAINPUT .LE. 90900))THEN
     	LHASET = 90800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90901) .AND. (LHAINPUT .LE. 90901))THEN
     	LHASET = 90901
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0114_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90902) .AND. (LHAINPUT .LE. 90902))THEN
     	LHASET = 90902
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0115_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90903) .AND. (LHAINPUT .LE. 90903))THEN
     	LHASET = 90903
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0116_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90904) .AND. (LHAINPUT .LE. 90904))THEN
     	LHASET = 90904
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0117_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90905) .AND. (LHAINPUT .LE. 90905))THEN
     	LHASET = 90905
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0118_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90906) .AND. (LHAINPUT .LE. 90906))THEN
     	LHASET = 90906
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0120_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90907) .AND. (LHAINPUT .LE. 90907))THEN
     	LHASET = 90907
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0121_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90908) .AND. (LHAINPUT .LE. 90908))THEN
     	LHASET = 90908
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0122_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90909) .AND. (LHAINPUT .LE. 90909))THEN
     	LHASET = 90909
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0123_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 90910) .AND. (LHAINPUT .LE. 90910))THEN
     	LHASET = 90910
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0124_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 91000) .AND. (LHAINPUT .LE. 92000)) THEN
     	LHASET = 91000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF10_1000.LHpdf'
     ELSEIF((LHAINPUT .GE. 93000) .AND. (LHAINPUT .LE. 94000))THEN
     	LHASET = 93000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF10_1000.LHgrid'		  
     ELSEIF((LHAINPUT .GE. 95000) .AND. (LHAINPUT .LE. 96000))THEN
     	LHASET = 95000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF12_1000.LHgrid'		  
     ELSEIF((LHAINPUT .GE. 97000) .AND. (LHAINPUT .LE. 98000))THEN
     	LHASET = 97000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_1000.LHgrid'		  
     ELSE
     	WRITE(LHAPRINT,5150)  LHASET
     	STOP
        ENDIF          
!...NNPDF  Family second tranche
  ELSEIF((LHAINPUT .GE. 190000) .AND. (LHAINPUT .LE. 210100)) THEN
     XMIN = 1.0D-9 
     Q2MIN = 2.0D0 
     Q2MAX = 1.0D08  
     IF((LHAINPUT .GE. 190000) .AND. (LHAINPUT .LE. 190100))THEN
     	LHASET = 190000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0114_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 190200) .AND. (LHAINPUT .LE. 190300))THEN
     	LHASET = 190200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0115_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 190400) .AND. (LHAINPUT .LE. 190500))THEN
     	LHASET = 190400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0116_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 190600) .AND. (LHAINPUT .LE. 190700))THEN
     	LHASET = 190600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0117_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 190800) .AND. (LHAINPUT .LE. 190900))THEN
     	LHASET = 190800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0118_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 191000) .AND. (LHAINPUT .LE. 191100))THEN
     	LHASET = 191000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0120_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 191200) .AND. (LHAINPUT .LE. 191300))THEN
     	LHASET = 191200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0121_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 191400) .AND. (LHAINPUT .LE. 191500))THEN
     	LHASET = 191400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0122_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 191600) .AND. (LHAINPUT .LE. 191700))THEN
     	LHASET = 191600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0123_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 191800) .AND. (LHAINPUT .LE. 191900))THEN
     	LHASET = 191800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_as_0124_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 192000) .AND. (LHAINPUT .LE. 192100))THEN
     	LHASET = 192000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_heraold_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 192200) .AND. (LHAINPUT .LE. 192300))THEN
     	LHASET = 192200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_dis_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 192400) .AND. (LHAINPUT .LE. 192500))THEN
     	LHASET = 192400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_dis+dy_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 192600) .AND. (LHAINPUT .LE. 192700))THEN
     	LHASET = 192600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF20_dis+jet_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 192800) .AND. (LHAINPUT .LE. 192900))THEN
     	LHASET = 192800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 192901) .AND. (LHAINPUT .LE. 193901))THEN
     	LHASET = 192901 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_1000.LHgrid'
     ELSEIF((LHAINPUT .GE. 194000) .AND. (LHAINPUT .LE. 194100))THEN
     	LHASET = 194000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0114_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 194200) .AND. (LHAINPUT .LE. 194300))THEN
     	LHASET = 194200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0115_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 194400) .AND. (LHAINPUT .LE. 194500))THEN
     	LHASET = 194400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0116_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 194600) .AND. (LHAINPUT .LE. 194700))THEN
     	LHASET = 194600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0117_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 194800) .AND. (LHAINPUT .LE. 194900))THEN
     	LHASET = 194800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0118_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 195000) .AND. (LHAINPUT .LE. 195100))THEN
     	LHASET = 195000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0120_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 195200) .AND. (LHAINPUT .LE. 195300))THEN
     	LHASET = 195200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0121_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 195400) .AND. (LHAINPUT .LE. 195500))THEN
     	LHASET = 195400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0122_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 195600) .AND. (LHAINPUT .LE. 195700))THEN
     	LHASET = 195600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0123_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 195800) .AND. (LHAINPUT .LE. 195900))THEN
     	LHASET = 195800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_as_0124_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 196000) .AND. (LHAINPUT .LE. 196100))THEN
     	LHASET = 196000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_mc_15_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 196200) .AND. (LHAINPUT .LE. 196300))THEN
     	LHASET = 196200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_mc_16_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 196400) .AND. (LHAINPUT .LE. 196500))THEN
     	LHASET = 196400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_mc_17_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 196600) .AND. (LHAINPUT .LE. 196700))THEN
     	LHASET = 196600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_mb_425_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 196800) .AND. (LHAINPUT .LE. 196900))THEN
     	LHASET = 196800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_mb_45_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 197000) .AND. (LHAINPUT .LE. 197100))THEN
     	LHASET = 197000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_mb_50_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 197200) .AND. (LHAINPUT .LE. 197300))THEN
     	LHASET = 197200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_mb_525_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 197400) .AND. (LHAINPUT .LE. 197500))THEN
     	LHASET = 197400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_FFN_NF3_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 197600) .AND. (LHAINPUT .LE. 197700))THEN
     	LHASET = 197600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_FFN_NF4_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 197800) .AND. (LHAINPUT .LE. 197900))THEN
     	LHASET = 197800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_FFN_NF5_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 198000) .AND. (LHAINPUT .LE. 198100))THEN
     	LHASET = 198000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_dis_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 198101) .AND. (LHAINPUT .LE. 199101))THEN
     	LHASET = 198101 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_dis_1000.LHgrid'
     ELSEIF((LHAINPUT .GE. 199200) .AND. (LHAINPUT .LE. 199300))THEN
     	LHASET = 199200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_dis+dy_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 199400) .AND. (LHAINPUT .LE. 199500))THEN
     	LHASET = 199400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_dis+jet_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 200000) .AND. (LHAINPUT .LE.200100))THEN
     	LHASET = 200000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 200200) .AND. (LHAINPUT .LE.200300))THEN
     	LHASET = 200200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_lo_as_0119_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 200400) .AND. (LHAINPUT .LE.200500))THEN
     	LHASET = 200400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_lo_as_0130_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 200600) .AND. (LHAINPUT .LE.200700))THEN
     	LHASET = 200600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_lostar_as_0119_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 200800) .AND. (LHAINPUT .LE.200900))THEN
     	LHASET = 200800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_lostar_as_0130_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 201000) .AND. (LHAINPUT .LE.202000))THEN
     	LHASET = 201000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_1000.LHgrid'
     ELSEIF((LHAINPUT .GE. 203000) .AND. (LHAINPUT .LE.203100))THEN
     	LHASET = 203000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0114_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 203200) .AND. (LHAINPUT .LE.203300))THEN
     	LHASET = 203200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0115_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 203400) .AND. (LHAINPUT .LE.203500))THEN
     	LHASET = 203400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0116_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 203600) .AND. (LHAINPUT .LE.203700))THEN
     	LHASET = 203600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0117_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 203800) .AND. (LHAINPUT .LE.203900))THEN
     	LHASET = 203800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0118_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 204000) .AND. (LHAINPUT .LE.204100))THEN
     	LHASET = 204000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0120_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 204200) .AND. (LHAINPUT .LE.204300))THEN
     	LHASET = 204200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0121_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 204400) .AND. (LHAINPUT .LE.204500))THEN
     	LHASET = 204400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0122_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 204600) .AND. (LHAINPUT .LE.204700))THEN
     	LHASET = 204600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0123_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 204800) .AND. (LHAINPUT .LE.204900))THEN
     	LHASET = 204800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_as_0124_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 205000) .AND. (LHAINPUT .LE.205100))THEN
     	LHASET = 205000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_mc_15_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 205200) .AND. (LHAINPUT .LE.205300))THEN
     	LHASET = 205200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_mc_16_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 205400) .AND. (LHAINPUT .LE.205500))THEN
     	LHASET = 205400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_mc_17_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 206000) .AND. (LHAINPUT .LE.206100))THEN
     	LHASET = 206000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_mb_425_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 206200) .AND. (LHAINPUT .LE.206300))THEN
     	LHASET = 206200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_mb_45_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 206400) .AND. (LHAINPUT .LE.206500))THEN
     	LHASET = 206400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_mb_50_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 206600) .AND. (LHAINPUT .LE.206700))THEN
     	LHASET = 206600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_mb_525_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 207000) .AND. (LHAINPUT .LE.207100))THEN
     	LHASET = 207000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_dis_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 207200) .AND. (LHAINPUT .LE.207300))THEN
     	LHASET = 207200 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_dis+dy_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 207400) .AND. (LHAINPUT .LE.207500))THEN
     	LHASET = 207400 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_heraonly_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 207600) .AND. (LHAINPUT .LE.207700))THEN
     	LHASET = 207600 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_collider_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 207800) .AND. (LHAINPUT .LE.207900))THEN
     	LHASET = 207800 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF21_nnlo_nf5_100.LHgrid'
     ELSEIF((LHAINPUT .GE. 210000) .AND. (LHAINPUT .LE.210100))THEN
     	LHASET = 210000 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF22_nlo_100.LHgrid'
     ELSE
     	WRITE(LHAPRINT,5150)  LHASET
     	STOP
        ENDIF          
!...NNPDF 2.3  Family 
  ELSEIF((LHAINPUT .GE. 229000) .AND. (LHAINPUT .LE. 246700)) THEN
     XMIN = 1.0D-9 
     Q2MIN = 2.0D0 
     Q2MAX = 1.0D08  

     IF((LHAINPUT .GE. 229000) .AND. (LHAINPUT .LE. 229100))THEN
     	LHASET = 229000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0114.LHgrid'
     ELSEIF((LHAINPUT .GE. 229200) .AND. (LHAINPUT .LE. 229300))THEN
     	LHASET = 229200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0115.LHgrid'
     ELSEIF((LHAINPUT .GE. 229400) .AND. (LHAINPUT .LE. 229500))THEN
     	LHASET = 229400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 229600) .AND. (LHAINPUT .LE. 229700))THEN
     	LHASET = 229600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 229800) .AND. (LHAINPUT .LE. 229900))THEN
     	LHASET = 229800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 230000) .AND. (LHAINPUT .LE. 230100))THEN
     	LHASET = 230000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 230200) .AND. (LHAINPUT .LE. 230300))THEN
     	LHASET = 230200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0120.LHgrid'
     ELSEIF((LHAINPUT .GE. 230400) .AND. (LHAINPUT .LE. 230500))THEN
     	LHASET = 230400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0121.LHgrid'
     ELSEIF((LHAINPUT .GE. 230600) .AND. (LHAINPUT .LE. 230700))THEN
     	LHASET = 230600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0122.LHgrid'
     ELSEIF((LHAINPUT .GE. 230800) .AND. (LHAINPUT .LE. 230900))THEN
     	LHASET = 230800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0123.LHgrid'
     ELSEIF((LHAINPUT .GE. 231000) .AND. (LHAINPUT .LE. 231100))THEN
     	LHASET = 231000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0124.LHgrid'

     ELSEIF((LHAINPUT .GE. 231200) .AND. (LHAINPUT .LE. 231300))THEN
     	LHASET = 231200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0114.LHgrid'
     ELSEIF((LHAINPUT .GE. 231400) .AND. (LHAINPUT .LE. 231500))THEN
     	LHASET = 231400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0115.LHgrid'
     ELSEIF((LHAINPUT .GE. 231600) .AND. (LHAINPUT .LE. 231700))THEN
     	LHASET = 231600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 231800) .AND. (LHAINPUT .LE. 231900))THEN
     	LHASET = 231800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 232000) .AND. (LHAINPUT .LE. 232100))THEN
     	LHASET = 232000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 232200) .AND. (LHAINPUT .LE. 232300))THEN
     	LHASET = 232200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 232400) .AND. (LHAINPUT .LE. 232500))THEN
     	LHASET = 232400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0120.LHgrid'
     ELSEIF((LHAINPUT .GE. 232600) .AND. (LHAINPUT .LE. 232700))THEN
     	LHASET = 232600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0121.LHgrid'
     ELSEIF((LHAINPUT .GE. 232800) .AND. (LHAINPUT .LE. 232900))THEN
     	LHASET = 232800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0122.LHgrid'
     ELSEIF((LHAINPUT .GE. 233000) .AND. (LHAINPUT .LE. 233100))THEN
     	LHASET = 233000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0123.LHgrid'
     ELSEIF((LHAINPUT .GE. 233200) .AND. (LHAINPUT .LE. 233300))THEN
     	LHASET = 233200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0124.LHgrid'

     ELSEIF((LHAINPUT .GE. 233400) .AND. (LHAINPUT .LE. 233500))THEN
     	LHASET = 233400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_noLHC_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 233600) .AND. (LHAINPUT .LE. 233700))THEN
     	LHASET = 233600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_noLHC_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 233800) .AND. (LHAINPUT .LE. 233900))THEN
     	LHASET = 233800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_noLHC_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 234000) .AND. (LHAINPUT .LE. 234100))THEN
     	LHASET = 234000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_noLHC_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 234200) .AND. (LHAINPUT .LE. 234300))THEN
     	LHASET = 234200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_noLHC_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 234400) .AND. (LHAINPUT .LE. 234500))THEN
     	LHASET = 234400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_noLHC_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 234600) .AND. (LHAINPUT .LE. 234700))THEN
     	LHASET = 234600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_noLHC_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 234800) .AND. (LHAINPUT .LE. 234900))THEN
     	LHASET = 234800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_noLHC_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 235000) .AND. (LHAINPUT .LE. 235100))THEN
     	LHASET = 235000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_noLHC_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 235200) .AND. (LHAINPUT .LE. 235300))THEN
     	LHASET = 235200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_noLHC_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 235400) .AND. (LHAINPUT .LE. 235500))THEN
     	LHASET = 235400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_collider_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 235600) .AND. (LHAINPUT .LE. 235700))THEN
     	LHASET = 235600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_collider_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 235800) .AND. (LHAINPUT .LE. 235900))THEN
     	LHASET = 235800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_collider_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 236000) .AND. (LHAINPUT .LE. 236100))THEN
     	LHASET = 236000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_collider_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 236200) .AND. (LHAINPUT .LE. 236300))THEN
     	LHASET = 236200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_collider_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 236400) .AND. (LHAINPUT .LE. 236500))THEN
     	LHASET = 236400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_collider_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 236600) .AND. (LHAINPUT .LE. 236700))THEN
     	LHASET = 236600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_collider_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 236800) .AND. (LHAINPUT .LE. 236900))THEN
     	LHASET = 236800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_collider_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 237000) .AND. (LHAINPUT .LE. 237100))THEN
     	LHASET = 237000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_collider_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 237200) .AND. (LHAINPUT .LE. 237300))THEN
     	LHASET = 237200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_collider_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 237400) .AND. (LHAINPUT .LE. 237500))THEN
     	LHASET = 237400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 237600) .AND. (LHAINPUT .LE. 237700))THEN
     	LHASET = 237600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 237800) .AND. (LHAINPUT .LE. 237900))THEN
     	LHASET = 237800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 238000) .AND. (LHAINPUT .LE. 238100))THEN
     	LHASET = 238000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 238200) .AND. (LHAINPUT .LE. 238300))THEN
     	LHASET = 238200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 238400) .AND. (LHAINPUT .LE. 238500))THEN
     	LHASET = 238400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF4_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 238600) .AND. (LHAINPUT .LE. 238700))THEN
     	LHASET = 238600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF4_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 238800) .AND. (LHAINPUT .LE. 238900))THEN
     	LHASET = 238800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF4_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 239000) .AND. (LHAINPUT .LE. 239100))THEN
     	LHASET = 239000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF4_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 239200) .AND. (LHAINPUT .LE. 239300))THEN
     	LHASET = 239200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF4_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 239400) .AND. (LHAINPUT .LE. 239500))THEN
     	LHASET = 239400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 239600) .AND. (LHAINPUT .LE. 239700))THEN
     	LHASET = 239600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 239800) .AND. (LHAINPUT .LE. 239900))THEN
     	LHASET = 239800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 240000) .AND. (LHAINPUT .LE. 240100))THEN
     	LHASET = 240000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 240200) .AND. (LHAINPUT .LE. 240300))THEN
     	LHASET = 240200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 240400) .AND. (LHAINPUT .LE. 240500))THEN
     	LHASET = 240400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF5_as_0116.LHgrid'
     ELSEIF((LHAINPUT .GE. 240600) .AND. (LHAINPUT .LE. 240700))THEN
     	LHASET = 240600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF5_as_0117.LHgrid'
     ELSEIF((LHAINPUT .GE. 240800) .AND. (LHAINPUT .LE. 240900))THEN
     	LHASET = 240800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF5_as_0118.LHgrid'
     ELSEIF((LHAINPUT .GE. 241000) .AND. (LHAINPUT .LE. 241100))THEN
     	LHASET = 241000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF5_as_0119.LHgrid'
     ELSEIF((LHAINPUT .GE. 241200) .AND. (LHAINPUT .LE. 241300))THEN
     	LHASET = 241200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_FFN_NF5_as_0120.LHgrid'

     ELSEIF((LHAINPUT .GE. 241400) .AND. (LHAINPUT .LE. 241500))THEN
     	LHASET = 241400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0116_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 241600) .AND. (LHAINPUT .LE. 241700))THEN
     	LHASET = 241600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0117_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 241800) .AND. (LHAINPUT .LE. 241900))THEN
     	LHASET = 241800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0118_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 242000) .AND. (LHAINPUT .LE. 242100))THEN
     	LHASET = 242000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0119_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 242200) .AND. (LHAINPUT .LE. 242300))THEN
     	LHASET = 242200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0120_mc.LHgrid'

     ELSEIF((LHAINPUT .GE. 242400) .AND. (LHAINPUT .LE. 242500))THEN
     	LHASET = 242400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0116_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 242600) .AND. (LHAINPUT .LE. 242700))THEN
     	LHASET = 242600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0117_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 242800) .AND. (LHAINPUT .LE. 242900))THEN
     	LHASET = 242800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0118_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 243000) .AND. (LHAINPUT .LE. 243100))THEN
     	LHASET = 243000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0119_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 243200) .AND. (LHAINPUT .LE. 243300))THEN
     	LHASET = 243200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF4_as_0120_mc.LHgrid'

     ELSEIF((LHAINPUT .GE. 243400) .AND. (LHAINPUT .LE. 243500))THEN
     	LHASET = 243400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0116_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 243600) .AND. (LHAINPUT .LE. 243700))THEN
     	LHASET = 243600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0117_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 243800) .AND. (LHAINPUT .LE. 243900))THEN
     	LHASET = 243800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0118_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 244000) .AND. (LHAINPUT .LE. 244100))THEN
     	LHASET = 244000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0119_mc.LHgrid'
     ELSEIF((LHAINPUT .GE. 244200) .AND. (LHAINPUT .LE. 244300))THEN
     	LHASET = 244200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_FFN_NF5_as_0120_mc.LHgrid'

     ELSEIF((LHAINPUT .GE. 244400) .AND. (LHAINPUT .LE. 244500))THEN
     	LHASET = 244400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0117_qed.LHgrid'
     ELSEIF((LHAINPUT .GE. 244600) .AND. (LHAINPUT .LE. 244700))THEN
     	LHASET = 244600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0118_qed.LHgrid'
     ELSEIF((LHAINPUT .GE. 244800) .AND. (LHAINPUT .LE. 244900))THEN
     	LHASET = 244800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0119_qed.LHgrid'

     ELSEIF((LHAINPUT .GE. 245000) .AND. (LHAINPUT .LE. 245100))THEN
     	LHASET = 245000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0117_qed_neutron.LHgrid'
     ELSEIF((LHAINPUT .GE. 245200) .AND. (LHAINPUT .LE. 245300))THEN
     	LHASET = 245200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0118_qed_neutron.LHgrid'
     ELSEIF((LHAINPUT .GE. 245400) .AND. (LHAINPUT .LE. 245500))THEN
     	LHASET = 245400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nlo_as_0119_qed_neutron.LHgrid'

     ELSEIF((LHAINPUT .GE. 245600) .AND. (LHAINPUT .LE. 245700))THEN
     	LHASET = 245600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0117_qed.LHgrid'
     ELSEIF((LHAINPUT .GE. 245800) .AND. (LHAINPUT .LE. 245900))THEN
     	LHASET = 245800
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0118_qed.LHgrid'
     ELSEIF((LHAINPUT .GE. 246000) .AND. (LHAINPUT .LE. 246100))THEN
     	LHASET = 246000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0119_qed.LHgrid'
     ELSEIF((LHAINPUT .GE. 246200) .AND. (LHAINPUT .LE. 246300))THEN
     	LHASET = 246200
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0117_qed_neutron.LHgrid'
     ELSEIF((LHAINPUT .GE. 246400) .AND. (LHAINPUT .LE. 246500))THEN
     	LHASET = 246400
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0118_qed_neutron.LHgrid'
     ELSEIF((LHAINPUT .GE. 246600) .AND. (LHAINPUT .LE. 246700))THEN
     	LHASET = 246600
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDF23_nnlo_as_0119_qed_neutron.LHgrid'

     ELSE
     	WRITE(LHAPRINT,5150)  LHASET
     	STOP
        ENDIF          
!...NNPDF Pol  Family 
  ELSEIF((LHAINPUT .GE. 250000) .AND. (LHAINPUT .LE. 250100)) THEN
     XMIN = 1.0D-9 
     Q2MIN = 2.0D0 
     Q2MAX = 1.0D08  
     IF((LHAINPUT .GE. 250000) .AND. (LHAINPUT .LE. 250100))THEN
     	LHASET = 250000
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/NNPDFpol10_100.LHgrid'
     ELSE
     	WRITE(LHAPRINT,5150)  LHASET
     	STOP
        ENDIF          
!...User defined  sets 
  ELSEIF((LHAINPUT .GE. 99002) .AND. (LHAINPUT .LE. 99004)) THEN
     XMIN = 1.0D-9 
     Q2MIN = 1.0D0 
     Q2MAX = 1.0D09  
     IF((LHAINPUT .GE.99002) .AND. (LHAINPUT .LE. 99002)) THEN
     	LHASET = 99002 
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/USERGRIDQ2.LHgrid'
     ELSEIF((LHAINPUT .GE. 99003) .AND. (LHAINPUT .LE. 99003))THEN
     	LHASET = 99003
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/USERGRIDQ3.LHgrid'
     ELSEIF((LHAINPUT .GE. 99004) .AND. (LHAINPUT .LE. 99004))THEN
     	LHASET = 99004
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/USERGRIDQ4.LHgrid'
     ELSE
     	WRITE(LHAPRINT,5150)  LHASET
     	STOP
     ENDIF          
!...Nuclear PDFs HKN sets 
  ELSEIF((LHAINPUT .GE. 100050) .AND. (LHAINPUT .LE. 100169)) THEN
     XMIN = 1.0D-9 
     Q2MIN = 1.0D0 
     Q2MAX = 1.0D08  
     IF((LHAINPUT .GE.100050) .AND. (LHAINPUT .LE. 100069)) THEN
     	LHASET = 100050
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/HKNlo.LHgrid'
     ELSEIF((LHAINPUT .GE. 100150) .AND. (LHAINPUT .LE. 100169))THEN
     	LHASET =100150
     	LHANAME=LHAPATH(1:LHAPATHLEN)//'/HKNnlo.LHgrid'
     ELSE
     	WRITE(LHAPRINT,5150)  LHASET
     	STOP
        ENDIF          
     ! 
     ! Pions
     ! 
     ! OW-PI Family
  elseif((lhainput .ge. 210) .and. (lhainput .le. 212)) then
     q2min = 4.0d0
     q2max = 2.0d03
     xmin = 5.0d-03
     xmax = 0.9998d0
     if((lhainput .ge. 210) .and. (lhainput .le. 212)) then
        lhaset = 210
        lhaname=lhapath(1:lhapathlen)//'/OWPI.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! SMRS-PI Family
  elseif((lhainput .ge. 230) .and. (lhainput .le. 233)) then
     q2min = 5.0d0
     q2max = 1.31d06
     xmin = 1.0d-05
     xmax = 0.9998d0
     if((lhainput .ge. 230) .and. (lhainput .le. 233)) then
        lhaset = 230
        lhaname=lhapath(1:lhapathlen)//'/SMRSPI.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! GRV-PI Family
  elseif((lhainput .ge. 250) .and. (lhainput .le. 252)) then
     q2max = 1.00d06
     xmin = 1.0d-05
     xmax = 0.9998d0
     if((lhainput .ge. 250) .and. (lhainput .le. 251)) then
        q2min = 3.0d-1
        lhaset = 250
        lhaname=lhapath(1:lhapathlen)//'/GRVPI1.LHgrid'
     elseif((lhainput .ge. 252) .and. (lhainput .le. 252)) then
        q2min = 2.5d-1
        lhaset = 252
        lhaname=lhapath(1:lhapathlen)//'/GRVPI0.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! ABFKW-PI Family
  elseif((lhainput .ge. 260) .and. (lhainput .le. 263)) then
     q2min = 2.0d0
     q2max = 1.00d08
     xmin = 1.0d-03
     xmax = 0.9998d0
     if((lhainput .ge. 260) .and. (lhainput .le. 263)) then
        lhaset = 260
        lhaname=lhapath(1:lhapathlen)//'/ABFKWPI.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! 
     ! photons
     ! 
     ! DO-G Family
  elseif((lhainput .ge. 310) .and. (lhainput .le. 312)) then
     q2min = 1.0d01
     q2max = 1.00d04
     xmin = 1.0d-05
     xmax = 0.9d0
     if((lhainput .ge. 310) .and. (lhainput .le. 311)) then
        lhaset = 310
        lhaname=lhapath(1:lhapathlen)//'/DOG0.LHgrid'
     elseif((lhainput .ge. 312) .and. (lhainput .le. 312)) then
        lhaset = 312
        lhaname=lhapath(1:lhapathlen)//'/DOG1.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! DG-G Family
  elseif((lhainput .ge. 320) .and. (lhainput .le. 324)) then
     xmin = 1.0d-05
     xmax = 0.9998d0
     lhaset = 320
     if((lhainput .ge. 320) .and. (lhainput .le. 321)) then
        q2min = 1.0d0
        q2max = 1.0d04
        ! lhaset = 320
        lhaname=lhapath(1:lhapathlen)//'/DGG.LHgrid'
     elseif((lhainput .ge. 322) .and. (lhainput .le. 322)) then
        q2min = 1.0d0
        q2max = 5.0d01
        ! lhaset = 322
        lhaname=lhapath(1:lhapathlen)//'/DGG.LHgrid'
     elseif((lhainput .ge. 323) .and. (lhainput .le. 323)) then
        q2min = 2.0d1
        q2max = 5.0d02
        ! lhaset = 323
        lhaname=lhapath(1:lhapathlen)//'/DGG.LHgrid'
     elseif((lhainput .ge. 324) .and. (lhainput .le. 324)) then
        q2min = 2.0d2
        q2max = 1.0d04
        ! lhaset = 324
        lhaname=lhapath(1:lhapathlen)//'/DGG.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! LAC/GAL-G Family
  elseif((lhainput .ge. 330) .and. (lhainput .le. 334)) then
     q2min = 4.0d00
     q2max = 1.0d05
     xmin = 1.0d-04
     xmax = 0.9998d0
     lhaset = 330
     if((lhainput .ge. 330) .and. (lhainput .le. 332)) then
        ! lhaset = 330
        lhaname=lhapath(1:lhapathlen)//'/LACG.LHgrid'
     elseif((lhainput .ge. 333) .and. (lhainput .le. 333)) then
        q2min = 1.0d00
        ! lhaset = 333
        lhaname=lhapath(1:lhapathlen)//'/LACG.LHgrid'
     elseif((lhainput .ge. 334) .and. (lhainput .le. 334)) then
        q2min = 4.0d00
        ! lhaset = 334
        lhaname=lhapath(1:lhapathlen)//'/LACG.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! GSG/GSG96-G Family
  elseif((lhainput .ge. 340) .and. (lhainput .le. 345)) then
     q2min = 5.3d00
     q2max = 1.0d08
     xmin = 5.0d-04
     xmax = 0.9998d0
     if((lhainput .ge. 340) .and. (lhainput .le. 341)) then
        lhaset = 340
        lhaname=lhapath(1:lhapathlen)//'/GSG1.LHgrid'
     elseif((lhainput .ge. 342) .and. (lhainput .le. 343)) then
        lhaset = 341
        lhaname=lhapath(1:lhapathlen)//'/GSG0.LHgrid'
     elseif((lhainput .ge. 344) .and. (lhainput .le. 344)) then
        lhaset = 344
        lhaname=lhapath(1:lhapathlen)//'/GSG961.LHgrid'
     elseif((lhainput .ge. 345) .and. (lhainput .le. 345)) then
        lhaset = 345
        lhaname=lhapath(1:lhapathlen)//'/GSG960.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! GRV-G Family
  elseif((lhainput .ge. 350) .and. (lhainput .le. 354)) then
     q2min = 3.0d-1
     q2max = 1.0d06
     xmin = 1.0d-05
     xmax = 0.9998d0
     if((lhainput .ge. 350) .and. (lhainput .le. 352)) then
        lhaset = 350
        lhaname=lhapath(1:lhapathlen)//'/GRVG1.LHgrid'
     elseif((lhainput .ge. 353) .and. (lhainput .le. 353)) then
        q2min = 2.5d-1
        lhaset = 352
        lhaname=lhapath(1:lhapathlen)//'/GRVG0.LHgrid'
     elseif((lhainput .ge. 354) .and. (lhainput .le. 354)) then
        q2min = 6.0d-1
        q2max = 5.0d04
        lhaset = 352
        lhaname=lhapath(1:lhapathlen)//'/GRVG0.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! ACFGP-G Family
  elseif((lhainput .ge. 360) .and. (lhainput .le. 363)) then
     q2min = 2.0d00
     q2max = 5.5d05
     xmin = 1.37d-03
     xmax = 0.9998d0
     if((lhainput .ge. 360) .and. (lhainput .le. 363)) then
        lhaset = 360
        lhaname=lhapath(1:lhapathlen)//'/ACFGPG.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! WHIT-G Family
  elseif((lhainput .ge. 380) .and. (lhainput .le. 386)) then
     q2min = 4.0d00
     q2max = 2.5d03
     xmin = 1.0d-03
     xmax = 0.9998d0
     if((lhainput .ge. 380) .and. (lhainput .le. 386)) then
        lhaset = 380
        lhaname=lhapath(1:lhapathlen)//'/WHITG.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! SAS-G Family
  elseif ((lhainput .ge. 390) .and. (lhainput .le. 398)) then
     q2max = 5.0d04
     xmin = 1.0d-05
     xmax = 0.9998d0
     lhaset = 390
     if ((lhainput .ge. 390) .and. (lhainput .le. 392)) then
        q2min = 3.6d-1
        ! lhaset = 390
        lhaname=lhapath(1:lhapathlen)//'/SASG.LHgrid'
     elseif((lhainput .ge. 393) .and. (lhainput .le. 394)) then
        q2min = 4.0d00
        !           lhaset = 393
        lhaname=lhapath(1:lhapathlen)//'/SASG.LHgrid'
     elseif((lhainput .ge. 395) .and. (lhainput .le. 396)) then
        q2min = 3.6d-1
        !           lhaset = 395
        lhaname=lhapath(1:lhapathlen)//'/SASG.LHgrid'
     elseif((lhainput .ge. 397) .and. (lhainput .le. 398)) then
        q2min = 4.0d00
        !           lhaset = 397
        lhaname=lhapath(1:lhapathlen)//'/SASG.LHgrid'
     else
        write(lhaprint,5150)  lhaset
        stop
     endif
     ! Unknown Family ?! Giving up
  else
     write(lhaprint,5150)  lhaset
     stop
  endif

  lhamemb=lhainput-lhaset
  ! Now work out if we have already called this set/member
  iset = 0
  do j=1,nsets
     if (lhaname.eq.lhanames(j).and. &
          lhamemb.eq.lhamembers(j)) then
        iset = j
     endif
  enddo
  if (iset.eq.0) then
     nsets=nsets+1
     if (nsets.gt.nmxset) then
        if (LHASILENT.ne.1) then
           print *, "WARNING: too many sets initialised"
           print *,"overwriting from set 1 again"
        endif
        nsets = 1
        ! stop
     endif
     iset=nsets
     lhanames(iset)=lhaname
     lhanumbers(iset)=lhainput
     lhamembers(iset)=lhamemb
     xxmin(iset)=xmin
     xxmax(iset)=xmax
     qq2min(iset)=q2min
     qq2max(iset)=q2max
     call initpdfsetm(iset,lhaname)
     call numberpdfm(iset,lhaallmem)
     if(lhasilent .ne. 1) then
        write(lhaprint,5151)
        write(lhaprint,5152) lhaname
        write(lhaprint,5153) lhaallmem
        write(lhaprint,5154)
     endif
     if ((lhamemb.lt.0) .or. (lhamemb.gt.lhaallmem)) then
        write(lhaprint,5155)  lhamemb
        write(lhaprint,5156)  lhaallmem
        stop
     endif

     ! print *,'calling initpdf',lhamemb 
     ! print *,'calling initpdfm ',iset,lhaname,lhamemb
     ! print *,'LHAGLUE .... initializing set,member ',iset,lhamemb
     call initpdfm(iset,lhamemb)
  endif
  !  the rest is done every time pdfset is called
  !print *,'setting nset to:',iset
  call setnset(iset)
  call setnmem(iset,lhamemb)
  xmin = xxmin(iset)
  xmax = xxmax(iset)
  q2min=qq2min(iset)
  q2max=qq2max(iset)
  call GetLam4M(iset,LHAMEMB,qcdl4)
  call GetLam5M(iset,LHAMEMB,qcdl5)

  QMZ = 91.1876D0
  alphasLHA = alphasPDFM(iset,QMZ)
  if(lhasilent .ne. 1) write(lhaprint,5158) alphasLHA

  if(lhaparm(17).EQ.'LHAPDF') then
     nptypepdfl = 1      ! Proton PDFs
     nflpdfl = 4
     qcdlha4 = qcdl4
     qcdlha5 = qcdl5
     if (LHASILENT .NE. 1) write(lhaprint,5159) qcdl4, qcdl5
  else
     nptypepdfl = 1      ! Proton PDFs
     nflpdfl = 4
     alambda = 0.192d0
     qcdlha4 = alambda
     qcdlha5 = alambda
     if (parm(1).EQ.'NPTYPE') then        !  PYTHIA
        qcdl4 = alambda
        qcdl5 = alambda
     endif
  endif

  ! Formats for initialization information.
5150 format(1X,'WRONG LHAPDF set number =',I12,' given! STOP EXE!')
5151 format(1X,'==============================================')
5152 format(1X,'PDFset name ',A80)
5153 format(1X,'with ',I10,' members')
5154 format(1X,'====  initialized. ===========================')
5155 format(1X,'LHAPDF problem => YOU asked for member = ',I10)
5156 format(1X,'Valid range is: 0 - ',I10,' Execution stopped.')
  !5157 format(1X,'Number of flavors for PDF is:',I4)
5158 format(1X,'Strong coupling at Mz for PDF is:',F9.5)
5159 format(1X,'Will use for PYTHIA QCDL4, QCDL5:',2F9.5)

  return
end subroutine pdfset


!********************************************************************
! -- STRUCTA
! -- copy of PDFLIB to use the eks98 nuclear correction factors

subroutine structa(x,q,a,upv,dnv,usea,dsea,str,chm,bot,top,glu)
  implicit double precision (a-h,o-z)
  character*20 lparm
  call getlhaparm(15,lparm)
  if(lparm.eq.'EPS08') then
     call eps08(x,q,a,ruv,rdv,ru,rd,rs,rc,rb,rt,rg)
  else if (lparm(1:5).eq.'EPS09') then
    if (lparm.eq.'EPS09LO') then
      iorder=1
      ipset=1
    else if (lparm.eq.'EPS09NLO') then
      iorder=2
      ipset=1
    else if (lparm(1:8).eq.'EPS09LO,') then
      iorder=1
      read(lparm(9:),*)ipset
    else if (lparm(1:9).eq.'EPS09NLO,') then
      iorder=2
      read(lparm(10:),*)ipset
    else
      iorder=2
      ipset=1
    endif
    ia=a
    call eps09(iorder,ipset,ia,x,q,ruv,rdv,ru,rd,rs,rc,rb,rg)
    rt=1.0d0
  else
     call eks98(x,q,a,ruv,rdv,ru,rd,rs,rc,rb,rt,rg)
  endif
  call structm(x,q,upv,dnv,usea,dsea,str,chm,bot,top,glu)
  upv = ruv*upv
  dnv = rdv*dnv
  usea = ru*usea
  dsea = rd*dsea
  str = rs*str
  chm = rc*chm
  bot = rb*bot
  top = rt*top
  glu = rg*glu
  return
end subroutine structa


!*********************************************************************
! STRUCTM
! Gives parton distributions according to the LHAPDF interface.
! Two evolution codes used:
!   EVLCTEQ for CTEQ PDF sets
!   QCDNUM  for Other PDF sets
! 
! Author: Dimitri Bourilkov  bourilkov@mailaps.org
! 
! v4.0  21-Mar-2005  Photon/pion/new p PDFs, updated for LHAPDF v4
! v3.0  23-Jan-2004
! 
! interface to LHAPDF library
subroutine structm(dx,dq,upv,dnv,usea,dsea,str,chm,bot,top,glu)
  ! double precision and integer declarations.
  implicit double precision(a-h, o-z)
  implicit integer(i-n)
  ! Common blocks
  include 'commonlhapdf.inc'
  include 'commonlhasets.inc'
  include 'commonlhacontrol.inc'
  include 'commonlhaglsta.inc'
  ! commonblocks.
  common/pydat1/mstu(200),paru(200),mstj(200),parj(200)
  save /pydat1/
  ! interface to lhapdflib.
  double precision qcdlha4, qcdlha5
  integer nfllha
  common/lhapdfr/qcdlha4, qcdlha5, nfllha
  save /lhapdfr/
  integer lhaextrp
  common/lhapdfe/lhaextrp
  save /lhapdfe/
  ! interface to pdflib.
  common/w50513/xmin,xmax,q2min,q2max
  save /w50513/
  double precision xmin,xmax,q2min,q2max
  ! local variables
  double precision upv,dnv,usea,dsea,str,chm,bot,top,glu
  double precision dx,dq,x,q,f(-6:6),photon,gluino

  x = dx
  q = dq
  q2 = q**2
  ! statistics
  if(lhaparm(16).ne.'NOSTAT') then
     totnum = totnum+1.d0
     if(x .lt. xmin) xminnum = xminnum+1.d0
     if(x .gt. xmax) xmaxnum = xmaxnum+1.d0
     if(q2 .lt. q2min) q2minnum = q2minnum+1.d0
     if(q2 .gt. q2max) q2maxnum = q2maxnum+1.d0
  endif

  ! range of validity e.g. 10^-6 < x < 1, q2min < q^2 extended by
  ! freezing x*f(x,q2) at borders.
  if(lhaextrp .ne. 1) then    ! safe mode == "freeze"
     xin=max(xmin,min(xmax,x))
     q=sqrt(max(0d0,q2min,min(q2max,q2)))
  else                        ! adventurous mode == own risk !
     xin=x
  endif

  call getnset(iset)
  !print *,'calling evolvepdfm:',iset

  ! fix to allow STRUCTM to work for photon PDFs (Herwig does this)
  ! set P2 = 0.0d0 and IP2 = 0
  if(lhanumbers(iset).ge.300.and.lhanumbers(iset).le.399) then  
     p2 = 0.0d0
     ip2 = 0
     call evolvepdfpm(iset,xin,q,p2,ip2,f)
  else if (lhanumbers(iset).ge.20460.and.lhanumbers(iset).le.20462) then
     call evolvepdfphotonm(iset,xin,q,f,photon)
  else if (lhanumbers(iset).ge.10670.and.lhanumbers(iset).le.10677) then
     call evolvepdfgluinom(iset,xin,q,f,gluino)
  else
     call evolvepdfm(iset,xin,q,f)
  endif
  glu = f(0)
  dsea = f(-1)
  dnv = f(1) - dsea
  usea = f(-2)
  upv = f(2) - usea
  str = f(3)
  chm = f(4)
  bot = f(5)
  top = f(6)

  return
end subroutine structm


!*********************************************************************
! STRUCTP
! Gives parton distributions according to the LHAPDF interface.
! Used for photons.
! 
! v4.0  21-Mar-2005  Photon/pion/new p PDFs, updated for LHAPDF v4
! 
! Interface to LHAPDF library
subroutine structp(dx,dq2,p2,ip2,upv,dnv,usea,dsea,str,chm,bot,top,glu)
  ! Double precision and integer declarations.
  implicit double precision(a-h, o-z)
  implicit integer(i-n)
  ! Common blocks
  include 'parmsetup.inc'
  include 'commonlhapdf.inc'
  include 'commonlhacontrol.inc'
  include 'commonlhaglsta.inc'
  ! Commonblocks.
  common/pydat1/mstu(200),paru(200),mstj(200),parj(200)
  save /pydat1/
  ! Interface to LHAPDFLIB.
  double precision qcdlha4, qcdlha5
  integer nfllha
  common/lhapdfr/qcdlha4, qcdlha5, nfllha
  save /lhapdfr/
  integer lhaextrp
  common/lhapdfe/lhaextrp
  save /lhapdfe/
  ! Interface to PDFLIB.
  common/w50513/xmin,xmax,q2min,q2max
  save /w50513/
  double precision xmin,xmax,q2min,q2max
  ! Local variables
  double precision upv,dnv,usea,dsea,str,chm,bot,top,glu
  double precision dx,dq2,q2,x,q,f(-6:6)

  x = dx
  q2 = dq2
  ! Statistics
  if(lhaparm(16).ne.'NOSTAT') then
     totnup = totnup+1.d0
     if(x .lt. xmin) xminnup = xminnup+1.d0
     if(x .gt. xmax) xmaxnup = xmaxnup+1.d0
     if(q2 .lt. q2min) q2minnup = q2minnup+1.d0
     if(q2 .gt. q2max) q2maxnup = q2maxnup+1.d0
  endif

  ! Range of validity e.g. 10^-6 < x < 1, Q2MIN < Q^2 extended by
  ! freezing x*f(x,Q2) at borders.
  q = dsqrt(q2)
  if(lhaextrp .ne. 1) then    ! safe mode == "freeze"
     xin=max(xmin,min(xmax,x))
     q=sqrt(max(0d0,q2min,min(q2max,q2)))
  else                        ! adventurous mode == OWN RISK !
     xin=x
  endif
  call getnset(iset)
  call evolvepdfpm(iset,xin,q,p2,ip2,f)
  glu = f(0)
  dsea = f(-1)
  dnv = f(1) - dsea
  usea = f(-2)
  upv = f(2) - usea
  str = f(3)
  chm = f(4)
  bot = f(5)
  top = f(6)
  return
end subroutine structp


!*********************************************************************
! PDFSTA
! For statistics ON structure functions (under/over-flows)
! 
! Author: Dimitri Bourilkov  bourilkov@mailaps.org
! 
! 
! first introduced in v4.0  28-Apr-2005 
! 
subroutine pdfsta
  ! Double precision and integer declarations.
  implicit double precision(a-h, o-z)
  implicit integer(i-n)
  ! Common blocks
  include 'commonlhaglsta.inc'
  ! Interface to LHAPDFLIB.

  print *
  print *,'===== PDFSTA statistics for PDF under/over-flows ===='
  print *
  print *,'====== STRUCTM statistics for nucleon/pion PDFs ====='
  print *
  print *,'  total # of calls ',TOTNUM
  if(totnum .gt. 0.d0) then
     percbelow = 100.d0*xminnum/totnum
     percabove = 100.d0*xmaxnum/totnum
     print *,'  X  below PDF min ',xminnum,' or ',percbelow, ' %'
     print *,'  X  above PDF max ',xmaxnum,' or ',percabove, ' %'
     percbelow = 100.d0*q2minnum/totnum
     percabove = 100.d0*q2maxnum/totnum
     print *,'  Q2 below PDF min ',q2minnum,' or ',percbelow, ' %'
     print *,'  Q2 above PDF max ',q2maxnum,' or ',percabove, ' %'
  endif
  print *
  print *,'========= STRUCTP statistics for photon PDFs ========'
  print *
  print *,'  total # of calls ',totnup
  if(totnup .gt. 0.d0) then
     percbelow = 100.d0*xminnup/totnup
     percabove = 100.d0*xmaxnup/totnup
     print *,'  X  below PDF min ',xminnup,' or ',percbelow, ' %'
     print *,'  X  above PDF max ',xmaxnup,' or ',percabove, ' %'
     percbelow = 100.d0*q2minnup/totnup
     percabove = 100.d0*q2maxnup/totnup
     print *,'  Q2 below PDF min ',q2minnup,' or ',percbelow, ' %'
     print *,'  Q2 above PDF max ',q2maxnup,' or ',percabove, ' %'
  endif
  print *
  return
end subroutine pdfsta


subroutine pftopdg(dx,dscale,dxpdf)
  !include "pdf/expdp.inc"
  double precision dx,dscale,dupv,ddnv,dusea,ddsea,dstr,dchm,dbot,dtop,dgl,dxpdf(-6:6)
  ! Call STRUCTM in PDFLIB to get flavour content
  call structm(dx,dscale,dupv,ddnv,dusea,ddsea,dstr,dchm,dbot,dtop,dgl)
  ! Convert flavour convention of PDFLIB to PDG convention
  dxpdf(0) = dgl
  dxpdf(1) = ddnv + ddsea
  dxpdf(2) = dupv + dusea
  dxpdf(3) = dstr
  dxpdf(4) = dchm
  dxpdf(5) = dbot
  dxpdf(6) = dtop
  dxpdf(-1) = ddsea
  dxpdf(-2) = dusea
  dxpdf(-3) = dstr
  dxpdf(-4) = dchm
  dxpdf(-5) = dbot
  dxpdf(-6) = dtop
  return
end subroutine pftopdg

! -*- F90 -*-


      subroutine SASGevolvep(xin,qin,p2in,ip2in,pdf) 
      real*8 xin,qin,q2in,p2in,pdf(-6:6),xval(45),qcdl4,qcdl5 
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
                                                                        
      save 
      call getnset(iset) 
      call getnmem(iset,imem) 
                                                                        
      iimem = imem 
      if(iimem.eq.0) iimem=6 
      q2in = qin*qin 
      call SFSASxx(iimem,xin,Q2in,p2in,ip2,                             &
     &                     upv,dnv,usea,dsea,str,chm,bot,top,glu)       
                                                                        
      pdf(-6)= top 
      pdf(6)= top 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SASGread(nset) 
!      print *,'calling SASGread'                                       
      read(1,*)nmem(nset),ndef(nset) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SASGalfa(alfas,qalfa) 
        call getnset(iset) 
        call getnmem(iset,imem) 
        call GetOrderAsM(iset,iord) 
        call Getlam4M(iset,imem,qcdl4) 
        call Getlam5M(iset,imem,qcdl5) 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
                                                                        
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SASGinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SASGpdf(mem) 
!      print *,'calling SASGpdf',mem                                    
!      imem = mem                                                       
      call getnset(iset) 
      call setnmem(iset,mem) 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!-----------------------------------------------------------------------
      SUBROUTINE SFSASxx(iset,DX,DQ2,DP2,ip2,                           &
     &                     DUPV,DDNV,DSEA,DSEAD,DSTR,DCHM,DBOT,DTOP,DGL)
!                                                                       
!   ********************************************************************
!   *                                                                  *
!   *        Interface to SASset of structure functions                *
!   *                                                                  *
!   *        Author:    H. Plothow-Besch (CERN-PPE)                    *
!   *                                                                  *
!   ********************************************************************
!                                                                       
! :::::::::::: Structure functions from the SAS group version 2         
! :::::::::::: Lambda = 0.200 GeV, Q**2 = 0.36 GeV**2 (DIS)             
!                                                                       
      double precision                                                  &
     &          DX,DQ2,DP2,                                             &
     &          DUPV,DDNV,DSEA,DSEAD,DSTR,DCHM,DBOT,DTOP,DGL            
      DIMENSION XPDFGM(-6:6) 
      REAL X, Q, Q2, P2, F2GAM, XPDFGM 
!      PARAMETER (ISET=1)                                               
!                                                                       
      X  = DX 
      Q  = SQRT(DQ2) 
      Q2 = DQ2 
      P2 = DP2 
!                                                                       
!     generate the individual structure fcn calls                       
!                                                                       
      if(iset.le.4) then 
         iiset=iset 
         CALL LHASASGAM1(iISET,X,Q2,P2,F2GAM,XPDFGM) 
      else 
         iiset = iset-4 
         CALL LHASASGAM2(iISET,X,Q2,P2,ip2,F2GAM,XPDFGM) 
      endif 
                                                                        
      UPV = XPDFGM(2) 
      DUPV = UPV 
      DNV = XPDFGM(1) 
      DDNV = DNV 
      SEAU = XPDFGM(-2) 
      DSEA = SEAU 
      SEAD = XPDFGM(-1) 
      DSEAD = SEAD 
      STR = XPDFGM(-3) 
      DSTR = STR 
      CHM = XPDFGM(-4) 
      DCHM = CHM 
      BOT = XPDFGM(-5) 
      DBOT = BOT 
      TOP = 0. 
!      IF (DSCAL.GT.TMAS) TOP = XPDFGM(6)                               
      DTOP = TOP 
      GL = XPDFGM(0) 
      DGL = GL 
!                                                                       
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! ------------- SASGAM1 ------------------------                        
!...SaSgam - parton distributions of the photon                         
!...by Gerhard A. Schuler and Torbjorn Sjostrand                        
!...For further information see preprint CERN-TH/95-62 and LU TP 95-6:  
!...Low- and high-mass components of the photon distribution functions  
!...Program last changed on 21 March 1995.                              
                                                                        
!...The user should only need to call the SASGAM routine,               
!...which in turn calls the auxiliary routines SASVM1, SASAN1,          
!...SASBEH and SASDIR. The package is self-contained.                   
                                                                        
!...One particular aspect of these parametrizations is that F2 for      
!...the photon is not obtained just as the charge-squared-weighted      
!...sum of quark distributions, but differ in the treatment of          
!...heavy flavours (in F2 the DIS relation W2 = Q2*(1-x)/x restricts    
!...the kinematics range of heavy-flavour production, but the same      
!...kinematics is not relevant e.g. for jet production) and, for the    
!...'MSbar' fits, in the addition of a Cgamma term related to the       
!...separation of direct processes. Schematically:                      
!...PDF = VMD (rho, omega, phi) + anomalous (d, u, s, c, b).            
!...F2  = VMD (rho, omega, phi) + anomalous (d, u, s) +                 
!...      Bethe-Heitler (c, b) (+ Cgamma (d, u, s)).                    
!...The J/psi and Upsilon states have not been included in the VMD sum, 
!...but low c and b masses in the other components should compensate    
!...for this in a duality sense.                                        
                                                                        
!...The calling sequence is the following:                              
!     CALL SASGAM1(ISET,X,Q2,P2,F2GM,XPDFGM)                            
!...with the following declaration statement:                           
!     DIMENSION XPDFGM(-6:6)                                            
!...and, optionally, further information in:                            
!     COMMON/SASCOM/XPVMD(-6:6),XPANL(-6:6),XPANH(-6:6),XPBEH(-6:6),    
!    &XPDIR(-6:6)                                                       
!...Input:  ISET = 1 : SaS set 1D ('DIS',   Q0 = 0.6 GeV)               
!                = 2 : SaS set 1M ('MSbar', Q0 = 0.6 GeV)               
!                = 3 : SaS set 2D ('DIS',   Q0 =  2  GeV)               
!                = 4 : SaS set 2M ('MSbar', Q0 =  2  GeV)               
!           X : x value.                                                
!           Q2 : Q2 value.                                              
!           P2 : P2 value; should be = 0. for an on-shell photon.       
!...Output: F2GM : F2 value of the photon (including factors of alpha_em
!           XPFDGM :  x times parton distribution functions of the photo
!               with elements 0 = g, 1 = d, 2 = u, 3 = s, 4 = c, 5 = b, 
!               6 = t (always empty!), - for antiquarks (result is same)
!...The breakdown by component is stored in the commonblock SASCOM,     
!               with elements as above.                                 
!           XPVMD : rho, omega, phi VMD part only of output.            
!           XPANL : d, u, s anomalous part only of output.              
!           XPANH : c, b anomalous part only of output.                 
!           XPBEH : c, b Bethe-Heitler part only of output.             
!           XPDIR : Cgamma (direct contribution) part only of output.   
                                                                        
      SUBROUTINE LHASASGAM1(ISET,X,Q2,P2,F2GM,XPDFGM) 
!...Purpose: to construct the F2 and parton distributions of the photon 
!...by summing homogeneous (VMD) and inhomogeneous (anomalous) terms.   
!...For F2, c and b are included by the Bethe-Heitler formula;          
!...in the 'MSbar' scheme additionally a Cgamma term is added.          
      DIMENSION XPDFGM(-6:6) 
      COMMON/LHASASCOM/XPVMD(-6:6),XPANL(-6:6),XPANH(-6:6),XPBEH(-6:6), &
     &XPDIR(-6:6)                                                       
      SAVE /LHASASCOM/ 
                                                                        
!...Temporary array.                                                    
      DIMENSION XPGA(-6:6) 
!...Charm and bottom masses (low to compensate for J/psi etc.).         
      DATA PMC/1.3/, PMB/4.6/ 
!...alpha_em and alpha_em/(2*pi).                                       
      DATA AEM/0.007297/, AEM2PI/0.0011614/ 
!...Lambda value for 4 flavours.                                        
      DATA ALAM/0.20/ 
!...Mixture u/(u+d), = 0.5 for incoherent and = 0.8 for coherent sum.   
      DATA FRACU/0.8/ 
!...VMD couplings f_V**2/(4*pi).                                        
      DATA FRHO/2.20/, FOMEGA/23.6/, FPHI/18.4/ 
!...Masses for rho (=omega) and phi.                                    
      DATA PMRHO/0.770/, PMPHI/1.020/ 
                                                                        
!...Reset output.                                                       
      F2GM=0. 
      DO 100 KFL=-6,6 
      XPDFGM(KFL)=0. 
      XPVMD(KFL)=0. 
      XPANL(KFL)=0. 
      XPANH(KFL)=0. 
      XPBEH(KFL)=0. 
      XPDIR(KFL)=0. 
  100 END DO 
                                                                        
!...Check that input sensible.                                          
      IF(ISET.LE.0.OR.ISET.GE.5) THEN 
        WRITE(*,*) ' FATAL ERROR: SaSgam called for unknown set' 
        WRITE(*,*) ' ISET = ',ISET 
        STOP 
      ENDIF 
      IF(X.LE.0..OR.X.GT.1.) THEN 
        WRITE(*,*) ' FATAL ERROR: SaSgam called for unphysical x' 
        WRITE(*,*) ' X = ',X 
        STOP 
      ENDIF 
                                                                        
!...Set Q0 cut-off parameter as function of set used.                   
      IF(ISET.LE.2) THEN 
        Q0=0.6 
      ELSE 
        Q0=2. 
      ENDIF 
      Q02 = Q0**2 
                                                                        
!...Call VMD parametrization for d quark and use to give rho, omega, phi
!...Note scale choice and dipole dampening for off-shell photon.        
      P2MX=MAX(P2,Q02) 
      CALL LHASASVM1(ISET,1,X,Q2,P2MX,ALAM,XPGA) 
      XFVAL=XPGA(1)-XPGA(2) 
      XPGA(1)=XPGA(2) 
      XPGA(-1)=XPGA(-2) 
      FACUD=AEM*(1./FRHO+1./FOMEGA)*(PMRHO**2/(PMRHO**2+P2))**2 
      FACS=AEM*(1./FPHI)*(PMPHI**2/(PMPHI**2+P2))**2 
      DO 110 KFL=-5,5 
      XPVMD(KFL)=(FACUD+FACS)*XPGA(KFL) 
  110 END DO 
      XPVMD(1)=XPVMD(1)+(1.-FRACU)*FACUD*XFVAL 
      XPVMD(2)=XPVMD(2)+FRACU*FACUD*XFVAL 
      XPVMD(3)=XPVMD(3)+FACS*XFVAL 
      XPVMD(-1)=XPVMD(-1)+(1.-FRACU)*FACUD*XFVAL 
      XPVMD(-2)=XPVMD(-2)+FRACU*FACUD*XFVAL 
      XPVMD(-3)=XPVMD(-3)+FACS*XFVAL 
                                                                        
!...Call anomalous parametrization for d + u + s.                       
      CALL LHASASAN1(-3,X,Q2,P2MX,ALAM,XPGA) 
      DO 120 KFL=-5,5 
      XPANL(KFL)=XPGA(KFL) 
  120 END DO 
                                                                        
!...Call anomalous parametrization for c and b.                         
      CALL LHASASAN1(4,X,Q2,P2MX,ALAM,XPGA) 
      DO 130 KFL=-5,5 
      XPANH(KFL)=XPGA(KFL) 
  130 END DO 
      CALL LHASASAN1(5,X,Q2,P2MX,ALAM,XPGA) 
      DO 140 KFL=-5,5 
      XPANH(KFL)=XPANH(KFL)+XPGA(KFL) 
  140 END DO 
                                                                        
!...Call Bethe-Heitler term expression for charm and bottom.            
      CALL LHASASBEH(4,X,Q2,P2,PMC**2,XPBH) 
      XPBEH(4)=XPBH 
      XPBEH(-4)=XPBH 
      CALL LHASASBEH(5,X,Q2,P2,PMB**2,XPBH) 
      XPBEH(5)=XPBH 
      XPBEH(-5)=XPBH 
                                                                        
!...For MSbar subtraction call C^gamma term expression for d, u, s.     
      IF(ISET.EQ.2.OR.ISET.EQ.4) THEN 
        CALL LHASASDIR(X,Q2,P2,Q02,XPGA) 
        DO 150 KFL=-5,5 
        XPDIR(KFL)=XPGA(KFL) 
  150   CONTINUE 
      ENDIF 
                                                                        
!...Store result in output array.                                       
      DO 160 KFL=-5,5 
      CHSQ=1./9. 
      IF(IABS(KFL).EQ.2.OR.IABS(KFL).EQ.4) CHSQ=4./9. 
      XPF2=XPVMD(KFL)+XPANL(KFL)+XPBEH(KFL)+XPDIR(KFL) 
      IF(KFL.NE.0) F2GM=F2GM+CHSQ*XPF2 
      XPDFGM(KFL)=XPVMD(KFL)+XPANL(KFL)+XPANH(KFL) 
  160 END DO 
                                                                        
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! ------------------ SASGAM2 ---------------------------                
!...SaSgam version 2 - parton distributions of the photon               
!...by Gerhard A. Schuler and Torbjorn Sjostrand                        
!...For further information see Z. Phys. C68 (1995) 607                 
!...and CERN-TH/96-04 and LU TP 96-2.                                   
!...Program last changed on 18 January 1996.                            
                                                                        
!!!!Note that one further call parameter - IP2 - has been added         
!!!!to the SASGAM argument list compared with version 1.                
                                                                        
!...The user should only need to call the SASGAM routine,               
!...which in turn calls the auxiliary routines SASVMD, SASANO,          
!...SASBEH and SASDIR. The package is self-contained.                   
                                                                        
!...One particular aspect of these parametrizations is that F2 for      
!...the photon is not obtained just as the charge-squared-weighted      
!...sum of quark distributions, but differ in the treatment of          
!...heavy flavours (in F2 the DIS relation W2 = Q2*(1-x)/x restricts    
!...the kinematics range of heavy-flavour production, but the same      
!...kinematics is not relevant e.g. for jet production) and, for the    
!...'MSbar' fits, in the addition of a Cgamma term related to the       
!...separation of direct processes. Schematically:                      
!...PDF = VMD (rho, omega, phi) + anomalous (d, u, s, c, b).            
!...F2  = VMD (rho, omega, phi) + anomalous (d, u, s) +                 
!...      Bethe-Heitler (c, b) (+ Cgamma (d, u, s)).                    
!...The J/psi and Upsilon states have not been included in the VMD sum, 
!...but low c and b masses in the other components should compensate    
!...for this in a duality sense.                                        
                                                                        
!...The calling sequence is the following:                              
!     CALL SASGAM2(ISET,X,Q2,P2,IP2,F2GM,XPDFGM)                        
!...with the following declaration statement:                           
!     DIMENSION XPDFGM(-6:6)                                            
!...and, optionally, further information in:                            
!     COMMON/SASCOM/XPVMD(-6:6),XPANL(-6:6),XPANH(-6:6),XPBEH(-6:6),    
!    &XPDIR(-6:6)                                                       
!     COMMON/SASVAL/VXPVMD(-6:6),VXPANL(-6:6),VXPANH(-6:6),VXPDGM(-6:6) 
!...Input:  ISET = 1 : SaS set 1D ('DIS',   Q0 = 0.6 GeV)               
!                = 2 : SaS set 1M ('MSbar', Q0 = 0.6 GeV)               
!                = 3 : SaS set 2D ('DIS',   Q0 =  2  GeV)               
!                = 4 : SaS set 2M ('MSbar', Q0 =  2  GeV)               
!           X : x value.                                                
!           Q2 : Q2 value.                                              
!           P2 : P2 value; should be = 0. for an on-shell photon.       
!           IP2 : scheme used to evaluate off-shell anomalous component.
!               = 0 : recommended default, see = 7.                     
!               = 1 : dipole dampening by integration; very time-consumi
!               = 2 : P_0^2 = max( Q_0^2, P^2 )                         
!               = 3 : P'_0^2 = Q_0^2 + P^2.                             
!               = 4 : P_{eff} that preserves momentum sum.              
!               = 5 : P_{int} that preserves momentum and average       
!                     evolution range.                                  
!               = 6 : P_{eff}, matched to P_0 in P2 -> Q2 limit.        
!               = 7 : P_{eff}, matched to P_0 in P2 -> Q2 limit.        
!...Output: F2GM : F2 value of the photon (including factors of alpha_em
!           XPFDGM :  x times parton distribution functions of the photo
!               with elements 0 = g, 1 = d, 2 = u, 3 = s, 4 = c, 5 = b, 
!               6 = t (always empty!), - for antiquarks (result is same)
!...The breakdown by component is stored in the commonblock SASCOM,     
!               with elements as above.                                 
!           XPVMD : rho, omega, phi VMD part only of output.            
!           XPANL : d, u, s anomalous part only of output.              
!           XPANH : c, b anomalous part only of output.                 
!           XPBEH : c, b Bethe-Heitler part only of output.             
!           XPDIR : Cgamma (direct contribution) part only of output.   
!...The above arrays do not distinguish valence and sea contributions,  
!...although this information is available internally. The additional   
!...commonblock SASVAL provides the valence part only of the above      
!...distributions. Array names VXPVMD, VXPANL and VXPANH correspond     
!...to XPVMD, XPANL and XPANH, while XPBEH and XPDIR are valence only   
!...and therefore not given doubly. VXPDGM gives the sum of valence     
!...parts, and so matches XPDFGM. The difference, i.e. XPVMD-VXPVMD     
!...and so on, gives the sea part only.                                 
                                                                        
      SUBROUTINE LHASASGAM2(ISET,X,Q2,P2,IP2,F2GM,XPDFGM) 
!...Purpose: to construct the F2 and parton distributions of the photon 
!...by summing homogeneous (VMD) and inhomogeneous (anomalous) terms.   
!...For F2, c and b are included by the Bethe-Heitler formula;          
!...in the 'MSbar' scheme additionally a Cgamma term is added.          
      DIMENSION XPDFGM(-6:6) 
      COMMON/LHASASCOM/XPVMD(-6:6),XPANL(-6:6),XPANH(-6:6),XPBEH(-6:6), &
     &XPDIR(-6:6)                                                       
      COMMON/LHASASVAL/VXPVMD(-6:6),VXPANL(-6:6),VXPANH(-6:6),          &
     &VXPDGM(-6:6)                                                      
      SAVE /LHASASCOM/,/LHASASVAL/ 
                                                                        
!...Temporary array.                                                    
      DIMENSION XPGA(-6:6), VXPGA(-6:6) 
!...Charm and bottom masses (low to compensate for J/psi etc.).         
      DATA PMC/1.3/, PMB/4.6/ 
!...alpha_em and alpha_em/(2*pi).                                       
      DATA AEM/0.007297/, AEM2PI/0.0011614/ 
!...Lambda value for 4 flavours.                                        
      DATA ALAM/0.20/ 
!...Mixture u/(u+d), = 0.5 for incoherent and = 0.8 for coherent sum.   
      DATA FRACU/0.8/ 
!...VMD couplings f_V**2/(4*pi).                                        
      DATA FRHO/2.20/, FOMEGA/23.6/, FPHI/18.4/ 
!...Masses for rho (=omega) and phi.                                    
      DATA PMRHO/0.770/, PMPHI/1.020/ 
!...Number of points in integration for IP2=1.                          
      DATA NSTEP/100/ 
                                                                        
!...Reset output.                                                       
      F2GM=0. 
      DO 100 KFL=-6,6 
      XPDFGM(KFL)=0. 
      XPVMD(KFL)=0. 
      XPANL(KFL)=0. 
      XPANH(KFL)=0. 
      XPBEH(KFL)=0. 
      XPDIR(KFL)=0. 
      VXPVMD(KFL)=0. 
      VXPANL(KFL)=0. 
      VXPANH(KFL)=0. 
      VXPDGM(KFL)=0. 
  100 END DO 
                                                                        
!...Check that input sensible.                                          
      IF(ISET.LE.0.OR.ISET.GE.5) THEN 
        WRITE(*,*) ' FATAL ERROR: SaSgam called for unknown set' 
        WRITE(*,*) ' ISET = ',ISET 
        STOP 
      ENDIF 
      IF(X.LE.0..OR.X.GT.1.) THEN 
        WRITE(*,*) ' FATAL ERROR: SaSgam called for unphysical x' 
        WRITE(*,*) ' X = ',X 
        STOP 
      ENDIF 
                                                                        
!...Set Q0 cut-off parameter as function of set used.                   
      IF(ISET.LE.2) THEN 
        Q0=0.6 
      ELSE 
        Q0=2. 
      ENDIF 
      Q02=Q0**2 
                                                                        
!...Scale choice for off-shell photon; common factors.                  
      Q2A=Q2 
      FACNOR=1. 
      IF(IP2.EQ.1) THEN 
        P2MX=P2+Q02 
        Q2A=Q2+P2*Q02/MAX(Q02,Q2) 
        FACNOR=LOG(Q2/Q02)/NSTEP 
      ELSEIF(IP2.EQ.2) THEN 
        P2MX=MAX(P2,Q02) 
      ELSEIF(IP2.EQ.3) THEN 
        P2MX=P2+Q02 
        Q2A=Q2+P2*Q02/MAX(Q02,Q2) 
      ELSEIF(IP2.EQ.4) THEN 
        P2MX=Q2*(Q02+P2)/(Q2+P2)*EXP(P2*(Q2-Q02)/                       &
     &  ((Q2+P2)*(Q02+P2)))                                             
      ELSEIF(IP2.EQ.5) THEN 
        P2MXA=Q2*(Q02+P2)/(Q2+P2)*EXP(P2*(Q2-Q02)/                      &
     &  ((Q2+P2)*(Q02+P2)))                                             
        P2MX=Q0*SQRT(P2MXA) 
        FACNOR=LOG(Q2/P2MXA)/LOG(Q2/P2MX) 
      ELSEIF(IP2.EQ.6) THEN 
        P2MX=Q2*(Q02+P2)/(Q2+P2)*EXP(P2*(Q2-Q02)/                       &
     &  ((Q2+P2)*(Q02+P2)))                                             
        P2MX=MAX(0.,1.-P2/Q2)*P2MX+MIN(1.,P2/Q2)*MAX(P2,Q02) 
      ELSE 
        P2MXA=Q2*(Q02+P2)/(Q2+P2)*EXP(P2*(Q2-Q02)/                      &
     &  ((Q2+P2)*(Q02+P2)))                                             
        P2MX=Q0*SQRT(P2MXA) 
        P2MXB=P2MX 
        P2MX=MAX(0.,1.-P2/Q2)*P2MX+MIN(1.,P2/Q2)*MAX(P2,Q02) 
        P2MXB=MAX(0.,1.-P2/Q2)*P2MXB+MIN(1.,P2/Q2)*P2MXA 
        FACNOR=LOG(Q2/P2MXA)/LOG(Q2/P2MXB) 
      ENDIF 
                                                                        
!...Call VMD parametrization for d quark and use to give rho, omega,    
!...phi. Note dipole dampening for off-shell photon.                    
      CALL LHASASVMD(ISET,1,X,Q2A,P2MX,ALAM,XPGA,VXPGA) 
      XFVAL=VXPGA(1) 
      XPGA(1)=XPGA(2) 
      XPGA(-1)=XPGA(-2) 
      FACUD=AEM*(1./FRHO+1./FOMEGA)*(PMRHO**2/(PMRHO**2+P2))**2 
      FACS=AEM*(1./FPHI)*(PMPHI**2/(PMPHI**2+P2))**2 
      DO 110 KFL=-5,5 
      XPVMD(KFL)=(FACUD+FACS)*XPGA(KFL) 
  110 END DO 
      XPVMD(1)=XPVMD(1)+(1.-FRACU)*FACUD*XFVAL 
      XPVMD(2)=XPVMD(2)+FRACU*FACUD*XFVAL 
      XPVMD(3)=XPVMD(3)+FACS*XFVAL 
      XPVMD(-1)=XPVMD(-1)+(1.-FRACU)*FACUD*XFVAL 
      XPVMD(-2)=XPVMD(-2)+FRACU*FACUD*XFVAL 
      XPVMD(-3)=XPVMD(-3)+FACS*XFVAL 
      VXPVMD(1)=(1.-FRACU)*FACUD*XFVAL 
      VXPVMD(2)=FRACU*FACUD*XFVAL 
      VXPVMD(3)=FACS*XFVAL 
      VXPVMD(-1)=(1.-FRACU)*FACUD*XFVAL 
      VXPVMD(-2)=FRACU*FACUD*XFVAL 
      VXPVMD(-3)=FACS*XFVAL 
                                                                        
      IF(IP2.NE.1) THEN 
!...Anomalous parametrizations for different strategies                 
!...for off-shell photons; except full integration.                     
                                                                        
!...Call anomalous parametrization for d + u + s.                       
        CALL LHASASANO(-3,X,Q2A,P2MX,ALAM,XPGA,VXPGA) 
        DO 120 KFL=-5,5 
        XPANL(KFL)=FACNOR*XPGA(KFL) 
        VXPANL(KFL)=FACNOR*VXPGA(KFL) 
  120   CONTINUE 
                                                                        
!...Call anomalous parametrization for c and b.                         
        CALL LHASASANO(4,X,Q2A,P2MX,ALAM,XPGA,VXPGA) 
        DO 130 KFL=-5,5 
        XPANH(KFL)=FACNOR*XPGA(KFL) 
        VXPANH(KFL)=FACNOR*VXPGA(KFL) 
  130   CONTINUE 
        CALL LHASASANO(5,X,Q2A,P2MX,ALAM,XPGA,VXPGA) 
        DO 140 KFL=-5,5 
        XPANH(KFL)=XPANH(KFL)+FACNOR*XPGA(KFL) 
        VXPANH(KFL)=VXPANH(KFL)+FACNOR*VXPGA(KFL) 
  140   CONTINUE 
                                                                        
      ELSE 
!...Special option: loop over flavours and integrate over k2.           
        DO 170 KF=1,5 
        DO 160 ISTEP=1,NSTEP 
        Q2STEP=Q02*(Q2/Q02)**((ISTEP-0.5)/NSTEP) 
        IF((KF.EQ.4.AND.Q2STEP.LT.PMC**2).OR.                           &
     &  (KF.EQ.5.AND.Q2STEP.LT.PMB**2)) GOTO 160                        
        CALL LHASASVMD(0,KF,X,Q2,Q2STEP,ALAM,XPGA,VXPGA) 
        FACQ=AEM2PI*(Q2STEP/(Q2STEP+P2))**2*FACNOR 
        IF(MOD(KF,2).EQ.0) FACQ=FACQ*(8./9.) 
        IF(MOD(KF,2).EQ.1) FACQ=FACQ*(2./9.) 
        DO 150 KFL=-5,5 
        IF(KF.LE.3) XPANL(KFL)=XPANL(KFL)+FACQ*XPGA(KFL) 
        IF(KF.GE.4) XPANH(KFL)=XPANH(KFL)+FACQ*XPGA(KFL) 
        IF(KF.LE.3) VXPANL(KFL)=VXPANL(KFL)+FACQ*VXPGA(KFL) 
        IF(KF.GE.4) VXPANH(KFL)=VXPANH(KFL)+FACQ*VXPGA(KFL) 
  150   CONTINUE 
  160   CONTINUE 
  170   CONTINUE 
      ENDIF 
                                                                        
!...Call Bethe-Heitler term expression for charm and bottom.            
      CALL LHASASBEH(4,X,Q2,P2,PMC**2,XPBH) 
      XPBEH(4)=XPBH 
      XPBEH(-4)=XPBH 
      CALL LHASASBEH(5,X,Q2,P2,PMB**2,XPBH) 
      XPBEH(5)=XPBH 
      XPBEH(-5)=XPBH 
                                                                        
!...For MSbar subtraction call C^gamma term expression for d, u, s.     
      IF(ISET.EQ.2.OR.ISET.EQ.4) THEN 
        CALL LHASASDIR(X,Q2,P2,Q02,XPGA) 
        DO 180 KFL=-5,5 
        XPDIR(KFL)=XPGA(KFL) 
  180   CONTINUE 
      ENDIF 
                                                                        
!...Store result in output array.                                       
      DO 190 KFL=-5,5 
      CHSQ=1./9. 
      IF(IABS(KFL).EQ.2.OR.IABS(KFL).EQ.4) CHSQ=4./9. 
      XPF2=XPVMD(KFL)+XPANL(KFL)+XPBEH(KFL)+XPDIR(KFL) 
      IF(KFL.NE.0) F2GM=F2GM+CHSQ*XPF2 
      XPDFGM(KFL)=XPVMD(KFL)+XPANL(KFL)+XPANH(KFL) 
      VXPDGM(KFL)=VXPVMD(KFL)+VXPANL(KFL)+VXPANH(KFL) 
  190 END DO 
                                                                        
      RETURN 
      END                                           
                                                                        
                                                                        
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE LHASASVMD(ISET,KF,X,Q2,P2,ALAM,XPGA,VXPGA) 
!...Purpose: to evaluate the VMD parton distributions of a photon,      
!...evolved homogeneously from an initial scale P2 to Q2.               
!...Does not include dipole suppression factor.                         
!...ISET is parton distribution set, see above;                         
!...additionally ISET=0 is used for the evolution of an anomalous photon
!...which branched at a scale P2 and then evolved homogeneously to Q2.  
!...ALAM is the 4-flavour Lambda, which is automatically converted      
!...to 3- and 5-flavour equivalents as needed.                          
      DIMENSION XPGA(-6:6), VXPGA(-6:6) 
      DATA PMC/1.3/, PMB/4.6/, AEM/0.007297/, AEM2PI/0.0011614/ 
                                                                        
!...Reset output.                                                       
      DO 100 KFL=-6,6 
      XPGA(KFL)=0. 
      VXPGA(KFL)=0. 
  100 END DO 
      KFA=IABS(KF) 
                                                                        
!...Calculate Lambda; protect against unphysical Q2 and P2 input.       
      ALAM3=ALAM*(PMC/ALAM)**(2./27.) 
      ALAM5=ALAM*(ALAM/PMB)**(2./23.) 
      P2EFF=MAX(P2,1.2*ALAM3**2) 
      IF(KFA.EQ.4) P2EFF=MAX(P2EFF,PMC**2) 
      IF(KFA.EQ.5) P2EFF=MAX(P2EFF,PMB**2) 
      Q2EFF=MAX(Q2,P2EFF) 
                                                                        
!...Find number of flavours at lower and upper scale.                   
      NFP=4 
      IF(P2EFF.LT.PMC**2) NFP=3 
      IF(P2EFF.GT.PMB**2) NFP=5 
      NFQ=4 
      IF(Q2EFF.LT.PMC**2) NFQ=3 
      IF(Q2EFF.GT.PMB**2) NFQ=5 
                                                                        
!...Find s as sum of 3-, 4- and 5-flavour parts.                        
      S=0. 
      IF(NFP.EQ.3) THEN 
        Q2DIV=PMC**2 
        IF(NFQ.EQ.3) Q2DIV=Q2EFF 
        S=S+(6./27.)*LOG(LOG(Q2DIV/ALAM3**2)/LOG(P2EFF/ALAM3**2)) 
      ENDIF 
      IF(NFP.LE.4.AND.NFQ.GE.4) THEN 
        P2DIV=P2EFF 
        IF(NFP.EQ.3) P2DIV=PMC**2 
        Q2DIV=Q2EFF 
        IF(NFQ.EQ.5) Q2DIV=PMB**2 
        S=S+(6./25.)*LOG(LOG(Q2DIV/ALAM**2)/LOG(P2DIV/ALAM**2)) 
      ENDIF 
      IF(NFQ.EQ.5) THEN 
        P2DIV=PMB**2 
        IF(NFP.EQ.5) P2DIV=P2EFF 
        S=S+(6./23.)*LOG(LOG(Q2EFF/ALAM5**2)/LOG(P2DIV/ALAM5**2)) 
      ENDIF 
                                                                        
!...Calculate frequent combinations of x and s.                         
      X1=1.-X 
      XL=-LOG(X) 
      S2=S**2 
      S3=S**3 
      S4=S**4 
                                                                        
!...Evaluate homogeneous anomalous parton distributions below or        
!...above threshold.                                                    
      IF(ISET.EQ.0) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = X * 1.5 * (X**2+X1**2) 
        XGLU = 0. 
        XSEA = 0. 
      ELSE 
        XVAL = (1.5/(1.-0.197*S+4.33*S2)*X**2 + (1.5+2.10*S)/           &
     &  (1.+3.29*S)*X1**2 + 5.23*S/(1.+1.17*S+19.9*S3)*X*X1) *          &
     &  X**(1./(1.+1.5*S)) * (1.-X**2)**(2.667*S)                       
        XGLU = 4.*S/(1.+4.76*S+15.2*S2+29.3*S4) *                       &
     &  X**(-2.03*S/(1.+2.44*S)) * (X1*XL)**(1.333*S) *                 &
     &  ((4.*X**2+7.*X+4.)*X1/3. - 2.*X*(1.+X)*XL)                      
        XSEA = S2/(1.+4.54*S+8.19*S2+8.05*S3) *                         &
     &  X**(-1.54*S/(1.+1.29*S)) * X1**(2.667*S) *                      &
     &  ((8.-73.*X+62.*X**2)*X1/9. + (3.-8.*X**2/3.)*X*XL +             &
     &  (2.*X-1.)*X*XL**2)                                              
      ENDIF 
                                                                        
!...Evaluate set 1D parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.1) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = 1.294 * X**0.80 * X1**0.76 
        XGLU = 1.273 * X**0.40 * X1**1.76 
        XSEA = 0.100 * X1**3.76 
      ELSE 
        XVAL = 1.294/(1.+0.252*S+3.079*S2) * X**(0.80-0.13*S) *         &
     &  X1**(0.76+0.667*S) * XL**(2.*S)                                 
        XGLU = 7.90*S/(1.+5.50*S) * EXP(-5.16*S) *                      &
     &  X**(-1.90*S/(1.+3.60*S)) * X1**1.30 * XL**(0.50+3.*S) +         &
     &  1.273 * EXP(-10.*S) * X**0.40 * X1**(1.76+3.*S)                 
        XSEA = (0.1-0.397*S2+1.121*S3)/(1.+5.61*S2+5.26*S3) *           &
     &  X**(-7.32*S2/(1.+10.3*S2)) *                                    &
     &  X1**((3.76+15.*S+12.*S2)/(1.+4.*S))                             
        XSEA0 = 0.100 * X1**3.76 
      ENDIF 
                                                                        
!...Evaluate set 1M parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.2) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = 0.8477 * X**0.51 * X1**1.37 
        XGLU = 3.42 * X**0.255 * X1**2.37 
        XSEA = 0. 
      ELSE 
        XVAL = 0.8477/(1.+1.37*S+2.18*S2+3.73*S3) * X**(0.51+0.21*S)    &
     &  * X1**1.37 * XL**(2.667*S)                                      
        XGLU = 24.*S/(1.+9.6*S+0.92*S2+14.34*S3) * EXP(-5.94*S) *       &
     &  X**((-0.013-1.80*S)/(1.+3.14*S)) * X1**(2.37+0.4*S) *           &
     &  XL**(0.32+3.6*S) + 3.42 * EXP(-12.*S) * X**0.255 *              &
     &  X1**(2.37+3.*S)                                                 
        XSEA = 0.842*S/(1.+21.3*S-33.2*S2+229.*S3) *                    &
     &  X**((0.13-2.90*S)/(1.+5.44*S)) * X1**(3.45+0.5*S) *             &
     &  XL**(2.8*S)                                                     
        XSEA0 = 0. 
      ENDIF 
                                                                        
!...Evaluate set 2D parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.3) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = X**0.46 * X1**0.64 + 0.76 * X 
        XGLU = 1.925 * X1**2 
        XSEA = 0.242 * X1**4 
      ELSE 
        XVAL = (1.+0.186*S)/(1.-0.209*S+1.495*S2) * X**(0.46+0.25*S)    &
     &  * X1**((0.64+0.14*S+5.*S2)/(1.+S)) * XL**(1.9*S) +              &
     &  (0.76+0.4*S) * X * X1**(2.667*S)                                
        XGLU = (1.925+5.55*S+147.*S2)/(1.-3.59*S+3.32*S2) *             &
     &  EXP(-18.67*S) * X**((-5.81*S-5.34*S2)/(1.+29.*S-4.26*S2))       &
     &  * X1**((2.-5.9*S)/(1.+1.7*S)) * XL**(9.3*S/(1.+1.7*S))          
        XSEA = (0.242-0.252*S+1.19*S2)/(1.-0.607*S+21.95*S2) *          &
     &  X**(-12.1*S2/(1.+2.62*S+16.7*S2)) * X1**4 * XL**S               
        XSEA0 = 0.242 * X1**4 
      ENDIF 
                                                                        
!...Evaluate set 2M parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.4) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = 1.168 * X**0.50 * X1**2.60 + 0.965 * X 
        XGLU = 1.808 * X1**2 
        XSEA = 0.209 * X1**4 
      ELSE 
        XVAL = (1.168+1.771*S+29.35*S2) * EXP(-5.776*S) *               &
     &  X**((0.5+0.208*S)/(1.-0.794*S+1.516*S2)) *                      &
     &  X1**((2.6+7.6*S)/(1.+5.*S)) * XL**(5.15*S/(1.+2.*S)) +          &
     &  (0.965+22.35*S)/(1.+18.4*S) * X * X1**(2.667*S)                 
        XGLU = (1.808+29.9*S)/(1.+26.4*S) * EXP(-5.28*S) *              &
     &  X**((-5.35*S-10.11*S2)/(1.+31.71*S)) *                          &
     &  X1**((2.-7.3*S+4.*S2)/(1.+2.5*S)) *                             &
     &  XL**(10.9*S/(1.+2.5*S))                                         
        XSEA = (0.209+0.644*S2)/(1.+0.319*S+17.6*S2) *                  &
     &  X**((-0.373*S-7.71*S2)/(1.+0.815*S+11.0*S2)) *                  &
     &  X1**(4.+S) * XL**(0.45*S)                                       
        XSEA0 = 0.209 * X1**4 
      ENDIF 
      ENDIF 
                                                                        
!...Threshold factors for c and b sea.                                  
      SLL=LOG(LOG(Q2EFF/ALAM**2)/LOG(P2EFF/ALAM**2)) 
      XCHM=0. 
      IF(Q2.GT.PMC**2.AND.Q2.GT.1.001*P2EFF) THEN 
        SCH=MAX(0.,LOG(LOG(PMC**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
        IF(ISET.EQ.0) THEN 
          XCHM=XSEA*(1.-(SCH/SLL)**2) 
        ELSE 
          XCHM=MAX(0.,XSEA-XSEA0*X1**(2.667*S))*(1.-SCH/SLL) 
        ENDIF 
      ENDIF 
      XBOT=0. 
      IF(Q2.GT.PMB**2.AND.Q2.GT.1.001*P2EFF) THEN 
        SBT=MAX(0.,LOG(LOG(PMB**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
        IF(ISET.EQ.0) THEN 
          XBOT=XSEA*(1.-(SBT/SLL)**2) 
        ELSE 
          XBOT=MAX(0.,XSEA-XSEA0*X1**(2.667*S))*(1.-SBT/SLL) 
        ENDIF 
      ENDIF 
                                                                        
!...Fill parton distributions.                                          
      XPGA(0)=XGLU 
      XPGA(1)=XSEA 
      XPGA(2)=XSEA 
      XPGA(3)=XSEA 
      XPGA(4)=XCHM 
      XPGA(5)=XBOT 
      XPGA(KFA)=XPGA(KFA)+XVAL 
      DO 110 KFL=1,5 
      XPGA(-KFL)=XPGA(KFL) 
  110 END DO 
      VXPGA(KFA)=XVAL 
      VXPGA(-KFA)=XVAL 
                                                                        
      RETURN 
      END                                           
                                                                        
!*********************************************************************  
                                                                        
      SUBROUTINE LHASASANO(KF,X,Q2,P2,ALAM,XPGA,VXPGA) 
!...Purpose: to evaluate the parton distributions of the anomalous      
!...photon, inhomogeneously evolved from a scale P2 (where it vanishes) 
!...to Q2.                                                              
!...KF=0 gives the sum over (up to) 5 flavours,                         
!...KF<0 limits to flavours up to abs(KF),                              
!...KF>0 is for flavour KF only.                                        
!...ALAM is the 4-flavour Lambda, which is automatically converted      
!...to 3- and 5-flavour equivalents as needed.                          
      DIMENSION XPGA(-6:6), VXPGA(-6:6), ALAMSQ(3:5) 
      DATA PMC/1.3/, PMB/4.6/, AEM/0.007297/, AEM2PI/0.0011614/ 
                                                                        
!...Reset output.                                                       
      DO 100 KFL=-6,6 
      XPGA(KFL)=0. 
      VXPGA(KFL)=0. 
  100 END DO 
      IF(Q2.LE.P2) RETURN 
      KFA=IABS(KF) 
                                                                        
!...Calculate Lambda; protect against unphysical Q2 and P2 input.       
      ALAMSQ(3)=(ALAM*(PMC/ALAM)**(2./27.))**2 
      ALAMSQ(4)=ALAM**2 
      ALAMSQ(5)=(ALAM*(ALAM/PMB)**(2./23.))**2 
      P2EFF=MAX(P2,1.2*ALAMSQ(3)) 
      IF(KF.EQ.4) P2EFF=MAX(P2EFF,PMC**2) 
      IF(KF.EQ.5) P2EFF=MAX(P2EFF,PMB**2) 
      Q2EFF=MAX(Q2,P2EFF) 
      XL=-LOG(X) 
                                                                        
!...Find number of flavours at lower and upper scale.                   
      NFP=4 
      IF(P2EFF.LT.PMC**2) NFP=3 
      IF(P2EFF.GT.PMB**2) NFP=5 
      NFQ=4 
      IF(Q2EFF.LT.PMC**2) NFQ=3 
      IF(Q2EFF.GT.PMB**2) NFQ=5 
                                                                        
!...Define range of flavour loop.                                       
      IF(KF.EQ.0) THEN 
        KFLMN=1 
        KFLMX=5 
      ELSEIF(KF.LT.0) THEN 
        KFLMN=1 
        KFLMX=KFA 
      ELSE 
        KFLMN=KFA 
        KFLMX=KFA 
      ENDIF 
                                                                        
!...Loop over flavours the photon can branch into.                      
      DO 110 KFL=KFLMN,KFLMX 
                                                                        
!...Light flavours: calculate t range and (approximate) s range.        
      IF(KFL.LE.3.AND.(KFL.EQ.1.OR.KFL.EQ.KF)) THEN 
        TDIFF=LOG(Q2EFF/P2EFF) 
        S=(6./(33.-2.*NFQ))*LOG(LOG(Q2EFF/ALAMSQ(NFQ))/                 &
     &  LOG(P2EFF/ALAMSQ(NFQ)))                                         
        IF(NFQ.GT.NFP) THEN 
          Q2DIV=PMB**2 
          IF(NFQ.EQ.4) Q2DIV=PMC**2 
          SNFQ=(6./(33.-2.*NFQ))*LOG(LOG(Q2DIV/ALAMSQ(NFQ))/            &
     &    LOG(P2EFF/ALAMSQ(NFQ)))                                       
          SNFP=(6./(33.-2.*(NFQ-1)))*LOG(LOG(Q2DIV/ALAMSQ(NFQ-1))/      &
     &    LOG(P2EFF/ALAMSQ(NFQ-1)))                                     
          S=S+(LOG(Q2DIV/P2EFF)/LOG(Q2EFF/P2EFF))*(SNFP-SNFQ) 
        ENDIF 
        IF(NFQ.EQ.5.AND.NFP.EQ.3) THEN 
          Q2DIV=PMC**2 
          SNF4=(6./(33.-2.*4))*LOG(LOG(Q2DIV/ALAMSQ(4))/                &
     &    LOG(P2EFF/ALAMSQ(4)))                                         
          SNF3=(6./(33.-2.*3))*LOG(LOG(Q2DIV/ALAMSQ(3))/                &
     &    LOG(P2EFF/ALAMSQ(3)))                                         
          S=S+(LOG(Q2DIV/P2EFF)/LOG(Q2EFF/P2EFF))*(SNF3-SNF4) 
        ENDIF 
                                                                        
!...u and s quark do not need a separate treatment when d has been done.
      ELSEIF(KFL.EQ.2.OR.KFL.EQ.3) THEN 
                                                                        
!...Charm: as above, but only include range above c threshold.          
      ELSEIF(KFL.EQ.4) THEN 
        IF(Q2.LE.PMC**2) EXIT
        P2EFF=MAX(P2EFF,PMC**2) 
        Q2EFF=MAX(Q2EFF,P2EFF) 
        TDIFF=LOG(Q2EFF/P2EFF) 
        S=(6./(33.-2.*NFQ))*LOG(LOG(Q2EFF/ALAMSQ(NFQ))/                 &
     &  LOG(P2EFF/ALAMSQ(NFQ)))                                         
        IF(NFQ.EQ.5.AND.NFP.EQ.4) THEN 
          Q2DIV=PMB**2 
          SNFQ=(6./(33.-2.*NFQ))*LOG(LOG(Q2DIV/ALAMSQ(NFQ))/            &
     &    LOG(P2EFF/ALAMSQ(NFQ)))                                       
          SNFP=(6./(33.-2.*(NFQ-1)))*LOG(LOG(Q2DIV/ALAMSQ(NFQ-1))/      &
     &    LOG(P2EFF/ALAMSQ(NFQ-1)))                                     
          S=S+(LOG(Q2DIV/P2EFF)/LOG(Q2EFF/P2EFF))*(SNFP-SNFQ) 
        ENDIF 
                                                                        
!...Bottom: as above, but only include range above b threshold.         
      ELSEIF(KFL.EQ.5) THEN 
        IF(Q2.LE.PMB**2) EXIT 
        P2EFF=MAX(P2EFF,PMB**2) 
        Q2EFF=MAX(Q2,P2EFF) 
        TDIFF=LOG(Q2EFF/P2EFF) 
        S=(6./(33.-2.*NFQ))*LOG(LOG(Q2EFF/ALAMSQ(NFQ))/                 &
     &  LOG(P2EFF/ALAMSQ(NFQ)))                                         
      ENDIF 
                                                                        
!...Evaluate flavour-dependent prefactor (charge^2 etc.).               
      CHSQ=1./9. 
      IF(KFL.EQ.2.OR.KFL.EQ.4) CHSQ=4./9. 
      FAC=AEM2PI*2.*CHSQ*TDIFF 
                                                                        
!...Evaluate parton distributions (normalized to unit momentum sum).    
      IF(KFL.EQ.1.OR.KFL.EQ.4.OR.KFL.EQ.5.OR.KFL.EQ.KF) THEN 
        XVAL= ((1.5+2.49*S+26.9*S**2)/(1.+32.3*S**2)*X**2 +             &
     &  (1.5-0.49*S+7.83*S**2)/(1.+7.68*S**2)*(1.-X)**2 +               &
     &  1.5*S/(1.-3.2*S+7.*S**2)*X*(1.-X)) *                            &
     &  X**(1./(1.+0.58*S)) * (1.-X**2)**(2.5*S/(1.+10.*S))             
        XGLU= 2.*S/(1.+4.*S+7.*S**2) *                                  &
     &  X**(-1.67*S/(1.+2.*S)) * (1.-X**2)**(1.2*S) *                   &
     &  ((4.*X**2+7.*X+4.)*(1.-X)/3. - 2.*X*(1.+X)*XL)                  
        XSEA= 0.333*S**2/(1.+4.90*S+4.69*S**2+21.4*S**3) *              &
     &  X**(-1.18*S/(1.+1.22*S)) * (1.-X)**(1.2*S) *                    &
     &  ((8.-73.*X+62.*X**2)*(1.-X)/9. + (3.-8.*X**2/3.)*X*XL +         &
     &  (2.*X-1.)*X*XL**2)                                              
                                                                        
!...Threshold factors for c and b sea.                                  
        SLL=LOG(LOG(Q2EFF/ALAM**2)/LOG(P2EFF/ALAM**2)) 
        XCHM=0. 
        IF(Q2.GT.PMC**2.AND.Q2.GT.1.001*P2EFF) THEN 
          SCH=MAX(0.,LOG(LOG(PMC**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
          XCHM=XSEA*(1.-(SCH/SLL)**3) 
        ENDIF 
        XBOT=0. 
        IF(Q2.GT.PMB**2.AND.Q2.GT.1.001*P2EFF) THEN 
          SBT=MAX(0.,LOG(LOG(PMB**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
          XBOT=XSEA*(1.-(SBT/SLL)**3) 
        ENDIF 
      ENDIF 
                                                                        
!...Add contribution of each valence flavour.                           
      XPGA(0)=XPGA(0)+FAC*XGLU 
      XPGA(1)=XPGA(1)+FAC*XSEA 
      XPGA(2)=XPGA(2)+FAC*XSEA 
      XPGA(3)=XPGA(3)+FAC*XSEA 
      XPGA(4)=XPGA(4)+FAC*XCHM 
      XPGA(5)=XPGA(5)+FAC*XBOT 
      XPGA(KFL)=XPGA(KFL)+FAC*XVAL 
      VXPGA(KFL)=VXPGA(KFL)+FAC*XVAL 
  110 END DO 
      DO 120 KFL=1,5 
      XPGA(-KFL)=XPGA(KFL) 
      VXPGA(-KFL)=VXPGA(KFL) 
  120 END DO 
                                                                        
      RETURN 
      END                                           
                                                                        
!*********************************************************************  
                                                                        
      SUBROUTINE LHASASBEH(KF,X,Q2,P2,PM2,XPBH) 
!...Purpose: to evaluate the Bethe-Heitler cross section for            
!...heavy flavour production.                                           
      DATA AEM2PI/0.0011614/ 
                                                                        
!...Reset output.                                                       
      XPBH=0. 
      SIGBH=0. 
                                                                        
!...Check kinematics limits.                                            
      IF(X.GE.Q2/(4.*PM2+Q2+P2)) RETURN 
      W2=Q2*(1.-X)/X-P2 
      BETA2=1.-4.*PM2/W2 
      IF(BETA2.LT.1E-10) RETURN 
      BETA=SQRT(BETA2) 
      RMQ=4.*PM2/Q2 
                                                                        
!...Simple case: P2 = 0.                                                
      IF(P2.LT.1E-4) THEN 
        IF(BETA.LT.0.99) THEN 
          XBL=LOG((1.+BETA)/(1.-BETA)) 
        ELSE 
          XBL=LOG((1.+BETA)**2*W2/(4.*PM2)) 
        ENDIF 
        SIGBH=BETA*(8.*X*(1.-X)-1.-RMQ*X*(1.-X))+                       &
     &  XBL*(X**2+(1.-X)**2+RMQ*X*(1.-3.*X)-0.5*RMQ**2*X**2)            
                                                                        
!...Complicated case: P2 > 0, based on approximation of                 
!...C.T. Hill and G.G. Ross, Nucl. Phys. B148 (1979) 373                
      ELSE 
        RPQ=1.-4.*X**2*P2/Q2 
        IF(RPQ.GT.1E-10) THEN 
          RPBE=SQRT(RPQ*BETA2) 
          IF(RPBE.LT.0.99) THEN 
            XBL=LOG((1.+RPBE)/(1.-RPBE)) 
            XBI=2.*RPBE/(1.-RPBE**2) 
          ELSE 
            RPBESN=4.*PM2/W2+(4.*X**2*P2/Q2)*BETA2 
            XBL=LOG((1.+RPBE)**2/RPBESN) 
            XBI=2.*RPBE/RPBESN 
          ENDIF 
          SIGBH=BETA*(6.*X*(1.-X)-1.)+                                  &
     &    XBL*(X**2+(1.-X)**2+RMQ*X*(1.-3.*X)-0.5*RMQ**2*X**2)+         &
     &    XBI*(2.*X/Q2)*(PM2*X*(2.-RMQ)-P2*X)                           
        ENDIF 
      ENDIF 
                                                                        
!...Multiply by charge-squared etc. to get parton distribution.         
      CHSQ=1./9. 
      IF(IABS(KF).EQ.2.OR.IABS(KF).EQ.4) CHSQ=4./9. 
      XPBH=3.*CHSQ*AEM2PI*X*SIGBH 
                                                                        
      RETURN 
      END                                           
                                                                        
!*********************************************************************  
                                                                        
       SUBROUTINE LHASASDIR(X,Q2,P2,Q02,XPGA) 
!...Purpose: to evaluate the direct contribution, i.e. the C^gamma term,
!...as needed in MSbar parametrizations.                                
      DIMENSION XPGA(-6:6) 
      DATA PMC/1.3/, PMB/4.6/, AEM2PI/0.0011614/ 
                                                                        
!...Reset output.                                                       
      DO 100 KFL=-6,6 
      XPGA(KFL)=0. 
  100 END DO 
                                                                        
!...Evaluate common x-dependent expression.                             
      XTMP = (X**2+(1.-X)**2) * (-LOG(X)) - 1. 
      CGAM = 3.*AEM2PI*X * (XTMP*(1.+P2/(P2+Q02)) + 6.*X*(1.-X)) 
                                                                        
!...d, u, s part by simple charge factor.                               
      XPGA(1)=(1./9.)*CGAM 
      XPGA(2)=(4./9.)*CGAM 
      XPGA(3)=(1./9.)*CGAM 
                                                                        
!...Also fill for antiquarks.                                           
      DO 110 KF=1,5 
      XPGA(-KF)=XPGA(KF) 
  110 END DO 
                                                                        
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       SUBROUTINE LHASASVM1(ISET,KF,X,Q2,P2,ALAM,XPGA) 
!...Purpose: to evaluate the VMD parton distributions of a photon,      
!...evolved homogeneously from an initial scale P2 to Q2.               
!...Does not include dipole suppression factor.                         
!...ISET is parton distribution set, see above;                         
!...additionally ISET=0 is used for the evolution of an anomalous photon
!...which branched at a scale P2 and then evolved homogeneously to Q2.  
!...ALAM is the 4-flavour Lambda, which is automatically converted      
!...to 3- and 5-flavour equivalents as needed.                          
      DIMENSION XPGA(-6:6) 
      DATA PMC/1.3/, PMB/4.6/, AEM/0.007297/, AEM2PI/0.0011614/ 
                                                                        
!...Reset output.                                                       
      DO 100 KFL=-6,6 
      XPGA(KFL)=0. 
  100 END DO 
      KFA=IABS(KF) 
                                                                        
!...Calculate Lambda; protect against unphysical Q2 and P2 input.       
      ALAM3=ALAM*(PMC/ALAM)**(2./27.) 
      ALAM5=ALAM*(ALAM/PMB)**(2./23.) 
      P2EFF=MAX(P2,1.2*ALAM3**2) 
      IF(KFA.EQ.4) P2EFF=MAX(P2EFF,PMC**2) 
      IF(KFA.EQ.5) P2EFF=MAX(P2EFF,PMB**2) 
      Q2EFF=MAX(Q2,P2EFF) 
                                                                        
!...Find number of flavours at lower and upper scale.                   
      NFP=4 
      IF(P2EFF.LT.PMC**2) NFP=3 
      IF(P2EFF.GT.PMB**2) NFP=5 
      NFQ=4 
      IF(Q2EFF.LT.PMC**2) NFQ=3 
      IF(Q2EFF.GT.PMB**2) NFQ=5 
                                                                        
!...Find s as sum of 3-, 4- and 5-flavour parts.                        
      S=0. 
      IF(NFP.EQ.3) THEN 
        Q2DIV=PMC**2 
        IF(NFQ.EQ.3) Q2DIV=Q2EFF 
        S=S+(6./27.)*LOG(LOG(Q2DIV/ALAM3**2)/LOG(P2EFF/ALAM3**2)) 
      ENDIF 
      IF(NFP.LE.4.AND.NFQ.GE.4) THEN 
        P2DIV=P2EFF 
        IF(NFP.EQ.3) P2DIV=PMC**2 
        Q2DIV=Q2EFF 
        IF(NFQ.EQ.5) Q2DIV=PMB**2 
        S=S+(6./25.)*LOG(LOG(Q2DIV/ALAM**2)/LOG(P2DIV/ALAM**2)) 
      ENDIF 
      IF(NFQ.EQ.5) THEN 
        P2DIV=PMB**2 
        IF(NFP.EQ.5) P2DIV=P2EFF 
        S=S+(6./23.)*LOG(LOG(Q2EFF/ALAM5**2)/LOG(P2DIV/ALAM5**2)) 
      ENDIF 
                                                                        
!...Calculate frequent combinations of x and s.                         
      X1=1.-X 
      XL=-LOG(X) 
      S2=S**2 
      S3=S**3 
      S4=S**4 
                                                                        
!...Evaluate homogeneous anomalous parton distributions below or        
!...above threshold.                                                    
      IF(ISET.EQ.0) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = X * 1.5 * (X**2+X1**2) 
        XGLU = 0. 
        XSEA = 0. 
      ELSE 
        XVAL = (1.5/(1.-0.197*S+4.33*S2)*X**2 + (1.5+2.10*S)/           &
     &  (1.+3.29*S)*X1**2 + 5.23*S/(1.+1.17*S+19.9*S3)*X*X1) *          &
     &  X**(1./(1.+1.5*S)) * (1.-X**2)**(2.667*S)                       
        XGLU = 4.*S/(1.+4.76*S+15.2*S2+29.3*S4) *                       &
     &  X**(-2.03*S/(1.+2.44*S)) * (X1*XL)**(1.333*S) *                 &
     &  ((4.*X**2+7.*X+4.)*X1/3. - 2.*X*(1.+X)*XL)                      
        XSEA = S2/(1.+4.54*S+8.19*S2+8.05*S3) *                         &
     &  X**(-1.54*S/(1.+1.29*S)) * X1**(2.667*S) *                      &
     &  ((8.-73.*X+62.*X**2)*X1/9. + (3.-8.*X**2/3.)*X*XL +             &
     &  (2.*X-1.)*X*XL**2)                                              
      ENDIF 
                                                                        
!...Evaluate set 1D parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.1) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = 1.294 * X**0.80 * X1**0.76 
        XGLU = 1.273 * X**0.40 * X1**1.76 
        XSEA = 0.100 * X1**3.76 
      ELSE 
        XVAL = 1.294/(1.+0.252*S+3.079*S2) * X**(0.80-0.13*S) *         &
     &  X1**(0.76+0.667*S) * XL**(2.*S)                                 
        XGLU = 7.90*S/(1.+5.50*S) * EXP(-5.16*S) *                      &
     &  X**(-1.90*S/(1.+3.60*S)) * X1**1.30 * XL**(0.50+3.*S) +         &
     &  1.273 * EXP(-10.*S) * X**0.40 * X1**(1.76+3.*S)                 
        XSEA = (0.1-0.397*S2+1.121*S3)/(1.+5.61*S2+5.26*S3) *           &
     &  X**(-7.32*S2/(1.+10.3*S2)) *                                    &
     &  X1**((3.76+15.*S+12.*S2)/(1.+4.*S))                             
        XSEA0 = 0.100 * X1**3.76 
      ENDIF 
                                                                        
!...Evaluate set 1M parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.2) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = 0.8477 * X**0.51 * X1**1.37 
        XGLU = 3.42 * X**0.255 * X1**2.37 
        XSEA = 0. 
      ELSE 
        XVAL = 0.8477/(1.+1.37*S+2.18*S2+3.73*S3) * X**(0.51+0.21*S)    &
     &  * X1**1.37 * XL**(2.667*S)                                      
        XGLU = 24.*S/(1.+9.6*S+0.92*S2+14.34*S3) * EXP(-5.94*S) *       &
     &  X**((-0.013-1.80*S)/(1.+3.14*S)) * X1**(2.37+0.4*S) *           &
     &  XL**(0.32+3.6*S) + 3.42 * EXP(-12.*S) * X**0.255 *              &
     &  X1**(2.37+3.*S)                                                 
        XSEA = 0.842*S/(1.+21.3*S-33.2*S2+229.*S3) *                    &
     &  X**((0.13-2.90*S)/(1.+5.44*S)) * X1**(3.45+0.5*S) *             &
     &  XL**(2.8*S)                                                     
        XSEA0 = 0. 
      ENDIF 
                                                                        
!...Evaluate set 2D parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.3) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = X**0.46 * X1**0.64 + 0.76 * X 
        XGLU = 1.925 * X1**2 
        XSEA = 0.242 * X1**4 
      ELSE 
        XVAL = (1.+0.186*S)/(1.-0.209*S+1.495*S2) * X**(0.46+0.25*S)    &
     &  * X1**((0.64+0.14*S+5.*S2)/(1.+S)) * XL**(1.9*S) +              &
     &  (0.76+0.4*S) * X * X1**(2.667*S)                                
        XGLU = (1.925+5.55*S+147.*S2)/(1.-3.59*S+3.32*S2) *             &
     &  EXP(-18.67*S) * X**((-5.81*S-5.34*S2)/(1.+29.*S-4.26*S2))       &
     &  * X1**((2.-5.9*S)/(1.+1.7*S)) * XL**(9.3*S/(1.+1.7*S))          
        XSEA = (0.242-0.252*S+1.19*S2)/(1.-0.607*S+21.95*S2) *          &
     &  X**(-12.1*S2/(1.+2.62*S+16.7*S2)) * X1**4 * XL**S               
        XSEA0 = 0.242 * X1**4 
      ENDIF 
                                                                        
!...Evaluate set 2M parton distributions below or above threshold.      
      ELSEIF(ISET.EQ.4) THEN 
      IF(Q2.LE.P2.OR.(KFA.EQ.4.AND.Q2.LT.PMC**2).OR.                    &
     &(KFA.EQ.5.AND.Q2.LT.PMB**2)) THEN                                 
        XVAL = 1.168 * X**0.50 * X1**2.60 + 0.965 * X 
        XGLU = 1.808 * X1**2 
        XSEA = 0.209 * X1**4 
      ELSE 
        XVAL = (1.168+1.771*S+29.35*S2) * EXP(-5.776*S) *               &
     &  X**((0.5+0.208*S)/(1.-0.794*S+1.516*S2)) *                      &
     &  X1**((2.6+7.6*S)/(1.+5.*S)) * XL**(5.15*S/(1.+2.*S)) +          &
     &  (0.965+22.35*S)/(1.+18.4*S) * X * X1**(2.667*S)                 
        XGLU = (1.808+29.9*S)/(1.+26.4*S) * EXP(-5.28*S) *              &
     &  X**((-5.35*S-10.11*S2)/(1.+31.71*S)) *                          &
     &  X1**((2.-7.3*S+4.*S2)/(1.+2.5*S)) *                             &
     &  XL**(10.9*S/(1.+2.5*S))                                         
        XSEA = (0.209+0.644*S2)/(1.+0.319*S+17.6*S2) *                  &
     &  X**((-0.373*S-7.71*S2)/(1.+0.815*S+11.0*S2)) *                  &
     &  X1**(4.+S) * XL**(0.45*S)                                       
        XSEA0 = 0.209 * X1**4 
      ENDIF 
      ENDIF 
                                                                        
!...Threshold factors for c and b sea.                                  
      SLL=LOG(LOG(Q2EFF/ALAM**2)/LOG(P2EFF/ALAM**2)) 
      XCHM=0. 
      IF(Q2.GT.PMC**2.AND.Q2.GT.1.001*P2EFF) THEN 
        SCH=MAX(0.,LOG(LOG(PMC**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
        IF(ISET.EQ.0) THEN 
          XCHM=XSEA*(1.-(SCH/SLL)**2) 
        ELSE 
          XCHM=MAX(0.,XSEA-XSEA0*X1**(2.667*S))*(1.-SCH/SLL) 
        ENDIF 
      ENDIF 
      XBOT=0. 
      IF(Q2.GT.PMB**2.AND.Q2.GT.1.001*P2EFF) THEN 
        SBT=MAX(0.,LOG(LOG(PMB**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
        IF(ISET.EQ.0) THEN 
          XBOT=XSEA*(1.-(SBT/SLL)**2) 
        ELSE 
          XBOT=MAX(0.,XSEA-XSEA0*X1**(2.667*S))*(1.-SBT/SLL) 
        ENDIF 
      ENDIF 
                                                                        
!...Fill parton distributions.                                          
      XPGA(0)=XGLU 
      XPGA(1)=XSEA 
      XPGA(2)=XSEA 
      XPGA(3)=XSEA 
      XPGA(4)=XCHM 
      XPGA(5)=XBOT 
      XPGA(KFA)=XPGA(KFA)+XVAL 
      DO 110 KFL=1,5 
      XPGA(-KFL)=XPGA(KFL) 
  110 END DO 
                                                                        
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE LHASASAN1(KF,X,Q2,P2,ALAM,XPGA) 
!...Purpose: to evaluate the parton distributions of the anomalous      
!...photon, inhomogeneously evolved from a scale P2 (where it vanishes) 
!...to Q2.                                                              
!...KF=0 gives the sum over (up to) 5 flavours,                         
!...KF<0 limits to flavours up to abs(KF),                              
!...KF>0 is for flavour KF only.                                        
!...ALAM is the 4-flavour Lambda, which is automatically converted      
!...to 3- and 5-flavour equivalents as needed.                          
      DIMENSION XPGA(-6:6),ALAMSQ(3:5) 
      DATA PMC/1.3/, PMB/4.6/, AEM/0.007297/, AEM2PI/0.0011614/ 
                                                                        
!...Reset output.                                                       
      DO 100 KFL=-6,6 
      XPGA(KFL)=0. 
  100 END DO 
      IF(Q2.LE.P2) RETURN 
      KFA=IABS(KF) 
                                                                        
!...Calculate Lambda; protect against unphysical Q2 and P2 input.       
      ALAMSQ(3)=(ALAM*(PMC/ALAM)**(2./27.))**2 
      ALAMSQ(4)=ALAM**2 
      ALAMSQ(5)=(ALAM*(ALAM/PMB)**(2./23.))**2 
      P2EFF=MAX(P2,1.2*ALAMSQ(3)) 
      IF(KF.EQ.4) P2EFF=MAX(P2EFF,PMC**2) 
      IF(KF.EQ.5) P2EFF=MAX(P2EFF,PMB**2) 
      Q2EFF=MAX(Q2,P2EFF) 
      XL=-LOG(X) 
                                                                        
!...Find number of flavours at lower and upper scale.                   
      NFP=4 
      IF(P2EFF.LT.PMC**2) NFP=3 
      IF(P2EFF.GT.PMB**2) NFP=5 
      NFQ=4 
      IF(Q2EFF.LT.PMC**2) NFQ=3 
      IF(Q2EFF.GT.PMB**2) NFQ=5 
                                                                        
!...Define range of flavour loop.                                       
      IF(KF.EQ.0) THEN 
        KFLMN=1 
        KFLMX=5 
      ELSEIF(KF.LT.0) THEN 
        KFLMN=1 
        KFLMX=KFA 
      ELSE 
        KFLMN=KFA 
        KFLMX=KFA 
      ENDIF 
                                                                        
!...Loop over flavours the photon can branch into.                      
      DO 110 KFL=KFLMN,KFLMX 
                                                                        
!...Light flavours: calculate t range and (approximate) s range.        
      IF(KFL.LE.3.AND.(KFL.EQ.1.OR.KFL.EQ.KF)) THEN 
        TDIFF=LOG(Q2EFF/P2EFF) 
        S=(6./(33.-2.*NFQ))*LOG(LOG(Q2EFF/ALAMSQ(NFQ))/                 &
     &  LOG(P2EFF/ALAMSQ(NFQ)))                                         
        IF(NFQ.GT.NFP) THEN 
          Q2DIV=PMB**2 
          IF(NFQ.EQ.4) Q2DIV=PMC**2 
          SNFQ=(6./(33.-2.*NFQ))*LOG(LOG(Q2DIV/ALAMSQ(NFQ))/            &
     &    LOG(P2EFF/ALAMSQ(NFQ)))                                       
          SNFP=(6./(33.-2.*(NFQ-1)))*LOG(LOG(Q2DIV/ALAMSQ(NFQ-1))/      &
     &    LOG(P2EFF/ALAMSQ(NFQ-1)))                                     
          S=S+(LOG(Q2DIV/P2EFF)/LOG(Q2EFF/P2EFF))*(SNFP-SNFQ) 
        ENDIF 
        IF(NFQ.EQ.5.AND.NFP.EQ.3) THEN 
          Q2DIV=PMC**2 
          SNF4=(6./(33.-2.*4))*LOG(LOG(Q2DIV/ALAMSQ(4))/                &
     &    LOG(P2EFF/ALAMSQ(4)))                                         
          SNF3=(6./(33.-2.*3))*LOG(LOG(Q2DIV/ALAMSQ(3))/                &
     &    LOG(P2EFF/ALAMSQ(3)))                                         
          S=S+(LOG(Q2DIV/P2EFF)/LOG(Q2EFF/P2EFF))*(SNF3-SNF4) 
        ENDIF 
                                                                        
!...u and s quark do not need a separate treatment when d has been done.
      ELSEIF(KFL.EQ.2.OR.KFL.EQ.3) THEN 
                                                                        
!...Charm: as above, but only include range above c threshold.          
      ELSEIF(KFL.EQ.4) THEN 
        IF(Q2.LE.PMC**2) EXIT
        P2EFF=MAX(P2EFF,PMC**2) 
        Q2EFF=MAX(Q2EFF,P2EFF) 
        TDIFF=LOG(Q2EFF/P2EFF) 
        S=(6./(33.-2.*NFQ))*LOG(LOG(Q2EFF/ALAMSQ(NFQ))/                 &
     &  LOG(P2EFF/ALAMSQ(NFQ)))                                         
        IF(NFQ.EQ.5.AND.NFP.EQ.4) THEN 
          Q2DIV=PMB**2 
          SNFQ=(6./(33.-2.*NFQ))*LOG(LOG(Q2DIV/ALAMSQ(NFQ))/            &
     &    LOG(P2EFF/ALAMSQ(NFQ)))                                       
          SNFP=(6./(33.-2.*(NFQ-1)))*LOG(LOG(Q2DIV/ALAMSQ(NFQ-1))/      &
     &    LOG(P2EFF/ALAMSQ(NFQ-1)))                                     
          S=S+(LOG(Q2DIV/P2EFF)/LOG(Q2EFF/P2EFF))*(SNFP-SNFQ) 
        ENDIF 
                                                                        
!...Bottom: as above, but only include range above b threshold.         
      ELSEIF(KFL.EQ.5) THEN 
        IF(Q2.LE.PMB**2) EXIT 
        P2EFF=MAX(P2EFF,PMB**2) 
        Q2EFF=MAX(Q2,P2EFF) 
        TDIFF=LOG(Q2EFF/P2EFF) 
        S=(6./(33.-2.*NFQ))*LOG(LOG(Q2EFF/ALAMSQ(NFQ))/                 &
     &  LOG(P2EFF/ALAMSQ(NFQ)))                                         
      ENDIF 
                                                                        
!...Evaluate flavour-dependent prefactor (charge^2 etc.).               
      CHSQ=1./9. 
      IF(KFL.EQ.2.OR.KFL.EQ.4) CHSQ=4./9. 
      FAC=AEM2PI*2.*CHSQ*TDIFF 
                                                                        
!...Evaluate parton distributions (normalized to unit momentum sum).    
      IF(KFL.EQ.1.OR.KFL.EQ.4.OR.KFL.EQ.5.OR.KFL.EQ.KF) THEN 
        XVAL= ((1.5+2.49*S+26.9*S**2)/(1.+32.3*S**2)*X**2 +             &
     &  (1.5-0.49*S+7.83*S**2)/(1.+7.68*S**2)*(1.-X)**2 +               &
     &  1.5*S/(1.-3.2*S+7.*S**2)*X*(1.-X)) *                            &
     &  X**(1./(1.+0.58*S)) * (1.-X**2)**(2.5*S/(1.+10.*S))             
        XGLU= 2.*S/(1.+4.*S+7.*S**2) *                                  &
     &  X**(-1.67*S/(1.+2.*S)) * (1.-X**2)**(1.2*S) *                   &
     &  ((4.*X**2+7.*X+4.)*(1.-X)/3. - 2.*X*(1.+X)*XL)                  
        XSEA= 0.333*S**2/(1.+4.90*S+4.69*S**2+21.4*S**3) *              &
     &  X**(-1.18*S/(1.+1.22*S)) * (1.-X)**(1.2*S) *                    &
     &  ((8.-73.*X+62.*X**2)*(1.-X)/9. + (3.-8.*X**2/3.)*X*XL +         &
     &  (2.*X-1.)*X*XL**2)                                              
                                                                        
!...Threshold factors for c and b sea.                                  
        SLL=LOG(LOG(Q2EFF/ALAM**2)/LOG(P2EFF/ALAM**2)) 
        XCHM=0. 
        IF(Q2.GT.PMC**2.AND.Q2.GT.1.001*P2EFF) THEN 
          SCH=MAX(0.,LOG(LOG(PMC**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
          XCHM=XSEA*(1.-(SCH/SLL)**3) 
        ENDIF 
        XBOT=0. 
        IF(Q2.GT.PMB**2.AND.Q2.GT.1.001*P2EFF) THEN 
          SBT=MAX(0.,LOG(LOG(PMB**2/ALAM**2)/LOG(P2EFF/ALAM**2))) 
          XBOT=XSEA*(1.-(SBT/SLL)**3) 
        ENDIF 
      ENDIF 
                                                                        
!...Add contribution of each valence flavour.                           
      XPGA(0)=XPGA(0)+FAC*XGLU 
      XPGA(1)=XPGA(1)+FAC*XSEA 
      XPGA(2)=XPGA(2)+FAC*XSEA 
      XPGA(3)=XPGA(3)+FAC*XSEA 
      XPGA(4)=XPGA(4)+FAC*XCHM 
      XPGA(5)=XPGA(5)+FAC*XBOT 
      XPGA(KFL)=XPGA(KFL)+FAC*XVAL 
  110 END DO 
      DO 120 KFL=1,5 
      XPGA(-KFL)=XPGA(KFL) 
  120 END DO 
                                                                        
      RETURN 
      END                                           

!***********************************************************************
!     Initial parameterization: NN (simplified wrt our code)            
!***********************************************************************
                                                                        
      subroutine LH_PDFIN(X,PDFTMP) 
      implicit none 
!                                                                       
      INCLUDE 'parmsetup.inc' 
      CHARACTER*16 name(nmxset) 
      INTEGER nmem(nmxset),ndef(nmxset),mmem 
      COMMON/NAME/name,nmem,ndef,mmem 
!                                                                       
      INTEGER KREP 
      integer MXREP 
      parameter(MXREP=1e3) 
      integer MXPDF 
      parameter(MXPDF=13) 
                                !# pdfs parametrized with NN            
      integer NTOTPDF 
      parameter(NTOTPDF=5) 
      integer MXPAR 
      parameter(MXPAR=2e2) 
!                                                                       
      integer JPDF 
      REAL*8 X 
      REAL*8 PDFTMP(MXPDF),PDFFLV(NTOTPDF) 
!                                                                       
!     Warnings                                                          
                                                                        
      KREP = MMEM 
      if(X.gt.1d0) then 
         write(6,*) "X = ",X 
         write(6,*) 'X greater than 1 in pdfin routine !' 
         call exit(-10) 
      elseif(X.le.0d0) then 
         write(6,*) "X = ",X 
         write(6,*) 'X less or equal 0 in pdfin routine !' 
         call exit(-10) 
      endif 
!                                                                       
!     Neural network parton distributions                               
      do JPDF=1,NTOTPDF 
         call LH_NNPDF(X,JPDF,KREP,PDFFLV(JPDF)) 
      enddo 
      call LH_PDFINPAR2EVLN(PDFFLV,PDFTMP) 
!                                                                       
      return 
      END                                           
                                                                        
!***********************************************************************
!     those commons might be changed depending on those put in inputPDF.
!***********************************************************************
                                                                        
      subroutine LH_NNPDF(X,JPDF,KREP,PDFNET) 
      implicit none 
!                                                                       
      integer KREP 
      integer MXREP 
      parameter(MXREP=1e3) 
      integer MXPDF 
      parameter(MXPDF=13) 
                                !# pdfs parametrized with NN            
      integer NTOTPDF 
      parameter(NTOTPDF=5) 
      integer MXPAR 
      parameter(MXPAR=2e2) 
!                                                                       
                                !NN basic parameters                    
      integer MXL,MXN 
      parameter(MXL=5,MXN=10) 
!                                                                       
                                            ! NN architecture           
      integer TNL(NTOTPDF),NEU(MXL,NTOTPDF) 
      REAL*8 XNOR(2,NTOTPDF),PDFNOR(2,NTOTPDF) 
      REAL*8 PDFEXP(2,NTOTPDF) 
      REAL*8 PDFDELTA(NTOTPDF) 
      REAL*8 XDELTALIN(NTOTPDF),XDELTALOG(NTOTPDF) 
      common/nnpdf10CNNARC/PDFEXP,PDFNOR,PDFDELTA,XDELTALIN             &
     &     ,XDELTALOG,XNOR,NEU,TNL                                      
!                                                                       
      real*8 PARTR(MXPAR,0:MXREP,MXPDF) 
      real*8 ANORMTR(MXPDF,0:MXREP) 
      common/nnpdf10CPARTR/PARTR,ANORMTR 
!                                                                       
      INTEGER ipdf,JPDF,NTMP(MXL),L 
      REAL*8 PDFOUT,X 
      REAL*8 XNNIN(MXN),XNNOUT,XNN(MXN,MXL) 
      REAL*8 PDFNET 
!                                                                       
!     Temporary array of neuron number                                  
      do L=1,TNL(JPDF) 
         NTMP(L)=NEU(L,JPDF) 
      enddo 
!                                                                       
      do IPDF=1,NTOTPDF 
!     Evaluate fixed coefficients used in the normalizaion of NN        
         XDELTALIN(IPDF)=1.d0/(XNOR(2,IPDF)-XNOR(1,IPDF))*0.8d0 
         XDELTALOG(IPDF)=1.d0/dlog(XNOR(2,IPDF)/XNOR(1,IPDF))*0.8d0 
         PDFDELTA(IPDF)=(PDFNOR(2,IPDF)-PDFNOR(1,IPDF))/0.8d0 
      enddo 
!                                                                       
      XNNIN(1)=(X-XNOR(1,JPDF))*XDELTALIN(JPDF)+0.1d0 
      XNNIN(2)=dlog(X/XNOR(1,JPDF))*XDELTALOG(JPDF)+0.1d0 
!                                                                       
!     Call neural network routine                                       
!                                                                       
      call LH_NNOUT(XNNIN,TNL(JPDF),NTMP,PARTR(1,KREP,JPDF),XNN,XNNOUT) 
!                                                                       
!     Output normalization: the delta is defined in pdfcreate.f         
!                                                                       
      PDFOUT=PDFNOR(1,JPDF)+(XNNOUT - 0.1d0)*PDFDELTA(JPDF) 
!                                                                       
!     Preprocessing exponents                                           
!                                                                       
      PDFNET=((1.-x)**PDFEXP(1,JPDF))*PDFOUT*x**(-PDFEXP(2,JPDF)) 
!                                                                       
!     PDF normalization factor (fixed in some cases by sum rules)       
!                                                                       
      PDFNET= ANORMTR(JPDF,KREP) * PDFNET 
!                                                                       
      return 
      END                                           
!                                                                       
!     file: NNSUB.f --> It evaluates NN output                          
!                                                                       
      subroutine LH_NNOUT(xnnin,tnl,n,PAR,xnn,xnnout) 
      implicit none 
!                                                                       
      integer MXL,MXN 
      parameter(MXL=5,MXN=10) 
      integer MXPAR 
      parameter(MXPAR=2e2) 
!                                                                       
      integer tnl,n,l,i,ii,j 
      REAL*8 xnnin,xnnout,xnn,LH_G,h 
      dimension n(mxl) 
      dimension xnnin(mxn) 
      dimension xnn(mxn,mxl) 
!                                                                       
      REAL*8 PAR(mxpar) 
      integer IPAR 
!                                                                       
      IPAR=0 
      do ii=1,n(1) 
         xnn(ii,1)=xnnin(ii) 
      enddo 
      do l=1,tnl-1 
         xnn(n(l)+1,l)=1d0 
      enddo 
                                                                        
      do   l=2,tnl-1 
         do  i=1,n(l) 
            h=0. 
            do j=1,n(l-1)+1 
               IPAR=IPAR+1 
               h=h+PAR(IPAR)*xnn(j,l-1) 
            enddo 
            xnn(i,l)=LH_G(h) 
         enddo 
      enddo 
      do i=1,n(tnl) 
         h=0. 
         do j=1,n(l-1)+1 
            IPAR=IPAR+1 
            h=h+PAR(IPAR)*xnn(j,l-1) 
         enddo 
         xnn(i,tnl)=h 
      enddo 
                                                                        
      xnnout=xnn(1,tnl) 
                                                                        
      return 
      END                                           
!                                                                       
!     Neural network activation function                                
!                                                                       
      function LH_g(x) 
      implicit none 
      REAL*8 LH_g,x 
!                                                                       
      LH_g=1./(1.+DExp(-x)) 
!                                                                       
      return 
      END                                           

! -*- F90 -*-


subroutine commoninit()
  include 'common.inc'
  integer i

  if (commoninitflag .ne. 'commonblockinitdone') then
     !print *, "Initialising LHAPDF steering data"
     commoninitflag = 'commonblockinitdone'

     ! LHAPDF common block
     lhaname = ' '
     lhaset = 0
     lhamemb = 0
     
     ! LHASETS common block
     do i = 1, nmxset
        lhanames(i) = ' '
        lhanumbers(i) = 0
        lhamembers(i) = 0
     end do
     nsets = 0
     
     ! LHAPDFC common block
     lhapath = 'pdfsets'
     
     ! LHACONTROL common block

     do i = 1, 20
        lhaparm(i) = ' '
        lhavalue(i) = 0.0d0
     end do

     ! LHAGLSTA common block
     xminnum = 0.0d0
     xmaxnum = 0.0d0
     q2minnum = 0.0d0
     q2maxnum = 0.0d0
     totnum = 0.0d0
     xminnup = 0.0d0
     xmaxnup = 0.0d0
     q2minnup = 0.0d0
     q2maxnup = 0.0d0
     totnup = 0.0d0
  end if
  
end subroutine commoninit

! -*- F90 -*-


double precision function alphasPDF(Q)
  implicit none
  integer nset
  double precision Q,a
  call getnset(nset)
  call evolveAs(nset,Q,a)
  alphasPDF=a
  return
end function alphasPDF


double precision function alphasPDFM(nset,Q)
  implicit none
  integer nset
  double precision Q,a
  call evolveAs(nset,Q,a)
  alphasPDFM=a
  return
end function alphasPDFM


subroutine GetQmass(nnf,mass)
  implicit none
  double precision mass
  integer nnf,order,nset
  nset = 1
  call GetQmassM(nset,nnf,mass)
  return
  entry GetOrderAs(order)
  nset = 1
  call GetOrderAsM(nset,order)
  return
end subroutine GetQmass

 
subroutine evolveAs(nset,Q,alphas)
  implicit none
  include 'parmsetup.inc'
  integer iset,imem
  common/SET/iset,imem
  integer nset
  character*16 s1,s2,s3
  double precision Q,alphas,alfas0,scale0
  double precision Q0(nmxset)
  double precision AlfasQ(nmxset)
  double precision b0,b1,b2,L,As,mass
  double precision CtLhALPI,CtLhAlphaNew,CtLhALPInew,CtLhalgluino
  parameter (b0=1.2202,b1=0.4897,b2=0.1913)
  integer n!,k
  integer order
  integer EvlOrd(nmxset)
  integer parm(nmxset)
  integer Etype(nmxset)
  integer Method(nmxset)
  integer nnf,naf
  double precision cmass(nmxset),bmass(nmxset),tmass(nmxset)
  common/masses_LHA/cmass,bmass,tmass
  save EvlOrd,parm,Etype,alfasQ,Q0,Method
  
  call setnset(nset)
  
  if (method(nset).eq.0) then
     if ((Etype(nset).eq.1).or.(Etype(nset).eq.2)) then
        L=log(Q/Q0(nset))
        As=alfasQ(nset)
        if (Etype(nset).eq.2) call GetParmPDF(nset,parm(nset),As)
        if (EvlOrd(nset).eq.0) L=b0*L
        if (EvlOrd(nset).eq.1) L=(b0+As*b1)*L
        if (EvlOrd(nset).eq.2) L=(b0+As*b1+As**2*b2)*L -0.5*As**2*b0*b1/2d0*L**2
        alphas=As/(1.0+As*L)
     endif
  endif
  if (method(nset).eq.1) then
     call alfasevolve(nset,alphas,Q)
  elseif (method(nset).eq.2) then
     call alphamrs(5,alphas,Q)
  elseif (method(nset).eq.3) then
     if(Etype(nset).eq.1) alphas = 3.1415926535898d0*CtLhALPI(Q)
     if(Etype(nset).eq.2) alphas = 3.1415926535898d0*CtLhALPInew(Q)
  elseif (method(nset).eq.4) then
     alphas = CtLhAlphaNew(Q)
  elseif (method(nset).eq.5) then
     call alphamrs(3,alphas,Q)
  elseif (method(nset).eq.6) then
     call alphamrs(4,alphas,Q)
  elseif (method(nset).eq.7) then
     call alphacteq5f34(3,alphas,Q)
  elseif (method(nset).eq.8) then
     call alphacteq5f34(4,alphas,Q)
  elseif (method(nset).eq.9) then
     alphas = CtLhalgluino(Q)
  elseif (method(nset).eq.10) then
     call alphacteq4(alphas,Q)
  endif
  return
  
  entry GetQmassM(nset,nnf,mass)
  n=abs(nnf)
  mass=0d0
  if (n.eq.4) mass=cmass(nset)
  if (n.eq.5) mass=bmass(nset)
  if (n.eq.6) mass=tmass(nset)
  return
  
  entry GetNactive(naf,q)
  ! compute nnfn = number of active flavors at scale qin.
  n = 3
  if(q .ge. cmass(nset)) n = 4
  if(q .ge. bmass(nset)) n = n + 1
  if(q .ge. tmass(nset)) n = n + 1
  naf = n
  return
  
  entry GetAlfas(nset,alfas0,scale0)
  scale0=Q0(nset)
  alfas0=alfasQ(nset)
  if (Etype(nset).eq.2) call GetParmPDF(nset,parm(nset),alfas0)
  return
  
  entry GetOrderAsM(nset,order)
  order=EvlOrd(nset)
  return
  
  entry InitAlphasPDF(nset)
  Etype(nset)=-1
  EvlOrd(nset)=-1
  read(1,*) s1,s2,s3
  if (index(s2,'lo').eq.1) EvlOrd(nset)=0
  if (index(s2,'nlo').eq.1) EvlOrd(nset)=1
  if (index(s2,'nnlo').eq.1) EvlOrd(nset)=2
  if (EvlOrd(nset).lt.0) then
     write(*,*) 'File description error:'
     write(*,*) 'Unknown alpha_s evolution order ',s2
     stop
  endif
  if (index(s1,'Fixed').eq.1) then
     Etype(nset)=1
     parm(nset)=-1
     read(1,*) alfasQ(nset),Q0(nset),cmass(nset),bmass(nset),tmass(nset)
  endif
  if (index(s1,'Variable').eq.1) then
     Etype(nset)=2
     alfasQ(nset)=0d0
     read(1,*) parm(nset),Q0(nset),cmass(nset),bmass(nset),tmass(nset)
  endif
  if (Etype(nset).lt.0) then
     write(*,*) 'File description error:'
     write(*,*) 'Unknown alpha_s evolution method ',s1
     stop
  endif
  Method(nset)=-1
  if (index(s3,'Internal').eq.1) Method(nset)=0
  if (index(s3,'EvolCode').eq.1) Method(nset)=1
  if (index(s3,'MRSTalfa').eq.1) Method(nset)=2
  if (index(s3,'CTEQalfa').eq.1) Method(nset)=3
  if (index(s3,'CTEQABalfa').eq.1) Method(nset)=4
  if (index(s3,'MRST3alfa').eq.1) Method(nset)=5
  if (index(s3,'MRST4alfa').eq.1) Method(nset)=6
  if (index(s3,'CTEQ5F3alfa').eq.1) Method(nset)=7
  if (index(s3,'CTEQ5F4alfa').eq.1) Method(nset)=8
  if (index(s3,'CTEQ6LGalfa').eq.1) Method(nset)=9
  if (index(s3,'CTEQ4alfa').eq.1) Method(nset)=10
  if (index(s3,'CT12alfa').eq.1) Method(nset)=1
  if (Method(nset).lt.0) then
     write(*,*) 'File description error:'
     write(*,*) 'Unknown alpha_s method ',s3
     stop
  endif
  return
end subroutine evolveAs


subroutine alphamrs(nflav,alpha,Q)
  IMPLICIT double precision (a-h,o-z)
  include 'parmsetup.inc'
  common/SET/iset,imem
  common/masses_LHA/cmass(nmxset),bmass(nmxset),tmass(nmxset)
  dimension parms(31)
  DATA PI/3.14159/
  DATA TOL/.0005/
  data memold/-1/
  integer nset
  save alambda,memold 
  call getnset(nset)
  
  ! Find alambda corresponding to alphas given in first parameter
  call getnmem(nset,imem)
     call listPDF(nset,imem,parms)
     alphas = parms(1)
     memold=imem
     qz2=8315.
     qz = dsqrt(qz2)
     alambda = 0.3000
     astep = 0.010
     tol2 = 0.0000001
     idir = +1
10   continue
     alambda = alambda + idir*astep
     call mrslambda(nflav,alpha,qz,alambda)
     
     if(idir*(alphas-alpha).gt.0.0) then
        goto 20
     else
        astep = 0.5*astep
        idir = -1*idir
        goto 20
     endif
20   continue
     if(abs(alpha-alphas).gt.tol2) goto 10
  ! alambda found  -- save it !!!!
  ! next call mrslambda to get alphas at q with the correct alambda
  call mrslambda(nflav,alpha,q,alambda)
  RETURN
END subroutine alphamrs


subroutine rgras(alpha,Q2)
  IMPLICIT double precision (a-h,o-z)
  !double precision mc,mb,mt
  include 'parmsetup.inc'
  character*16 name(nmxset)
  integer nmem(nmxset),ndef(nmxset),mem
  common/NAME/name,nmem,ndef,mem
  q=dsqrt(q2)
  call getnset(nset)
  nflav=5
  if(name(nset).eq.'QCDNUM_MRST3') nflav=3     
  if(name(nset).eq.'QCDNUM_MRST4') nflav=4     
  call alphamrs(nflav,alpha,Q)
  return
end subroutine rgras


! new vewrsion of mrslambda 13/5/2004 - includes lo, nlo, and nnlo with flags
subroutine mrslambda(nflav,alpha,Q,alambda)
  IMPLICIT DOUBLE PRECISION(A-H,O-Z)
  DATA PI/3.14159/
  DATA TOL/.0005/
  !  The value of Lambda required corresponds to nflav=4
  !  iord=0 gives leading order, iord=1 gives NLO, iord=2 gives NNLO
  qsdt=8.18    !!  This is the value of 4m_c^2
  qsct=74.0    !!  This is the value of 4m_b^2
  al2=alambda*alambda
  q2=q*q
  t=dlog(q2/al2)
  
  ! CHECK: explicitly initialising ALFQC{3,4,5} (by AB)
  ALFQC3 = 0
  ALFQC4 = 0
  ALFQC5 = 0
  
  call getnset(nset)
  call GetOrderAsM(nset,iord)
  ITH=0
  TT=T
  qsdtt=qsdt/4.
  qsctt=qsct/4.
  AL=ALAMBDA
  AL2=AL*AL
  FLAV=4.
  if(nflav.eq.3) flav=3.
  QS=AL2*dEXP(T)
  
  if(qs.lt.0.5d0) then   !!  running stops below 0.5
     qs=0.5d0
     t=dlog(qs/al2)
     tt=t
  endif
  
  IF(QS.gt.QSCTT.and.nflav.gt.4) GOTO 12  
  IF(QS.lt.QSDTT.and.nflav.gt.3) GOTO 312  
11 CONTINUE
  B0=11-2.*FLAV/3. 
  X1=4.*PI/B0
  IF(IORD.eq.0) then
     ALPHA=X1/T
  ELSE
     if(iord.gt.1) then
        alpha=qwikalf(t,iord,flav)
        goto 51
     endif
     B1=102.-38.*FLAV/3.
     X2=B1/B0**2
     AS2=X1/T*(1.-X2*dLOG(T)/T)
5    AS=AS2
     F=-T+X1/AS-X2*dLOG(X1/AS+X2)
     FP=-X1/AS**2*(1.-X2/(X1/AS+X2))
     AS2=AS-F/FP
     DEL=ABS(F/FP/AS)
     IF((DEL-TOL).GT.0.) goto 5
     ALPHA=AS2
51   continue
  ENDIF
  IF(ITH.EQ.0) RETURN
  GOTO (13,14,15) ITH
  ! GOTO 5
12 ITH=1
  T=dLOG(QSCTT/AL2)
  GOTO 11
13 ALFQC4=ALPHA
  FLAV=5.   
  ITH=2
  
  GOTO 11
14 ALFQC5=ALPHA
  ITH=3
  T=TT
  GOTO 11
15 ALFQS5=ALPHA
  ALFINV=1./ALFQS5+1./ALFQC4-1./ALFQC5
  ALPHA=1./ALFINV
  RETURN
  
311 CONTINUE
  B0=11-2.*FLAV/3. 
  X1=4.*PI/B0
  IF(IORD.eq.0) then
     ALPHA=X1/T
     
  ELSE
     if(iord.gt.1) then
        alpha=qwikalf(t,iord,flav)
        goto 351
     endif
     B1=102.-38.*FLAV/3.
     X2=B1/B0**2
     AS2=X1/T*(1.-X2*dLOG(T)/T)
35   AS=AS2
     F=-T+X1/AS-X2*dLOG(X1/AS+X2)
     FP=-X1/AS**2*(1.-X2/(X1/AS+X2))
     AS2=AS-F/FP
     DEL=ABS(F/FP/AS)
     IF((DEL-TOL).GT.0.) goto 35
     ALPHA=AS2
     
351  continue
  endif
  IF(ITH.EQ.0) RETURN
  GOTO (313,314,315) ITH
312 ITH=1
  T=dLOG(QSDTT/AL2)
  GOTO 311
313 ALFQC4=ALPHA
  FLAV=3.   
  ITH=2
  GOTO 311
314 ALFQC3=ALPHA
  ITH=3
  T=TT
  GOTO 311
315 ALFQS3=ALPHA
  ALFINV=1./ALFQS3+1./ALFQC4-1./ALFQC3
  ALPHA=1./ALFINV
  RETURN
END subroutine mrslambda


double precision function qwikalf(t,iord,flav)
  implicit double precision(a-h,o-z)
  dimension z3(6),z4(6),z5(6),zz3(6),zz4(6),zz5(6)
  data z3/ -.161667E+01,0.954244E+01,0.768623E+01,0.101523E+00,-.360127E-02,0.457867E-04/
  data z4/ -.172239E+01,0.831185E+01,0.721463E+01,0.835531E-01,-.285436E-02,0.349129E-04/
  data z5/ -.872190E+00,0.572816E+01,0.716119E+01,0.195884E-01,-.300199E-03,0.151741E-05/
  data zz3/-.155611E+02,0.168406E+02,0.603014E+01,0.257682E+00,-.970217E-02,0.127628E-03/
  data zz4/-.106762E+02,0.118497E+02,0.664964E+01,0.112996E+00,-.317551E-02,0.302434E-04/
  data zz5/-.531860E+01,0.708503E+01,0.698352E+01,0.274170E-01,-.426894E-03,0.217591E-05/
  
  data pi/3.14159/
  nfm2=flav-2.
  x=dsqrt(t)
  x2=x*x
  x3=x*x2
  x4=x*x3
  x5=x*x4
  goto (1,2) iord
1 goto (3,4,5) nfm2
3 y=z3(1)+z3(2)*x+z3(3)*x2+z3(4)*x3+z3(5)*x4+z3(6)*x5
  goto 10
4 y=z4(1)+z4(2)*x+z4(3)*x2+z4(4)*x3+z4(5)*x4+z4(6)*x5
  goto 10
5 y=z5(1)+z5(2)*x+z5(3)*x2+z5(4)*x3+z5(5)*x4+z5(6)*x5
  goto 10
2 goto (6,7,8) nfm2
6 y=zz3(1)+zz3(2)*x+zz3(3)*x2+zz3(4)*x3+zz3(5)*x4+zz3(6)*x5
  goto 10
7 y=zz4(1)+zz4(2)*x+zz4(3)*x2+zz4(4)*x3+zz4(5)*x4+zz4(6)*x5
  goto 10
8 y=zz5(1)+zz5(2)*x+zz5(3)*x2+zz5(4)*x3+zz5(5)*x4+zz5(6)*x5
  goto 10
10 qwikalf=4.*pi/y
  return
end function qwikalf


!=====================================================================
! alphas routine from PDFLIB
! D OUBLE PRECISION FUNCTION ALPHAS2(SCALE,qcdl5)
subroutine aspdflib(alphas2,SCALE,iord,qcdl5)
  implicit double precision (a-h,o-z)
  double precision NF
  DATA XMC/1.43D0/,XMB/4.30D0/,XMT/100.D0/
  DATA ZEROD/0.D0/,PONED/0.001D0/,ONED/1.D0/,TWOD/2.D0/
  
  LO = 1
  if(iord.ne.0) LO = 2
  
  TMAS = 180.0d0
  
  ALPHAS2 = ZEROD
  PI=4.0D0*ATAN(ONED)
  B6  = (33.D0-2.D0*6.D0)/PI/12.D0
  BP6 = (153.D0 - 19.D0*6.D0) / PI / TWOD / (33.D0 - 2.D0*6.D0)
  B5  = (33.D0-2.D0*5.D0)/PI/12.D0
  BP5 = (153.D0 - 19.D0*5.D0) / PI / TWOD / (33.D0 - 2.D0*5.D0)
  B4  = (33.D0-2.D0*4.D0)/PI/12.D0
  BP4 = (153.D0 - 19.D0*4.D0) / PI / TWOD / (33.D0 - 2.D0*4.D0)
  B3  = (33.D0-2.D0*3.D0)/PI/12.D0
  BP3 = (153.D0 - 19.D0*3.D0) / PI / TWOD / (33.D0 - 2.D0*3.D0)
  XLC = TWOD * LOG( XMC/QCDL5)
  XLB = TWOD * LOG( XMB/QCDL5)
  XLT = TWOD * LOG( XMT/QCDL5 * TMAS/XMT)
  XLLC = LOG( XLC)
  XLLB = LOG( XLB)
  XLLT = LOG( XLT)
  C65  =  ONED/( ONED/(B5 * XLT) - XLLT*BP5/(B5 * XLT)**2 ) - &
       ONED/( ONED/(B6 * XLT) - XLLT*BP6/(B6 * XLT)**2 )
  C45  =  ONED/( ONED/(B5 * XLB) - XLLB*BP5/(B5 * XLB)**2 ) - &
       ONED/( ONED/(B4 * XLB) - XLLB*BP4/(B4 * XLB)**2 )
  C35  =  ONED/( ONED/(B4 * XLC) - XLLC*BP4/(B4 * XLC)**2 ) - &
       ONED/( ONED/(B3 * XLC) - XLLC*BP3/(B3 * XLC)**2 ) + C45
  
  Q = SCALE
  XLQ = TWOD *  LOG( Q/QCDL5 )
  XLLQ =  LOG( XLQ )
  
  ! IF  ( NF .LT. ZEROD) THEN
  IF ( Q .GT. XMT * TMAS/XMT) THEN
     NF = 6.D0
  ELSEIF  ( Q .GT. XMB ) THEN
     NF = 5.D0
  ELSEIF  ( Q .GT. XMC ) THEN
     NF = 4.D0
  ELSE
     NF = 3.D0
  ENDIF
  IF(NF .GT. 6.D0) NF = 6.D0
  IF      ( NF .EQ. 6.D0 ) THEN
     ALF = ONED/(ONED/(ONED/(B6*XLQ)- BP6/(B6*XLQ)**2*XLLQ) + C65)
     IF (LO.EQ.1) ALF = ONED/B6/XLQ
  ELSEIF  ( NF .EQ. 5.D0 ) THEN
     ALF = ONED/(B5 * XLQ) -  BP5/(B5 * XLQ)**2 * XLLQ
     IF (LO.EQ.1) ALF = ONED/B5/XLQ
  ELSEIF  ( NF .EQ. 4.D0 ) THEN
     ALF = ONED/(ONED/(ONED/(B4*XLQ)- BP4/(B4*XLQ)**2*XLLQ) + C45)
     IF (LO.EQ.1) ALF = ONED/B4/XLQ
  ELSEIF  ( NF .EQ. 3.D0 ) THEN
     ALF = ONED/(ONED/(ONED/(B3*XLQ)- BP3/(B3*XLQ)**2*XLLQ) + C35)
     IF (LO.EQ.1) ALF = ONED/B3/XLQ
  ELSE
     WRITE(*,*) 'Error in Alphas2'
     STOP
  ENDIF
  ALPHAS2 = ALF
  RETURN
END subroutine aspdflib


! ========================================================================
SUBROUTINE CtLhAlphaNewSET(MC,MB,MT,Q0,ALPHA0,IORDER,IMODE)
  ! call to set quark masses for alpha_s, and choose lambda or its 
  ! equivalent to make alpha_s take the value alpha0 at scale Q0.
  IMPLICIT NONE
  include 'parmsetup.inc'
  DOUBLE PRECISION MC, MB, MT, Q0, ALPHA0
  INTEGER IORDER, IMODE
  
  DOUBLE PRECISION UDSCBT, QQ0, AALPHA0
  INTEGER IIORDER, IIMODE
  COMMON /QMASSES/ UDSCBT(6), IIMODE, IIORDER
  COMMON /ALSCALE/ QQ0(nmxset), AALPHA0(nmxset)
  integer iset
  double precision Adummy(nmxset)
  integer Nfl(nmxset), Idummy(nmxset)
  common / QCDtable /  Adummy, Nfl, Idummy
  
  call getnset(iset)
  
  if((imode .lt. 1) .or. (imode .gt. 3)) then
     print *,'CtLhAlphaNewSET: fatal imode=',imode
     stop
  endif
  
  IIMODE = IMODE
  QQ0(iset) = Q0
  AALPHA0(iset) = ALPHA0
  IIORDER = IORDER
  
  UDSCBT(1) = .005D0
  UDSCBT(2) = .010D0
  UDSCBT(3) = .300D0
  UDSCBT(4) = MC
  UDSCBT(5) = MB
  UDSCBT(6) = MT
  
  ! set artificial quark masses, if necessary, in alpha_s to enforce 
  ! the requested maximum number of flavors...
  if(Nfl(iset) .le. 5) UDSCBT(6) = 6.d99
  if(Nfl(iset) .le. 4) UDSCBT(5) = 5.d99
  if(Nfl(iset) .le. 3) UDSCBT(4) = 4.d99
  if(Nfl(iset) .le. 2) UDSCBT(3) = 3.d99
  if(Nfl(iset) .le. 1) UDSCBT(2) = 2.d99
  if(Nfl(iset) .le. 0) UDSCBT(1) = 1.d99
  
  RETURN
END SUBROUTINE CtLhAlphaNewSET


FUNCTION CtLhAlphaNew(Q)
  IMPLICIT NONE
  DOUBLE PRECISION CtLhAlphaNew, Q
  DOUBLE PRECISION Q2, CtLhQALPHAS, UDSCBT
  integer nf,ier
  INTEGER IIMODE, IIORDER
  COMMON /QMASSES/ UDSCBT(6), IIMODE, IIORDER
  if ((iimode .ge. 1) .and. (iimode .le. 3)) then
     Q2=Q*Q
     nf=6
     if (Q2.lt. UDSCBT(6)**2) nf=5
     if (Q2.lt. UDSCBT(5)**2) nf=4
     if (Q2.lt. UDSCBT(4)**2) nf=3
     if (Q2.lt. UDSCBT(3)**2) nf=2
     if (Q2.lt. UDSCBT(2)**2) nf=1
     if (Q2.lt. UDSCBT(1)**2) nf=0
     
     ! external maximum number of flavors -- typically, nfmax=5 so 
     ! top quark is not a parton even at large Q...
     CtLhAlphaNew=CtLhQALPHAS(Q2,nf,ier)
     if(ier .ne. 0) then
        print *,'warning in CtLhAlphaNew, Q=',Q,' nf=',nf,' ier=',ier,' CtLhAlphaNew=',CtLhAlphaNew
     endif
  else
     print *,'CtLhAlphaNew: undefined mode=',iimode 
     stop
  endif
  
  return
end FUNCTION CtLhAlphaNew


FUNCTION CtLhQALPHAS(QQ2,NF,IERR)
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'parmsetup.inc' 
  COMMON /ALSCALE/ Q0(nmxset), ALPHA0(nmxset)
  COMMON /QMASSES/ UDSCBT(6), IIMODE, IIORDER
  
  call getnset(iset)
  
  Q02 = Q0(iset)**2
  ALP0 = ALPHA0(iset)
  IOR = IIORDER
  
  NFFF = NF
  CtLhQALPHAS = CtLhA0TOA1(QQ2,Q02,ALP0,IOR,NFFF,IERR)
  
  RETURN
END FUNCTION CtLhQALPHAS


FUNCTION CtLhA0TOA1(QSU,QS0,AS0,IORD,NFF,IERR)
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  COMMON /QMASSES/ UDSCBT(6), IIMODE, IIORDER
  QS1   = QSU
  QMU0  = SQRT(QS0)
  QMU1  = SQRT(QS1)
  
  ! CHECK: explicit initialisation of NF{0,1} (by AB)
  NF0 = 0
  NF1 = 0
  DO I = 1, 6
     IF(QMU0.GE.UDSCBT(I)) NF0 = I
     IF(QMU1.GE.UDSCBT(I)) NF1 = I
  ENDDO
  
  IF(NF1.LT.NF0) THEN
     IST = -1
     JST =  0
  ELSE
     IST = 1
     JST = 1
  ENDIF
  
  ALFA0 = AS0
  Q00   = QS0
  
  IERR = 0
  DO NF = NF0,NF1,IST
     IF(NF.NE.NF1) THEN
        Q21 = UDSCBT(NF+JST)**2
     ELSE
        Q21 = QS1
     ENDIF
     IMODE = IIMODE
     ALFA1 = CtLhALPHAR(Q21,Q00,ALFA0,NF,IORD,IMODE,JERR)
     IERR = IERR + JERR!IERR is sum of all errors
     ALFA0 = ALFA1
     Q00   = Q21
  END DO
  
  CtLhA0TOA1 = ALFA0
  NFF    = NF1
  
  RETURN
END FUNCTION CtLhA0TOA1


FUNCTION CtLhALPHAR(QSQ,QS0,AS0,NF,IORD,IMODE,IERR)
  ! calculate ALPHAS FROM RGE GIVEN AS0 AT QS0.
  !
  ! IORD=1: LEADING ORDER DEFINED BY 
  !                 Q*d(alpha)/d(Q) = c1*alpha**2 
  !
  ! IORD=2,IMODE=1: QCD NUM CHOICE DEFINED BY 
  !                 Q*d(alpha)/d(Q) = c1*alpha**2 + c2*alpha**3
  !
  ! IORD=2,IMODE=2: AD HOC ALTERNATIVE DEFINED BY 
  !                 Q*d(alpha)/d(Q) = c1*alpha**2 / (1 - (c2/c1)*alpha)
  !
  ! IORD=2,IMODE=3: TRADITIONAL CTEQ CHOICE DEFINED BY 
  !                 ALPHA = c3*(1 - c4*log(L)/L)/L, WHERE L=log((Q/lambda)**2)
  !
  ! c1 = -beta0/(2*pi)     where beta0 =  11. -  (2./3.)*nf
  ! c2 = -beta1/(8*pi**2)  where beta1 = 102. - (38./3.)*nf
  !
  ! c3 = -2/c1
  ! c4 = -2*c2/c1**2
  !
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  
  DATA PI / 3.14159265358979d0 /
  
  BET0 = 11.d0 -(2*NF)/3.d0
  BET1 = 102.d0 - (38*NF)/3.d0
  B0   = BET0/(4.d0*PI)
  B1   = BET1/(4.d0*PI*BET0)
  IERR = 0
  
  TERM0 = 1.d0/AS0+B0*LOG(QSQ/QS0)
  IF (TERM0.LE.0.) THEN
     CtLhALPHAR = 100.
     IERR   = 1
     PRINT *,'CtLhALPHAR WARNING: RETURN 100.'
     RETURN
  ENDIF
  ALFA0 = 1.d0/TERM0

  ! ORDER=1 IS LEADING ORDER, WHICH IS SAME FOR ALL IMODE.
  IF (IORD.EQ.1) THEN
     CtLhALPHAR = ALFA0
     RETURN
  ELSEIF(IORD.NE.2) THEN
     PRINT *,'FATAL ERROR: UNDEFINED ORDER IN CtLhALPHAR'
     STOP
  ENDIF

  
  ! QCD NUM CHOICE: Q*d(alpha)/d(Q) = c1*alpha**2 + c2*alpha**3
  IF(IMODE .EQ. 1) THEN
     
     ! use Newton's method to solve the equation, instead of the 
     ! simple iterative method used in qcdnum (jcp 9/01)
     DO ITER = 1, 20
        ARG   = (1.d0/ALFA0+B1)/(1.d0/AS0+B1)
        IF(ARG.LE.0.) THEN
           CtLhALPHAR = 10.
           IERR   = 1
           PRINT *,'CtLhALPHAR WARNING: RETURN 10.'
           RETURN
        ENDIF
        
        TERM  = TERM0 + B1*LOG(ARG) - 1.d0/ALFA0
        ALFA1 = ALFA0/(1.d0 + ALFA0*(1.d0 + B1*ALFA0)*TERM)
        
        IF(ABS(ALFA1-ALFA0).LT.1.E-12) GOTO 20
        ALFA0 = ALFA1
     ENDDO
     
     CtLhALPHAR = 10.
     IERR   = 1
     RETURN
     
20   CONTINUE
     CtLhALPHAR = ALFA1
     RETURN

     ! AD HOC ALTERNATIVE: Q*d(alpha)/d(Q) = c1*alpha**2 / (1 - (c2/c1)*alpha)
  ELSEIF(IMODE .EQ. 2) THEN
     
     ! first get a good starting point, to be sure Newton's method doesn't go 
     ! to the wrong root.
     BEST = 9.d99
     ! CHECK: adding explicit initialisation of ALBST (by AB)
     ALBST = ALFA0
     DO ITRY = 0, 20
        IF(ITRY.NE.0) ALFA0 = (1./B1)*(ITRY-0.5D0)/20.D0
        F = -1.d0/ALFA0 + TERM0 - B1*LOG(ALFA0/AS0) 
        IF(ABS(F) .LT. BEST) THEN
           BEST = ABS(F)
           ALBST = ALFA0
        ENDIF
     ENDDO
     
     ALFA0 = ALBST
     DO ITER=1, 20
        F = -1.d0/ALFA0 + TERM0 - B1*LOG(ALFA0/AS0) 
        ALFA1 = ALFA0/(1.d0 + ALFA0*F/(1.d0 - B1*ALFA0))
        IF(ABS(ALFA1-ALFA0) .LT. 1.E-12) GOTO 30
        ALFA0 = ALFA1
     ENDDO
     
     CtLhALPHAR = 10.
     IERR   = 1
     RETURN
     
30   CONTINUE
     CtLhALPHAR = ALFA1
     RETURN
     
     ! TRADITIONAL CTEQ CHOICE: ALPHA = c3*(1 - c4*log(L)/L)/L, WHERE L=log((Q/lambda)**2)
  ELSEIF(IMODE .EQ. 3) THEN
     
     Z = -LOG(B0*AS0)
     TMP = BET1/BET0**2
     
     DO ITER = 1, 20
        F = EXP(Z) - (1.D0 - TMP*Z*EXP(-Z))/(B0*AS0)
        FPRI = EXP(Z)  + TMP*(1.D0-Z)*EXP(-Z)/(B0*AS0)
        ZNEW = Z - F/FPRI
        IF(ABS(Z-ZNEW) .LT. 1.E-10) GOTO 40
        Z = ZNEW
     ENDDO
     
     CtLhALPHAR = 10.
     IERR   = 1
     RETURN
     
40   CONTINUE
     XLAMSQ = QS0 * EXP(-EXP(ZNEW))
     
     XL = LOG(QSQ/XLAMSQ)
     
     ! return a fixed value if no solution...
     IF (XL .LE. 0.D0) THEN
        CtLhALPHAR = 10.D0
        IERR = 1
        RETURN
     ENDIF
     
     CtLhALPHAR = (1.d0 - TMP*LOG(XL)/XL)/(B0*XL)
     
     ! place a cutoff if comes out very large...
     if (CtLhALPHAR .gt. 10.d0) then
        CtLhALPHAR = 10.d0
        IERR = 1
     endif
     
     RETURN
     
  ELSE
     PRINT *,'FATAL UNDEFINED IMODE=',IMODE
     STOP
  ENDIF
  
  RETURN
END FUNCTION CtLhALPHAR


FUNCTION CtLhALPInew (AMU)
  ! Returns effective g**2/(4pi**2) = alpha/pi.
  IMPLICIT DOUBLE PRECISION (A-H, O-Z)
  data pi / 3.14159265358979d0 /
  q = amu
  alpha = CtLhAlphaNew(q)
  CtLhalpinew = alpha/pi
  RETURN
END FUNCTION CtLhALPInew


subroutine CTEQ6NewAlpha(nset,mem)
  IMPLICIT DOUBLE PRECISION (A-H, O-Z)
  include 'parmsetup.inc'
  common / QCDtable /  Alambda(nmxset), Nfl(nmxset), Iorder(nmxset)
  dimension parms(2)
  q0 = 91.188d0
  call listPDF(nset,mem,parms)
  alpha0 = parms(1)
  ximode = parms(2)
  imode = int(ximode)
  iiorder = iorder(nset)
  
  ! **********************************************************
  ! the input data file should probably specify a very large 
  ! value for xmt, because we never allow top quark as a parton
  ! in the PDF fitting, so there are never more than 5 active 
  ! flavors.  Presume it is most consistent therefore to 
  ! also keep top quark loop out of running of alpha.
  ! **********************************************************
  
  call GetQmassM(nset,4,cmass)
  call GetQmassM(nset,5,bmass)
  call GetQmassM(nset,6,tmass)
  call CtLhAlphaNewSET(cmass,bmass,tmass,Q0,ALPHA0,IIORDER,IMODE)
  RETURN
END subroutine CTEQ6NewAlpha


subroutine getnset(nset)
  integer iset,nset
  save iset
  nset = iset      
  return
  
  entry setnset(nset)
  iset = nset
  return      
end subroutine getnset


subroutine getnmem(nset,nmem)
  include 'parmsetup.inc'
  integer nmem,nset,member(nmxset)
  save member
  nmem = member(nset)      
  return
  
  entry setnmem(nset,nmem)
  member(nset) = nmem
  return      
end subroutine getnmem


subroutine alphacteq5f34(nflav,alphas,q)
  IMPLICIT DOUBLE PRECISION (A-H, O-Z)
  parameter(pi=3.14159265358979323846d0)
  
  alphas = pi*CtLhALPI34(nflav,q)
  return
end subroutine alphacteq5f34


FUNCTION CtLhALPI34 (nflav,AMU)
  IMPLICIT DOUBLE PRECISION (A-H, O-Z)
  COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ
  COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET
  LOGICAL SET
  PARAMETER (D0 = 0.D0, D1 = 1.D0, BIG = 1.0D15)
  DATA IW1, IW2 / 2*0 /
  IF(.NOT.SET) CALL CtLhLAMCWZ
  NEFF = LhCtNFL(AMU)
  
  if(neff.gt.nflav) neff=nflav
  
  ALM  = ALAM(NEFF)
  if(neff.eq.3) alm = 0.395
  if(neff.eq.4) alm = 0.309
  CtLhALPI34 = CtLhALPQCD (NORDER, NEFF, AMU/ALM, IRT)
  IF (IRT .EQ. 1) THEN
     CALL CtLhWARNR (IW1, 'AMU < ALAM in CtLhALPI34', 'AMU', AMU,ALM, BIG, 1)
  ELSEIF (IRT .EQ. 2) THEN
     CALL CtLhWARNR(IW2,'CtLhALPI34 > 3; Be aware!','CtLhALPI34',CtLhALPI34, D0, D1, 0)
  ENDIF
  RETURN
END FUNCTION CtLhALPI34

subroutine alphacteq4(alphas,q)
  IMPLICIT DOUBLE PRECISION (A-H, O-Z)
  parameter(pi=3.14159265358979323846d0)
  
  alphas = pi*CtLhALPI4(q)
  return
end subroutine alphacteq4

FUNCTION CtLhALPI4 (AMU)
  IMPLICIT DOUBLE PRECISION (A-H, O-Z)
  COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ
  COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET
  LOGICAL SET
  PARAMETER (D0 = 0.D0, D1 = 1.D0, BIG = 1.0D15)
  DATA IW1, IW2 / 2*0 /
  IF(.NOT.SET) CALL CtLhLAMCWZ
  NEFF = LhCtNFL(AMU)
  
!  ALM  = ALAM(NEFF)
  call getnset(nset)
  call getnmem(nset,nmem)
  call getLam5M(nset,nmem,alm)
  call getOrderPDFM(nset,norderm)
  norderm=norderm+1
  CtLhALPI4 = CtLhALPQCD (NORDERM, NEFF, AMU/ALM, IRT)
  IF (IRT .EQ. 1) THEN
     CALL CtLhWARNR (IW1, 'AMU < ALAM in CtLhALPI4', 'AMU', AMU,ALM, BIG, 1)
  ELSEIF (IRT .EQ. 2) THEN
     CALL CtLhWARNR(IW2,'CtLhALPI34 > 3; Be aware!','CtLhALPI4',CtLhALPI4, D0, D1, 0)
  ENDIF
  RETURN
END FUNCTION CtLhALPI4


function CtLhalgluino(Q)
  !     51  mg=50  GeV  WITH TOP MASS OF 174
  !     52  mg=15  GeV  
  !     53  mg=25  GeV  
  !     54  mg=35  GeV  
  !     55  mg=50  GeV  
  !     56  mg=90  GeV  
  !     57  mg=100  GeV  
  !     58  mg=200  GeV  
  !     59  mg=inf  GeV  

  IMPLICIT DOUBLE PRECISION (A-H, O-Z)
  Parameter (nsets=8)
  Dimension xmass(6), gArray(nsets), nfArray(nsets)
  Dimension xlamStrange(nsets),xlamCharm(nsets),xlamBottom(nsets),xlamGluino(nsets),xlamTop(nsets)
  data iorder /2/
  Data xmass / 0.0, 0.0, 0.5d0, 1.3d0, 4.5d0, 174.0d0/
  Data gArray / 15.0d0, 25.0d0, 35.0d0, 50.0d0, 90.0d0, 100.0d0, 200.0d0, 1.0d99/  !*** Last value = Infinity
  Data  xlamStrange /  0.240257, 0.272782, 0.296194, 0.322873,  0.371374,  0.372537, 0.372537, 0.372537/
  Data  xlamCharm   /  0.197153, 0.227834, 0.250338, 0.276386, 0.324772, 0.325947, 0.325947, 0.325947/
  Data  xlamBottom  /  0.128981, 0.151553, 0.168364, 0.188074,  0.225349, 0.226264, 0.226264, 0.226264/
  Data  xlamGluino  / 0.005,  0.005,  0.005,  0.005,  0.005, 0.00480354,  0.00355387,  0.0/
  
  Data  xlamTop     /  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/
  Data nfArray /5,5,5,5,5,5,5,5/ 
  
  ! 3456789012345678901234567890123456789012345678901234567890123456789012
  
  zmass=91.2
  
  pi=4.0d0*atan(1.0d0)
  
  call getnset(iset)
  call getnmem(iset,imem)
  
  nfMax=nfArray(imem)
  nf=3
  if(Q.ge.xmass(4))  nf=4
  if(Q.ge.xmass(5))  nf=5
  if(Q.ge.xmass(6))  nf=6  !*** Top for Iset=51 only
  if(nf.gt.nfMax) nf=nfMax
  
  gmass=gArray(imem+1)
  ng=0
  if(Q.ge.gmass) ng=1
  
  xlam = xlamStrange(imem+1)
  if(Q.ge.xmass(4))  xlam = xlamCharm(imem+1)
  if(Q.ge.xmass(5))  xlam = xlamBottom(imem+1)
  if(Q.ge.gmass   )  xlam = xlamGluino(imem+1)
  
  if((Q.ge.xmass(6)).and.(nfMax.ge.6))  xlam = xlamTop(imem+1)
  
  nsquark=0
  b0=11. - 2./3.*nf - 2.*ng- 1./6.*nsquark
  b1=102.-38./3.*nf-48.*ng-11./3.*nsquark+13./3.*ng*nsquark
  if(iorder.eq.1) b1=0
  
  xlog=Log(Q**2/xlam**2)
  
  tmp= 4.*pi*( 1./(b0*xlog) - b1*Log(xlog)/(b0**3*xlog**2))
  
  CtLhalgluino=tmp
  Return
End function CtLhalgluino

! -*- F90 -*-


      subroutine MRSTqedevolve(x,Q,pdf,photon)
      implicit real*8(a-h,o-z)
      include 'parmsetup.inc'
      character*16 name(nmxset)
      character*80 line
      character*512 setpath
      integer nmem(nmxset),ndef(nmxset),mmem
!      integer member(nmxset)
      integer nset,iset
      common/NAME/name,nmem,ndef,mmem
      parameter(nx=49,nq=37,np=9,nqc0=2,nqb0=11,nqc=35,nqb=26,          &
     &nhess=0)
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      real*8 pdf(-6:6),photon,phot
      real*8 f1(nx,nq)                                                  &
     &,f2(nx,nq)                                                        &
     &,f3(nx,nq)                                                        &
     &,f4(nx,nq)                                                        &
     &,f5(nx,nq)                                                        &
     &,f6(nx,nq)                                                        &
     &,f7(nx,nq)                                                        &
     &,f8(nx,nq)                                                        &
     &,f9(nx,nq)                                                        &
     &,fc(nx,nqc),fb(nx,nqb)
      real*8 qq(nq),xx(nx),                                             &
     &cc1(0:nhess,nx,nq,4,4,nmxset),cc2(0:nhess,nx,nq,4,4,nmxset),      &
     &cc3(0:nhess,nx,nq,4,4,nmxset),cc4(0:nhess,nx,nq,4,4,nmxset),      &
     &cc6(0:nhess,nx,nq,4,4,nmxset),cc8(0:nhess,nx,nq,4,4,nmxset),      &
     &cc9(0:nhess,nx,nq,4,4,nmxset),                                    &
     &ccc(0:nhess,nx,nqc,4,4,nmxset),ccb(0:nhess,nx,nqb,4,4,nmxset)
      real*8 xxl(nx),qql(nq),qqlc(nqc),qqlb(nqb)
      data xx/1d-5,2d-5,4d-5,6d-5,8d-5,                                 &
     &              1d-4,2d-4,4d-4,6d-4,8d-4,                           &
     &              1d-3,2d-3,4d-3,6d-3,8d-3,                           &
     &              1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2,               &
     &           .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0,     &
     &           .3d0,.325d0,.35d0,.375d0,.4d0,.425d0,.45d0,.475d0,     &
     &           .5d0,.525d0,.55d0,.575d0,.6d0,.65d0,.7d0,.75d0,        &
     &           .8d0,.9d0,1d0/
      data qq/1.25d0,1.5d0,2d0,2.5d0,3.2d0,4d0,5d0,6.4d0,8d0,1d1,       &
     &        1.2d1,1.8d1,2.6d1,4d1,6.4d1,1d2,                          &
     &        1.6d2,2.4d2,4d2,6.4d2,1d3,1.8d3,3.2d3,5.6d3,1d4,          &
     &        1.8d4,3.2d4,5.6d4,1d5,1.8d5,3.2d5,5.6d5,1d6,              &
     &        1.8d6,3.2d6,5.6d6,1d7/
      data xmin,xmax,qsqmin,qsqmax/1d-5,1d0,1.25d0,1d7/
      save

      xsave=x
      qsq = q*q
      q2save=qsq

      xlog=dlog(x)
      qsqlog=dlog(qsq)

      call getnset(iset)
!      imem=member(iset)
      call getnmem(iset,imem)
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,cc1(0,1,1,1,1,iset),upv)
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,cc2(0,1,1,1,1,iset),dnv)
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,cc3(0,1,1,1,1,iset),glu)
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,cc4(0,1,1,1,1,iset),usea)
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,cc6(0,1,1,1,1,iset),str)
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,cc8(0,1,1,1,1,iset),dsea)
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,cc9(0,1,1,1,1,iset),photon)

      chm=0.d0
      if(qsq.gt.emc2) then
      call jeppe2(0,xlog,qsqlog,nx,nqc,xxl,qqlc,ccc(0,1,1,1,1,iset),chm)
      endif

      bot=0.d0
      if(qsq.gt.emb2) then
      call jeppe2(0,xlog,qsqlog,nx,nqb,xxl,qqlb,ccb(0,1,1,1,1,iset),bot)
      endif

      pdf(0)  = glu
      pdf(1)  = dnv+dsea
      pdf(-1) = dsea
      pdf(2)  = upv+usea
      pdf(-2) = usea
      pdf(3)  = str
      pdf(-3) = str
      pdf(4)  = chm
      pdf(-4) = chm
      pdf(5)  = bot
      pdf(-5) = bot
      pdf(6) = 0.0d0
      pdf(-6) = 0.0d0

      x=xsave
      qsq=q2save
      return
 
      entry MRSTqedgetgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=1,nx
          gridx(jx)=xx(jx)
      enddo
      do jq=1,nq
          gridq(jq)=qq(jq)
      enddo
      ngridx=nx
      ngridq=nq        
      return
!
      entry MRSTqedread(nset)
! - dummy read in to get to End: (stream 1 is still open)
      read(1,*)nmem(nset),ndef(nset)

      do i=0,nmem(nset)
        do n=1,nx-1
          do m=1,nq
            read(1,'(a)'),line
          enddo
        enddo
      enddo

      do n=1,nx
      xxl(n)=dlog(xx(n))
      enddo
      do m=1,nq
      qql(m)=dlog(qq(m))
      enddo

      return
!
      entry MRSTqedpdf(mem)
        call getnset(iset)
        call setnmem(iset,mem)

! have to reopen stream 1
        call getsetpath(setpath)
        open(1,file=setpath(1:len_trim(setpath)),action='READ')
        line = ''
        do while (line(2:11).ne.'Evolution:')
           read(1,'(a)'),line
        enddo
        read(1,'(a)'),line
        read(1,'(a)'),line

        read(1,*)nmem(iset),ndef(iset)

! - dummy read up to the member requested
      do i=0,mem-1
        do n=1,nx-1
          do m=1,nq
            read(1,'(a)')line
          enddo
        enddo
      enddo


!- read in the data of the requested member
        do 20 n=1,nx-1
        do 20 m=1,nq
        read(1,50)f1(n,m),f2(n,m),f3(n,m),f4(n,m),                      &
     &                  f5(n,m),f7(n,m),f6(n,m),f8(n,m),f9(n,m)
! notation: 1=uval 2=val 3=glue 4=usea 5=chm 6=str 7=btm 8=dsea 9-photon
   20 continue
!      write(*,*)'PDF set ',nm,' first element ',f1(1,1)

      do 40 m=1,nq
      f1(nx,m)=0.d0
      f2(nx,m)=0.d0
      f3(nx,m)=0.d0
      f4(nx,m)=0.d0
      f5(nx,m)=0.d0
      f6(nx,m)=0.d0
      f7(nx,m)=0.d0
      f8(nx,m)=0.d0
      f9(nx,m)=0.d0
   40 continue

      call jeppe1(0,nx,nq,xxl,qql,f1,cc1(0,1,1,1,1,iset))
      call jeppe1(0,nx,nq,xxl,qql,f2,cc2(0,1,1,1,1,iset))
      call jeppe1(0,nx,nq,xxl,qql,f3,cc3(0,1,1,1,1,iset))
      call jeppe1(0,nx,nq,xxl,qql,f4,cc4(0,1,1,1,1,iset))
      call jeppe1(0,nx,nq,xxl,qql,f6,cc6(0,1,1,1,1,iset))
      call jeppe1(0,nx,nq,xxl,qql,f8,cc8(0,1,1,1,1,iset))
      call jeppe1(0,nx,nq,xxl,qql,f9,cc9(0,1,1,1,1,iset))

      emc2=2.045
      emb2=18.5

      do 44 m=1,nqc
      qqlc(m)=qql(m+nqc0)
      do 44 n=1,nx
      fc(n,m)=f5(n,m+nqc0)
   44 continue
      qqlc(1)=dlog(emc2)
      call jeppe1(0,nx,nqc,xxl,qqlc,fc,ccc(0,1,1,1,1,iset))

      do 45 m=1,nqb
      qqlb(m)=qql(m+nqb0)
      do 45 n=1,nx
      fb(n,m)=f7(n,m+nqb0)
   45 continue
      qqlb(1)=dlog(emb2)
      call jeppe1(0,nx,nqb,xxl,qqlb,fb,ccb(0,1,1,1,1,iset))

      close(1)
   50 format(9f10.5)


      return
!
      entry MRSTqedalfa(nflav,alfas,Qalfa)
        call getnset(iset)
        call alphamrs(nflav,alfas,Qalfa)
      return
!
      entry MRSTqedinit(Eorder,Q2fit)
      return
!
      END

! -*- F90 -*-


      subroutine A02Mevolve(xb,Q,fset) 
      implicit none 
      include 'parmsetup.inc' 
      integer npdf,npar,kschem,i,k,n,m,kx,nxbb 
      integer nxb,nq,np,nvar,pdfmem,imem,nvar2
!      parameter(nxb=99,nq=20,np=9,nvar=17) 
      parameter(nxb=99,nq=20,np=9,nvar=0,nvar2=17) 
      integer nexp(0:np) 
      data nexp / 0, 3, 4, 5, 5, 5, 5, 5, 5, 5 / 
      character*16 name(nmxset) 
      character*80 line 
      character*512 setpath 
      integer nmem(nmxset),ndef(nmxset),mem 
      common/NAME/name,nmem,ndef,mem 
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
!      integer iset,iimem                                               
!      common/SET/iset,iimem                                            
      integer nset,iset,ii 
      real*8 f(0:nvar,nxb,nq+1,0:np),xx(nxb) 
      real*8 fsp(nxb),bs(nxb),cs(nxb),ds(nxb) 
      real*8 bsp(0:nvar,nxb,nq+1,0:np),csp(0:nvar,nxb,nq+1,0:np)        &
     &      ,dsp(0:nvar,nxb,nq+1,0:np)                                  
      real*8 x1,xd,del,dels,delx,delx1,xlog1 
      real*8 pdfs(0:np),fset(-6:6),alfas 
      real*8 x,Q,xb,q2,xmin,xmax,qsq,qsqmin,qsqmax,b,ss 
      real*8 aa,f0,fp,fm 
      data xmin,xmax,qsqmin,qsqmax/1d-7,1d0,0.8d0,2d8/ 
                                                                        
      save f,npdf,npar,pdfmem,dels,delx,x1,delx1,xlog1,nxbb,xx          &
     &,fsp,bsp,csp,dsp                                                  
!      save                                                             
                                                                        
      q2=Q*Q 
      if(q2.lt.qsqmin.or.q2.gt.qsqmax) print 99,q2 
      if(xb.lt.xmin.or.xb.gt.xmax)       print 98,x 
   99 format('  WARNING:  Q^2 VALUE IS OUT OF RANGE   ') 
   98 format('  WARNING:   X  VALUE IS OUT OF RANGE   ') 
                                                                        
      x=max(xb,xmin) 
      x=min(x,xmax) 
      qsq=max(q2,qsqmin) 
      qsq=min(qsq,qsqmax) 
                                                                        
      if (x.gt.x1) then 
        xd=(1d0-x1)**2-(1d0-x)**2 
        n=int(xd/delx1)+nxbb 
      else 
        xd=dlog(x)-xlog1 
        n=nxbb+int(xd/DELX)-1 
      end if 
      aa=x-xx(n) 
                                                                        
      ss=dlog(dlog(qsq/0.04d0))-dlog(dlog(qsqmin/0.04d0)) 
      m=int(ss/dels)+1 
      b=ss/dels-dble(m)+1.d0 
                                                                        
!      k=pdfmem 
      k=0 
                                                                        
      do i=0,npdf 
        f0=f(k,n,m,i) + aa*bsp(k,n,m,i) + aa**2*csp(k,n,m,i)            &
     &              + aa**3*dsp(k,n,m,i)                                
        fp=f(k,n,m+1,i) + aa*bsp(k,n,m+1,i) + aa**2*csp(k,n,m+1,i)      &
     &                + aa**3*dsp(k,n,m+1,i)                            
        if (m.ge.2) then 
          fm=f(k,n,m-1,i) + aa*bsp(k,n,m-1,i) + aa**2*csp(k,n,m-1,i)    &
     &                   +aa**3*dsp(k,n,m-1,i)                          
          pdfs(i)=fm*b*(b-1d0)/2d0 + f0*(1d0-b**2) + fp*b*(b+1d0)/2d0 
        else 
          pdfs(i)= f0*(1d0-b) + fp*b 
        end if 
        pdfs(i) = pdfs(i)*(1d0-x)**dble(nexp(i)) 
      end do 
                                                                        
      fset(-6)=pdfs(9) 
      fset(-5)=pdfs(8) 
      fset(-4)=pdfs(7) 
      fset(-3)=pdfs(5) 
!--reversed mrs 7/7/04 due                                              
      fset(-1)=pdfs(6) 
      fset(-2)=pdfs(4) 
      fset(0)=pdfs(3) 
!--reversed mrs 7/7/04 due                                              
      fset(2)=pdfs(1)+pdfs(4) 
      fset(1)=pdfs(2)+pdfs(6) 
      fset(3)=pdfs(5) 
      fset(4)=pdfs(7) 
      fset(5)=pdfs(8) 
      fset(6)=pdfs(9) 
      return 
!                                                                       
      entry A02Malfa(alfas,Q) 
      q2=Q*Q 
      if(q2.lt.qsqmin.or.q2.gt.qsqmax) print 99,q2 
      qsq=max(q2,qsqmin) 
      qsq=min(qsq,qsqmax) 
                                                                        
      ss=log(log(qsq/0.04))-log(log(qsqmin/0.04)) 
      m=int(ss/dels)+1 
      b=ss/dels-m+1 
                                                                        
      k=pdfmem 
      alfas=(1d0-b)*f(0,1,m,0)+b*f(0,1,m+1,0) 
      return 
!                                                                                                                                              
      entry A02Mgetgrid(nset,ngridx,ngridq,gridx,gridq)
     
      ngridx=nxb
      do jx=1,nxb
          gridx(jx)=xx(jx)
      enddo

      ngridq=nq
      do jq=1,ngridq
          gridq(jq)= 0.04*exp(exp( &
     & log(log(qsqmin/0.04))+(float(jq-1)/19)*( log(log(qsqmax/0.04))-log(log(qsqmin/0.04)) ) & 
     & ))
      enddo 
       
      return
      entry A02Mread(nset) 
! following fix because members are 0-nvar                              
!      nmem = nvar + 1                                                  
                                                                        
      nmem(nset) = nvar2 
      ndef(nset) = 0 
! - dummy read in to get to End: (stream 1 is still open)               
      read(1,*) npdf 
      npar=nvar2 
      do k=0,npar 
         do n=1,nxb-1 
            do m=1,nq 
               read(1,*) (f(k,n,m,i),i=0,npdf) 
            enddo 
         enddo 
      enddo 
                                                                                                                                                
      return 
!                                                                       
      entry A02Minit 
                                                                        
      dels=(dlog(dlog(qsqmax/0.04d0))-                                  &
     &      dlog(dlog(qsqmin/0.04d0)))/dble(nq-1)                       
                                                                        
                                                                        
      return 
!                                                                       
      entry A02Mpdf(imem) 
      pdfmem=imem 
      if ((pdfmem.lt.0).or.(pdfmem.gt.npar)) then 
         write(*,*) 'A02M PDF set:' 
         write(*,*) 'PDF member out of range:' 
         write(*,*) 'member = ',pdfmem,'    member range = (0,',npar,')' 
         stop 
      endif 
 
      call getnset(iset)
      nmem(iset) = nvar2 
      ndef(iset) = 0 
      
! have to reopen stream 1                                               
      call getsetpath(setpath) 
      open(1,file=setpath(1:len_trim(setpath)),action='READ') 
      line = '' 
      do while (line(2:11).ne.'Evolution:') 
         read(1,'(a)') line 
      enddo 
      read(1,'(a)'),line 
      read(1,'(a)'),line 
                                                                        
                                                                        
      read(1,*) npdf 
!      print *,'number of members',npdf                                 
      npar=nvar2 
      do k=0,imem-1 
         do n=1,nxb-1 
            do m=1,nq 
               read(1,*) (f(0,n,m,i),i=0,npdf) 
            enddo 
         enddo 
      enddo 

      do n=1,nxb-1 
         do m=1,nq 
            read(1,*) (f(0,n,m,i),i=0,npdf) 
         enddo 
      enddo 

                                                                        
      nxbb=nxb/2 
      x1=0.3d0 
      xlog1=dlog(x1) 
      delx=(dlog(x1)-dlog(xmin))/dble(nxbb-1) 
      DELX1=(1.d0-x1)**2/dble(nxbb+1) 
                                                                        
!...X GRID                                                              
      do kx=1,nxbb 
        xx(kx)=dexp(dlog(xmin)+delx*dble(kx-1)) 
      end do 
      do kx=nxbb+1,nxb-1 
        xx(kx)=1.d0-dsqrt(dabs((1.d0-x1)**2-delx1*dble(kx-nxbb))) 
      end do 
      xx(nxb)=1d0 
                                                                        
      do i=0,npdf 
        do m=1,nq 
          if (i.ne.0) then 
            f(0,nxb,m,i)=0d0 
          else 
            f(0,nxb,m,i)=f(0,nxb-1,m,i) 
          end if 
          do n=1,nxb-1 
            f(0,n,m,i)=f(0,n,m,i)/(1d0-xx(n))**nexp(i) 
          end do 
          do n=1,nxb 
            fsp(n)=f(0,n,m,i) 
          end do 
          call a02mspline (nxb,xx,fsp,bs,cs,ds) 
          do n=1,nxb 
            bsp(0,n,m,i)=bs(n) 
            csp(0,n,m,i)=cs(n) 
            dsp(0,n,m,i)=ds(n) 
          end do 
        end do 
      end do 
      close(1)
      return 

      END                                           
                                                                        
! --------------------------------------------------------------------- 
      SUBROUTINE A02MSPLINE(N,X,Y,B,C,D) 
! --------------------------------------------------------------------- 
! CALCULATE THE COEFFICIENTS B,C,D IN A CUBIC SPLINE INTERPOLATION.     
! INTERPOLATION SUBROUTINES ARE TAKEN FROM                              
! G.E. FORSYTHE, M.A. MALCOLM AND C.B. MOLER,                           
! COMPUTER METHODS FOR MATHEMATICAL COMPUTATIONS (PRENTICE-HALL, 1977). 
!                                                                       
      IMPLICIT REAL*8(A-H,O-Z) 
                                                                        
      DIMENSION X(N), Y(N), B(N), C(N), D(N) 
!                                                                       
      NM1=N-1 
      IF(N.LT.2) RETURN 
      IF(N.LT.3) GOTO 250 
      D(1)=X(2)-X(1) 
      C(2)=(Y(2)-Y(1))/D(1) 
      DO 210 K=2,NM1 
         D(K)=X(K+1)-X(K) 
         B(K)=2.0D0*(D(K-1)+D(K)) 
         C(K+1)=(Y(K+1)-Y(K))/D(K) 
         C(K)=C(K+1)-C(K) 
  210 END DO 
      B(1)=-D(1) 
      B(N)=-D(N-1) 
      C(1)=0.0D0 
      C(N)=0.0D0 
      IF(N.EQ.3) GOTO 215 
      C(1)=C(3)/(X(4)-X(2))-C(2)/(X(3)-X(1)) 
      C(N)=C(N-1)/(X(N)-X(N-2))-C(N-2)/(X(N-1)-X(N-3)) 
      C(1)=C(1)*D(1)**2.0D0/(X(4)-X(1)) 
      C(N)=-C(N)*D(N-1)**2.0D0/(X(N)-X(N-3)) 
  215 CONTINUE 
      DO 220 K=2,N 
         T=D(K-1)/B(K-1) 
         B(K)=B(K)-T*D(K-1) 
         C(K)=C(K)-T*C(K-1) 
  220 END DO 
      C(N)=C(N)/B(N) 
      DO 230 IB=1,NM1 
         K=N-IB 
         C(K)=(C(K)-D(K)*C(K+1))/B(K) 
  230 END DO 
      B(N)=(Y(N)-Y(NM1))/D(NM1)                                         &
     &     +D(NM1)*(C(NM1)+2.0D0*C(N))                                  
      DO 240 K=1,NM1 
         B(K)=(Y(K+1)-Y(K))/D(K)                                        &
     &        -D(K)*(C(K+1)+2.0D0*C(K))                                 
         D(K)=(C(K+1)-C(K))/D(K) 
         C(K)=3.0D0*C(K) 
  240 END DO 
      C(N)=3.0D0*C(N) 
      D(N)=D(N-1) 
      RETURN 
  250 CONTINUE 
      B(1)=(Y(2)-Y(1))/(X(2)-X(1)) 
      C(1)=0.0D0 
      D(1)=0.0D0 
      B(2)=B(1) 
      C(2)=0.0D0 
      D(2)=0.0D0 
      RETURN 
      END                                           

! -*- F90 -*-


      subroutine SMRSPevolve(xin,qin,pdf) 
      include 'parmsetup.inc' 
      PARAMETER(NX=50) 
      PARAMETER(NQ=19) 
      real*8 xin,qin,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      real*8 SIG,QNS,GL 
      real*8 holdit 
      real*8 f 
      common /SMRSP/ F(7,NX,NQ,3) 
      character*16 name(nmxset) 
      character*1 dummy 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
      integer initread/0/ 
      save 
                                                                        
      call getnset(iset) 
      call getnmem(iset,imem) 
                                                                        
      iimem = imem 
      if(iimem.eq.0) iimem = 2 
      if(iimem.le.3) then 
       call SMRSPxx(iimem,xin,qin,upv,dnv,usea,str,chm,bot,glu) 
      endif 
                                                                        
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv+usea 
      pdf(-1)= usea 
      pdf(1 )= dnv+usea 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SMRSPread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
      do j=1,3 
      do k=1,NX 
      do l=1,NQ 
      if(initread.eq.0) then 
        read(1,*)(F(m,k,l,j),m=1,5),F(7,k,l,j),F(6,k,l,j) 
      else 
        read(1,'(a1)')dummy 
      endif 
      enddo 
      enddo 
      enddo 
      initread=1 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SMRSPalfa(alfas,qalfa) 
        call getnset(iset) 
        call getnmem(iset,imem) 
        call GetOrderAsM(iset,iord) 
        call Getlam4M(iset,imem,qcdl4) 
        call Getlam5M(iset,imem,qcdl5) 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SMRSPinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry SMRSPpdf(mem) 
!      imem = mem                                                       
      call getnset(iset) 
      call setnmem(iset,mem) 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!                                                                       
      SUBROUTINE SMRSPxx(iset,X,SCALE,UPV,DNV,SEA,STR,CHM,BOT,GLU) 
!                                                                       
! ::::::::::::  PION STRUCTURE FUNCTION :: 10% SEA :::::::::::::::::    
!                                                                       
      implicit real*8 (a-h,o-z) 
      PARAMETER(NX=50) 
      PARAMETER(NQ=19) 
      PARAMETER(NTENTH=21) 
      common /SMRSP/ F(7,NX,NQ,3) 
      DIMENSION G(7),XX(NX),N0(7),XX0(NX) 
!      DIMENSION F(7,NX,NQ),G(7),XX(NX),N0(7)                           
      DATA XX/1.D-5,2.D-5,4.D-5,6.D-5,8.D-5,                            &
     &        1.D-4,2.D-4,4.D-4,6.D-4,8.D-4,                            &
     &        1.D-3,2.D-3,4.D-3,6.D-3,8.D-3,                            &
     &        1.D-2,2.D-2,4.D-2,6.D-2,8.D-2,                            &
     &     .1D0,.125D0,.15D0,.175D0,.2D0,.225D0,.25D0,.275D0,           &
     &     .3D0,.325D0,.35D0,.375D0,.4D0,.425D0,.45D0,.475D0,           &
     &     .5D0,.525D0,.55D0,.575D0,.6D0,.65D0,.7D0,.75D0,              &
     &     .8D0,.85D0,.9D0,.95D0,.975D0,1.D0/                           
      DATA XMIN,XMAX,QSQMIN,QSQMAX/1.D-5,1.D0,5.D0,1310720.D0/ 
      DATA N0/0,0,3,5,0,5,0/ 
      DATA ZEROD/0.D0/,PONED/0.1D0/,ONED/1.D0/,ONEDO/1.1D0/,TWOD/2.D0/ 
      DATA INIT/0/ 
      save 
      XSAVE=X 
      IF(INIT.NE.0) GOTO 10 
      INIT=1 
      do n=1,nx 
        xx0(n)=xx(n) 
      enddo 
      do jset=1,3 
      DO 20 N=1,NX-1 
      DO 20 M=1,NQ 
         DO 25 I=1,7 
   25    F(I,N,M,jset)=F(I,N,M,jset)/(ONED-XX0(N))**N0(I) 
   20 CONTINUE 
      DO 30 J=1,NTENTH-1 
      if(jset.eq.1) XX(J)= LOG10(XX(J))+ONEDO 
      DO 30 I=2,6 
      DO 30 K=1,NQ 
   30 F(I,J,K,jset)= LOG(F(I,J,K,jset))                                 &
     &              *F(I,NTENTH,K,jset)/ LOG(F(I,NTENTH,K,jset))        
   50 FORMAT(7F10.5) 
      DO 40 I=1,7 
      DO 40 M=1,NQ 
   40 F(I,NX,M,jset)=ZEROD 
      enddo 
   10 CONTINUE 
!      IF(X.LT.XMIN) X=XMIN                                             
!      IF(X.GT.XMAX) X=XMAX                                             
      QSQ=SCALE**2 
!      IF(QSQ.LT.QSQMIN) QSQ=QSQMIN                                     
!      IF(QSQ.GT.QSQMAX) QSQ=QSQMAX                                     
      XXX=X 
      IF(X.LT.PONED) XXX= LOG10(X)+ONEDO 
      N=0 
   70 N=N+1 
      IF(XXX.GT.XX(N+1)) GOTO 70 
      A=(XXX-XX(N))/(XX(N+1)-XX(N)) 
      RM= LOG(QSQ/QSQMIN)/ LOG(TWOD) 
      B=RM-AINT(RM) 
      M=1+  INT(RM) 
      DO 60 I=1,7 
      G(I)= (ONED-A)*(ONED-B)*F(I,N,M,iset)+(ONED-A)*B*F(I,N,M+1,iset)  &
     &    + A*(ONED-B)*F(I,N+1,M,iset)  + A*B*F(I,N+1,M+1,iset)         
      IF(N.GE.NTENTH) GOTO 65 
      IF(I.EQ.7.OR.I.EQ.1) GOTO 65 
          FAC=(ONED-B)*F(I,NTENTH,M,iset)+B*F(I,NTENTH,M+1,iset) 
          G(I)=FAC**(G(I)/FAC) 
   65 CONTINUE 
      G(I)=G(I)*(ONED-X)**N0(I) 
   60 END DO 
! UPBAR DISTRIBUTION = D DISTRIBUTION                                   
      UPV=G(2) 
      DNV=G(2) 
! THIS SEA IS (UBAR+DBAR)/2                                             
      SEA=G(4) 
      STR=G(6) 
      CHM=G(5) 
      GLU=G(3) 
      BOT=G(7) 
      X=XSAVE 
      RETURN 
      END                                           

!********************************************************
!
!     wrapNNPDF.f: 
!     Routine called by LHAPDF package for the evolved PDF
!     in a (x,Q) point as called by NNPDF.LHpdf file.
!         
!     In 'wrapevolve.f' the package calls:
!     IF(NAME(NSET).EQ.'NNPDF') call NNPDFevolve(x,Q,f)
!     IF(NAME(NSET).EQ.'NNPDF') call NNPDFread(nset)
!     IF(NAME(NSET).EQ.'NNPDF') call NNPDFalfa(alfas,Q)
!     IF(NAME(NSET).EQ.'NNPDF') call NNPDFinit(nset,Eorder,Q2fit)
!
!
!********************************************************

      SUBROUTINE NNPDFevolve(x,Q,f)
      IMPLICIT none
!
      INCLUDE 'parmsetup.inc'
      CHARACTER*16 name(nmxset)
      INTEGER nmem(nmxset),ndef(nmxset),mmem
      COMMON/NAME/name,nmem,ndef,mmem
!
      INTEGER nset,pdfmem
      REAL*8 f(-6:6)
      REAL*8 x,Q
!
      INTEGER order
      REAL*8 alfas,alphaNNPDF,alfas0,q0
      REAL*8 Eorder,Q2fit,mass
      REAL*8 pdfout(13)
      REAL*8 check
      REAL*8 pi
      PARAMETER (pi = 3.1415926535897932385)
!
      INTEGER i,nff 
      REAL*8 xpt
!
      INTEGER ipt,imodev,ivfn,itmc
      COMMON/nnpdf10EVFLAGS/ipt,imodev,ivfn,itmc 
      INTEGER ieval,niter,nmax
      COMMON/nnpdf10ngrid/ ieval,niter,nmax
      REAL*8 xmin,xm1,xm2,xmax
      COMMON/nnpdf10GRID/xmin,xm1,xm2,xmax  
      REAL*8 epsevol
      COMMON/nnpdf10evolacc/epsevol
!
      REAL*8 qq,qq2,qth(4:6)
      REAL*8 q20,q2
      COMMON/nnpdf10EVSCALE/q20,q2
      REAL*8 q2th(4:6),asref,q2ref
      COMMON/nnpdf10vfns/q2th,asref,q2ref
      REAL*8 as0,asc,asb,ast,asq
      COMMON/nnpdf10AS/ as0,asc,asb,ast,asq
!
      q2    = q**2.                ! for the commons
      qq2   = q**2.
      qq = q
      asq   = alphaNNPDF(qq)   
      asq   = asq / (4.*pi) 
!       
      xpt = x
      CALL lh_evolfactx(0,xpt)
      CALL lh_pdfevolx(xpt,pdfout)
      CALL lh_pdfevln2lha(pdfout,f)
      DO i = -6,6,1
         f(i) = x * f(i)
      ENDDO
!
      RETURN

!********************************************************

      ENTRY NNPDFread(nset)
!
!     Read evol params from NNPDF08.LHpdf
      READ(1,*) ivfn,imodev,itmc,niter,xmin,xm1,xm2,xmax,epsevol
!
      RETURN

!********************************************************

      ENTRY NNPDFalfa(alfas,Q)
!      
      QQ = Q             
      alfas =  alphaNNPDF(QQ)
!
      RETURN

!********************************************************

      ENTRY NNPDFinit(nset,Eorder,Q2fit)
!      
      CALL GetOrderPDFM(nset,order)
      IPT = order 
!
      CALL GetQ2fitM(nset,Q2)
      Q2fit = Q2
      Q20   = Q2
!
      call GetQmassM(nset,4,mass)
      QTH(4) = mass
      call GetQmassM(nset,5,mass)
      QTH(5) = mass
      call GetQmassM(nset,6,mass)
      QTH(6) = mass
      DO i = 4,6
         q2th(i) = qth(i)**2d0
      ENDDO
!
      CALL GetAlfas(nset,alfas0,Q0)
      asref = 0.119 
      q2ref = q0**2d0
!
      RETURN

!********************************************************

      ENTRY NNPDFpdf(nset)
!
      pdfmem = mmem
      IF (pdfmem.LT.0) THEN
         WRITE(*,*) 'NNPDF set:'
         WRITE(*,*) 'PDF member out of range:'
         WRITE(*,*) 'member = ',pdfmem
         STOP
      ENDIF
      RETURN
!
      END

! -*- F90 -*-

!--   31/05/2012 by Graeme Watt <Graeme.Watt(at)cern.ch>.
!--   Test automatic calculation of PDF uncertainties in LHAPDF.

!--   Compile with:
!--    gfortran -ffree-form testPDFunc.f `lhapdf-config --ldflags`



program testPDFunc

  implicit none
  integer nset,nmem,imem,MaxNumSets
  double precision x,q,xf(-6:6),xg(0:100),xu(0:100), &
       &     xf0,xfp,xfm,xfs,correlation
  logical lMonteCarlo,lSymmetric
  character*10 lhaversion

  !-- Get the LHAPDF version number.
  call getlhapdfversion(lhaversion)
  write(6,*) "LHAPDF Version = ",lhaversion

  !-- Get the maximum number of concurrent PDF sets.
  call GetMaxNumSets(MaxNumSets)
  write(6,*) "MaxNumSets = ",MaxNumSets
  write(6,*)

  !-- Test three PDF sets that have different uncertainty calculations.
  do nset = 1, MaxNumSets

     if (nset.eq.1) then
        call InitPDFSetByNameM(nset,"MSTW2008nnlo68cl.LHgrid")
     else if (nset.eq.2) then
        call InitPDFSetByNameM(nset,"abm11_5n_nnlo.LHgrid")
     else if (nset.eq.3) then
        call InitPDFSetByNameM(nset,"NNPDF21_nnlo_nf5_100.LHgrid")
     end if
     call numberPDFM(nset,nmem)
     write(6,*) "PDF set = ",nset
     write(6,*) "Number of PDF members = ",nmem

     !-- Check if Monte Carlo PDF set (NNPDF) or if
     !-- should compute symmetric errors (Alekhin).
     call GetPDFUncTypeM(nset,lMonteCarlo,lSymmetric)
     write(6,*) "lMonteCarlo = ",lMonteCarlo
     write(6,*) "lSymmetric = ",lSymmetric
     write(6,*)

     x = 0.1D0 ! momentum fraction
     q = 100.D0 ! scale in GeV

     !-- Fill arrays xg and xu using all PDF members.
     do imem = 0, nmem
        call InitPDFM(nset,imem)
        call evolvePDFM(nset,x,q,xf)
        xg(imem) = xf(0)    ! gluon distribution
        xu(imem) = xf(2)    ! up-quark distribution
     end do

     !-- Calculate PDF uncertainty on gluon distribution.
     write(6,*) "Gluon distribution at Q (GeV) = ",q
     write(6,'(A2,A10,4A12)') " #","x","xg","error+","error-","error"
     call GetPDFuncertaintyM(nset,xg,xf0,xfp,xfm,xfs)
     write(6,'(1P5E12.4)') x,xf0,xfp,xfm,xfs
     write(6,*)

     !-- Calculate PDF uncertainty on up-quark distribution.
     write(6,*) "Up-quark distribution at Q (GeV) = ",q
     write(6,'(A2,A10,4A12)') " #","x","xu","error+","error-","error"
     call GetPDFuncertaintyM(nset,xu,xf0,xfp,xfm,xfs)
     write(6,'(1P5E12.4)') x,xf0,xfp,xfm,xfs
     write(6,*)

     !-- Calculate PDF correlation between gluon and up-quark.
     call GetPDFcorrelationM(nset,xg,xu,correlation)
     write(6,*) "Correlation between xg and xu = ",correlation
     write(6,*)

  end do

  stop
end program testPDFunc

program example2
  implicit double precision (a-h,o-z)
  double precision f(-6:6)
  integer lhaids(3)
  character*50 setnames(3)
  data lhaids /11000, 25300, 303600/
  data setnames /"CT10nlo", "MMHT2014nnlo68cl", "NNPDF31_nnlo_as_0118"/

  nsets = 3
  nmem = 0
  x = 1e-3
  q = 1000

  ! Modern init by set ID
  write(*,*) "MODERN INIT BY ID"
  do i=1,nsets
     call lhapdf_initpdfset_byid(i, lhaids(i))
  enddo
  do i=1,nsets
     call lhapdf_xfxq_stdpartons(i, nmem, x, q, f)
     write(*,*) i, nmem, f
  enddo
  write(*,*)

  ! Modern init by set name
  write(*,*) "MODERN INIT BY NAME"
  do i=1,nsets
     call lhapdf_initpdfset_byname(i, setnames(i))
  enddo
  do i=1,nsets
     call lhapdf_xfxq_stdpartons(i, nmem, x, q, f)
     write(*,*) i, nmem, f
  enddo
  write(*,*)

  ! Old-style init by name (note no reload messages, since PDFs match)
  write(*,*) "OLD INIT BY NAME"
  do i=1,nsets
     call initpdfsetbynamem(i, setnames(i))
  enddo
  do i=1,nsets
     call lhapdf_xfxq_stdpartons(i, nmem, x, q, f)
     write(*,*) i, nmem, f
  enddo
  write(*,*)

end program example2

! -*- F90 -*-


      subroutine CTEQ65evolve(x,Q,pdf) 
      implicit real*8(a-h,o-z) 
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      real*8 pdf(-6:6) 
      integer nset 
      Character Line*80 
      PARAMETER (MXX = 204, MXQ = 25, MXF = 6, MaxVal=3, nhess = 52) 
      PARAMETER (MXPQX = (MXF+1+MaxVal) * MXQ * MXX) 
      Common                                                            &
     & / CtqPar1nhess65 /                                               &
     &  Al(nmxset), XV(0:MXX,nmxset), TV(0:MXQ,nmxset),                 &
     &  UPD(0:nhess,MXPQX,nmxset)                                       &
     & / CtqPar2 / Nx(nmxset), Nt(nmxset), NfMx(nmxset)                 &
     & / XQrange / Qini(nmxset), Qmax(nmxset), Xmin(nmxset)             &
     & / QCDtable /  Alambda(nmxset), Nfl(nmxset), Iorder(nmxset)       &
     & / Masstbl / Amass(6,nmxset)                                      
                                                                        
      common/masses_LHA/cMass(nmxset),bMass(nmxset),tMass(nmxset) 
                                                                        
      data pi / 3.141592653589793d0 / 
      save 
!                                                                       
      call getnset(iset) 
      call getnmem(iset,imem) 
                                                                        
      U =         X * CtLhCtq65Pdf(imem,1,X,Q) 
      D =         X * CtLhCtq65Pdf(imem,2,X,Q) 
      USEA =      X * CtLhCtq65Pdf(imem,-1,X,Q) 
      DSEA =      X * CtLhCtq65Pdf(imem,-2,X,Q) 
      STR =       X * CtLhCtq65Pdf(imem,-3,X,Q) 
      CHM =       X * CtLhCtq65Pdf(imem,-4,X,Q) 
      BOT =       X * CtLhCtq65Pdf(imem,-5,X,Q) 
      GLU  =      X * CtLhCtq65Pdf(imem,0,X,Q) 
!                                                                       
      pdf(0)  = glu 
      pdf(1)  = d 
      pdf(-1) = dsea 
      pdf(2)  = u 
      pdf(-2) = usea 
      pdf(3)  = str 
      pdf(-3) = str 
      pdf(4)  = chm 
      pdf(-4) = chm 
      pdf(5)  = bot 
      pdf(-5) = bot 
      pdf(6)  = 0.0d0 
      pdf(-6) = 0.0d0 
      return 
!                                                                       
                                          !like cteq65evolve, but allows
      entry CTEQ65cevolve(x,Q,pdf) 
!                                                                       
      call getnset(iset) 
      call getnmem(iset,imem) 
                                                                        
      U =         X * CtLhCtq65Pdf(imem,1,X,Q) 
      D =         X * CtLhCtq65Pdf(imem,2,X,Q) 
      USEA =      X * CtLhCtq65Pdf(imem,-1,X,Q) 
      DSEA =      X * CtLhCtq65Pdf(imem,-2,X,Q) 
      STR =       X * CtLhCtq65Pdf(imem,3,X,Q) 
      SBAR =      X * CtLhCtq65Pdf(imem,-3,X,Q) 
      CHM =       X * CtLhCtq65Pdf(imem,4,X,Q) 
      CBAR =      X * CtLhCtq65Pdf(imem,-4,X,Q) 
      BOT =       X * CtLhCtq65Pdf(imem,5,X,Q) 
      GLU  =      X * CtLhCtq65Pdf(imem,0,X,Q) 
!                                                                       
      pdf(0)  = glu 
      pdf(1)  = d 
      pdf(-1) = dsea 
      pdf(2)  = u 
      pdf(-2) = usea 
      pdf(3)  = str 
      pdf(-3) = sbar 
      pdf(4)  = chm 
      pdf(-4) = cbar 
      pdf(5)  = bot 
      pdf(-5) = bot 
      pdf(6)  = 0.0d0 
      pdf(-6) = 0.0d0 
                                                                        
      return 
!                                                                       
                                          !like cteq65evolve, but allows
      entry CTEQ65sevolve(x,Q,pdf) 
!                                                                       
      call getnset(iset) 
      call getnmem(iset,imem) 
                                                                        
      U =         X * CtLhCtq65Pdf(imem,1,X,Q) 
      D =         X * CtLhCtq65Pdf(imem,2,X,Q) 
      USEA =      X * CtLhCtq65Pdf(imem,-1,X,Q) 
      DSEA =      X * CtLhCtq65Pdf(imem,-2,X,Q) 
      STR =       X * CtLhCtq65Pdf(imem,3,X,Q) 
      SBAR =      X * CtLhCtq65Pdf(imem,-3,X,Q) 
      CHM =       X * CtLhCtq65Pdf(imem,-4,X,Q) 
      BOT =       X * CtLhCtq65Pdf(imem,5,X,Q) 
      GLU  =      X * CtLhCtq65Pdf(imem,0,X,Q) 
!                                                                       
      pdf(0)  = glu 
      pdf(1)  = d 
      pdf(-1) = dsea 
      pdf(2)  = u 
      pdf(-2) = usea 
      pdf(3)  = str 
      pdf(-3) = sbar 
      pdf(4)  = chm 
      pdf(-4) = chm 
      pdf(5)  = bot 
      pdf(-5) = bot 
      pdf(6)  = 0.0d0 
      pdf(-6) = 0.0d0 
                                                                        
      return 
      
      entry CTEQ65getgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=0,nx(nset)
          gridx(jx+1)=xv(jx,nset)
      enddo
      do jq=0,nt(nset)
          qtemp = alambda(nset)*dexp(dexp(tv(jq,nset)))
          gridq(jq+1)=qtemp*qtemp
      enddo
      ngridx=nx(nset)
      ngridq=nt(nset)
      return        
!                                                                       
      entry CTEQ65read(nset) 
      call CtLhbldat1 
      call CtLhbldat2 
                                                                        
      call LHct65set 
                                                                        
                                            !*** nmem+1=number of member
      read(1,*)nmem(nset),ndef(nset) 
      if(nmem(nset) .gt. nhess) then 
         print *,'fatal error:  nmem=',nmem(nset),' > nhess=',nhess 
         stop 
      endif 
                                                                        
      MxVal = 3 
      Read  (1, '(A)') Line 
      Read  (1, '(A)') Line 
      Read  (1, *) Dr, Fl, Al(nset), (Amass(I,nset),I=1,6) 
      Iorder(nset) = Nint(Dr) 
      Nfl(nset) = Nint(Fl) 
      Alambda(nset) = Al(nset) 
                                                                        
      cMass(nset) = Amass(4,nset) 
      bMass(nset) = Amass(5,nset) 
      tMass(nset) = Amass(6,nset) 
                                                                        
      Read  (1, '(A)') Line 
!                                               This is the .pds (WKT) f
      Read  (1, *) N0, N0, N0, NfMx(nset), N0, N0 
      Read  (1, '(A)') Line 
      Read  (1, *) NX(nset),  NT(nset), N0, N0, N0 
      Read  (1, '(A)') (Line,I=1,4) 
      Read  (1, *)                                                      &
     &  QINI(nset), QMAX(nset), (aa,TV(I,nset), I =0, NT(nset))         
                                                                        
      Read  (1, '(A)') Line 
      Read  (1, *) XMIN(nset), aa, (XV(I,nset), I =1, NX(nset)) 
      XV(0,nset)=0D0 
!                                                                       
!                  Since quark = anti-quark for nfl>2 at this stage,    
!                  we Read  out only the non-redundent data points      
!     No of flavors = NfMx (sea) + 1 (gluon) + 2 (valence)              
                                                                        
                                                                        
      Nblk = (NX(nset)+1) * (NT(nset)+1) 
      Npts =  Nblk  * (NfMx(nset)+1+MxVal) 
                                                                        
                                             !*** new version: allows nm
      do ihess = 0,nmem(nset) 
                                                                        
        Read  (1, '(A)') Line 
        Read  (1, '(A)') Line 
        Read  (1, *, IOSTAT=IRET) (UPD(ihess,I,nset), I=1,Npts) 
                                                                        
      enddo 
      return 
!                                                                       
      entry CTEQ66read(nset) 
      call CtLhbldat1 
      call CtLhbldat2 
                                                                        
      call LHct65set 
                                                                        
                                            !*** nmem+1=number of member
      read(1,*)nmem(nset),ndef(nset) 
      if(nmem(nset) .gt. nhess) then 
         print *,'fatal error:  nmem=',nmem(nset),' > nhess=',nhess 
         stop 
      endif 
                                                                        
      MxVal = 2 
      Read  (1, '(A)') Line 
      Read  (1, '(A)') Line 
      Read  (1, *) Dr, Fl, Al(nset), (Amass(I,nset),I=1,6) 
      Iorder(nset) = Nint(Dr) 
      Nfl(nset) = Nint(Fl) 
      Alambda(nset) = Al(nset) 
                                                                        
      cMass(nset) = Amass(4,nset) 
      bMass(nset) = Amass(5,nset) 
      tMass(nset) = Amass(6,nset) 
                                                                        
      Read  (1, '(A)') Line 
!                                               This is the .pds (WKT) f
      Read  (1, *) N0, N0, N0, NfMx(nset), N0, N0 
      Read  (1, '(A)') Line 
      Read  (1, *) NX(nset),  NT(nset), N0, N0, N0 
      Read  (1, '(A)') (Line,I=1,4) 
      Read  (1, *)                                                      &
     &  QINI(nset), QMAX(nset), (aa,TV(I,nset), I =0, NT(nset))         
                                                                        
      Read  (1, '(A)') Line 
      Read  (1, *) XMIN(nset), aa, (XV(I,nset), I =1, NX(nset)) 
      XV(0,nset)=0D0 
!                                                                       
!                  Since quark = anti-quark for nfl>2 at this stage,    
!                  we Read  out only the non-redundent data points      
!     No of flavors = NfMx (sea) + 1 (gluon) + 2 (valence)              
                                                                        
                                                                        
      Nblk = (NX(nset)+1) * (NT(nset)+1) 
      Npts =  Nblk  * (NfMx(nset)+1+MxVal) 
                                                                        
                                             !*** new version: allows nm
      do ihess = 0,nmem(nset) 
                                                                        
        Read  (1, '(A)') Line 
        Read  (1, '(A)') Line 
        Read  (1, *, IOSTAT=IRET) (UPD(ihess,I,nset), I=1,Npts) 
                                                                        
      enddo 
      return 
!                                                                       
                                             !like CTEQ65read, but c.ne.
      entry CTEQ65cread(nset) 
      call CtLhbldat1 
      call CtLhbldat2 
      call LHct65set 
                                                                        
                                            !*** nmem+1=number of member
      read(1,*)nmem(nset),ndef(nset) 
      if(nmem(nset) .gt. nhess) then 
         print *,'fatal error:  nmem=',nmem(nset),' > nhess=',nhess 
         stop 
      endif 
                                                                        
                                               !one more species free   
      MxVal = 4 
      Read  (1, '(A)') Line 
      Read  (1, '(A)') Line 
      Read  (1, *) Dr, Fl, Al(nset), (Amass(I,nset),I=1,6) 
      Iorder(nset) = Nint(Dr) 
      Nfl(nset) = Nint(Fl) 
      Alambda(nset) = Al(nset) 
                                                                        
      cMass(nset) = Amass(4,nset) 
      bMass(nset) = Amass(5,nset) 
      tMass(nset) = Amass(6,nset) 
                                                                        
      Read  (1, '(A)') Line 
!                                               This is the .pds (WKT) f
      Read  (1, *) N0, N0, N0, NfMx(nset), N0, N0 
      Read  (1, '(A)') Line 
      Read  (1, *) NX(nset),  NT(nset), N0, N0, N0 
      Read  (1, '(A)') (Line,I=1,4) 
      Read  (1, *)                                                      &
     &  QINI(nset), QMAX(nset), (aa,TV(I,nset), I =0, NT(nset))         
                                                                        
      Read  (1, '(A)') Line 
      Read  (1, *) XMIN(nset), aa, (XV(I,nset), I =1, NX(nset)) 
      XV(0,nset)=0D0 
!                                                                       
! we Read only the non-redundent data points                            
                                                                        
      Nblk = (NX(nset)+1) * (NT(nset)+1) 
      Npts =  Nblk  * (NfMx(nset)+1+MxVal) 
                                                                        
                                             !*** new version: allows nm
      do ihess = 0,nmem(nset) 
                                                                        
        Read  (1, '(A)') Line 
        Read  (1, '(A)') Line 
        Read  (1, *, IOSTAT=IRET) (UPD(ihess,I,nset), I=1,Npts) 
                                                                        
      enddo 
      return 
!                                                                       
      entry CTEQ65alfa(alfas,Qalfa) 
      alfas = pi*CtLhALPI(Qalfa) 
      return 
!                                                                       
      entry CTEQ65init(Eorder,Q2fit) 
      return 
!                                                                       
      entry CTEQ65pdf(mem) 
!        imem = mem                                                     
        call getnset(iset) 
        call setnmem(iset,mem) 
      return 
!                                                                       
      END                                           
                                                                        
      subroutine LHct65set 
      Implicit Double Precision (A-H,O-Z) 
      common /ctq65co/ xlast, qlast, nxsave 
      nxsave = -1000 
      xlast = -2. 
      qlast = -2. 
      return 
      END                                           
                                                                        
!=======================================================================
      Function CtLhPartonX65 (imem,IPRTN, XX, QQ) 
!  Given the parton distribution function in the array U in             
!  COMMON / PEVLDT / , this routine interpolates to find                
!  the parton distribution at an arbitray point in x and q.             
!                                                                       
      Implicit Double Precision (A-H,O-Z) 
                                                                        
      include 'parmsetup.inc' 
      PARAMETER (MXX = 204, MXQ = 25, MXF = 6, MaxVal=3, nhess = 52) 
      PARAMETER (MXPQX = (MXF+1+MaxVal) * MXQ * MXX) 
                                                                        
      Common                                                            &
     & / CtqPar1nhess65 /                                               &
     &  Al(nmxset), XV(0:MXX,nmxset), TV(0:MXQ,nmxset),                 &
     &  UPD(0:nhess,MXPQX,nmxset)                                       &
     & / CtqPar2 / Nx(nmxset), Nt(nmxset), NfMx(nmxset)                 &
     & / XQrange / Qini(nmxset), Qmax(nmxset), Xmin(nmxset)             
      common /ctq65co/ xlast,qlast, nxsave 
                                                                        
        parameter(nqvec = 4) 
                                                                        
      Dimension fvec(4), fij(4) 
      Dimension xvpow(0:mxx) 
      Data OneP / 1.00001 / 
                                !**** choice of interpolation variable  
      Data xpow / 0.3d0 / 
      Save xvpow 
      Data ixprint,iqprint/0,0/ 
      save ixprint,iqprint 
                                                                        
         save jq, jx, JLx, JLq, ss, sy2, sy3, s23, ty2, ty3 
         save const1 , const2, const3, const4, const5, const6 
         save tt, t13, t12, t23, t34 , t24, tmp1, tmp2, tdet 
                                                                        
      call getnset(iset) 
      call getnmem(iset,imem) 
                                                                        
! store the powers used for interpolation on first call...              
      if(nx(iset) .ne. nxsave) then 
         nxsave = nx(iset) 
         xvpow(0) = 0.D0 
         do i = 1, nx(iset) 
            xvpow(i) = xv(i,iset)**xpow 
         enddo 
      endif 
                                                                        
      X = XX 
      Q = QQ 
                                                                        
      if((x.lt.xmin(iset)).or.(x.gt.1.d0)) then 
        ixprint=ixprint+1 
        if(ixprint.lt.11) print 98,x 
        if(ixprint.eq.10) print *,                                      &
     &  'more warning messages like the last suppressed.'               
      endif 
   98 format(' WARNING:  X=',e12.5,' OUT OF RANGE') 
      if((q.lt.qini(iset)).or.(q.gt.qmax(iset))) then 
        iqprint=iqprint+1 
        if(iqprint.lt.11) print 99,q 
        if(iqprint.eq.10) print *,                                      &
     &  'more warning messages like the last suppressed.'               
      endif 
   99 format(' WARNING:  Q=',e12.5,' OUT OF RANGE') 
                                                                        
! skip the initialization in x if same as in the previous call.         
        if(x .eq. xlast) goto 100 
        xlast = x 
                                                                        
!      -------------    find lower end of interval containing x, i.e.,  
!                       get jx such that xv(jx) .le. x .le. xv(jx+1)... 
      JLx = -1 
      JU = Nx(iset)+1 
   11 If (JU-JLx .GT. 1) Then 
         JM = (JU+JLx) / 2 
         If (X .Ge. XV(JM,iset)) Then 
            JLx = JM 
         Else 
            JU = JM 
         Endif 
         Goto 11 
      Endif 
!                     Ix    0   1   2      Jx  JLx         Nx-2     Nx  
!                           |---|---|---|...|---|-x-|---|...|---|---|   
!                     x     0  Xmin               x                 1   
!                                                                       
      If     (JLx .LE. -1) Then 
        Print '(A,1pE12.4)','Severe error: x <= 0 in CtLhPartonX65 x=',x 
        Stop 
      ElseIf (JLx .Eq. 0) Then 
         Jx = 0 
      Elseif (JLx .LE. Nx(iset)-2) Then 
                                                                        
!                For interior points, keep x in the middle, as shown abo
         Jx = JLx - 1 
      Elseif (JLx.Eq.Nx(iset)-1 .or. x.LT.OneP) Then 
                                                                        
!                  We tolerate a slight over-shoot of one (OneP=1.00001)
!              perhaps due to roundoff or whatever, but not more than th
!                                      Keep at least 4 points >= Jx     
         Jx = JLx - 2 
      Else 
        Print '(A,1pE12.4)','Severe error: x > 1 in CtLhPartonX65 x=',x 
        Stop 
      Endif 
!          ---------- Note: JLx uniquely identifies the x-bin; Jx does n
                                                                        
!                       This is the variable to be interpolated in      
      ss = x**xpow 
                                                                        
      If (JLx.Ge.2 .and. JLx.Le.Nx(iset)-2) Then 
                                                                        
!     initiation work for "interior bins": store the lattice points in s
      svec1 = xvpow(jx) 
      svec2 = xvpow(jx+1) 
      svec3 = xvpow(jx+2) 
      svec4 = xvpow(jx+3) 
                                                                        
      s12 = svec1 - svec2 
      s13 = svec1 - svec3 
      s23 = svec2 - svec3 
      s24 = svec2 - svec4 
      s34 = svec3 - svec4 
                                                                        
      sy2 = ss - svec2 
      sy3 = ss - svec3 
                                                                        
! constants needed for interpolating in s at fixed t lattice points...  
      const1 = s13/s23 
      const2 = s12/s23 
      const3 = s34/s23 
      const4 = s24/s23 
      s1213 = s12 + s13 
      s2434 = s24 + s34 
      sdet = s12*s34 - s1213*s2434 
      tmp = sy2*sy3/sdet 
      const5 = (s34*sy2-s2434*sy3)*tmp/s12 
      const6 = (s1213*sy2-s12*sy3)*tmp/s34 
                                                                        
      EndIf 
                                                                        
  100      continue 
                                                                        
! skip the initialization in q if same as in the previous call.         
        if(q .eq. qlast) goto 110 
        qlast = q 
                                                                        
      tt = log(log(Q/Al(iset))) 
                                                                        
!         --------------Now find lower end of interval containing Q, i.e
!                          get jq such that qv(jq) .le. q .le. qv(jq+1).
      JLq = -1 
      JU = NT(iset)+1 
   12 If (JU-JLq .GT. 1) Then 
         JM = (JU+JLq) / 2 
         If (tt .GE. TV(JM,iset)) Then 
            JLq = JM 
         Else 
            JU = JM 
         Endif 
         Goto 12 
       Endif 
                                                                        
      If     (JLq .LE. 0) Then 
         Jq = 0 
      Elseif (JLq .LE. Nt(iset)-2) Then 
!                                  keep q in the middle, as shown above 
         Jq = JLq - 1 
      Else 
!                         JLq .GE. Nt-1 case:  Keep at least 4 points >=
        Jq = Nt(iset) - 3 
                                                                        
      Endif 
!                                   This is the interpolation variable i
                                                                        
      If (JLq.GE.1 .and. JLq.LE.Nt(iset)-2) Then 
!                                        store the lattice points in t..
      tvec1 = Tv(jq,iset) 
      tvec2 = Tv(jq+1,iset) 
      tvec3 = Tv(jq+2,iset) 
      tvec4 = Tv(jq+3,iset) 
                                                                        
      t12 = tvec1 - tvec2 
      t13 = tvec1 - tvec3 
      t23 = tvec2 - tvec3 
      t24 = tvec2 - tvec4 
      t34 = tvec3 - tvec4 
                                                                        
      ty2 = tt - tvec2 
      ty3 = tt - tvec3 
                                                                        
      tmp1 = t12 + t13 
      tmp2 = t24 + t34 
                                                                        
      tdet = t12*t34 - tmp1*tmp2 
                                                                        
      EndIf 
                                                                        
  110      continue 
                                                                        
! get the pdf function values at the lattice points...                  
! In this code, we store 10 flavors: u,ubar,d,dbar,s,sbar,c,cbar,b=bbar,
! hence Iprtn=5 (b) is obtained from -5 (bbar)                          
                                                                        
      If (Iprtn .GE. 5) Then 
         Ip = - Iprtn 
      Else 
         Ip = Iprtn 
      EndIf 
      jtmp = ((Ip + NfMx(iset))*(NT(iset)+1)+(jq-1))*(NX(iset)+1)+jx+1 
                                                                        
      Do it = 1, nqvec 
                                                                        
         J1  = jtmp + it*(NX(iset)+1) 
                                                                        
       If (Jx .Eq. 0) Then 
!                          For the first 4 x points, interpolate x^2*f(x
!                           This applies to the two lowest bins JLx = 0,
!            We cannot put the JLx.eq.1 bin into the "interior" section 
!                           (as we do for q), since Upd(J1) is undefined
         fij(1) = 0 
         fij(2) = Upd(imem,J1+1,iset) * XV(1,iset)**2 
         fij(3) = Upd(imem,J1+2,iset) * XV(2,iset)**2 
         fij(4) = Upd(imem,J1+3,iset) * XV(3,iset)**2 
!                                                                       
!                 Use CtLhPolint which allows x to be anywhere w.r.t. th
                                                                        
         Call CtLhPolint4(XVpow(0), Fij(1), 4, ss, Fx, Dfx) 
                                                                        
         If (x .GT. 0D0)  fvec(it) =  Fx / x**2 
!                                              Pdf is undefined for x.eq
       ElseIf  (JLx .Eq. Nx(iset)-1) Then 
!                                                This is the highest x b
                                                                        
!** fix allow 4 consecutive elements with iset... mrw 19.9.2005         
        fij(1) = Upd(imem,j1,iset) 
        fij(2) = Upd(imem,j1+1,iset) 
        fij(3) = Upd(imem,j1+2,iset) 
        fij(4) = Upd(imem,j1+3,iset) 
        Call CtLhPolint4 (XVpow(Nx(iset)-3), Fij(1), 4, ss, Fx, Dfx) 
                                                                        
        fvec(it) = Fx 
                                                                        
       Else 
                                                                        
! for all interior points, use Jon's in-line function                   
! This applied to (JLx.Ge.2 .and. JLx.Le.Nx-2)                          
! (This is cubic spline interpolation, as used by cteq; it was          
! changed to polint in previous Durham releases (jcp).)                 
         sf2 = Upd(imem,J1+1,iset) 
         sf3 = Upd(imem,J1+2,iset) 
                                                                        
         Fvec(it) = (const5*(Upd(imem,J1,iset)                          &
     &                             - sf2*const1 + sf3*const2)           &
     &             + const6*(Upd(imem,J1+3,iset)                        &
     &                             + sf2*const3 - sf3*const4)           &
     &             + sf2*sy3 - sf3*sy2) / s23                           
                                                                        
       Endif 
                                                                        
      enddo 
!                                   We now have the four values Fvec(1:4
!     interpolate in t...                                               
                                                                        
      If (JLq .LE. 0) Then 
!                         1st Q-bin, as well as extrapolation to lower Q
        Call CtLhPolint4(TV(0,iset), Fvec(1), 4, tt, ff, Dfq) 
                                                                        
      ElseIf (JLq .GE. Nt(iset)-1) Then 
!                         Last Q-bin, as well as extrapolation to higher
        Call CtLhPolint4(TV(Nt(iset)-3,iset), Fvec(1), 4, tt, ff, Dfq) 
      Else 
!                         Interrior bins : (JLq.GE.1 .and. JLq.LE.Nt-2) 
!       which include JLq.Eq.1 and JLq.Eq.Nt-2, since Upd is defined for
!                         the full range QV(0:Nt)  (in contrast to XV)  
        tf2 = fvec(2) 
        tf3 = fvec(3) 
                                                                        
        g1 = ( tf2*t13 - tf3*t12) / t23 
        g4 = (-tf2*t34 + tf3*t24) / t23 
                                                                        
        h00 = ((t34*ty2-tmp2*ty3)*(fvec(1)-g1)/t12                      &
     &    +  (tmp1*ty2-t12*ty3)*(fvec(4)-g4)/t34)                       
                                                                        
        ff = (h00*ty2*ty3/tdet + tf2*ty3 - tf3*ty2) / t23 
      EndIf 
                                                                        
      CtLhPartonX65 = ff 
                                                                        
      Return 
      END                                           
!=======================================================================
      Function CtLhCtq65Pdf (imem,Iparton, X, Q) 
      Implicit Double Precision (A-H,O-Z) 
      include 'parmsetup.inc' 
      Logical Warn 
      Common                                                            &
     & / CtqPar2 / Nx(nmxset), Nt(nmxset), NfMx(nmxset)                 &
     & / QCDtable /  Alambda(nmxset), Nfl(nmxset), Iorder(nmxset)       
                                                                        
      Data Warn /.true./ 
      save Warn 
                                                                        
      call getnset(iset) 
                                                                        
      If (X .lt. 0D0 .or. X .gt. 1D0) Then 
        Print *, 'X out of range in CtLhCtq65Pdf: ', X 
        Stop 
      Endif 
      If (Q .lt. Alambda(iset)) Then 
        Print *, 'Q out of range in CtLhCtq65Pdf: ', Q 
        Stop 
      Endif 
                                                                        
! added to force pdf = 0.0 at x=1.0 exactly - mrw                       
      if(x .eq. 1.0d0) then 
          CtLhCtq65Pdf = 0.0d0 
          return 
      endif 
!                                                                       
      If ((Iparton .lt. -NfMx(iset) .or. Iparton .gt. NfMx(iset))) Then 
         If (Warn) Then 
!        put a warning for calling extra flavor.                        
             Warn = .false. 
             Print *, 'Warning: Iparton out of range in CtLhCtq65Pdf: ' &
     &              , Iparton                                           
         Endif 
         CtLhCtq65Pdf = 0D0 
         Return 
      Endif 
                                                                        
      CtLhCtq65Pdf = CtLhPartonX65 (imem,Iparton, X, Q) 
      if(CtLhCtq65Pdf.lt.0.D0)  CtLhCtq65Pdf = 0.D0 
                                                                        
      Return 
                                                                        
!                             ********************                      
      END                                           

! -*- F90 -*-


subroutine numberPDF(noe)
  implicit none
  integer nset,noe
  nset = 1
  call numberPDFM(nset,noe)
  return
end subroutine numberPDF

      
subroutine listPDF(nset, imem, parm)
  implicit none
  include 'parmsetup.inc'
  character*16 name(nmxset)
  integer nmem(nmxset),ndef(nmxset)
  common/NAME/name,nmem,ndef,mem
  character*16 s1
  integer i,j,mem,imem,noe,nop,listN(nmxset),listP(nmxset),type
  double precision parmL(nmxset,0:noemax,nopmax),parm(nopmax)
  integer nset
  save listN,listP,parmL
#ifdef NNPDF
! nnpdf variables
  integer MXPDF
  parameter(MXPDF=13)
  integer NTOTPDF
  parameter(NTOTPDF=5)      
  integer MXPAR
  parameter(MXPAR=2e2)
  integer MXL,MXN	   
  parameter(MXL=5,MXN=10)
  integer IPAR,IPDF,IDUM
  integer NPAR(MXPDF)
  integer MXREP
  parameter(MXREP=1e3)
  real*8 PARTR(MXPAR,0:MXREP,MXPDF)
  real*8 ANORMTR(MXPDF,0:MXREP)
  common/nnpdf10CPARTR/PARTR,ANORMTR
!
#endif
  mem=imem
  if (mem.gt.listN(nset)) then
     write(*,*) 'Maximum number of PDFs in list exceeded: ', mem,' > ',listN
     write(*,*) 'Returning most likely PDF'
     mem=0
  endif
  if (mem.lt.0) then
     write(*,*) 'Negative PDF member requested: ', mem
     write(*,*) 'Returning most likely PDF'
     mem=0
  endif
  do i=1,listP(nset)
     parm(i)=parmL(nset,mem,i)
  enddo
  return

  entry nopPDF(nset,nop)
  nop=listP(nset)
  return
  
  entry numberPDFM(nset, noe)
  if (      NAME(nset).eq.'MRSTgrid'    .or. NAME(nset).eq.'MRST98grid'  &
       .or. NAME(nset).eq.'A02'         .or. NAME(nset).eq.'A02M'        &
       .or. NAME(nset).eq.'ABKM09'      .or. NAME(nset).eq.'ABM11'       &
       .or. NAME(nset).eq.'CTEQ5grid'   .or. NAME(nset).eq.'CTEQ6grid'   &
       .or. NAME(nset).eq.'CTEQ65grid'  .or. NAME(nset).eq.'CTEQ66grid'  &
       .or. NAME(nset).eq.'CTEQ65cgrid' .or. NAME(nset).eq.'CTEQ6ABgrid' &
       .or. NAME(nset).eq.'SASG'        .or. NAME(nset).eq.'GRVG'        &
       .or. NAME(nset).eq.'DOG'         .or. NAME(nset).eq.'DGG'         &
       .or. NAME(nset).eq.'LACG'        .or. NAME(nset).eq.'GSG'         &
       .or. NAME(nset).eq.'GSG96'       .or. NAME(nset).eq.'ACFGP'       &
       .or. NAME(nset).eq.'WHITG'       .or. NAME(nset).eq.'OWP'         &
       .or. NAME(nset).eq.'SMRSP'       .or. NAME(nset).eq.'GRVP'        &
       .or. NAME(nset).eq.'ABFKWP'      .or. NAME(nset).eq.'ZEUSGRID'    &
       .or. NAME(nset)(1:5).eq.'GJR08'  .or. NAME(nset).eq.'NNPDFint'    &
       .or. NAME(nset).eq.'HKNgrid'                                      &
       .or. NAME(nset).eq.'CT12grid' & 
       !.or. NAME.eq.'H12000' &
       !.or. NAME.eq.'GRV' &
       ) then
     noe = nmem(nset)
  else
     noe=listN(nset)
  endif
  return
  
  entry InitListPDF(nset)
  type=-1
  read(1,*) s1,listN(nset),listP(nset)
  !print *,s1,listN(nset),listP(nset)
  if (index(s1,'list').eq.1) then
     type=1
     do i=0,listN(nset)
        read(1,*) (parmL(nset,i,j),j=1,listP(nset))
       !print *,i,(parmL(nset,i,j),j=1,listP(nset))
     enddo
      !print *,parmL(nset,0,1)
!
#ifdef NNPDF
  elseif (index(s1,'nnpar').eq.1) then
     type=2 ! is type=2 ok?

     do i=0,listN(nset)
  	read(1,*)idum
  	if(idum.ne.i)write(*,*)"error in InitListPDF"
  	do ipdf = 1,listP(nset)
  	   read(1,*) npar(ipdf)
  	   read(1,*) anormtr(ipdf,i)
  	   do ipar = 1,npar(ipdf)
  	      read(1,*) partr(ipar,i,ipdf)
  	   enddo
  	enddo
     enddo
#endif
  endif
  if (type.lt.0) then
     write(*,*) 'File description error:'
     write(*,*) 'Unknown parameter list type ',s1
     stop
  endif
  return
end subroutine listPDF

! -*- F90 -*-


subroutine MRST2006evolve(x,Q,pdf)
  implicit none
  ! implicit real*8 (a-h,o-z)
  include 'parmsetup.inc'
  character*16 name(nmxset)
  character*80 line
  character*512 setpath
  integer i,f,nhess,nx,nq,np,nqc0,nqb0,nqc,nqb,n,m,io
  double precision x,q,xmin,xmax,qsqmin,qsqmax,emc2,emb2,eps,dummy,qsq, &
       xlog,qsqlog,res,ExtrapLHAPDF,InterpLHAPDF
  double precision emc2minuseps,emb2minuseps
  double precision xsave,q2save
  double precision gridx(nmxgridx),gridq(nmxgridq)
  integer ngridx,ngridq,jx,jq
  double precision pdf(-6:6),alfas,Qalfa,Q2fit,eorder
  double precision upv,dnv,glu,usea,str,dsea,sbar,chm,bot
  integer iset,nflav,mem,nset,nmem(nmxset),ndef(nmxset),mmem,imem
  common/NAME/name,nmem,ndef,mmem
  parameter(nx=64,nq=48,np=9,nqc0=4,nqb0=14,nqc=nq-nqc0,nqb=nq-nqb0)
  parameter(xmin=1d-6,xmax=1d0,qsqmin=1d0,qsqmax=1d9,eps=1d-6)
  parameter(nhess=0,emc2=1.43d0**2,emb2=4.3d0**2) ! MRST 2006 NNLO
  parameter(emc2minuseps=emc2-eps,emb2minuseps=emb2-eps)
  double precision f1(nx,nq),f2(nx,nq),f3(nx,nq),f4(nx,nq),f5(nx,nq), &
       f6(nx,nq),f7(nx,nq),f8(nx,nq),fc(nx,nqc),fb(nx,nqb),f9(nx,nq)
  double precision qq(nq),xx(nx),cc1(0:nhess,nx,nq,4,4),cc2(0:nhess,nx,nq,4,4), &
       cc3(0:nhess,nx,nq,4,4),cc4(0:nhess,nx,nq,4,4),cc6(0:nhess,nx,nq,4,4), &
       cc8(0:nhess,nx,nq,4,4),cc9(0:nhess,nx,nq,4,4),ccc(0:nhess,nx,nqc,4,4), &
       ccb(0:nhess,nx,nqb,4,4)
  double precision xxl(nx),qql(nq),qqlc(nqc),qqlb(nqb)
  data xx/1d-6,2d-6,4d-6,6d-6,8d-6,1d-5,2d-5,4d-5,6d-5,8d-5,1d-4,2d-4,4d-4,6d-4, &
       8d-4,1d-3,2d-3,4d-3,6d-3,8d-3,1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2, &     
       .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0,.3d0,.325d0,.35d0,.375d0, &
       .4d0,.425d0,.45d0,.475d0,.5d0,.525d0,.55d0,.575d0,.6d0,.625d0,.65d0,.675d0, &
       .7d0,.725d0,.75d0,.775d0,.8d0,.825d0,.85d0,.875d0,.9d0,.925d0,.95d0,.975d0,1d0/
  data qq/1.d0,1.25d0,1.5d0,emc2minuseps,emc2,2.5d0,3.2d0,4d0,5d0,6.4d0,8d0,1d1,1.2d1, &
       emb2minuseps,emb2,2.6d1,4d1,6.4d1,1d2,1.6d2,2.4d2,4d2,6.4d2,1d3,1.8d3,3.2d3,5.6d3, &
       1d4,1.8d4,3.2d4,5.6d4,1d5,1.8d5,3.2d5,5.6d5,1d6,1.8d6,3.2d6,5.6d6,1d7,1.8d7,3.2d7, &
       5.6d7,1d8,1.8d8,3.2d8,5.6d8,1d9/
  save

  xsave=x
  qsq=q*q
  q2save=qsq
          
  if (qsq.gt.qq(nqc0).and.qsq.lt.qq(nqc0+1)) qsq = qq(nqc0)
  if (qsq.gt.qq(nqb0).and.qsq.lt.qq(nqb0+1)) qsq = qq(nqb0)
  
  xlog=log10(x)
  qsqlog=log10(qsq)

  call getnset(iset)
  call getnmem(iset,imem)
  
  upv =  0.d0
  dnv =  0.d0
  glu =  0.d0
  usea = 0.d0
  str =  0.d0
  dsea = 0.d0
  sbar = 0.d0
  chm =  0.d0
  bot =  0.d0
      
  if (x.le.0.d0.or.x.gt.xmax.or.qsq.lt.qsqmin) then
     print *,"Error in GetOnePDF: x,qsq = ",x,qsq
  else if (x.lt.xmin.or.qsq.gt.qsqmax) then ! extrapolate
     print *, "Warning in GetOnePDF, extrapolating: f = ",f,", x = ",x,", q = ",q
     upv =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc1)
     dnv =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc2)
     glu =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc3)
     usea = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc4)
     str =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc6)
     dsea = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc8)
     sbar = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc9)
     if (qsq.ge.emc2) then ! chm
        chm = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nqc,xxl,qqlc,ccc)
     endif
     if (qsq.ge.emb2) then ! bot
        bot = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nqb,xxl,qqlb,ccb)
     endif
  else
     upv =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc1)
     dnv =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc2)
     glu =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc3)
     usea = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc4)
     str =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc6)
     dsea = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc8)
     sbar = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc9)
     if (qsq.ge.emc2) then ! chm
        chm = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nqc,xxl,qqlc,ccc)
     endif
     if (qsq.ge.emb2) then ! bot
        bot = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nqb,xxl,qqlb,ccb)
     endif
     
  end if

  pdf(0)  = glu
  pdf(1)  = dnv+dsea
  pdf(-1) = dsea
  pdf(2)  = upv+usea
  pdf(-2) = usea
  pdf(3)  = str
  pdf(-3) = sbar
  pdf(4)  = chm
  pdf(-4) = chm
  pdf(5)  = bot
  pdf(-5) = bot
  pdf(6)  = 0.0d0
  pdf(-6) = 0.0d0
  
  x=xsave
  qsq=q2save
  return
  
  entry MRST2006getgrid(nset,ngridx,ngridq,gridx,gridq)
  do jx=1,nx
      gridx(jx)=xx(jx)
  enddo
  do jq=1,nq
      gridq(jq)=qq(jq)
  enddo
  ngridx=nx
  ngridq=nq        
  return
  !----------------------------------------------------------------------

  entry MRST2006read(nset)
  ! - dummy read in to get to End: (stream 1 is still open) 
  read(1,*)nmem(nset),ndef(nset)
  
  do i=0,nmem(nset)
     do n=1,nx-1
        do m=1,nq
           read(1,'(a)') line
        enddo
     enddo
  enddo
  

  return
  !----------------------------------------------------------------------

  entry MRST2006alfa(nflav,alfas,Qalfa)
  ! print *,'MRST2006alfa',nflav,alfas,Qalfa
  call getnset(iset)
  call alphamrs(nflav,alfas,Qalfa)
  ! print *,'MRST2006alfa',nflav,alfas,Qalfa
  return

  !----------------------------------------------------------------------

  entry MRST2006init(Eorder,Q2fit)
  return

  !----------------------------------------------------------------------

  entry MRST2006pdf(mem)
  call getnset(iset)
  call setnmem(iset,mem)
  
  ! have to reopen stream 1 
  call getsetpath(setpath)
  open(1,file=setpath(1:len_trim(setpath)),action='READ')
  
  line = ''
  do while (line(2:11).ne.'Evolution:') 
     read(1,'(a)'),line
  enddo
  read(1,'(a)'),line
  read(1,'(a)'),line
  
  read(1,*)nmem(iset),ndef(iset)
  
  ! - dummy read up to the member requested
  do i=0,mem-1
     do n=1,nx-1
        do m=1,nq
           read(1,'(a)')line
        enddo
     enddo
  enddo
  
      
  !- read in the data of the requested member
  do  n=1,nx-1
     do  m=1,nq
        ! print *,i,n,m
        read(1,50) f1(n,m),f2(n,m),f3(n,m),f4(n,m),f5(n,m),f7(n,m),f6(n,m),f8(n,m),f9(n,m)
        ! write(6,50) f1(n,m),f2(n,m),f3(n,m),f4(n,m),f5(n,m),f7(n,m),f6(n,m),f8(n,m),f9(n,m)
        !--   Notation:1=upv 2=dnv 3=glu 4=usea 5=chm 6=str 7=bot 8=dsea 9=sbar
     enddo
  enddo
  ! write(*,*)'PDF set ',i,' first element ',f1(1,1)
  do m=1,nq
     f1(nx,m)=0d0
     f2(nx,m)=0d0
     f3(nx,m)=0d0
     f4(nx,m)=0d0
     f5(nx,m)=0d0
     f6(nx,m)=0d0
     f7(nx,m)=0d0
     f8(nx,m)=0d0
     f9(nx,m)=0d0
  enddo

  do n=1,nx
     xxl(n)=log10(xx(n))
  enddo
  do m=1,nq
     qql(m)=log10(qq(m))
  enddo
  
  call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f1,cc1)
  call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f2,cc2)
  call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f3,cc3)
  call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f4,cc4)
  call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f6,cc6)
  call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f8,cc8)
  call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f9,cc9)
  
  do m=1,nqc
     qqlc(m)=qql(m+nqc0)
     do  n=1,nx
        fc(n,m)=f5(n,m+nqc0)
     enddo
  enddo
  call InitialLHAPDF(i,nhess,nx,nqc,nqc0-nqc0,nqb0-nqc0,xxl,qqlc,fc,ccc)
          
  do m=1,nqb
     qqlb(m)=qql(m+nqb0)
     do n=1,nx
        fb(n,m)=f7(n,m+nqb0)
     enddo
  enddo
  call InitialLHAPDF(i,nhess,nx,nqb,nqc0-nqb0,nqb0-nqb0,xxl,qqlb,fb,ccb)
  
  close(1)
 
50 format(9e13.5)
  
end subroutine MRST2006evolve


!----------------------------------------------------------------------


subroutine InitialLHAPDF(i,nhess,nx,my,myc0,myb0,xx,yy,ff,cc)
  implicit none
  integer nhess,i,nx,my,myc0,myb0,j,k,l,m,n
  double precision xx(nx),yy(my),ff(nx,my),ff1(nx,my),ff2(nx,my),ff12(nx,my), &
       yy0(4),yy1(4),yy2(4),yy12(4),z(16),cl(16),cc(0:nhess,nx,my,4,4), &
       iwt(16,16),dx,dy,polderiv,d1,d2,d1d2,xxd
  data iwt/1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
       0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0, &
       -3,0,0,3,0,0,0,0,-2,0,0,-1,0,0,0,0, &
       2,0,0,-2,0,0,0,0,1,0,0,1,0,0,0,0, &
       0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0, &
       0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0, &
       0,0,0,0,-3,0,0,3,0,0,0,0,-2,0,0,-1, &
       0,0,0,0,2,0,0,-2,0,0,0,0,1,0,0,1, &
       -3,3,0,0,-2,-1,0,0,0,0,0,0,0,0,0,0, &
       0,0,0,0,0,0,0,0,-3,3,0,0,-2,-1,0,0, &
       9,-9,9,-9,6,3,-3,-6,6,-6,-3,3,4,2,1,2, &
       -6,6,-6,6,-4,-2,2,4,-3,3,3,-3,-2,-1,-1,-2, &
       2,-2,0,0,1,1,0,0,0,0,0,0,0,0,0,0, &
       0,0,0,0,0,0,0,0,2,-2,0,0,1,1,0,0, &
       -6,6,-6,6,-3,-3,3,3,-4,4,2,-2,-2,-2,-1,-1, &
       4,-4,4,-4,2,2,-2,-2,2,-2,-2,2,1,1,1,1/

  do m=1,my
     dx=xx(2)-xx(1)
     ff1(1,m)=(ff(2,m)-ff(1,m))/dx
     dx=xx(nx)-xx(nx-1)
     ff1(nx,m)=(ff(nx,m)-ff(nx-1,m))/dx
     do n=2,nx-1
        ff1(n,m)=polderiv(xx(n-1),xx(n),xx(n+1),ff(n-1,m),ff(n,m),ff(n+1,m))
     enddo
  enddo

  !--   Calculate the derivatives at qsq=emc2-eps,emc2,emb2-eps,emb2
  !--   in a similar way as at the endpoints qsqmin and qsqmax.
  do n=1,nx
     do m = 1, my
        if (m.eq.1.or.m.eq.myc0+1.or.m.eq.myb0+1) then
           dy=yy(m+1)-yy(m)
           ff2(n,m)=(ff(n,m+1)-ff(n,m))/dy
        else if (m.eq.my.or.m.eq.myc0.or.m.eq.myb0) then
           dy=yy(m)-yy(m-1)
           ff2(n,m)=(ff(n,m)-ff(n,m-1))/dy
        else
           ff2(n,m)=polderiv(yy(m-1),yy(m),yy(m+1),ff(n,m-1),ff(n,m),ff(n,m+1))
        end if
     end do
  end do

  do m=1,my
     dx=xx(2)-xx(1)
     ff12(1,m)=(ff2(2,m)-ff2(1,m))/dx
     dx=xx(nx)-xx(nx-1)
     ff12(nx,m)=(ff2(nx,m)-ff2(nx-1,m))/dx
     do n=2,nx-1
        ff12(n,m)=polderiv(xx(n-1),xx(n),xx(n+1),ff2(n-1,m),ff2(n,m),ff2(n+1,m))
     enddo
  enddo

  do n=1,nx-1
     do m=1,my-1
        d1=xx(n+1)-xx(n)
        d2=yy(m+1)-yy(m)
        d1d2=d1*d2
        
        yy0(1)=ff(n,m)
        yy0(2)=ff(n+1,m)
        yy0(3)=ff(n+1,m+1)
        yy0(4)=ff(n,m+1)
            
        yy1(1)=ff1(n,m)
        yy1(2)=ff1(n+1,m)
        yy1(3)=ff1(n+1,m+1)
        yy1(4)=ff1(n,m+1)
        
        yy2(1)=ff2(n,m)
        yy2(2)=ff2(n+1,m)
        yy2(3)=ff2(n+1,m+1)
        yy2(4)=ff2(n,m+1)
        
        yy12(1)=ff12(n,m)
        yy12(2)=ff12(n+1,m)
        yy12(3)=ff12(n+1,m+1)
        yy12(4)=ff12(n,m+1)
        
        do k=1,4
           z(k)=yy0(k)
           z(k+4)=yy1(k)*d1
           z(k+8)=yy2(k)*d2
           z(k+12)=yy12(k)*d1d2
        enddo
        
        do l=1,16
           xxd=0.d0
           do k=1,16
              xxd=xxd+iwt(k,l)*z(k)
           enddo
           cl(l)=xxd
        enddo
        l=0
        do k=1,4
           do j=1,4
              l=l+1
              cc(i,n,m,k,j)=cl(l)
           enddo
        enddo
     enddo
  enddo
  return
end subroutine InitialLHAPDF


!----------------------------------------------------------------------


double precision function InterpLHAPDF(i,nhess,x,y,nx,my,xx,yy,cc)
  implicit none
  integer i,nx,my,nhess,locx,l,m,n
  double precision xx(nx),yy(my),cc(0:nhess,nx,my,4,4),x,y,z,t,u

  n=locx(xx,nx,x)
  m=locx(yy,my,y)
  
  t=(x-xx(n))/(xx(n+1)-xx(n))
  u=(y-yy(m))/(yy(m+1)-yy(m))
  
  z=0.d0
  do l=4,1,-1
     z = t*z + ((cc(i,n,m,l,4)*u + cc(i,n,m,l,3))*u + cc(i,n,m,l,2))*u + cc(i,n,m,l,1)
  enddo
  
  InterpLHAPDF = z

  return
end function InterpLHAPDF


!----------------------------------------------------------------------


double precision function ExtrapLHAPDF(i,nhess,x,y,nx,my,xx,yy,cc)
  implicit none
  integer i,nx,my,nhess,locx,n,m
  double precision xx(nx),yy(my),cc(0:nhess,nx,my,4,4),x,y,z,f0,f1,z0,z1,InterpLHAPDF
      
  n=locx(xx,nx,x)           ! 0: below xmin, nx: above xmax
  m=locx(yy,my,y)           ! 0: below qsqmin, my: above qsqmax
      
  !--   If extrapolation in small x only:
  if (n.eq.0.and.m.gt.0.and.m.lt.my) then
     f0 = InterpLHAPDF(i,nhess,xx(1),y,nx,my,xx,yy,cc)
     f1 = InterpLHAPDF(i,nhess,xx(2),y,nx,my,xx,yy,cc)
     if (f0.gt.0.d0.and.f1.gt.0.d0) then
        z = exp(log(f0)+(log(f1)-log(f0))/(xx(2)-xx(1))*(x-xx(1)))
     else
        z = f0+(f1-f0)/(xx(2)-xx(1))*(x-xx(1))
     end if
     !--   If extrapolation into large q only:
  else if (n.gt.0.and.m.eq.my) then
     f0 = InterpLHAPDF(i,nhess,x,yy(my),nx,my,xx,yy,cc)
     f1 = InterpLHAPDF(i,nhess,x,yy(my-1),nx,my,xx,yy,cc)
     if (f0.gt.0.d0.and.f1.gt.0.d0) then
        z = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))*(y-yy(my)))
     else
        z = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my))
     end if
     !--   If extrapolation into large q AND small x:
  else if (n.eq.0.and.m.eq.my) then
     f0 = InterpLHAPDF(i,nhess,xx(1),yy(my),nx,my,xx,yy,cc)
     f1 = InterpLHAPDF(i,nhess,xx(1),yy(my-1),nx,my,xx,yy,cc)
     if (f0.gt.0.d0.and.f1.gt.0.d0) then
        z0 = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))*(y-yy(my)))
     else
        z0 = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my))
     end if
     f0 = InterpLHAPDF(i,nhess,xx(2),yy(my),nx,my,xx,yy,cc)
     f1 = InterpLHAPDF(i,nhess,xx(2),yy(my-1),nx,my,xx,yy,cc)
     if (f0.gt.0.d0.and.f1.gt.0.d0) then
        z1 = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))*(y-yy(my)))
     else
        z1 = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my))
     end if
     if (z0.gt.0.d0.and.z1.gt.0.d0) then
        z = exp(log(z0)+(log(z1)-log(z0))/(xx(2)-xx(1))*(x-xx(1)))
     else
        z = z0+(z1-z0)/(xx(2)-xx(1))*(x-xx(1))
     end if
  else
     print *,"Error in ExtrapLHAPDF"
     stop
  end if
  
  ExtrapLHAPDF = z      
  
  return
end function ExtrapLHAPDF


!----------------------------------------------------------------------

! -*- F90 -*-


      subroutine MRSTevolve(x,Q,pdf) 
      implicit real*8(a-h,o-z) 
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
!      integer member(nmxset)                                           
      integer nset,iset 
      common/NAME/name,nmem,ndef,mmem 
      parameter(nx=49,nq=37,np=8,nqc0=2,nqb0=11,nqc=35,nqb=26,          &
     &nhess=30)                                                         
      real*8 pdf(-6:6) 
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      real*8 f1(nx,nq)                                                  &
     &,f2(nx,nq)                                                        &
     &,f3(nx,nq)                                                        &
     &,f4(nx,nq)                                                        &
     &,f5(nx,nq)                                                        &
     &,f6(nx,nq)                                                        &
     &,f7(nx,nq)                                                        &
     &,f8(nx,nq)                                                        &
     &,fc(nx,nqc),fb(nx,nqb)                                            
      real*8 qq(nq),xx(nx),                                             &
     &cc1(0:nhess,nx,nq,4,4,nmxset),cc2(0:nhess,nx,nq,4,4,nmxset),      &
     &cc3(0:nhess,nx,nq,4,4,nmxset),cc4(0:nhess,nx,nq,4,4,nmxset),      &
     &cc6(0:nhess,nx,nq,4,4,nmxset),cc8(0:nhess,nx,nq,4,4,nmxset),      &
     &ccc(0:nhess,nx,nqc,4,4,nmxset),ccb(0:nhess,nx,nqb,4,4,nmxset)     
      real*8 xxl(nx),qql(nq),qqlc(nqc),qqlb(nqb) 
      data xx/1d-5,2d-5,4d-5,6d-5,8d-5,                                 &
     &              1d-4,2d-4,4d-4,6d-4,8d-4,                           &
     &              1d-3,2d-3,4d-3,6d-3,8d-3,                           &
     &              1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2,               &
     &           .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0,     &
     &           .3d0,.325d0,.35d0,.375d0,.4d0,.425d0,.45d0,.475d0,     &
     &           .5d0,.525d0,.55d0,.575d0,.6d0,.65d0,.7d0,.75d0,        &
     &           .8d0,.9d0,1d0/                                         
      data qq/1.25d0,1.5d0,2d0,2.5d0,3.2d0,4d0,5d0,6.4d0,8d0,1d1,       &
     &        1.2d1,1.8d1,2.6d1,4d1,6.4d1,1d2,                          &
     &        1.6d2,2.4d2,4d2,6.4d2,1d3,1.8d3,3.2d3,5.6d3,1d4,          &
     &        1.8d4,3.2d4,5.6d4,1d5,1.8d5,3.2d5,5.6d5,1d6,              &
     &        1.8d6,3.2d6,5.6d6,1d7/                                    
      data xmin,xmax,qsqmin,qsqmax/1d-5,1d0,1.25d0,1d7/ 
      save 
                                                                        
      xsave=x 
      qsq = q*q 
      q2save=qsq 
                                                                        
      xlog=dlog(x) 
      qsqlog=dlog(qsq) 
                                                                        
      call getnset(iset) 
!      imem=member(iset)                                                
      call getnmem(iset,imem) 
                                                                        
                                ! G.W. 24/04/2008                       
      if (qsq.lt.qsqmin) then 
         qsqlog=dlog(1.01D0*qsqmin) 
         call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                    &
     &   cc1(0,1,1,1,1,iset),upv1)                                      
         call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                    &
     &         cc2(0,1,1,1,1,iset),dnv1)                                
         call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                    &
     &         cc3(0,1,1,1,1,iset),glu1)                                
         call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                    &
     &   cc4(0,1,1,1,1,iset),usea1)                                     
         call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                    &
     &   cc6(0,1,1,1,1,iset),str1)                                      
         call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                    &
     &   cc8(0,1,1,1,1,iset),dsea1)                                     
         qsqlog=dlog(qsqmin) 
      end if 
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                       &
     &cc1(0,1,1,1,1,iset),upv)                                          
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                       &
     &cc2(0,1,1,1,1,iset),dnv)                                          
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                       &
     &cc3(0,1,1,1,1,iset),glu)                                          
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                       &
     &cc4(0,1,1,1,1,iset),usea)                                         
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                       &
     &cc6(0,1,1,1,1,iset),str)                                          
      call jeppe2(imem,xlog,qsqlog,nx,nq,xxl,qql,                       &
     &cc8(0,1,1,1,1,iset),dsea)                                         
                                ! G.W. 24/04/2008                       
      if (qsq.lt.qsqmin) then 
!--   Calculate the anomalous dimension, dlog(xf)/dlog(qsq),            
!--   evaluated at qsqmin.  Then extrapolate the PDFs to low            
!--   qsq < qsqmin by interpolating the anomalous dimenion between      
!--   the value at qsqmin and a value of 1 for qsq << qsqmin.           
!--   If value of PDF at qsqmin is very small, just set                 
!--   anomalous dimension to 1 to prevent rounding errors.              
         if (abs(upv).lt.1.D-4)  then
             anom = 1.D0
         else  
             anom = (upv1-upv)/upv/0.01D0 
         endif   
         upv = upv*(qsq/qsqmin)**(anom*qsq/qsqmin+1.D0-qsq/qsqmin)
         if (abs(dnv).lt.1.D-4) then
             anom = 1.D0
         else 
             anom = (dnv1-dnv)/dnv/0.01D0 
         endif
         dnv = dnv*(qsq/qsqmin)**(anom*qsq/qsqmin+1.D0-qsq/qsqmin)
         if (abs(glu).lt.1.D-4) then
             anom = 1.D0
         else 
             anom = (glu1-glu)/glu/0.01D0  
         endif
         glu = glu*(qsq/qsqmin)**(anom*qsq/qsqmin+1.D0-qsq/qsqmin) 
         if (abs(usea).lt.1.D-4) then
             anom = 1.D0 
         else
             anom = (usea1-usea)/usea/0.01D0
         endif 
         usea = usea*(qsq/qsqmin)**(anom*qsq/qsqmin+1.D0-qsq/qsqmin) 
         if (abs(str).lt.1.D-4) then
             anom = 1.D0 
         else
             anom = (str1-str)/str/0.01D0 
         endif
         str = str*(qsq/qsqmin)**(anom*qsq/qsqmin+1.D0-qsq/qsqmin) 
         if (abs(dsea).lt.1.D-4) then
             anom = 1.D0 
         else
             anom = (dsea1-dsea)/dsea/0.01D0 
         endif
         dsea = dsea*(qsq/qsqmin)**(anom*qsq/qsqmin+1.D0-qsq/qsqmin) 
      end if 
                                                                        
                                                                        
                                                                        
      chm=0.d0 
      if(qsq.gt.emc2) then 
      call jeppe2(imem,xlog,qsqlog,nx,nqc,xxl,qqlc,                     &
     &ccc(0,1,1,1,1,iset),chm)                                          
      endif 
                                                                        
      bot=0.d0 
      if(qsq.gt.emb2) then 
      call jeppe2(imem,xlog,qsqlog,nx,nqb,xxl,qqlb,                     &
     &ccb(0,1,1,1,1,iset),bot)                                          
      endif 
                                                                        
      pdf(0)  = glu 
      pdf(1)  = dnv+dsea 
      pdf(-1) = dsea 
      pdf(2)  = upv+usea 
      pdf(-2) = usea 
      pdf(3)  = str 
      pdf(-3) = str 
      pdf(4)  = chm 
      pdf(-4) = chm 
      pdf(5)  = bot 
      pdf(-5) = bot 
      pdf(6)  = 0.0d0 
      pdf(-6) = 0.0d0 
                                                                        
      x=xsave 
      qsq=q2save 
      return 
!                                                                       
      entry MRSTgetgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=1,nx
          gridx(jx)=xx(jx)
      enddo
      do jq=1,nq
          gridq(jq)=qq(jq)
      enddo
      ngridx=nx
      ngridq=nq        
      return
      
      entry MRSTread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
!      print *,nmem(nset),ndef(nset)                                    
!      do nm = 0,nmem-1                                                 
      do nm = 0,nmem(nset) 
        do 20 n=1,nx-1 
        do 20 m=1,nq 
        read(1,50)f1(n,m),f2(n,m),f3(n,m),f4(n,m),                      &
     &                  f5(n,m),f7(n,m),f6(n,m),f8(n,m)                 
! notation: 1=uval 2=val 3=glue 4=usea 5=chm 6=str 7=btm 8=dsea         
   20 continue 
!      write(*,*)'PDF set ',nm,' first element ',f1(1,1)                
      do 40 m=1,nq 
      f1(nx,m)=0.d0 
      f2(nx,m)=0.d0 
      f3(nx,m)=0.d0 
      f4(nx,m)=0.d0 
      f5(nx,m)=0.d0 
      f6(nx,m)=0.d0 
      f7(nx,m)=0.d0 
      f8(nx,m)=0.d0 
   40 continue 
                                                                        
      do n=1,nx 
      xxl(n)=dlog(xx(n)) 
      enddo 
      do m=1,nq 
      qql(m)=dlog(qq(m)) 
      enddo 
                                                                        
      call jeppe1(nm,nx,nq,xxl,qql,f1,cc1(0,1,1,1,1,nset)) 
      call jeppe1(nm,nx,nq,xxl,qql,f2,cc2(0,1,1,1,1,nset)) 
      call jeppe1(nm,nx,nq,xxl,qql,f3,cc3(0,1,1,1,1,nset)) 
      call jeppe1(nm,nx,nq,xxl,qql,f4,cc4(0,1,1,1,1,nset)) 
      call jeppe1(nm,nx,nq,xxl,qql,f6,cc6(0,1,1,1,1,nset)) 
      call jeppe1(nm,nx,nq,xxl,qql,f8,cc8(0,1,1,1,1,nset)) 
                                                                        
      emc2=2.045 
      emb2=18.5 
                                                                        
      do 44 m=1,nqc 
      qqlc(m)=qql(m+nqc0) 
      do 44 n=1,nx 
      fc(n,m)=f5(n,m+nqc0) 
   44 continue 
      qqlc(1)=dlog(emc2) 
      call jeppe1(nm,nx,nqc,xxl,qqlc,fc,ccc(0,1,1,1,1,nset)) 
                                                                        
      do 45 m=1,nqb 
      qqlb(m)=qql(m+nqb0) 
      do 45 n=1,nx 
      fb(n,m)=f7(n,m+nqb0) 
   45 continue 
      qqlb(1)=dlog(emb2) 
      call jeppe1(nm,nx,nqb,xxl,qqlb,fb,ccb(0,1,1,1,1,nset)) 
                                                                        
                                                                        
      enddo 
   50 format(8f10.5) 
      return 
!                                                                       
                                                                        
      entry MRSTalfa(nflav,alfas,Qalfa) 
        call getnset(iset) 
!        mem = member(iset)                                             
!        call setnmem(member(iset))                                     
        call alphamrs(nflav,alfas,Qalfa) 
      return 
!                                                                       
      entry MRSTinit(Eorder,Q2fit) 
      return 
!                                                                       
      entry MRSTpdf(mem) 
!      if(mem.eq.0) mem=ndef                                            
!      imem = mem                                                       
        call getnset(iset) 
!        member(iset)=mem                                               
        call setnmem(iset,mem) 
                                                                        
      return 
!                                                                       
      END                                           

! -*- F90 -*-


subroutine weightPDF(x)
  implicit none
  integer nset,imem,nfmax
  double precision x,Q
  nset=1
  call weightPDFM(nset,x)
  return
  
  entry GetNF(nfmax)
  nset=1
  call GetNFM(nset,nfmax)
  return
  
  entry GetThreshold(imem,Q)
  nset=1
  call GetThresholdM(nset,imem,Q)
  return
end subroutine weightPDF


subroutine parmPDF(nset,x,pdf)
  implicit none
!  include 'parmsetup.inc'
  include 'commonlhasets.inc'
  integer nset
  character*16 name(nmxset)
  integer nmem(nmxset),ndef(nmxset),mem
  common/NAME/name,nmem,ndef,mem
  real xp(40),x4,fgdis4
  character*16 s1,s2
  integer i,j,imem,nop,Nfunc(nmxset),Fw(nmxset),nfmax!,M,parmN
  double precision x,b0,Poly,pdf(-6:6),Fparm(nopmax),F(nofmax)!,N
  double precision Ccoef(nmxset,-6:6,nofmax),Fpow(nmxset,nofmax)
  double precision Q,Treshold(nmxset,-6:6)
  ! data Treshold/39*0d0/
  integer Fmap(nmxset,nofmax,npfmax)
  integer Ftype(nmxset,nofmax),Fn(nmxset,nofmax),Ctype(nmxset,-6:6)
  integer lhasilent
  common/lhasilent/lhasilent
  logical first
  data first/.true./
  save Nfunc,Fn,Fw,Fpow,Fmap,Ccoef,Fparm,Ftype,Ctype,first,Treshold
#ifdef NNPDF
!     NNPDF variables
  INTEGER KREP
  integer MXPDF
  parameter(MXPDF=13)
  integer NTOTPDF 
  parameter(NTOTPDF=5)
  integer MXPAR
  parameter(MXPAR=2e2)
  integer MXL,MXN	   
  parameter(MXL=5,MXN=10)
  integer NPAR(MXPDF)
  integer tnl(ntotpdf),neu(mxl,ntotpdf)
  real*8 XNOR(2,NTOTPDF),PDFNOR(2,NTOTPDF),PDFOUT(MXPDF),FFF(nofmax)
  real*8 PDFEXP(2,NTOTPDF)
  real*8 PDFDELTA(NTOTPDF)
  real*8 XDELTALIN(NTOTPDF),XDELTALOG(NTOTPDF)
  common/nnpdf10CNNARC/PDFEXP,PDFNOR,PDFDELTA,XDELTALIN &
     &     ,XDELTALOG,XNOR,NEU,TNL
!  
#endif
  integer Nx(nmxset), Nt(nmxset), NfMx(nmxset)
  common/ CtqPar2 / Nx, Nt, NfMx
  do i=1,Nfunc(nset)
     if (Ftype(nset,i).eq.1) then
        Poly=1.0
        
        do j=4,Fn(nset,i)
           Poly=Poly+Fparm(Fmap(nset,i,j))*x**(float(j-3)/Fpow(nset,i))
        enddo
        Poly=Fparm(Fmap(nset,i,1))*Poly
        F(i)=x**Fparm(Fmap(nset,i,2))*(1.0-x)**Fparm(Fmap(nset,i,3))*Poly
     endif
     if (Ftype(nset,i).eq.2) then
        if (x.lt.0.9999999) then
           Poly = Fparm(Fmap(nset,i,2))*log(x)+Fparm(Fmap(nset,i,3))*log(1.0-x) &
                + Fparm(Fmap(nset,i,4))*x &
                + Fparm(Fmap(nset,i,6))*log(1.0+x*exp(Fparm(Fmap(nset,i,5))))
           F(i) = Fparm(Fmap(nset,i,1))*exp(Poly)
        else
           F(i)=0d0
        endif
     endif
     if (Ftype(nset,i).eq.101) then
        Poly = exp(Fparm(Fmap(nset,i,1))) * x**(Fparm(Fmap(nset,i,2))-1) * (1d0-x)**Fparm(Fmap(nset,i,3))
        Poly = Poly + (1d0+Fparm(Fmap(nset,i,4))*x) * (1d0-x)**Fparm(Fmap(nset,i,5))
        b0=10d0
        if (Poly.gt.b0) then
           F(i)=Poly
        elseif (Poly.lt.-b0) then
           F(i)=0d0
        else
           F(i)=Poly+log(1d0+exp(-b0*Poly)-exp(-b0))/b0
        endif
     endif
     ! - to add the mrst2004 gluon convolution
     if (Ftype(nset,i).eq.201) then
        xp(2) = Fparm(Fmap(nset,i,1))
        xp(3) = Fparm(Fmap(nset,i,2))
        xp(23)= Fparm(Fmap(nset,i,3))
        xp(16)= Fparm(Fmap(nset,i,4))
        xp(5) = Fparm(Fmap(nset,i,5))
        xp(40)= Fparm(Fmap(nset,i,6))
        xp(24)= Fparm(Fmap(nset,i,7)) 
        xp(20)= Fparm(Fmap(nset,i,8)) 
        xp(4) = Fparm(Fmap(nset,i,9)) 
        xp(1) = Fparm(Fmap(nset,i,10))
        x4 = x
        call gconv(x4,xp,fgdis4)
        F(i) = FGDIS4
     endif

#ifdef NNPDF
!     NNPDF
      if (Ftype(nset,i).eq.301) then
         KREP = mem
         if(krep.le.0.or.krep.gt.1000)then
            write(*,*)"krep has a value not allowed in inputPDF"
         endif
         call LH_PDFIN(x,PDFOUT) ! In wrapXNN.f: pdfout(1:13) sing,g,uv,dv,sv,cv,bv,tv,t3,t8,t15,t24,t35
         call LH_PDFEVLN2INPAR(PDFOUT,FFF)  ! in EVLNNPDF.f: F: sing,g,Triplet,ValTot, SeaAsym
         F(i) = FFF(I)
      endif
     !--
#endif
  enddo
  do i=-6,6
     pdf(i)=0.0
     if (Ctype(nset,i).gt.0) then
        if (Ctype(nset,i).eq.1) then
           do j=1,Nfunc(nset)
              pdf(i)=pdf(i)+Ccoef(nset,i,j)*F(j)
              !  print *,i,j,Ccoef(i,j),F(j)
           enddo
        endif
        if (Ctype(nset,i).eq.101) then
           if (i.eq.-2) then
              pdf(i)=F(int(Ccoef(nset,i,1)))/(F(int(Ccoef(nset,i,2)))+1d0)
           endif
           if (i.eq.-1) then
              pdf(i) = F(int(Ccoef(nset,i,1)))/(1d0/F(int(Ccoef(nset,i,2)))+1d0)
           endif
           if (i.eq.1) then
              pdf(i)=F(1)+pdf(-1)
           endif
           if (i.eq.2) then
              pdf(i)=F(2)+pdf(-2)
           endif
        endif
     endif
  enddo
  ! print *,pdf
  return
  
  entry weightPDFM(nset,x)
  if (Fw(nset).ge.0) then
     x=Fparm(Fw(nset))
  else
     call numberPDF(nop)
     x=1.0/float(nop)
  endif
  return
  
  ! entry GetParmPDFM(nset,imem,x)
  entry GetParmPDF(nset,imem,x)
  x=Fparm(imem)
  return
  
  entry GetNfM(nset,nfmax)
  if (name(nset).eq.'MRST' .or. name(nset).eq.'EVLCTEQ' .or. name(nset)(1:6).eq.'QCDNUM') then
     nfmax=0
     do i=1,6
        if (Treshold(nset,-i).ge.0d0) nfmax=nfmax+1
        if (Treshold(nset,i).ge.0d0) nfmax=nfmax+1
     enddo
     nfmax=nfmax/2
  else if(name(nset)(1:2).eq.'CT') then
     nfmax = NfMx(nset)
  else 
     call getNflavM(nset,nfmax)
  endif
  return
  
  entry GetThresholdM(nset,imem,Q)
  Q=Treshold(nset,imem)
  return
  
  ! entry InitEvolvePDFM(nset,imem)
  entry InitEvolvePDF(nset,imem)
  ! print*, 'calling listPDF',nset,imem
  call listPDF(nset,imem,Fparm)
  ! print *,Fparm
  return
  
  ! entry initInputPDFM(nset)
  entry initInputPDF(nset)
  if(first) then
     do i=1,nmxset
        do j=-6,6
           Treshold(i,j)=0.0d0
        enddo
     enddo
     first=.false.
  endif
  read(1,*) s1,Fw(nset),Nfunc(nset)
  ! print *,s1,Fw,Nfunc
  if (lhasilent.eq.0) then
     write(*,*) 'Parametrization: ',s1
     write(*,*)
  endif
  do i=1,Nfunc(nset)
     Ftype(nset,i)=-1
     read(1,*) s1,s2
     if (index(s2,'x-taylor').eq.1) then
        Ftype(nset,i)=1
        read(1,*) FPow(nset,i),Fn(nset,i)
        read(1,*) (Fmap(nset,i,j),j=1,Fn(nset,i))
     endif
     if (index(s2,'log-pade').eq.1) then
        Ftype(nset,i)=2
        FPow(nset,i)=0d0
        read(1,*) Fn(nset,i)
        read(1,*) (Fmap(nset,i,j),j=1,Fn(nset,i))
     endif
     if (index(s2,'cteq6-ratio').eq.1) then
        Ftype(nset,i)=101
        Fpow(nset,i)=0d0
        Fn(nset,i)=5
        read(1,*) (Fmap(nset,i,j),j=1,Fn(nset,i))
     endif
     if (index(s2,'convol').eq.1) then
        Ftype(nset,i)=201
        read(1,*) Fn(nset,i)
        read(1,*) (Fmap(nset,i,j),j=1,Fn(nset,i))
     endif
#ifdef NNPDF
     if (index(s2,'XNNPDF').eq.1) then
     	Ftype(nset,i)=301
     	read(1,*) tnl(i)
     	read(1,*) (neu(j,i),j=1,tnl(i))
     	read(1,*) (xnor(j,i),j=1,2)
     	read(1,*) (pdfnor(j,i),j=1,2)
     	read(1,*) (pdfexp(j,i),j=1,2)
     	read(1,*) NPAR(i)
     endif
#endif
     if (Ftype(nset,i).lt.0) then
        write(*,*) 'File description error:'
        write(*,*) 'Unknown functional ',s2
        stop
     endif
  enddo
  read(1,*) s1
  do i=-6,6
     Ctype(nset,i)=-1
     read(1,*) s1,s2
     ! print *,s1,s2
     if (index(s2,'none').eq.1) then
        Ctype(nset,i)=0
        Treshold(nset,i)=-1d0
     endif
     if (index(s2,'treshold').eq.1) then
        Ctype(nset,i)=0
        read(1,*) Treshold(nset,i)
     endif
     if (index(s2,'composite').eq.1) then
        Ctype(nset,i)=1
        Treshold(nset,i)=0d0
        read(1,*) (Ccoef(nset,i,j),j=1,Nfunc(nset))
     endif
     if (index(s2,'cteq6-ratio').eq.1) then
        Ctype(nset,i)=101
        Treshold(nset,i)=0d0
        read(1,*) (Ccoef(nset,i,j),j=1,3)
     endif
     if (Ctype(nset,i).lt.0) then
        write(*,*) 'File description error:'
        write(*,*) 'Unknown composit type ',s2
        stop
     endif
  enddo
  if (Fw(nset).ge.0) then
     write(*,*) '***********************************************'
     write(*,*) '* Note that this is a weighted PDF set.       *'
     write(*,*) '* See manual for proper use.                  *'
     write(*,*) '***********************************************'
  endif
  return
end subroutine parmPDF


FUNCTION BETA_LHA(X1,X2)
  CALL GAMMA_LHA(X1,G1,IER)
  IF(IER.NE.0) write(16,*) 'GAMMA_LHA ERROR: IER= ',IER,X1,X2
  CALL GAMMA_LHA(X2,G2,IER)
  IF(IER.NE.0) write(16,*) 'GAMMA_LHA ERROR: IER= ',IER,X1,X2
  X3=X1+X2
  CALL GAMMA_LHA(X3,G3,IER)
  IF(IER.NE.0) write(16,*) 'GAMMA_LHA ERROR: IER= ',IER,X1,X2
  BETA_LHA=G1*G2/G3
  RETURN
END FUNCTION BETA_LHA


SUBROUTINE GAMMA_LHA(XX,GX,IER)
  IF((XX-34.5).LE.0) THEN
     GOTO 6
  ELSE
     GOTO 4
  ENDIF
4 IER=2
  GX=1.E38
  RETURN
6 X=XX
  ERR=1.0E-6
  IER=0
  GX=1.0
  IF((X-2.0).LE.0) THEN
     GOTO 50
  ELSE
     GOTO 15
  ENDIF
10 IF((X-2.0).LE.0) THEN
     GOTO 110
  ELSE
     GOTO 15
  ENDIF
15 X=X-1.0
  GX=GX*X
  GOTO 10
50 IF((X-1.0).LT.0) THEN
     GOTO 60
  ELSE IF ((X-1.0).EQ.0) THEN
     GOTO 120
  ELSE
     GOTO 110
  ENDIF
  ! SEE IF X IS NEAR NEGATIVE INTEGER OR ZERO
60 IF((X-ERR).LE.0) THEN
     GOTO 62
  ELSE
     GOTO 80
  ENDIF
62 K=X
  Y=FLOAT(K)-X
  IF((ABS(Y)-ERR).LE.0) THEN
     GOTO 130
  ELSE
     GOTO 64
  ENDIF
64 IF((1.0-Y-ERR).LE.0) THEN
     GOTO 130
  ELSE
     GOTO 70
  ENDIF
  ! X NOT NEAR A NEGATIVE INTEGER OR ZERO
70 IF((X-1.0).LE.0) THEN
     GOTO 80
  ELSE
     GOTO 110
  ENDIF
80 GX=GX/X
  X=X+1.0
  GOTO 70
110 Y=X-1.0
  GY=1.0+Y*(-0.5771017+Y*(+0.9858540+Y*(-0.8764218+Y*(+0.8328212+Y*(-0.5684729+Y*(+0.2548205+Y*(-0.05149930)))))))
  GX=GX*GY
120 RETURN
130 IER=1
  RETURN
END SUBROUTINE GAMMA_LHA


FUNCTION ALPHA(T,AL)
  COMMON/AINPUT/IORD,QSCT,QSDT
  COMMON/PARAM/PARA(40)
  DATA PI/3.14159/
  DATA TOL/.0005/
  ITH=0
  TT=T
  qsctt=qsct/4.
  qsdtt=qsdt/4.
  ! AL=para(1)
  AL2=AL*AL
  FLAV=4.
  QS=AL2*EXP(T)

  ! CHECK: explicitly initialising ALFQC{3,4,5} (by AB)
  ALFQC3 = 0
  ALFQC4 = 0
  ALFQC5 = 0
  
  if (qs.lt.0.5d0) then   !!  running stops below 0.5
     qs=0.5d0
     t=alog(qs/al2)
     tt=t
  endif
  
  IF(QS.gt.QSCTT) GOTO 12  
  IF(QS.lt.QSDTT) GOTO 312  
11 CONTINUE
  B0=11-2.*FLAV/3. 
  IF(IORD.LE.0) THEN
     GOTO 1
  ELSE
     GOTO 2
  ENDIF
  !     IF(IORD)2,2,2 !TAKE CARE !!
1 CONTINUE
  ALPHA=4.*PI/B0/T
  RETURN
2 CONTINUE
  X1=4.*PI/B0
  B1=102.-38.*FLAV/3.
  X2=B1/B0**2
  AS=X1/T*(1.-X2*aLOG(T)/T)
5 CONTINUE
  F=-T+X1/AS-X2*aLOG(X1/AS+X2)
  FP=-X1/AS**2*(1.-X2/(X1/AS+X2))
  AS2=AS-F/FP
  DEL=ABS(F/FP/AS)
  IF((DEL-TOL).LE.0) THEN
     GOTO 3
  ELSE
     GOTO 4
  ENDIF
3 CONTINUE
  ALPHA=AS2
  IF(ITH.EQ.0) RETURN
  GOTO (13,14,15) ITH
4 CONTINUE
  AS=AS2
  GOTO 5
12 ITH=1
  T=aLOG(QSCTT/AL2)
  GOTO 11
13 ALFQC4=ALPHA
  FLAV=5.   
  ITH=2
  GOTO 11
14 ALFQC5=ALPHA
  ITH=3
  T=TT
  GOTO 11
15 ALFQS5=ALPHA
  ALFINV=1./ALFQS5+1./ALFQC4-1./ALFQC5
  ALPHA=1./ALFINV
  RETURN
311 CONTINUE
  B0=11-2.*FLAV/3. 
  IF(IORD.LE.0)THEN
     GOTO 31
  ELSE
     GOTO 32
  ENDIF
  !     IF(IORD)32,32,32 !TAKE CARE !!
31 CONTINUE
  ALPHA=4.*PI/B0/T
  RETURN
32 CONTINUE
  X1=4.*PI/B0
  B1=102.-38.*FLAV/3.
  X2=B1/B0**2
  AS=X1/T*(1.-X2*aLOG(T)/T)
35 CONTINUE
  F=-T+X1/AS-X2*aLOG(X1/AS+X2)
  FP=-X1/AS**2*(1.-X2/(X1/AS+X2))
  AS2=AS-F/FP
  DEL=ABS(F/FP/AS)
  ! IF(DEL-TOL)33,33,34
  IF((DEL-TOL).LE.0) THEN
     GOTO 33
  ELSE
     GOTO 34
  ENDIF
33 CONTINUE
  ALPHA=AS2
  IF(ITH.EQ.0) RETURN
  GOTO (313,314,315) ITH
34 CONTINUE
  AS=AS2
  GOTO 35
312 ITH=1
  T=aLOG(QSDTT/AL2)
  GOTO 311
313 ALFQC4=ALPHA
  FLAV=3.   
  ITH=2
  GOTO 311
314 ALFQC3=ALPHA
  ITH=3
  T=TT
  GOTO 311
315 ALFQS3=ALPHA
  ALFINV=1./ALFQS3+1./ALFQC4-1./ALFQC3
  ALPHA=1./ALFINV
  RETURN
END FUNCTION ALPHA


SUBROUTINE WATE96
  !*******************************************************************
  !*****              *****
  !***** THE X(I) AND W(I) ARE THE DIRECT OUTPUT FROM A PROGRAM  *****
  !***** USING NAG ROUTINE D01BCF TO CALCULATE THE        *****
  !***** GAUSS-LEGENDRE WEIGHTS FOR 96 POINT INTEGRATION.        *****
  !***** THEY AGREE TO TYPICALLY 14 DECIMAL PLACES WITH THE      *****
  !***** TABLE IN ABRAMOWITZ & STEGUN, PAGE 919.         *****
  !*****              *****
  !***** ---->   PETER HARRIMAN, APRIL 3RD 1990.         *****
  !*****              *****
  !*******************************************************************
  DIMENSION X(48),W(48)
  COMMON/GAUS96/XI(96),WI(96),nterms,XX(97)
  NTERMS=96
  X( 1)=   0.01627674484960183561
  X( 2)=   0.04881298513604856015
  X( 3)=   0.08129749546442434360
  X( 4)=   0.11369585011066471632
  X( 5)=   0.14597371465489567682
  X( 6)=   0.17809688236761733390
  X( 7)=   0.21003131046056591064
  X( 8)=   0.24174315616383866556
  X( 9)=   0.27319881259104774468
  X(10)=   0.30436494435449495954
  X(11)=   0.33520852289262397655
  X(12)=   0.36569686147231213885
  X(13)=   0.39579764982890709712
  X(14)=   0.42547898840729897474
  X(15)=   0.45470942216774136446
  X(16)=   0.48345797392059470382
  X(17)=   0.51169417715466604391
  X(18)=   0.53938810832435567233
  X(19)=   0.56651041856139533470
  X(20)=   0.59303236477757022282
  X(21)=   0.61892584012546672523
  X(22)=   0.64416340378496526886
  X(23)=   0.66871831004391424358
  X(24)=   0.69256453664216964528
  X(25)=   0.71567681234896561582
  X(26)=   0.73803064374439816819
  X(27)=   0.75960234117664555964
  X(28)=   0.78036904386743123629
  X(29)=   0.80030874413913884180
  X(30)=   0.81940031073792957139
  X(31)=   0.83762351122818502758
  X(32)=   0.85495903343459936363
  X(33)=   0.87138850590929436968
  X(34)=   0.88689451740241818933
  X(35)=   0.90146063531585023110
  X(36)=   0.91507142312089592706
  X(37)=   0.92771245672230655266
  X(38)=   0.93937033975275308073
  X(39)=   0.95003271778443564022
  X(40)=   0.95968829144874048809
  X(41)=   0.96832682846326217918
  X(42)=   0.97593917458513455843
  X(43)=   0.98251726356301274934
  X(44)=   0.98805412632962202890
  X(45)=   0.99254390032376081654
  X(46)=   0.99598184298720747465
  X(47)=   0.99836437586317963722
  X(48)=   0.99968950388322870559
  W( 1)=   0.03255061449236316962
  W( 2)=   0.03251611871386883307
  W( 3)=   0.03244716371406427668
  W( 4)=   0.03234382256857594104
  W( 5)=   0.03220620479403026124
  W( 6)=   0.03203445623199267876
  W( 7)=   0.03182875889441101874
  W( 8)=   0.03158933077072719007
  W( 9)=   0.03131642559686137819
  W(10)=   0.03101033258631386231
  W(11)=   0.03067137612366917839
  W(12)=   0.03029991542082762553
  W(13)=   0.02989634413632842385
  W(14)=   0.02946108995816795100
  W(15)=   0.02899461415055528410
  W(16)=   0.02849741106508543861
  W(17)=   0.02797000761684838950
  W(18)=   0.02741296272602931385
  W(19)=   0.02682686672559184485
  W(20)=   0.02621234073567250055
  W(21)=   0.02557003600534944960
  W(22)=   0.02490063322248370695
  W(23)=   0.02420484179236479915
  W(24)=   0.02348339908592633665
  W(25)=   0.02273706965832950717
  W(26)=   0.02196664443874448477
  W(27)=   0.02117293989219144572
  W(28)=   0.02035679715433347898
  W(29)=   0.01951908114014518992
  W(30)=   0.01866067962741165898
  W(31)=   0.01778250231604547316
  W(32)=   0.01688547986424539715
  W(33)=   0.01597056290256253144
  W(34)=   0.01503872102699521608
  W(35)=   0.01409094177231515264
  W(36)=   0.01312822956696188190
  W(37)=   0.01215160467108866759
  W(38)=   0.01116210209983888144
  W(39)=   0.01016077053500880978
  W(40)=   0.00914867123078384552
  W(41)=   0.00812687692569928101
  W(42)=   0.00709647079115442616
  W(43)=   0.00605854550423662775
  W(44)=   0.00501420274292825661
  W(45)=   0.00396455433844564804
  W(46)=   0.00291073181793626202
  W(47)=   0.00185396078894924657
  W(48)=   0.00079679206555731759
  DO I=1,48
     XI(I)=-X(49-I)
     WI(I)=W(49-I)
     XI(I+48)=X(I)
     WI(I+48)=W(I)
  END DO
  DO I=1,96
     XX(I)=0.5*(XI(I)+1.)
  END DO
  XX(97)=1.0
  EXPON=1.0
  DO I=1,96
     YI=2.*(0.5*(1.+XI(I)))**EXPON-1.
     WI(I)=WI(I)/(1.+XI(I))*(1.+YI)*EXPON
     XI(I)=YI
     XX(I)=0.5*(1.+YI)
  END DO
  RETURN
END SUBROUTINE WATE96

        
subroutine gconv(x,xp,fgdis)
  COMMON/AINPUT/IORD,QSCT,QSDT
  common/GAUS96/XI(96),WI(96),NTERMS,XX(97)
  dimension xp(40)
  logical first
  data first/.true./
  if (first) then
     call wate96
     first=.false.
  endif
  PI = 3.14159
  PI2 = PI*PI
  iord = 1
  qsdt=8.18    !!  This is the value of 4m_c^2
  qsct=74.0    !!  This is the value of 4m_b^2
  cf = 4./3.
  eta4 = xp(40)
  T=alog(1/xp(1)**2)
  ! AL = 0.550/(4.* 3.14159)
  AL=ALPHA(T,xp(1))/(4.* pi)
  rx=sqrt(x)
  FF1 = BETA_LHA(XP(2),XP(3)+1.)+XP(16)*BETA_LHA(XP(2)+1.,XP(3)+1.)+XP(23)*BETA_LHA(XP(2)+0.5,XP(3)+1.)
  FF2 = BETA_LHA(XP(2)+1.,XP(3)+1.)+XP(16)*BETA_LHA(XP(2)+2.,XP(3)+1.)+XP(23)*BETA_LHA(XP(2)+1.5,XP(3)+1.)
  FF3 = BETA_LHA(XP(5),ETA4+1.)+XP(20)*BETA_LHA(XP(5)+1.,ETA4+1.)+XP(24)*BETA_LHA(XP(5)+0.5,ETA4+1.)
  FF4 = BETA_LHA(XP(5)+1.,ETA4+1.)+XP(20)*BETA_LHA(XP(5)+2.,ETA4+1.)+XP(24)*BETA_LHA(XP(5)+1.5,ETA4+1.)
  COEFU = 2.*XP(4)/FF1
  COEFD =    XP(4)/FF3
  ! print *,'coefu ',coefu
  ! print *,'coefd ',coefd
  UV=coefu*X**XP(2)*(1.-X)**XP(3)*(1.+XP(16)*X+XP(23)*SQRT(X))
  DV=coefd*X**XP(5)*(1.-X)**ETA4*(1.+XP(20)*X+XP(24)*SQRT(X))
  FGDIS=al*CF*(-9.-2.*PI2/3.+alog(1.-x)*(-3.+2.*alog(1.-x)))*(UV+DV)
     
  DO M=1,NTERMS
     Y=0.5*(1.-X)*XI(M)+0.5*(1.+X)
     XY=X/Y
     UVXY = coefu*XY**XP(2) * (1.-XY)**XP(3) * (1.+XP(16) * XY + XP(23) * SQRT(XY))
     DVXY = coefd*XY**XP(5) * (1.-XY)**ETA4 * (1.+XP(20) * XY + XP(24) * SQRT(XY))
     AL1=ALOG(1.-Y)
     C22=CF*(6.+4.*Y-2.*(1.+Y*Y)/(1.-Y)*ALOG(Y)-2.*(1.+Y)*ALOG(1.-Y))
     C23=CF*(-3.+4.*ALOG(1.-Y))/(1.-Y)
     FGDIS=FGDIS+.5*(1.-X)*WI(M)*al*(C22*(uvxy+dvxy)+C23*(uvxy+dvxy-uv-dv))
  END DO
   
  return
end subroutine gconv

! -*- F90 -*-


subroutine GetLam4(mem,lam4)
  implicit none
  integer mem,nset
  double precision lam4,lam5
  nset = 1
  call GetLam4M(nset,mem,lam4)
  return
  
  entry GetLam5(mem,lam5)
  nset = 1
  call GetLam5M(nset,mem,lam5)
  return
end subroutine GetLam4


subroutine GetXmin(mem,xmin)
  implicit none
  integer mem,nset
  double precision xmin,xmax,q2min,q2max
  nset = 1
  call GetXminM(nset,mem,xmin)
  return
  
  entry GetXmax(mem,xmax)
  nset = 1
  call GetXmaxM(nset,mem,xmax)
  return
  
  entry GetQ2min(mem,q2min)
  nset = 1
  call GetQ2minM(nset,mem,q2min)
  return
  
  entry GetQ2max(mem,q2max)
  nset = 1
  call GetQ2maxM(nset,mem,q2max)
  return
  
  entry GetMinMax(mem,xmin,xmax,q2min,q2max)
  nset = 1
  call GetMinMaxM(nset,mem,xmin,xmax,q2min,q2max)
  return
end subroutine GetXmin

      
subroutine initQCDparams(nset)
  implicit double precision(a-h,o-z)
  include 'parmsetup.inc'
  double precision parmQCD(nmxset,0:noemax,2),lam4,lam5
  integer nset
  ! integer iset,imem
  ! common/SET/iset,imem
  save
  read(1,*)nmem,nrep
  if(nrep.eq.0) then
     do i=0,nmem
        read(1,*) (parmQCD(nset,i,j),j=1,2)
     enddo
  else
     read(1,*) (parmQCD(nset,0,j),j=1,2)
     do i=1,nmem
        do j=1,2
           parmQCD(nset,i,j)=parmQCD(nset,0,j)
        enddo
     enddo
  endif
  return
  
  entry GetLam4M(nset,mem,lam4)
  lam4 = parmQCD(nset,mem,1)
  return
  
  entry GetLam5M(nset,mem,lam5)
  lam5 = parmQCD(nset,mem,2)
  return
end subroutine initQCDparams

      
subroutine initMinMax(nset)
  implicit double precision(a-h,o-z)
  include 'parmsetup.inc'
  double precision parmXmin(nmxset,0:noemax),xmin
  double precision parmXmax(nmxset,0:noemax),xmax
  double precision parmQ2min(nmxset,0:noemax),q2min
  double precision parmQ2max(nmxset,0:noemax),q2max
  integer nset
  save
  read(1,*)nmem,nrep
  if(nrep.eq.0) then
     do i=0,nmem
        read(1,*) &
             parmXmin(nset,i),&
             parmXmax(nset,i),&
             parmQ2min(nset,i),&
             parmQ2max(nset,i)
     enddo
  else
     read(1,*) &
          parmXmin(nset,0),&
          parmXmax(nset,0),&
          parmQ2min(nset,0),&
          parmQ2max(nset,0)
     do i=1,nmem
        parmXmin(nset,i) = parmXmin(nset,0)
        parmXmax(nset,i) = parmXmax(nset,0)
        parmQ2min(nset,i) = parmQ2min(nset,0)
        parmQ2max(nset,i) = parmQ2max(nset,0)
     enddo
  endif
  return

  entry GetXminM(nset,mem,xmin)
  xmin = parmXmin(nset,mem)
  return
  
  entry GetXmaxM(nset,mem,xmax)
  xmax = parmXmax(nset,mem)
  return
  
  entry GetQ2minM(nset,mem,q2min)
  q2min = parmQ2min(nset,mem)
  return
  
  entry GetQ2maxM(nset,mem,q2max)
  q2max = parmQ2max(nset,mem)
  return
  
  entry GetMinMaxM(nset,mem,xmin,xmax,q2min,q2max)
  xmin = parmXmin(nset,mem)
  xmax = parmXmax(nset,mem)
  q2min = parmQ2min(nset,mem)
  q2max = parmQ2max(nset,mem)
  return
end subroutine initMinMax

      subroutine HERAevolve(x,Q,pdf)
      implicit double precision (a-h,o-z)
      include 'parmsetup.inc'
      character*64 gridname
      character*16 name(nmxset)
      integer nmem(nmxset),ndef(nmxset),mem
      common/NAME/name,nmem,ndef,mem
      integer nset,iset,isetlast
      data isetlast/-1/
      integer Eorder
      real*8 mc,mc2,mb,mb2,mt,mt2
      real*8 f(-6:6),pdf(-6:6)
      integer qnerr
      parameter(nstartp=7)
      DIMENSION QSP(NSTARTP)
      DATA QSP/10.,20.,30.,40.,50.,80.,100./
      real*8 xval(45)
      logical HEAVY,VFN
      real*8 pwgt(20)
      save
!
      call getnset(iset)
!      print *,'iset=',iset,' now calling get_pdfqcd'
      if(iset.ne.isetlast) then
        call get_pdfqcd(iset)
        isetlast = iset
      endif
!
      Q2=Q*Q
      UCENT=QPDFXQ('UPVAL',X,Q2,IFAIL)
      DCENT=QPDFXQ('DNVAL',X,Q2,IFAIL)
      GCENT=QPDFXQ('GLUON',X,Q2,IFAIL)
      UBCEN=QPDFXQ('UB',X,Q2,IFAIL)
      DBCEN=QPDFXQ('DB',X,Q2,IFAIL)
      STCEN=QPDFXQ('SB',X,Q2,IFAIL)
      IF(Q2.GE.Q2C)THEN
        CHCEN=QPDFXQ('CB',X,Q2,IFAIL)
      ELSE
        CHCEN=0.0
      ENDIF
      IF(Q2.GE.Q2B)THEN
        BTCEN=QPDFXQ('BB',X,Q2,IFAIL)
      ELSE
        BTCEN=0.0
      ENDIF
      pdf(1)=dcent+dbcen
      pdf(2)=ucent+ubcen
      pdf(3)=stcen
      pdf(4)=chcen
      pdf(5)=btcen
      pdf(6)=0d0
      pdf(0)=gcent
      pdf(-1)=dbcen
      pdf(-2)=ubcen
      pdf(-3)=stcen
      pdf(-4)=chcen
      pdf(-5)=btcen
      pdf(-6)=0d0
!
      return
!
!===========================================================================
      entry HERAalfa(alfas,Q)
      Q2=Q*Q
      nf=6
      if (Q2.lt.mt2) nf=5
      if (Q2.lt.mb2) nf=4
      if (Q2.lt.mc2) nf=3
      alfas=QALFAS(Q2,Qlam,nf,iflag)
!      print *,q2,alfas,qlam,nf,iflag
      return
!
!===========================================================================
      entry HERAread(nset)
         read(1,*) gridname,nx,xmin,xmax,nq,qmin,qmax
!	 print *,gridname,nx,xmin,xmax,nq,qmin,qmax,' from HERAread'
      return
!
!===========================================================================
      entry HERAinit(nset,Eorder,Q2fit)
!      print *,name(nset), ' from HERAinit'
      if(name(nset).eq.'QCDNUM_HERA_TR') then
         HEAVY = .FALSE.
	 VFN = .TRUE.
      else if(name(nset).eq.'QCDNUM_HERA_FF') then
         HEAVY = .TRUE.
	 VFN = .FALSE.
      else if(name(nset).eq.'QCDNUM_HERA_ZM') then
         HEAVY = .FALSE.
	 VFN = .FALSE.
      else
        print *,'name/scheme not recognized'
	stop 1
      endif
!--try 3 way logic ffn/zm-vfn/rt-vfn
      IF(HEAVY)THEN
      IVFN=1
      ELSE
      IVFN=0
      ENDIF
      IF(VFN)THEN
      IVFN=IVFN+2
      ELSE
      IVFN=IVFN
      ENDIF
! IVFN=0 IS ZM-VFN, 1 IS FFN,2 IS RT-VFN, 3 IS NOT ALLOWED  

      IF(IVFN.EQ.3)THEN
      WRITE(*,*)'IVFN=3 SO STOP',IVFN
      STOP
      ENDIF    

      
      
!--qcdnum initialisation
      CALL QNINIT
!--se thresholds
      Q0=Q2fit
      ZM=91.187D0
      ZM2=ZM*ZM
      ALPHAS=QNALFA(ZM2)

      call getQmassM(nset,4,mc)
      mc2=mc*mc
      call getQmassM(nset,5,mb)
      mb2=mb*mb
      call getQmassM(nset,6,mt)
      mt2=mt*mt
    
!      Q2C=1.8225
      Q2C=mc2
!      Q2B=18.49
      Q2B=mb2 
!      print  *,q2c,q2b    
      q2t=mt2

      IF (Q0.LT.Q2C) THEN
        NACT=3
      ELSE
        NACT=4
      ENDIF
!--this merely defines nact where we startevolution
!--namely at q0
      IF (HEAVY) NACT=3

      CALL QNRSET('MCSTF',SQRT(Q2C))
      CALL QNRSET('MBSTF',SQRT(Q2B))
      CALL QNRSET('MCALF',SQRT(Q2C))
      CALL QNRSET('MBALF',SQRT(Q2B))
      CALL QNRSET('MTALF',SQRT(Q2T))
    
      IF (HEAVY) THEN
        CALL QTHRES(1D10,2D10)
!        CALL QTHRES(1D6,2D6)
      ELSE
        CALL QTHRES(Q2C,Q2B)
      ENDIF
 
      DO I=1,NSTARTP
        CALL GRQINP(QSP(I),1)
      ENDDO
      CALL GRQINP(Q0,1)
      CALL GRQINP(Q2C,1)
      CALL GRQINP(Q2B,1)
!      qcdnum grid not my grid

!      CALL GRXLIM(120,97D-8)
!      print *,'nx = ',nx
      CALL GRXLIM(nx,xmin)

!      CALL GRQLIM(61,29D-2,200D3) 
!      print *,'nq = ',nq
      CALL GRQLIM(nq,qmin,qmax) 

!--   Get final grid definitions and grid indices of Q0, Q2C and Q2B

      CALL GRGIVE(NXGRI,XMI,XMA,NQGRI,QMI,QMA)
!      WRITE(*,*)'NX,XL,XH,NQ,QL,QH',NXGRI,XMI,XMA,NQGRI,QMI,QMA
      IQ0 = IQFROMQ(Q0)
      IQC = IQFROMQ(Q2C)
      IQB = IQFROMQ(Q2B)
!--   Allow for heavy weights

      IF (HEAVY) THEN
        CALL QNLSET('WTF2C',.TRUE.)
        CALL QNLSET('WTF2B',.TRUE.)
        CALL QNLSET('CLOWQ',.FALSE.)
        CALL QNLSET('WTFLC',.TRUE.)
        CALL QNLSET('WTFLB',.TRUE.)
      ENDIF

!--   Compute weights and dump, or read in
!
!      IF (READIN) THEN 
!        OPEN(UNIT=24,FILE='weights.dat',FORM='UNFORMATTED',
!     .                                  STATUS='UNKNOWN')
!        CALL QNREAD(24,ISTOP,IERR)
!      ELSE
!        CALL QNFILW(0,0)
!        IF (HEAVY) THEN
!          OPEN(UNIT=24,FILE='weights.dat',FORM='UNFORMATTED',
!     .                                    STATUS='UNKNOWN')
!          CALL QNDUMP(24)
!        ENDIF
!      ENDIF


      if (index(gridname,'none').eq.1) then
         call qnfilw(0,0)
      else
         qnerr=-1
         open(unit=2,status='old',file=gridname, &
     &        form='unformatted',err=1)
         call QNREAD(2,1,qnerr)
 1       close(2)
         if (qnerr.ne.0) then
            write(*,*) 'Grid file problem: ',gridname
            if (qnerr.lt.0) then 
               write(*,*) 'Grid file does not exist'
               write(*,*) 'Calculating and creating grid file'
               call qnfilw(0,0)
               open(unit=2,status='unknown',file=gridname, &
     &              form='unformatted')
               call QNDUMP(2)
               close(2)
            else
               write(*,*) 'Existing grid file is inconsistent'
               if (qnerr.eq.1) &
     &              write(*,*) 'Defined grid different'
               if (qnerr.eq.2) &
     &              write(*,*) 'Heavy quark weight table different'
               if (qnerr.eq.3) &
     &              write(*,*) 'Charm mass different'
               if (qnerr.eq.4) &
     &              write(*,*) 'Bottom mass different'
               stop
            endif
         endif
      endif

!--   Apply cuts to grid
!--taking away the s cut at 600d0
      CALL GRCUTS(-1D0,-1D0,-1D0,-1D0)




!--   Choose renormalisation and factorisation scales

      CALL QNRSET('AAAR2',1D0)  ! renormalisation
      CALL QNRSET('BBBR2',0D0)
      CALL QNRSET('AAM2L',1D0)  ! factorisation (light)
      CALL QNRSET('BBM2L',0D0)
      CALL QNRSET('AAM2H',1D0)  ! factorisation (heavy)
      CALL QNRSET('BBM2H',0D0)
 
!       ZM=91.187D0
      imem=0
!      print *,imem
! -- only need call to listPDF here to get alphas
      call listPDF(nset,imem,xval)
!      print *,xval
        AS=XVAL(13)
!        AS=0.118d0
      CALL QNRSET('ALFQ0',ZM*ZM)
      CALL QNRSET('ALFAS',AS)

!      ZM2=ZM*ZM
      ALPHAS=QNALFA(ZM2)
      WRITE(*,*)'ALPHAS AT Mz2',ALPHAS

!--   Book non-singlet distributions

      CALL QNBOOK(2,'UPLUS')
      CALL QNBOOK(3,'DPLUS')
      CALL QNBOOK(4,'SPLUS')
      CALL QNBOOK(5,'CPLUS')
      CALL QNBOOK(6,'BPLUS')
      CALL QNBOOK(7,'UPVAL')
      CALL QNBOOK(8,'DNVAL')
 
!--   Book linear combinations for proton for f = 3,4,5 flavours

!--define some quark pdfs
         CALL dVZERO(PWGT,20)        
        PWGT(2) = 0.5

        PWGT(7) = -0.5

        PWGT(1) = 0.5/3.
        CALL QNLINC(17,'UB',3,PWGT)
        PWGT(1) = 0.5/4.
        CALL QNLINC(17,'UB',4,PWGT)
        PWGT(1) = 0.5/5.
        CALL QNLINC(17,'UB',5,PWGT) 
        CALL dVZERO(PWGT,20) 

        PWGT(4) = 0.5
        PWGT(1) = 0.5/3.
        CALL QNLINC(18,'SB',3,PWGT)
        PWGT(1) = 0.5/4.
        CALL QNLINC(18,'SB',4,PWGT)
        PWGT(1) = 0.5/5.
        CALL QNLINC(18,'SB',5,PWGT)
         CALL dVZERO(PWGT,20)        
        CALL QNLINC(19,'CB',3,PWGT)
        PWGT(5) = 0.5
        PWGT(1) = 0.5/4.

        CALL QNLINC(19,'CB',4,PWGT)
        PWGT(1) = 0.5/5.
        CALL QNLINC(19,'CB',5,PWGT) 
        CALL dVZERO(PWGT,20) 
        PWGT(3) = 0.5

        PWGT(8) = -0.5

        PWGT(1) = 0.5/3.
        CALL QNLINC(20,'DB',3,PWGT)
        PWGT(1) = 0.5/4.
        CALL QNLINC(20,'DB',4,PWGT)
        PWGT(1) = 0.5/5.
        CALL QNLINC(20,'DB',5,PWGT)
         CALL dVZERO(PWGT,20)        
        CALL QNLINC(21,'BB',3,PWGT)
       CALL QNLINC(21,'BB',4,PWGT)  
        PWGT(6) = 0.5
  
        PWGT(1) = 0.5/5.
        CALL QNLINC(21,'BB',5,PWGT) 
!---

      return
!
!==========================================================================
      entry HERApdf(nset)
!      print *,'calling HERApdf ',nset
!      ZM = 91.187d0
!      zm2 = zm*zm

!      ALPHAS=QNALFA(ZM2)
      
      
!      imem=mem
      call getnmem(nset,imem)    
      call listPDF(nset,imem,xval)
!      print *,xval
!      print *,imem,xval

        FS=XVAL(14)
        FC=XVAL(15)
!-- iremeber to change fs and fc with choices of Q20, and fc with =
!-- choices of mc.
!
!-- the free parameters are XVAL(1),2,3,4,6,9,10,11,12,13,14 which are :

!- 1,2,3,4 the parameters of the u_valence quark
!--ignore the names UA,Ub in the code, in the write-up these are called
!--x^B(1-x)^C (1+D x+E x^2) where 1=B,2=C,3=E,4=D.. you can see =
!--this from reading the code, but i thought it c--best to spell it out, =
!--normalisation comes from number sum-rule and is done in the code


      UA=XVAL(1)
      UB=XVAL(2)
      UE=XVAL(3)
      UC=XVAL(4)
!... 6 is the only free parameter for the d-valence: 6=C, where x^B =
!(1-x)^C, the B parameter is set equal to c--that of the u-valence, where =
!-- DA=UA means that B=1 again. normalisation comes from number sum-rule =
!c-- and is done in the code
      DA=UA
      DB=XVAL(5)
      DE=0.0
      DC=0.0
!------sea is in two bits Ubar and Dbar: parameter XVAL(9) gives an =
!overall sea normalisation, which is split up
!-- into Ubar (UBN)and Dbar(DBN) using the fractions fc and fs in the =
!-- code below
      SN=XVAL(6)
!-- Ubar and Dbar share a common low -x slope parameter XVAL(10), so =
!-- both Ubar and Dbar take the form
!--  X^B(1-x)C, B=10 is the same for both C=11 for Ubar and C=12 =
!--for Dbar
      SA=XVAL(7)
      SB=XVAL(8)
      SC=XVAL(9)
      SE=0.
!--- make sea more complex
      UBA=SA
      DBA=SA
      UBB=SB
      DBB=SC
      UBC=0.
      DBC=0.
      UBE=0.
      DBE=0.
!      UBN=SN/4.
!      DBN=SN/4.
       UBN=SN/2.*(1.-FS)/(2.-FS-FC)
       DBN=SN/2.*(1.-FC)/(2.-FS-FC)
!-- now for a simple gluon param. x^B(1-x)^C, where B=13 and C=14, =
!-- and norm comes from the momentum sum-rule c--below.
      GA=XVAL(10)
      GB=XVAL(11)
      GC=XVAL(12)
      GE=0.0d0
      
      AS=XVAL(13)
!-- alphas is 0.1176 and parameter 17 is not free in the fit
       CALL QNRSET('ALFAS',AS)

!--   Input quark distributions at Q2 = Q02 GeV2
       UN=2./AREA(UA-1,UB,UE,UC)
       DN=1./AREA(DA-1,DB,DE,DC)
        GN=(1-UN*AREA(UA,UB,UE,UC)- &
     &        DN*AREA(DA,DB,DE,DC)-2.*UBN*AREA(UBA,UBB,UBE,UBC) &
     &       -2.*DBN*AREA(DBA,DBB,DBE,DBC))/AREA(GA,GB,GE,GC)

      nxgri = nx
      DO IX = 1,NXGRI
        xX = XFROMIX(IX)
        UPVAL=UN*FF_LHA2(xX,UA,UB,UE,UC)
        DNVAL=DN*FF_LHA2(xX,DA,DB,DE,DC)
        UBAR=UBN*FF_LHA2(xX,UBA,UBB,UBE,UBC)
        DBAR=DBN*FF_LHA2(xX,DBA,DBB,DBE,DBC)
        SEA=2.*(UBAR+DBAR)

        SINGL=UPVAL+DNVAL+SEA  
!
        GLUON=GN*FF_LHA2(xX,GA,GB,GE,GC)

        UBQ=(1.-FC)*UBAR
        CBQ=FC*UBAR
        DBQ=(1.-FS)*DBAR
        SBQ=FS*DBAR
        USEA=2*UBQ
        DSEA=2*DBQ
        SSEA=2*SBQ
        CSEA=2*CBQ
!
        UPLUS=UPVAL+USEA-1./NACT*SINGL
        DPLUS=DNVAL+DSEA-1./NACT*SINGL
        SPLUS=SSEA-1./NACT*SINGL
        CPLUS=CSEA-1./NACT*SINGL
!-- the fraction of charm is simply imposed- not dynamically generated
        CALL QNPSET('GLUON',IX,IQ0,GLUON)
        CALL QNPSET('SINGL',IX,IQ0,SINGL)
        CALL QNPSET('UPLUS',IX,IQ0,UPLUS)
        CALL QNPSET('DPLUS',IX,IQ0,DPLUS)
        CALL QNPSET('SPLUS',IX,IQ0,SPLUS)
        CALL QNPSET('CPLUS',IX,IQ0,CPLUS)
        CALL QNPSET('UPVAL',IX,IQ0,UPVAL)
        CALL QNPSET('DNVAL',IX,IQ0,DNVAL)
      ENDDO
!--THINGS ARE FINE FOR HEAVY SO DO IT
!       print *, 'HEAVY is: ',heavy, 'NACT is: ',nact
       IF (HEAVY) THEN

!--     Evolve over whole grid

        CALL EVOLSG(IQ0,1,NQGRI)
        CALL EVPLUS('UPLUS',IQ0,1,NQGRI)
        CALL EVPLUS('DPLUS',IQ0,1,NQGRI)
        CALL EVPLUS('SPLUS',IQ0,1,NQGRI)
        CALL EVOLNM('UPVAL',IQ0,1,NQGRI)
        CALL EVOLNM('DNVAL',IQ0,1,NQGRI)

      ELSE

!--     Evolve gluon, singlet and valence over whole grid
        CALL EVOLSG(IQ0,1,NQGRI)
        CALL EVOLNM('UPVAL',IQ0,1,NQGRI)
        CALL EVOLNM('DNVAL',IQ0,1,NQGRI)
!--     Be more careful with plus distributions
        IF (NACT.EQ.3) THEN
!--THINGS ARE ALSO FINE IF 1Q0 IS BELOW 1QC THEN CLEARLY CSEA=0. IS OK
!--SITUATION CD BE 1<Q0<Q2C<Q2B ETC
!--GO DOWN QO TO 1 UP Q0 TO  Q2C
          CALL EVPLUS('UPLUS',IQ0,1,IQC)
          CALL EVPLUS('DPLUS',IQ0,1,IQC)
          CALL EVPLUS('SPLUS',IQ0,1,IQC)
!--DEAL WITH CHARM THRESH
          FACTOR=1./3.-1./4.
          CALL QADDSI('UPLUS',IQC,FACTOR)
          CALL QADDSI('DPLUS',IQC,FACTOR)
          CALL QADDSI('SPLUS',IQC,FACTOR)
          CALL QNPNUL('CPLUS')
          FACTOR=-1/4.
          CALL QADDSI('CPLUS',IQC,FACTOR)
!--GO UP Q2C TO Q2B
          CALL EVPLUS('UPLUS',IQC,IQC,IQB)
          CALL EVPLUS('DPLUS',IQC,IQC,IQB)
          CALL EVPLUS('SPLUS',IQC,IQC,IQB)
          CALL EVPLUS('CPLUS',IQC,IQC,IQB)


        ELSEIF(NACT.EQ.4)THEN

!-NOW DO MIDDLE FOR UPLUS,DPLUS,SPLUS,CPLUS
          CALL EVPLUS('UPLUS',IQ0,IQC,IQB)
          CALL EVPLUS('DPLUS',IQ0,IQC,IQB)
          CALL EVPLUS('SPLUS',IQ0,IQC,IQB)
          CALL EVPLUS('CPLUS',IQ0,IQC,IQB)
!--THEN GO DOWN IQC TO 1
             IF(IQC.GT.1)THEN
             FACTOR=1./4.-1./3.
             CALL QADDSI('UPLUS',IQC,FACTOR)
             CALL QADDSI('DPLUS',IQC,FACTOR)
             CALL QADDSI('SPLUS',IQC,FACTOR)
             CALL EVPLUS('UPLUS',IQC,1,IQC)
             CALL EVPLUS('DPLUS',IQC,1,IQC)
             CALL EVPLUS('SPLUS',IQC,1,IQC)
             ENDIF

        ENDIF
!--THEN DEAL WITH B THRESHOLD FOR ALL4
        FACTOR=1./4.-1./5.
        CALL QADDSI('UPLUS',IQB,FACTOR)
        CALL QADDSI('DPLUS',IQB,FACTOR)
        CALL QADDSI('SPLUS',IQB,FACTOR)
        CALL QADDSI('CPLUS',IQB,FACTOR)
!--THEN GO UP
        IF(IQB.LT.NQGRI)THEN
       CALL EVPLUS('UPLUS',IQB,IQB,NQGRI)
        CALL EVPLUS('DPLUS',IQB,IQB,NQGRI)
        CALL EVPLUS('SPLUS',IQB,IQB,NQGRI)
        CALL EVPLUS('CPLUS',IQB,IQB,NQGRI)
        ENDIF
!C--THEN DEAL WITH B TURNING ON AT IQB AND GO UP
        CALL QNPNUL('BPLUS')
        FACTOR=-1./5.
       CALL QADDSI('BPLUS',IQB,FACTOR)
        CALL EVPLUS('BPLUS',IQB,IQB,NQGRI)
      ENDIF 
      AMSR= GN*AREA(GA,GB,GE,GC)+UN*AREA(UA,UB,UE,UC) &
     &      +  DN*AREA(DA,DB,DE,DC)+2.*UBN*AREA(UBA,UBB,UBE,UBC) &
     &      +  2.*DBN*AREA(DBA,DBB,DBE,DBC)   

      call getnset(iset)
      call save_pdfqcd(iset)

      RETURN
  
      END

!------------------------------------------------------------------------=
      DOUBLE PRECISION FUNCTION AREA(A,B,E,C)
!------------------------------------------------------------------------=

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      IF (A.LE.-0.99.OR.B.LE.-0.99) THEN
        AREA=1D6
        RETURN
      ENDIF

      AR1=(DGAMMA_LHA(A+1)*DGAMMA_LHA(B+1))/DGAMMA_LHA(A+B+2)
!      AR2=E*(DGAMMA(A+1.5)*DGAMMA(B+1))/DGAMMA(A+B+2.5)
      AR2=E*(DGAMMA_LHA(A+3)*DGAMMA_LHA(B+1))/DGAMMA_LHA(A+B+4)
      AR3=C*(DGAMMA_LHA(A+2)*DGAMMA_LHA(B+1))/DGAMMA_LHA(A+B+3)
      AREA=AR1+AR2+AR3
      IF (AREA.LE.1D-6) AREA=1D-6

      RETURN
      END

!------------------------------------------------------------------------=
      DOUBLE PRECISION FUNCTION FF_LHA2(X,A,B,E,C)
!------------------------------------------------------------------------=

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
!      FF=X**A*(1D0-X)**B*(1+E*SQRT(X)+C*X)
      FF_LHA2=X**A*(1D0-X)**B*(1+C*X + E*X*X)
      RETURN
      END

!------------------------------------------------------------------------ 
      

! -*- F90 -*-


! Initialize a PDF set, determining the path to the PDF set directory automatically
! subroutine InitPDFsetByCodes(code1, code2, code3)
!   write(*,*) "Not implemented yet: this will move the 'glue' interface to ", &
!        "LHAPDF proper and use the InitPDFsetByName function to ", &
!        "get the path automatically."
!   return
! end subroutine InitPDFsetByCodes



! Initialize a PDF set, determining the path to the PDF set
! directory automatically
subroutine InitPDFsetByName(setname)
  implicit none
  character setname*(*)
  integer nset
  nset = 1
  call commoninit()
  call InitPDFsetByNameM(nset,setname)
  return
end subroutine InitPDFsetByName



! Initialize a PDF set, determining the path to the PDF set
! directory automatically
subroutine InitPDFsetByNameM(nset,setname)
  implicit none
  include 'parmsetup.inc'
  include 'commonlhapdfc.inc'
  include 'commonlhacontrol.inc'
  character setname*(*)
  integer nset
  character*512 dirpath, setpath

  ! Initialise common blocks
  call commoninit()

  ! Find the directory with the PDFsets
  call getdirpath(dirpath)

  ! Now build the path to the PDF set
  setpath = dirpath(:len_trim(dirpath)) // "/" // setname(:len_trim(setname))

  ! Initialize using the detected PDF set
  call InitPDFsetM(nset, setpath(:len_trim(setpath)))
  return
end subroutine InitPDFsetByNameM



subroutine InitPDFset(setpath)
  implicit none
  integer nset
  character setpath*(*)
  nset = 1
  call commoninit()
  call InitPDFsetM(nset,setpath)
  return
end subroutine InitPDFset


subroutine InitLHAPDF()
  call commoninit()
end subroutine InitLHAPDF


subroutine InitPDFsetM(nset,setpath)
  implicit none
  include 'parmsetup.inc'
  include 'commonlhacontrol.inc'
  character*512 filename
  common/lhafilename/filename
  character setpath*(*)
  character*512 inputfile(nmxset)
  character*64 string
  character*16 s1,s2
  character*10 lhaversion
  integer id,token,Ctoken
  integer lhaonce
  save lhaonce,inputfile
  data lhaonce/0/
  integer lhasilent
  common/lhasilent/lhasilent
  integer nset,nnset
  integer stat

  filename=setpath
#ifndef LOW_MEMORY
  ! check if this set is already initialized - will not work for lite
  if(inputfile(nset)(:len_trim(setpath)).eq.setpath) return
#endif

  ! Initialise common blocks
  call commoninit()
  call getlhapdfversion(lhaversion)

  inputfile(nset)=setpath
  lhasilent = 0
  if (lhaparm(19).eq.'SILENT') then
     lhasilent = 1
  elseif (lhaparm(19).eq.'LOWKEY') then
     if (lhaonce .eq. 0) then
        lhaonce = 1
     else
        lhasilent = 1
     endif
  endif

  call setnset(nset)
  open(unit=1, file=setpath, status='old', iostat=stat)
  if (stat .ne. 0) then
    write(*,*) 'File ', setpath(:len_trim(setpath)), ' cannot be opened !'
    write(*,*) 'If you have not already done so:'
    write(*,*) 'Use the bin/lhapdf-getdata script to download the file.'
    write(*,*) 'Set the environmental variable LHAPATH to specify the directory if not as default (above).'
    close(1)
    call exit(1)
  end if
  read(1,*) s1,s2
  if ((    index(s2,'1.0').ne.1) &
     .and.(index(s2,'1.1').ne.1) &
     .and.(index(s2,'2.0').ne.1) &
     .and.(index(s2,'2.1').ne.1) &
     .and.(index(s2,'3.0').ne.1) &
     .and.(index(s2,'3.1').ne.1) &
     .and.(index(s2,'4.0').ne.1) &
     .and.(index(s2,'5.0').ne.1) &
     .and.(index(s2,'5.3').ne.1) &
     .and.(index(s2,'5.4').ne.1) &
     .and.(index(s2,'5.5').ne.1) &
     .and.(index(s2,'5.6').ne.1) &
     .and.(index(s2,'5.7').ne.1) &
     .and.(index(s2,'5.8').ne.1)) then
     write(*,*) 'Version ',s2,' not supported by this version of LHAPDF'
     stop
  else
     if (lhasilent.eq.0) then
        write(*,*) '*************************************'
        write(*,*) '*       LHAPDF Version ',lhaversion,'   *'
        write(*,*) '*   Configured for the following:   *'
#ifdef ALL
        write(*,*) '*             All PDFs              *'
#endif
#ifndef ALL
#ifdef MRST
        write(*,*) '*             MRSTMAIN              *'
#endif
#ifdef MRST06
        write(*,*) '*              MRST06               *'
#endif
#ifdef MRST98
        write(*,*) '*              MRST98               *'
#endif
#ifdef MRSTQED
        write(*,*) '*              MRSTQED              *'
#endif
#ifdef CTEQ
        write(*,*) '*               CTEQ                *'
#endif
#ifdef MSTW
        write(*,*) '*               MSTW                *'
#endif
#ifdef ALEKHIN
        write(*,*) '*              ALEKHIN              *'
#endif
#ifdef NNPDF
        write(*,*) '*               NNPDF               *'
#endif
#ifdef BOTJE
        write(*,*) '*               BOTJE               *'
#endif
#ifdef FERMI
        write(*,*) '*               FERMI               *'
#endif
#ifdef ZEUS
        write(*,*) '*               ZEUS                *'
#endif
#ifdef H1
        write(*,*) '*                H1                 *'
#endif
#ifdef HERA
        write(*,*) '*               HERA                *'
#endif
#ifdef GRV
        write(*,*) '*                GRV                *'
#endif
#ifdef GJR
        write(*,*) '*               GJR/JR              *'
#endif
#ifdef HKN
        write(*,*) '*                HKN                *'
#endif
#ifdef PIONS
        write(*,*) '*               PIONS               *'
#endif
#ifdef PHOTONS
        write(*,*) '*              PHOTONS              *'
#endif
#ifdef USER
        write(*,*) '*               USER                *'
#endif
#endif
#ifdef LOW_MEMORY
        write(*,*) '*          LOW MEMORY option        *'
#endif
#ifdef FULL_MEMORY
        write(*,*) '*         FULL MEMORY option        *'
#endif
 1111 format(' *    Maximum ',i2,' concurrent set(s)   *')
        write(*,1111),nmxset
        write(*,*) '*************************************'
        write(*,*)
     endif
  endif
  id=Ctoken()
1 read(1,*) string
  id=token(string)
  ! print *,'id = ',id,string
  if (id.eq.0) then
     write(*,*) 'File description error:'
     write(*,*) 'Command not understood: ',string
     stop
  endif
  if (id.eq.1) call descriptionPDF(nset,id)
  ! print *,'1/2'
  if (id.eq.2) call initEvolve(nset)
  ! print *,'2/3'
  if (id.eq.3) call initAlphasPDF(nset)
  ! print *,'3/4'
  if (id.eq.4) call initInputPDF(nset)
  ! print *,'4/5'
  if (id.eq.5) call initListPDF(nset)
  ! print *,'5/6'
  if (id.eq.6) call initQCDparams(nset)
  ! print *,'6/7'
  if (id.eq.7) call initMinMax(nset)
  ! print *,'7/8'
  if (id.ne.8) goto 1
  close(1)
  ! print *,'calling InitEvolveCode',nset
  call InitEvolveCode(nset)

  ! Initialize the default member 0
  call InitPDFM(nset,0)

  return
  entry getsetpath(setpath)
    call getnset(nnset)
    setpath=inputfile(nnset)
  return

end subroutine InitPDFsetM



integer function token(s)
  implicit none
  character*16 s
  integer not,i,Ctoken
  parameter(not=8)
  character*16 t(not)
  data t/'Description:','Evolution:','Alphas:', 'Parametrization:', &
       'Parameterlist:','QCDparams:','MinMax:','End:'/
  integer count(not)
  save count

  token=0
  do i=1,not
     if (s.eq.t(i)) token=i
  enddo
  if (token.ne.0) then
     count(token)=count(token)+1
     if (count(token).eq.2) then
        write(*,*) 'File description error:'
        write(*,*) 'Second definition of entry: ',s
        stop
     endif
  endif
  return

  entry Ctoken()
  do i=1,not
     count(i)=0
  enddo
  Ctoken=0
  return
end function token



subroutine LHAprint(iprint)
  implicit none
  include 'commonlhacontrol.inc'
  integer lhasilent,iprint
  common/lhasilent/lhasilent
  call commoninit()
  lhasilent = iprint
  ! If using stream #6, don't silence!
  if(iprint.ne.6) lhaparm(19)='SILENT'
  return
end subroutine LHAprint



subroutine setPDFpath(pathname)
  implicit none
  include 'commonlhapdfc.inc'
  include 'commonlhacontrol.inc'
  include 'parmsetup.inc'
  character*(*) pathname
  integer j

  call commoninit()
  lhaparm(20) = 'LHAPATH'
  do j=1,len_trim(lhapath)
     lhapath(j:j)=''
  enddo
  lhapath = pathname
  return
end subroutine setPDFpath



subroutine lhaset(lhaparm2,lhavalue2)
  implicit none
  include 'commonlhacontrol.inc'
  character*20 lhaparm2(20)
  double precision lhavalue2(20)
  integer j

  call commoninit()
  do j=1,20
     lhaparm(j)=lhaparm2(j)
     lhavalue(j)=lhavalue2(j)
  enddo
  return
end subroutine lhaset



subroutine setlhaparm(lparm)
  implicit none
  include 'commonlhacontrol.inc'
  character*(*) lparm
  integer nparm

  call commoninit()

  if(lparm.eq.'EKS98') then
     lhaparm(15)='EKS98'
  else if(lparm.eq.'EPS08') then
     lhaparm(15)='EPS08'
  else if(lparm.eq.'EPS09') then
     lhaparm(15)='EPS09'
  else if(lparm(1:5).eq.'EPS09') then
     lhaparm(15)=lparm(1:LEN_TRIM(lparm))
  else if(lparm.eq.'15') then
     lhaparm(15)=''
  else if(lparm.eq.'NOSTAT') then
     lhaparm(16)='NOSTAT'
  else if (lparm.eq.'16') then
     lhaparm(16)=''
  else if (lparm.eq.'LHAPDF') then
     lhaparm(17)='LHAPDF'
  else if (lparm.eq.'17') then
     lhaparm(17)=''
  else if (lparm.eq.'EXTRAPOLATE') then
     lhaparm(18)='EXTRAPOLATE'
  else if (lparm.eq.'18') then
     lhaparm(18)=''
  else if (lparm.eq.'SILENT') then
     lhaparm(19)='SILENT'
  else if (lparm.eq.'LOWKEY') then
     lhaparm(19)='LOWKEY'
  else if (lparm.eq.'19') then
     lhaparm(19)=''
  else
     print *,'WARNING from SetLHAPARM - value',lparm,'not recognized!'
  endif
  return

  entry getlhaparm(nparm,lparm)
  lparm = lhaparm(nparm)
  return
end subroutine setlhaparm



subroutine getdirpath(dirpath)
  ! This routine is to determine the directory path for the PDFsets
  ! directory. It has a two-fold purpose:
  ! 1) to return the value as an argument in dirpath for the native
  !    LHAPDF use (ie via initPDFSetByName
  ! 2) to fill the value of lhapath in the LHAPDFC common for use in
  !    lhaglue.
  implicit none
  include 'commonlhapdfc.inc'
  include 'commonlhacontrol.inc'
  include 'parmsetup.inc'
  character*(*) dirpath

  ! First look in the LHAPDFC array (lhaparm(20), set by setPDFpath).
  ! Next, check environmental variable LHAPATH.
  ! Finally, use binreloc via getdatapath(...).
  ! Will use default path if this all fails.
  if (lhaparm(20) /= 'LHAPATH') then
     call getenv('LHAPATH', lhapath)
     !call get_environment_variable('LHAPATH',lhapath)
     if (lhapath.eq.'') then
        call getdatapath(dirpath)
        lhapath = dirpath
     endif
  endif
  dirpath = lhapath
  return
end subroutine getdirpath


!-- Get the maximum number of concurrent PDF sets.
subroutine GetMaxNumSets(MaxNumSets)
  implicit none
  include 'parmsetup.inc'
  integer MaxNumSets
  MaxNumSets = nmxset
end subroutine GetMaxNumSets


logical function has_photon()
  implicit none
  include 'parmsetup.inc'
  integer nset
  character*16 name(nmxset)
  integer nmem(nmxset),ndef(nmxset),mem
  common/NAME/name,nmem,ndef,mem
!
  call getnset(nset)
  has_photon = .FALSE.

  if(name(nset).eq.'MRST4qed') has_photon = .TRUE.
  if(name(nset).eq.'NNPDF20intqed') has_photon = .TRUE.
!
  return
!
end function has_photon

! -*- F90 -*-


      subroutine EVLCTEQevolve(x,Q,f) 
      implicit none 
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      real*8 f(-6:6) 
      real*8 x,Q,xx,qq,up,dn,ubar,dbar,gluon,sbar,cbar,bbar,tbar,Blam 
      real*8 xmin,qmax,anx,anq,Q2fit,qini,Ahdn,ordi,anf,mass,pi,alfas 
      real*8 Q0,alfas0 
      real*8 CtLhpardis,CtLhALPI,parmflavor,CtLhastolam 
      integer nflavor,Eorder,j,nx,nq 
      integer nset 
      data pi / 3.141592653589793d0 / 
      external parmflavor 
      save nflavor,xmin,qmax,anx,anq 
                                                                        
!                                                                       
        xx = x 
        qq = Q 
        up   = xx*CtLhpardis(1,xx,qq) 
        dn   = xx*CtLhpardis(2,xx,qq) 
        ubar = xx*CtLhpardis(-1,xx,qq) 
        dbar = xx*CtLhpardis(-2,xx,qq) 
        gluon= xx*CtLhpardis( 0,xx,qq) 
                                                                        
        if(nflavor .ge. 3) then 
           sbar = xx*CtLhpardis(-3,xx,qq) 
        else 
           sbar = 0.d0 
        endif 
                                                                        
        if(nflavor .ge. 4) then 
           cbar = xx*CtLhpardis(-4,xx,qq) 
        else 
           cbar = 0.d0 
        endif 
                                                                        
        if(nflavor .ge. 5) then 
           bbar = xx*CtLhpardis(-5,xx,qq) 
        else 
           bbar = 0.d0 
        endif 
                                                                        
        if(nflavor .eq. 6) then 
           tbar = xx*CtLhpardis(-6,xx,qq) 
        else 
           tbar = 0.d0 
        endif 
                                                                        
        f(6) = tbar 
        f(5) = bbar 
        f(4) = cbar 
        f(3) = sbar 
        f(2) = up 
        f(1) = dn 
        f(0) = gluon 
        f(-1) = dbar 
        f(-2) = ubar 
        f(-3) = sbar 
        f(-4) = cbar 
        f(-5) = bbar 
        f(-6) = tbar 
!                                                                       
        return 
!                                                                       
      entry EVLCTEQread(nset) 
      call CtLhbldat1 
      call CtLhbldat2 
      read(1,*) xmin,qmax,nx,nq 
      anx=nx 
      anq=nq-1 
      return 
!                                                                       
      entry EVLCTEQalfa(alfas,Q) 
      alfas = pi*CtLhALPI(Q) 
      return 
!                                                                       
      entry EVLCTEQinit(nset,Eorder,Q2fit) 
!                                                                       
      Ahdn=1d0 
      call CtLhParPdf(1,'IHDN',Ahdn,j) 
      call CtLhParPdf(1,'QMAX',qmax,j) 
      call CtLhParPdf(1,'XMIN',xmin,j) 
      call GetOrderAsM(nset,j) 
      ordi=j+1.0 
      call CtLhParQcd(1,'ORDR',ordi,j) 
      call GetThresholdM(nset,4,mass) 
      call CtLhParQcd(1,'M4',mass,j) 
      call GetThresholdM(nset,5,mass) 
      call CtLhParQcd(1,'M5',mass,j) 
      mass=180d0 
      call CtLhParQcd(1,'M6',mass,j) 
      call GetNfM(nset,j) 
      nflavor=j 
      Anf=nflavor 
      call CtLhParQcd(1,'NFL',Anf,j) 
      qini=sqrt(Q2fit) 
      call CtLhParPdf(1,'QINI',qini,j) 
      call CtLhEvlpar(1,'NFMX', Anf, j) 
      ordi=Eorder+1.0 
      call CtLhParPdf(1,'IKNL',ordi,j) 
      return 
!                                                                       
      entry EVLCTEQpdf(nset) 
      call GetOrderAsM(nset,j) 
      call GetAlfas(nset,alfas0,Q0) 
      Blam=CtLhastolam(alfas0,Q0,j+1,nflavor) 
      call CtLhSetLam (nflavor,Blam,j+1) 
      call CtLhParPdf(1,'NX',anx,j) 
      call CtLhParPdf(1,'NT',anq,j) 
      call CtLhEvolve (parmflavor,j) 
      if (j .ne. 0) then 
         write(*,*) 'EVLCTEQ Evolve Error code :',j 
         stop 
      endif 
      return 
!                                                                       
      END                                           
!                                                                       
      double precision function parmflavor(i,x) 
      implicit none 
      real*8 x,f(-6:6) 
      integer i,i0 
      integer iset 
!                                                                       
      call getnset(iset) 
      call parmPDF(iset,x,f) 
      i0=i 
      if (i.eq.-2) i0=-1 
      if (i.eq.-1) i0=-2 
      if (i.eq.1) i0=2 
      if (i.eq.2) i0=1 
      parmflavor=f(i0)/x 
      return 
!                                                                       
      END                                           
                                                                        
      function CtLhastolam(as,q,nloop,nf) 
      implicit double precision (a-h,o-z) 
      data pi / 3.141592653589793d0 / 
      xlp = nloop-1d0 
      b  = (33.0-2.0*nf)/pi/12.0 
      bp = (153.0 - 19.0*nf) / pi / 2.0 / (33.0 - 2.0*nf) * xlp 
      t  = 1.0/b/as 
!-----------------------------------------------------------            
! Solve the equation                                                    
!                                                                       
    1 xlt = log(t) 
      ot = t 
!-----------------------------------------------------------            
! Solve the equation                                                    
! Value and Derivative of alfa with respect to t                        
!                                                                       
      as0  = 1/b/t - bp*xlt/(b*t)**2 
      as1  = - 1/b/t**2 -bp/b**2*(1-2*xlt)/t**3 
      t  = (as-as0)/as1 + t 
      if(abs(ot-t)/ot.gt..00001)goto 1 
      CtLhastolam = q/exp(t/2.0) 
      return 
      END                                           

program example2
  implicit double precision (a-h,o-z)
  character*64 name
  double precision f(-6:6),mom1(9),mom2(9)

  Q=100d0
  name='Botje_100.LHpdf'
  call InitPDFsetByName(name)
  
  call numberPDF(Nmem)
  print *,Nmem
  write(*,*)
  write(*,*) 'Calculating the gluon momentum PDF average <g>'
  write(*,*) 'and standard deviaton SD(g) for several x values'
  write(*,*) 'at Q=100 GeV'
  write(*,*)
  write(*,*) '1. The slow way:'
  write(*,*) 
  write(*,*) '   x       <g>         SD(g)'
  do ix=10,95,10
     x = dfloat(ix)*1.0d-03
     gmom1=0d0
     gmom2=0d0
     do i=1,Nmem
        call InitPDF(i)
        call evolvePDF(x,Q,f)
        gmom1=gmom1+f(0)
        gmom2=gmom2+f(0)**2
     enddo
     av=gmom1/Nmem
     sd=sqrt(gmom2/Nmem-av**2)
     write(*,*) x,av,sd
  enddo
  write(*,*) 
  write(*,*) '2. The fast way:'
  write(*,*) 
  write(*,*) '   x       <g>         SD(g)'
  do i=1,9
     mom1(i)=0d0
     mom2(i)=0d0
  enddo
  do i=1,Nmem
     call InitPDF(i)
     ic=0
     do ix=10,95,10
        x = dfloat(ix)*1.0d-03
        call evolvePDF(x,Q,f)
        ic=ic+1
        mom1(ic)=mom1(ic)+f(0)
        mom2(ic)=mom2(ic)+f(0)**2
     enddo
  enddo
  ic=0
  do ix=10,95,10
     x = dfloat(ix)*1.0d-03
     ic=ic+1
     av=mom1(ic)/Nmem
     sd=sqrt(mom2(ic)/Nmem-av**2)
     write(*,*) x,av,sd
  enddo
  
  Q=10d0
  x1=0.001d0
  x2=0.01d0
  write(*,*)
  write(*,*) 'Calculating the normalized correlation coefficient'
  write(*,*) '<g1g2> between g(x=0.001) and g(x=0.01) and'
  write(*,*) '<sAlpha> between the strange quark momentum PDF'
  write(*,*) 'at x=0.001 and alpha_S(Q) for Q=10 GeV'
  write(*,*)
  avg1=0d0
  avg2=0d0
  avs=0d0
  avAs=0d0
  sdg1=0d0
  sdg2=0d0
  sds=0d0
  sdAs=0d0
  Cg1g2=0d0
  CsAs=0d0
  j=3
  do i=1,Nmem
     call InitPDF(i)
     As=alphasPDF(Q)
     print *,Q,As
     call evolvePDF(x1,Q,f)
     g1=f(0)
     s=f(j)
     call evolvePDF(x2,Q,f)
     g2=f(0)
     avAs=avAs+As
     avg1=avg1+g1
     avg2=avg2+g2
     avs=avs+s
     sdAs=sdAs+As**2
     sdg1=sdg1+g1**2
     sdg2=sdg2+g2**2
     sds=sds+s**2
     CsAs=CsAs+s*As
     Cg1g2=Cg1g2+g1*g2
  enddo
  avAs=avAs/Nmem
  avs=avs/Nmem
  avg1=avg1/Nmem
  avg2=avg2/Nmem
  print *,sdAs,Nmem,avas
  sdAs=sdAs/Nmem-avAs**2
  sds=sds/Nmem-avs**2
  sdg1=sdg1/Nmem-avg1**2
  sdg2=sdg2/Nmem-avg2**2
  CsAs=CsAs/Nmem-avs*avAs
  Cg1g2=Cg1g2/Nmem-avg1*avg2
  write(*,*) '<g1g2>    = ',Cg1g2/sqrt(sdg1*sdg2)
  print *,CsAs,sds,sdAs
  write(*,*) '<sAlpha> = ',CsAs/sqrt(sds*sdAs)
end program example2

      subroutine USERGRIDevolve(xin,qin,pdf)
      implicit real*8 (a-h,o-z)
      include 'parmsetup.inc'
      double precision parm(nopmax)
      character*16 name(nmxset)
      integer nmem(nmxset),ndef(nmxset),mmem
      common/NAME/name,nmem,ndef,mmem
      CHARACTER*80 LINE
      dimension pdf(-6:6)
      integer init,set,i,j,k,l,nset,iset
      parameter(nhess=0)
      double precision fgrid(0:nhess,201,201,-6:6),grid(402)
      double precision agrid(201),alfas,Qalfa
      integer nacross,iparton(13)
      logical NPARTON(-6:6)
      common/ugrid/NUMX,NUMQ2,fgrid
      double precision up,upv,dn,dnv,usea,dsea,str,chm,bot,glu
      double precision qq(5),yntmp(5)
      save 
      x=xin
      q2=qin*qin 
      call getnset(iset)
      upv  = 0.0d0
      dnv  = 0.0d0
      usea = 0.0d0
      dsea = 0.0d0
      str  = 0.0d0
      sbar = 0.0d0
      chm  = 0.0d0
      cbar = 0.0d0
      bot  = 0.0d0
      bbar = 0.0d0
      top  = 0.0d0
      tbar = 0.0d0
      glu = 0.0d0
      if(name(iset)(1:len_trim(name(iset))).eq.'USERGRIDQ4') then
        ! HERE FOR QUARTIC POLYNOMIAL INTERPOLATION
          do np = 1,npartons
              if(iparton(np).eq.-6) tbar = USERGRIDQ4(x,Q2,grid,-6)
              if(iparton(np).eq.-5) bbar = USERGRIDQ4(x,Q2,grid,-5)
              if(iparton(np).eq.-4) cbar = USERGRIDQ4(x,Q2,grid,-4)
              if(iparton(np).eq.-3) sbar = USERGRIDQ4(x,Q2,grid,-3)
              if(iparton(np).eq.-2) usea = USERGRIDQ4(x,Q2,grid,-2)
              if(iparton(np).eq.-1) dsea = USERGRIDQ4(x,Q2,grid,-1)
              if(iparton(np).eq.0) glu = USERGRIDQ4(x,Q2,grid,0)
              if(iparton(np).eq.1) dnv = USERGRIDQ4(x,Q2,grid,1)
              if(iparton(np).eq.2) upv = USERGRIDQ4(x,Q2,grid,2)
              if(iparton(np).eq.3) str = USERGRIDQ4(x,Q2,grid,3)
              if(iparton(np).eq.4) chm = USERGRIDQ4(x,Q2,grid,4)
              if(iparton(np).eq.5) bot = USERGRIDQ4(x,Q2,grid,5)
              if(iparton(np).eq.6) top = USERGRIDQ4(x,Q2,grid,6)
          enddo
      else if(name(iset)(1:len_trim(name(iset))).eq.'USERGRIDQ3') then
        ! HERE FOR CUBIC POLYNOMIAL INTERPOLATION
          do np = 1,npartons
              if(iparton(np).eq.-6) tbar = USERGRIDQ3(x,Q2,grid,-6)
              if(iparton(np).eq.-5) bbar = USERGRIDQ3(x,Q2,grid,-5)
              if(iparton(np).eq.-4) cbar = USERGRIDQ3(x,Q2,grid,-4)
              if(iparton(np).eq.-3) sbar = USERGRIDQ3(x,Q2,grid,-3)
              if(iparton(np).eq.-2) usea = USERGRIDQ3(x,Q2,grid,-2)
              if(iparton(np).eq.-1) dsea = USERGRIDQ3(x,Q2,grid,-1)
              if(iparton(np).eq.0) glu = USERGRIDQ3(x,Q2,grid,0)
              if(iparton(np).eq.1) dnv = USERGRIDQ3(x,Q2,grid,1)
              if(iparton(np).eq.2) upv = USERGRIDQ3(x,Q2,grid,2)
              if(iparton(np).eq.3) str = USERGRIDQ3(x,Q2,grid,3)
              if(iparton(np).eq.4) chm = USERGRIDQ3(x,Q2,grid,4)
              if(iparton(np).eq.5) bot = USERGRIDQ3(x,Q2,grid,5)
              if(iparton(np).eq.6) top = USERGRIDQ3(x,Q2,grid,6)
          enddo  
      else if(name(iset)(1:len_trim(name(iset))).eq.'USERGRIDQ2') then
        ! HERE FOR QUADRATIC POLYNOMIAL INTERPOLATION
          do np = 1,npartons
              if(iparton(np).eq.-6) tbar = USERGRIDQ2(x,Q2,grid,-6)
              if(iparton(np).eq.-5) bbar = USERGRIDQ2(x,Q2,grid,-5)
              if(iparton(np).eq.-4) cbar = USERGRIDQ2(x,Q2,grid,-4)
              if(iparton(np).eq.-3) sbar = USERGRIDQ2(x,Q2,grid,-3)
              if(iparton(np).eq.-2) usea = USERGRIDQ2(x,Q2,grid,-2)
              if(iparton(np).eq.-1) dsea = USERGRIDQ2(x,Q2,grid,-1)
              if(iparton(np).eq.0) glu = USERGRIDQ2(x,Q2,grid,0)
              if(iparton(np).eq.1) dnv = USERGRIDQ2(x,Q2,grid,1)
              if(iparton(np).eq.2) upv = USERGRIDQ2(x,Q2,grid,2)
              if(iparton(np).eq.3) str = USERGRIDQ2(x,Q2,grid,3)
              if(iparton(np).eq.4) chm = USERGRIDQ2(x,Q2,grid,4)
              if(iparton(np).eq.5) bot = USERGRIDQ2(x,Q2,grid,5)
              if(iparton(np).eq.6) top = USERGRIDQ2(x,Q2,grid,6)
          enddo  
      else
          print *,'Unknown interpolation method ',   &
     & name(iset)(1:len_trim(name(iset))),' called for!'
          stop
      endif
      up = upv + usea
      dn = dnv + dsea  

      if(NPARTON(-6)) then
          pdf(-6) = tbar
      else 
          pdf(-6) = top
      endif
      pdf(6) = top

      if(NPARTON(-5)) then
          pdf(-5) = bbar
      else
          pdf(-5) = bot
      endif
      pdf(5) = bot

      if(NPARTON(-4)) then
          pdf(-4) = cbar
      else
          pdf(-4) = chm
      endif
      pdf(4) = chm

      if(NPARTON(-3)) then
          pdf(-3) = sbar
      else
          pdf(-3) = str
      endif
      pdf(3) = str
      pdf(-2) = usea
      pdf(2)  = up
      pdf(-1) = dsea
      pdf(1)  = dn
      pdf(0)  = glu
      return
!      
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry USERGRIDread(nset)
!     
      call getnmem(nset,imem) 

      read(1,*)nmem(nset),ndef(nset),NUMX,NUMQ2,nacross,npartons,(iparton(k),k=1,npartons)
      
      do np = -6,6
          NPARTON(np) = .FALSE.
      enddo
      
      nnx = numx/nacross
      nnq2 = numq2/nacross
      
      do iq=1,nnq2
         read(1,*) (grid(NUMX+(iq-1)*nacross+ii),ii=1,nacross)
      enddo

      do jx=1,nnx
         read(1,*) (grid((jx-1)*nacross+ii),ii=1,nacross)
      enddo

    !read in to alphas grid  
      do iq=1,nnq2
         read(1,*) (agrid((iq-1)*nacross+ii),ii=1,nacross)
      enddo

      do ns=0,nmem(nset)
        do k = 1,npartons
          NPARTON(iparton(k)) = .TRUE.
          do IQ=1,NUMQ2
            do JX=1,nnx
	      read(1,*)(fgrid(ns,(jx-1)*nacross+ii,iq,iparton(k)),ii=1,nacross)
            enddo
          enddo
        enddo
      enddo
      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry USERGRIDalfa(alfas,Qalfa)
      q2 = Qalfa*Qalfa
      nqlow = -1
      nqhi = NUMQ2+1
      do while (nqhi-nqlow.gt.1)
         nqmid = (nqlow+nqhi)/2
	 if(q2.ge.grid(NUMX+nqmid)) then
	    nqlow = nqmid
	 else 
	    nqhi = nqmid
	 endif
      enddo
      ! do a linear interpolation on the alphas grid
      npt = 2 
      call userpolint(grid(NUMX+nqlow),agrid(nqlow),npt,q2,alfas,dy)
      call getnset(iset)
      call getnmem(iset,imem)
      call listPDF(iset,imem,parm)
      alfas=alfas*parm(1)/0.1176d0
      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry USERGRIDinit(Eorder,Q2fit)
      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry USERGRIDpdf(mem)
      imem = mem
      call getnset(iset)
      call setnmem(iset,imem)
      return
!
 1000 format(5e13.5)
      end
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! attempt at polynomial (order 4) interpolation based on  polint
      double precision function USERGRIDQ4(x,Q2,grid,n)
      implicit real*8(a-h,o-z)
      integer iset,imem,nhess
      parameter(nhess=0)
      double precision grid(402),x,Q2
      double precision fgrid(0:nhess,201,201,-6:6)
      double precision ya(5,5),yntmp(5),ymtmp(5)
      common/ugrid/NUMX,NUMQ2,fgrid
      
      npt = 5
      call getnset(iset)
      call getnmem(iset,imem)      
      
! find the x bins around x
      nxlow = -1
      nxhi = NUMX+1
      do while (nxhi-nxlow.gt.1)
         nxmid = (nxlow+nxhi)/2
	 if(x.ge.grid(nxmid)) then
	    nxlow = nxmid
	 else 
	    nxhi = nxmid
	 endif
      enddo

! find the q2 bins around q2
      nqlow = -1
      nqhi = NUMQ2+1
      do while (nqhi-nqlow.gt.1)
         nqmid = (nqlow+nqhi)/2
	 if(q2.ge.grid(NUMX+nqmid)) then
	    nqlow = nqmid
	 else 
	    nqhi = nqmid
	 endif
      enddo
      
! fill the temp 4x4 funtion array (allowing for endpoints and extrapolation)
	if(nxlow.le.0) nxlow=1
	if(nxlow.ge.NUMX) nxlow=NUMX-1
        if(nxlow.eq.1) then
	   nxbot = 1
	elseif(nxlow.eq.2) then
	   nxbot = 2
	else
	   if(nxlow.eq.NUMX-1) then
	      nxbot = 4
	   else
	      nxbot = 3
	   endif
	endif
	if(nqlow.le.0) nqlow=1
	if(nqlow.ge.NUMQ2) nqlow=NUMQ2-1
        if(nqlow.eq.1) then
	   nqbot = 1
	elseif(nqlow.eq.2) then
	   nqbot = 2
	else
	   if(nqlow.eq.NUMQ2-1) then
	      nqbot = 4
	   else   
	      nqbot = 3
	   endif
	endif
	
        do nx=1,5
          do nq=1,5 
	      ya(nx,nq) = fgrid(imem,nxlow+nx-nxbot,nqlow+nq-nqbot,n)
	  enddo   
        enddo      
      
      do j=1,5
        do k=1,5
	      yntmp(k)=ya(j,k)
	    enddo
	    call userpolint(grid(NUMX+nqlow-nqbot+1),yntmp,npt,q2,ymtmp(j),dy)
      enddo 
      call userpolint(grid(nxlow-nxbot+1),ymtmp,npt,x,y,dy)
      
      usergridq4=y
      
      return
      end     
!=========================================================
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! attempt at polynomial (order 3) interpolation based on  polint
      double precision function USERGRIDQ3(x,Q2,grid,n)
      implicit real*8(a-h,o-z)
      integer iset,imem,nhess
      parameter(nhess=0)
      double precision grid(402),x,Q2
      double precision fgrid(0:nhess,201,201,-6:6)
      double precision ya(4,4),yntmp(4),ymtmp(4)
      common/ugrid/NUMX,NUMQ2,fgrid
      
      npt = 4
      call getnset(iset)
      call getnmem(iset,imem)      
      
! find the x bins around x
      nxlow = -1
      nxhi = NUMX+1
      do while (nxhi-nxlow.gt.1)
         nxmid = (nxlow+nxhi)/2
	 if(x.ge.grid(nxmid)) then
	    nxlow = nxmid
	 else 
	    nxhi = nxmid
	 endif
      enddo

! find the q2 bins around q2
      nqlow = -1
      nqhi = NUMQ2+1
      do while (nqhi-nqlow.gt.1)
         nqmid = (nqlow+nqhi)/2
	 if(q2.ge.grid(NUMX+nqmid)) then
	    nqlow = nqmid
	 else 
	    nqhi = nqmid
	 endif
      enddo
      
! fill the temp 4x4 funtion array (allowing for endpoints and extrapolation)
	if(nxlow.le.0) nxlow=1
	if(nxlow.ge.NUMX) nxlow=NUMX-1
    if(nxlow.eq.1) then
	   nxbot = 1
	else
	   if(nxlow.eq.NUMX-1) then
	      nxbot = 3
	   else
	      nxbot = 2
	   endif
	endif
	if(nqlow.le.0) nqlow=1
	if(nqlow.ge.NUMQ2) nqlow=NUMQ2-1
    if(nqlow.eq.1) then
	   nqbot = 1
	else
	   if(nqlow.eq.NUMQ2-1) then
	      nqbot = 3
	   else   
	      nqbot = 2
	   endif
	endif
	
        do nx=1,4
          do nq=1,4 
	      ya(nx,nq) = fgrid(imem,nxlow+nx-nxbot,nqlow+nq-nqbot,n)
	  enddo   
        enddo      
      
      do j=1,4
        do k=1,4
	      yntmp(k)=ya(j,k)
	    enddo
	    call userpolint(grid(NUMX+nqlow-nqbot+1),yntmp,npt,q2,ymtmp(j),dy)
      enddo 
      call userpolint(grid(nxlow-nxbot+1),ymtmp,npt,x,y,dy)
      
      usergridq3=y
      
      return
      end     
!=========================================================
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! attempt at polynomial (order 2) interpolation based on  polint
      double precision function USERGRIDQ2(x,Q2,grid,n)
      implicit real*8(a-h,o-z)
      integer iset,imem,nhess
      parameter(nhess=0)
      double precision grid(402),x,Q2
      double precision fgrid(0:nhess,201,201,-6:6)
      double precision ya(3,3),yntmp(3),ymtmp(3)
      common/ugrid/NUMX,NUMQ2,fgrid
      
      npt = 3
      call getnset(iset)
      call getnmem(iset,imem)      
      
! find the x bins around x
      nxlow = -1
      nxhi = NUMX+1
      do while (nxhi-nxlow.gt.1)
         nxmid = (nxlow+nxhi)/2
	 if(x.ge.grid(nxmid)) then
	    nxlow = nxmid
	 else 
	    nxhi = nxmid
	 endif
      enddo

! find the q2 bins around q2
      nqlow = -1
      nqhi = NUMQ2+1
      do while (nqhi-nqlow.gt.1)
         nqmid = (nqlow+nqhi)/2
	 if(q2.ge.grid(NUMX+nqmid)) then
	    nqlow = nqmid
	 else 
	    nqhi = nqmid
	 endif
      enddo
      
! fill the temp 4x4 funtion array (allowing for endpoints and extrapolation)
	if(nxlow.le.0) nxlow=1
	if(nxlow.ge.NUMX) nxlow=NUMX-1
    if(nxlow.eq.1) then
	   nxbot = 1
	else
	   if(nxlow.eq.NUMX-1) then
	      nxbot = 2
	   else
	      nxbot = 1
	   endif
	endif
	if(nqlow.le.0) nqlow=1
	if(nqlow.ge.NUMQ2) nqlow=NUMQ2-1
    if(nqlow.eq.1) then
	   nqbot = 1
	else
	   if(nqlow.eq.NUMQ2-1) then
	      nqbot = 2
	   else   
	      nqbot = 1
	   endif
	endif
	
        do nx=1,3
          do nq=1,3 
	      ya(nx,nq) = fgrid(imem,nxlow+nx-nxbot,nqlow+nq-nqbot,n)
	  enddo   
        enddo      
      
      do j=1,3
        do k=1,3
	      yntmp(k)=ya(j,k)
	    enddo
	    call userpolint(grid(NUMX+nqlow-nqbot+1),yntmp,npt,q2,ymtmp(j),dy)
      enddo 
      call userpolint(grid(nxlow-nxbot+1),ymtmp,npt,x,y,dy)
      
      usergridq2=y
      
      return
      end     
!=========================================================
      
         SUBROUTINE USERPOLINT (XA,YA,N,X,Y,DY)

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
!                                        Adapted from "Numerical Recipes"
      PARAMETER (NMAX=10)
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)
      NS=1
      DIF=ABS(X-XA(1))
      DO 11 I=1,N
        DIFT=ABS(X-XA(I))
        IF (DIFT.LT.DIF) THEN
          NS=I
          DIF=DIFT
        ENDIF
        C(I)=YA(I)
        D(I)=YA(I)
11    CONTINUE
      Y=YA(NS)
      NS=NS-1
      DO 13 M=1,N-1
        DO 12 I=1,N-M
          HO=XA(I)-X
          HP=XA(I+M)-X
          W=C(I+1)-D(I)
          DEN=HO-HP
          IF(DEN.EQ.0.) RETURN
          DEN=W/DEN
          D(I)=HP*DEN
          C(I)=HO*DEN
12      CONTINUE
        IF (2*NS.LT.N-M)THEN
          DY=C(NS+1)
        ELSE
          DY=D(NS)
          NS=NS-1
        ENDIF
        Y=Y+DY
13    CONTINUE
      RETURN
      END
!=========================================================

! -*- F90 -*-


      subroutine GSG96evolvep0(xin,qin,p2in,ip2in,pdf) 
      include 'parmsetup.inc' 
      real*8 xin,qin,q2in,p2in,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      real*8 SIG,QNS,GL 
      common/gsgdat/SIG(78,11,3),QNS(78,11,3),GL(78,11,3) 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
                                                                        
      save 
                                                                        
      iimem = 2 
      call GS96HL(iimem,xin,qin,upv,dnv,str,chm,bot,glu) 
      usea = upv 
      dsea = dnv 
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSG96evolvep1(xin,qin,p2in,ip2in,pdf) 
                                                                        
      iimem = 1 
      call GS96HL(iimem,xin,qin,upv,dnv,str,chm,bot,glu) 
      usea = upv 
      dsea = dnv 
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSG96read(nset) 
      read(1,*)nmem(nset),ndef(nset) 
                                                                        
      do m = 1,2 
      do k = 1,78 
        read(1,*)(sig(k,j,m),j=1,4) 
        read(1,*)(sig(k,j,m),j=5,8) 
        read(1,*)(sig(k,j,m),j=9,11) 
      enddo 
      do k = 1,78 
        read(1,*)(qns(k,j,m),j=1,4) 
        read(1,*)(qns(k,j,m),j=5,8) 
        read(1,*)(qns(k,j,m),j=9,11) 
      enddo 
      do k = 1,78 
        read(1,*)(gl(k,j,m),j=1,4) 
        read(1,*)(gl(k,j,m),j=5,8) 
        read(1,*)(gl(k,j,m),j=9,11) 
      enddo 
      enddo 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSG96alfa(alfas,qalfa) 
       call getnset(iset) 
       call getnmem(iset,imem) 
       call GetOrderAsM(iset,iord) 
       call Getlam4M(iset,imem,qcdl4) 
       call Getlam5M(iset,imem,qcdl5) 
       call aspdflib(alfas,Qalfa,iord,qcdl5) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSG96init(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSG96pdf(mem) 
      call getnset(iset) 
      call setnmem(iset,mem) 
!      imem = mem                                                       
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!      SUBROUTINE GS96HO(X,Q,U,D,S,C,B,G)                               
      SUBROUTINE GS96HL(iset,X,Q,U,D,S,C,B,G) 
      implicit real*8 (a-h,o-z) 
      PARAMETER(NP=78,NQ=11,NARG=2) 
!****************************************************************       
! Subroutine returns the parton distributions in the photon in  *       
! next-to-leading order. u,d etc. gives the actual distributions*       
! not x times the distributions; Q2 means Q^2. The distributions*       
! are valid for 5.0e^-4< x < 1.0 and 5.3 GeV^2 < Q^2 < 1.0e^8.  *       
! if higher Q^2 or lower x is required, these may be obtained   *       
! from the authors on request.                                  *       
! Lionel Gordon April 1996 : Gordon@hep.anl.gov                 *       
! John Storrow             :johns@a3.ph.man.ac.uk               *       
!****************************************************************       
!      DIMENSION SIG(NP,NQ),QNS(NP,NQ),GL(NP,NQ),Y(NP)                  
      DIMENSION Y(NP) 
      DIMENSION XT(NARG),NA(NARG),A(NP+NQ),QT(NQ) 
      common/gsgdat/SIG(78,11,3),QNS(78,11,3),GL(78,11,3) 
      EXTERNAL GS2XCOR 
!      SAVE SIG,QNS,GL,Y,ICALL                                          
      SAVE Y,ICALL 
      DATA QT /3.0D0,20.0D0,50.0D0,100.0D0,500.0D0,1.0D3,1.0D4,1.0D5,   &
     & 1.0D6,1.0D7,1.0D8/                                               
!*****************************************************************      
        q2=q*q 
!if x is out of range                                                   
       IF((X.LT.5.0D-4).OR.(X.GT.1.0D0)) GOTO 90 
!******************************************************************     
       IF (ICALL.NE.1) THEN 
! get the x coordinates                                                 
       CALL GS2XCOR(Y,NP) 
        ICALL=1 
        END IF 
!                                                                       
      DO 30 IX=1,NP 
        A(IX)=Y(IX) 
   30 END DO 
      DO 40 IQ=1,NQ 
        A(NP+IQ)=QT(IQ) 
   40 END DO 
!                                                                       
      NA(1)=NP 
      NA(2)=NQ 
       XT(1)=X 
       XT(2)=Q2 
      XSIG=DBFINT(2,XT,NA,A,SIG(1,1,iset)) 
      XQNS=DBFINT(2,XT,NA,A,QNS(1,1,iset)) 
        G =DBFINT(2,XT,NA,A,GL(1,1,iset)) 
!                                                                       
      IF (Q2.LT.50.0D0) THEN 
! Use three flavour evolution.                                          
       U=(XSIG+9.0D0*XQNS)/6.0D0 
       D=(XSIG-4.5D0*XQNS)/6.0D0 
       S=D 
       C=0.0D0 
       B=0.0D0 
!                                                                       
      ELSE IF((Q2.GT.50.0).AND.(Q2.LT.250.0)) THEN 
! Use four flavour evolution                                            
      U=(XSIG+6.0D0*XQNS)/8.0D0 
      D=(XSIG-6.0D0*XQNS)/8.0D0 
      S=D 
      C=U 
      B=0.0D0 
      ELSE 
! Use five flavour evolution                                            
      U=(XSIG+7.5D0*XQNS)/10.0D0 
      D=(XSIG-5.0D0*XQNS)/10.0D0 
      S=D 
      C=U 
      B=D 
      ENDIF 
      U=X*U 
      US=U 
      D=X*D 
      DS=D 
      S=X*S 
      C=X*C 
      B=X*B 
      G=X*G 
   90 RETURN 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      SUBROUTINE GS2XCOR(Y,NP) 
      IMPLICIT REAL*8(A-H,O-Z) 
      DIMENSION Y(NP) 
      N=1 
      DO 10 IX=1,20,2 
         Y(N)=DBLE(IX)/2000.0D0 
      N=N+1 
   10 END DO 
      DO 20 IX=30,200,10 
         Y(N)=DBLE(IX)/2000.0D0 
      N=N+1 
   20 END DO 
      DO 30 IX=240,1600,40 
         Y(N)=REAL(IX)/2000.0D0 
      N=N+1 
   30 END DO 
      DO 40 IX=1625,1980,25 
         Y(N)=REAL(IX)/2000.0D0 
      N=N+1 
   40 END DO 
      RETURN 
      END                                           

! -*- F90 -*-


      subroutine OWPevolve(xin,qin,pdf) 
      include 'parmsetup.inc' 
      real*8 xin,qin,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset) 
      common/NAME/name,nmem,ndef,mmem 
      integer mem,mmem 
      integer nset 
!      integer iset,iimem                                               
!      common/SET/iset,iimem                                            
                                                                        
      save 
                                                                        
      q2in = qin*qin 
!      iset = imem                                                      
                                                                        
      if(imem.eq.0) then 
         call strowp1(xin,Qin,upv,dnv,usea,str,chm,glu) 
      elseif(imem.eq.1) then 
         call strowp1(xin,Qin,upv,dnv,usea,str,chm,glu) 
      elseif(imem.eq.2) then 
         call strowp2(xin,Qin,upv,dnv,usea,str,chm,glu) 
      else 
      endif 
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= 0.0d0 
      pdf(5 )= 0.0d0 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv+usea 
      pdf(-1)= usea 
      pdf(1 )= dnv+usea 
      pdf(0 )= glu 
                                                                        
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry OWPread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
!      iset = nset                                                      
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry OWPalfa(alfas,qalfa) 
        call getnset(iset) 
        call GetOrderAsM(iset,iord) 
!        print*,'from getorderasm',iord                                 
        call Getlam4M(iset,imem,qcdl4) 
!        print*,'from getorderasm',iord                                 
        call Getlam5M(iset,imem,qcdl5) 
!        print*,'from getorderasm',iord                                 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry OWPinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry OWPpdf(mem) 
      imem = mem 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!*********************************************************************  
                                                                        
      SUBROUTINE STROWP1(X,SCALE,UPV,DNV,SEA,STR,CHM,GL) 
! ::::::::::::::  OWENS SET 1 PION STRUCTURE FUNCTION  :::::::::::::::  
      implicit real*8 (a-h,o-z) 
      DOUBLE PRECISION DGAMMA_LHA 
      double precision                                                  &
     &       COW(3,5,4),TS(6),XQ(9)                                     
                                                                        
!...Expansion coefficients for up and down valence quark distributions. 
      DATA ((COW(IP,IS,1),IS=1,5),IP=1,3)/                              &
     &  4.0000D-01,  7.0000D-01,  0.0000D+00,  0.0000D+00,  0.0000D+00, &
     & -6.2120D-02,  6.4780D-01,  0.0000D+00,  0.0000D+00,  0.0000D+00, &
     & -7.1090D-03,  1.3350D-02,  0.0000D+00,  0.0000D+00,  0.0000D+00/ 
!...Expansion coefficients for gluon distribution.                      
      DATA ((COW(IP,IS,2),IS=1,5),IP=1,3)/                              &
     &  8.8800D-01,  0.0000D+00,  3.1100D+00,  6.0000D+00,  0.0000D+00, &
     & -1.8020D+00, -1.5760D+00, -1.3170D-01,  2.8010D+00, -1.7280D+01, &
     &  1.8120D+00,  1.2000D+00,  5.0680D-01, -1.2160D+01,  2.0490D+01/ 
!...Expansion coefficients for (up+down+strange) quark sea distribution.
      DATA ((COW(IP,IS,3),IS=1,5),IP=1,3)/                              &
     &  9.0000D-01,  0.0000D+00,  5.0000D+00,  0.0000D+00,  0.0000D+00, &
     & -2.4280D-01, -2.1200D-01,  8.6730D-01,  1.2660D+00,  2.3820D+00, &
     &  1.3860D-01,  3.6710D-03,  4.7470D-02, -2.2150D+00,  3.4820D-01/ 
!...Expansion coefficients for charm quark sea distribution.            
      DATA ((COW(IP,IS,4),IS=1,5),IP=1,3)/                              &
     &  0.0000D+00, -2.2120D-02,  2.8940D+00,  0.0000D+00,  0.0000D+00, &
     &  7.9280D-02, -3.7850D-01,  9.4330D+00,  5.2480D+00,  8.3880D+00, &
     & -6.1340D-02, -1.0880D-01, -1.0852D+01, -7.1870D+00, -1.1610D+01/ 
                                                                        
       DATA ZEROD/0.D0/, ONED/1.D0/, SIXD/6.D0/ 
       DATA ALAM/0.2D0/, Q02/4.D0/, QMAX2/2.D3/ 
!...Pion structure functions from Owens.                                
!...Allowed variable range: 4 GeV^2 < Q^2 < approx 2000 GeV^2.          
                                                                        
!...Determine set, Lambda and s expansion variable.                     
        Q2 = SCALE*SCALE 
!        Q2IN = MIN( QMAX2,MAX( Q02,Q2))                                
        Q2IN = Q2 
        SD = LOG( LOG( Q2IN/ALAM**2)/ LOG( Q02/ALAM**2)) 
                                                                        
!...Calculate structure functions.                                      
        DO 240 KFL=1,4 
        DO 230 IS=1,5 
  230   TS(IS)=COW(1,IS,KFL)+COW(2,IS,KFL)*SD+                          &
     &  COW(3,IS,KFL)*SD*SD                                             
        IF(KFL.EQ.1) THEN 
!if defined(CERNLIB_SINGLE)                                             
!          DENOM = GAMMA(TS(1))*GAMMA(TS(2)+ONED)/GAMMA(TS(1)+TS(2)+ONED
!endif                                                                  
!if defined(CERNLIB_DOUBLE)                                             
          DENOM = DGAMMA_LHA(TS(1))*DGAMMA_LHA(TS(2)+ONED)/             &
     &                              DGAMMA_LHA(TS(1)+TS(2)+ONED)        
!endif                                                                  
          XQ(KFL)=X**TS(1)*(1.-X)**TS(2)/DENOM 
        ELSE 
          XQ(KFL)=TS(1)*X**TS(2)*(1.-X)**TS(3)*(1.+TS(4)*X+TS(5)*X**2) 
        ENDIF 
  240   CONTINUE 
                                                                        
!...Put into output arrays.                                             
        UPV = XQ(1) 
        DNV = XQ(1) 
        SEA = XQ(3)/SIXD 
        STR = XQ(3)/SIXD 
        CHM = XQ(4) 
        BOT = ZEROD 
        TOP = ZEROD 
        GL  = XQ(2) 
!                                                                       
        RETURN 
      END                                           
                                                                        
!*********************************************************************  
                                                                        
      SUBROUTINE STROWP2(X,SCALE,UPV,DNV,SEA,STR,CHM,GL) 
! ::::::::::::::  OWENS SET 2 PION STRUCTURE FUNCTION  :::::::::::::::  
      implicit real*8 (a-h,o-z) 
      DOUBLE PRECISION DGAMMA_LHA 
      double precision                                                  &
     &       COW(3,5,4),TS(6),XQ(9)                                     
                                                                        
!...Expansion coefficients for up and down valence quark distributions. 
      DATA ((COW(IP,IS,1),IS=1,5),IP=1,3)/                              &
     &  4.0000D-01,  6.2800D-01,  0.0000D+00,  0.0000D+00,  0.0000D+00, &
     & -5.9090D-02,  6.4360D-01,  0.0000D+00,  0.0000D+00,  0.0000D+00, &
     & -6.5240D-03,  1.4510D-02,  0.0000D+00,  0.0000D+00,  0.0000D+00/ 
!...Expansion coefficients for gluon distribution.                      
      DATA ((COW(IP,IS,2),IS=1,5),IP=1,3)/                              &
     &  7.9400D-01,  0.0000D+00,  2.8900D+00,  6.0000D+00,  0.0000D+00, &
     & -9.1440D-01, -1.2370D+00,  5.9660D-01, -3.6710D+00, -8.1910D+00, &
     &  5.9660D-01,  6.5820D-01, -2.5500D-01, -2.3040D+00,  7.7580D+00/ 
!...Expansion coefficients for (up+down+strange) quark sea distribution.
      DATA ((COW(IP,IS,3),IS=1,5),IP=1,3)/                              &
     &  9.0000D-01,  0.0000D+00,  5.0000D+00,  0.0000D+00,  0.0000D+00, &
     & -1.4170D-01, -1.6970D-01, -2.4740D+00, -2.5340D+00,  5.6210D-01, &
     & -1.7400D-01, -9.6230D-02,  1.5750D+00,  1.3780D+00, -2.7010D-01/ 
!...Expansion coefficients for charm quark sea distribution.            
      DATA ((COW(IP,IS,4),IS=1,5),IP=1,3)/                              &
     &  0.0000D+00, -8.8200D-02,  1.9240D+00,  0.0000D+00,  0.0000D+00, &
     &  6.2290D-02, -2.8920D-01,  2.4240D-01, -4.4630D+00, -8.3670D-01, &
     & -4.0990D-02, -1.0820D-01,  2.0360D+00,  5.2090D+00, -4.8400D-02/ 
                                                                        
       DATA ZEROD/0.D0/, ONED/1.D0/, SIXD/6.D0/ 
       DATA ALAM/0.4D0/, Q02/4.D0/, QMAX2/2.D3/ 
!...Pion structure functions from Owens.                                
!...Allowed variable range: 4 GeV^2 < Q^2 < approx 2000 GeV^2.          
                                                                        
!...Determine set, Lambda and s expansion variable.                     
        Q2 = SCALE*SCALE 
!        Q2IN = MIN( QMAX2,MAX( Q02,Q2))                                
        Q2IN = Q2 
        SD = LOG( LOG( Q2IN/ALAM**2)/ LOG( Q02/ALAM**2)) 
                                                                        
!...Calculate structure functions.                                      
        DO 10 KFL=1,4 
        DO 20 IS=1,5 
   20   TS(IS)=COW(1,IS,KFL)+COW(2,IS,KFL)*SD+                          &
     &  COW(3,IS,KFL)*SD*SD                                             
        IF(KFL.EQ.1) THEN 
!if defined(CERNLIB_SINGLE)                                             
!         DENOM = GAMMA(TS(1))*GAMMA(TS(2)+ONED)/GAMMA(TS(1)+TS(2)+ONED)
!endif                                                                  
!if defined(CERNLIB_DOUBLE)                                             
          DENOM = DGAMMA_LHA(TS(1))*DGAMMA_LHA(TS(2)+ONED)/             &
     &                              DGAMMA_LHA(TS(1)+TS(2)+ONED)        
!endif                                                                  
          XQ(KFL)=X**TS(1)*(1.-X)**TS(2)/DENOM 
        ELSE 
          XQ(KFL)=TS(1)*X**TS(2)*(1.-X)**TS(3)*(1.+TS(4)*X+TS(5)*X**2) 
        ENDIF 
   10   CONTINUE 
                                                                        
!...output                                                              
        UPV = XQ(1) 
        DNV = XQ(1) 
        SEA = XQ(3)/SIXD 
        STR = XQ(3)/SIXD 
        CHM = XQ(4) 
        GL  = XQ(2) 
!                                                                       
        RETURN 
      END                                           

! -*- F90 -*-


      subroutine USERevolve(x,Q,f) 
      implicit none 
      integer nset 
      real*8 f(-6:6) 
      real*8 x,Q 
      real*8 alfas 
      real*8 Eorder,Q2fit 
      return 
!                                                                       
      entry USERread(nset) 
      return 
!                                                                       
      entry USERalfa(alfas,Q) 
      return 
!                                                                       
      entry USERinit(nset,Eorder,Q2fit) 
      return 
!                                                                       
      entry USERpdf(nset) 
      return 
!                                                                       
      END                                           

program example3
  implicit double precision (a-h,o-z)
  double precision f(-6:6)
  
  QMZ=91.71d0
  Nmem=31
  write(*,*)
  do i=1,Nmem
     write(*,*) '---------------------------------------------'
     write(*,*) 'PDF set ',i
     write(*,*)
     write(*,*) 'x*Gluon'
     write(*,*) '   x     Q=10 GeV     Q=100 GeV    Q=1000 GeV'
     do ix=10,95,10
        x = dfloat(ix)*1.0d-03
        Q=10d0
        call parden(x,Q,f,i)
        g1=f(0)
        Q=100d0
        call parden(x,Q,f,i)
        g2=f(0)
        Q=1000d0
        call parden(x,Q,f,i)
        g3=f(0)
        write(*,*) x,g1,g2,g3
     enddo
     a=alphasPDF(QMZ)
     write(*,*)
     write(*,*) 'alpha_S(M_Z) = ',a
     write(*,*)
  enddo

end program example3

subroutine parden(x,Q,f,imem)
  implicit none
  character*64 name
  data name/'Alekhin_100.LHpdf'/
  double precision x,Q,f(-6:6)
  integer imem,init,lmem
  data init/0/
  data lmem/-1/
  save init,lmem
  
  if (init.eq.0) then
     init=1
     call InitPDFsetByName(name)
  endif
  if (imem.ne.lmem) then
     lmem=imem
     call InitPDF(lmem)
  endif
  call evolvePDF(x,Q,f)
  return

end subroutine parden

      subroutine GJRevolve(xin,qin,pdf)
      implicit real*8 (a-h,o-z)
      include 'parmsetup.inc'
      character*16 name(nmxset)
      integer nmem(nmxset),ndef(nmxset),mmem
      common/NAME/name,nmem,ndef,mmem
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      CHARACTER*80 LINE
      dimension pdf(-6:6)
      integer ng(2),init,set,i,j,k,l,nset,iset
      double precision fgrid(118,99,-5:3,0:26),grid(217)
      !double precision fgrid(118,99,-5:3,0:0),grid(217)
!      common/fgridc/fgrid
      double precision upv,dnv,usea,dsea,str,chm,bot,glu
      double precision arg(2)
      double precision lha_dfint
      double precision lha_gjr08
      data ng /118,99/

      data grid &
     & /1d-9,1.25d-9,1.6d-9,2d-9,2.5d-9,3.16d-9,4d-9,5d-9,6.3d-9,8d-9, &
     &  1d-8,1.25d-8,1.6d-8,2d-8,2.5d-8,3.16d-8,4d-8,5d-8,6.3d-8,8d-8, &
     &  1d-7,1.25d-7,1.6d-7,2d-7,2.5d-7,3.16d-7,4d-7,5d-7,6.3d-7,8d-7, &
     &  1d-6,1.25d-6,1.6d-6,2d-6,2.5d-6,3.16d-6,4d-6,5d-6,6.3d-6,8d-6, &
     &  1d-5,1.25d-5,1.6d-5,2d-5,2.5d-5,3.16d-5,4d-5,5d-5,6.3d-5,8d-5, &
     &  1d-4,1.25d-4,1.6d-4,2d-4,2.5d-4,3.16d-4,4d-4,5d-4,6.3d-4,8d-4, &
     &  1d-3,1.25d-3,1.6d-3,2d-3,2.5d-3,3.16d-3,4d-3,5d-3,6.3d-3,8d-3, &
     &  1d-2,1.25d-2,1.6d-2,2d-2,2.5d-2,3.16d-2,4d-2,5d-2,6.3d-2,8d-2, &
     &  0.10d0,0.125d0,0.15d0,0.175d0,0.20d0,0.225d0,0.25d0,0.275d0, &
     &  0.30d0,0.325d0,0.35d0,0.375d0,0.40d0,0.425d0,0.45d0,0.475d0, &
     &  0.50d0,0.525d0,0.55d0,0.575d0,0.60d0,0.625d0,0.65d0,0.675d0, &
     &  0.70d0,0.725d0,0.75d0,0.775d0,0.80d0,0.825d0,0.85d0,0.875d0, &
     &  0.9d0,0.920d0,0.94d0,0.960d0,0.98d0,1d0, &
     &  0.3d0,0.31d0,0.35d0,0.375d0,0.4d0,0.45d0,0.5d0,0.51d0,0.525d0, &
     &  0.55d0,0.575d0,0.6d0,0.65d0,0.7d0,0.75d0,0.8d0,0.85d0,0.9d0, &
     &  1d0,1.25d0,1.6d0,2d0,2.5d0,3.16d0,4d0,5d0,6.3d0,8d0, &
     &  1d1,1.25d1,1.6d1,2d1,2.5d1,3.16d1,4d1,5d1,6.3d1,8d1, &
     &  1d2,1.25d2,1.6d2,2d2,2.5d2,3.16d2,4d2,5d2,6.3d2,8d2, &
     &  1d3,1.25d3,1.6d3,2d3,2.5d3,3.16d3,4d3,5d3,6.3d3,8d3, &
     &  1d4,1.25d4,1.6d4,2d4,2.5d4,3.16d4,4d4,5d4,6.3d4,8d4, &
     &  1d5,1.25d5,1.6d5,2d5,2.5d5,3.16d5,4d5,5d5,6.3d5,8d5, &
     &  1d6,1.25d6,1.6d6,2d6,2.5d6,3.16d6,4d6,5d6,6.3d6,8d6, &
     &  1d7,1.25d7,1.6d7,2d7,2.5d7,3.16d7,4d7,5d7,6.3d7,8d7,1d8/

      save 
      x=xin
      q2=qin*qin 
      call getnset(iset)
      call getnmem(iset,imem)
       upv =  LHA_GJR08(x,Q2,grid,fgrid,ng,1,imem)
      dnv =  LHA_GJR08(x,Q2,grid,fgrid,ng,2,imem)
      usea = LHA_GJR08(x,Q2,grid,fgrid,ng,-1,imem)
      dsea = LHA_GJR08(x,Q2,grid,fgrid,ng,-2,imem)
      str =  LHA_GJR08(x,Q2,grid,fgrid,ng,-3,imem)
      glu =  LHA_GJR08(x,Q2,grid,fgrid,ng,0,imem)
      pdf(-6) = 0.0d0
       pdf(6) = 0.0d0
      pdf(-5) = 0.0d0
       pdf(5) = 0.0d0
      pdf(-4) = 0.0d0
       pdf(4) = 0.0d0
      pdf(-3) = str
       pdf(3) = str
      pdf(-2) = usea
       pdf(2) = upv+usea
      pdf(-1) = dsea
       pdf(1) = dnv+dsea
       pdf(0) = glu
      if(name(iset)(1:7).eq.'GJR08VF'.or. &
     &   name(iset)(1:7).eq.'GJR08LO') then
        chm =  LHA_GJR08(x,Q2,grid,fgrid,ng,-4,imem)
       bot =  LHA_GJR08(x,Q2,grid,fgrid,ng,-5,imem)
       pdf(-5) = bot
        pdf(5) = bot
       pdf(-4) = chm
        pdf(4) = chm
      endif
      return
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!      
      entry GJRgetgrid(nset,ngridx,ngridq,gridx,gridq)
     
      ngridx=118
      do jx=1,118
          gridx(jx)=grid(jx)
      enddo

      ngridq=99      
      do jq=1,99
          gridq(jq)=grid(118+jq)
      enddo 
       
      return
      
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry GJRread(nset)
!     
      call getnmem(nset,imem) 
      read(1,*)nmem(nset),ndef(nset)
      lstart = -3
      if(name(nset)(1:7).eq.'GJR08VF') lstart=-5
      do i=0,nmem(nset)
      !do ii=0,nmem(nset)
!       i = 0
       do j=1,118
        do k=1,99
         if(name(nset)(1:7).eq.'GJR08VF'.or. &
     &      name(nset)(1:7).eq.'GJR08LO') then
           read(1,*) fgrid(j,k,-5,i),fgrid(j,k,-4,i), &
     &  	   fgrid(j,k,-3,i),fgrid(j,k,-2,i),fgrid(j,k,-1,i), &
     &  	   fgrid(j,k,0,i),fgrid(j,k,1,i),fgrid(j,k,2,i), &
     &  	   fgrid(j,k,3,i)
         else
          read(1,*) fgrid(j,k,-3,i),fgrid(j,k,-2,i),fgrid(j,k,-1,i), &
     &  	   fgrid(j,k,0,i),fgrid(j,k,1,i),fgrid(j,k,2,i), &
     &  	    fgrid(j,k,3,i)
         endif
        if(name(nset)(1:7).ne.'GJR08LO') then
          do  l=-lstart,3
            if (grid(118+k) < 0.5d0) then
              fgrid(j,k,l,i)=0d0
              fgrid(j,k,l,i)=0d0/fgrid(j,k,l,i)
            endif
          enddo
         endif
        enddo
       enddo
      enddo

      return
!

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry GJRalfa(alfas,qalfa)
      call getnset(iset)
      call getnmem(iset,imem)
      arg(1) = 1d-9
      arg(2) = qalfa*qalfa
!      imem = 0
      alfas = lha_dfint(2,arg,ng,grid,fgrid(1,1,3,imem))
      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry GJRinit(Eorder,Q2fit)
      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry GJRpdf(mem)
      imem = mem
      call getnset(iset)
       call setnmem(iset,imem)
      return
!
 1000 format(5e13.5)
      end
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      double precision function LHA_GJR08(x,Q2,grid,fgrid,ng,n,set)
      implicit none
      integer ng(2),n,set
      double precision grid(217),arg(2),x,Q2
      double precision lha_dfint
      double precision fgrid(118,99,-5:3,0:26)
!      common/fgridc/fgrid
      arg(1) = x
      arg(2) = Q2
       LHA_GJR08 = lha_dfint(2,arg,ng,grid,fgrid(1,1,n,set))
      end
      
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 
!! CERNLIB E104 modified to be used with GJR08 GRIDS:
!! Name changed from fint to dfint.
!! Name changed from dfint to lha_dfint.
!! Real variables changed to double precision.
!! External references to CERNLIB (error handling) routines removed.
          DOUBLE PRECISION FUNCTION LHA_DFINT(NARG,ARG,NENT,ENT,TABLE)
          INTEGER   NENT(9), INDEX(32)
          DOUBLE PRECISION ARG(9),   ENT(9),   TABLE(9), WEIGHT(32)
          LHA_DFINT  =  0d0
          IF(NARG .LT. 1  .OR.  NARG .GT. 5)  GOTO 300
          LMAX      =  0
          ISTEP     =  1
          KNOTS     =  1
          INDEX(1)  =  1
          WEIGHT(1) =  1d0
          DO 100    N  =  1, NARG
             X     =  ARG(N)
             NDIM  =  NENT(N)
             LOCA  =  LMAX
             LMIN  =  LMAX + 1
             LMAX  =  LMAX + NDIM
             IF(NDIM .GT. 2)  GOTO 10
             IF(NDIM .EQ. 1)  GOTO 100
             H  =  X - ENT(LMIN)
             IF(H .EQ. 0.)  GOTO 90
             ISHIFT  =  ISTEP
             IF(X-ENT(LMIN+1) .EQ. 0d0)  GOTO 21
             ISHIFT  =  0
             ETA     =  H / (ENT(LMIN+1) - ENT(LMIN))
             GOTO 30
  10         LOCB  =  LMAX + 1
  11         LOCC  =  (LOCA+LOCB) / 2
!             IF(X-ENT(LOCC))  12, 20, 13
             IF(X-ENT(LOCC).lt.0)  goto 12
             IF(X-ENT(LOCC).eq.0)  goto 20
             IF(X-ENT(LOCC).gt.0)  goto 13            
  12         LOCB  =  LOCC
             GOTO 14
  13         LOCA  =  LOCC
  14         IF(LOCB-LOCA .GT. 1)  GOTO 11
             LOCA    =  MIN0( MAX0(LOCA,LMIN), LMAX-1 )
             ISHIFT  =  (LOCA - LMIN) * ISTEP
             ETA     =  (X - ENT(LOCA)) / (ENT(LOCA+1) - ENT(LOCA))
             GOTO 30
  20         ISHIFT  =  (LOCC - LMIN) * ISTEP
  21         DO 22  K  =  1, KNOTS
                INDEX(K)  =  INDEX(K) + ISHIFT
  22            CONTINUE
             GOTO 90
  30         DO 31  K  =  1, KNOTS
                INDEX(K)         =  INDEX(K) + ISHIFT
                INDEX(K+KNOTS)   =  INDEX(K) + ISTEP
                WEIGHT(K+KNOTS)  =  WEIGHT(K) * ETA
                WEIGHT(K)        =  WEIGHT(K) - WEIGHT(K+KNOTS)
  31            CONTINUE
             KNOTS  =  2*KNOTS
  90         ISTEP  =  ISTEP * NDIM
 100         CONTINUE
          DO 200    K  =  1, KNOTS
             I  =  INDEX(K)
             LHA_DFINT  =  LHA_DFINT + WEIGHT(K) * TABLE(I)
 200         CONTINUE
          RETURN
 300      WRITE(*,1000) NARG
          STOP
1000      FORMAT( 7X, 24HFUNCTION DFINT... NARG =,I6, &
     &              17H NOT WITHIN RANGE)
          END

! -*- F90 -*-


      subroutine ACFGPevolvep(xin,qin,p2in,ip2in,pdf) 
      include 'parmsetup.inc' 
      real*8 xin,qin,q2in,p2in,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      real*4 par,par2,calc,celc 
      common/acfgp/PAR(30,3),CALC(8,20,32,3),PAR2(30),CELC(8,20,32) 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
                                                                        
      save 
                                                                        
      if(imem.eq.1) then 
        call ACFGP1(xin,qin,upv,dnv,usea,dsea,str,chm,glu) 
                                                                        
      elseif(imem.eq.2) then 
        call ACFGP2(xin,qin,upv,dnv,usea,dsea,str,chm,glu) 
                                                                        
      elseif(imem.eq.3.or.imem.eq.0) then 
        call SFAFG1(xin,qin,upv,dnv,usea,dsea,str,chm,glu) 
                                                                        
      else 
        CONTINUE 
      endif 
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= 0.0d0 
      pdf(5 )= 0.0d0 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ACFGPread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
      do iset = 1,3 
        read(1,*)(par(j,iset),j=1,4) 
        read(1,*)(par(j,iset),j=5,8) 
        read(1,*)(par(j,iset),j=9,12) 
        read(1,*)(par(j,iset),j=13,16) 
        read(1,*)(par(j,iset),j=17,20) 
        read(1,*)(par(j,iset),j=21,24) 
        read(1,*)(par(j,iset),j=25,28) 
        read(1,*)(par(j,iset),j=29,30) 
        do j=1,32 
          do k=1,20 
            read(1,*)(calc(i,k,j,iset),i=1,4) 
            read(1,*)(calc(i,k,j,iset),i=5,8) 
          enddo 
        enddo 
      enddo 
! last one                                                              
      read(1,*)(par2(j),j=1,4) 
      read(1,*)(par2(j),j=5,8) 
      read(1,*)(par2(j),j=9,12) 
      read(1,*)(par2(j),j=13,16) 
      read(1,*)(par2(j),j=17,20) 
      read(1,*)(par2(j),j=21,24) 
      read(1,*)(par2(j),j=25,28) 
      read(1,*)(par2(j),j=29,30) 
      do j=1,32 
        do k=1,20 
          read(1,*)(celc(i,k,j),i=1,4) 
          read(1,*)(celc(i,k,j),i=5,8) 
        enddo 
      enddo 
                                                                        
      return 
                                                                        
                                                                        
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ACFGPalfa(alfas,qalfa) 
        call getnset(iset) 
        call GetOrderAsM(iset,iord) 
        call Getlam4M(iset,imem,qcdl4) 
        call Getlam5M(iset,imem,qcdl5) 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
                                                                        
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ACFGPinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry ACFGPpdf(mem) 
      imem = mem 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      SUBROUTINE ACFGP1(DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DGL) 
!                                                                       
!     INTERPOLATION PROGRAM WHICH INTERPOLATES THE GRID "DATAGA" AND GIV
!     QUARK AND GLUON DISTRIBUTIONS IN THE REAL PHOTON, AS FUNCTIONS OF 
!                                                                       
!     THE Q2-EVOLUTION IS PERFORMED WITH BLL AP-EQUATIONS AND NF=4. A MA
!     CHARM DISTRIBUTION (BORROWED FROM GLUCK AND REYA) IS ALSO AVAILABL
!                                                                       
!     THE BOUNDARY CONDITIONS ARE SUCH THAT THE DISTRIBUTION FUNCTIONS A
!     BY A VDM "ANSATZ" AT Q2=.25 GEV**2.                               
!                                                                       
!     THE PROGRAM WORKS FOR  2. GEV**2 < Q2 <5.5E+5   AND .00137 < X < .
!                                                                       
!     THE DISTRIBUTIONS ARE CALCULATED IN THE MSBAR FACTORIZATION SCHEME
!                                                                       
!     THE VALUE OF LAMBDA-MSB IS 200 MEV                                
!                                                                       
!     THE OUTPUT IS WRITTEN IN THE FILE 'FILEOUT':                      
!                                  X*U=X*U(X,Q2)                        
!                                  X*D= ...                             
!                                  X*S= ...                             
!                                  X*C= ...  (MASSLESS CHARM WITH     C(
!                                 X*CM= ...  (MASSIVE CHARM WITH MC=1.5 
!                              X*GLU=GLUON(X,Q2)*X                      
!                                                                       
!                                                                       
!                    F2 = PHOTON STRUCTURE FUNCTION WITHOUT CHARM       
!                    F2C=  "        "         "     WITH MASSIVE CHARM  
!                                                                       
      double precision                                                  &
     &       DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL                      
      REAL    X, Q, UV, DV, UB, DB, SB, CB, BB, GL 
      REAL       Q2 
      common/acfgp/PAR(30,3),CALC(8,20,32,3),PAR2(30),CELC(8,20,32) 
      DIMENSION XPDF(7),CALCO(8,20,32) 
      COMMON/W5051I7/CALCO 
      EXTERNAL AFCPLU 
      DATA ZERO/0.0/ 
!---------------------------------------------------------------------- 
       DATA ISTART/0/ 
       SAVE ISTART,OWLAM2,Q02,FLAV, /W5051I7/ 
!                                                                       
      IF (ISTART.EQ.0) THEN 
        ISTART=1 
        DO 10 K=1,32 
        DO 10 I=1,20 
        DO 10 M=1,8 
   10   CALCO(M,I,K) = CALC(M,I,K,1) 
           OWLAM=PAR(1,1) 
           OWLAM2=OWLAM**2 
           Q02=PAR(30,1) 
           FLAV=PAR(25,1) 
           DELTA=PAR(29,1) 
           CALL WATE32 
         ENDIF 
!                                                                       
      X = DX 
      Q = DQ 
      Q2 = Q*Q 
      IDQ2=2 
      SB=0. 
      IF((Q2-Q02).LE.0) THEN 
        GOTO 1 
      ELSE 
        GOTO 2 
      ENDIF 
    2 IF((IDQ2-1).LE.0) THEN 
        GOTO 1 
      ELSE 
        GOTO 3 
      ENDIF 
    3 SB= LOG( LOG( MAX(Q02,Q2)/OWLAM2)/ LOG(Q02/OWLAM2)) 
    1 CONTINUE 
      CALL AURGAM(8,0,X,SB,XPDF(7)) 
      CALL AURGAM(7,0,X,SB,SING) 
      CALL AURGAM(4,0,X,SB,DPLUSNS) 
      CALL AURGAM(3,0,X,SB,CPLUSNS) 
      CALL AURGAM(5,0,X,SB,UPLUSNS) 
      CALL AURGAM(6,0,X,SB,SPLUSNS) 
      XPDF(3) = CPLUSNS 
      XPDF(4) = DPLUSNS 
      XPDF(5) = UPLUSNS 
      XPDF(6) = SPLUSNS 
      XPDF(1) = SING 
!                                                                       
      ADD = XPDF(1)/FLAV 
      UPLUS=XPDF(5)+ADD 
      DPLUS=-XPDF(4)+ADD 
      SPLUS=-XPDF(6)+ADD 
      CPLUS=-XPDF(3)+ADD 
      UB=UPLUS*0.5 
      UV=UB 
      DB=DPLUS*0.5 
      DV=DB 
      SB=SPLUS*0.5 
      CB=CPLUS*0.5 
      SING=XPDF(1) 
      GLU=XPDF(7) 
      GL=GLU 
!                                                                       
      DUV=MAX(ZERO,UV) 
      DDV=MAX(ZERO,DV) 
      DUB=MAX(ZERO,UB) 
      DDB=MAX(ZERO,DB) 
      DSB=MAX(ZERO,SB) 
      DCB=MAX(ZERO,CB) 
      DGL=MAX(ZERO,GL) 
!                                                                       
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE ACFGP2(DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DGL) 
!                                                                       
!     INTERPOLATION PROGRAM WHICH INTERPOLATES THE GRID "DATAGA" AND GIV
!     QUARK AND GLUON DISTRIBUTIONS IN THE REAL PHOTON, AS FUNCTIONS OF 
!                                                                       
!     THE Q2-EVOLUTION IS PERFORMED WITH BLL AP-EQUATIONS AND NF=4. A MA
!     CHARM DISTRIBUTION (BORROWED FROM GLUCK AND REYA) IS ALSO AVAILABL
!                                                                       
!     THE BOUNDARY CONDITIONS ARE SUCH THAT THE DISTRIBUTION FUNCTIONS A
!     BY A VDM "ANSATZ" AT Q2=.25 GEV**2.                               
!                                                                       
!     THE PROGRAM WORKS FOR  2. GEV**2 < Q2 <5.5E+5   AND .00137 < X < .
!                                                                       
!     THE DISTRIBUTIONS ARE CALCULATED IN THE MSBAR FACTORIZATION SCHEME
!                                                                       
!     THE VALUE OF LAMBDA-MSB IS 200 MEV                                
!                                                                       
!     THE OUTPUT IS WRITTEN IN THE FILE 'FILEOUT':                      
!                                  X*U=X*U(X,Q2)                        
!                                  X*D= ...                             
!                                  X*S= ...                             
!                                  X*C= ...  (MASSLESS CHARM WITH     C(
!                                 X*CM= ...  (MASSIVE CHARM WITH MC=1.5 
!                              X*GLU=GLUON(X,Q2)*X                      
!                                                                       
!                                                                       
!                    F2 = PHOTON STRUCTURE FUNCTION WITHOUT CHARM       
!                    F2C=  "        "         "     WITH MASSIVE CHARM  
!                                                                       
      double precision                                                  &
     &       DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL                      
      REAL    X, Q, UV, DV, UB, DB, SB, CB, BB, GL 
      REAL       Q2 
      common/acfgp/PAR(30,3),CALC(8,20,32,3),PAR2(30),CELC(8,20,32) 
      DIMENSION XPDF(7),CALCO(8,20,32) 
      COMMON/W5051I7/CALCO 
      EXTERNAL AFCPLU 
      DATA ZERO/0.0/ 
!---------------------------------------------------------------------- 
       DATA ISTART/0/ 
       SAVE ISTART,OWLAM2,Q02,FLAV, /W5051I7/ 
!                                                                       
      IF (ISTART.EQ.0) THEN 
        ISTART=1 
        DO 10 K=1,32 
        DO 10 I=1,20 
        DO 10 M=1,8 
   10   CALCO(M,I,K) = CALC(M,I,K,2) 
           OWLAM=PAR(1,2) 
           OWLAM2=OWLAM**2 
           Q02=PAR(30,2) 
           FLAV=PAR(25,2) 
           DELTA=PAR(29,2) 
           CALL WATE32 
         ENDIF 
!                                                                       
      X = DX 
      Q = DQ 
      Q2 = Q*Q 
      IDQ2=2 
      SB=0. 
      IF((Q2-Q02).LE.0) THEN 
        GOTO 1 
      ELSE 
        GOTO 2 
      ENDIF 
    2 IF((IDQ2-1).LE.0) THEN 
        GOTO 1 
      ELSE 
         GOTO 3 
      ENDIF 
    3 SB= LOG( LOG( MAX(Q02,Q2)/OWLAM2)/ LOG(Q02/OWLAM2)) 
    1 CONTINUE 
      CALL AURGAM(8,0,X,SB,XPDF(7)) 
      CALL AURGAM(7,0,X,SB,SING) 
      CALL AURGAM(4,0,X,SB,DPLUSNS) 
      CALL AURGAM(3,0,X,SB,CPLUSNS) 
      CALL AURGAM(5,0,X,SB,UPLUSNS) 
      CALL AURGAM(6,0,X,SB,SPLUSNS) 
      XPDF(3) = CPLUSNS 
      XPDF(4) = DPLUSNS 
      XPDF(5) = UPLUSNS 
      XPDF(6) = SPLUSNS 
      XPDF(1) = SING 
!                                                                       
      ADD = XPDF(1)/FLAV 
      UPLUS=XPDF(5)+ADD 
      DPLUS=-XPDF(4)+ADD 
      SPLUS=-XPDF(6)+ADD 
      CPLUS=-XPDF(3)+ADD 
      UB=UPLUS*0.5 
      UV=UB 
      DB=DPLUS*0.5 
      DV=DB 
      SB=SPLUS*0.5 
      CB=CPLUS*0.5 
      SING=XPDF(1) 
      GLU=XPDF(7) 
      GL=GLU 
!... get parton density with massive charm                              
      CPLUM=AFCPLU(X,Q2) 
      CB=CPLUM*0.5 
!                                                                       
      DUV=MAX(ZERO,UV) 
      DDV=MAX(ZERO,DV) 
      DUB=MAX(ZERO,UB) 
      DDB=MAX(ZERO,DB) 
      DSB=MAX(ZERO,SB) 
      DCB=MAX(ZERO,CB) 
      DGL=MAX(ZERO,GL) 
!                                                                       
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE SFAFG1(DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DGL) 
!                                                                       
!***********************************************************************
!                       ( 1st of February 1994)                         
!     This is an interpolation program which reads the files GRPOL and  
!     GRVDM and gives the quark and gluon distributions in real photon  
!     as functions of x and Q**2.                                       
!                                                                       
!     The Q**2 evolution is a BLL evolution (MSbar scheme) with Nf=4    
!     and LAMBDA(MSbar)=.200 Gev.                                       
!                                                                       
!     A massless charm distribution is generated for Q**2 > 2 Gev**2.   
!                                                                       
!     The distributions are the sum of a pointlike part (PL) and of a   
!     Vdm part (VDM):                                                   
!                     dist=PL + KA*VDM                                  
!     KA is a factor which can be adjusted ( the default value is KA=1.0
!     The file GRPOL contains the pointlike part of the distributions.  
!     The file GRVDM contains the vdm part (A precise definition of this
!     latter is given in the paper "PARTON DISTRIBUTIONS IN THE PHOTON",
!     Preprint LPTHE Orsay 93-37, by P.Aurenche,M.Fontannaz and J.Ph.Gui
!                                                                       
!     The output of the program is written in the file GETOUT with the  
!     following conventions                                             
!                              UPLUS=x(u+ubar)                          
!                              DPLUS=x(d+dbar)                          
!                              SPLUS=x(s+sbar)                          
!                              CPLUS=x(c+cbar)                          
!                              SING =UPLUS+DPLUS+SPLUS+CPLUS            
!                              GLU  =x*g                                
!                                                                       
!      The interpolation is valid for     2. < Q**2 < 5.5E+5 Gev**2,    
!                             and for   .0015<  x   < .99               
!                                                                       
!      The program also gives the structure function F2:                
!                        F2 = q*Cq + g*Cg + Cgam                        
!      Cq and Cg are the Wilson coeficients and Cgam is the direct term.
!                                                                       
!      Although the charm quark evolution is massless, the direct term  
!      Cgam includes the effects due to the charm quark mass. The charm 
!      quark threshold is therefore correctly described at the lowest   
!      ordre in alphastrong (Details are given in the preprint).        
!                                                                       
!                                                                       
!***********************************************************************
!                                                                       
      double precision                                                  &
     &       DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL                      
      REAL    X, Q, UV, DV, UB, DB, SB, CB, BB, GL 
      REAL       Q2 
      DIMENSION XPDF(7) 
      common/acfgp/PAR(30,3),CALC(8,20,32,3),PAR2(30),CELC(8,20,32) 
      DIMENSION CALCO(8,20,32) 
      DIMENSION CELCO(8,20,32) 
      COMMON/W5051IA/CALCO 
      COMMON/W5051IB/CELCO 
      EXTERNAL AFCPLU 
      DATA ZERO/0.0/ 
!---------------------------------------------------------------------- 
       DATA ISTART/0/ 
       SAVE ISTART,OWLAM2,Q02,FLAV,KA, /W5051IA/, /W5051IB/ 
!                                                                       
      IF (ISTART.EQ.0) THEN 
        ISTART=1 
        DO 10 K=1,32 
        DO 10 I=1,20 
        DO 10 M=1,8 
        CALCO(M,I,K) = CALC(M,I,K,3) 
   10   CELCO(M,I,K) = CELC(M,I,K) 
           OWLAM=PAR(1,3) 
           OWLAM2=OWLAM**2 
           Q02=PAR(30,3) 
           FLAV=PAR(25,3) 
           DELTA=PAR(29,3) 
           CALL WATE32 
           KA=1.0 
         ENDIF 
!                                                                       
      X = DX 
      Q = DQ 
      Q2 = Q*Q 
      IDQ2=2 
      SB=0. 
      IF((Q2-Q02).LE.0) THEN 
        GOTO 1 
      ELSE 
        GOTO 2 
      ENDIF 
    2 IF((IDQ2-1).LE.0) THEN 
        GOTO 1 
      ELSE 
         GOTO 3 
      ENDIF 
    3 SB= LOG( LOG( MAX(Q02,Q2)/OWLAM2)/ LOG(Q02/OWLAM2)) 
    1 CONTINUE 
      CALL AFGINT(8,0,X,SB,XPDF(7)) 
      CALL AFGINT(7,0,X,SB,SING) 
      CALL AFGINT(4,0,X,SB,DPLUSNS) 
      CALL AFGINT(3,0,X,SB,CPLUSNS) 
      CALL AFGINT(5,0,X,SB,UPLUSNS) 
      CALL AFGINT(6,0,X,SB,SPLUSNS) 
      XPDF(3) = CPLUSNS 
      XPDF(4) = DPLUSNS 
      XPDF(5) = UPLUSNS 
      XPDF(6) = SPLUSNS 
      XPDF(1) = SING 
!                                                                       
      ADD = XPDF(1)/FLAV 
      UPLUS= XPDF(5)+ADD 
      DPLUS=-XPDF(4)+ADD 
      SPLUS=-XPDF(6)+ADD 
      CPLUS=-XPDF(3)+ADD 
      SING=XPDF(1) 
      GLU=XPDF(7) 
      GL=GLU 
!                                                                       
      CALL AFGIN2(8,0,X,SB,XPDF(7)) 
      CALL AFGIN2(7,0,X,SB,SING) 
      CALL AFGIN2(4,0,X,SB,DPLUSNS) 
      CALL AFGIN2(3,0,X,SB,CPLUSNS) 
      CALL AFGIN2(5,0,X,SB,UPLUSNS) 
      CALL AFGIN2(6,0,X,SB,SPLUSNS) 
      XPDF(3) = CPLUSNS 
      XPDF(4) = DPLUSNS 
      XPDF(5) = UPLUSNS 
      XPDF(6) = SPLUSNS 
      XPDF(1) = SING 
!                                                                       
      ADD2 = XPDF(1)/FLAV 
      UPLU2= XPDF(5)+ADD2 
      DPLU2=-XPDF(4)+ADD2 
      SPLU2=-XPDF(6)+ADD2 
      CPLU2=-XPDF(3)+ADD2 
      SING2=XPDF(1) 
      GLU2=XPDF(7) 
      UB=UPLUS+UPLU2*KA 
      UB=UB/2.0
      UV=UB 
      DB=DPLUS+DPLU2*KA 
      DB=DB/2.0
      DV=DB 
      SB=SPLUS+SPLU2*KA 
      SB=SB/2.0
      CB=CPLUS+CPLU2*KA 
      CB=CB/2.0
      SING=SING+SING2*KA 
      GL=GLU+GLU2*KA 
!                                                                       
      DUV=MAX(ZERO,UV) 
      DDV=MAX(ZERO,DV) 
      DUB=MAX(ZERO,UB) 
      DDB=MAX(ZERO,DB) 
      DSB=MAX(ZERO,SB) 
      DCB=MAX(ZERO,CB) 
      DGL=MAX(ZERO,GL) 
!                                                                       
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE WATE32 
!  32 POINT GAUSSIAN QUADRATURE ROUTINE                                 
      double precision                                                  &
     &       X(16),W(16)                                                
      double precision                                                  &
     &               XI(32),WI(32),XX(33)                               
      COMMON/W5051I9/XI,WI,XX,NTERMS 
      NTERMS=32 
      X(1)=0.048307665687738316235D0 
      X(2)=0.144471961582796493485D0 
      X(3)=0.239287362252137074545D0 
      X(4)=0.331868602282127649780D0 
      X(5)=0.421351276130635345364D0 
      X(6)=0.506899908932229390024D0 
      X(7)=0.587715757240762329041D0 
      X(8)=0.663044266930215200975D0 
      X(9)=0.732182118740289680387D0 
      X(10)=0.794483795967942406963D0 
      X(11)=0.849367613732569970134D0 
      X(12)=0.896321155766052123965D0 
      X(13)=0.934906075937739689171D0 
      X(14)=0.964762255587506430774D0 
      X(15)=0.985611511545268335400D0 
      X(16)=0.997263861849481563545D0 
      W(1)=0.096540088514727800567D0 
      W(2)=0.095638720079274859419D0 
      W(3)=0.093844399080804565639D0 
      W(4)=0.091173878695763884713D0 
      W(5)=0.087652093004403811143D0 
      W(6)=0.083311924226946755222D0 
      W(7)=0.078193895787070306472D0 
      W(8)=0.072345794108848506225D0 
      W(9)=0.065822222776361846838D0 
      W(10)=0.058684093478535547145D0 
      W(11)=0.050998059262376176196D0 
      W(12)=0.042835898022226680657D0 
      W(13)=0.034273862913021433103D0 
      W(14)=0.025392065309262059456D0 
      W(15)=0.016274394730905670605D0 
      W(16)=0.007018610009470096600D0 
      NTERMH = NTERMS/2 
      DO 1 I=1,NTERMH 
      XI(I)=-X(17-I) 
      WI(I)=W(17-I) 
      XI(I+16)=X(I) 
      WI(I+16)=W(I) 
    1 END DO 
      DO 2 I=1,NTERMS 
    2 XX(I)=0.5D0*(XI(I)+1.0D0) 
      XX(33)=1.0D0 
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE AURGAM(I,NDRV,X,S,ANS) 
      DIMENSION F1(32),F2(32),F3(32) 
      DIMENSION AF(3),AS(3) 
      DIMENSION CALCO(8,20,32) 
      COMMON/W5051I7/CALCO 
      DATA DELTA/0.8000E-01/ 
      ANS=0. 
      IF(X.GT.0.9985) RETURN 
      N=3 
      IS=S/DELTA+1 
      IF(IS.GE.17) IS=17 
      IS1=IS+1 
      IS2=IS1+1 
      DO 1 L=1,32 
      KL=L+32*NDRV 
      F1(L)=CALCO(I,IS,KL) 
      F2(L)=CALCO(I,IS1,KL) 
      F3(L)=CALCO(I,IS2,KL) 
    1 END DO 
      AF(1)=AFGETFV(X,F1) 
      AF(2)=AFGETFV(X,F2) 
      AF(3)=AFGETFV(X,F3) 
      AS(1)=(IS-1)*DELTA 
      AS(2)=AS(1)+DELTA 
      AS(3)=AS(2)+DELTA 
      CALL AFPOLIN(AS,AF,N,S,AANS,DY) 
      ANS=AANS 
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE AFGINT(I,NDRV,X,S,ANS) 
      DIMENSION F1(32),F2(32),F3(32) 
      DIMENSION AF(3),AS(3) 
      DIMENSION CALCO(8,20,32) 
      COMMON/W5051IA/CALCO 
      DATA DELTA/0.8000E-01/ 
      ANS=0. 
      IF(X.GT.0.9985) RETURN 
      N=3 
      IS=S/DELTA+1 
!     IF(IS.GE.17) IS=17                                                
      IS1=IS+1 
      IS2=IS1+1 
      DO 1 L=1,32 
      KL=L+32*NDRV 
      F1(L)=CALCO(I,IS,KL) 
      F2(L)=CALCO(I,IS1,KL) 
      F3(L)=CALCO(I,IS2,KL) 
    1 END DO 
      AF(1)=AFGETFV(X,F1) 
      AF(2)=AFGETFV(X,F2) 
      AF(3)=AFGETFV(X,F3) 
      AS(1)=(IS-1)*DELTA 
      AS(2)=AS(1)+DELTA 
      AS(3)=AS(2)+DELTA 
      CALL AFPOLIN(AS,AF,N,S,AANS,DY) 
      ANS=AANS 
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE AFGIN2(I,NDRV,X,S,ANS) 
      DIMENSION F1(32),F2(32),F3(32) 
      DIMENSION AF(3),AS(3) 
      DIMENSION CELCO(8,20,32) 
      COMMON/W5051IB/CELCO 
      DATA DELTA/0.8000E-01/ 
      ANS=0. 
      IF(X.GT.0.9985) RETURN 
      N=3 
      IS=S/DELTA+1 
!     IF(IS.GE.17) IS=17                                                
      IS1=IS+1 
      IS2=IS1+1 
      DO 1 L=1,32 
      KL=L+32*NDRV 
      F1(L)=CELCO(I,IS,KL) 
      F2(L)=CELCO(I,IS1,KL) 
      F3(L)=CELCO(I,IS2,KL) 
    1 END DO 
      AF(1)=AFGETFV(X,F1) 
      AF(2)=AFGETFV(X,F2) 
      AF(3)=AFGETFV(X,F3) 
      AS(1)=(IS-1)*DELTA 
      AS(2)=AS(1)+DELTA 
      AS(3)=AS(2)+DELTA 
      CALL AFPOLIN(AS,AF,N,S,AANS,DY) 
      ANS=AANS 
      RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      FUNCTION AFCPLU(X,Q2) 
      CMS=1.5**2 
      BETS=1-4.*CMS*X/(1.-X)/Q2 
      IF(BETS.LE..0) THEN 
         AFCPLU=.0 
         RETURN 
      ENDIF 
      BETA=SQRT(BETS) 
      CPLU=(8.*X*(1.-X)-1.-4.*CMS*X*(1.-X)/Q2)*BETA 
      CAU=X**2+(1.-X)**2+4.*CMS*X*(1.-3.*X)/Q2-8.*CMS**2*X**2/Q2**2 
      CPLU=CPLU+CAU* LOG((1.+BETA)/(1.-BETA)) 
      AFCPLU=3.*(4./9.)*CPLU*X/(3.1415*137.) 
    1 RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       FUNCTION AFGETFV(X,FVL) 
!  NOUVEAU PROGRAMME D'INTERPOLATION UTILISANT UNE ROUTINE DE MATH. RECI
       DIMENSION FVL(32) 
       double precision                                                 &
     &                XI(32),WI(32),XX(33)                              
       COMMON/W5051I9/XI,WI,XX,NTERMS 
       DIMENSION A(4),B(4) 
       N=4 
       EPS=1.E-7 
       XAM=XX(1)-EPS 
       XAP=XX(1)+EPS 
!      IF(X.LT.XAM) PRINT*,' X = ',X                                    
       IF(X.GT.XAM.AND.X.LT.XAP) GOTO 50 
       GOTO 80 
   50  Y=FVL(1) 
       GOTO 77 
   80  IF(X.LT.XX(2)) GOTO 51 
       IF(X.GT.XX(30)) GOTO 61 
       DO 1 I=3,30 
       IF(X.GT.XX(I)) GOTO 1 
       A(1)=XX(I-2) 
       A(2)=XX(I-1) 
       A(3)=XX(I) 
       A(4)=XX(I+1) 
       B(1)=FVL(I-2) 
       B(2)=FVL(I-1) 
       B(3)=FVL(I) 
       B(4)=FVL(I+1) 
       GOTO 70 
    1  CONTINUE 
   61  A(1)=XX(29) 
       A(2)=XX(30) 
       A(3)=XX(31) 
       A(4)=XX(32) 
       B(1)=FVL(29) 
       B(2)=FVL(30) 
       B(3)=FVL(31) 
       B(4)=FVL(32) 
       GOTO 70 
   51  A(1)=XX(1) 
       A(2)=XX(2) 
       A(3)=XX(3) 
       A(4)=XX(4) 
       B(1)=FVL(1) 
       B(2)=FVL(2) 
       B(3)=FVL(3) 
       B(4)=FVL(4) 
! 70   IF(X.GT..2.AND.X.LT..8) THEN                                     
!            CALL AFPOLIN(A,B,N,X,Y,DY)                                 
!      ELSE                                                             
!            CALL AFRATIN(A,B,N,X,Y,DY)                                 
!      ENDIF                                                            
   70  CONTINUE 
             CALL AFPOLIN(A,B,N,X,Y,DY) 
   77  AFGETFV=Y 
       RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE AFPOLIN(XA,YA,N,X,Y,DY) 
      PARAMETER (NMAX=10) 
      DIMENSION XA(NMAX),YA(NMAX),C(NMAX),D(NMAX) 
      Y=0. 
      IF(N.GT.NMAX) RETURN 
      NS=1 
      DIF=ABS(X-XA(1)) 
      DO 11 I=1,N 
        DIFT=ABS(X-XA(I)) 
        IF (DIFT.LT.DIF) THEN 
          NS=I 
          DIF=DIFT 
        ENDIF 
        C(I)=YA(I) 
        D(I)=YA(I) 
   11 END DO 
      Y=YA(NS) 
      NS=NS-1 
      DO 13 M=1,N-1 
        DO 12 I=1,N-M 
          HO=XA(I)-X 
          HP=XA(I+M)-X 
          W=C(I+1)-D(I) 
          DEN=HO-HP 
!         IF(DEN.EQ.0.)PAUSE                                            
          DEN=W/DEN 
          D(I)=HP*DEN 
          C(I)=HO*DEN 
   12   CONTINUE 
        IF (2*NS.LT.N-M)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
   13 END DO 
      RETURN 
      END                                           

! -*- F90 -*-

!--   31/05/2012 by Graeme Watt <Graeme.Watt(at)cern.ch>.
!--   Calculation of PDF uncertainties and PDF correlations.
!--
!--   Use formulae for PDF uncertainties and correlations in:
!--    G. Watt, JHEP 1109 (2011) 069 [arXiv:1106.5788 [hep-ph]].
!--   Code should distinguish between NNPDF (Monte Carlo approach),
!--   Alekhin02/ABKM09/ABM11 (symmetric Hessian approach).  Other
!--   PDF sets are assumed to use the asymmetric Hessian approach.
!--   List of subroutines in this file:
!--    GetMaxNumSets(MaxNumSets)
!--    GetPDFUncType(lMonteCarlo,lSymmetric)
!--    GetPDFUncTypeM(nset,lMonteCarlo,lSymmetric)
!--    GetPDFuncertainty(values,central,errplus,errminus,errsym)
!--    GetPDFuncertaintyM(nset,values,central,errplus,errminus,errsym)
!--    GetPDFcorrelation(valuesA,valuesB,correlation)
!--    GetPDFcorrelationM(nset,valuesA,valuesB,correlation)
!--   Input variables above are nset, values, valuesA, valuesB.
!--   Other arguments above are all output variables.


!-- Get flags indicating if Monte Carlo PDF set (NNPDF) and
!-- if should compute symmetric errors (NNPDF, Alekhin).

subroutine GetPDFUncType(lMonteCarlo,lSymmetric)
  implicit none
  logical lMonteCarlo,lSymmetric
  integer nset
  nset = 1
  call GetPDFUncTypeM(nset,lMonteCarlo,lSymmetric)
  return
end subroutine GetPDFUncType

subroutine GetPDFUncTypeM(nset,lMonteCarlo,lSymmetric)
  implicit none
  include 'parmsetup.inc'
  logical lMonteCarlo,lSymmetric
  character*16 name(nmxset)
  integer nset,nmem(nmxset),ndef(nmxset),mem
  common/NAME/name,nmem,ndef,mem
  if ((name(nset).eq.'NNPDF').or.(name(nset).eq.'NNPDFint').or. &
       (name(nset).eq.'NNPDF20int').or.(name(nset).eq.'NNPDF20intqed')) then ! NNPDF Monte Carlo PDF sets
     lMonteCarlo = .true.
     lSymmetric = .true.
  else if ((name(nset).eq.'A02M').or.(name(nset).eq.'ABKM09').or. &
       (name(nset).eq.'ABM11')) then ! symmetric eigenvector PDF sets
     lMonteCarlo = .false.
     lSymmetric = .true.
  else ! default: assume asymmetric Hessian eigenvector PDF sets
     lMonteCarlo = .false.
     lSymmetric = .false.
  end if
end subroutine GetPDFUncTypeM


!-- Calculate the PDF uncertainty using the appropriate formula for
!-- either the Hessian or Monte Carlo approach given an array
!-- "values(0:nmem)".  In the Monte Carlo approach, the uncertainty is
!-- given by the standard deviation, and the central (average) value
!-- is not necessarily "values(0)" for quantities with a non-linear
!-- dependence on PDFs.  In the Hessian approach, the central value is
!-- the best-fit "values(0)" and the uncertainty is given by either
!-- the symmetric or asymmetric formula using eigenvector PDF sets.

subroutine GetPDFuncertainty(values, &
     &     central,errplus,errminus,errsym)
  implicit none
  integer nset
  double precision values(0:*),central,errplus,errminus,errsym
  nset = 1
  call GetPDFuncertaintyM(nset,values, &
       &     central,errplus,errminus,errsym)
  return
end subroutine GetPDFuncertainty


subroutine GetPDFuncertaintyM(nset,values, &
     &     central,errplus,errminus,errsym)
  implicit none
  integer nset,nmem,imem
  double precision values(0:*),central,errplus,errminus,errsym
  logical lMonteCarlo,lSymmetric

  call numberPDFM(nset,nmem)
  call GetPDFUncTypeM(nset,lMonteCarlo,lSymmetric)

  central = 0.D0 ! central value
  errplus = 0.D0 ! positive uncertainty
  errminus = 0.D0 ! negative uncertainty
  errsym = 0.D0 ! symmetrised uncertainty

  if (lMonteCarlo) then ! calculate average and standard deviation

     do imem = 1, nmem
        central = central + values(imem)
        errsym = errsym + values(imem)**2
     end do
     central = central/nmem ! mean of values
     errsym = errsym/nmem ! mean of squared values
     errsym = nmem/(nmem-1.D0)*(errsym-central**2)
     if (errsym.gt.0.D0) then
        errsym = sqrt(errsym)
     else
        errsym = 0.D0
     end if
     errplus = errsym
     errminus = errsym

  else if (lSymmetric) then ! symmetric Hessian eigenvector PDF sets

     do imem = 1, nmem
        errsym = errsym + (values(imem)-values(0))**2
     end do
     errsym = sqrt(errsym)
     errplus = errsym
     errminus = errsym
     central = values(0)

  else ! default: assume asymmetric Hessian eigenvector PDF sets

     !-- check that nmem is non-zero and even
     if (nmem.ne.0.and.(mod(nmem,2).eq.0)) then
        do imem = 1, nmem/2 ! sum over eigenvectors
           errplus = errplus + max(0.D0, &
                &        values(2*imem-1)-values(0), &
                &        values(2*imem)-values(0))**2
           errminus = errminus + max(0.D0, &
                &        values(0)-values(2*imem-1), &
                &        values(0)-values(2*imem))**2
           errsym = errsym + (values(2*imem-1)-values(2*imem))**2
        end do
        errplus = sqrt(errplus)
        errminus = sqrt(errminus)
        errsym = 0.5D0*sqrt(errsym)
     end if
     central = values(0)

  end if

  return
end subroutine GetPDFuncertaintyM


!-- Calculate the PDF correlation using the appropriate formula for
!-- either the Hessian or Monte Carlo approach given two arrays
!-- "valuesA(0:nmem)" and "valuesB(0:nmem)".  The correlation can vary
!-- between -1 and +1 where values close to {-1,0,+1} mean that the two
!-- quantities A and B are {anticorrelated,uncorrelated,correlated}.

subroutine GetPDFcorrelation(valuesA,valuesB,correlation)
  implicit none
  integer nset
  double precision valuesA(0:*),valuesB(0:*),correlation
  nset = 1
  call GetPDFcorrelationM(nset,valuesA,valuesB,correlation)
  return
end subroutine GetPDFcorrelation

subroutine GetPDFcorrelationM(nset,valuesA,valuesB,correlation)
  implicit none
  integer nset,nmem,imem
  double precision valuesA(0:*),valuesB(0:*),correlation
  double precision A0,Ap,Am,As,B0,Bp,Bm,Bs
  logical lMonteCarlo,lSymmetric

  call numberPDFM(nset,nmem)
  call GetPDFUncTypeM(nset,lMonteCarlo,lSymmetric)

  call GetPDFuncertaintyM(nset,valuesA,A0,Ap,Am,As)
  call GetPDFuncertaintyM(nset,valuesB,B0,Bp,Bm,Bs)

  correlation = 0.D0

  if (lMonteCarlo) then ! calculate average and standard deviation

     do imem = 1, nmem
        correlation = correlation + valuesA(imem)*valuesB(imem)
     end do
     correlation = (correlation/nmem - A0*B0)/(As*Bs)*nmem/(nmem-1.D0)

  else if (lSymmetric) then ! symmetric Hessian eigenvector PDF sets

     do imem = 1, nmem
        correlation = correlation + &
             & (valuesA(imem)-A0)*(valuesB(imem)-B0)
     end do
     correlation = correlation/(As*Bs)

  else ! default: assume asymmetric Hessian eigenvector PDF sets

     !-- check that nmem is non-zero and even
     if (nmem.ne.0.and.(mod(nmem,2).eq.0)) then
        do imem = 1, nmem/2 ! sum over eigenvectors
           correlation = correlation + &
                & (valuesA(2*imem-1)-valuesA(2*imem)) * &
                & (valuesB(2*imem-1)-valuesB(2*imem))
        end do
        correlation = correlation/(4.D0*As*Bs)
     end if

  end if

  return
end subroutine GetPDFcorrelationM

! -*- F90 -*-
!
! A simple Fortran wrapper around LHAPDF for interfacing to C++
! By Stefan Gieseke 2004
! Adapted for LHAPDFv4 by Mike Whalley
! Adapted for LHAPDFv5 by Craig Group/Mike Whalley
! Improved string passing by Andy Buckley

subroutine finitpdfset(name)
  character name*(*)
  ! print *, "@@@", name, "@@@"
  ! print *, len_trim(name)
  ! print *, len(name)
  call InitPDFset(name)
end subroutine finitpdfset

subroutine finitpdfsetm(nset,name)
  character name*(*)
  integer nset
  call InitPDFsetM(nset,name)
end subroutine finitpdfsetm

subroutine finitpdfsetbyname(name)
  character name*(*)
  ! print *, "@@@", name, "@@@"
  ! print *, len_trim(name)
  ! print *, len(name)
  call InitPDFsetByName(name)
end subroutine finitpdfsetbyname

subroutine finitpdfsetbynameM(nset,name)
  character name*(*)
  integer nset
  call InitPDFsetByNameM(nset,name)
end subroutine finitpdfsetbynameM

! TODO: What's the point?!
subroutine finitpdf(mem)
  integer mem
  call InitPDF(mem)
end subroutine finitpdf

! TODO: What's the point?!
subroutine finitpdfM(nset,mem)
  integer nset,mem
  call InitPDFM(nset,mem)
end subroutine finitpdfM

subroutine fhasphoton(haspho)
  implicit none
  integer haspho
  logical has_photon
  haspho = 0
  if (has_photon()) then
     haspho = 1
  end if
end subroutine fhasphoton

! TODO: What's the point?!
subroutine fnumberpdf(set)
  integer set
  call numberPDF(set)
end subroutine fnumberpdf

! TODO: What's the point?!
subroutine fnumberpdfM(nset,set)
  integer nset,set
  call numberPDFM(nset,set)
end subroutine fnumberpdfM

! TODO: What's the point?!
subroutine fevolvepdf(x,Q,f)
  real*8 x,Q
  real*8 f(-6:6)
  call evolvePDF(x,Q,f)
end subroutine fevolvepdf

! TODO: What's the point?!
subroutine fevolvepdfm(nset,x,Q,f)
  real*8 x,Q
  real*8 f(-6:6)
  integer nset
  call evolvePDFM(nset,x,Q,f)
end subroutine fevolvepdfm

! TODO: What's the point?!
subroutine fevolvepdfp(x,Q,P2,ip,f)
  real*8 x,Q,P2
  real*8 f(-6:6)
  integer ip
  call evolvePDFp(x,Q,P2,ip,f)
end subroutine fevolvepdfp

! TODO: What's the point?!
subroutine fevolvepdfpM(nset,x,Q,P2,ip,f)
  real*8 x,Q,P2
  real*8 f(-6:6)
  integer ip,nset
  call evolvePDFpM(nset,x,Q,P2,ip,f)
end subroutine fevolvepdfpM

! TODO: What's the point?!
subroutine fevolvepdfa(x,Q,a,f)
  real*8 x,Q,a
  real*8 f(-6:6)
  call evolvePDFa(x,Q,a,f)
end subroutine fevolvepdfa

! TODO: What's the point?!
subroutine fevolvepdfaM(nset,x,Q,a,f)
  real*8 x,Q,a
  real*8 f(-6:6)
  integer nset
  call evolvePDFaM(nset,x,Q,a,f)
end subroutine fevolvepdfaM

! TODO: What's the point?!
subroutine fevolvepdfphoton(x,Q,f,photon)
  real*8 x,Q,photon
  real*8 f(-6:6)
  call evolvePDFphoton(x,Q,f,photon)
end subroutine fevolvepdfphoton

! TODO: What's the point?!
subroutine fevolvepdfphotonM(nset,x,Q,f,photon)
  real*8 x,Q,photon
  real*8 f(-6:6)
  integer nset
  call evolvePDFphotonM(nset,x,Q,f,photon)
end subroutine fevolvepdfphotonM

! TODO: What's the point?!
subroutine falphaspdfm(nset,Q,ans)
  real*8 ans,Q,alphasPDFM
  integer nset
  ans=alphasPDFM(nset,Q)
end subroutine falphaspdfm

! TODO: What's the point?!
subroutine falphaspdf(Q,ans)
  real*8 ans,Q,alphasPDF
  ans=alphasPDF(Q)
end subroutine falphaspdf

! TODO: What's the point?!
subroutine fgetorderpdf(order)
  integer order
  call getorderpdf(order)
end subroutine fgetorderpdf

! TODO: What's the point?!
subroutine fgetorderpdfm(nset,order)
  integer nset,order
  call getorderpdfM(nset,order)
end subroutine fgetorderpdfm

! TODO: What's the point?!
subroutine fgetorderas(order)
  integer order
  call getorderas(order)
end subroutine fgetorderas

! TODO: What's the point?!
subroutine fgetorderasm(nset,order)
  integer nset,order
  call getorderasm(nset,order)
end subroutine fgetorderasm

! TODO: What's the point?!
subroutine fgetdesc()
  call getdesc()
end subroutine fgetdesc

! TODO: What's the point?!
subroutine fgetdescm(nset)
  integer nset
  call getdescm(nset)
end subroutine fgetdescm

! TODO: What's the point?!
subroutine fgetqmass(nf,mass)
  integer nf
  real*8 mass
  call getqmass(nf,mass)
end subroutine fgetqmass

! TODO: What's the point?!
subroutine fgetqmassm(nset,nf,mass)
  integer nset,nf
  real*8 mass
  call getqmassm(nset,nf,mass)
end subroutine fgetqmassm

! TODO: What's the point?!
subroutine fgetthreshold(nf,Q)
  integer nf
  real*8 Q
  call getthreshold(nf,Q)
end subroutine fgetthreshold

! TODO: What's the point?!
subroutine fgetthresholdm(nset,nf,Q)
  integer nset,nf
  real*8 Q
  call getthresholdm(nset,nf,Q)
end subroutine fgetthresholdm

! TODO: What's the point?!
subroutine fgetnf(nfmax)
  integer nfmax
  call getnf(nfmax)
end subroutine fgetnf

! TODO: What's the point?!
subroutine fgetnfm(nset,nfmax)
  integer nset,nfmax
  call getnfm(nset,nfmax)
end subroutine fgetnfm

! TODO: What's the point?!
subroutine fgetlam4(mem,xlam4)
  integer mem
  real*8 xlam4
  call getlam4(mem,xlam4)
end subroutine fgetlam4

! TODO: What's the point?!
subroutine fgetlam4m(nset,mem,xlam4)
  integer nset,mem
  real*8 xlam4
  call getlam4m(nset,mem,xlam4)
end subroutine fgetlam4m

! TODO: What's the point?!
subroutine fgetlam5(mem,xlam5)
  integer mem
  real*8 xlam5
  call getlam5(mem,xlam5)
end subroutine fgetlam5

! TODO: What's the point?!
subroutine fgetlam5m(nset,mem,xlam5)
  integer nset,mem
  real*8 xlam5
  call getlam5m(nset,mem,xlam5)
end subroutine fgetlam5m

! TODO: What's the point?!
subroutine fgetXmin(mem,xmin)
  integer mem
  real*8 xmin
  call getXmin(mem,xmin)
end subroutine fgetXmin

! TODO: What's the point?!
subroutine fgetXmax(mem,xmax)
  integer mem
  real*8 xmax
  call getXmax(mem,xmax)
end subroutine fgetXmax

! TODO: What's the point?!
subroutine fgetQ2min(mem,q2min)
  integer mem
  real*8 q2min
  call getQ2min(mem,q2min)
end subroutine fgetQ2min

! TODO: What's the point?!
subroutine fgetQ2max(mem,q2max)
  integer mem
  real*8 q2max
  call getQ2max(mem,q2max)
end subroutine fgetQ2max

! TODO: What's the point?!
subroutine fgetXminM(nset,mem,xmin)
  integer nset,mem
  real*8 xmin
  call getXminM(nset,mem,xmin)
end subroutine fgetXminM

! TODO: What's the point?!
subroutine fgetXmaxM(nset,mem,xmax)
  integer nset,mem
  real*8 xmax
  call getXmaxM(nset,mem,xmax)
end subroutine fgetXmaxM

! TODO: What's the point?!
subroutine fgetQ2minM(nset,mem,q2min)
  integer nset,mem
  real*8 q2min
  call getQ2minM(nset,mem,q2min)
end subroutine fgetQ2minM

! TODO: What's the point?!
subroutine fgetQ2maxM(nset,mem,q2max)
  integer nset,mem
  real*8 q2max
  call getQ2maxM(nset,mem,q2max)
end subroutine fgetQ2maxM

! TODO: What's the point?!
subroutine fgetMinMax(mem,xmin,xmax,q2min,q2max)
  integer mem
  real*8 xmin,xmax,q2min,q2max
  call getMinMax(mem,xmin,xmax,q2min,q2max)
end subroutine fgetMinMax

! TODO: What's the point?!
subroutine fgetMinMaxM(nset,mem,xmin,xmax,q2min,q2max)
  integer nset,mem
  real*8 xmin,xmax,q2min,q2max
  call getMinMaxM(nset,mem,xmin,xmax,q2min,q2max)
end subroutine fgetMinMaxM

subroutine fextrapolateon()
  call SetLHAPARM('EXTRAPOLATE')
end subroutine fextrapolateon

subroutine fextrapolateoff()
  call SetLHAPARM('18')
end subroutine fextrapolateoff

subroutine fsilent()
  call SetLHAPARM('SILENT')
end subroutine fsilent

subroutine flowkey()
  call SetLHAPARM('LOWKEY')
end subroutine flowkey

subroutine fdefaultverb()
  call SetLHAPARM('19')
end subroutine fdefaultverb

subroutine fsetpdfpath(path)
  character path*(*)
  call SetPDFPath(path)
end subroutine fsetpdfpath

! -*- F90 -*-


      subroutine MRST98evolve(x,Q,pdf) 
      implicit real*8(a-h,o-z) 
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      integer nset 
      common/NAME/name,nmem,ndef,mmem 
      parameter(nx=49,nq=37,ntenth=23,np=8,members=5) 
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      real*8 pdf(-6:6) 
      real*8 f(0:members,np,nx,nq+1) 
      real*8 qq(nq),xx(nx),xxin(nx),g(np),n0(np) 
      data xxin/1d-5,2d-5,4d-5,6d-5,8d-5,                               &
     &              1d-4,2d-4,4d-4,6d-4,8d-4,                           &
     &              1d-3,2d-3,4d-3,6d-3,8d-3,                           &
     &              1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2,               &
     &           .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0,     &
     &           .3d0,.325d0,.35d0,.375d0,.4d0,.425d0,.45d0,.475d0,     &
     &           .5d0,.525d0,.55d0,.575d0,.6d0,.65d0,.7d0,.75d0,        &
     &           .8d0,.9d0,1d0/                                         
      data qq/1.25d0,1.5d0,2d0,2.5d0,3.2d0,4d0,5d0,6.4d0,8d0,1d1,       &
     &        1.2d1,1.8d1,2.6d1,4d1,6.4d1,1d2,                          &
     &        1.6d2,2.4d2,4d2,6.4d2,1d3,1.8d3,3.2d3,5.6d3,1d4,          &
     &        1.8d4,3.2d4,5.6d4,1d5,1.8d5,3.2d5,5.6d5,1d6,              &
     &        1.8d6,3.2d6,5.6d6,1d7/                                    
      data xmin,xmax,qsqmin,qsqmax/1d-5,1d0,1.25d0,1d7/ 
      data n0/3,4,5,9,9,9,9,9/ 
      save 
!                                                                       
      xsave=x 
      qsq = q*q 
      q2save=qsq 
!                                                                       
      if(x.lt.xmin) x=xmin 
      if(x.gt.xmax) x=xmax 
      if(qsq.lt.qsqmin)        qsq=qsqmin 
      if(qsq.gt.qsqmax)        qsq=qsqmax 
!                                                                       
      xxx=x 
      if(x.lt.xx(ntenth)) xxx=dlog10(x/xx(ntenth))+xx(ntenth) 
      n=0 
   70 n=n+1 
      if(xxx.gt.xx(n+1)) goto 70 
      a=(xxx-xx(n))/(xx(n+1)-xx(n)) 
      m=0 
   80 m=m+1 
      if(qsq.gt.qq(m+1)) goto 80 
      b=(qsq-qq(m))/(qq(m+1)-qq(m)) 
      do 60 i=1,np 
      g(i)= (1d0-a)*(1d0-b)*f(imem,i,n,m)+(1d0-a)*b*f(imem,i,n,m+1)     &
     &          +       a*(1d0-b)*f(imem,i,n+1,m)+a*b*f(imem,i,n+1,m+1) 
      if(n.ge.ntenth) goto 65 
      if(i.eq.5.or.i.eq.7) goto 65 
          fac=(1d0-b)*f(imem,i,ntenth,m)+b*f(imem,i,ntenth,m+1) 
           g(i)=fac*10d0**(g(i)-fac) 
   65 continue 
      g(i)=g(i)*(1d0-x)**n0(i) 
   60 continue 
      upv=g(1) 
      dnv=g(2) 
      usea=g(4) 
      dsea=g(8) 
      str=g(6) 
      chm=g(5) 
      glu=g(3) 
      bot=g(7) 
!                                                                       
      pdf(0)  = glu 
      pdf(1)  = dnv+dsea 
      pdf(-1) = dsea 
      pdf(2)  = upv+usea 
      pdf(-2) = usea 
      pdf(3)  = str 
      pdf(-3) = str 
      pdf(4)  = chm 
      pdf(-4) = chm 
      pdf(5)  = bot 
      pdf(-5) = bot 
      pdf(6)  = 0.0d0 
      pdf(-6) = 0.0d0 
                                                                        
      x=xsave 
      qsq=q2save 
      return 
!                                                                       
      entry MRST98getgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=1,nx
          gridx(jx)=xx(jx)
      enddo
      do jq=1,nq
          gridq(jq)=qq(jq)
      enddo
      ngridx=nx
      ngridq=nq        
      return

      entry MRST98read(nset) 
      read(1,*)nmem(nset),ndef(nset) 
! - first resotre the xx array                                          
      do j=1,nx 
        xx(j)=xxin(j) 
      enddo 
! - next read in the data points                                        
      do nm = 0,nmem(nset) 
        do 20 n=1,nx-1 
        do 20 m=1,nq 
        read(1,50)f(nm,1,n,m),f(nm,2,n,m),f(nm,3,n,m),f(nm,4,n,m),      &
     &                  f(nm,5,n,m),f(nm,7,n,m),f(nm,6,n,m),f(nm,8,n,m) 
! notation: 1=uval 2=val 3=glue 4=usea 5=chm 6=str 7=btm 8=dsea         
        do 25 i=1,np 
   25        f(nm,i,n,m)=f(nm,i,n,m)/(1d0-xx(n))**n0(i) 
   20   continue 
!        write(*,*)'PDF set ',nm,' first element ',f(nm,1,1,1)          
        do 31 j=1,ntenth-1 
!        xx(j)=dlog10(xx(j)/xx(ntenth))+xx(ntenth)                      
        do 31 i=1,8 
        if(i.eq.5.or.i.eq.7) goto 31 
        do 30 k=1,nq 
   30   f(nm,i,j,k)=dlog10(f(nm,i,j,k)/f(nm,i,ntenth,k))                &
     &              +f(nm,i,ntenth,k)                                   
   31   continue 
   50   format(8f10.5) 
        do 40 i=1,np 
        do 40 m=1,nq 
   40 f(nm,i,nx,m)=0d0 
       enddo 
      do 32 j=1,ntenth-1 
        xx(j)=dlog10(xx(j)/xx(ntenth))+xx(ntenth) 
   32 continue 
      return 
!                                                                       
      entry MRST98alfa(alfas,Qalfa) 
        call alphamrs(5,alfas,Qalfa) 
      return 
!                                                                       
      entry MRST98init(Eorder,Q2fit) 
      return 
!                                                                       
      entry MRST98pdf(mem) 
!      if(mem.eq.0) mem=ndef                                            
      imem = mem 
!      print *,imem                                                     
                                                                        
      return 
!                                                                       
      END                                           

! -*- F90 -*-


      subroutine GSGevolvep0(xin,qin,p2in,ip2in,pdf) 
      include 'parmsetup.inc' 
      real*8 xin,qin,q2in,p2in,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      real*8 SIG,QNS,GL 
      real*8 holdit 
      common/gsgdat/SIG(78,11,3),QNS(78,11,3),GL(78,11,3) 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
      save 
                                                                        
      call getnset(iset) 
      call getnmem(iset,iimem) 
! -- this is LO 2 --> 3 0/1 --> 2                                       
      if(iimem.eq.2) iimem = 3 
      if(iimem.eq.0) iimem = 2 
      if(iimem.eq.1) iimem = 2 
                                                                        
      call SFGSHL(iimem,xin,qin,upv,dnv,usea,dsea,str,chm,bot,glu) 
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSGevolvep1(xin,qin,p2in,ip2in,pdf) 
                                                                        
!--- this is HO --- iimem=1                                             
      iimem = 1 
       call SFGSHL(iimem,xin,qin,upv,dnv,usea,dsea,str,chm,bot,glu) 
                                                                        
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSGread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
      do j=1,3 
      do k=1,78 
      do m=1,11 
         read(1,*)SIG(k,m,j),QNS(k,m,j),GL(k,m,j) 
      enddo 
      enddo 
      enddo 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSGalfa(alfas,qalfa) 
        call getnset(iset) 
        call getnmem(iset,imem) 
        call GetOrderAsM(iset,iord) 
        call Getlam4M(iset,imem,qcdl4) 
        call Getlam5M(iset,imem,qcdl5) 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
!        call aspdflib(alfas,Qalfa,iord,qcdl5)                          
                                                                        
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSGinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GSGpdf(mem) 
      call getnset(iset) 
      call setnmem(iset,mem) 
!      imem = mem                                                       
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!      SUBROUTINE SFGSHO(X,Q,U,D,US,DS,S,C,B,G)                         
      SUBROUTINE SFGSHL(iset,X,Q,U,D,US,DS,S,C,B,G) 
!                                                                       
!****************************************************************       
! Subroutine returns the parton distributions in the photon in  *       
! higher  order. u,d etc. gives the actual distributions and    *       
! not x times the distributions; Q2 means Q 2. The distributions*       
! are valid for 5.0e -4< x < 1.0 and 5.3 GeV 2 < Q 2 < 1.0e 8.  *       
! if higher Q 2 or lower x is required, these may be obtained   *       
! from the authors on request.                                  *       
! Lionel Gordon July 1991 : Gordon@uk.ac.man.ph.v2              *       
!****************************************************************       
!                                                                       
      implicit real*8 (a-h,o-z) 
      PARAMETER(NP=78,NQ=11,NARG=2) 
      double precision                                                  &
     &       DBFINT,                                                    &
     &       Y(NP),                                                     &
     &       XT(NARG),A(NP+NQ),QT(NQ)                                   
!     +       SIG(NP,NQ),QNS(NP,NQ),GL(NP,NQ),Y(NP),                    
      common/gsgdat/SIG(78,11,3),QNS(78,11,3),GL(78,11,3) 
      DIMENSION NA(NARG) 
      EXTERNAL GSXCOR 
!      SAVE SIG,QNS,GL,Y,ICALL                                          
      SAVE Y,ICALL 
      DATA QT /5.3D0,20.0D0,50.0D0,1.0D2,5.0D2,1.0D3,1.0D4,1.0D5,       &
     & 1.0D6,1.0D7,1.0D8/                                               
      DATA ZEROD/0.D0/ 
      DATA ICALL/0/ 
!*****************************************************************      
       U = ZEROD 
       D = ZEROD 
       S = ZEROD 
       C = ZEROD 
       B = ZEROD 
       G = ZEROD 
!if x is out of range                                                   
      if(iset.eq.1) then 
        IF((X.LT.5.0D-4).OR.(X.GT.0.95D0)) GOTO 90 
      else 
        IF((X.LT.5.0D-4).OR.(X.GT.0.99D0)) GOTO 90 
      endif 
                                                                        
!******************************************************************     
       IF (ICALL.NE.1) THEN 
! get the x coordinates                                                 
          CALL GSXCOR(Y,NP) 
          ICALL=1 
        END IF 
!                                                                       
      DO 30 IX=1,NP 
        A(IX)=Y(IX) 
   30 END DO 
      DO 40 IQ=1,NQ 
        A(NP+IQ)=QT(IQ) 
   40 END DO 
!                                                                       
      Q2 = Q*Q 
      NA(1)=NP 
      NA(2)=NQ 
       XT(1)=X 
       XT(2)=Q2 
      XSIG=DBFINT(2,XT,NA,A,SIG(1,1,iset)) 
      XQNS=DBFINT(2,XT,NA,A,QNS(1,1,iset)) 
        G =DBFINT(2,XT,NA,A,GL(1,1,iset)) 
!                                                                       
      IF (Q2.LT.50.0D0) THEN 
! Use three flavour evolution.                                          
       U=(XSIG+9.0D0*XQNS)/6.0D0 
       D=(XSIG-4.5D0*XQNS)/6.0D0 
       S=D 
       C=ZEROD 
       B=ZEROD 
!                                                                       
      ELSE IF((Q2.GT.50.0D0).AND.(Q2.LT.250.0D0)) THEN 
! Use four flavour evolution                                            
      U=(XSIG+6.0D0*XQNS)/8.0D0 
      D=(XSIG-6.0D0*XQNS)/8.0D0 
      S=D 
      C=U 
      B=ZEROD 
      ELSE 
! Use five flavour evolution                                            
      U=(XSIG+7.5D0*XQNS)/10.0D0 
      D=(XSIG-5.0D0*XQNS)/10.0D0 
      S=D 
      C=U 
      B=D 
      ENDIF 
      U=X*U 
      US=U 
      D=X*D 
      DS=D 
      S=X*S 
      C=X*C 
      B=X*B 
      G=X*G 
   90 RETURN 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      SUBROUTINE GSXCOR(Y,NP) 
!                                                                       
      implicit real*8 (a-h,o-z) 
      double precision                                                  &
     &       Y(NP)                                                      
      N=1 
      DO 10 IX=1,20,2 
         Y(N)=    (IX)/2000.0D0 
      N=N+1 
   10 END DO 
      DO 20 IX=30,200,10 
         Y(N)=    (IX)/2000.0D0 
           N=N+1 
   20 END DO 
      DO 30 IX=240,1600,40 
         Y(N)=    (IX)/2000.0D0 
      N=N+1 
   30 END DO 
      DO 40 IX=1625,1980,25 
         Y(N)=    (IX)/2000.0D0 
      N=N+1 
   40 END DO 
      RETURN 
      END                                           

      subroutine ABKM09evolve(xb,Q,fset)
      implicit none
      include 'parmsetup.inc'
      integer npdf,npar,kschem,i,k,n,m,kx,nxbb
      integer nxb,nq,np,nvar,pdfmem,imem,nvar2
      parameter(nxb=99,nq=20,np=9,nvar=0,nvar2=25)
      character*16 name(nmxset)
      character*80 line 
      character*512 setpath 
      integer nmem(nmxset),ndef(nmxset),mem
      common/NAME/name,nmem,ndef,mem
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
!      integer iset,iimem
!      common/SET/iset,iimem
      integer nset,iset
      real*8 f(0:nvar,nxb,nq+1,0:np),xx(nxb)
      real*8 fsp(nxb),bs(nxb),cs(nxb),ds(nxb)
      real*8 bsp(0:nvar,nxb,nq+1,0:np),csp(0:nvar,nxb,nq+1,0:np) &
     &      ,dsp(0:nvar,nxb,nq+1,0:np)
      real*8 x1,xd,del,dels,delx,delx1,xlog1
      real*8 pdfs(0:np),fset(-6:6),alfas
      real*8 x,Q,xb,q2,xmin,xmax,qsq,qsqmin,qsqmax,b,ss
      real*8 aa,f0,fp,fm
      real*8 pdfs0(0:np),pdfsp(0:np),pdfsm(0:np),q2plus,q2minus,q2zero
      real*8 q2mat,delq2,f2p,f2pp,aq2,bq2,cq2
      integer ios
      data xmin,xmax,qsqmin,qsqmax/1d-7,1d0,0.8d0,2d8/
      data q2mat /1d0/

      save f,npdf,npar,pdfmem,dels,delx,x1,delx1,xlog1,nxbb,xx &
     &,fsp,bsp,csp,dsp
!      save 
      
      q2=Q*Q
      if(q2.gt.qsqmax) print 99,q2
      if(xb.lt.xmin.or.xb.gt.xmax)    print 98,xb

  99  format('  WARNING:  Q^2 VALUE IS OUT OF RANGE   ',g12.3)
  98  format('  WARNING:   X  VALUE IS OUT OF RANGE   ',g12.3)

      x=max(xb,xmin)
      x=min(x,xmax)
      qsq=min(q2,qsqmax)

      if (x.gt.x1) then
        xd=(1d0-x1)**2-(1d0-x)**2
        n=int(xd/delx1)+nxbb
      else
        xd=dlog(x)-xlog1
        n=nxbb+int(xd/DELX)-1
      end if
      aa=x-xx(n)

      !k=pdfmem
      k=0

      if (qsq.ge.q2mat) then 
        ss=dlog(dlog(qsq/0.04d0))-dlog(dlog(qsqmin/0.04d0))
        m=int(ss/dels)+1
        b=ss/dels-dble(m)+1.d0
 
        do i=1,npdf
          f0=f(k,n,m,i) + aa*bsp(k,n,m,i) + aa**2*csp(k,n,m,i) & 
     &                  + aa**3*dsp(k,n,m,i)
          fp=f(k,n,m+1,i) + aa*bsp(k,n,m+1,i) + aa**2*csp(k,n,m+1,i) &
     &                    + aa**3*dsp(k,n,m+1,i)
          if (m.ge.2) then 
            fm=f(k,n,m-1,i) + aa*bsp(k,n,m-1,i) + aa**2*csp(k,n,m-1,i) &
     &                      +aa**3*dsp(k,n,m-1,i)
            pdfs(i)=fm*b*(b-1d0)/2d0 + f0*(1d0-b**2) + fp*b*(b+1d0)/2d0
          else 
            pdfs(i)= f0*(1d0-b) + fp*b
           end if
        end do
      else 
        delq2=q2mat*0.1

        do i=1,npdf

          q2plus=q2mat+delq2
          ss=dlog(dlog(q2plus/0.04d0))-dlog(dlog(qsqmin/0.04d0))
          m=int(ss/dels)+1
          b=ss/dels-dble(m)+1.d0

          f0=f(k,n,m,i) + aa*bsp(k,n,m,i) + aa**2*csp(k,n,m,i)  &
     &                  + aa**3*dsp(k,n,m,i)
          fp=f(k,n,m+1,i) + aa*bsp(k,n,m+1,i) + aa**2*csp(k,n,m+1,i) &
     &                    + aa**3*dsp(k,n,m+1,i)
          if (m.ge.2) then 
            fm=f(k,n,m-1,i) + aa*bsp(k,n,m-1,i) + aa**2*csp(k,n,m-1,i) &
     &                      +aa**3*dsp(k,n,m-1,i)
            pdfsp(i)=fm*b*(b-1d0)/2d0 + f0*(1d0-b**2) + fp*b*(b+1d0)/2d0
          else 
            pdfsp(i)= f0*(1d0-b) + fp*b
           end if

          q2minus=q2mat-delq2
          ss=dlog(dlog(q2minus/0.04d0))-dlog(dlog(qsqmin/0.04d0))
          m=int(ss/dels)+1
          b=ss/dels-dble(m)+1.d0

          f0=f(k,n,m,i) + aa*bsp(k,n,m,i) + aa**2*csp(k,n,m,i) & 
     &                  + aa**3*dsp(k,n,m,i)
          fp=f(k,n,m+1,i) + aa*bsp(k,n,m+1,i) + aa**2*csp(k,n,m+1,i) &
     &                    + aa**3*dsp(k,n,m+1,i)
          if (m.ge.2) then 
            fm=f(k,n,m-1,i) + aa*bsp(k,n,m-1,i) + aa**2*csp(k,n,m-1,i) &
     &                      +aa**3*dsp(k,n,m-1,i)
            pdfsm(i)=fm*b*(b-1d0)/2d0 + f0*(1d0-b**2) + fp*b*(b+1d0)/2d0
          else 
            pdfsm(i)= f0*(1d0-b) + fp*b
           end if

          q2zero=q2mat
          ss=dlog(dlog(q2zero/0.04d0))-dlog(dlog(qsqmin/0.04d0))
          m=int(ss/dels)+1
          b=ss/dels-dble(m)+1.d0

          f0=f(k,n,m,i) + aa*bsp(k,n,m,i) + aa**2*csp(k,n,m,i) & 
     &                  + aa**3*dsp(k,n,m,i)
          fp=f(k,n,m+1,i) + aa*bsp(k,n,m+1,i) + aa**2*csp(k,n,m+1,i) &
     &                    + aa**3*dsp(k,n,m+1,i)
          if (m.ge.2) then 
            fm=f(k,n,m-1,i) + aa*bsp(k,n,m-1,i) + aa**2*csp(k,n,m-1,i) &
     &                      +aa**3*dsp(k,n,m-1,i)
            pdfs0(i)=fm*b*(b-1d0)/2d0 + f0*(1d0-b**2) + fp*b*(b+1d0)/2d0
          else 
            pdfs0(i)= f0*(1d0-b) + fp*b
           end if

          f2p=(pdfsp(i)-pdfsm(i))/2./delq2
          f2pp=(pdfsp(i)+pdfsm(i)-2*pdfs0(i))/delq2**2
          cq2=(f2pp*q2mat**2-2*f2p*q2mat+2*pdfs0(i))/2/q2mat**3
          bq2=f2pp/2.-3*cq2*q2mat
          aq2=f2p-2*bq2*q2mat-3*cq2*q2mat**2
          pdfs(i)=aq2*q2 + bq2*q2**2 + cq2*q2**3
!          print *,i,xb,q2,aq2,bq2,cq2
        end do
      end if

      fset(-6)=pdfs(9)
      fset(-5)=pdfs(8)
      fset(-4)=pdfs(7)
      fset(-3)=pdfs(5)
!--reversed mrs 7/7/04 due
      fset(-1)=pdfs(6)
      fset(-2)=pdfs(4)
      fset(0)=pdfs(3)
!--reversed mrs 7/7/04 due
      fset(2)=pdfs(1)+pdfs(4)
      fset(1)=pdfs(2)+pdfs(6)
      fset(3)=pdfs(5)
      fset(4)=pdfs(7)
      fset(5)=pdfs(8)
      fset(6)=pdfs(9)
      return
!
      entry ABKM09alfa(alfas,Q)
      q2=Q*Q
      if(q2.gt.qsqmax) print 99,q2
      qsq=max(q2,q2mat)
      qsq=min(qsq,qsqmax)

      ss=log(log(qsq/0.04))-log(log(qsqmin/0.04))
      m=int(ss/dels)+1
      b=ss/dels-m+1

      k=pdfmem

      if (m.ge.2) then 
        fm=f(k,1,m-1,0)
        fp=f(k,1,m+1,0)
        f0=f(k,1,m,0)
        alfas=fm*b*(b-1d0)/2d0 + f0*(1d0-b**2) + fp*b*(b+1d0)/2d0
      else 
        alfas= f0*(1d0-b) + fp*b
      end if

      return
!
      entry ABKM09getgrid(nset,ngridx,ngridq,gridx,gridq)
     
      ngridx=nxb
      do jx=1,nxb
          gridx(jx)=xx(jx)
      enddo

      ngridq=nq
      do jq=1,ngridq
          gridq(jq)= 0.04*exp(exp( &
     & log(log(qsqmin/0.04))+(float(jq-1)/19)*( log(log(qsqmax/0.04))-log(log(qsqmin/0.04)) ) & 
     & ))
      enddo 
       
      return
      entry ABKM09read(nset)
! following fix because members are 0-nvar
!      nmem = nvar + 1

      nmem(nset) = nvar
      ndef(nset) = 0

! - dummy read in to get to End: (stream 1 is still open)               
      read(1,fmt="(i2,i2)") npdf,npar
!      print *,'number of members',npdf,npar
      if (npar.eq.0) npar=nvar2

      do k=0,npar
         do n=1,nxb-1
            do m=1,nq
               read(1,*) (f(k,n,m,i),i=0,npdf)
!	       print 100,k,n,m,i,(f(k,n,m,i),i=0,npdf)
            enddo
         enddo
      enddo
  100 format (4i4,13f11.5)

      return
!
      entry ABKM09init

      dels=(dlog(dlog(qsqmax/0.04d0))- &
     &      dlog(dlog(qsqmin/0.04d0)))/dble(nq-1)


      return
!
      entry ABKM09pdf(imem)
      pdfmem=imem
      if ((pdfmem.lt.0).or.(pdfmem.gt.npar)) then
         write(*,*) 'ABKM09 PDF set:'
         write(*,*) 'PDF member out of range:'
         write(*,*) 'member = ',pdfmem,'    member range = (0,',npar,')'
         stop
      endif

      call getnset(iset)
      nmem(iset) = npar 
      ndef(iset) = 0 
      
! have to reopen stream 1                                               
      call getsetpath(setpath) 
      open(1,file=setpath(1:len_trim(setpath)),action='READ') 
      line = '' 
      do while (line(2:11).ne.'Evolution:') 
         read(1,'(a)') line 
      enddo 

      read(1,'(a)'),line 
      read(1,'(a)'),line 

      read(1,fmt="(i2,i2)") npdf,npar
      if (npar.eq.0) npar=nvar2

      do k=0,imem-1
         do n=1,nxb-1
            do m=1,nq
               read(1,*) (f(0,n,m,i),i=0,npdf)
            enddo
         enddo
      enddo
      
      do n=1,nxb-1 
         do m=1,nq 
            read(1,*) (f(0,n,m,i),i=0,npdf) 
         enddo 
      enddo 

      nxbb=nxb/2
      x1=0.3d0
      xlog1=dlog(x1)
      delx=(dlog(x1)-dlog(xmin))/dble(nxbb-1)
      DELX1=(1.d0-x1)**2/dble(nxbb+1)

!...X GRID
      do kx=1,nxbb
        xx(kx)=dexp(dlog(xmin)+delx*dble(kx-1))
      end do
      do kx=nxbb+1,nxb-1
        xx(kx)=1.d0-dsqrt(dabs((1.d0-x1)**2-delx1*dble(kx-nxbb)))
      end do
      xx(nxb)=1d0

      do i=0,npdf
        do m=1,nq
          if (i.ne.0) then 
            f(0,nxb,m,i)=0d0
          else 
            f(0,nxb,m,i)=f(0,nxb-1,m,i)
          end if
          do n=1,nxb-1
          end do
          do n=1,nxb
            fsp(n)=f(0,n,m,i)
          end do
          call ABKM09spline (nxb,xx,fsp,bs,cs,ds)
          do n=1,nxb
            bsp(0,n,m,i)=bs(n)
            csp(0,n,m,i)=cs(n)
            dsp(0,n,m,i)=ds(n)
          end do
        end do
      end do
      close(1)
      return
      end

! ---------------------------------------------------------------------
      SUBROUTINE ABKM09SPLINE(N,X,Y,B,C,D)
! ---------------------------------------------------------------------
! CALCULATE THE COEFFICIENTS B,C,D IN A CUBIC SPLINE INTERPOLATION.
! INTERPOLATION SUBROUTINES ARE TAKEN FROM
! G.E. FORSYTHE, M.A. MALCOLM AND C.B. MOLER,
! COMPUTER METHODS FOR MATHEMATICAL COMPUTATIONS (PRENTICE-HALL, 1977).
!
      IMPLICIT REAL*8(A-H,O-Z)

      DIMENSION X(N), Y(N), B(N), C(N), D(N)
!
      NM1=N-1
      IF(N.LT.2) RETURN
      IF(N.LT.3) GO TO 250
      D(1)=X(2)-X(1)
      C(2)=(Y(2)-Y(1))/D(1)
      DO 210 K=2,NM1
         D(K)=X(K+1)-X(K)
         B(K)=2.0D0*(D(K-1)+D(K))
         C(K+1)=(Y(K+1)-Y(K))/D(K)
         C(K)=C(K+1)-C(K)
  210 CONTINUE
      B(1)=-D(1)
      B(N)=-D(N-1)
      C(1)=0.0D0
      C(N)=0.0D0
      IF(N.EQ.3) GO TO 215
      C(1)=C(3)/(X(4)-X(2))-C(2)/(X(3)-X(1))
      C(N)=C(N-1)/(X(N)-X(N-2))-C(N-2)/(X(N-1)-X(N-3))
      C(1)=C(1)*D(1)**2.0D0/(X(4)-X(1))
      C(N)=-C(N)*D(N-1)**2.0D0/(X(N)-X(N-3))
 215  CONTINUE
      DO 220 K=2,N
         T=D(K-1)/B(K-1)
         B(K)=B(K)-T*D(K-1)
         C(K)=C(K)-T*C(K-1)
 220  CONTINUE
      C(N)=C(N)/B(N)
      DO 230 IB=1,NM1
         K=N-IB
         C(K)=(C(K)-D(K)*C(K+1))/B(K)
 230  CONTINUE
      B(N)=(Y(N)-Y(NM1))/D(NM1) &
     &     +D(NM1)*(C(NM1)+2.0D0*C(N))
      DO 240 K=1,NM1
         B(K)=(Y(K+1)-Y(K))/D(K) &
     &        -D(K)*(C(K+1)+2.0D0*C(K))
         D(K)=(C(K+1)-C(K))/D(K)
         C(K)=3.0D0*C(K)
 240  CONTINUE
      C(N)=3.0D0*C(N)
      D(N)=D(N-1)
      RETURN
 250  CONTINUE
      B(1)=(Y(2)-Y(1))/(X(2)-X(1))
      C(1)=0.0D0
      D(1)=0.0D0
      B(2)=B(1)
      C(2)=0.0D0
      D(2)=0.0D0
      RETURN
      END

! -*- F90 -*-


      subroutine DOGevolvep0(xin,qin,p2in,ip2in,pdf) 
      include 'parmsetup.inc' 
      real*8 xin,qin,q2in,p2in,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer ns 
                                                                        
      save 
                                                                        
      call DOPHO1(xin,qin,upv,dnv,usea,dsea,str,chm,bot,glu) 
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry DOGevolvep1(xin,qin,p2in,ip2in,pdf) 
                                                                        
      call DOPHO2(xin,qin,upv,dnv,usea,dsea,str,chm,bot,glu) 
                                                                        
      pdf(-6)= 0.0d0 
      pdf(6)= 0.0d0 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv 
      pdf(-1)= dsea 
      pdf(1 )= dnv 
      pdf(0 )= glu 
                                                                        
      return 
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry DOGread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry DOGalfa(alfas,qalfa) 
        call getnset(iset) 
        call GetOrderAsM(iset,iord) 
        call Getlam4M(iset,imem,qcdl4) 
        call Getlam5M(iset,imem,qcdl5) 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry DOGinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry DOGpdf(mem) 
      imem = mem 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
       SUBROUTINE DOPHO1(DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL) 
!********************************************************************   
!*                                                                  *   
!*    Parametrization of parton distribution functions              *   
!*    in the photon (LO analysis) - asymptotic solution of AP eq.!  *   
!*                                                                  *   
!* authors:  D.Duke and H.Owens (DO)                                *   
!*           /Phys.Rev. D26 (1982) 1600/                            *   
!*                                                                  *   
!* Prepared by:                                                     *   
!*             Krzysztof Charchula, DESY                            *   
!*             bitnet: F1PCHA@DHHDESY3                              *   
!*             decnet: 13313::CHARCHULA                             *   
!*                                                                  *   
!* Modified by:                                                     *   
!*             H. Plothow-Besch/CERN-PPE                            *   
!*                                                                  *   
!********************************************************************   
!                                                                       
      implicit real*8 (a-h,o-z) 
       double precision                                                 &
     &        CQ(5),                                                    &
     &        DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL                     
      PARAMETER (ALPEM=7.29927D-3, PI=3.141592D0) 
      PARAMETER (ALAM=0.2D0) 
      DATA CQ/0.33333D0,0.66666D0,0.33333D0,0.66666D0,0.33333D0/ 
!                                                                       
       Q2 = DQ*DQ 
       ALAM2=ALAM**2 
       FQ=ALPEM/(2.*PI)*LOG(Q2/ALAM2) 
!                                                                       
!...gluons                                                              
       POMG=0.194*(1.-DX)**1.03/(DX**0.97) 
       DGL=POMG*FQ 
!                                                                       
!...quarks                                                              
        POM1=(1.81-1.67*DX+2.16*DX**2) 
        POM2=DX**0.7/(1.-0.4*LOG(1.-DX)) 
        POM3=38.D-4*(1.-DX)**1.82/(DX**1.18) 
          DDB=(CQ(1)**2*POM1*POM2+POM3)*FQ 
          DDV=DDB 
          DUB=(CQ(2)**2*POM1*POM2+POM3)*FQ 
          DUV=DUB 
          DSB=(CQ(3)**2*POM1*POM2+POM3)*FQ 
          DCB=(CQ(4)**2*POM1*POM2+POM3)*FQ 
          DBB=(CQ(5)**2*POM1*POM2+POM3)*FQ 
       RETURN 
      END                                           
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       SUBROUTINE DOPHO2(DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL) 
!********************************************************************   
!*                                                                  *   
!*    Parametrization of parton distribution functions              *   
!*    in the photon (LO analysis) - asymptotic solution of AP eq.!  *   
!*                                                                  *   
!* authors:  D.Duke and H.Owens (DO)                                *   
!*           /Phys.Rev. D26 (1982) 1600/                            *   
!*                                                                  *   
!* Prepared by:                                                     *   
!*             Krzysztof Charchula, DESY                            *   
!*             bitnet: F1PCHA@DHHDESY3                              *   
!*             decnet: 13313::CHARCHULA                             *   
!*                                                                  *   
!* Modified by:                                                     *   
!*             H. Plothow-Besch/CERN-PPE                            *   
!*                                                                  *   
!********************************************************************   
!                                                                       
      implicit real*8 (a-h,o-z) 
      double precision                                                  &
     &        CQ(5),                                                    &
     &        DX,DQ,DUV,DDV,DUB,DDB,DSB,DCB,DBB,DGL                     
      PARAMETER (ALPEM=7.29927D-3,PI=3.141592D0) 
      PARAMETER (ALAM=0.4D0) 
      DATA CQ/0.33333D0,0.66666D0,0.33333D0,0.66666D0,0.33333D0/ 
!                                                                       
       Q2 = DQ*DQ 
       ALAM2=ALAM**2 
       FQ=ALPEM/(2.*PI)*LOG(Q2/ALAM2) 
!                                                                       
!...gluons                                                              
       POMG=0.194*(1.-DX)**1.03/(DX**0.97) 
       DGL=POMG*FQ 
!                                                                       
!...quarks                                                              
        POM1=(1.81-1.67*DX+2.16*DX**2) 
        POM2=DX**0.7/(1.-0.4*LOG(1.-DX)) 
        POM3=38.D-4*(1.-DX)**1.82/(DX**1.18) 
          DDB=(CQ(1)**2*POM1*POM2+POM3)*FQ 
          DDV=DDB 
          DUB=(CQ(2)**2*POM1*POM2+POM3)*FQ 
          DUV=DUB 
          DSB=(CQ(3)**2*POM1*POM2+POM3)*FQ 
          DCB=(CQ(4)**2*POM1*POM2+POM3)*FQ 
          DBB=(CQ(5)**2*POM1*POM2+POM3)*FQ 
       RETURN 
      END                                           

! -*- F90 -*-


      subroutine evolvePDF(x,Q,f) 
      implicit none 
      include 'parmsetup.inc'
      real*8 gridx(nmxgridx),gridq(nmxgridq)
      integer nxgrid,nqgrid
      integer nset,imem,Eorder,IP2 
      real*8 x,Q,P2,Q2fit,f(-6:6),alfas,a,photon,gluino 
      nset = 1 
      call evolvePDFM(nset,x,Q,f) 
      return 
!                                                                       
      entry evolvePDFp(x,Q,P2,IP2,f) 
      nset = 1 
      call evolvePDFpM(nset,x,Q,P2,IP2,f) 
      return 
!                                                                       
      entry evolvePDFa(x,Q,a,f) 
      nset = 1 
      call evolvePDFaM(nset,x,Q,a,f) 
      return 
!                                                                       
      entry evolvePDFphoton(x,Q,f,photon) 
      nset = 1 
      call evolvePDFphotonM(nset,x,Q,f,photon) 
      return 
!                                                                       
      entry evolvePDFgluino(x,Q,f,gluino) 
      nset = 1 
      call evolvePDFgluinoM(nset,x,Q,f,gluino) 
      return 
!                                                                       
      entry initPDF(imem) 
      nset = 1 
      call initPDFM(nset,imem) 
      return

      entry getgrid(nxgrid,nqgrid,gridx,gridq)
      nset = 1
      call getgridM(nset,nxgrid,nqgrid,gridx,gridq)

      return 
      END                                           
!                                                                       
      subroutine evolvePDFaM(nset,xin,Qin,a,f) 
      implicit none 
      real*8 x,Q,a,f(-6:6) 
      real*8 ruv,rdv,ru,rd,rs,rc,rb,rt,rg 
      integer nset,iimem,j 
      real*8 xin,qin,q2in 
      character*20 lparm 
      real*8 xmin,xmax,q2min,q2max 
      integer iorder,ipset,ia
     
                                                                        
      call getlhaparm(18,lparm) 
      if(lparm.ne.'EXTRAPOLATE') then 
        call getnmem(nset,iimem) 
        call getminmaxm(nset,iimem,xmin,xmax,q2min,q2max) 
        x = max(xmin,min(xmax,xin)) 
        q2in = qin**2 
        q = sqrt(max(0d0,q2min,min(q2max,q2in))) 
      else 
        x = xin 
        q = qin 
      endif 
                                                                        
      call getlhaparm(15,lparm) 
      if(lparm.eq.'EPS08') then 
        call eps08(x,q,a,ruv,rdv,ru,rd,rs,rc,rb,rt,rg)
      else if(lparm(1:5).eq.'EPS09') then 
        if(lparm.eq.'EPS09LO') then 
          iorder=1
          ipset=1 
        else if(lparm.eq.'EPS09NLO') then 
          iorder=2
          ipset=1 
        else if(lparm(1:8).eq.'EPS09LO,') then 
          iorder=1
          read(lparm(9:),*)ipset 
        else if(lparm(1:9).eq.'EPS09NLO,') then 
          iorder=2
          read(lparm(10:),*)ipset 
        else
          iorder=2
          ipset=1 
        endif
        ia = a
        call eps09(iorder,ipset,ia,x,q,ruv,rdv,ru,rd,rs,rc,rb,rg)
        rt = 1.0d0
      else
        call eks98(x,q,a,ruv,rdv,ru,rd,rs,rc,rb,rt,rg)
      endif
      
      call evolvePDFM(nset,x,Q,f)
      f(0) = f(0)*rg
      f(1) = f(1)*rdv-f(-1)*(rdv-rd)
      f(2) = f(2)*ruv-f(-2)*(ruv-ru)
      f(3) = f(3)*rs      
      f(4) = f(4)*rc      
      f(5) = f(5)*rb      
      f(6) = f(6)*rt      
      f(-6) = f(-6)*rt
      f(-5) = f(-5)*rb
      f(-4) = f(-4)*rc
      f(-3) = f(-3)*rs
      f(-2) = f(-2)*ru
      f(-1) = f(-1)*rd

      return
      end
!      
      subroutine evolvePDFM(nset,xin,Qin,f)
      implicit none
      include 'parmsetup.inc'
      integer Eorder,index,imem
      character*16 name(nmxset)
      integer nmem(nmxset),ndef(nmxset),mem,ip2
      common/NAME/name,nmem,ndef,mem
      integer iset,iimem
      common/SET/iset,iimem
      integer nset,j
      real*8 x,xin,Q,Qin,Q2fit,alfas,p2,q2in
      real*8 f(-6:6),photon,gluino,xphoton
      character*20 lparm
      real*8 xmin,xmax,q2min,q2max
      real*8 gridx(nmxgridx),gridq(nmxgridq)
      integer nxgrid,nqgrid
      character*512 setpath
      integer nnpdf,nnpdf100,nnpdf1000
       data nnpdf,nnpdf100,nnpdf1000/0,0,0/
      save
!
      call setnset(nset)
!      
!      print *,'this is evolvePDFM, name=',nset,name(nset)
!   set all f's to 0.0d0 at start
!      do j = -6,6
!        f(j) = 0.0d0
!      enddo 

      call getlhaparm(18,lparm)
      if(lparm.ne.'EXTRAPOLATE') then
        call getnmem(nset,iimem)
        call getminmaxm(nset,iimem,xmin,xmax,q2min,q2max)
        x = max(xmin,min(xmax,xin))
        q2in = qin**2
        q = sqrt(max(0d0,q2min,min(q2max,q2in)))
      else
        x = xin
        q = qin
      endif

#ifdef QCDNUM 
      if (name(nset).eq.'QCDNUM') call QCDNUMevolve(x,Q,f)
      if (name(nset).eq.'QCDNUM_MRST') call QCDNUMevolve(x,Q,f)
      if (name(nset).eq.'QCDNUM_MRST3') call QCDNUM3evolve(x,Q,f)
      if (name(nset).eq.'QCDNUM_MRST4') call QCDNUM4evolve(x,Q,f)
#endif
#ifdef GRV
      if (name(nset).eq.'GRV') call GRVevolve(x,Q,f)
#endif
#ifdef ZEUS     
      if (name(nset)(1:12).eq.'QCDNUM_ZEUS_') call ZEUSevolve(x,Q,f)
#endif
#ifdef HERA
      if (name(nset)(1:12).eq.'QCDNUM_HERA_') call HERAevolve(x,Q,f)
      if (name(nset)(1:8).eq.'HERAGRID') call HERAGRIDevolve(x,Q,f)
#endif
#ifdef CTEQ
      if (name(nset).eq.'EVLCTEQ') call EVLCTEQevolve(x,Q,f)
      if (name(nset).eq.'CTEQ5grid') call CTEQ5evolve(x,Q,f)
      if (name(nset).eq.'CTEQ6grid') call CTEQ6evolve(x,Q,f)
      if (name(nset).eq.'CTEQ65grid') call CTEQ65evolve(x,Q,f)
      if (name(nset).eq.'CTEQ65cgrid') call CTEQ65cevolve(x,Q,f)
      if (name(nset).eq.'CTEQ65sgrid') call CTEQ65sevolve(x,Q,f)
      if (name(nset).eq.'CTEQ6ABgrid') call CTEQ6evolve(x,Q,f)
      if (name(nset).eq.'CTEQ66grid') call CTEQ65evolve(x,Q,f)
      if (name(nset).eq.'CT10grid') call CT12evolve(x,Q,f)
      if (name(nset).eq.'CT12grid') call CT12evolve(x,Q,f)
#endif
#ifdef MRST
      if (name(nset).eq.'MRST') call QCDNUMevolve(x,Q,f)
      if (name(nset).eq.'MRSTpdf') call QCDNUMevolve(x,Q,f)
      if (name(nset).eq.'MRSTgrid') call MRSTevolve(x,Q,f)
      if (name(nset).eq.'MRST3grid') call MRSTevolve(x,Q,f)
      if (name(nset).eq.'MRST4grid') call MRSTevolve(x,Q,f)
#endif
#ifdef MRSTQED
      if (name(nset).eq.'MRST4qed') call MRSTqedevolve(x,Q,f,xphoton)
#endif
#ifdef MRST98
      if (name(nset).eq.'MRST98grid') call MRST98evolve(x,Q,f)
#endif
#ifdef MRST06
      if (name(nset).eq.'MRST2006grid') call MRST2006evolve(x,Q,f)
#endif
#ifdef MSTW
      if (name(nset).eq.'MSTWgrid') call MSTWevolve(x,Q,f,xphoton)
#endif
#ifdef ALEKHIN
      if (name(nset).eq.'A02M') call A02Mevolve(x,Q,f)
      if (name(nset).eq.'ABKM09') call ABKM09evolve(x,Q,f)
      if (name(nset).eq.'ABM11') call ABM11evolve(x,Q,f)
#endif
#ifdef H1
      if (name(nset).eq.'H12000') call H1evolve(x,Q,f)
#endif
#ifdef GJR
      if (name(nset)(1:5).eq.'GJR08') call GJRevolve(x,Q,f)
#endif
#ifdef NNPDF
      if (name(nset).eq.'NNPDF') call NNPDFevolve(x,Q,f)
      if (name(nset).eq.'NNPDFint') call NNPDFINTevolve(x,Q,f)
      if (name(nset).eq.'NNPDF20int') call NNPDFINT20evolve(x,Q,f)
      if (name(nset).eq.'NNPDF20intqed') call NNPDFINT20qedevolve(x,Q,f,xphoton)
#endif
#ifdef HKN
      if (name(nset).eq.'HKNgrid') call hknevolve(x,Q,f)
#endif
#ifdef PIONS
      if (name(nset).eq.'OWP') call OWPevolve(x,Q,f)
      if (name(nset).eq.'SMRSP') call SMRSPevolve(x,Q,f)
      if (name(nset).eq.'GRVP0') call GRVP0evolve(x,Q,f)
      if (name(nset).eq.'GRVP1') call GRVP1evolve(x,Q,f)
      if (name(nset).eq.'ABFKWP') call ABFKWPevolve(x,Q,f)
#endif
#ifdef USER
      if (name(nset).eq.'USER') call USERevolve(x,Q,f)
      if (name(nset)(1:8).eq.'USERGRID') call USERGRIDevolve(x,Q,f)
#endif
      return
!
      entry evolvePDFpM(nset,xin,Qin,P2,IP2,f)
!
      call setnset(nset)
!      
      call getlhaparm(18,lparm)
      if(lparm.ne.'EXTRAPOLATE') then
        call getnmem(nset,iimem)
        call getminmaxm(nset,iimem,xmin,xmax,q2min,q2max)
        x = max(xmin,min(xmax,xin))
        q2in = qin**2
        q = sqrt(max(0d0,q2min,min(q2max,q2in)))
      else
        x = xin
        q = qin
      endif
!
#ifdef PHOTONS
      if(name(nset).eq.'SASG') call SASGevolvep(x,Q,P2,IP2,f)
      if(name(nset).eq.'GRVG0') call GRVGevolvep0(x,Q,P2,IP2,f)
      if(name(nset).eq.'GRVG1') call GRVGevolvep1(x,Q,P2,IP2,f)
      if (name(nset).eq.'DOG0') call DOGevolvep0(x,Q,P2,IP2,f)
      if (name(nset).eq.'DOG1') call DOGevolvep1(x,Q,P2,IP2,f)
      if (name(nset).eq.'DGG') call DGGevolvep(x,Q,P2,IP2,f)
      if (name(nset).eq.'LACG') call LACGevolvep(x,Q,P2,IP2,f)
      if (name(nset).eq.'GSG0') call GSGevolvep0(x,Q,P2,IP2,f)
      if (name(nset).eq.'GSG1') call GSGevolvep1(x,Q,P2,IP2,f)
      if (name(nset).eq.'GSG960') call GSG96evolvep0(x,Q,P2,IP2,f)
      if (name(nset).eq.'GSG961') call GSG96evolvep1(x,Q,P2,IP2,f)
      if (name(nset).eq.'ACFGP') call ACFGPevolvep(x,Q,P2,IP2,f)
      if (name(nset).eq.'WHITG') call WHITGevolvep(x,Q,P2,IP2,f)
#endif
      return
!
      entry evolvePDFphotonM(nset,xin,qin,f,photon)      

!
      call setnset(nset)
!
      call getlhaparm(18,lparm)
      if(lparm.ne.'EXTRAPOLATE') then
        call getnmem(nset,iimem)
        call getminmaxm(nset,iimem,xmin,xmax,q2min,q2max)
        x = max(xmin,min(xmax,xin))
        q2in = qin**2
        q = sqrt(max(0d0,q2min,min(q2max,q2in)))
      else
        x = xin
        q = qin
      endif
!
#ifdef MRSTQED      
      if(name(nset).eq.'MRST4qed') then
        call MRSTqedevolve(x,Q,f,photon)
      else if (name(nset).ne.'NNPDF20intqed') then
        photon = 0.0d0
      endif
#endif
!
#ifdef NNPDF      
      if(name(nset).eq.'NNPDF20intqed') then
        call NNPDFINT20qedevolve(x,Q,f,photon)
      else if (name(nset).ne.'MRST4qed') then
        photon = 0.0d0
      endif
#endif
!
      return

      entry evolvePDFgluinoM(nset,xin,qin,f,gluino)      

!
      call setnset(nset)
!
      call getlhaparm(18,lparm)
      if(lparm.ne.'EXTRAPOLATE') then
        call getnmem(nset,iimem)
        call getminmaxm(nset,iimem,xmin,xmax,q2min,q2max)
        x = max(xmin,min(xmax,xin))
        q2in = qin**2
        q = sqrt(max(0d0,q2min,min(q2max,q2in)))
      else
        x = xin
        q = qin
      endif
!
#ifdef CTEQ
      if(name(nset).eq.'CTEQ6LGgrid') then
        call CTEQ6LGevolve(x,Q,f,gluino)
      else
        gluino = 0.0d0
      endif
#endif
      return


      entry readevolve(nset)
!
      call getsetpath(setpath)
!
      if(index(setpath,'NNPDF').gt.0) then
          if(nset.gt.1) then
              if((index(setpath,'1000.').gt.0.and.nnpdf.gt.0).or.(index(setpath,'100.').gt.0.and.nnpdf1000.gt.0)) then
                  print *,'LHAPDF ERROR: MULTISET-INITIALIZATION with NNPDF 1000 sets IS NOT AVAIABLE (AT THE MOMENT)!'
                  STOP
              endif
          endif
          nnpdf=nnpdf+1
          if(index(setpath,'1000').gt.0) then
              nnpdf1000=nnpdf1000+1
          else
              nnpdf100=nnpdf100+1
          endif
      endif

!
      read(1,*) name(nset)   
!      print *, 'this is readevolve', name(nset)   
!
      call setnset(nset)
!      
#ifdef QCDNUM
      if (name(nset).eq.'QCDNUM') call QCDNUMread(nset)
      if (name(nset).eq.'QCDNUM_MRST') call QCDNUMread(nset)
      if (name(nset).eq.'QCDNUM_MRST3') call QCDNUM3read(nset)
      if (name(nset).eq.'QCDNUM_MRST4') call QCDNUM4read(nset)
#endif
#ifdef GRV
      if (name(nset).eq.'GRV') call GRVread(nset)
#endif
#ifdef ZEUS
      if (name(nset)(1:12).eq.'QCDNUM_ZEUS_') call ZEUSread(nset)
#endif
#ifdef HERA
      if (name(nset)(1:12).eq.'QCDNUM_HERA_') call HERAread(nset)
      if (name(nset)(1:8).eq.'HERAGRID') call HERAGRIDread(nset)
#endif
#ifdef CTEQ
      if (name(nset).eq.'EVLCTEQ') call EVLCTEQread(nset)
      if (name(nset).eq.'CTEQ5grid') call CTEQ5read(nset)
      if (name(nset).eq.'CTEQ6grid') call CTEQ6read(nset)
      if (name(nset).eq.'CTEQ65grid') call CTEQ65read(nset)
      if (name(nset).eq.'CTEQ65cgrid') call CTEQ65cread(nset)
      if (name(nset).eq.'CTEQ65sgrid') call CTEQ65read(nset)
      if (name(nset).eq.'CTEQ6ABgrid') call CTEQ6read(nset)
      if (name(nset).eq.'CTEQ66grid') call CTEQ66read(nset)
      if (name(nset).eq.'CTEQ6LGgrid') call CTEQ6LGread(nset)
      if (name(nset).eq.'CT10grid') call CT12read(nset)
      if (name(nset).eq.'CT12grid') call CT12read(nset)
#endif
#ifdef MRST
      if (name(nset).eq.'MRST') call QCDNUMread(nset)
      if (name(nset).eq.'MRSTpdf') call QCDNUMread(nset)
      if (name(nset).eq.'MRSTgrid') call MRSTread(nset)
      if (name(nset).eq.'MRST3grid') call MRSTread(nset)
      if (name(nset).eq.'MRST4grid') call MRSTread(nset)
#endif
#ifdef MRSTQED
      if (name(nset).eq.'MRST4qed') call MRSTqedread(nset)
#endif
#ifdef MRST98
      if (name(nset).eq.'MRST98grid') call MRST98read(nset)
#endif
#ifdef MRST06
      if (name(nset).eq.'MRST2006grid') call MRST2006read(nset)
#endif
#ifdef MSTW
      if (name(nset).eq.'MSTWgrid') call MSTWread(nset)
#endif
#ifdef ALEKHIN
      if (name(nset).eq.'A02M') call A02Mread(nset)
      if (name(nset).eq.'ABKM09') call ABKM09read(nset)
      if (name(nset).eq.'ABM11') call ABM11read(nset)
#endif
#ifdef H1      
      if (name(nset).eq.'H12000') call H1read(nset)
#endif
#ifdef GJR
      if (name(nset)(1:5).eq.'GJR08') call GJRread(nset)
#endif
#ifdef NNPDF
      if (name(nset).eq.'NNPDF') call NNPDFread(nset)
      if (name(nset).eq.'NNPDFint') call NNPDFINTread(nset)
      if (name(nset).eq.'NNPDF20int') call NNPDFINT20read(nset)
      if (name(nset).eq.'NNPDF20intqed') call NNPDFINT20qedread(nset)
#endif
#ifdef HKN
      if (name(nset).eq.'HKNgrid') call hknread(nset)
#endif
#ifdef PHOTONS
      if (name(nset).eq.'SASG') call SASGread(nset)
      if (name(nset).eq.'GRVG0' .OR. &
     &    name(nset).eq.'GRVG1') call GRVGread(nset)
      if (name(nset).eq.'DOG0' .OR. &
     &    name(nset).eq.'DOG1') call DOGread(nset)
      if (name(nset).eq.'DGG') call DGGread(nset)
      if (name(nset).eq.'LACG') call LACGread(nset)
      if (name(nset).eq.'GSG0' .OR. & 
     &    name(nset).eq.'GSG1') call GSGread(nset)
      if (name(nset).eq.'GSG960' .OR. &
     &    name(nset).eq.'GSG961') call GSG96read(nset)
      if (name(nset).eq.'ACFGP') call ACFGPread(nset)
      if (name(nset).eq.'WHITG') call WHITGread(nset)
#endif
#ifdef PIONS
      if (name(nset).eq.'OWP') call OWPread(nset)
      if (name(nset).eq.'SMRSP') call SMRSPread(nset)
      if (name(nset).eq.'GRVP0' .OR. & 
     &    name(nset).eq.'GRVP1') call GRVPread(nset)
      if (name(nset).eq.'ABFKWP') call ABFKWPread(nset)
#endif
#ifdef USER
      if (name(nset).eq.'USER') call USERread(nset)
      if (name(nset)(1:8).eq.'USERGRID') call USERGRIDread(nset)
#endif
      return
!
      entry alfasevolve(nset,alfas,Qin)
!
      call setnset(nset)
        q = qin
#ifdef QCDNUM
      if (name(nset).eq.'QCDNUM') call QCDNUMalfa(alfas,Q)
      if (name(nset).eq.'QCDNUM_MRST') call QCDNUMalfa(alfas,Q)
      if (name(nset).eq.'QCDNUM_MRST3') call QCDNUM3alfa(alfas,Q)
      if (name(nset).eq.'QCDNUM_MRST4') call QCDNUM4alfa(alfas,Q)
#endif
#ifdef GRV
      if (name(nset).eq.'GRV') call GRValfa(alfas,Q)
#endif
#ifdef ZEUS
      if (name(nset)(1:12).eq.'QCDNUM_ZEUS_') call ZEUSalfa(alfas,Q)
#endif
#ifdef HERA
      if (name(nset)(1:12).eq.'QCDNUM_HERA_') call HERAalfa(alfas,Q)
      if (name(nset)(1:8).eq.'HERAGRID') call HERAGRIDalfa(alfas,Q)
#endif
#ifdef CTEQ
      if (name(nset).eq.'EVLCTEQ') call EVLCTEQalfa(alfas,Q)
      if (name(nset).eq.'CTEQ5grid') call CTEQ5alfa(alfas,Q)
      if (name(nset).eq.'CTEQ6grid') call CTEQ6alfa(alfas,Q)
      if (name(nset).eq.'CTEQ65grid') call CTEQ65alfa(alfas,Q)
      if (name(nset).eq.'CTEQ65cgrid') call CTEQ65alfa(alfas,Q)
      if (name(nset).eq.'CTEQ65sgrid') call CTEQ65alfa(alfas,Q)
      if (name(nset).eq.'CTEQ66grid') call CTEQ65alfa(alfas,Q)
      if (name(nset).eq.'CTEQ6LGgrid') call CTEQ6LGalfa(alfas,Q)
      if (name(nset).eq.'CT10grid') call CT12alfa(alfas,Q)
      if (name(nset).eq.'CT12grid') call CT12alfa(alfas,Q)
#endif
#ifdef MRST
      if (name(nset).eq.'MRST') call QCDNUMalfa(alfas,Q)
      if (name(nset).eq.'MRSTpdf') call QCDNUMalfa(alfas,Q)
      if (name(nset).eq.'MRSTgrid') call MRSTalfa(5,alfas,Q)
      if (name(nset).eq.'MRST3grid') call MRSTalfa(3,alfas,Q)
      if (name(nset).eq.'MRST4grid') call MRSTalfa(4,alfas,Q)
#endif
#ifdef MRSTQED
      if (name(nset).eq.'MRST4qed') call MRSTqedalfa(4,alfas,Q)
#endif
#ifdef MRST98
      if (name(nset).eq.'MRST98grid') call MRST98alfa(alfas,Q)
#endif
#ifdef MRST06
      if (name(nset).eq.'MRST2006grid') call MRST2006alfa(5,alfas,Q)
#endif
#ifdef MSTW
      if (name(nset).eq.'MSTWgrid') call MSTWalfa(alfas,Q)
#endif
#ifdef ALEKHIN
      if (name(nset).eq.'A02M') call A02Malfa(alfas,Q)
      if (name(nset).eq.'ABKM09') call ABKM09alfa(alfas,Q)
      if (name(nset).eq.'ABM11') call ABM11alfa(alfas,Q)
#endif
#ifdef H1
      if (name(nset).eq.'H12000') call H1alfa(alfas,Q)
#endif
#ifdef GJR
      if (name(nset)(1:5).eq.'GJR08') call GJRalfa(alfas,Q)
#endif
#ifdef NNPDF
      if (name(nset).eq.'NNPDF') call NNPDFalfa(alfas,Q)
      if (name(nset).eq.'NNPDFint') call NNPDFINTalfa(alfas,Q)
      if (name(nset).eq.'NNPDF20int') call NNPDFINT20alfa(alfas,Q)
      if (name(nset).eq.'NNPDF20intqed') call NNPDFINT20qedalfa(alfas,Q)
#endif
#ifdef HKN
      if (name(nset).eq.'HKNgrid') call hknalfa(alfas,Q)
#endif
#ifdef PHOTONS
      if (name(nset).eq.'SASG') call SASGalfa(alfas,Q)
      if (name(nset).eq.'GRVG0' .OR. &
     &    name(nset).eq.'GRVG1') call GRVGalfa(alfas,Q)
      if (name(nset).eq.'DOG0' .OR. &
     &    name(nset).eq.'DOG1') call DOGalfa(alfas,Q)
      if (name(nset).eq.'DGG') call DGGalfa(alfas,Q)
      if (name(nset).eq.'LACG') call LACGalfa(alfas,Q)
      if (name(nset).eq.'GSG0' .OR. &
     &    name(nset).eq.'GSG1') call GSGalfa(alfas,Q)
      if (name(nset).eq.'GSG960' .OR. &
     &    name(nset).eq.'GSG961') call GSG96alfa(alfas,Q)
      if (name(nset).eq.'ACFGP') call ACFGPalfa(alfas,Q)
      if (name(nset).eq.'WHITG') call WHITGalfa(alfas,Q)
#endif
#ifdef PIONS
      if (name(nset).eq.'OWP') call OWPalfa(alfas,Q)
      if (name(nset).eq.'SMRSP') call SMRSPalfa(alfas,Q)
      if (name(nset).eq.'GRVP0' .OR. & 
     &    name(nset).eq.'GRVP1') call GRVPalfa(alfas,Q)
      if (name(nset).eq.'ABFKWP') call ABFKWPalfa(alfas,Q)
#endif
#ifdef USER
      if (name(nset).eq.'USER') call USERalfa(alfas,Q)
      if (name(nset)(1:8).eq.'USERGRID') call USERGRIDalfa(alfas,Q)
#endif
      return
!
      entry initevolution(nset,Eorder,Q2fit)
!
      call setnset(nset)
!            
#ifdef QCDNUM
      if (name(nset).eq.'QCDNUM') call QCDNUMinit(nset,Eorder,Q2fit)
      if (name(nset).eq.'QCDNUM_MRST') then 
        call QCDNUMinit(nset,Eorder,Q2fit) 
        call QNLSET('BMARK',.TRUE.) 
      endif 
      if (name(nset).eq.'QCDNUM_MRST3') then 
        call QCDNUM3init(nset,Eorder,Q2fit) 
        call QNLSET('BMARK',.TRUE.) 
      endif 
      if (name(nset).eq.'QCDNUM_MRST4') then 
        call QCDNUM4init(nset,Eorder,Q2fit) 
        call QNLSET('BMARK',.TRUE.) 
      endif 
#endif
#ifdef GRV
      if (name(nset).eq.'GRV') call GRVinit(Eorder,Q2fit)
#endif
#ifdef ZEUS
      if (name(nset)(1:12).eq.'QCDNUM_ZEUS_') &
     & call ZEUSinit(nset,Eorder,Q2fit)
#endif
#ifdef HERA
      if (name(nset)(1:12).eq.'QCDNUM_HERA_') & 
     & call HERAinit(nset,Eorder,Q2fit)
      if (name(nset)(1:8).eq.'HERAGRID')call HERAGRIDinit(nset,Eorder,Q2fit)
#endif
#ifdef CTEQ
      if (name(nset).eq.'EVLCTEQ') call EVLCTEQinit(nset,Eorder,Q2fit)
      if (name(nset).eq.'CTEQ5grid') call CTEQ5init(Eorder,Q2fit)
      if (name(nset).eq.'CTEQ6grid') call CTEQ6init(Eorder,Q2fit)
      if (name(nset).eq.'CTEQ65grid') call CTEQ65init(Eorder,Q2fit)
      if (name(nset).eq.'CTEQ65cgrid') call CTEQ65init(Eorder,Q2fit)
      if (name(nset).eq.'CTEQ65sgrid') call CTEQ65init(Eorder,Q2fit)
      if (name(nset).eq.'CTEQ66grid') call CTEQ65init(Eorder,Q2fit)
      if (name(nset).eq.'CTEQ6LGgrid') call CTEQ6LGinit(Eorder,Q2fit)
      if (name(nset).eq.'CT10grid') call CT12init(Eorder,Q2fit)
      if (name(nset).eq.'CT12grid') call CT12init(Eorder,Q2fit)
#endif
#ifdef MRST
      if (name(nset).eq.'MRSTgrid') call MRSTinit(Eorder,Q2fit)
      if (name(nset).eq.'MRST3grid') call MRSTinit(Eorder,Q2fit)
      if (name(nset).eq.'MRST4grid') call MRSTinit(Eorder,Q2fit)
#endif
#ifdef MRSTQED
      if (name(nset).eq.'MRST4qed') call MRSTqedinit(Eorder,Q2fit)
#endif
#ifdef MRST98
      if (name(nset).eq.'MRST98grid') call MRST98init(Eorder,Q2fit)
#endif
#ifdef MRST06
      if (name(nset).eq.'MRST2006grid') call MRST2006init(Eorder,Q2fit)
#endif
#ifdef MSTW
      if (name(nset).eq.'MSTWgrid') call MSTWinit(Eorder,Q2fit)
#endif
#ifdef ALEKHIN
      if (name(nset).eq.'A02M') call A02Minit
      if (name(nset).eq.'ABKM09') call ABKM09init
      if (name(nset).eq.'ABM11') call ABM11init
#endif
#ifdef H1
      if (name(nset).eq.'H12000') call H1init(Eorder,Q2fit)
#endif
#ifdef GJR
      if (name(nset)(1:5).eq.'GJR08') call GJRinit(Eorder,Q2fit)
#endif
#ifdef NNPDF
      if (name(nset).eq.'NNPDF') call NNPDFinit(nset,Eorder,Q2fit)
      if (name(nset).eq.'NNPDFint') call NNPDFINTinit(nset,Eorder,Q2fit)
      if (name(nset).eq.'NNPDF20int') call NNPDFINT20init(nset,Eorder,Q2fit)
      if (name(nset).eq.'NNPDF20intqed') call NNPDFINT20qedinit(nset,Eorder,Q2fit)
#endif
#ifdef PHOTONS
      if (name(nset).eq.'SASG') call SASGinit(Eorder,Q2fit)
      if (name(nset).eq.'GRVG0' .OR. &
     &    name(nset).eq.'GRVG1') call GRVGinit(Eorder,Q2fit)
      if (name(nset).eq.'DOG0' .OR. &
     &    name(nset).eq.'DOG1') call DOGinit(Eorder,Q2fit)
      if (name(nset).eq.'DGG') call DGGinit(Eorder,Q2fit)
      if (name(nset).eq.'LACG') call LACGinit(Eorder,Q2fit)
      if (name(nset).eq.'GSG0' .OR. &
     &    name(nset).eq.'GSG1') call GSGinit(Eorder,Q2fit)
      if (name(nset).eq.'GSG960' .OR. &
     &    name(nset).eq.'GSG961') call GSG96init(Eorder,Q2fit)
      if (name(nset).eq.'ACFGP') call ACFGPinit(Eorder,Q2fit)
      if (name(nset).eq.'WHITG') call WHITGinit(Eorder,Q2fit)
#endif
#ifdef PIONS
      if (name(nset).eq.'OWP') call OWPinit(Eorder,Q2fit)
      if (name(nset).eq.'SMRSP') call SMRSPinit(Eorder,Q2fit)
      if (name(nset).eq.'GRVP0' .OR. & 
     &    name(nset).eq.'GRVP1') call GRVPinit(Eorder,Q2fit)
      if (name(nset).eq.'ABFKWP') call ABFKWPinit(Eorder,Q2fit)
#endif
#ifdef HKN
      if (name(nset).eq.'HKNgrid') call hkninit(nset,Eorder,Q2fit)
#endif
#ifdef USER
      if (name(nset).eq.'USER') call USERinit(nset,Eorder,Q2fit)
      if (name(nset)(1:8).eq.'USERGRID') call USERGRIDinit(nset,Eorder,Q2fit)
#endif
      return
!
      entry initPDFM(nset,imem)
!
      call setnset(nset)
      call setnmem(nset,imem)
!            
      iimem = imem
#ifdef QCDNUM
      if (name(nset).eq.'QCDNUM') then
         call InitEvolvePDF(nset,imem)
         call QCDNUMpdf(nset)
      endif
      if (name(nset).eq.'QCDNUM_MRST') then
         call InitEvolvePDF(nset,imem)
         call QCDNUMpdf(nset)
      endif
      if (name(nset).eq.'QCDNUM_MRST3') then
         call InitEvolvePDF(nset,imem)
         call QCDNUM3pdf(nset)
      endif
      if (name(nset).eq.'QCDNUM_MRST4') then
         call InitEvolvePDF(nset,imem)
         call QCDNUM4pdf(nset)
      endif
#endif
#ifdef ZEUS
      if (name(nset)(1:12).eq.'QCDNUM_ZEUS_') then
         call InitEvolvePDF(nset,imem)
         call ZEUSpdf(nset)
      endif
#endif
#ifdef HERA
      if (name(nset)(1:12).eq.'QCDNUM_HERA_') then
         call InitEvolvePDF(nset,imem)
         call HERApdf(nset)
      endif
      if (name(nset)(1:8).eq.'HERAGRID') call HERAGRIDpdf(imem)
#endif
#ifdef MRST
      if (name(nset).eq.'MRST') then
         call InitEvolvePDF(nset,imem)
         call QCDNUMpdf(nset)
      endif
      if (name(nset).eq.'MRSTpdf') then
         call InitEvolvePDF(nset,imem)
         call QCDNUMpdf(nset)
      endif
      if (name(nset).eq.'MRSTgrid') call MRSTpdf(imem)
      if (name(nset).eq.'MRST3grid') call MRSTpdf(imem)
      if (name(nset).eq.'MRST4grid') call MRSTpdf(imem)
#endif
#ifdef MRSTQED
      if (name(nset).eq.'MRST4qed') call MRSTqedpdf(imem)
#endif
#ifdef MRST98
      if (name(nset).eq.'MRST98grid') call MRST98pdf(imem)
#endif
#ifdef MRST06
      if (name(nset).eq.'MRST2006grid') call MRST2006pdf(imem)
#endif
#ifdef CTEQ
      if (name(nset).eq.'EVLCTEQ') then
         call InitEvolvePDF(nset,imem)
         call EVLCTEQpdf(nset)
!          call EVLCTEQpdf(nset,imem)
      endif
      if (name(nset).eq.'CTEQ65grid') then
         call CTEQ6NewAlpha(nset,imem)
      endif
      if (name(nset).eq.'CTEQ65cgrid') then
         call CTEQ6NewAlpha(nset,imem)
      endif
      if (name(nset).eq.'CTEQ65sgrid') then
         call CTEQ6NewAlpha(nset,imem)
      endif
      if (name(nset).eq.'CTEQ6ABgrid') then
         call CTEQ6NewAlpha(nset,imem)
!         call CTEQ6pdf(nset)
      endif
      if (name(nset).eq.'CTEQ66grid') then
         call CTEQ6NewAlpha(nset,imem)
      endif
      if (name(nset).eq.'CT10grid') then
         call CTEQ6NewAlpha(nset,imem)
      endif
      if (name(nset).eq.'CT12grid') then
         call CTEQ6NewAlpha(nset,imem)
      endif
      if (name(nset).eq.'CTEQ5grid') call CTEQ5pdf(imem)
      if (name(nset).eq.'CTEQ6grid') call CTEQ6pdf(imem)
      if (name(nset).eq.'CTEQ65grid') call CTEQ65pdf(imem)
      if (name(nset).eq.'CTEQ66grid') call CTEQ65pdf(imem)
      if (name(nset).eq.'CTEQ65cgrid') call CTEQ65pdf(imem)
      if (name(nset).eq.'CTEQ65sgrid') call CTEQ65pdf(imem)
      if (name(nset).eq.'CTEQ6ABgrid') call CTEQ6pdf(imem)
      if (name(nset).eq.'CTEQ66grid') call CTEQ65pdf(imem)
      if (name(nset).eq.'CTEQ6LGgrid') call CTEQ6LGpdf(imem)
      if (name(nset).eq.'CT10grid') call CT12pdf(imem)
      if (name(nset).eq.'CT12grid') call CT12pdf(imem)
#endif
#ifdef H1
      if (name(nset).eq.'H12000') then
         call InitEvolvePDF(nset,imem)
         call H1pdf(imem)
      endif         
#endif
#ifdef NNPDF
      if (name(nset).eq.'NNPDF') then
         call InitEvolvePDF(nset,imem)
         call NNPDFpdf(nset)
      endif
      if (name(nset).eq.'NNPDFint') then
         call InitEvolvePDF(nset,imem)
         call NNPDFINTpdf(imem)
      endif
      if (name(nset).eq.'NNPDF20int') then
         call InitEvolvePDF(nset,imem)
         call NNPDFINT20pdf(imem)
      endif
      if (name(nset).eq.'NNPDF20intqed') then
         call InitEvolvePDF(nset,imem)
         call NNPDFINT20qedpdf(imem)
      endif
#endif
#ifdef MSTW
      if (name(nset).eq.'MSTWgrid') call MSTWpdf(imem)
#endif
#ifdef GJR
      if (name(nset)(1:5).eq.'GJR08') call GJRpdf(imem)
#endif
#ifdef ALEKHIN
      if (name(nset).eq.'A02M') call A02Mpdf(imem)
      if (name(nset).eq.'ABKM09') call ABKM09pdf(imem)
      if (name(nset).eq.'ABM11') call ABM11pdf(imem)
#endif
#ifdef HKN
      if (name(nset).eq.'HKNgrid') call hknpdf(imem)
#endif
#ifdef PHOTONS
!      if (name(nset).eq.'GRV0' .OR. &
!     &    name(nset).eq.'GRV1') call GRVpdf(imem)
      if (name(nset).eq.'SASG') call SASGpdf(imem)
      if (name(nset).eq.'GRVG') call GRVGpdf(imem)
      if (name(nset).eq.'DOG0' .OR. &
     &    name(nset).eq.'DOG1') call DOGpdf(imem)
      if (name(nset).eq.'DGG') call DGGpdf(imem)
      if (name(nset).eq.'LACG') call LACGpdf(imem)
      if (name(nset).eq.'GSG0' .OR. &
     &    name(nset).eq.'GSG1') call GSGpdf(imem)
      if (name(nset).eq.'GSG960' .OR. &
     &    name(nset).eq.'GSG961') call GSG96pdf(imem)
      if (name(nset).eq.'ACFGP') call ACFGPpdf(imem)
      if (name(nset).eq.'WHITG') call WHITGpdf(imem)
#endif
#ifdef PIONS
      if (name(nset).eq.'OWP') call OWPpdf(imem)
      if (name(nset).eq.'SMRSP') call SMRSPpdf(imem)
      if (name(nset).eq.'GRVP0' .OR. &
     &    name(nset).eq.'GRVP1') call GRVPpdf(imem) 
      if (name(nset).eq.'ABFKWP') call ABFKWPpdf(imem)
#endif
#ifdef USER
      if (name(nset).eq.'USER') then
         call InitEvolvePDF(nset,imem)
         call USERpdf(imem)
      endif
      if (name(nset)(1:8).eq.'USERGRID') then
         call InitEvolvePDF(nset,imem)
         call USERGRIDpdf(imem)
      endif
#endif
      return
!
      entry getGridM(nset,nxgrid,nqgrid,gridx,gridq)
#ifdef MRST
      if(name(nset).eq.'MRSTgrid') call MRSTgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if(name(nset).eq.'MRST3grid') call MRSTgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if(name(nset).eq.'MRST4grid') call MRSTgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif 
#ifdef MRSTQED
      if(name(nset).eq.'MRST4qed') call MRSTqedgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif 
#ifdef MRST98
      if(name(nset).eq.'MRST98grid') call MRST98getgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif 
#ifdef MRST06
      if(name(nset).eq.'MRST2006grid') call MRST2006getgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif 
#ifdef MSTW
      if(name(nset).eq.'MSTWgrid') call MSTWgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif 
#ifdef CTEQ
      if (name(nset).eq.'CTEQ6grid') call CTEQ6getgrid(nset,nxgrid,nqgrid,gridx,gridq)  
      if (name(nset).eq.'CTEQ6ABgrid') call CTEQ6getgrid(nset,nxgrid,nqgrid,gridx,gridq) 
      if (name(nset).eq.'CTEQ5grid') call CTEQ5getgrid(nset,nxgrid,nqgrid,gridx,gridq) 
      if (name(nset).eq.'CTEQ65grid') call CTEQ65getgrid(nset,nxgrid,nqgrid,gridx,gridq) 
      if (name(nset).eq.'CTEQ65cgrid') call CTEQ65getgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if (name(nset).eq.'CTEQ65sgrid') call CTEQ65getgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if (name(nset).eq.'CTEQ66grid') call CTEQ65getgrid(nset,nxgrid,nqgrid,gridx,gridq) 
      if (name(nset).eq.'CT10grid') call CT12getgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if (name(nset).eq.'CT12grid') call CT12getgrid(nset,nxgrid,nqgrid,gridx,gridq) 
#endif
#ifdef NNPDF
!      if (name(nset).eq.'NNPDFint') call NNPDFINTgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if (name(nset).eq.'NNPDF20int') call NNPDFINT20getgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if (name(nset).eq.'NNPDF20qedint') call NNPDFINT20qedgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif
#ifdef HERA
      if (name(nset)(1:8).eq.'HERAGRID') call HERAGRIDgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif
#ifdef ALEKHIN
      if (name(nset).eq.'A02M') call A02Mgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if (name(nset).eq.'ABKM09') call ABKM09getgrid(nset,nxgrid,nqgrid,gridx,gridq)
      if (name(nset).eq.'ABM11') call ABM11getgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif
#ifdef GJR
      if (name(nset)(1:5).eq.'GJR08') call GJRgetgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif
#ifdef H1
      if (name(nset).eq.'H12000') call H1getgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif
#ifdef HKN
      if (name(nset).eq.'HKNgrid') call hkngetgrid(nset,nxgrid,nqgrid,gridx,gridq)
#endif
      return
           
      end

! -*- F90 -*-


      subroutine GRVevolve(xin,qin,pdf) 
      implicit real*8 (a-h,o-z) 
      include 'parmsetup.inc' 
      PARAMETER(ngrid=2) 
      PARAMETER (NPART=6, NX=68, NQ=27, NARG=2) 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      DIMENSION XXUVF(0:ngrid,NX,NQ), XXDVF(0:ngrid,NX,NQ),             &
     &          XXDEF(0:ngrid,NX,NQ), XXUDF(0:ngrid,NX,NQ),             &
     &          XXSF(0:ngrid,NX,NQ),   XXGF(0:ngrid,NX,NQ),             &
     &          XUVF(NX,NQ), XDVF(NX,NQ),                               &
     &          XDEF(NX,NQ), XUDF(NX,NQ),                               &
     &          XSF(NX,NQ),   XGF(NX,NQ),                               &
     &          PARTON (NPART,NQ,NX-1),                                 &
     &          QS(NQ), XB(NX), XT(NARG), NA(NARG), ARRF(NX+NQ)         
      CHARACTER*80 LINE 
      dimension pdf(-6:6) 
      save 
      x=xin 
      q2=qin*qin 
!...CHECK OF X AND Q2 VALUES :                                          
      IF ( (X.LT.0.99D-9) .OR. (X.GT.1.D0) ) THEN 
         WRITE(6,91) 
   91    FORMAT (2X,'PARTON INTERPOLATION: X OUT OF RANGE') 
         STOP 
      ENDIF 
      IF ( (Q2.LT.0.799) .OR. (Q2.GT.1.01E6) ) THEN 
         WRITE(6,92) 
   92    FORMAT (2X,'PARTON INTERPOLATION: Q2 OUT OF RANGE') 
         STOP 
      ENDIF 
!...INTERPOLATION :                                                     
      DO IQ=1,NQ 
      DO IX=1,NX 
      xuvf(ix,iq)=xxuvf(imem,ix,iq) 
      xdvf(ix,iq)=xxdvf(imem,ix,iq) 
      xdef(ix,iq)=xxdef(imem,ix,iq) 
      xudf(ix,iq)=xxudf(imem,ix,iq) 
      xsf(ix,iq)=xxsf(imem,ix,iq) 
      xgf(ix,iq)=xxgf(imem,ix,iq) 
      enddo 
      enddo 
      XT(1) = DLOG(X) 
      XT(2) = DLOG(Q2) 
      X1 = 1.- X 
      XV = X**0.5 
      XS = X**(-0.2) 
      UV = FINT_LHA(NARG,XT,NA,ARRF,XUVF) * X1**3 * XV 
      DV = FINT_LHA(NARG,XT,NA,ARRF,XDVF) * X1**4 * XV 
      DE = FINT_LHA(NARG,XT,NA,ARRF,XDEF) * X1**7 * XV 
      UD = FINT_LHA(NARG,XT,NA,ARRF,XUDF) * X1**7 * XS 
      US = 0.5 * (UD - DE) 
      DS = 0.5 * (UD + DE) 
      SS = FINT_LHA(NARG,XT,NA,ARRF,XSF)  * X1**7 * XS 
      GL = FINT_LHA(NARG,XT,NA,ARRF,XGF)  * X1**5 * XS 
!                                                                       
                                                                        
      pdf(-6) = 0.0d0 
       pdf(6) = 0.0d0 
      pdf(-5) = 0.0d0 
       pdf(5) = 0.0d0 
      pdf(-4) = 0.0d0 
       pdf(4) = 0.0d0 
      pdf(-3) = ss 
       pdf(3) = ss 
      pdf(-2) = us 
       pdf(2) = uv+us 
      pdf(-1) = ds 
       pdf(1) = dv+ds 
       pdf(0) = gl 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRVread(nset) 
!                                                                       
!      print *,'calling grvread'                                        
      read(1,*)nmem(nset),ndef(nset) 
                                                                        
      read(1,93)xb 
!      print *,xb                                                       
      read(1,93)qs 
!      print *,qs                                                       
   93 format(8e8.2) 
!                                                                       
      do ng=0,nmem(nset) 
!                                                                       
      READ(1,89) LINE 
   89 FORMAT(A80) 
!      print *,line                                                     
      DO 15 M = 1, NX-1 
      DO 15 N = 1, NQ 
      READ(1,90) PARTON(1,N,M), PARTON(2,N,M), PARTON(3,N,M),           &
     &           PARTON(4,N,M), PARTON(5,N,M), PARTON(6,N,M)            
   90 FORMAT (6(1PE10.3)) 
   15 CONTINUE 
!                                                                       
!....ARRAYS FOR THE INTERPOLATION SUBROUTINE :                          
      DO 10 IQ = 1, NQ 
      DO 20 IX = 1, NX-1 
        XB0V = XB(IX)**0.5 
        XB0S = XB(IX)**(-0.2) 
        XB1 = 1.-XB(IX) 
        xXUVF(ng,IX,IQ) = PARTON(1,IQ,IX) / (XB1**3 * XB0V) 
        xXDVF(ng,IX,IQ) = PARTON(2,IQ,IX) / (XB1**4 * XB0V) 
        xXDEF(ng,IX,IQ) = PARTON(3,IQ,IX) / (XB1**7 * XB0V) 
        xXUDF(ng,IX,IQ) = PARTON(4,IQ,IX) / (XB1**7 * XB0S) 
        xXSF(ng,IX,IQ)  = PARTON(5,IQ,IX) / (XB1**7 * XB0S) 
        xXGF(ng,IX,IQ)  = PARTON(6,IQ,IX) / (XB1**5 * XB0S) 
   20 END DO 
        xXUVF(ng,NX,IQ) = 0.E0 
        xXDVF(ng,NX,IQ) = 0.E0 
        xXDEF(ng,NX,IQ) = 0.E0 
        xXUDF(ng,NX,IQ) = 0.E0 
        xXSF(ng,NX,IQ)  = 0.E0 
        xXGF(ng,NX,IQ)  = 0.E0 
   10 END DO 
      NA(1) = NX 
      NA(2) = NQ 
      DO 30 IX = 1, NX 
        ARRF(IX) = DLOG(XB(IX)) 
   30 END DO 
      DO 40 IQ = 1, NQ 
        ARRF(NX+IQ) = DLOG(QS(IQ)) 
   40 END DO 
                                                                        
      enddo 
                                                                        
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRValfa(alfas,qalfa) 
      call getnset(iset) 
      q2alfa = qalfa*qalfa 
      call GetOrderAsM(iset,iord) 
      nord=iord+1 
      alfas=grvals(q2alfa,nord) 
      alfas = 4.0d0*3.14159d0*alfas 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRVinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRVpdf(mem) 
      imem = mem 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!                                                                       
      FUNCTION FINT_LHA(NARG,ARG,NENT,ENT,TABLE) 
!********************************************************************   
!                                                                   *   
!   THE INTERPOLATION ROUTINE (CERN LIBRARY ROUTINE E104)           *   
!                                                                   *   
!********************************************************************   
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      DIMENSION ARG(5),NENT(5),ENT(10),TABLE(10) 
      DIMENSION D(5),NCOMB(5),IENT(5) 
      KD=1 
      M=1 
      JA=1 
         DO 5 I=1,NARG 
      NCOMB(I)=1 
      JB=JA-1+NENT(I) 
         DO 2 J=JA,JB 
      IF (ARG(I).LE.ENT(J)) GOTO 3 
    2 END DO 
      J=JB 
    3 IF (J.NE.JA) GOTO 4 
      J=J+1 
    4 JR=J-1 
      D(I)=(ENT(J)-ARG(I))/(ENT(J)-ENT(JR)) 
      IENT(I)=J-JA 
      KD=KD+IENT(I)*M 
      M=M*NENT(I) 
    5 JA=JB+1 
      FINT_LHA=0. 
   10 FAC=1. 
      IADR=KD 
      IFADR=1 
         DO 15 I=1,NARG 
      IF (NCOMB(I).EQ.0) GOTO 12 
      FAC=FAC*(1.-D(I)) 
      GOTO 15 
   12 FAC=FAC*D(I) 
      IADR=IADR-IFADR 
   15 IFADR=IFADR*NENT(I) 
      FINT_LHA=FINT_LHA+FAC*TABLE(IADR) 
      IL=NARG 
   40 IF (NCOMB(IL).EQ.0) GOTO 80 
      NCOMB(IL)=0 
      IF (IL.EQ.NARG) GOTO 10 
      IL=IL+1 
         DO 50  K=IL,NARG 
   50 NCOMB(K)=1 
      GOTO 10 
   80 IL=IL-1 
      IF(IL.NE.0) GOTO 40 
      RETURN 
      END                                           
                                                                        
!      FUNCTION ALPHAS (Q2, NAORD)                                      
      FUNCTION grvals (Q2, NAORD) 
!********************************************************************   
!                                                                   *   
!   THE ALPHA_S ROUTINE.                                            *   
!                                                                   *   
!   INPUT :  Q2    =  scale in GeV**2  (not too low, of course);    *   
!            NAORD =  1 (LO),  2 (NLO).                             *   
!                                                                   *   
!   OUTPUT:  alphas_s/(4 pi) for use with the GRV(98) partons.      *   
!                                                                   *   
!******************************************************i*************   
!                                                                       
      IMPLICIT DOUBLE PRECISION (A - Z) 
      INTEGER NF, K, I, NAORD 
      DIMENSION LAMBDAL (3:6),  LAMBDAN (3:6), Q2THR (3) 
!                                                                       
!...HEAVY QUARK THRESHOLDS AND LAMBDA VALUES :                          
      DATA Q2THR   /  1.960,  20.25,  30625. / 
      DATA LAMBDAL / 0.2041, 0.1750, 0.1320, 0.0665 / 
      DATA LAMBDAN / 0.2994, 0.2460, 0.1677, 0.0678 / 
!                                                                       
!...DETERMINATION OF THE APPROPRIATE NUMBER OF FLAVOURS :               
      NF = 3 
      DO 10 K = 1, 3 
      IF (Q2 .GT. Q2THR (K)) THEN 
         NF = NF + 1 
      ELSE 
          GOTO 20 
       END IF 
   10  CONTINUE 
!                                                                       
!...LO ALPHA_S AND BETA FUNCTION FOR NLO CALCULATION :                  
   20  B0 = 11.- 2./3.* NF 
       B1 = 102.- 38./3.* NF 
       B10 = B1 / (B0*B0) 
       IF (NAORD .EQ. 1) THEN 
         LAM2 = LAMBDAL (NF) * LAMBDAL (NF) 
         ALP  = 1./(B0 * DLOG (Q2/LAM2)) 
         GOTO 1 
       ELSE IF (NAORD .EQ. 2) then 
         LAM2 = LAMBDAN (NF) * LAMBDAN (NF) 
         B1 = 102.- 38./3.* NF 
         B10 = B1 / (B0*B0) 
       ELSE 
         WRITE (6,91) 
   91    FORMAT ('INVALID CHOICE FOR ORDER IN ALPHA_S') 
         STOP 
       END IF 
!                                                                       
!...START VALUE FOR NLO ITERATION :                                     
       LQ2 = DLOG (Q2 / LAM2) 
       ALP = 1./(B0*LQ2) * (1.- B10*DLOG(LQ2)/LQ2) 
!                                                                       
!...EXACT NLO VALUE, FOUND VIA NEWTON PROCEDURE :                       
       DO 2 I = 1, 6 
       XL  = DLOG (1./(B0*ALP) + B10) 
       XLP = DLOG (1./(B0*ALP*1.01) + B10) 
       XLM = DLOG (1./(B0*ALP*0.99) + B10) 
       Y  = LQ2 - 1./ (B0*ALP) + B10 * XL 
       Y1 = (- 1./ (B0*ALP*1.01) + B10 * XLP                            &
     &       + 1./ (B0*ALP*0.99) - B10 * XLP) / (0.02D0*ALP)            
       ALP = ALP - Y/Y1 
    2  CONTINUE 
!                                                                       
!...OUTPUT :                                                            
!  1    ALPHAS = ALP                                                    
    1  grvals = ALP 
       RETURN 
      END                                           

! -*- F90 -*-


SUBROUTINE CtLhALFSET (QS, ALFS) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  EXTERNAL CtLhRTALF 
  COMMON / CtLhRTALFC / ALFST, JORD, NEFF 
  DATA ALAM, BLAM, ERR / 0.01, 10.0, 0.02 / 
  ALFST = ALFS 
  CALL CtLhParQcd (2, 'ORDR', ORDR, IR1) 
  JORD  = Int(ORDR) 
  NEFF = LhCtNFL(QS) 
  EFLLN  = CtLhQZBRNT (CtLhRTALF, ALAM, BLAM, ERR, IR2) 
  EFFLAM = QS / EXP (EFLLN) 
  CALL CtLhSETL1 (NEFF, EFFLAM) 
END SUBROUTINE CtLhALFSET


FUNCTION CtLhALPI (AMU) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ 
  COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
  LOGICAL SET 
  PARAMETER (D0 = 0.D0, D1 = 1.D0, BIG = 1.0D15) 
  DATA IW1, IW2 / 2*0 / 
  IF(.NOT.SET) CALL CtLhLAMCWZ 
  NEFF = LhCtNFL(AMU) 
  ALM  = ALAM(NEFF) 
  CtLhALPI = CtLhALPQCD (NORDER, NEFF, AMU/ALM, IRT) 
  IF (IRT .EQ. 1) THEN 
     CALL CtLhWARNR (IW1, 'AMU < ALAM in CtLhALPI', 'AMU', AMU,     &
          &              ALM, BIG, 1)                                        
  ELSEIF (IRT .EQ. 2) THEN 
     CALL CtLhWARNR (IW2, 'CtLhALPI > 3; Be aware!', 'CtLhALPI',    &
          &  CtLhALPI, D0, D1, 0)                                            
  ENDIF
  RETURN 
END FUNCTION CtLhALPI


FUNCTION CtLhALPQCD (IRDR, NF, RML, IRT) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  PARAMETER (D0 = 0.D0, D1 = 1.D0, BIG = 1.0D15) 
  PARAMETER (CG = 3.0d0, TR = 0.5d0, CF = 4.0d0/3.0d0) 
  IRT = 0 
  IF (IRDR .LT. 1 .OR. IRDR .GT. 2) THEN 
     print *,                                                        &
          &  'Order out of range in CtLhALPQCD: IRDR = ', IRDR               
     STOP 
  ENDIF
  B0 = (11.d0*CG  - 2.* NF) / 3.d0 
  B1 = (34.d0*CG**2 - 10.d0*CG*NF - 6.d0*CF*NF) / 3.d0 
  RM2 = RML**2 
  IF (RM2 .LE. 1.) THEN 
     IRT = 1 
     CtLhALPQCD = 99. 
     RETURN 
  ENDIF
  ALN = LOG (RM2) 
  AL = 4.d0/ B0 / ALN 
  IF (IRDR .GE. 2) AL = AL * (1.d0-B1*LOG(ALN) / ALN / B0**2) 
  IF (AL .GE. 3.) THEN 
     IRT = 2 
  ENDIF
  CtLhALPQCD = AL 
  RETURN 
END FUNCTION CtLhALPQCD


FUNCTION CtLhAMHATF(I) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ 
  COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
  LOGICAL SET 
  IF (.NOT.SET) CALL CtLhLAMCWZ 
  IF ((I.LE.0).OR.(I.GT.9)) THEN 
     print *,'warning I OUT OF RANGE IN CtLhAMHATF' 
     CtLhAMHATF = 0 
  ELSE 
     CtLhAMHATF = AMHAT(I) 
  ENDIF
  RETURN 
END FUNCTION CtLhAMHATF


FUNCTION CtLhDXDZ (Z) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
  DATA HUGE, IWRN / 1.E20, 0 / 
  ZZ = Z 
  X = CtLhXFRMZ (ZZ) 
  TEM = CtLhDZDX (X) 
  IF     (TEM .NE. D0) THEN 
     TMP = D1 / TEM 
  Else 
     CALL CtLhWARNR(IWRN, 'CtLhDXDZ singular in CtLhDXDZ; set=HUGE',   &
          &             'Z', Z, D0, D1, 0)                                   
     TMP = HUGE 
  EndIf
  CtLhDXDZ = TMP 
  RETURN 
END FUNCTION CtLhDXDZ


SUBROUTINE CtLhEVLPAR (IACT, NAME, VALUE, IRET) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  CHARACTER*(*) NAME 
  IRET = 1 
  IF     (IACT .EQ. 0) THEN 
     WRITE ( NINT(VALUE) , 101) 
101  FORMAT (/ ' Initiation parameters:   Qini, Ipd0, Ihdn ' / &
          &                  ' Maximum Q, Order of Alpha:     Qmax, IKNL ' / &
          &                  ' X- mesh parameters   :   Xmin, Xcr,   Nx  ' / &
          &                  ' LnQ-mesh parameters  :         Nt,   Jt   ' / &
          &                  ' # of parton flavors  :         NfMx       ' /)
     IRET = 4 
  ElseIF (IACT .EQ. 1) THEN 
     CALL CtLhEVLSET (NAME, VALUE, IRET) 
  Else 
     print *,'fatal evlpar' 
     stop 
  EndIf
  RETURN 
END SUBROUTINE CtLhEVLPAR


SUBROUTINE CtLhEVLSET (NAME, VALUE, IRET) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  LOGICAL LSTX 
  CHARACTER*(*) NAME 
  PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
  PARAMETER (MXPN = MXF * 2 + 2) 
  PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
  COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
  COMMON / LhCtQARAY1 / QINI,QMAX, QV(0:MXQ),TV(0:MXQ), NT,JT,NG 
  COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx                  &
       & / PdfSwh / Iset, IpdMod, Iptn0, NuIni                            
  IRET = 1 
  IF     (NAME .EQ. 'QINI')  THEN 
     IF (VALUE .LE. 0) GOTO 12 
     QINI = VALUE 
  ElseIF (NAME .EQ. 'IPD0')  THEN 
     ITEM = NINT(VALUE) 
     IF (Item .Eq. 10 .or. Item .Eq. 11) GOTO 12 
     IPD0 = ITEM 
  ElseIF (NAME .EQ. 'IHDN') THEN 
     ITEM = NINT(VALUE) 
     IF (ITEM .LT. -1 .OR. ITEM .GT. 5) GOTO 12 
     IHDN = ITEM 
  ElseIF (NAME .EQ. 'QMAX')  THEN 
     IF (VALUE .LE. QINI) GOTO 12 
     QMAX = VALUE 
  ElseIF (NAME .EQ. 'IKNL') THEN 
     ITMP = NINT(VALUE) 
     ITEM = ABS(ITMP) 
     IF (ITEM.NE.1.AND.ITEM.NE.2) GOTO 12 
     IKNL = ITMP 
  ElseIF (NAME .EQ. 'XCR') THEN 
     IF (VALUE .LT. XMIN .OR. VALUE .GT. 10.) GOTO 12 
     XCR = VALUE 
     LSTX = .FALSE. 
  ElseIF (NAME .EQ. 'XMIN') THEN 
     IF (VALUE .LT. 1D-7 .OR. VALUE .GT. 1D0) GOTO 12 
     XMIN = VALUE 
     LSTX = .FALSE. 
  ElseIF (NAME .EQ. 'NX') THEN 
     ITEM = NINT(VALUE) 
     IF (ITEM .LT. 10 .OR. ITEM .GT. MXX-1) GOTO 12 
     NX = ITEM 
     LSTX = .FALSE. 
  ElseIF (NAME .EQ. 'NT') THEN 
     ITEM = NINT(VALUE) 
     IF (ITEM .LT. 2 .OR. ITEM .GT. MXQ) GOTO 12 
     NT = ITEM 
  ElseIF (NAME .EQ. 'JT') THEN 
     ITEM = NINT(VALUE) 
     IF (ITEM .LT. 1 .OR. ITEM .GT. 5) GOTO 12 
     JT = ITEM 
  ElseIF (NAME .EQ. 'NFMX') THEN 
     ITEM = NINT(VALUE) 
     IF (ITEM .LT. 1 .OR. ITEM .GT. MXPN) GOTO 12 
     NfMx = ITEM 
  ElseIF (NAME .EQ. 'IPDMOD') THEN 
     ITEM = NINT(VALUE) 
     IF (Abs(Item) .Gt. 1) GOTO 12 
     IpdMod = ITEM 
  ElseIF (NAME .EQ. 'IPTN0') THEN 
     ITEM = NINT(VALUE) 
     IF (ABS(ITEM) .GT. MXF) GOTO 12 
     IPTN0 = ITEM 
  ElseIF (NAME .EQ. 'NUINI') THEN 
     ITEM = NINT(VALUE) 
     IF (ITEM .LE. 0) GOTO 12 
     NuIni = ITEM 
  Else 
     IRET = 0 
  EndIf
  RETURN 
12 IRET = 2 
  RETURN 
END SUBROUTINE CtLhEVLSET


SUBROUTINE CtLhEVOLVE (FINI, IRET) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  include 'parmsetup.inc' 
  LOGICAL LSTX 
  PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
  PARAMETER (MXPN = MXF * 2 + 2) 
  PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
  PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
  COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
  COMMON / LhCtQARAY1 / QINI,QMAX, QV(0:MXQ),TV(0:MXQ), NT,JT,NG 
  COMMON / LhCtQARAY2 / TLN(MXF), DTN(MXF), NTL(MXF), NTN(MXF) 
  COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx 
  COMMON / LhCtPEVLDT / UPD(MXPQX,nmxset), KF, Nelmt 
  COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
  COMMON / LhCtVARBAB / GB(NDG, NDH, MXX), H(NDH, MXX, M1:M2) 
  DIMENSION QRKP(MXF) 
  DIMENSION JI(-MXF : MXF+1) 
  EXTERNAL LhCtNSRHSP, LhCtNSRHSM, FINI 
  DATA DZER / 0.0 / 
  save nxsave, ntsave, jtsave, ngsave,                              &
       &     xcrsave, xminsave, qinisave, qmaxsave, ientry                
  data ientry / 0 / 
  !                                                                       
  call getnset(iset) 
  !                                                                       
  ientry = ientry + 1 
  IRET = 0 
  IF (IHDN .LE. 4) THEN 
     MXVAL = 2 
  ElseIF (IHDN .LE. 6) THEN 
     MXVAL = 3 
  EndIf
  IF (.NOT. LSTX) CALL CtLhXARRAY 
  CALL CtLhPARPDF (2, 'ALAM', AL, IR) 
  CALL CtLhQARRAY (NINI) 
  NFSN = NFMX + 1 
  KF = 2 * NFMX + 2 
  Nelmt = KF * (Nt+1) * (Nx+1) 
  DO IFLV = -NFMX, NFMX+1 
     JFL = NFMX + IFLV 
     JI(IFLV) = JFL * (NT+1) * (NX+1) 
  END DO
  DO IZ = 1, NX 
     UPD(JI(0)+IZ+1,iset) = FINI (0, XV(IZ)) 
     UPD(JI(NFSN)+IZ+1,iset) = 0 
     IF (NFMX .EQ. 0) EXIT
     DO IFLV = 1, NINI 
        A = FINI ( IFLV, XV(IZ)) 
        B = FINI (-IFLV, XV(IZ)) 
        QRKP (IFLV) = A + B 
        UPD(JI(NFSN)+IZ+1,iset) =                                     &
             &       UPD(JI(NFSN)+IZ+1,iset) + QRKP (IFLV)                      
        UPD(JI(-IFLV)+IZ+1,iset) = A - B 
     END DO
     DO IFLV = 1, NINI 
        UPD(JI( IFLV)+IZ+1,iset) =                                   &
             &        QRKP(IFLV) - UPD(JI(NFSN)+IZ+1,iset)/NINI                 
     END DO
  END DO
  DO NEFF = NINI, NFMX 
     IF (IKNL .EQ. 2) CALL CtLhSTUPKL (NEFF) 
     ICNT = NEFF - NINI + 1 
     IF (NTN(ICNT) .EQ. 0) EXIT
     NITR = NTN (ICNT) 
     DT   = DTN (ICNT) 
     TIN  = TLN (ICNT) 
     CALL CtLhSNEVL (IKNL, NX, NITR, JT, DT, TIN, NEFF,            &
          &    UPD(JI(NFSN)+2,iset), UPD(JI(0)+2,iset),                      &
          &    UPD(JI(NFSN)+1,iset), UPD(JI(0)+1,iset))                      
     IF (NEFF .EQ. 0) GOTO 88 
     DO IFLV = 1, NEFF 
        CALL CtLhNSEVL (LhCtNSRHSP, IKNL, NX, NITR, JT, DT, TIN,     &
             &     NEFF, UPD(JI( IFLV)+2,iset), UPD(JI( IFLV)+1,iset))          
        IF (IFLV .LE. MXVAL)                                         &
             &     CALL CtLhNSEVL (LhCtNSRHSM, IKNL, NX, NITR, JT, DT, TIN,     &
             &     NEFF, UPD(JI(-IFLV)+2,iset), UPD(JI(-IFLV)+1,iset))          
        DO IS = 0, NITR 
           DO IX = 0, NX 
              TP = UPD (IS*(NX+1) + IX + 1 + JI( IFLV),iset) 
              TS = UPD (IS*(NX+1) + IX + 1 + JI( NFSN),iset) / NEFF 
              TP = TP + TS 
              IF (IKNL .GT. 0) TP = MAX (TP, DZER) 
              IF (IFLV .LE. MXVAL) THEN 
                 TM = UPD (IS*(NX+1) + IX + 1 + JI(-IFLV),iset) 
                 IF (IKNL .GT. 0) THEN 
                    TM = MAX (TM, DZER) 
                    TP = MAX (TP, TM) 
                 EndIf
              Else 
                 TM = 0. 
              EndIf
              UPD (JI( IFLV) + IS*(NX+1) + IX + 1,iset) = (TP + TM)/2. 
              UPD (JI(-IFLV) + IS*(NX+1) + IX + 1,iset) = (TP - TM)/2. 
           END DO
        END DO
     END DO
     DO IFLV = NEFF + 1, NFMX 
        DO IS = 0, NITR 
           DO IX = 0, NX 
              UPD(JI( IFLV) + IS*(NX+1) + IX + 1,iset) = 0 
              UPD(JI(-IFLV) + IS*(NX+1) + IX + 1,iset) = 0 
           END DO
        END DO
     END DO
88   CONTINUE 
     IF (NFMX .EQ. NEFF) EXIT
     DO IFLV = -NFMX, NFMX+1 
        JI(IFLV) = JI(IFLV) + NITR * (NX+1) 
     END DO
     CALL CtLhHQRK (NX, TT, NEFF+1, UPD(JI(0)+2,iset),               &
          &     UPD(JI(NEFF+1)+2,iset))                                      
     DO IZ = 1, NX 
        QRKP (NEFF+1) = 2. * UPD(JI( NEFF+1) + IZ + 1,iset) 
        UPD (JI(NFSN)+IZ+1,iset) = UPD (JI(NFSN)+IZ+1,iset)            &
             &        + QRKP (NEFF+1)                                           
        VS00 =  UPD (JI(NFSN)+IZ+1,iset) / (NEFF+1) 
        UPD(JI( NEFF+1) + IZ + 1,iset) = QRKP(NEFF+1) - VS00 
        DO IFL = 1, NEFF 
           A = UPD(JI( IFL)+IZ+1,iset) 
           B = UPD(JI(-IFL)+IZ+1,iset) 
           QRKP(IFL) = A + B 
           UPD(JI( IFL)+IZ+1,iset) = QRKP(IFL) - VS00 
           IF (IFL .LE. MXVAL)  UPD(JI(-IFL)+IZ+1,iset) = A - B 
        END DO
     END DO
  END DO
  if(ientry .eq. 1) then 
     nxsave = nx 
     ntsave = nt 
     jtsave = jt 
     ngsave = ng 
     xcrsave = xcr 
     xminsave = xmin 
     qinisave = qini 
     qmaxsave = qmax 
  endif
  if((nx .ne. nxsave) .or.                                        &
       &           (nt .ne. ntsave) .or.                                  &
       &           (jt .ne. jtsave) .or.                                  &
       &           (ng .ne. ngsave) .or.                                  &
       &           (xcr .ne. xcrsave) .or.                                &
       &           (xmin .ne. xminsave) .or.                              &
       &           (qini .ne. qinisave) .or.                              &
       &           (qmax .ne. qmaxsave)) then                             
     write(6,669) nx, nt, jt, ng, xcr, xmin,                      &
          &                        qini, qmax, ientry                        
669  format(1x,'evolve.f:  nx,nt,jt,ng=',4i4,                  &
          &               ' xcr,xmin=',2f9.6,                                &
          &               ' qini, qmax',f7.4,1x,e12.5,' ientry=',i6)         
     nxsave = nx 
     ntsave = nt 
     jtsave = jt 
     ngsave = ng 
     qinisave = qini 
     qmaxsave = qmax 
     xcrsave = xcr 
     xminsave = xmin 
  endif
  Return 
END SUBROUTINE CtLhEVOLVE


FUNCTION CtLhFINTRP (FF,  X0, DX, NX,  XV,  ERR, IR) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
  PARAMETER (MX = 3) 
  DIMENSION FF (0:NX), XX(MX) 
  DATA SML, XX / 1.D-5,  0., 1.0, 2.0 / 
  DATA  IW1, IW3, IW5 / 3 * 0 / 
  IR = 0 
  X = XV 
  ERR = 0. 
  ANX = NX 
  CtLhFINTRP = 0. 
  IF (NX .LT. 1) THEN 
     CALL CtLhWARNI(IW1, 'Nx < 1, error in CtLhFINTRP.',            &
          &              'NX', NX, 1, 256, 1)                                
     IR = 1 
     RETURN 
  ELSE 
     MNX = MIN(NX+1, MX) 
  ENDIF
  IF (DX .LE. 0) THEN 
     CALL CtLhWARNR(IW3, 'DX < 0, error in CtLhFINTRP.',            &
          &              'DX', DX, D0, D1, 1)                                
     IR = 2 
     RETURN 
  ENDIF
  XM = X0 + DX * NX 
  IF (X .LT. X0-SML .OR. X .GT. XM+SML) THEN 
     CALL CtLhWARNR(IW5,                                             &
          &     'X out of range in CtLhFINTRP, Extrapolation used.',         &
          &     'X',X,X0,XM,1)                                               
     IR = 3 
  ENDIF
  TX = (X - X0) / DX 
  IF (TX .LE. 1.) THEN 
     IX = 0 
  ELSEIF (TX .GE. ANX-1.) THEN 
     IX = NX - 2 
  ELSE 
     IX = Int(TX) 
  ENDIF
  DDX = TX - IX 
  CALL CtLhRATINT (XX, FF(IX), MNX, DDX, TEM, ERR) 
  CtLhFINTRP = TEM 
  RETURN 
END FUNCTION CtLhFINTRP


FUNCTION CtLhGausInt(F,XL,XR,AERR,RERR,ERR,IRT) 
  IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
  DIMENSION XLIMS(100), R(93), W(93) 
  INTEGER PTR(4),NORD(4) 
  external f 
  DATA PTR,NORD/4,10,22,46,  6,12,24,48/ 
  DATA R/.2386191860,.6612093865,.9324695142,                     &
       & .1252334085,.3678314990,.5873179543,.7699026742,.9041172563,     &
       & .9815606342,.0640568929,.1911188675,.3150426797,.4337935076,     &
       & .5454214714,.6480936519,.7401241916,.8200019860,.8864155270,     &
       & .9382745520,.9747285560,.9951872200,.0323801710,.0970046992,     &
       & .1612223561,.2247637903,.2873624873,.3487558863,.4086864820,     &
       & .4669029048,.5231609747,.5772247261,.6288673968,.6778723796,     &
       & .7240341309,.7671590325,.8070662040,.8435882616,.8765720203,     &
       & .9058791367,.9313866907,.9529877032,.9705915925,.9841245837,     &
       & .9935301723,.9987710073,.0162767488,.0488129851,.0812974955,     &
       & .1136958501,.1459737146,.1780968824,.2100313105,.2417431561,     &
       & .2731988126,.3043649444,.3352085229,.3656968614,.3957976498,     &
       & .4254789884,.4547094222,.4834579739,.5116941772,.5393881083,     &
       & .5665104186,.5930323648,.6189258401,.6441634037,.6687183100,     &
       & .6925645366,.7156768123,.7380306437,.7596023411,.7803690438,     &
       & .8003087441,.8194003107,.8376235112,.8549590334,.8713885059,     &
       & .8868945174,.9014606353,.9150714231,.9277124567,.9393703398,     &
       & .9500327178,.9596882914,.9683268285,.9759391746,.9825172636,     &
       & .9880541263,.9925439003,.9959818430,.9983643759,.9996895039/     
  DATA W/.4679139346,.3607615730,.1713244924,                     &
       & .2491470458,.2334925365,.2031674267,.1600783285,.1069393260,     &
       & .0471753364,.1279381953,.1258374563,.1216704729,.1155056681,     &
       & .1074442701,.0976186521,.0861901615,.0733464814,.0592985849,     &
       & .0442774388,.0285313886,.0123412298,.0647376968,.0644661644,     &
       & .0639242386,.0631141923,.0620394232,.0607044392,.0591148397,     &
       & .0572772921,.0551995037,.0528901894,.0503590356,.0476166585,     &
       & .0446745609,.0415450829,.0382413511,.0347772226,.0311672278,     &
       & .0274265097,.0235707608,.0196161605,.0155793157,.0114772346,     &
       & .0073275539,.0031533461,.0325506145,.0325161187,.0324471637,     &
       & .0323438226,.0322062048,.0320344562,.0318287589,.0315893308,     &
       & .0313164256,.0310103326,.0306713761,.0302999154,.0298963441,     &
       & .0294610900,.0289946142,.0284974111,.0279700076,.0274129627,     &
       & .0268268667,.0262123407,.0255700360,.0249006332,.0242048418,     &
       & .0234833991,.0227370697,.0219666444,.0211729399,.0203567972,     &
       & .0195190811,.0186606796,.0177825023,.0168854799,.0159705629,     &
       & .0150387210,.0140909418,.0131282296,.0121516047,.0111621020,     &
       & .0101607705,.0091486712,.0081268769,.0070964708,.0060585455,     &
       & .0050142027,.0039645543,.0029107318,.0018539608,.0007967921/     
  DATA TOLABS,TOLREL,NMAX/1.E-35,5.E-4,100/ 
  TOLABS=AERR 
  TOLREL=RERR 
  
  CtLhGausInt=0. 
  NLIMS=2 
  XLIMS(1)=XL 
  XLIMS(2)=XR 
10 AA=(XLIMS(NLIMS)-XLIMS(NLIMS-1))/2D0 
  BB=(XLIMS(NLIMS)+XLIMS(NLIMS-1))/2D0 
  TVAL=0. 
  DO 15 I=1,3 
15   TVAL=TVAL+W(I)*(F(BB+AA*R(I))+F(BB-AA*R(I))) 
     TVAL=TVAL*AA 
     DO 25 J=1,4 
        VAL=0. 
        DO 20 I=PTR(J),PTR(J)-1+NORD(J) 
20         VAL=VAL+W(I)*(F(BB+AA*R(I))+F(BB-AA*R(I))) 
           VAL=VAL*AA 
           TOL=MAX(TOLABS,TOLREL*ABS(VAL)) 
           IF (ABS(TVAL-VAL).LT.TOL) THEN 
              CtLhGausInt=CtLhGausInt+VAL 
              NLIMS=NLIMS-2 
              IF (NLIMS.NE.0) GOTO 10 
              RETURN 
           END IF
25         TVAL=VAL 
           IF (NMAX.EQ.2) THEN 
              CtLhGausInt=VAL 
              RETURN 
           END IF
           IF (NLIMS.GT.(NMAX-2)) THEN 
              write(*,50) CtLhGausInt,NMAX,BB-AA,BB+AA 
              RETURN 
           END IF
           XLIMS(NLIMS+1)=BB 
           XLIMS(NLIMS+2)=BB+AA 
           XLIMS(NLIMS)=BB 
           NLIMS=NLIMS+2 
           GOTO 10 
50         FORMAT (' CtLhGausInt FAILS, CtLhGausInt,NMAX,XL,XR=',          &
                &            G15.7,I5,2G15.7)                                      
      END                                           
      SUBROUTINE CtLhHINTEG (NX, F, H) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPN = MXF * 2 + 2) 
      PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtHINTEC / GH(NDG, MXX) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      DIMENSION F(NX), H(NX), G(MXX) 
      DZ = 1D0 / (NX-1) 
      DO 20 I = 1, NX-2 
         NP = NX - I + 1 
         TEM = GH(1,I)*F(I) + GH(2,I)*F(I+1) + GH(3,I)*F(I+2) 
         DO 30 KZ = 3, NP 
            IY = I + KZ - 1 
            W = XA(I,1) / XA(IY,1) 
            G(KZ) = DXTZ(IY)*(F(IY)-W*F(I))/(1.-W) 
   30    CONTINUE 
         HTEM = CtLhSMPSNA (NP-2, DZ, G(3), ERR) 
         TEM1 = F(I) * ELY(I) 
         H(I) = TEM + HTEM + TEM1 
   20 END DO 
      H(NX-1) = F(NX) - F(NX-1) + F(NX-1) * (ELY(NX-1) - XA(NX-1,0)) 
      H(NX)   = 0 
      RETURN 
      END                                           
      SUBROUTINE CtLhHQRK (NX, TT, NQRK, Y, F) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      DIMENSION Y(NX), F(NX) 
      IF (NX .GT. 1) GOTO 11 
11    CONTINUE 
      DO IZ = 1, NX 
         IF (NX .GT. 1) THEN 
            F(IZ) = 0 
            EXIT
         EndIf
      END DO
      RETURN 
      END                                           


      SUBROUTINE CtLhINTEGR (NX, M, F,   G, IR) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      CHARACTER MSG*80 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPN = MXF * 2 + 2) 
      PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtVARBAB / GB(NDG, NDH, MXX), H(NDH, MXX, M1:M2) 
      DIMENSION   F(NX), G(NX) 
      DATA IWRN1, IWRN2 / 0, 0 / 
      IRR = 0 
      IF (NX .LT. 1 .OR. XA(NX-1,1) .EQ. 0D0) THEN 
        MSG = 'NX out of range in CtLhINTEGR call' 
        CALL CtLhWARNI (IWRN1, MSG, 'NX', NX, 0, MXX, 0) 
        IRR = 1 
      EndIf 
      IF (M .LT. M1 .OR. M .GT. M2) THEN 
        MSG ='Exponent M out of range in CtLhINTEGR' 
        CALL CtLhWARNI (IWRN2, MSG, 'M', M, M1, M2, 1) 
        IRR = 2 
      EndIf 
      G(NX) = 0D0 
      TEM = H(1, NX-1, -M) * F(NX-2) + H(2, NX-1, -M) * F(NX-1)         &
     &    + H(3, NX-1, -M) * F(NX)                                      
      IF (M .EQ. 0) THEN 
         G(NX-1) = TEM 
      Else 
         G(NX-1) = TEM * XA(NX-1, M) 
      EndIf 
      DO 10 I = NX-2, 2, -1 
         TEM = TEM + H(1,I,-M)*F(I-1) + H(2,I,-M)*F(I)                  &
     &             + H(3,I,-M)*F(I+1) + H(4,I,-M)*F(I+2)                
         IF (M .EQ. 0) THEN 
            G(I) = TEM 
         Else 
            G(I) = TEM * XA(I, M) 
         EndIf 
   10 END DO 
      TEM = TEM + H(2,1,-M)*F(1) + H(3,1,-M)*F(2) + H(4,1,-M)*F(3) 
      IF (M .EQ. 0) THEN 
         G(1) = TEM 
      Else 
         G(1) = TEM * XA(1, M) 
      EndIf 
      IR = IRR 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhKERNEL                                             &
     &(XX, FF1, FG1, GF1, GG1, PNSP, PNSM, FF2, FG2, GF2, GG2, NFL, IRT)
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (PI = 3.141592653589793d0, PI2 = PI ** 2) 
      PARAMETER (D0 = 0.0, D1 = 1.0) 
      DATA CF, CG, TR, IWRN / 1.33333333333333d0, 3.0d0, 0.5d0, 0 / 
      IRT = 0 
      TRNF = TR * NFL 
      X = XX 
      IF (X .LE. 0. .OR. X .GE. 1.) THEN 
        CALL CtLhWARNR(IWRN, 'X out of range in CtLhKERNEL', 'X', X,    &
     &             D0, D1, 1)                                           
        IRT = 1 
        RETURN 
      EndIf 
      XI = 1./ X 
      X2 = X ** 2 
      XM1I = 1./ (1.- X) 
      XP1I = 1./ (1.+ X) 
      XLN = LOG (X) 
      XLN2 = XLN ** 2 
      XLN1M = LOG (1.- X) 
      SPEN2 = CtLhSPENC2 (X) 
      FFP = (1.+ X2) * XM1I 
      FGP = (2.- 2.* X + X2) / X 
      GFP = 1. - 2.* X + 2.* X2 
      GGP = XM1I + XI - 2. + X - X2 
      FFM = (1.+ X2) * XP1I 
      FGM = - (2.+ 2.* X + X2) / X 
      GFM = 1. + 2.* X + 2.* X2 
      GGM = XP1I - XI - 2. - X - X2 
      FF1 = CF * FFP * (1.- X) 
      FG1 = CF * FGP * X 
      GF1 = 2.* TRNF * GFP 
      GG1 = 2.* CG * GGP * X * (1.-X) 
      PCF2 = -2.* FFP *XLN*XLN1M - (3.*XM1I + 2.*X)*XLN                 &
     &     - (1.+X)/2.*XLN2 - 5.*(1.-X)                                 
      PCFG = FFP * (XLN2 + 11.*XLN/3.+ 67./9.- PI**2 / 3.)              &
     &     + 2.*(1.+X) * XLN + 40.* (1.-X) / 3.                         
      PCFT = (FFP * (- XLN - 5./3.) - 2.*(1.-X)) * 2./ 3. 
      PQQB = 2.* FFM * SPEN2 + 2.*(1.+X)*XLN + 4.*(1.-X) 
      PQQB = (CF**2-CF*CG/2.) * PQQB 
      PQQ2 = CF**2 * PCF2 + CF*CG * PCFG / 2. + CF*TRNF * PCFT 
      PNSP = (PQQ2 + PQQB) * (1.-X) 
      PNSM = (PQQ2 - PQQB) * (1.-X) 
      FFCF2 = - 1. + X + (1.- 3.*X) * XLN / 2. - (1.+ X) * XLN2 / 2.    &
     &      - FFP * (3.* XLN / 2. + 2.* XLN * XLN1M)                    &
     &      + FFM * 2.* SPEN2                                           
      FFCFG = 14./3.* (1.-X)                                            &
     &      + FFP * (11./6.* XLN + XLN2 / 2. + 67./18. - PI2 / 6.)      &
     &      - FFM * SPEN2                                               
      FFCFT = - 16./3. + 40./3.* X + (10.* X + 16./3.* X2 + 2.) * XLN   &
     &                 - 112./9.* X2 + 40./9./X - 2.* (1.+ X) * XLN2    &
     &      - FFP * (10./9. + 2./3. * XLN)                              
      FGCF2 = - 5./2.- 7./2.* X + (2.+ 7./2.* X) * XLN + (X/2.-1.)*XLN2 &
     &               - 2.* X * XLN1M                                    &
     &      - FGP * (3.* XLN1M + XLN1M ** 2)                            
      FGCFG = 28./9. + 65./18.* X + 44./9. * X2 - (12.+ 5.*X + 8./3.*X2)&
     &                      * XLN + (4.+ X) * XLN2 + 2.* X * XLN1M      &
     &      + FGP * (-2.*XLN*XLN1M + XLN2/2. + 11./3.*XLN1M + XLN1M**2  &
     &               - PI2/6. + 0.5)                                    &
     &      + FGM * SPEN2                                               
      FGCFT = -4./3.* X - FGP * (20./9.+ 4./3.*XLN1M) 
      GFCFT = 4.- 9.*X + (-1.+ 4.*X)*XLN + (-1.+ 2.*X)*XLN2 + 4.*XLN1M  &
     &      + GFP * (-4.*XLN*XLN1M + 4.*XLN + 2.*XLN2 - 4.*XLN1M        &
     &               + 2.*XLN1M**2 - 2./3.* PI2 + 10.)                  
      GFCGT = 182./9.+ 14./9.*X + 40./9./X + (136./3.*X - 38./3.)*XLN   &
     &               - 4.*XLN1M - (2.+ 8.*X)*XLN2                       &
     &      + GFP * (-XLN2 + 44./3.*XLN - 2.*XLN1M**2 + 4.*XLN1M        &
     &               + PI2/3. - 218./9.)                                &
     &      + GFM * 2. * SPEN2                                          
      GGCFT = -16.+ 8.*X + 20./3.*X2 + 4./3./X + (-6.-10.*X)*XLN        &
     &        - 2.* (1.+ X) * XLN2                                      
      GGCGT = 2.- 2.*X + 26./9.*X2 - 26./9./X - 4./3.*(1.+X)*XLN        &
     &      - GGP * 20./9.                                              
      GGCG2 = 27./2.*(1.-X) + 67./9.*(X2-XI) + 4.*(1.+X)*XLN2           &
     &              + (-25.+ 11.*X - 44.*X2)/3.*XLN                     &
     &      + GGP * (67./9.- 4.*XLN*XLN1M + XLN2 - PI2/3.)              &
     &      + GGM * 2.* SPEN2                                           
      FF2 = CF * TRNF * FFCFT + CF ** 2 * FFCF2 + CF * CG   * FFCFG 
      FG2 = CF * TRNF * FGCFT + CF ** 2 * FGCF2 + CF * CG   * FGCFG 
      GF2 = CF * TRNF * GFCFT                   + CG * TRNF * GFCGT 
      GG2 = CF * TRNF * GGCFT + CG ** 2 * GGCG2 + CG * TRNF * GGCGT 
      XLG = (LOG(1./(1.-X)) + 1.) 
      XG2 = XLG ** 2 
      FF2 = FF2 * X * (1.- X) 
      FG2 = FG2 * X / XG2 
      GF2 = GF2 * X / XG2 
      GG2 = GG2 * X * (1.- X) 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhLAMCWZ 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      LOGICAL SET 
      CALL CtLhSETL1 (NF, AL) 
      END                                           


      FUNCTION LhCtNAMQCD(NNAME) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      CHARACTER NNAME*(*), NAME*8 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      LOGICAL SET 
      CHARACTER ONECH*(1) 
      ONECH = '0' 
      IASC0 = ICHAR(ONECH) 
      NAME = NNAME 
      LhCtNAMQCD=0 
      IF ( (NAME .EQ. 'ALAM') .OR. (NAME .EQ. 'LAMB') .OR.              &
     &        (NAME .EQ. 'LAM') .OR. (NAME .EQ. 'LAMBDA') )             &
     &             LhCtNAMQCD=1                                         
      IF ( (NAME .EQ. 'NFL') .OR. (NAME(1:3) .EQ. '#FL') .OR.           &
     &        (NAME .EQ. '# FL') )                                      &
     &             LhCtNAMQCD=2                                         
      DO 10 I=1, 9 
         IF (NAME .EQ. 'M'//CHAR(I+IASC0))                              &
     &             LhCtNAMQCD=I+2                                       
   10    CONTINUE 
      DO 20 I= 0, NF 
         IF (NAME .EQ. 'LAM'//CHAR(I+IASC0))                            &
     &             LhCtNAMQCD=I+13                                      
   20    CONTINUE 
      IF (NAME(:3).EQ.'ORD' .OR. NAME(:3).EQ.'NRD') LhCtNAMQCD = 24 
      RETURN 
      END     

                                      
      FUNCTION LhCtNFL(AMU) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      LOGICAL SET 
      IF (.NOT. SET) CALL CtLhLAMCWZ 
      LhCtNFL = NF - NHQ 
      IF ((LhCtNFL .EQ. NF) .OR. (AMU .LE. AMN)) GOTO 20 
      DO 10 I = NF - NHQ + 1, NF 
         IF (AMU .GE. AMHAT(I)) THEN 
            LhCtNFL = I 
         ELSE 
            GOTO 20 
         ENDIF 
   10    CONTINUE 
   20 RETURN 
      END       

                                    
      SUBROUTINE CtLhNSEVL (RHS, IKNL,NX,NT,JT,DT,TIN,NEFF,U0,UN) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPN = MXF * 2 + 2) 
      PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      DIMENSION  U0(NX), UN(0:NX, 0:NT) 
      DIMENSION  Y0(MXX), Y1(MXX), YP(MXX), F0(MXX), F1(MXX), FP(MXX) 
      external rhs 
      DDT = DT / JT 
      IF (NX .GT. MXX) THEN 
      WRITE (*,*) 'Nx =', NX, ' greater than Max pts in CtLhNSEVL.' 
      STOP 'Program stopped in CtLhNSEVL' 
      EndIf 
! ++ remove unused quantities (jcp)                                     
! ++  TMD = TIN + DT * NT / 2.                                          
! ++  AMU = EXP(TMD)                                                    
! ++  TEM = 6./ (33.- 2.* NEFF) / CtLhALPI(AMU)                         
! ++  TLAM = TMD - TEM                                                  
      DO 9 IX = 1, NX 
      UN(IX, 0)  = U0(IX) 
    9 END DO 
      UN(0, 0) = 3D0*U0(1) - 3D0*U0(2) - U0(1) 
      TT = TIN 
      DO 10 IZ = 1, NX 
      Y0(IZ)   = U0(IZ) 
   10 END DO 
      DO 20 IS = 1, NT 
         DO 202 JS = 1, JT 
            IRND = (IS-1) * JT + JS 
            IF (IRND .EQ. 1) THEN 
                CALL RHS (TT, Neff, Y0, F0) 
                DO 250 IZ = 1, NX 
                   Y0(IZ) = Y0(IZ) + DDT * F0(IZ) 
  250           CONTINUE 
                TT = TT + DDT 
                CALL RHS (TT, NEFF, Y0, F1) 
                DO 251 IZ = 1, NX 
                   Y1(IZ) = U0(IZ) + DDT * (F0(IZ) + F1(IZ)) / 2D0 
  251           CONTINUE 
            Else 
                CALL RHS (TT, NEFF, Y1, F1) 
                DO 252 IZ = 1, NX 
                   YP(IZ) = Y1(IZ) + DDT * (3D0 * F1(IZ) - F0(IZ)) / 2D0 
  252           CONTINUE 
                TT = TT + DDT 
                CALL RHS (TT, NEFF, YP, FP) 
                DO 253 IZ = 1, NX 
                   Y1(IZ) = Y1(IZ) + DDT * (FP(IZ) + F1(IZ)) / 2D0 
                   F0(IZ) = F1(IZ) 
  253           CONTINUE 
            EndIf 
  202    CONTINUE 
         DO 260 IZ = 1, NX 
            UN (IZ, IS) = Y1(IZ) 
  260    CONTINUE 
         UN(0, IS) = 3D0*Y1(1) - 3D0*Y1(2) + Y1(3) 
   20 END DO 
      RETURN 
      END       

                                    
      SUBROUTINE LhCtNSRHSM (TT, NEFF, FI, FO) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LSTX 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtXYARAY / ZZ(MXX, MXX), ZV(0:MXX) 
      COMMON / LhCtKRNL01 / AFF2(MXX),AFG2(MXX),AGF2(MXX),AGG2(MXX),    &
     &                  ANSP (MXX), ANSM (MXX), ZFG2, ZGF2, ZQQB        
      COMMON / LhCtKRN2ND / FFG(MXX, MXX), GGF(MXX, MXX), PNS(MXX, MXX) 
      COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx 
      DIMENSION G1(MXX), FI(NX), FO(NX) 
      DIMENSION W0(MXX), W1(MXX), WH(MXX) 
      S = EXP(TT) 
      Q = AL * EXP (S) 
      CPL = CtLhALPI(Q) 
      CPL2= CPL ** 2 / 2. * S 
      CPL = CPL * S 
      CALL CtLhINTEGR (NX, 0, FI, W0, IR1) 
      CALL CtLhINTEGR (NX, 1, FI, W1, IR2) 
      CALL CtLhHINTEG (NX,    FI, WH) 
      DO 230 IZ = 1, NX 
      FO(IZ) = 2.* FI(IZ) + 4./3.* ( 2.* WH(IZ) - W0(IZ) - W1(IZ)) 
      FO(IZ) = CPL * FO(IZ) 
  230 END DO 
      IF (IKNL .EQ. 2) THEN 
      DZ = 1./ (NX - 1) 
      DO 21 IX = 1, NX-1 
        NP = NX - IX + 1 
        IS = NP 
        DO 31 KZ = 2, NP 
          IY = IX + KZ - 1 
          IT = NX - IY + 1 
          XY = ZZ (IS, IT) 
          G1(KZ) = PNS (IS,IT) * (FI(IY) - XY * FI(IX)) 
   31   CONTINUE 
        TEM1 = CtLhSMPNOL (NP, DZ, G1, ERR) 
        TMP2 = (TEM1 - FI(IX) * ANSM(IX)) * CPL2 
        FO(IX) = FO(IX) + TMP2 
   21 END DO 
      EndIf 
      RETURN 
      END       

                                    
      SUBROUTINE LhCtNSRHSP (TT, NEFF, FI, FO) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LSTX 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtXYARAY / ZZ(MXX, MXX), ZV(0:MXX) 
      COMMON / LhCtKRNL01 / AFF2(MXX),AFG2(MXX),AGF2(MXX),AGG2(MXX),    &
     &                  ANSP (MXX), ANSM (MXX), ZFG2, ZGF2, ZQQB        
      COMMON / LhCtKRN2ND / FFG(MXX, MXX), GGF(MXX, MXX), PNS(MXX, MXX) 
      COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx 
      DIMENSION G1(MXX), FI(NX), FO(NX) 
      DIMENSION W0(MXX), W1(MXX), WH(MXX) 
      S = EXP(TT) 
      Q = AL * EXP (S) 
      CPL = CtLhALPI(Q) 
      CPL2= CPL ** 2 / 2. * S 
      CPL = CPL * S 
      CALL CtLhINTEGR (NX, 0, FI, W0, IR1) 
      CALL CtLhINTEGR (NX, 1, FI, W1, IR2) 
      CALL CtLhHINTEG (NX,    FI, WH) 
      DO 230 IZ = 1, NX 
      FO(IZ) = 2.* FI(IZ) + 4./3.* ( 2.* WH(IZ) - W0(IZ) - W1(IZ)) 
      FO(IZ) = CPL * FO(IZ) 
  230 END DO 
      IF (IKNL .EQ. 2) THEN 
      DZ = 1./ (NX - 1) 
      DO 21 IX = 1, NX-1 
        NP = NX - IX + 1 
        DO 31 KZ = 2, NP 
          IY = IX + KZ - 1 
          XY = ZZ (NX-IX+1, NX-IY+1) 
          G1(KZ) = PNS (IX,IY) * (FI(IY) - XY * FI(IX)) 
   31   CONTINUE 
        TEM1 = CtLhSMPNOL (NP, DZ, G1, ERR) 
        TMP2 = (TEM1 + FI(IX) * (-ANSP(IX) + ZQQB)) * CPL2 
        FO(IX) = FO(IX) + TMP2 
   21 END DO 
      EndIf 
      RETURN 
      END     

                                      
      FUNCTION CtLhPARDIS (IPRTN, XX, QQ) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      include 'parmsetup.inc' 
      Character Msg*80 
      LOGICAL LSTX 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPN = MXF * 2 + 2) 
      PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      PARAMETER (Smll = 1D-9) 
        parameter(nqvec = 4) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtXYARAY / ZZ(MXX, MXX), ZV(0:MXX) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtQARAY1 / QINI,QMAX, QV(0:MXQ),TV(0:MXQ), NT,JT,NG 
      COMMON / LhCtQARAY2 / TLN(MXF), DTN(MXF), NTL(MXF), NTN(MXF) 
      COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx 
      COMMON / LhCtPEVLDT / UPD(MXPQX,nmxset), KF, Nelmt 
      COMMON / LhCtCOMQMS / VALQMS(9) 
      dimension fvec(4), fij(4) 
      dimension xvpow(0:mxx) 
      Data Iwrn1, Iwrn2, Iwrn3, OneP / 3*0, 1.00001 / 
                                 !**** choice of interpolation variable 
      data xpow / 0.3d0 / 
      data nxsave / 0 / 
        save xvpow, nxsave 
         save xlast, qlast 
         save jq, jx, JLx, JLq, ss, sy2, sy3, s23, ty2, ty3 
         save const1 , const2, const3, const4, const5, const6 
         save tt, t13, t12, t23, t34 , t24, tmp1, tmp2, tdet 
!                                                                       
      call getnset(iset) 
!                                                                       
      if(nx .ne. nxsave) then 
         xvpow(0) = 0D0 
         do i = 1, nx 
            xvpow(i) = xv(i)**xpow 
         enddo 
        nxsave = nx 
      endif 
                                                                        
      X = XX 
      Q = QQ 
                                                                        
!      if((x.lt.xmin).or.(x.gt.1.d0)) print 98,x                        
!  98  format(' WARNING:  X=',e12.5,' OUT OF RANGE')                    
!      if((q.lt.qini).or.(q.gt.qmax)) print 99,q                        
!  99  format(' WARNING:  Q=',e12.5,' OUT OF RANGE')                    
                                                                        
! enforce threshold early to improve speed...                           
        ii = iabs(IPRTN) 
        if(ii .ne. 0) then 
           if(QQ .lt. VALQMS(ii) ) then 
              ctlhpardis = 0.d0 
              return 
           endif 
        endif 
                                                                        
! force pardis = 0.0d0 at exactly =1.0d0 - added mrw 10/May/06          
        if(xx .eq. 1.0d0) then 
          ctlhpardis = 0.0d0 
          return 
        endif 
                                                                        
! skip the initialization in x if same as in the previous call.         
        if(x .eq. xlast) goto 100 
        xlast = x 
                                                                        
      JLx = -1 
      JU = Nx+1 
   11 If (JU-JLx .GT. 1) Then 
         JM = (JU+JLx) / 2 
         If (X .Ge. XV(JM)) Then 
            JLx = JM 
         Else 
            JU = JM 
         Endif 
         Goto 11 
      Endif 
      If     (JLx .LE. -1) Then 
        Print '(A,1pE12.4)','Severe error: x <= 0 in ParDis x=', x 
        Stop 
      ElseIf (JLx .Eq. 0) Then 
         Jx = 0 
         Msg = '0 < X < Xmin in ParDis; extrapolation used!' 
         CALL CtLhWARNR (IWRN1, Msg, 'X', X, Xmin, 1D0, 1) 
      Elseif (JLx .LE. Nx-2) Then 
         Jx = JLx - 1 
      Elseif (JLx.Eq.Nx-1 .or. x.LT.OneP) Then 
         Jx = JLx - 2 
      Else 
        Print '(A,1pE12.4)','Severe error: x > 1 in ParDis x=', x 
        Stop 
      Endif 
      ss = x**xpow 
      If (JLx.Ge.2 .and. JLx.Le.Nx-2) Then 
      svec1 = xvpow(jx) 
      svec2 = xvpow(jx+1) 
      svec3 = xvpow(jx+2) 
      svec4 = xvpow(jx+3) 
      s12 = svec1 - svec2 
      s13 = svec1 - svec3 
      s23 = svec2 - svec3 
      s24 = svec2 - svec4 
      s34 = svec3 - svec4 
      sy2 = ss - svec2 
      sy3 = ss - svec3 
      const1 = s13/s23 
      const2 = s12/s23 
      const3 = s34/s23 
      const4 = s24/s23 
      s1213 = s12 + s13 
      s2434 = s24 + s34 
      sdet = s12*s34 - s1213*s2434 
      tmp = sy2*sy3/sdet 
      const5 = (s34*sy2-s2434*sy3)*tmp/s12 
      const6 = (s1213*sy2-s12*sy3)*tmp/s34 
      EndIf 
                                                                        
  100      continue 
                                                                        
! skip the initialization in q if same as in the previous call.         
        if(q .eq. qlast) goto 110 
        qlast = q 
                                                                        
      tt = log(log(Q/Al)) 
                                                                        
      JLq = -1 
      JU = NT+1 
   12 If (JU-JLq .GT. 1) Then 
         JM = (JU+JLq) / 2 
         If (Q .GE. QV(JM)) Then 
            JLq = JM 
         Else 
            JU = JM 
         Endif 
         Goto 12 
       Endif 
      If     (JLq .LE. 0) Then 
         Jq = 0 
         If (JLq .LT. 0) Then 
          Msg = 'Q < Q0 in ParDis; extrapolation used!' 
          CALL CtLhWARNR (IWRN2, Msg, 'Q', Q, Qini, 1D0, 1) 
         EndIf 
      Elseif (JLq .LE. Nt-2) Then 
         Jq = JLq - 1 
      Else 
        Jq = Nt - 3 
        If (JLq .GE. Nt) Then 
         Msg = 'Q > Qmax in ParDis; extrapolation used!' 
         CALL CtLhWARNR (IWRN3, Msg, 'Q', Q, Qmax, 1D0, 1) 
        Endif 
      Endif 
                                                                        
      If (JLq.GE.1 .and. JLq.LE.Nt-2) Then 
      tvec1 = Tv(jq) 
      tvec2 = Tv(jq+1) 
      tvec3 = Tv(jq+2) 
      tvec4 = Tv(jq+3) 
      t12 = tvec1 - tvec2 
      t13 = tvec1 - tvec3 
      t23 = tvec2 - tvec3 
      t24 = tvec2 - tvec4 
      t34 = tvec3 - tvec4 
      ty2 = tt - tvec2 
      ty3 = tt - tvec3 
      tmp1 = t12 + t13 
      tmp2 = t24 + t34 
      tdet = t12*t34 - tmp1*tmp2 
      EndIf 
                                                                        
  110      continue 
                                                                        
      jtmp = ((IPRTN + NfMx)*(NT+1)+(jq-1))*(NX+1)+jx+1 
      Do it = 1, nqvec 
         J1  = jtmp + it*(NX+1) 
       If (Jx .Eq. 0) Then 
         fij(1) = 0 
         fij(2) = Upd(J1+1,iset) * Xa(1,2) 
         fij(3) = Upd(J1+2,iset) * Xa(2,2) 
         fij(4) = Upd(J1+3,iset) * Xa(3,2) 
         Call CtLhPolint4 (XVpow(0), Fij(1), 4, ss, Fx, Dfx) 
                                                                        
         If (x .GT. 0D0)  Fvec(it) =  Fx / x**2 
       ElseIf  (JLx .Eq. Nx-1) Then 
        Call CtLhPolint4 (XVpow(Nx-3), Upd(J1,iset), 4, ss, Fx, Dfx) 
        Fvec(it) = Fx 
       Else 
         sf2 = Upd(J1+1,iset) 
         sf3 = Upd(J1+2,iset) 
         Fvec(it) = (const5*(Upd(J1,iset)                               &
     &                             - sf2*const1 + sf3*const2)           &
     &               + const6*(Upd(J1+3,iset)                           &
     &                             + sf2*const3 - sf3*const4)           &
     &               + sf2*sy3 - sf3*sy2) / s23                         
       Endif 
      enddo 
      If (JLq .LE. 0) Then 
        Call CtLhPolint4 (TV(0), Fvec(1), 4, tt, ff, Dfq) 
      ElseIf (JLq .GE. Nt-1) Then 
        Call CtLhPolint4 (TV(Nt-3), Fvec(1), 4, tt, ff, Dfq) 
      Else 
        tf2 = fvec(2) 
        tf3 = fvec(3) 
        g1 = ( tf2*t13 - tf3*t12) / t23 
        g4 = (-tf2*t34 + tf3*t24) / t23 
        h00 = ((t34*ty2-tmp2*ty3)*(fvec(1)-g1)/t12                      &
     &          +  (tmp1*ty2-t12*ty3)*(fvec(4)-g4)/t34)                 
        ff = (h00*ty2*ty3/tdet + tf2*ty3 - tf3*ty2) / t23 
      EndIf 
      CtLhPARDIS = ff 
      Return 
      END                                           
                
                                                        
      SUBROUTINE CtLhPARPDF (IACT, NAME, VALUE, IRET) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      CHARACTER NAME*(*), Uname*10 
      LOGICAL START1 
      DATA ILEVEL, LRET / 1, 1 / 
      JRET = IRET 
      CALL CtLhUPC (NAME, Ln, Uname) 
      IF (IACT .EQ. 0 .OR. IACT .EQ. 4) then 
!     >    IVALUE = NINT (VALUE)   !tentatively remove this since it see
       print *,'Fatal error: iact=',iact 
       stop 
      ENDIF 
      START1 = (IACT .NE. 1) .AND. (IACT .NE. 2) 
! prepare to remove this stuff, since I think IACT=1 or 2 always        
      if(start1) then 
        print *,'Fatal error: start1=',start1 
        stop 
      endif 
      IF (START1)  ILEVEL = 1 
      GOTO (1, 2), ILEVEL 
    1 START1 = .TRUE. 
      ILEVEL = 0 
      CALL CtLhParQcd (IACT, Uname(1:Ln), VALUE, JRET) 
              IF (JRET .EQ. 1)  GOTO 11 
              IF (JRET .EQ. 2)  GOTO 12 
              IF (JRET .EQ. 3)  GOTO 13 
              IF (JRET .GT. 4)  GOTO 15 
              ILEVEL =  ILEVEL + 1 
    2 CALL CtLhEVLPAR (IACT, Uname(1:Ln), VALUE, JRET) 
              IF (JRET .EQ. 1)  GOTO 11 
              IF (JRET .EQ. 2)  GOTO 12 
              IF (JRET .EQ. 3)  GOTO 13 
              IF (JRET .GT. 4)  GOTO 15 
              ILEVEL =  ILEVEL + 1 
      IF (.NOT. START1) GOTO 1 
      IF (JRET .EQ. 0)  GOTO 10 
      GOTO 14 
   10 CONTINUE 
   11 CONTINUE 
   12 CONTINUE 
   13 CONTINUE 
   14 CONTINUE 
   15 CONTINUE 
      IF (JRET .NE. 4) LRET = JRET 
      IF (LRET.EQ.0 .OR. LRET.EQ.2 .OR. LRET.EQ.3) THEN 
        PRINT *, 'Error in CtLhPARPDF: IRET, IACT, NAME, VALUE =',      &
     &  LRET, IACT, NAME, VALUE                                         
        PRINT *, 'fatal error in CtLhparpdf' 
        stop 
      EndIf 
      IRET= JRET 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhParQcd(IACT,NAME,VALUE,IRET) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      INTEGER IACT,IRET 
      CHARACTER*(*) NAME 
      IRET=1 
      IF (IACT.EQ.0) THEN 
         WRITE (NINT(VALUE), *)  'LAM(BDA), NFL, ORD(ER), Mi, ',        &
     &               '(i in 1 to 9), LAMi (i in 1 to NFL)'              
         IRET=4 
      ELSEIF (IACT.EQ.1) THEN 
         CALL CtLhQCDSET (NAME,VALUE,IRET) 
      ELSEIF (IACT.EQ.2) THEN 
         CALL CtLhQCDGET (NAME,VALUE,IRET) 
      ELSE 
         IRET=3 
      ENDIF 
      RETURN 
      END     

                                      
      FUNCTION CtLhPFF1 (XX) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LA, LB, LSTX 
      PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      PARAMETER (MX = 3) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtKRNL00 / DZ, XL(MX), NNX 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtKRN1ST / FF1(0:MXX),FG1(0:MXX),GF1(0:MXX),GG1(0:MXX),&
     &                  FF2(0:MXX), FG2(0:MXX), GF2(0:MXX), GG2(0:MXX), &
     &                  PNSP(0:MXX), PNSM(0:MXX)                        
      SAVE 
      DATA LA, LB / 2 * .FALSE. / 
      LB = .TRUE. 
      ENTRY CtLhTFF1(ZZ) 
      LA = .TRUE. 
      IF (LA .AND. .NOT.LB) THEN 
        Z = ZZ 
        X = CtLhXFRMZ (Z) 
      Else 
        X = XX 
      EndIf 
      IF (X .GE. D1) THEN 
        CtLhPFF1 = 0 
        RETURN 
      ElseIF (X .GE. XMIN) THEN 
        Z = CtLhZFRMX (X) 
        TEM = CtLhFINTRP (FF1,  -DZ, DZ, NX,  Z,  ERR, IRT) 
      Else 
        CALL CtLhPOLIN1 (XL, FF1(1), MX, X, TEM, ERR) 
      EndIf 
      IF (LA) THEN 
         IF (LB) THEN 
            CtLhPFF1 = TEM / (1.-X) 
            LB   =.FALSE. 
         Else 
            CtLhTFF1 = TEM / (1.-X) * CtLhDXDZ(Z) 
         EndIf 
         LA   =.FALSE. 
      Else 
         IF (LB) THEN 
! +++ something is wrong, since QFF1 and RFF1 are not used.             
! +++ but this code appears to only be used for extrapolation           
! +++ to small x, which is unreliable anyway, so ignore for now (jcp)   
            QFF1 = TEM 
            LB   =.FALSE. 
         Else 
            RFF1 = TEM * X / (1.-X) 
         EndIf 
      EndIf 
      RETURN 
      ENTRY CtLhFNSP (XX) 
      X = XX 
      IF (X .GE. D1) THEN 
        CtLhFNSP = 0. 
        RETURN 
      ElseIF (X .GE. XMIN) THEN 
        Z = CtLhZFRMX (X) 
        TEM = CtLhFINTRP (PNSP,  -DZ, DZ, NX,  Z,  ERR, IRT) 
      Else 
        CALL CtLhPOLIN1 (XL, PNSP(1), MX, X, TEM, ERR) 
      EndIf 
      CtLhFNSP = TEM / (1.- X) 
      RETURN 
      ENTRY CtLhFNSM (XX) 
      X = XX 
      IF (X .GE. D1) THEN 
        CtLhFNSM = 0. 
        RETURN 
      ElseIF (X .GE. XMIN) THEN 
        Z = CtLhZFRMX (X) 
        TEM = CtLhFINTRP (PNSM,  -DZ, DZ, NX,  Z,  ERR, IRT) 
      Else 
        CALL CtLhPOLIN1 (XL, PNSM(1), MX, X, TEM, ERR) 
      EndIf 
      CtLhFNSM = TEM / (1.- X) 
      RETURN 
      ENTRY CtLhRGG1 (XX) 
      X = XX 
      IF (X .GE. D1) THEN 
                                   !error corrected? (jcp)              
        CtLhRGG1= 0 
        RETURN 
      ElseIF (X .GE. XMIN) THEN 
        Z = CtLhZFRMX (X) 
        TEM = CtLhFINTRP (GG1,  -DZ, DZ, NX,  Z,  ERR, IRT) 
      Else 
        CALL CtLhPOLIN1 (XL, GG1(1), MX, X, TEM, ERR) 
      EndIf 
      IF (LA) THEN 
                                            !error corrected? (jcp)     
         CtLhRGG1 = TEM / X / (1.-X) 
         LA   =.FALSE. 
      Else 
         IF (LB) THEN 
                                              !error corrected? (jcp)   
            CtLhRGG1 = TEM / X 
            LB   =.FALSE. 
         Else 
            CtLhRGG1 = TEM / (1.-X) 
         EndIf 
      EndIf 
      RETURN 
      ENTRY CtLhRFF2 (XX) 
      X = XX 
      IF (X .GE. D1) THEN 
                                    !error corrected? (jcp)             
        CtLhRFF2 = 0 
        RETURN 
      ElseIF (X .GE. XMIN) THEN 
        Z = CtLhZFRMX (X) 
        TEM = CtLhFINTRP (FF2,  -DZ, DZ, NX,  Z,  ERR, IRT) 
      Else 
        CALL CtLhPOLIN1 (XL, FF2(1), MX, X, TEM, ERR) 
      EndIf 
      IF (LA) THEN 
                                            !error corrected? (jcp)     
         CtLhRFF2 = TEM / X / (1.-X) 
         LA   =.FALSE. 
      Else 
         IF (LB) THEN 
                                              !error corrected? (jcp)   
            CtLhRFF2 = TEM / X 
            LB   =.FALSE. 
         Else 
            CtLhRFF2 = TEM / (1.-X) 
         EndIf 
      EndIf 
      RETURN 
      ENTRY CtLhRGG2 (XX) 
      X = XX 
      IF (X .GE. D1) THEN 
                                    !error corrected? (jcp)             
        CtLhRGG2 = 0 
        RETURN 
      ElseIF (X .GE. XMIN) THEN 
        Z = CtLhZFRMX (X) 
        TEM = CtLhFINTRP (GG2,  -DZ, DZ, NX,  Z,  ERR, IRT) 
      Else 
        CALL CtLhPOLIN1 (XL, GG2(1), MX, X, TEM, ERR) 
      EndIf 
      IF (LA) THEN 
                                            !error corrected? (jcp)     
         CtLhRGG2 = TEM / X / (1.-X) 
         LA   =.FALSE. 
      Else 
         IF (LB) THEN 
                                      !error corrected? (jcp)           
            CtLhRGG2 = TEM / X 
            LB   =.FALSE. 
         Else 
            CtLhRGG2 = TEM / (1.-X) 
         EndIf 
      EndIf 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhPOLIN1 (XA,YA,N,X,Y,DY) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (NMAX=10) 
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX) 
      NS=1 
      DIF=ABS(X-XA(1)) 
      DO 11 I=1,N 
        DIFT=ABS(X-XA(I)) 
        IF (DIFT.LT.DIF) THEN 
          NS=I 
          DIF=DIFT 
        ENDIF 
        C(I)=YA(I) 
        D(I)=YA(I) 
   11 END DO 
      Y=YA(NS) 
      NS=NS-1 
      DO 13 M=1,N-1 
        DO 12 I=1,N-M 
          HO=XA(I)-X 
          HP=XA(I+M)-X 
          W=C(I+1)-D(I) 
          DEN=HO-HP 
          DEN=W/DEN 
          D(I)=HP*DEN 
          C(I)=HO*DEN 
   12   CONTINUE 
        IF (2*NS.LT.N-M)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
   13 END DO 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhQARRAY (NINI) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPN = MXF * 2 + 2) 
      PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
      COMMON / LhCtQARAY1 / QINI,QMAX, QV(0:MXQ),TV(0:MXQ), NT,JT,NG 
      COMMON / LhCtQARAY2 / TLN(MXF), DTN(MXF), NTL(MXF), NTN(MXF) 
      COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx 
      NCNT = 0 
      IF (NT .GE. mxq) NT = mxq - 1 
      S = LOG(QINI/AL) 
      TINI = LOG(S) 
      S = LOG(QMAX/AL) 
      TMAX = LOG(S) 
    1 DT0 = (TMAX - TINI) / float(NT) 
      NINI = LhCtNFL(QINI) 
      NFMX = LhCtNFL(QMAX) 
      Call CtLhParQcd (2, 'ORDER', Ord, Ir) 
      Call CtLhParQcd (2, 'ALAM', Al0, Ir) 
      Call CtLhParQcd (2, 'NFL', Afl0, Ir) 
      AFL = NfMx 
      Call CtLhParQcd (1, 'NFL', AFL, Ir) 
      Iordr = Nint (Ord) 
      Ifl0  = Nint (Afl0) 
      Call CtLhSetLam (Ifl0, Al0, Iordr) 
      NG = NFMX - NINI + 1 
      QIN  = QINI 
      QOUT = QINI 
      S = LOG(QIN/AL) 
      TIN  = LOG(S) 
      TLN(1) = TIN 
      NTL(1)  = 0 
      QV(0) = QINI 
      TV(0) = Tin 
      DO 20 NEFF = NINI, NFMX 
        ICNT = NEFF - NINI + 1 
        IF (NEFF .LT. NFMX) THEN 
          THRN = CtLhAMHATF (NEFF + 1) 
          QOUN = MIN (QMAX, THRN) 
        Else 
          QOUN = QMAX 
        EndIf 
        IF (QOUN-QOUT .LE. 0.0001) THEN 
          DT   = 0 
          NITR = 0 
        Else 
          QOUT = QOUN 
          S = LOG(QOUT/AL) 
          TOUT = LOG(S) 
          TEM = TOUT - TIN 
          NITR = INT (TEM / DT0) + 1 
          DT  = TEM / NITR 
        EndIf 
        DTN (ICNT) = DT 
        NTN (ICNT) = NITR 
        TLN (ICNT) = TIN 
        NTL (ICNT+1) = NTL(ICNT) + NITR 
        IF (NITR .NE. 0) THEN 
        DO 205 I = 1, NITR 
           TV (NTL(ICNT)+I) = TIN + DT * I 
           S = EXP (TV(NTL(ICNT)+I)) 
           QV (NTL(ICNT)+I) = AL * EXP (S) 
  205   CONTINUE 
        EndIf 
        QIN = QOUT 
        TIN = TOUT 
   20 END DO 
      NCNT = NCNT + 1 
      NTP = NTL (NG + 1) 
      ND  = NTP - NT 
      IF (NTP .GE. MXQ) THEN 
         NT = MXQ - ND - NCNT 
         GOTO 1 
      EndIf 
      NT = NTP 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhQCDGET(NAME,VALUE,IRET) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      CHARACTER*(*) NAME 
      COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      COMMON / LhCtCOMQMS / VALQMS(9) 
      LOGICAL SET 
      PARAMETER (PI=3.141592653589793d0, EULER=0.57721566) 
      ICODE = LhCtNAMQCD(NAME) 
      IRET = 1 
      IF (ICODE .EQ. 1) THEN 
         VALUE = AL 
      ELSEIF (ICODE .EQ. 2) THEN 
         VALUE = NF 
      ELSEIF ((ICODE .GE. 3) .AND. (ICODE .LE. 12))  THEN 
         VALUE = VALQMS(ICODE - 2) 
      ELSEIF ((ICODE .GE. 13) .AND. (ICODE .LE. 13+NF))  THEN 
         VALUE = ALAM(ICODE - 13) 
      ELSEIF (ICODE .EQ. 24) THEN 
         VALUE = NORDER 
      ELSE 
         IRET=0 
      ENDIF 
      END       

                                    
      SUBROUTINE CtLhQCDSET (NAME,VALUE,IRET) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      CHARACTER*(*) NAME 
      COMMON / LhCtCOMQMS / VALQMS(9) 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      LOGICAL SET 
      PARAMETER (PI=3.141592653589793d0, EULER=0.57721566) 
      IVALUE = NINT(VALUE) 
      ICODE  = LhCtNAMQCD(NAME) 
      IF (ICODE .EQ. 0) THEN 
         IRET=0 
!     print *,'warning empty CtLhQCDSET call: NAME=',                   
!     &                 NAME,' VALUE=',VALUE                            
      ELSE 
         IRET = 1 
         SET = .FALSE. 
         IF (ICODE .EQ. 1) THEN 
            IF (VALUE.LE.0) GOTO 12 
            AL=VALUE 
         ELSEIF (ICODE .EQ. 2) THEN 
            IF ( (IVALUE .LT. 0) .OR. (IVALUE .GT. 9)) GOTO 12 
            NF = IVALUE 
         ELSEIF ((ICODE .GE. 3) .AND. (ICODE .LE. 11))  THEN 
            IF (VALUE .LT. 0) GOTO 12 
            Scle = Min (Value , VALQMS(ICODE - 2)) 
            AlfScle = CtLhALPI(Scle) * Pi 
            VALQMS(ICODE - 2) = VALUE 
            Call CtLhAlfSet (Scle, AlfScle) 
         ELSEIF ((ICODE .GE. 13) .AND. (ICODE .LE. 13+NF))  THEN 
            IF (VALUE .LE. 0) GOTO 12 
            CALL CtLhSETL1 (ICODE-13, VALUE) 
         ELSEIF (ICODE .EQ. 24)  THEN 
            IF ((IVALUE .LT. 1) .OR. (IVALUE .GT. 2)) GOTO 12 
            NORDER = IVALUE 
         ENDIF 
         IF (.NOT. SET) CALL CtLhLAMCWZ 
      ENDIF 
      RETURN 
   12 IRET=2 
      RETURN 
      END     

                                      
      FUNCTION CtLhQZBRNT(FUNC, X1, X2, TOLIN, IRT) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (ITMAX = 1000, EPS = 3.E-12) 
      external func 
      TOL = ABS(TOLIN) 
      A=X1 
      B=X2 
      FA=FUNC(A) 
      FB=FUNC(B) 
      IF(FB*FA.GT.0.)  THEN 
        WRITE (*, *) 'Root must be bracketed for CtLhQZBRNT.' 
        IRT = 1 
      ENDIF 
      FC=FB 
      DO 11 ITER=1,ITMAX 
        IF(FB*FC.GT.0.) THEN 
          C=A 
          FC=FA 
          D=B-A 
          E=D 
        ENDIF 
        IF(ABS(FC).LT.ABS(FB)) THEN 
          A=B 
          B=C 
          C=A 
          FA=FB 
          FB=FC 
          FC=FA 
        ENDIF 
        TOL1=2.*EPS*ABS(B)+0.5*TOL 
        XM=.5*(C-B) 
        IF(ABS(XM).LE.TOL1 .OR. FB.EQ.0.)THEN 
          CtLhQZBRNT=B 
          RETURN 
        ENDIF 
        IF(ABS(E).GE.TOL1 .AND. ABS(FA).GT.ABS(FB)) THEN 
          S=FB/FA 
          IF(A.EQ.C) THEN 
            P=2.*XM*S 
            Q=1.-S 
          ELSE 
            Q=FA/FC 
            R=FB/FC 
            P=S*(2.*XM*Q*(Q-R)-(B-A)*(R-1.)) 
            Q=(Q-1.)*(R-1.)*(S-1.) 
          ENDIF 
          IF(P.GT.0.) Q=-Q 
          P=ABS(P) 
          IF(2.*P .LT. MIN(3.*XM*Q-ABS(TOL1*Q),ABS(E*Q))) THEN 
            E=D 
            D=P/Q 
          ELSE 
            D=XM 
            E=D 
          ENDIF 
        ELSE 
          D=XM 
          E=D 
        ENDIF 
        A=B 
        FA=FB 
        IF(ABS(D) .GT. TOL1) THEN 
          B=B+D 
        ELSE 
          B=B+SIGN(TOL1,XM) 
        ENDIF 
        FB=FUNC(B) 
   11 END DO 
      WRITE (*, *) 'CtLhQZBRNT exceeding maximum iterations.' 
      IRT = 2 
      CtLhQZBRNT=B 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhRATINT(XA,YA,N,X,Y,DY) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (NMAX=10,TINY=1.E-25) 
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX) 
      NS=1 
      HH=ABS(X-XA(1)) 
      DO 11 I=1,N 
        H=ABS(X-XA(I)) 
        IF (H.EQ.0.)THEN 
          Y=YA(I) 
          DY=0.0 
          RETURN 
        ELSE IF (H.LT.HH) THEN 
          NS=I 
          HH=H 
        ENDIF 
        C(I)=YA(I) 
        D(I)=YA(I)+TINY 
   11 END DO 
      Y=YA(NS) 
      NS=NS-1 
      DO 13 M=1,N-1 
        DO 12 I=1,N-M 
          W=C(I+1)-D(I) 
          H=XA(I+M)-X 
          T=(XA(I)-X)*D(I)/H 
          DD=T-C(I+1) 
          DD=W/DD 
          D(I)=C(I+1)*DD 
          C(I)=T*DD 
   12   CONTINUE 
        IF (2*NS.LT.N-M)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
   13 END DO 
      RETURN 
      END     

                                      
      FUNCTION CtLhRTALF (EFLLN) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      include 'parmsetup.inc' 
      PARAMETER (PI = 3.141592653589793d0) 
      COMMON / CtLhRTALFC / ALFST, JORD, NEFF 
      EFMULM = EXP (EFLLN) 
      TEM1 = PI / ALFST 
      TEM2 = 1. / CtLhALPQCD (JORD, NEFF, EFMULM, I) 
      CtLhRTALF = TEM1 - TEM2 
      END       

                                    
      Subroutine CtLhbldat1 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      include 'parmsetup.inc' 
      LOGICAL LSTX 
      PARAMETER (MXX = 105, MXQ = 25, MxF = 6) 
      PARAMETER (MxPN = MxF * 2 + 2) 
      PARAMETER (MxQX= MXQ * MXX,   MxPQX = MxQX * MxPN) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtQARAY1 / QINI,QMAX, QV(0:MXQ),TV(0:MXQ), NT,JT,NG 
      COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx 
      COMMON / LhCtPEVLDT / UPD(MXPQX,nmxset), KF, Nelmt 
        PARAMETER (NF0 = 4, Nshp = 8,NEX = Nshp+2) 
      XMIN =  .999999D-4 
      XCR = 1.5 
      JT = 1 
      Return 
      END       

                                    
      SUBROUTINE CtLhSETL1  (NEF, VLAM) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL SET 
      COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      COMMON / LhCtCOMQMS / VALQMS(9) 
      IF (NEF .LT. 0 .OR. NEF .GT. NF) THEN 
        WRITE(*,*)'NEF out of range in CtLhSETL1: NEF NF =',NEF,NF 
        STOP 
      ENDIF 
      AMHAT(0) = 0. 
      DO 5 N = 1, NF 
         AMHAT(N) = VALQMS(N) 
    5    CONTINUE 
      ALAM(NEF) = VLAM 
      DO 10 N = NEF, 1, -1 
         CALL CtLhTRNLAM(NORDER, N, -1, IR1) 
   10    CONTINUE 
      DO 20 N = NEF, NF-1 
         CALL CtLhTRNLAM(NORDER, N, 1, IR1) 
   20    CONTINUE 
      DO 30, N = NF, 1, -1 
         IF ((ALAM(N) .GE. 0.7 * AMHAT(N))                              &
     &       .OR. (ALAM(N-1) .GE. 0.7 * AMHAT(N)))THEN                  
            NHQ = NF - N 
            GOTO 40 
            ENDIF 
   30    CONTINUE 
      NHQ = NF 
   40 CONTINUE 
      DO 50, N = NF-NHQ, 1, -1 
         AMHAT(N) = 0 
         ALAM(N-1) = ALAM(N) 
   50    CONTINUE 
      AMN = ALAM(NF) 
      DO 60, N = 0, NF-1 
         IF (ALAM(N) .GT. AMN)  AMN = ALAM(N) 
   60    CONTINUE 
      AMN = AMN * 1.0001 
      AL = ALAM(NF) 
      SET = .TRUE. 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhSETLAM (NEF, WLAM, IRDR) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      LOGICAL SET 
      IF ((NEF .LT. 0) .OR. (NEF .GT. NF)) THEN 
         WRITE(*,*)'NEF out of range in CtLhSETLAM: NEF NF=',NEF,NF 
         STOP 
      ENDIF 
      VLAM = WLAM 
      IF (IRDR .NE. NORDER) then 
        PRINT *,'fatal error: wanted cnvl1' 
        stop 
      ENDIF 
      CALL CtLhSETL1 (NEF, VLAM) 
      END       

                                    
      Subroutine CtLhbldat2 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtCOMQMS / VALQMS(9) 
      COMMON / LhCtQCDPAR_LHA / AL, NF, NORDER, SET 
      LOGICAL SET 
      AL = .226d0 
      NF = 5 
      NORDER = 2 
      SET = .FALSE. 
      VALQMS(1) =  0. 
      VALQMS(2) =  0. 
      VALQMS(3) =  0.2d0 
      VALQMS(4) =  1.3d0 
      VALQMS(5) =  4.5d0 
      VALQMS(6) =  174.d0 
      VALQMS(7) =  0. 
      VALQMS(8) =  0. 
      VALQMS(9) =  0. 
      Return 
      END     

                                      
      FUNCTION CtLhSMPNOL (NX, DX, FN, ERR) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      DIMENSION FN(NX) 
      MS = MOD(NX, 2) 
      IF (NX .LE. 1 .OR. NX .GT. 1000) THEN 
         PRINT *, 'NX =', NX, ' OUT OF RANGE IN CtLhSMPNOL!' 
         STOP 
      ELSEIF (NX .EQ. 2) THEN 
         TEM = DX * FN(2) 
      ELSEIF (NX .EQ. 3) THEN 
         TEM = DX * FN(2) * 2. 
      ELSE 
         IF (MS .EQ. 0) THEN 
            TEM = DX * (23.* FN(2) - 16.* FN(3) + 5.* FN(4)) / 12. 
            TMP = DX * (3.* FN(2) - FN(3)) / 2. 
            ERR = ABS(TEM - TMP) 
            TEM = TEM + CtLhSMPSNA (NX-1, DX, FN(2), ER1) 
            ERR = ABS(ER1) + ERR 
         ELSE 
            TEM = DX * (8.* FN(2) - 4.* FN(3) + 8.* FN(4)) / 3. 
            TMP = DX * (3.* FN(2) + 2.* FN(3) + 3.* FN(4)) / 2. 
            ERR = ABS(TEM - TMP) 
            TEM = TEM + CtLhSMPSNA (NX-4, DX, FN(5), ER1) 
            ERR = ABS(ER1) + ERR 
         ENDIF 
      ENDIF 
      CtLhSMPNOL = TEM 
      RETURN 
      END     

                                      
      FUNCTION CtLhSMPSNA (NX, DX, F, ERR) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
      PARAMETER (MAXX = 1000) 
      DIMENSION F(NX) 
      DATA IW1, IW2, TINY / 2*0, 1.E-35 / 
      IF (DX .LE. 0.) THEN 
        CALL CtLhWARNR(IW2,'DX cannot be < 0. in CtLhSMPSNA', 'DX',     &
     &         DX, D0, D1, 0)                                           
        CtLhSMPSNA = 0. 
        RETURN 
      ENDIF 
      IF (NX .LE. 0 .OR. NX .GT. MAXX) THEN 
        CALL CtLhWARNI(IW1, 'NX out of range in CtLhSMPSNA', 'NX', NX,  &
     &               1, MAXX, 1)                                        
        SIMP = 0. 
      ELSEIF (NX .EQ. 1) THEN 
        SIMP = 0. 
      ELSEIF (NX .EQ. 2) THEN 
        SIMP = (F(1) + F(2)) / 2. 
        ERRD = (F(1) - F(2)) / 2. 
      ELSE 
        MS = MOD(NX, 2) 
        IF (MS .EQ. 0) THEN 
          ADD = (9.*F(NX) + 19.*F(NX-1) - 5.*F(NX-2) + F(NX-3)) / 24. 
          NZ = NX - 1 
        ELSE 
          ADD = 0. 
          NZ = NX 
        ENDIF 
        IF (NZ .EQ. 3) THEN 
          SIMP = (F(1) + 4.* F(2) + F(3)) / 3. 
          TRPZ = (F(1) + 2.* F(2) + F(3)) / 2. 
        ELSE 
          SE = F(2) 
          SO = 0 
          NM1 = NZ - 1 
          DO 60 I = 4, NM1, 2 
            IM1 = I - 1 
            SE = SE + F(I) 
            SO = SO + F(IM1) 
   60     CONTINUE 
          SIMP = (F(1) + 4.* SE + 2.* SO + F(NZ)) / 3. 
          TRPZ = (F(1) + 2.* (SE + SO) + F(NZ)) / 2. 
        ENDIF 
        ERRD = TRPZ - SIMP 
        SIMP = SIMP + ADD 
      ENDIF 
      CtLhSMPSNA = SIMP * DX 
      IF (ABS(SIMP) .GT. TINY) THEN 
        ERR = ERRD / SIMP 
      ELSE 
        ERR = 0. 
      ENDIF 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhSNEVL(IKNL,NX,NT,JT,DT,TIN,NEFF,UI,GI,US,GS) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXQX= MXQ * MXX) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      DIMENSION UI(NX), US(0:NX, 0:NT) 
      DIMENSION GI(NX), GS(0:NX, 0:NT) 
      DIMENSION Y0(MXX), Y1(MXX), YP(MXX), F0(MXX), F1(MXX), FP(MXX) 
      DIMENSION Z0(MXX), Z1(MXX), ZP(MXX), G0(MXX), G1(MXX), GP(MXX) 
      DATA D0 / 0.0 / 
      JTT = 2 * JT 
      DDT = DT / JTT 
      IF (NX .GT. MXX) THEN 
      WRITE (*,*) 'Nx =', NX, ' too many pts in CtLhSNEVL' 
      STOP 'Program stopped in CtLhSNEVL' 
      EndIf 
! ++ remove unused quantities (jcp)                                     
! ++  TMD = TIN + DT * NT / 2.                                          
! ++  AMU = EXP(TMD)                                                    
! ++  TEM = 6./ (33.- 2.* NEFF) / CtLhALPI(AMU)                         
! ++  TLAM = TMD - TEM                                                  
      DO 9 IX = 1, NX 
      US (IX, 0) = UI(IX) 
      GS (IX, 0) = GI(IX) 
    9 END DO 
      US ( 0, 0) = (UI(1) - UI(2))* 3D0 + UI(3) 
      GS ( 0, 0) = (GI(1) - GI(2))* 3D0 + GI(3) 
      TT = TIN 
      DO 10 IZ = 1, NX 
      Y0(IZ) = UI(IZ) 
      Z0(IZ) = GI(IZ) 
   10 END DO 
      DO 20 IS = 1, NT 
         DO 202 JS = 1, JTT 
            IRND = (IS-1) * JTT + JS 
            IF (IRND .EQ. 1) THEN 
                CALL CtLhSNRHS (TT, NEFF, Y0,Z0,  F0,G0) 
                DO 250 IZ = 1, NX 
                   Y0(IZ) = Y0(IZ) + DDT * F0(IZ) 
                   Z0(IZ) = Z0(IZ) + DDT * G0(IZ) 
  250           CONTINUE 
                TT = TT + DDT 
                CALL CtLhSNRHS (TT, NEFF, Y0, Z0,  F1, G1) 
                DO 251 IZ = 1, NX 
                   Y1(IZ) = UI(IZ) + DDT * (F0(IZ) + F1(IZ)) / 2D0 
                   Z1(IZ) = GI(IZ) + DDT * (G0(IZ) + G1(IZ)) / 2D0 
  251           CONTINUE 
            Else 
                CALL CtLhSNRHS (TT, NEFF, Y1, Z1,  F1, G1) 
                DO 252 IZ = 1, NX 
                   YP(IZ) = Y1(IZ) + DDT * (3D0 * F1(IZ) - F0(IZ)) / 2D0 
                   ZP(IZ) = Z1(IZ) + DDT * (3D0 * G1(IZ) - G0(IZ)) / 2D0 
  252           CONTINUE 
                TT = TT + DDT 
                CALL CtLhSNRHS (TT, NEFF, YP, ZP,  FP, GP) 
                DO 253 IZ = 1, NX 
                   Y1(IZ) = Y1(IZ) + DDT * (FP(IZ) + F1(IZ)) / 2D0 
                   Z1(IZ) = Z1(IZ) + DDT * (GP(IZ) + G1(IZ)) / 2D0 
                   F0(IZ) = F1(IZ) 
                   G0(IZ) = G1(IZ) 
  253           CONTINUE 
            EndIf 
  202    CONTINUE 
         DO 260 IX = 1, NX 
           IF (IKNL .GT. 0) THEN 
            US (IX, IS) = MAX(Y1(IX), D0) 
            GS (IX, IS) = MAX(Z1(IX), D0) 
           Else 
            US (IX, IS) = Y1(IX) 
            GS (IX, IS) = Z1(IX) 
           EndIf 
  260    CONTINUE 
         US(0, IS) = 3D0*Y1(1) - 3D0*Y1(2) + Y1(3) 
         GS(0, IS) = 3D0*Z1(1) - 3D0*Z1(2) + Z1(3) 
   20 END DO 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhSNRHS (TT, NEFF, FI, GI,  FO, GO) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LSTX 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtXYARAY / ZZ(MXX, MXX), ZV(0:MXX) 
      COMMON / LhCtKRNL01 / AFF2(MXX),AFG2(MXX),AGF2(MXX),AGG2(MXX),    &
     &                  ANSP (MXX), ANSM (MXX), ZFG2, ZGF2, ZQQB        
      COMMON / LhCtKRN2ND / FFG(MXX, MXX), GGF(MXX, MXX), PNS(MXX, MXX) 
      COMMON / LhCtEVLPAC / AL, IKNL, IPD0, IHDN, NfMx 
      DIMENSION GI(NX), GO(NX), G1(MXX), G2(MXX), G3(MXX), G4(MXX) 
      DIMENSION FI(NX), FO(NX), W0(MXX), W1(MXX), WH(MXX), WM(MXX) 
      DIMENSION R0(MXX), R1(MXX), R2(MXX), RH(MXX), RM(MXX) 
      S = EXP(TT) 
      Q = AL * EXP (S) 
      CPL = CtLhALPI(Q) 
      CPL2= CPL ** 2 / 2. * S 
      CPL = CPL * S 
      CALL CtLhINTEGR (NX,-1, FI, WM, IR1) 
      CALL CtLhINTEGR (NX, 0, FI, W0, IR2) 
      CALL CtLhINTEGR (NX, 1, FI, W1, IR3) 
      CALL CtLhINTEGR (NX,-1, GI, RM, IR4) 
      CALL CtLhINTEGR (NX, 0, GI, R0, IR5) 
      CALL CtLhINTEGR (NX, 1, GI, R1, IR6) 
      CALL CtLhINTEGR (NX, 2, GI, R2, IR7) 
      CALL CtLhHINTEG (NX,    FI, WH) 
      CALL CtLhHINTEG (NX,    GI, RH) 
      IF (IKNL .GT. 0) THEN 
      DO 230 IZ = 1, NX 
      FO(IZ) = ( 2D0 * FI(IZ)                                           &
     &      + 4D0 / 3D0 * ( 2D0 * WH(IZ) - W0(IZ) - W1(IZ) ))           &
     &      + NEFF * ( R0(IZ) - 2D0 * R1(IZ) + 2D0 * R2(IZ) )           
      FO(IZ) = FO(IZ) * CPL 
      GO(IZ) = 4D0 / 3D0 * ( 2D0 * WM(IZ) - 2D0 * W0(IZ)  + W1(IZ) )    &
     &      + (33D0 - 2D0 * NEFF) / 6D0 * GI(IZ)                        &
     &      + 6D0 * (RH(IZ) + RM(IZ) - 2D0 * R0(IZ) + R1(IZ) - R2(IZ))  
      GO(IZ) = GO(IZ) * CPL 
  230 END DO 
      Else 
      DO 240 IZ = 1, NX 
      FO(IZ) = NEFF * (-R0(IZ) + 2.* R1(IZ) )                           &
     & + 2.* FI(IZ) + 4./ 3.* ( 2.* WH(IZ) - W0(IZ) - W1(IZ) )          
      FO(IZ) = FO(IZ) * CPL 
      GO(IZ) = 4./ 3.* ( 2.* W0(IZ) - W1(IZ) )                          &
     &+ (33.- 2.* NEFF) / 6.* GI(IZ) + 6.*(RH(IZ) + R0(IZ) - 2.* R1(IZ))
      GO(IZ) = GO(IZ) * CPL 
  240 END DO 
      EndIf 
      IF (IKNL .EQ. 2) THEN 
      DZ = 1./(NX - 1) 
      DO 21 I = 1, NX-1 
        NP = NX - I + 1 
        IS = NP 
           g2(1)=0d0 
           g3(1)=0d0 
        DO 31 KZ = 2, NP 
          IY = I + KZ - 1 
          IT = NX - IY + 1 
          XY = ZZ (IS, IT) 
          G1(KZ) = FFG(I, IY) * (FI(IY) - XY**2 *FI(I)) 
          G4(KZ) = GGF(I, IY) * (GI(IY) - XY**2 *GI(I)) 
                                                        !FG             
           G2(KZ) = FFG(IS,IT) * (GI(IY) - xy*GI(I)) 
                                                        !GF (usual notat
           G3(KZ) = GGF(IS,IT) * (FI(IY) - XY*FI(I)) 
   31   CONTINUE 
        TEM1 = CtLhSMPNOL (NP, DZ, G1, ERR) 
        TEM2 = CtLhSMPSNA (NP, DZ, G2, ERR) 
        TEM3 = CtLhSMPSNA (NP, DZ, G3, ERR) 
        TEM4 = CtLhSMPNOL (NP, DZ, G4, ERR) 
        TEM1 = TEM1 - FI(I) * (AFF2(I) + ZGF2) 
        TEM4 = TEM4 - GI(I) * (AGG2(I) + ZFG2) 
         tem2 = tem2 + GI(I)*AFG2(I) 
         tem3=  tem3 + FI(I)*AGF2(I) 
        TMF = TEM1 + TEM2 
        TMG = TEM3 + TEM4 
        FO(I) = FO(I) + TMF * CPL2 
        GO(I) = GO(I) + TMG * CPL2 
   21 END DO 
      EndIf 
      RETURN 
      END     

                                      
      FUNCTION CtLhSPENC2 (X) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      EXTERNAL CtLhSPN2IN 
      COMMON / LhCtSPENCC / XX 
      DATA U1, AERR, RERR / 1.D0, 1.E-7, 5.E-3 / 
      XX = X 
      TEM = CtLhGausInt(CtLhSPN2IN, XX, U1, AERR, RERR, ERR, IRT) 
      CtLhSPENC2 = TEM + LOG (XX) ** 2 / 2. 
      RETURN 
      END     

                                      
      FUNCTION CtLhSPN2IN (ZZ) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtSPENCC / X 
      Z = ZZ 
      TEM = LOG (1.+ X - Z) / Z 
      CtLhSPN2IN = TEM 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhSTUPKL (NFL) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LSTX 
      PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MX = 3) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtXYARAY / ZZ(MXX, MXX), ZV(0:MXX) 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtKRN1ST / FF1(0:MXX),FG1(0:MXX),GF1(0:MXX),GG1(0:MXX),&
     &                  FF2(0:MXX), FG2(0:MXX), GF2(0:MXX), GG2(0:MXX), &
     &                  PNSP(0:MXX), PNSM(0:MXX)                        
      COMMON / LhCtKRN2ND / FFG(MXX, MXX), GGF(MXX, MXX), PNS(MXX, MXX) 
      COMMON / LhCtKRNL00 / DZ, XL(MX), NNX 
      COMMON / LhCtKRNL01 / AFF2(MXX),AFG2(MXX),AGF2(MXX),AGG2(MXX),    &
     &                  ANSP (MXX), ANSM (MXX), ZFG2, ZGF2, ZQQB        
      EXTERNAL CtLhPFF1, CtLhRGG1, CtLhRFF2, CtLhRGG2 
      EXTERNAL CtLhFNSP, CtLhFNSM 
      dimension aff1(mxx),agg1(mxx) 
      PARAMETER (PI = 3.141592653589793d0, PI2 = PI**2) 
      DATA CF, CG, TR / 1.33333333333333d0, 3.0, 0.5 / 
                                              ! zeta(3.0)               
      data zeta3/1.20205690315959d0/ 
      SAVE 
      DATA AERR, RERR / 0.0, 0.02 / 
      NNX = NX 
      DZ = 1./ (NX - 1) 
      DO 5 I0 = 1, MX 
        XL(I0) = XV(I0) 
    5 END DO 
      DO 10 I = 1, NX-1 
        XZ = XV(I) 
      CALL CtLhKERNEL (XZ, FF1(I), GF1(I), FG1(I), GG1(I), PNSP(I),     &
     &          PNSM(I), FF2(I), GF2(I), FG2(I), GG2(I), NFL, IRT)      
   10 END DO 
      FF1(0) = FF1(1) * 3. - FF1(2) * 3. + FF1(3) 
      FG1(0) = FG1(1) * 3. - FG1(2) * 3. + FG1(3) 
      GF1(0) = GF1(1) * 3. - GF1(2) * 3. + GF1(3) 
      GG1(0) = GG1(1) * 3. - GG1(2) * 3. + GG1(3) 
      PNSP(0) = PNSP(1) * 3. - PNSP(2) * 3. + PNSP(3) 
      PNSM(0) = PNSM(1) * 3. - PNSM(2) * 3. + PNSM(3) 
      FF2(0) = FF2(1) * 3. - FF2(2) * 3. + FF2(3) 
      FG2(0) = FG2(1) * 3. - FG2(2) * 3. + FG2(3) 
      GF2(0) = GF2(1) * 3. - GF2(2) * 3. + GF2(3) 
      GG2(0) = GG2(1) * 3. - GG2(2) * 3. + GG2(3) 
      FF1(NX) = FF1(NX-1) * 3. - FF1(NX-2) * 3. + FF1(NX-3) 
      FG1(NX) = FG1(NX-1) * 3. - FG1(NX-2) * 3. + FG1(NX-3) 
      GF1(NX) = GF1(NX-1) * 3. - GF1(NX-2) * 3. + GF1(NX-3) 
      GG1(NX) = GG1(NX-1) * 3. - GG1(NX-2) * 3. + GG1(NX-3) 
      PNSM(NX) = PNSM(NX-1) * 3. - PNSM(NX-2) * 3. + PNSM(NX-3) 
      PNSP(NX) = PNSP(NX-1) * 3. - PNSP(NX-2) * 3. + PNSP(NX-3) 
      FF2(NX) = FF2(NX-1) * 3. - FF2(NX-2) * 3. + FF2(NX-3) 
      FG2(NX) = FG2(NX-1) * 3. - FG2(NX-2) * 3. + FG2(NX-3) 
      GF2(NX) = GF2(NX-1) * 3. - GF2(NX-2) * 3. + GF2(NX-3) 
      GG2(NX) = GG2(NX-1) * 3. - GG2(NX-2) * 3. + GG2(NX-3) 
         RER = RERR * 4. 
         AFF1(1) = CtLhGausInt(CtLhPFF1,D0,XV(1),AERR,RERR,ER1,IRT) 
         DGG1     = NFL / 3. 
         TMPG     = CtLhGausInt(CtLhRGG1,D0,XV(1),AERR,RERR,ER3,IRT) 
         AGG1(1) = TMPG + DGG1 
       ANSM(1) = CtLhGausInt(CtLhFNSM,D0,XV(1),AERR,RER,ER2,IRT) 
       ANSP(1) = CtLhGausInt(CtLhFNSP,D0,XV(1),AERR,RER,ER2,IRT) 
         AER = AFF1(1) * RER 
         AFF2(1) = CtLhGausInt(CtLhRFF2, D0, XV(1),  AER, RER, ER2, IRT) 
         AER = AGG1(1) * RER 
         AGG2(1) = CtLhGausInt(CtLhRGG2, D0, XV(1),  AER, RER, ER4, IRT) 
      DO 20 I2 = 2, NX-1 
      TEM =CtLhGausInt(CtLhPFF1,XV(I2-1),XV(I2),AERR,RERR,ER1,IRT) 
      AFF1(I2) = TEM + AFF1(I2-1) 
      AER = ABS(TEM * RER) 
      AFF2(I2)=CtLhGausInt(CtLhRFF2,XV(I2-1),XV(I2),AER,RER,ER2,IRT)    &
     &        +AFF2(I2-1)                                               
      TEM      = CtLhGausInt(CtLhRGG1,XV(I2-1),XV(I2),AERR,RERR,ER3,IRT) 
      TMPG     = TMPG + TEM 
      AGG1(I2) = TMPG + DGG1 
      AER = ABS(TEM * RER) 
      AGG2(I2)=CtLhGausInt(CtLhRGG2,XV(I2-1),XV(I2),AER,RER,ER4,IRT)    &
     &        +AGG2(I2-1)                                               
      ANSP(I2)=CtLhGausInt(CtLhFNSP,XV(I2-1),XV(I2),AERR,RER,ER4,IRT)   &
     &        +ANSP(I2-1)                                               
      ANSM(I2)=CtLhGausInt(CtLhFNSM,XV(I2-1),XV(I2),AERR,RER,ER4,IRT)   &
     &        +ANSM(I2-1)                                               
   20 END DO 
      ANSP(NX)=CtLhGausInt(CtLhFNSP,XV(NX-1),D1,AERR,RER,ERR,           &
     & IRT) + ANSP(NX-1)                                                
      ANSM(NX)=CtLhGausInt(CtLhFNSM,XV(NX-1),D1,AERR,RER,ERR,           &
     & IRT) + ANSM(NX-1)                                                
           TRNF = TR * NFL 
                                                          !loop over x  
      do i2=1,nx-1 
         x=xv(i2) 
!        XI = 1./ X                !unused - jcp                        
         X2 = X ** 2 
         X3=  x**3 
         XLN = DLOG (X) 
         XLN2 = XLN ** 2 
         XLN1M = DLOG (1.- X) 
         xLi2m=CtLhxLi(2,-x) 
         xLi2=CtLhxLi(2,x) 
         xLi3=CtLhxLi(3,x) 
         xLi31m=CtLhxLi(3,1d0-x) 
         xLi32=CtLhxLi(3,x2) 
         xln1m2=xln1m*xln1m 
         xln1p=dlog(1d0+x) 
         x1m=1d0-x 
         x1p=1d0+x 
         x3m=3d0-x 
         x3p=3d0+x 
         wgfcft=                                                        &
     & (9 + 4*Pi2 - 22*x + 13*x2 + 6*(3 - 4*x + x2)*xln1m +             &
     & 40*xln - 24*xLi2)/9.                                             
       wgfcf2=                                                          &
     & (6*(2*(-9 + Pi2) + 3*x*(5 + x)) +4*(3 +2*Pi2+3*x*(-3 + 2*x))*    &
     & xln1m + 6*x3m*x1m*xln1m2 - 6*(x*(8 + 3*x) + 4*xln1m2)*           &
     & xln - 3*(-4 + x)*x*xln2)/12 - 2*(3 + 2*xln1m)*xLi2 - 4*xLi31m    
       wgfcfg=                                                          &
     & (3637-186*Pi2-x*(3198+72*Pi2+x*(231 + 208*x)))/108.- xln +       &
     & (3*xln1m*(-33 - 4*Pi2 + (50 - 17*x)*x - 3*x3m*x1m*xln1m) +       &
     & 2*(x*(198 + x*(27+8*x))+9*xln1m*(3 - 4*x + x2 + 2*xln1m))*       &
     & xln - 9*x*(4 + x)*xln2)/18- x1p*x3p*xln*xln1p-                   &
     & (x1p*x3p - 4*xln)*xLi2m + (31d0/3d0 +4*xln1m- 4*xln)*xLi2 +      &
     & 4*xLi31m + 12*xLi3 - 2*xLi32 - 10*zeta3                          
       wfgcft=                                                          &
     & (18 - 81*x + 6*Pi2*x + 123*x2 - 6*Pi2*x2 - 60*x3 +               &
     & 4*Pi2*x3 - 6*(-2 + 3*x - 3*x2 + 2*x3)*xln1m2 -33*x*xln +         &
     & 15*x2*xln - 24*x3*xln - 9*x*xln2 + 9*x2*xln2 -                   &
     & 12*x3*xln2 - 12*x1m*xln1m*(-1 + 2*x2 + 2*xln - x*xln +           &
     & 2*x2*xln) - 24*xLi2)/9.                                          
       wfgcgt=                                                          &
     & (2*(-67 + 2*Pi2 + x*(64 + x*(-91 + 3*Pi2 + 94*x)) +              &
     & x1m*(7+x*(-5+16*x))*xln1m -3*x1m*(2+ x*(-1+2*x))*xln1m2 -        &
     & 20*xln - 3*x*xln*(13 + 16*x*x1p - 3*x1p*xln) +                   &
     & 6*x1p*(2+x+2*x2)*xln*xln1p+6*x1p*(2+x+2*x2)*xLi2m))/9.           
       AGF2(I2) = CF*TRNF*WGFCFT+CF**2* WGFCF2+CF*CG*WGFCFG 
       AFG2(I2) = CF*TRNF*WFGCFT            +CG*TRNF*WFGCGT 
            !i2                                                         
      enddo 
       AGF2(nx)=0d0 
       AFG2(nx)=0d0 
       ZGF2=-28./27.*Cf**2+94./27.*Cf*Cg -52./27.*Cf*TrNf 
       ZFG2= 37./27.*Cf*TrNf + 35./54.*Cg*TrNf 
       ZQQB=1.43862321154902*(Cf**2-0.5*Cf*Cg) 
      DO 21 IX = 1, NX-1 
        X = XV(IX) 
        NP = NX - IX + 1 
        IS = NP 
        XG2 = (LOG(1./(1.-X)) + 1.) ** 2 
        FFG (IS, IS) = FG2(NX) * DXTZ(I) * XG2 
      GGF (IS, IS) = GF2(NX) * DXTZ(I) * XG2 
      PNS (IS, IS) =PNSM(NX) * DXTZ(I) 
        DO 31 KZ = 2, NP 
          IY = IX + KZ - 1 
          IT = NX - IY + 1 
          XY = X / XV(IY) 
          XM1 = 1.- XY 
          XG2 = (LOG(1./XM1) + 1.) ** 2 
          Z  = ZZ (IX, IY) 
          TZ = (Z + DZ) / DZ 
          IZ = Int(TZ) 
          IZ = MAX (IZ, 0) 
          IZ = MIN (IZ, NX-1) 
          DT = TZ - IZ 
          TEM = (FF2(IZ) * (1.- DT) + FF2(IZ+1) * DT) / XM1 / XY 
          FFG (IX, IY) = TEM * DXTZ(IY) 
          TEM = (FG2(IZ) * (1.- DT) + FG2(IZ+1) * DT) * XG2 / XY 
          FFG (IS, IT) = TEM * DXTZ(IY) 
          TEM = (GF2(IZ) * (1.- DT) + GF2(IZ+1) * DT) * XG2 / XY 
        GGF (IS, IT) = TEM * DXTZ(IY) 
          TEM = (GG2(IZ) * (1.- DT) + GG2(IZ+1) * DT) / XM1 / XY 
        GGF (IX, IY) = TEM * DXTZ(IY) 
        TEM = (PNSP(IZ) * (1.- DT) + PNSP(IZ+1) * DT) / XM1 
        PNS (IX, IY) = TEM * DXTZ(IY) 
        TEM = (PNSM(IZ) * (1.- DT) + PNSM(IZ+1) * DT) / XM1 
        PNS (IS, IT) = TEM * DXTZ(IY) 
   31   CONTINUE 
   21 END DO 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhTRNLAM (IRDR, NF, IACT, IRT) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtCWZPRM / ALAM(0:9), AMHAT(0:9), AMN, NHQ 
      COMMON / LhCtTRNCOM / VMULM, JRDR, N, N1 
      EXTERNAL CtLhZBRLAM 
      DATA ALM0, BLM0, RERR / 0.01, 10.0, 0.0001 / 
      DATA IR1, SML / 0, 1.E-5 / 
      IRT = 0 
      N = NF 
      JRDR = IRDR 
      JACT = IACT 
      VLAM = ALAM(N) 
      IF (JACT .GT. 0) THEN 
         N1 = N + 1 
         THMS = AMHAT(N1) 
         ALM = LOG (THMS/VLAM) 
         BLM = BLM0 
      ELSE 
         N1 = N -1 
         THMS = AMHAT(N) 
         ALM = ALM0 
         THMS = MAX (THMS, SML) 
         BLM = LOG (THMS/VLAM) 
      ENDIF 
      IF (VLAM .GE. 0.7 * THMS) THEN 
         IF (JACT .EQ. 1) THEN 
            AMHAT(N1) = 0 
         ELSE 
            AMHAT(N) = 0 
         ENDIF 
         IRT = 4 
         ALAM(N1) = VLAM 
         RETURN 
      ENDIF 
      IF (ALM .GE. BLM) THEN 
         WRITE (*, *) 'CtLhTRNLAM has ALM >= BLM: ', ALM, BLM 
         WRITE (*, *) 'I do not know how to continue' 
         STOP 
         ENDIF 
      VMULM = THMS/VLAM 
      ERR = RERR * LOG (VMULM) 
      WLLN = CtLhQZBRNT (CtLhZBRLAM, ALM, BLM, ERR, IR1) 
      ALAM(N1) = THMS / EXP (WLLN) 
      IF (IR1 .NE. 0) THEN 
         WRITE (*, *) 'CtLhQZBRNT failed in CtLhTRNLAM; ',              &
     &        'NF, VLAM =', NF, VLAM                                    
         WRITE (*, *) 'I do not know how to continue' 
        STOP 
      ENDIF 
      RETURN 
      END       
      
                              
      SUBROUTINE CtLhUPC (A, La, UpA) 
      CHARACTER A*(*), UpA*(*), C*(1) 
      INTEGER I, La, Ld 
      La = Len(A) 
      Lb = Len(UpA) 
      If (Lb .Lt. La) Stop 'UpCase conversion length mismatch!' 
      Ld = ICHAR('A')-ICHAR('a') 
      DO 1 I = 1, Lb 
        If (I .Le. La) Then 
         c = A(I:I) 
         IF ( LGE(C, 'a') .AND. LLE(C, 'z') ) THEN 
           UpA (I:I) = CHAR(Ichar(c) + ld) 
         Else 
           UpA (I:I) = C 
         ENDIF 
        Else 
         UpA (I:I) = ' ' 
        Endif 
    1 END DO 
                                                                        
      RETURN 
      END       

                                    
      SUBROUTINE CtLhWARNI (IWRN, MSG, NMVAR, IVAB,                     &
     &                  IMIN, IMAX, IACT)                               
      CHARACTER*(*) MSG, NMVAR 
      Save Iw 
      Data Nmax / 100 / 
      IW = IWRN 
      IV = IVAB 
                                                                        
      IF  (IW .EQ. 0) THEN 
         PRINT '(1X,A/1X, 2A,I10)', MSG, NMVAR,' = ', IV 
         IF (IACT .EQ. 1) THEN 
         PRINT '(A/2I10)', ' The limits are: ', IMIN, IMAX 
         ENDIF 
      ENDIF 
      If (Iw .LT. Nmax) Then 
         PRINT '(1X,A/1X, 2A,I10)', MSG, NMVAR,' = ', IV 
      Elseif (Iw .Eq. Nmax) Then 
         Print '(/A/)', 'CtLhWARNI Severe Warning: Too many errors' 
      Endif 
      IWRN = IW + 1 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhWARNR (IWRN, MSG, NMVAR, VARIAB,                   &
     &                  VMIN, VMAX, IACT)                               
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
      CHARACTER*(*) MSG, NMVAR 
      Save Iw 
!      Data Nmax / 100 /                                                
      Data Nmax / 10 / 
      IW = IWRN 
      VR = VARIAB 
      IF  (IW .EQ. 0) THEN 
         PRINT '(1X, A/1X,2A,1PD16.7)', MSG, NMVAR, ' = ', VR 
         IF (IACT .EQ. 1) THEN 
         PRINT       '(A/2(1PE15.4))', ' The limits are: ', VMIN, VMAX 
         ENDIF 
      ENDIF 
      If (Iw .LT. Nmax) Then 
         PRINT '(I5, 2A/1X,2A,1PD16.7)', IW, '   ', MSG,                &
     &                  NMVAR, ' = ', VR                                
      Elseif (Iw .Eq. Nmax) Then 
         Print '(/A/)', 'CtLhWARNR Severe Warning: Too many errors' 
      Endif 
      IWRN = IW + 1 
      RETURN 
      END       

                                    
      SUBROUTINE CtLhXARRAY 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LSTX 
      PARAMETER (D0 = 0.0, D10=10.0) 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPN = MXF * 2 + 2) 
      PARAMETER (MXQX= MXQ * MXX,   MXPQX = MXQX * MXPN) 
      PARAMETER (M1=-3, M2=3, NDG=3, NDH=NDG+1, L1=M1-1, L2=M2+NDG-2) 
      Character Msg*80 
      COMMON / LhCtVARIBX / XA(MXX, L1:L2), ELY(MXX), DXTZ(MXX) 
      COMMON / LhCtVARBAB / GB(NDG, NDH, MXX), H(NDH, MXX, M1:M2) 
      COMMON / LhCtHINTEC / GH(NDG, MXX) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtXYARAY / ZZ(MXX, MXX), ZV(0:MXX) 
      DIMENSION G1(NDG,NDH), G2(NDG,NDH), A(NDG) 
      DATA F12, F22, F32 / 1D0, 1D0, 1D0 / 
      DATA (G1(I,NDH), G2(I,1), I=1,NDG) / 0.0,0.0,0.0,0.0,0.0,0.0 / 
      DATA PUNY / 1D-30 / 
      XV(0) = 0D0 
      DZ = 1D0 / (NX-1) 
      DO 10 I = 1, NX - 1 
         Z = DZ * (I-1) 
         ZV(I) = Z 
         X = CtLhXFRMZ (Z) 
         DXTZ(I) = CtLhDXDZ(Z) / X 
         XV (I)  = X 
         XA(I, 1) = X 
         XA(I, 0) = LOG (X) 
         DO 20 L = L1, L2 
          IF (L .NE. 0 .AND. L .NE. 1)  XA(I, L) = X ** L 
   20    CONTINUE 
   10 END DO 
         XV(1) = Xmin 
         XV(NX) = 1D0 
         ZV(Nx) = 1D0 
         DXTZ(NX) = CtLhDXDZ(1.D0) 
         DO 21 L = L1, L2 
            XA (NX, L) = 1D0 
   21    CONTINUE 
         XA (NX, 0) = 0D0 
      DO 11 I = 1, NX-1 
         ELY(I) = LOG(1D0 - XV(I)) 
   11 END DO 
       ELY(NX) = 3D0* ELY(NX-1) - 3D0* ELY(NX-2) + ELY(NX-3) 
      DO 17 IX = 1, NX 
      ZZ (IX, IX) = 1. 
      DO 17 IY = IX+1, NX 
         XY = XV(IX) / XV(IY) 
         ZZ (IX, IY) = CtLhZFRMX (XY) 
         ZZ (NX-IX+1, NX-IY+1) = XY 
   17 CONTINUE 
      DO 30 I = 1, NX-1 
      IF (I .NE. NX-1) THEN 
        F11 = 1D0/XV(I) 
        F21 = 1D0/XV(I+1) 
        F31 = 1D0/XV(I+2) 
        F13 = XV(I) 
        F23 = XV(I+1) 
        F33 = XV(I+2) 
        DET = F11*F22*F33 + F21*F32*F13 + F31*F12*F23                   &
     &      - F31*F22*F13 - F21*F12*F33 - F11*F32*F23                   
        IF (ABS(DET) .LT. PUNY) THEN 
           Msg='Determinant close to zero; will be arbitrarily set to:' 
           CALL CtLhWARNR(IWRN, Msg, 'DET', PUNY, D0, D0, 0) 
           DET = PUNY 
        EndIf 
        G2(1,2) = (F22*F33 - F23*F32) / DET 
        G2(1,3) = (F32*F13 - F33*F12) / DET 
        G2(1,4) = (F12*F23 - F13*F22) / DET 
        G2(2,2) = (F23*F31 - F21*F33) / DET 
        G2(2,3) = (F33*F11 - F31*F13) / DET 
        G2(2,4) = (F13*F21 - F11*F23) / DET 
        G2(3,2) = (F21*F32 - F22*F31) / DET 
        G2(3,3) = (F31*F12 - F32*F11) / DET 
        G2(3,4) = (F11*F22 - F12*F21) / DET 
        B2 = LOG (XV(I+2)/XV(I)) 
        B3 = XV(I) * (B2 - 1.) + XV(I+2) 
        GH (1,I) = B2 * G2 (2,2) + B3 * G2 (3,2) 
        GH (2,I) = B2 * G2 (2,3) + B3 * G2 (3,3) 
        GH (3,I) = B2 * G2 (2,4) + B3 * G2 (3,4) 
      EndIf 
        DO 51 J = 1, NDH 
           DO 52 L = 1, NDG 
              IF     (I .EQ. 1) THEN 
                 GB(L,J,I) = G2(L,J) 
              ElseIF (I .EQ. NX-1) THEN 
                 GB(L,J,I) = G1(L,J) 
              Else 
                 GB(L,J,I) = (G1(L,J) + G2(L,J)) / 2D0 
              EndIf 
   52      CONTINUE 
   51   CONTINUE 
        DO 35 MM = M1, M2 
           DO 40 K = 1, NDG 
             KK = K + MM - 2 
             IF (KK .EQ. 0) THEN 
               A(K) = XA(I+1, 0) - XA(I, 0) 
             Else 
               A(K) = (XA(I+1, KK) - XA(I, KK)) / DBLE(KK) 
             EndIf 
   40      CONTINUE 
           DO 41 J = 1, NDH 
             TEM = 0 
             DO 43 L = 1, NDG 
               TEM = TEM + A(L) * GB(L,J,I) 
   43        CONTINUE 
             H(J,I,MM) = TEM 
   41      CONTINUE 
   35   CONTINUE 
      DO 42 J = 1, NDG 
        DO 44 L = 1, NDG 
           G1(L,J) = G2(L,J+1) 
   44 END DO 
   42 END DO 
   30 END DO 
      LSTX = .TRUE. 
      RETURN 
      END     

                                      
      FUNCTION CtLhXFRMZ (Z) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LSTX 
      PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
      PARAMETER (MXX = 105) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      COMMON / LhCtINVERT / ZA 
      EXTERNAL CtLhZFXL 
      DATA TEM, RER / D1, 1E-3 / 
      DATA ZLOW, ZHIGH, IWRN2 / -10.0, 1.00002, 0 / 
      EPS = TEM * RER 
      ZA = Z 
      IF (Z .LE. ZHIGH .AND. Z .GT. ZLOW) THEN 
          XLA = LOG (XMIN) * 1.5 
          XLB = 0.00001 
          TEM = CtLhZBRNT (CtLhZFXL, XLA, XLB, EPS, IRT) 
      Else 
        CALL CtLhWARNR (IWRN2, 'Z out of range in CtLhXFRMZ, X set=0.', &
     &              'Z', Z, ZLOW, ZHIGH, 1)                             
        TEM = 0 
      EndIf 
      CtLhXFRMZ = EXP(TEM) 
      RETURN 
      END     

                                      
      FUNCTION CtLhxLi(n,x) 
      implicit NONE 
      integer NCUT, i,n,m3 
      real*8 CtLhxLi,Out,x,pi2by6,zeta3,c1,c2 
      real*8 r,xt,L,xln1m 
      parameter (m3=8) 
      dimension c1(2:m3),c2(2:m3) 
      data NCUT/27/ 
      data c1/0.75,-0.5833333333333333d0,0.454861111111111d0,           &
     &        -0.3680555555555555d0,0.3073611111111111d0,               &
     &        -0.2630555555555555d0,0.2294880243764172d0/               
      data c2/-0.5d0,0.5d0,-0.4583333333333333d0,0.416666666666666d0,   &
     &        -0.3805555555555555d0,0.35d0,-0.3241071428571428d0/       
      data zeta3,pi2by6 /1.20205690315959d0,1.64493406684823d0/ 
      L=0.0 
      i=0 
      r=1.0 
      if (abs(x).gt.r) then 
        PRINT *,'Li: x out of range (-1,1) , x=',x 
        STOP 
      endif 
      if (n.lt.0) then 
       PRINT *,'Polylogarithm Li undefined for n=',n 
       STOP 
      elseif (n.eq.0) then 
       Out=x/(1d0-x) 
      elseif (n.eq.1) then 
       Out=-dlog(1-x) 
      elseif (n.eq.2) then 
                                                !Calculate dilogarithm  
                                                !separately for x<0.5 an
      if (x.ge.(-0.5).and.x.le.0.5) then 
         do while(i.le.NCUT) 
                 i=i+1 
          r=r*x 
          L=L+r/i/i 
         enddo 
         Out=L 
       elseif (x.eq.0) then 
         Out=0d0 
                             !n.eq.2,x>0.5                              
       elseif(x.gt.0.5) then 
         xt = 1.0-x 
         L = pi2by6 - dlog(x)*dlog(xt) 
         do while(i.le.NCUT) 
          i=i+1 
          r=r*xt 
          L=L-r/i/i 
         enddo 
         Out=L 
       elseif (x.lt.(-0.5)) then 
         xt=-x/(1d0-x) 
         L=-0.5*dlog(1-x)**2 
         do while (i.le.NCUT) 
          i=i+1 
          r=r*xt 
          L=L-r/i/i 
         enddo 
         Out=L 
       endif 
                                        !use the expansion of Li3 near x
      elseif (n.eq.3.and.x.ge.0.8) then 
       L=zeta3+pi2by6*dlog(x) 
       xt=(1d0-x) 
       xln1m=dlog(xt) 
       do i=2,m3 
        L=L+(c1(i)+c2(i)*xln1m)*xt**i 
       enddo 
       Out=L 
           !n>3 or x=3,x<0.8                                            
      else 
         do while(i.le.NCUT) 
          i=i+1 
          r=r*x 
          L=L+r/dble(i)**dble(n) 
         enddo 
         Out=L 
      endif 
      CtLhxLi=Out 
          ! CtLhxLi                                                     
      END     

                                      
      FUNCTION CtLhZBRLAM (WLLN) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtTRNCOM / VMULM, JRDR, N, N1 
      WMULM = EXP (WLLN) 
      TEM1 = 1./ CtLhALPQCD(JRDR, N1, WMULM, I) 
      TEM2 = 1./ CtLhALPQCD(JRDR, N,  VMULM, I) 
      CtLhZBRLAM = TEM1 - TEM2 
      END     

                                      
      FUNCTION CtLhZBRNT(FUNC, X1, X2, TOL, IRT) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (ITMAX = 1000, EPS = 3.E-12) 
      external func 
      IRT = 0 
      TOL = ABS(TOL) 
      A=X1 
      B=X2 
      FA=FUNC(A) 
      FB=FUNC(B) 
      IF(FB*FA.GT.0.)  THEN 
        PRINT *, 'Root must be bracketed for CtLhZBRNT. Set = 0' 
        IRT = 1 
        CtLhZBRNT=0. 
        RETURN 
      ENDIF 
      FC=FB 
      DO 11 ITER=1,ITMAX 
        IF(FB*FC.GT.0.) THEN 
          C=A 
          FC=FA 
          D=B-A 
          E=D 
        ENDIF 
        IF(ABS(FC).LT.ABS(FB)) THEN 
          A=B 
          B=C 
          C=A 
          FA=FB 
          FB=FC 
          FC=FA 
        ENDIF 
        TOL1=2.*EPS*ABS(B)+0.5*TOL 
        XM=.5*(C-B) 
        IF(ABS(XM).LE.TOL1 .OR. FB.EQ.0.)THEN 
          CtLhZBRNT=B 
          RETURN 
        ENDIF 
        IF(ABS(E).GE.TOL1 .AND. ABS(FA).GT.ABS(FB)) THEN 
          S=FB/FA 
          IF(A.EQ.C) THEN 
            P=2.*XM*S 
            Q=1.-S 
          ELSE 
            Q=FA/FC 
            R=FB/FC 
            P=S*(2.*XM*Q*(Q-R)-(B-A)*(R-1.)) 
            Q=(Q-1.)*(R-1.)*(S-1.) 
          ENDIF 
          IF(P.GT.0.) Q=-Q 
          P=ABS(P) 
          IF(2.*P .LT. MIN(3.*XM*Q-ABS(TOL1*Q),ABS(E*Q))) THEN 
            E=D 
            D=P/Q 
          ELSE 
            D=XM 
            E=D 
          ENDIF 
        ELSE 
          D=XM 
          E=D 
        ENDIF 
        A=B 
        FA=FB 
        IF(ABS(D) .GT. TOL1) THEN 
          B=B+D 
        ELSE 
          B=B+SIGN(TOL1,XM) 
        ENDIF 
        FB=FUNC(B) 
   11 END DO 
      PRINT *, 'CtLhZBRNT exceeding maximum iterations.' 
      IRT = 2 
      CtLhZBRNT=B 
      RETURN 
      END     

                                      
      FUNCTION CtLhZFRMX (XX) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      LOGICAL LSTX 
      PARAMETER (D0=0D0, D1=1D0, D2=2D0, D3=3D0, D4=4D0, D10=1D1) 
      PARAMETER (MXX = 105) 
      COMMON / LhCtXXARAY / XCR, XMIN, XV(0:MXX), LSTX, NX 
      DATA IWRN1, HUGE, TINY / 0, 1.E35, 1.E-35 / 
      F(X) = (XCR-XMIN) * LOG (X/XMIN) + LOG (XCR/XMIN) * (X-XMIN) 
      D(X) = (XCR-XMIN) / X          + LOG (XCR/XMIN) 
      X = XX 
      IF (X .GE. XMIN) THEN 
         TEM = F(X) / F(D1) 
      ElseIF (X .GE. D0) THEN 
         X = MAX (X, TINY) 
         TEM = F(X) / F(D1) 
      Else 
         CALL CtLhWARNR(IWRN1, 'X out of range in CtLhZFRMX'            &
     &             , 'X', X, TINY, HUGE, 1)                             
         TEM = 99. 
         STOP 
      EndIf 
      CtLhZFRMX = TEM 
      RETURN 
      ENTRY CtLhDZDX (XX) 
      X = XX 
      IF (X .GE. XMIN) THEN 
         TEM = D(X) / F(D1) 
      ElseIF (X .GE. D0) THEN 
         X = MAX (X, TINY) 
         TEM = D(X) / F(D1) 
      Else 
         CALL CtLhWARNR(IWRN1, 'X out of range in CtLhDZDX '            &
     &             , 'X', X, TINY, HUGE, 1)                             
         TEM = 99. 
         STOP 
      EndIf 
      CtLhDZDX = TEM 
      RETURN 
      END     

                                      
      FUNCTION CtLhZFXL (XL) 
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      COMMON / LhCtINVERT / ZA 
      X = EXP(XL) 
      TT = CtLhZFRMX (X) - ZA 
      CtLhZFXL = TT 
      RETURN 
      END                                           

      SUBROUTINE CtLhPOLINT4 (XA,YA,N,X,Y,DY) 
! fast version of polint, valid only for N=4                            
! Have explicitly unrolled the loops.                                   
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
                                                                        
      PARAMETER (NMAX=4) 
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX) 
                                                                        
        if(n .ne. 4) then 
           print *,'fatal CtLhPolint4 call',n 
           stop 
        endif 
                                                                        
      NS=1 
      DIF=ABS(X-XA(1)) 
                                                                        
        DIFT=ABS(X-XA(1)) 
        IF (DIFT.LT.DIF) THEN 
          NS=1 
          DIF=DIFT 
        ENDIF 
        C(1)=YA(1) 
        D(1)=YA(1) 
                                                                        
        DIFT=ABS(X-XA(2)) 
        IF (DIFT.LT.DIF) THEN 
          NS=2 
          DIF=DIFT 
        ENDIF 
        C(2)=YA(2) 
        D(2)=YA(2) 
                                                                        
        DIFT=ABS(X-XA(3)) 
        IF (DIFT.LT.DIF) THEN 
          NS=3 
          DIF=DIFT 
        ENDIF 
        C(3)=YA(3) 
        D(3)=YA(3) 
                                                                        
        DIFT=ABS(X-XA(4)) 
        IF (DIFT.LT.DIF) THEN 
          NS=4 
          DIF=DIFT 
        ENDIF 
        C(4)=YA(4) 
        D(4)=YA(4) 
                                                                        
                                                                        
      Y=YA(NS) 
      NS=NS-1 
                                                                        
                                                                        
          HO=XA(1)-X 
          HP=XA(2)-X 
          W=C(2)-D(1) 
          DEN=W/(HO-HP) 
          D(1)=HP*DEN 
          C(1)=HO*DEN 
                                                                        
                                                                        
          HO=XA(2)-X 
          HP=XA(3)-X 
          W=C(3)-D(2) 
          DEN=W/(HO-HP) 
          D(2)=HP*DEN 
          C(2)=HO*DEN 
                                                                        
                                                                        
          HO=XA(3)-X 
          HP=XA(4)-X 
          W=C(4)-D(3) 
          DEN=W/(HO-HP) 
          D(3)=HP*DEN 
          C(3)=HO*DEN 
                                                                        
        IF (2*NS.LT.3)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
                                                                        
          HO=XA(1)-X 
          HP=XA(3)-X 
          W=C(2)-D(1) 
          DEN=W/(HO-HP) 
          D(1)=HP*DEN 
          C(1)=HO*DEN 
                                                                        
          HO=XA(2)-X 
          HP=XA(4)-X 
          W=C(3)-D(2) 
          DEN=W/(HO-HP) 
          D(2)=HP*DEN 
          C(2)=HO*DEN 
                                                                        
        IF (2*NS.LT.2)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
                                                                        
          HO=XA(1)-X 
          HP=XA(4)-X 
          W=C(2)-D(1) 
          DEN=W/(HO-HP) 
          D(1)=HP*DEN 
          C(1)=HO*DEN 
                                                                        
        IF (2*NS.LT.4-3)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
                                                                        
      RETURN 
      END                                           
      SUBROUTINE CTLHPOLINT3 (XA,YA,N,X,Y,DY) 
! fast version of polint, valid only for N=3                            
! Have explicitly unrolled the loops.                                   
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
      PARAMETER (NMAX=3) 
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX) 
        if(n .ne. 3) then 
           print *,'fatal CtLhPolint3 call',n 
           stop 
        endif 
      NS=1 
      DIF=ABS(X-XA(1)) 
        DIFT=ABS(X-XA(1)) 
        IF (DIFT.LT.DIF) THEN 
          NS=1 
          DIF=DIFT 
        ENDIF 
        C(1)=YA(1) 
        D(1)=YA(1) 
        DIFT=ABS(X-XA(2)) 
        IF (DIFT.LT.DIF) THEN 
          NS=2 
          DIF=DIFT 
        ENDIF 
        C(2)=YA(2) 
        D(2)=YA(2) 
        DIFT=ABS(X-XA(3)) 
        IF (DIFT.LT.DIF) THEN 
          NS=3 
          DIF=DIFT 
        ENDIF 
        C(3)=YA(3) 
        D(3)=YA(3) 
      Y=YA(NS) 
      NS=NS-1 
          HO=XA(1)-X 
          HP=XA(2)-X 
          W=C(2)-D(1) 
          DEN=W/(HO-HP) 
          D(1)=HP*DEN 
          C(1)=HO*DEN 
          HO=XA(2)-X 
          HP=XA(3)-X 
          W=C(3)-D(2) 
          DEN=W/(HO-HP) 
          D(2)=HP*DEN 
          C(2)=HO*DEN 
        IF (2*NS.LT.2)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
          HO=XA(1)-X 
          HP=XA(3)-X 
          W=C(2)-D(1) 
          DEN=W/(HO-HP) 
          D(1)=HP*DEN 
          C(1)=HO*DEN 
        IF (2*NS.LT.1)THEN 
          DY=C(NS+1) 
        ELSE 
          DY=D(NS) 
          NS=NS-1 
        ENDIF 
        Y=Y+DY 
      RETURN 
      END                                           

! -*- F90 -*-


      subroutine MRST2006evolve(x,Q,pdf) 
      implicit none 
!      implicit real*8 (a-h,o-z)                                        
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer i,f,nhess,nx,nq,np,nqc0,nqb0,nqc,nqb,n,m,io 
      double precision x,q,xmin,xmax,qsqmin,qsqmax,emc2,emb2,eps,       &
     &   dummy,qsq,xlog,qsqlog,res,ExtrapLHAPDF,InterpLHAPDF            
      double precision emc2minuseps,emb2minuseps 
      double precision xsave,q2save 
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      double precision pdf(-6:6),alfas,Qalfa,Q2fit,eorder 
      double precision upv,dnv,glu,usea,str,dsea,sbar,chm,bot 
      integer iset,nflav,mem,nset,nmem(nmxset),ndef(nmxset),mmem,imem 
      common/NAME/name,nmem,ndef,mmem 
      parameter(nx=64,nq=48,np=9,nqc0=4,nqb0=14,nqc=nq-nqc0,nqb=nq-nqb0) 
      parameter(xmin=1d-6,xmax=1d0,qsqmin=1d0,qsqmax=1d9,eps=1d-6) 
                                                       ! MRST 2006 NNLO 
      parameter(nhess=30,emc2=1.43d0**2,emb2=4.3d0**2) 
      parameter(emc2minuseps=emc2-eps,emb2minuseps=emb2-eps) 
      double precision f1(nx,nq),f2(nx,nq),f3(nx,nq),f4(nx,nq),         &
     &     f5(nx,nq),f6(nx,nq),f7(nx,nq),f8(nx,nq),fc(nx,nqc),          &
     &     fb(nx,nqb),f9(nx,nq)                                         
      double precision qq(nq),xx(nx),cc1(0:nhess,nx,nq,4,4),            &
     &     cc2(0:nhess,nx,nq,4,4),cc3(0:nhess,nx,nq,4,4),               &
     &     cc4(0:nhess,nx,nq,4,4),cc6(0:nhess,nx,nq,4,4),               &
     &     cc8(0:nhess,nx,nq,4,4),cc9(0:nhess,nx,nq,4,4),               &
     &     ccc(0:nhess,nx,nqc,4,4),ccb(0:nhess,nx,nqb,4,4)              
      double precision xxl(nx),qql(nq),qqlc(nqc),qqlb(nqb) 
      data xx/1d-6,2d-6,4d-6,6d-6,8d-6,                                 &
     &     1d-5,2d-5,4d-5,6d-5,8d-5,                                    &
     &     1d-4,2d-4,4d-4,6d-4,8d-4,                                    &
     &     1d-3,2d-3,4d-3,6d-3,8d-3,                                    &
     &     1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2,                        &
     &           .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0,     &
     &           .3d0,.325d0,.35d0,.375d0,.4d0,.425d0,.45d0,.475d0,     &
     &           .5d0,.525d0,.55d0,.575d0,.6d0,.625d0,.65d0,.675d0,     &
     &     .7d0,.725d0,.75d0,.775d0,.8d0,.825d0,.85d0,.875d0,           &
     &     .9d0,.925d0,.95d0,.975d0,1d0/                                
      data qq/1.d0,                                                     &
     &     1.25d0,1.5d0,emc2minuseps,emc2,2.5d0,3.2d0,4d0,5d0,6.4d0,8d0,&
     &     1d1,1.2d1,emb2minuseps,emb2,2.6d1,4d1,6.4d1,1d2,             &
     &     1.6d2,2.4d2,4d2,6.4d2,1d3,1.8d3,3.2d3,5.6d3,1d4,             &
     &     1.8d4,3.2d4,5.6d4,1d5,1.8d5,3.2d5,5.6d5,1d6,                 &
     &     1.8d6,3.2d6,5.6d6,1d7,1.8d7,3.2d7,5.6d7,1d8,                 &
     &     1.8d8,3.2d8,5.6d8,1d9/                                       
      save 
                                                                        
      xsave=x 
      qsq=q*q 
      q2save=qsq 
                                                                        
                                                                        
      if (qsq.gt.qq(nqc0).and.qsq.lt.qq(nqc0+1)) qsq = qq(nqc0) 
      if (qsq.gt.qq(nqb0).and.qsq.lt.qq(nqb0+1)) qsq = qq(nqb0) 
                                                                        
      xlog=log10(x) 
      qsqlog=log10(qsq) 
                                                                        
      call getnset(iset) 
      call getnmem(iset,imem) 
                                                                        
      upv =  0.d0 
      dnv =  0.d0 
      glu =  0.d0 
      usea = 0.d0 
      str =  0.d0 
      dsea = 0.d0 
      sbar = 0.d0 
      chm =  0.d0 
      bot =  0.d0 
                                                                        
      if (x.le.0.d0.or.x.gt.xmax.or.qsq.lt.qsqmin) then 
         print *,"Error in GetOnePDF: x,qsq = ",x,qsq 
                                                ! extrapolate           
      else if (x.lt.xmin.or.qsq.gt.qsqmax) then 
         print *, "Warning in GetOnePDF, extrapolating: f = ",f,        &
     &           ", x = ",x,", q = ",q                                  
         upv =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc1) 
         dnv =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc2) 
         glu =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc3) 
         usea = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc4) 
         str =  ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc6) 
         dsea = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc8) 
         sbar = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc9) 
                               ! chm                                    
         if (qsq.ge.emc2) then 
        chm = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nqc,xxl,qqlc,ccc) 
         endif 
                               ! bot                                    
         if (qsq.ge.emb2) then 
        bot = ExtrapLHAPDF(imem,nhess,xlog,qsqlog,nx,nqb,xxl,qqlb,ccb) 
         endif 
      else 
         upv =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc1) 
         dnv =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc2) 
         glu =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc3) 
         usea = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc4) 
         str =  InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc6) 
         dsea = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc8) 
         sbar = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nq,xxl,qql,cc9) 
                               ! chm                                    
         if (qsq.ge.emc2) then 
        chm = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nqc,xxl,qqlc,ccc) 
         endif 
                               ! bot                                    
         if (qsq.ge.emb2) then 
        bot = InterpLHAPDF(imem,nhess,xlog,qsqlog,nx,nqb,xxl,qqlb,ccb) 
         endif 
                                                                        
      end if 
                                                                        
      pdf(0)  = glu 
      pdf(1)  = dnv+dsea 
      pdf(-1) = dsea 
      pdf(2)  = upv+usea 
      pdf(-2) = usea 
      pdf(3)  = str 
      pdf(-3) = sbar 
      pdf(4)  = chm 
      pdf(-4) = chm 
      pdf(5)  = bot 
      pdf(-5) = bot 
      pdf(6)  = 0.0d0 
      pdf(-6) = 0.0d0 
                                                                        
      x=xsave 
      qsq=q2save 
      return 
!                                                                       
                                                                        
      entry MRST2006getgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=1,nx
          gridx(jx)=xx(jx)
      enddo
      do jq=1,nq
          gridq(jq)=qq(jq)
      enddo
      ngridx=nx
      ngridq=nq        
      return
!---------------------------------------------------------------------- 
                                                                        
      entry MRST2006read(nset) 
         read(1,*)nmem(nset),ndef(nset) 
                                                                        
                                                                        
      do i = 0,nhess 
                                                                        
                                                                        
        do  n=1,nx-1 
          do  m=1,nq 
!            print *,i,n,m                                              
            read(1,50) f1(n,m),f2(n,m),f3(n,m),f4(n,m),                 &
     &           f5(n,m),f7(n,m),f6(n,m),f8(n,m),f9(n,m)                
!            write(6,50) f1(n,m),f2(n,m),f3(n,m),f4(n,m),               
!     &           f5(n,m),f7(n,m),f6(n,m),f8(n,m),f9(n,m)               
!--   Notation:1=upv 2=dnv 3=glu 4=usea 5=chm 6=str 7=bot 8=dsea 9=sbar 
          enddo 
        enddo 
!      write(*,*)'PDF set ',i,' first element ',f1(1,1)                 
          do m=1,nq 
             f1(nx,m)=0d0 
             f2(nx,m)=0d0 
             f3(nx,m)=0d0 
             f4(nx,m)=0d0 
             f5(nx,m)=0d0 
             f6(nx,m)=0d0 
             f7(nx,m)=0d0 
             f8(nx,m)=0d0 
             f9(nx,m)=0d0 
          enddo 
                                                                        
          do n=1,nx 
             xxl(n)=log10(xx(n)) 
          enddo 
          do m=1,nq 
             qql(m)=log10(qq(m)) 
          enddo 
                                                                        
          call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f1,cc1) 
          call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f2,cc2) 
          call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f3,cc3) 
          call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f4,cc4) 
          call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f6,cc6) 
          call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f8,cc8) 
          call InitialLHAPDF(i,nhess,nx,nq,nqc0,nqb0,xxl,qql,f9,cc9) 
                                                                        
          do m=1,nqc 
             qqlc(m)=qql(m+nqc0) 
             do  n=1,nx 
                fc(n,m)=f5(n,m+nqc0) 
             enddo 
          enddo 
          call InitialLHAPDF(i,nhess,nx,nqc,nqc0-nqc0,nqb0-nqc0,        &
     &     xxl,qqlc,fc,ccc)                                             
                                                                        
          do m=1,nqb 
             qqlb(m)=qql(m+nqb0) 
             do n=1,nx 
                fb(n,m)=f7(n,m+nqb0) 
             enddo 
          enddo 
          call InitialLHAPDF(i,nhess,nx,nqb,nqc0-nqb0,nqb0-nqb0,        &
     &     xxl,qqlb,fb,ccb)                                             
                                                                        
      enddo 
                                                                        
   50 format(9e13.5) 
      return 
!---------------------------------------------------------------------- 
                                                                        
      entry MRST2006alfa(nflav,alfas,Qalfa) 
!        print *,'MRST2006alfa',nflav,alfas,Qalfa                       
        call getnset(iset) 
        call alphamrs(nflav,alfas,Qalfa) 
!        print *,'MRST2006alfa',nflav,alfas,Qalfa                       
      return 
!                                                                       
!---------------------------------------------------------------------- 
      entry MRST2006init(Eorder,Q2fit) 
      return 
!---------------------------------------------------------------------- 
!                                                                       
      entry MRST2006pdf(mem) 
        call getnset(iset) 
        call setnmem(iset,mem) 
      return 
!                                                                       
      END                                           
                                                                        
!---------------------------------------------------------------------- 
                                                                        
      subroutine InitialLHAPDF(i,nhess,nx,my,myc0,myb0,xx,yy,ff,cc) 
      implicit none 
      integer nhess,i,nx,my,myc0,myb0,j,k,l,m,n 
      double precision xx(nx),yy(my),ff(nx,my),                         &
     &     ff1(nx,my),ff2(nx,my),                                       &
     &     ff12(nx,my),yy0(4),yy1(4),yy2(4),yy12(4),z(16),              &
     &     cl(16),cc(0:nhess,nx,my,4,4),iwt(16,16),                     &
     &     dx,dy,polderiv,d1,d2,d1d2,xxd                                
                                                                        
      data iwt/1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                         &
     &     0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,                             &
     &     -3,0,0,3,0,0,0,0,-2,0,0,-1,0,0,0,0,                          &
     &     2,0,0,-2,0,0,0,0,1,0,0,1,0,0,0,0,                            &
     &     0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,                             &
     &     0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,                             &
     &     0,0,0,0,-3,0,0,3,0,0,0,0,-2,0,0,-1,                          &
     &     0,0,0,0,2,0,0,-2,0,0,0,0,1,0,0,1,                            &
     &     -3,3,0,0,-2,-1,0,0,0,0,0,0,0,0,0,0,                          &
     &     0,0,0,0,0,0,0,0,-3,3,0,0,-2,-1,0,0,                          &
     &     9,-9,9,-9,6,3,-3,-6,6,-6,-3,3,4,2,1,2,                       &
     &     -6,6,-6,6,-4,-2,2,4,-3,3,3,-3,-2,-1,-1,-2,                   &
     &     2,-2,0,0,1,1,0,0,0,0,0,0,0,0,0,0,                            &
     &     0,0,0,0,0,0,0,0,2,-2,0,0,1,1,0,0,                            &
     &     -6,6,-6,6,-3,-3,3,3,-4,4,2,-2,-2,-2,-1,-1,                   &
     &     4,-4,4,-4,2,2,-2,-2,2,-2,-2,2,1,1,1,1/                       
                                                                        
      do m=1,my 
         dx=xx(2)-xx(1) 
         ff1(1,m)=(ff(2,m)-ff(1,m))/dx 
         dx=xx(nx)-xx(nx-1) 
         ff1(nx,m)=(ff(nx,m)-ff(nx-1,m))/dx 
         do n=2,nx-1 
            ff1(n,m)=polderiv(xx(n-1),xx(n),xx(n+1),ff(n-1,m),ff(n,m),  &
     &           ff(n+1,m))                                             
         enddo 
      enddo 
                                                                        
!--   Calculate the derivatives at qsq=emc2-eps,emc2,emb2-eps,emb2      
!--   in a similar way as at the endpoints qsqmin and qsqmax.           
      do n=1,nx 
         do m = 1, my 
            if (m.eq.1.or.m.eq.myc0+1.or.m.eq.myb0+1) then 
               dy=yy(m+1)-yy(m) 
               ff2(n,m)=(ff(n,m+1)-ff(n,m))/dy 
            else if (m.eq.my.or.m.eq.myc0.or.m.eq.myb0) then 
               dy=yy(m)-yy(m-1) 
               ff2(n,m)=(ff(n,m)-ff(n,m-1))/dy 
            else 
               ff2(n,m)=polderiv(yy(m-1),yy(m),yy(m+1),ff(n,m-1),       &
     &              ff(n,m),ff(n,m+1))                                  
            end if 
         end do 
      end do 
                                                                        
      do m=1,my 
         dx=xx(2)-xx(1) 
         ff12(1,m)=(ff2(2,m)-ff2(1,m))/dx 
         dx=xx(nx)-xx(nx-1) 
         ff12(nx,m)=(ff2(nx,m)-ff2(nx-1,m))/dx 
         do n=2,nx-1 
            ff12(n,m)=polderiv(xx(n-1),xx(n),xx(n+1),ff2(n-1,m),        &
     &           ff2(n,m),ff2(n+1,m))                                   
         enddo 
      enddo 
                                                                        
      do n=1,nx-1 
         do m=1,my-1 
            d1=xx(n+1)-xx(n) 
            d2=yy(m+1)-yy(m) 
            d1d2=d1*d2 
                                                                        
            yy0(1)=ff(n,m) 
            yy0(2)=ff(n+1,m) 
            yy0(3)=ff(n+1,m+1) 
            yy0(4)=ff(n,m+1) 
                                                                        
            yy1(1)=ff1(n,m) 
            yy1(2)=ff1(n+1,m) 
            yy1(3)=ff1(n+1,m+1) 
            yy1(4)=ff1(n,m+1) 
                                                                        
            yy2(1)=ff2(n,m) 
            yy2(2)=ff2(n+1,m) 
            yy2(3)=ff2(n+1,m+1) 
            yy2(4)=ff2(n,m+1) 
                                                                        
            yy12(1)=ff12(n,m) 
            yy12(2)=ff12(n+1,m) 
            yy12(3)=ff12(n+1,m+1) 
            yy12(4)=ff12(n,m+1) 
                                                                        
            do k=1,4 
               z(k)=yy0(k) 
               z(k+4)=yy1(k)*d1 
               z(k+8)=yy2(k)*d2 
               z(k+12)=yy12(k)*d1d2 
            enddo 
                                                                        
            do l=1,16 
               xxd=0.d0 
               do k=1,16 
                  xxd=xxd+iwt(k,l)*z(k) 
               enddo 
               cl(l)=xxd 
            enddo 
            l=0 
            do k=1,4 
               do j=1,4 
                  l=l+1 
                  cc(i,n,m,k,j)=cl(l) 
               enddo 
            enddo 
         enddo 
      enddo 
      return 
      END                                           
                                                                        
!---------------------------------------------------------------------- 
                                                                        
      double precision function InterpLHAPDF(i,nhess,x,y,nx,my,xx,yy,   &
     &     cc)                                                          
      implicit none 
      integer i,nx,my,nhess,locx,l,m,n 
      double precision xx(nx),yy(my),cc(0:nhess,nx,my,4,4),             &
     &     x,y,z,t,u                                                    
                                                                        
      n=locx(xx,nx,x) 
      m=locx(yy,my,y) 
                                                                        
      t=(x-xx(n))/(xx(n+1)-xx(n)) 
      u=(y-yy(m))/(yy(m+1)-yy(m)) 
                                                                        
      z=0.d0 
      do l=4,1,-1 
         z=t*z+((cc(i,n,m,l,4)*u+cc(i,n,m,l,3))*u                       &
     &        +cc(i,n,m,l,2))*u+cc(i,n,m,l,1)                           
      enddo 
                                                                        
      InterpLHAPDF = z 
                                                                        
      return 
      END                                           
                                                                        
!---------------------------------------------------------------------- 
                                                                        
      double precision function ExtrapLHAPDF(i,nhess,x,y,nx,my,xx,yy,   &
     &     cc)                                                          
      implicit none 
      integer i,nx,my,nhess,locx,n,m 
      double precision xx(nx),yy(my),cc(0:nhess,nx,my,4,4),             &
     &     x,y,z,f0,f1,z0,z1,InterpLHAPDF                               
                                                                        
                                ! 0: below xmin, nx: above xmax         
      n=locx(xx,nx,x) 
                                ! 0: below qsqmin, my: above qsqmax     
      m=locx(yy,my,y) 
                                                                        
!--   If extrapolation in small x only:                                 
      if (n.eq.0.and.m.gt.0.and.m.lt.my) then 
         f0 = InterpLHAPDF(i,nhess,xx(1),y,nx,my,xx,yy,cc) 
         f1 = InterpLHAPDF(i,nhess,xx(2),y,nx,my,xx,yy,cc) 
         if (f0.gt.0.d0.and.f1.gt.0.d0) then 
            z = exp(log(f0)+(log(f1)-log(f0))/(xx(2)-xx(1))*(x-xx(1))) 
         else 
            z = f0+(f1-f0)/(xx(2)-xx(1))*(x-xx(1)) 
         end if 
!--   If extrapolation into large q only:                               
      else if (n.gt.0.and.m.eq.my) then 
         f0 = InterpLHAPDF(i,nhess,x,yy(my),nx,my,xx,yy,cc) 
         f1 = InterpLHAPDF(i,nhess,x,yy(my-1),nx,my,xx,yy,cc) 
         if (f0.gt.0.d0.and.f1.gt.0.d0) then 
            z = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))*        &
     &           (y-yy(my)))                                            
         else 
            z = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my)) 
         end if 
!--   If extrapolation into large q AND small x:                        
      else if (n.eq.0.and.m.eq.my) then 
         f0 = InterpLHAPDF(i,nhess,xx(1),yy(my),nx,my,xx,yy,cc) 
         f1 = InterpLHAPDF(i,nhess,xx(1),yy(my-1),nx,my,xx,yy,cc) 
         if (f0.gt.0.d0.and.f1.gt.0.d0) then 
            z0 = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))*       &
     &           (y-yy(my)))                                            
         else 
            z0 = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my)) 
         end if 
         f0 = InterpLHAPDF(i,nhess,xx(2),yy(my),nx,my,xx,yy,cc) 
         f1 = InterpLHAPDF(i,nhess,xx(2),yy(my-1),nx,my,xx,yy,cc) 
         if (f0.gt.0.d0.and.f1.gt.0.d0) then 
            z1 = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))*       &
     &           (y-yy(my)))                                            
         else 
            z1 = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my)) 
         end if 
         if (z0.gt.0.d0.and.z1.gt.0.d0) then 
            z = exp(log(z0)+(log(z1)-log(z0))/(xx(2)-xx(1))*(x-xx(1))) 
         else 
            z = z0+(z1-z0)/(xx(2)-xx(1))*(x-xx(1)) 
         end if 
      else 
         print *,"Error in ExtrapLHAPDF" 
         stop 
      end if 
                                                                        
      ExtrapLHAPDF = z 
                                                                        
      return 
      END                                           

! -*- F90 -*-

!-------------------------------------------------------------------
!--   Example program to demonstrate usage of the MSTW 2008 PDFs. --
!--   LHAPDF version by Graeme Watt <watt(at)hep.ucl.ac.uk>.      --
!-------------------------------------------------------------------

PROGRAM Example8
  
  IMPLICIT NONE
  INTEGER iset,ieigen,neigen,ix,nx,iq,nq,flav,nhess
  DOUBLE PRECISION x,q,xmin,xmax,q2min,q2max, &
       &     xf(-6:6),xfp(-6:6),xfm(-6:6), &
       &     summin(-6:6),summax(-6:6),sum(-6:6), &
       &     mCharm,mBottom,qcdl4,qcdl5,alphasPDF,MZ
  CHARACTER flavours(-5:5)*10,xfilename(-5:5)*50,qfilename(-5:5)*50
  DATA flavours /"bbar","cbar","sbar","ubar","dbar","glu", &
       &     "dn","up","str","chm","bot"/
  
  call SetLHAPARM('EXTRAPOLATE') ! extrapolate beyond grids

  !-- Two sets of error PDFs are provided for each fit, corresponding to
  !-- an estimated 90% C.L. (as for previous MRST and CTEQ sets) or to
  !-- a 68% (one-sigma) C.L.: see Section 6 of arXiv:0901.0002.
  !-- The central PDF set is the same in both cases.

  call InitPDFSetByNameM(1,"MSTW2008lo90cl.LHgrid") ! 90% C.L.
  call InitPDFSetByNameM(2,"MSTW2008nlo90cl.LHgrid") ! 90% C.L.
  call InitPDFSetByNameM(3,"MSTW2008nnlo90cl.LHgrid") ! 90% C.L.

  !call InitPDFSetByNameM(1, "MSTW2008lo68cl.LHgrid") ! 68% C.L.
  !call InitPDFSetByNameM(2, "MSTW2008nlo68cl.LHgrid") ! 68% C.L.
  !call InitPDFSetByNameM(3, "MSTW2008nnlo68cl.LHgrid") ! 68% C.L.

  ! Print out values of mCharm and mBottom.
  call GetQmassM(3,4,mCharm)
  call GetQmassM(3,5,mBottom)
  write(6,*) "mCharm,mBottom = ",mCharm,mBottom

  ! Print out values of alphaS(MZ) for each fit.
  MZ = 91.1876D0
  Call InitPDFM(1,0) ! central set
  WRITE(6,'("LO: alphaS(MZ) = ",F7.5)') alphasPDF(MZ)
  Call InitPDFM(2,0) ! central set
  WRITE(6,'("NLO: alphaS(MZ) = ",F7.5)') alphasPDF(MZ)
  Call InitPDFM(3,0) ! central set
  WRITE(6,'("NNLO: alphaS(MZ) = ",F7.5)') alphasPDF(MZ)

  ! Warning: values of qcdl4 and qcdl5 set to zero since no longer used.
  call GetLam4M(3,0,qcdl4)
  call GetLam5M(3,0,qcdl5)
  write(6,*) "qcdl4,qcdl5 = ",qcdl4,qcdl5

  !----------------------------------------------------------------------

  !--   Calculate the uncertainty on the parton distributions using both
  !--   the formula for asymmetric errors [eqs.(51,52) of arXiv:0901.0002]
  !--   and the formula for symmetric errors [eq.(50) of same paper].

  !-- Select either the LO, NLO or NNLO fits.
  !  iset = 1 ! LO
  !  iset = 2 ! NLO
  iset = 3 ! NNLO

  !--   First get xf as a function of x at a fixed value of q.
  !--   Extrapolation will be used for x < 10^-6.
  q = 1.d1
  nx = 100
  xmin = 1.d-7
  xmax = 0.99d0
  DO flav = -5, 5
     xfilename(flav) = "x"//flavours(flav)(1:len_trim(flavours(flav))) &
          &        //"_vs_x.dat"
     OPEN(UNIT=20+flav,FILE=xfilename(flav))
     WRITE(20+flav,'(" # q = ",1PE12.4)') q
     WRITE(20+flav,'(A2,A10,4A12)') " #","x","x"// &
          &        flavours(flav)(1:len_trim(flavours(flav))), &
          &        "error+","error-","error"
  END DO ! flav
  DO ix = 1, nx
     !--   Assign x values distributed logarithmically.
     x = 10.d0**(log10(xmin) + (ix-1.D0)/(nx-1.D0)* &
          & (log10(xmax)-log10(xmin)))
     Call initPDFM(iset,0) ! central set
     Call evolvePDFM(iset,x,q,xf)
     DO flav = -5, 5
        summax(flav) = 0.d0
        summin(flav) = 0.d0
        sum(flav) = 0.d0
     END DO
     Call numberPDFM(iset,nhess)  ! number of eigenvector PDF sets
     neigen = nhess/2
     DO ieigen = 1, neigen ! loop over eigenvector sets
        Call initPDFM(iset,2*ieigen-1) ! "+" direction
        call evolvePDFM(iset,x,q,xfp)
        Call initPDFM(iset,2*ieigen) ! "-" direction
        call evolvePDFM(iset,x,q,xfm)
        DO flav = -5, 5
           summax(flav) = summax(flav) + &
                & (max(xfp(flav)-xf(flav),xfm(flav)-xf(flav),0.d0))**2
           summin(flav) = summin(flav) + &
                & (max(xf(flav)-xfp(flav),xf(flav)-xfm(flav),0.d0))**2
           sum(flav) = sum(flav)+(xfp(flav)-xfm(flav))**2
        END DO ! flav
     END DO ! ieigen
     DO flav = -5, 5
        WRITE(20+flav,'(1P5E12.4)') x,xf(flav), &
             & sqrt(summax(flav)),sqrt(summin(flav)),0.5d0*sqrt(sum(flav))
     END DO ! flav
  END DO ! ix
  DO flav = -5, 5
     CLOSE(UNIT=20+flav)
     WRITE(6,*) "x"//flavours(flav)(1:len_trim(flavours(flav))), &
          &        " vs. x for q2 = ",q**2," written to ", &
          &        xfilename(flav)(1:len_trim(xfilename(flav)))
  END DO ! flav

  !--   Now get xf as a function of q^2 at a fixed value of x.
  !--   Extrapolation will be used for q^2 < 1 GeV^2 and for q^2 > 10^9 GeV^2.
  x = 1.d-3
  nq = 100
  q2min = 5.d-1
  q2max = 1.d10
  DO flav = -5, 5
     qfilename(flav) = "x"//flavours(flav)(1:len_trim(flavours(flav))) &
          &        //"_vs_q2.dat"
     OPEN(UNIT=20+flav,FILE=qfilename(flav))
     WRITE(20+flav,'(" # x = ",1PE12.4)') x
     WRITE(20+flav,'(A2,A10,4A12)') " #","q2","x"// &
          &        flavours(flav)(1:len_trim(flavours(flav))), &
          &        "error+","error-","error"
  END DO ! flav
  DO iq = 1, nq
     !--   Assign q2 values distributed logarithmically.
     q = sqrt(10.d0**(log10(q2min) + (iq-1.D0)/(nq-1.D0)* &
          &           (log10(q2max)-log10(q2min))))
     Call initPDFM(iset,0) ! central set
     Call evolvePDFM(iset,x,q,xf)
     DO flav = -5, 5
        summax(flav) = 0.d0
        summin(flav) = 0.d0
        sum(flav) = 0.d0
     END DO
     Call numberPDFM(iset,nhess)  ! number of eigenvector PDF sets
     neigen = nhess/2
     DO ieigen = 1, neigen ! loop over eigenvector sets
        Call initPDFM(iset,2*ieigen-1) ! "+" direction
        call evolvePDFM(iset,x,q,xfp)
        Call initPDFM(iset,2*ieigen) ! "-" direction
        call evolvePDFM(iset,x,q,xfm)
        DO flav = -5, 5
           summax(flav) = summax(flav) + &
                & (max(xfp(flav)-xf(flav),xfm(flav)-xf(flav),0.d0))**2
           summin(flav) = summin(flav) + &
                & (max(xf(flav)-xfp(flav),xf(flav)-xfm(flav),0.d0))**2
           sum(flav) = sum(flav)+(xfp(flav)-xfm(flav))**2
        END DO ! flav
     END DO ! ieigen        
     DO flav = -5, 5     
        WRITE(20+flav,'(1P5E12.4)') q**2,xf(flav), &
             & sqrt(summax(flav)),sqrt(summin(flav)),0.5d0*sqrt(sum(flav))
     END DO ! flav
  END DO ! iq
  DO flav = -5, 5
     CLOSE(UNIT=20+flav)
     WRITE(6,*) "x"//flavours(flav)(1:len_trim(flavours(flav))), &
          &        " vs. q2 for x = ",x," written to ", &
          &        qfilename(flav)(1:len_trim(qfilename(flav)))
  END DO ! flav

  STOP
END PROGRAM Example8
!----------------------------------------------------------------------

!////////////////////////////////////////////////////////////////
!/ Program to demonstrate usage of the MRST 2006 NNLO PDFs.    //
!/ to calculate errors.   Fortan version                       //
!////////////////////////////////////////////////////////////////
! Main program
  Implicit Double Precision (a-h,o-z)
  Character*80 Name
  Double Precision plus,minus,diff
  Dimension fc(0:9),x(0:9),f(-6:6)
  Dimension summax(0:9), summin(0:9), sum(0:9)
  Integer flav
  ! Show initialisation banner only once
  Call SetLHAParm('LOWKEY') ! or SILENT, for no banner at all

  ! You could explicitly set the path to the PDFsets directory
  ! Call setPDFPath("/home/whalley/local/share/lhapdf/PDFsets")

  ! Initialize PDF sets
  Name = "MSTW2008nnlo90cl.LHgrid"
  Call initPDFSetByNameM(1, Name)
  Call initPDFSetByNameM(2, Name)
  Call initPDFSetByNameM(3, Name)

  ! Find the number of eigensets from numberPDF()
  Call numberPDFM(1,neigen)
  neigen = neigen/2
  print *,"Number of eigensets in this fit = ",neigen
  ! Find the min and max values of x and Q2
  Call getXmin(0,xmin)
  Call getXmax(0,xmax)
  print *,"Valid x-range = [",xmin,", ",xmax,"]"
  ! Number of x values to sample
  nx = 10
  ! Set the Q scale and flavour
  q = 10d0
  flav = 4

  ! Get x's and central PDF values
  Call initPDFM(1, 0)
  do ix=0,nx-1
    x(ix) = xlogdist_x(xmin, 0.9*xmax, ix, nx)
    call evolvePDFM(1, x(ix), q, f)
    fc(ix)=f(flav)
    summax(ix) = 0.0d0
    summin(ix) = 0.0d0
    sum(ix) = 0.0d0
  enddo

  ! Sum over error contributions (two ways, depending on how LHDPAF was compiled)
  do ieigen=1,neigen
    call initPDFM(2, 2*ieigen-1)
    call initPDFM(3, 2*ieigen)
    do ix=0,nx-1
      ! Find central and plus/minus values
      call evolvePDFM(2, x(ix), q, f)
      fp = f(flav)
      call evolvePDFM(3, x(ix), q, f)
      fm = f(flav)
      ! Construct shifts
      plus = max(max(fp-fc(ix), fm-fc(ix)),0.0d0)
      minus = min(min(fp-fc(ix), fm-fc(ix)),0.0d0)
      diff = fp-fm
      ! Add it together
      summax(ix) = summax(ix) + plus*plus
      summin(ix) = summin(ix) + minus*minus
      sum(ix) = sum(ix) +  diff*diff
    enddo
  enddo

  print *,"flavour = ",flav,"    Asymmetric (%)   Symmetric (%)"
  print *,"     x    Q**2    xf(x)    plus    minus      +-      "
  do ix=0,nx-1
     eplus = dsqrt(summax(ix))*100/fc(ix)
     eminus=  dsqrt(summin(ix))*100/fc(ix)
     eavge =  0.5*dsqrt(sum(ix))*100/fc(ix)
     print 1000, x(ix), q*q, fc(ix), eplus, eminus, eavge
  enddo
  stop
1000 format(1x,f10.7,f5.0,1pe10.2,0pf8.2,f8.2,f8.2)
  end

 double precision function xlogdist_x(xmin,xmax,ix,nx)
  implicit double precision (a-h,o-z)
 ! print *,xmin,xmax,ix,nx
  xlog10xmin = dlog10(xmin)
  xlog10xmax = dlog10(xmax)
  xlog10x = xlog10xmin + (dfloat(ix)/dfloat(nx-1))*(xlog10xmax-xlog10xmin)
 ! print *,xlog10xmin,xlog10xmax,xlog10x
  xlogdist_x = 10.0d0**xlog10x
  return
 end

! -*- F90 -*-


subroutine GetOrderPDF(order)
  implicit none
  integer nset,order
  double precision Q,Q2
  nset = 1
  call GetOrderPDFM(nset,order)
  return

  entry GetRenFac(Q)
  nset = 1
  call GetRenFacM(nset,Q)
  return

  entry GetQ2fit(Q2)
  nset = 1
  call GetQ2fitM(nset,Q2)
  return
end subroutine GetOrderPDF

subroutine InitEvolve(nset)
  implicit none
  character*16 s2
  character*64 ctemp
  double precision Q,Q2,Q2fit,muR
  integer nset,order,EvlOrd,nFlav,nf,i1,i2,i3
  
  save EvlOrd,Q2fit,muR,nFlav
  
  EvlOrd=-1
  read(1,'(a)') ctemp
  i1=index(ctemp,',')
  i2=index(ctemp(i1+1:),',')
  i3=index(ctemp(i1+i2+1:),',')
  if(i3>0) then
    read(ctemp,*) s2,Q2fit,muR,nFlav
  else
    read(ctemp,*) s2,Q2fit,muR
    nFlav=-1
  endif
  if (index(s2,'lo').eq.1) EvlOrd=0
  if (index(s2,'nlo').eq.1) EvlOrd=1
  if (index(s2,'nnlo').eq.1) EvlOrd=2
  if (EvlOrd.lt.0) then
     write(*,*) 'File description error:'
     write(*,*) 'Unknown PDF evolution order ',s2
     stop
  endif
  if (muR.ne.1.0d0) then
     write(*,*) '***********************************************'
     write(*,*) '* Note than the renormalization scale is      *'
     write(*,*) '* unequal to the factorization scale for this *'
     write(*,*) '* particular PDF set.                         *'
     write(*,*) '* See manual for proper use.                  *'
     write(*,*) '***********************************************'
  endif
  ! print *,'calling readevolve', nset
  call readevolve(nset)
  return
  
  entry InitEvolveCode(nset)
  !print *,'calling initevolution', nset,Evlord,Q2fit
  call initevolution(nset,EvlOrd,Q2fit)
  return
  
  entry GetOrderPDFM(nset,order)
  order=EvlOrd
  return
  
  entry GetRenFacM(nset,Q)
  Q=muR
  return

  entry GetQ2fitM(nset,Q2)
  Q2=Q2fit
  return  

  entry GetNFlavM(nset,nf)
  nf=nFlav
  return  

end subroutine InitEvolve

program example5

! Using lhaglue for 3 different PDF sets proton/photon/pion 
! Using setpdfpath to define the path
! Using PDFsta for statistics
 
  implicit double precision (a-h,o-z)
  character*20 parm(20)
  double precision value(20),g(3)
  integer inset(3)
  data inset/20200,391,231/ 
  common/W50513/xmin,xmax,q2min,q2max

  parm(1)='DEFAULT'
  call setlhaparm('SILENT')
  !call setpdfpath('../PDFsets')
  qmz = 91.180d0      
  ip2 = 0
  p2 = 0.0d0
  do j=1,3  
     print *,'PDF set ',j,' is PDF set number ',inset(j)
     value(1)=inset(j)
     call pdfset(parm,value)
     call getdescm(j)
     call getlam4m(j,0,xlam4)
     call getlam5m(j,0,xlam5)
     a=alphasPDF(QMZ)
     print *,'PDF number, alpha_s(mz), xmin, xmax, q2min, q2max, lambda4, lambda5'
     print *,value(1),a,xmin,xmax,q2min,q2max,xlam4,xlam5
     write(*,*) '---------------------------------------------'
  enddo
  Q=100.0d0
  q2 = q*q
  print *,'x*gluon at Q = 100 GeV'
  print *,'PDF sets: ',(inset(j),j=1,3)
  write(*,*) '---------------------------------------------'
  do ix=10,95,10
     x = dfloat(ix)*1.0d-03
     do j=1,3
        value(1)=inset(j)
        call pdfset(parm,value)
        if(value(1).ge.300.and.value(1).le.399) then
           ! call structp(x,q2,p2,ip2,upv,dnv,usea,dsea,str,chm,bot,top,glu)
           call structm(x,q,upv,dnv,usea,dsea,str,chm,bot,top,glu)
        else
           call structm(x,q,upv,dnv,usea,dsea,str,chm,bot,top,glu)
        endif
        g(j)=glu
     enddo
     write(*,*) x,(g(j),j=1,3)
  enddo

  call PDFsta
end program example5

! -*- F90 -*-

!-- LHAPDF version of MSTW interpolation code and alphaS routines.
!-- 22/01/2009 by Graeme Watt <watt(at)hep.ucl.ac.uk>

!-- Modified to allow possibility of different heavy-quark masses.
!-- 25/06/2010 by Graeme Watt <Graeme.Watt(at)cern.ch>

!-- Fix "NaN" bug for q <= m_c when m_c^2 < 1.25 GeV^2.
!-- 25/01/2011 by Graeme Watt <Graeme.Watt(at)cern.ch>

subroutine MSTWevolve(x,Q,xpdf,xphoton)
  implicit none
  !
  include 'parmsetup.inc'
  character*16 name(nmxset)
  character*80 line
  character*512 setpath
  integer iset,mem,nset,nmem(nmxset),ndef(nmxset),mmem,imem
  COMMON/NAME/name,nmem,ndef,mmem
  double precision xpdf(-6:6),xvalence(6),xphoton, &
       &     x,Q,alfas,Qalfa,Eorder,Q2fit,MSTWALPHAS
  logical warn,fatal
  parameter(warn=.false.,fatal=.true.)
  !   Set warn=.true. to turn on warnings when extrapolating.
  !   Set fatal=.false. to return zero instead of terminating when
  !    invalid input values of x and q are used.
  integer ih,f,nhess,nx,nq,np,nqc0,nqb0,n,m,ip,io, &
       &     nExtraFlavours,i,j
  double precision xmin,xmax,qsqmin,qsqmax,mc2,mb2,eps, &
       &     qsq,xlog,qsqlog,res,res1,anom,ExtrapolateMSTWPDF, &
       &     InterpolateMSTWPDF
  parameter(nx=64,nq=48,np=12)
  parameter(xmin=1d-6,xmax=1d0,qsqmin=1d0,qsqmax=1d9,eps=1d-6)
  parameter(nhess=0)
  character dummyChar,dummyWord*50
  double precision gridx(nmxgridx),gridq(nmxgridq)
  integer ngridx,ngridq,jx,jq
  double precision ff(np,nx,nq)
  double precision qqorig(nq),qq(nq),xx(nx),cc(np,0:nhess,nx,nq,4,4,nmxset)
  double precision xxl(nx),qql(nq,nmxset,0:nhess)
  !   Store values of distance and tolerance along each eigenvector,
  !   heavy-quark masses and alphaS parameters in COMMON block.
  !   Allow the possibility of different alphaS parameters and
  !   heavy-quark masses for each member of the set.
  double precision distance(nmxset,0:nhess),tolerance(nmxset,0:nhess), &
       &     mCharm(nmxset,0:nhess),mBottom(nmxset,0:nhess), &
       &     alphaSQ0(nmxset,0:nhess),alphaSMZ(nmxset,0:nhess)
  integer alphaSorder(nmxset,0:nhess),alphaSnfmax(nmxset,0:nhess)
  common/mstwCommon/distance,tolerance, &
       &     mCharm,mBottom,alphaSQ0,alphaSMZ,alphaSorder,alphaSnfmax
  double precision mCharmSave,mBottomSave,mTopSave
  double precision cmass(nmxset),bmass(nmxset),tmass(nmxset)
  common/masses_LHA/cmass,bmass,tmass
  data xx/1d-6,2d-6,4d-6,6d-6,8d-6, &
       &     1d-5,2d-5,4d-5,6d-5,8d-5, &
       &     1d-4,2d-4,4d-4,6d-4,8d-4, &
       &     1d-3,2d-3,4d-3,6d-3,8d-3, &
       &     1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2, &
       &     .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0, &
       &     .3d0,.325d0,.35d0,.375d0,.4d0,.425d0,.45d0,.475d0, &
       &     .5d0,.525d0,.55d0,.575d0,.6d0,.625d0,.65d0,.675d0, &
       &     .7d0,.725d0,.75d0,.775d0,.8d0,.825d0,.85d0,.875d0, &
       &     .9d0,.925d0,.95d0,.975d0,1d0/
  data qqorig/1.d0, &
       &     1.25d0,1.5d0,0.d0,0.d0,2.5d0,3.2d0,4d0,5d0,6.4d0,8d0, &
       &     1d1,1.2d1,0.d0,0.d0,2.6d1,4d1,6.4d1,1d2, &
       &     1.6d2,2.4d2,4d2,6.4d2,1d3,1.8d3,3.2d3,5.6d3,1d4, &
       &     1.8d4,3.2d4,5.6d4,1d5,1.8d5,3.2d5,5.6d5,1d6, &
       &     1.8d6,3.2d6,5.6d6,1d7,1.8d7,3.2d7,5.6d7,1d8, &
       &     1.8d8,3.2d8,5.6d8,1d9/
  save

  call getnset(iset)
  call getnmem(iset,imem)
  ih = 0

  qsq=q*q
  mc2=mCharm(iset,ih)**2
  mb2=mBottom(iset,ih)**2
  !   If mc2 < qsq < mc2+eps, then qsq = mc2+eps.
  if (qsq.gt.mc2.and.qsq.lt.mc2+eps) then
     qsq = mc2+eps
  end if
  !   If mb2 < qsq < mb2+eps, then qsq = mb2+eps.
  if (qsq.gt.mb2.and.qsq.lt.mb2+eps) then
     qsq = mb2+eps
  end if

  xlog=log10(x)
  qsqlog=log10(qsq)

  do f = 0, 13 ! loop over flavours

     res = 0.d0

     if (f.eq.0) then          ! gluon
        ip = 1
     else if (f.ge.1.and.f.le.5) then ! quarks
        ip = f+1
     else if (f.le.-1.and.f.ge.-5) then ! antiquarks
        ip = -f+1
     else if (f.ge.7.and.f.le.11) then ! valence quarks
        ip = f
     else if (f.eq.13) then    ! photon
        ip = 12
     else if (abs(f).ne.6.and.f.ne.12) then
        if (warn.or.fatal) print *,"Error in MSTWevolve: f = ",f
        if (fatal) stop
     end if

     if (x.le.0.d0.or.x.gt.xmax.or.q.le.0.d0) then

        if (warn.or.fatal) print *,"Error in MSTWevolve: x,qsq = ", &
             &        x,qsq
        if (fatal) stop

     else if (abs(f).eq.6.or.f.eq.12) then ! set top quarks to zero

        res = 0.d0

     else if (qsq.lt.qsqmin) then ! extrapolate to low Q^2

        if (warn) then
           print *, "Warning in MSTWevolve, extrapolating: f = ",f, &
                &           ", x = ",x,", q = ",q
        end if

        if (x.lt.xmin) then    ! extrapolate to low x

           res = ExtrapolateMSTWPDF(ip,np,ih,nhess,xlog, &
                & log10(qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
           res1 = ExtrapolateMSTWPDF(ip,np,ih,nhess,xlog, &
                & log10(1.01D0*qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
           if (f.le.-1.and.f.ge.-5) then ! antiquark = quark - valence
              res = res - ExtrapolateMSTWPDF(ip+5,np,ih,nhess,xlog, &
                   & log10(qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
              res1 = res1 - ExtrapolateMSTWPDF(ip+5,np,ih,nhess,xlog, &
                   & log10(1.01D0*qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
           end if

        else                   ! do usual interpolation

           res = InterpolateMSTWPDF(ip,np,ih,nhess,xlog, &
                & log10(qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
           res1 = InterpolateMSTWPDF(ip,np,ih,nhess,xlog, &
                & log10(1.01D0*qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
           if (f.le.-1.and.f.ge.-5) then ! antiquark = quark - valence
              res = res - InterpolateMSTWPDF(ip+5,np,ih,nhess,xlog, &
                   & log10(qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
              res1 = res1 - InterpolateMSTWPDF(ip+5,np,ih,nhess,xlog, &
                   & log10(1.01D0*qsqmin),nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
           end if

        end if

        !   Calculate the anomalous dimension, dlog(xf)/dlog(qsq),
        !   evaluated at qsqmin.  Then extrapolate the PDFs to low
        !   qsq < qsqmin by interpolating the anomalous dimenion between
        !   the value at qsqmin and a value of 1 for qsq << qsqmin.
        !   If value of PDF at qsqmin is very small, just set
        !   anomalous dimension to 1 to prevent rounding errors.
        !   Impose minimum anomalous dimension of -2.5.
        if (abs(res).ge.1.D-5) then
           anom = max( -2.5D0, (res1-res)/res/0.01D0 )
        else
           anom = 1.D0
        end if
        res = res*(qsq/qsqmin)**(anom*qsq/qsqmin+1.D0-qsq/qsqmin)

     else if (x.lt.xmin.or.qsq.gt.qsqmax) then ! extrapolate

        if (warn) then
           print *, "Warning in MSTWevolve, extrapolating: f = ",f, &
                &           ", x = ",x,", q = ",q
        end if

        res = ExtrapolateMSTWPDF(ip,np,ih,nhess,xlog, &
             & qsqlog,nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))

        if (f.le.-1.and.f.ge.-5) then ! antiquark = quark - valence
           res = res - ExtrapolateMSTWPDF(ip+5,np,ih,nhess,xlog, &
                & qsqlog,nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
        end if

     else                      ! do usual interpolation

        res = InterpolateMSTWPDF(ip,np,ih,nhess,xlog, &
             & qsqlog,nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))

        if (f.le.-1.and.f.ge.-5) then ! antiquark = quark - valence
           res = res - InterpolateMSTWPDF(ip+5,np,ih,nhess,xlog, &
                & qsqlog,nx,nq,xxl,qql(1,iset,ih),cc(1,0,1,1,1,1,iset))
        end if

     end if

     if (f.ge.7.and.f.le.12) then
        xvalence(f-6) = res
     else if (f.eq.13) then
        xphoton = res
     else
        xpdf(f) = res
     end if

  end do

  do f = 1, 6
     xpdf(-f) = xpdf(f) - xvalence(f) ! antiquarks
  end do

  return 
  !                                                                       
  entry MSTWgetgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=1,nx
          gridx(jx)=xx(jx)
      enddo
      do jq=1,nq
          gridq(jq)=qq(jq)
      enddo
      ngridx=nx
      ngridq=nq        
  return

  entry MSTWread(nset)

  ! Dummy read to get to the 'End:' (stream 1 is still open)
  read(1,*) nmem(nset),ndef(nset)
  do ih = 0, nmem(nset)
     !   Read header containing heavy-quark masses and alphaS values.
     read(1,*)
     read(1,*)
     read(1,*) dummyChar,dummyWord,dummyWord,dummyChar, &
          &        distance(nset,0),tolerance(nset,0)
     read(1,*) dummyChar,dummyWord,dummyChar,mCharm(nset,0)
     read(1,*) dummyChar,dummyWord,dummyChar,mBottom(nset,0)
     read(1,*) dummyChar,dummyWord,dummyChar,alphaSQ0(nset,0)
     read(1,*) dummyChar,dummyWord,dummyChar,alphaSMZ(nset,0)
     read(1,*) dummyChar,dummyWord,dummyWord,dummyChar, &
          &        alphaSorder(nset,0),alphaSnfmax(nset,0)
     read(1,*) dummyChar,dummyWord,dummyChar,nExtraFlavours
     read(1,*)
     read(1,*)
     !   Now read in the grids from the grid file.
     do n=1,nx-1
        do m=1,nq
           read(1,*,iostat=io)
           if (io.ne.0) then
              print *,"Error in MSTWevolve reading file"
              stop
           end if
        enddo
     enddo
  end do

  return 
  !                                                                       
  entry MSTWalfa(alfas,Qalfa)
  call getnset(iset)
  call getnmem(iset,imem)

  ! Check value of Qalfa is below appropriate thresholds.
  ! If not, redefine thresholds and reinitialise alphaS.
  IF (alphaSnfmax(iset,0).EQ.5) THEN ! maximum of five flavours
     IF (Qalfa.GT.mTopSave) THEN
        mTopSave = 2.D0*Qalfa
        CALL MSTWINITALPHAS(alphaSorder(iset,0), &
             &     1.D0,1.D0,alphaSQ0(iset,0), &
             &     mCharmSave,mBottomSave,mTopSave)
     END IF
  ELSE IF (alphaSnfmax(iset,0).EQ.4) THEN ! maximum of four flavours
     IF (Qalfa.GT.mBottomSave) THEN
        mBottomSave = 2.D0*Qalfa
        mTopSave = mBottomSave/0.9D0
        CALL MSTWINITALPHAS(alphaSorder(iset,0), &
             &     1.D0,1.D0,alphaSQ0(iset,0), &
             &     mCharmSave,mBottomSave,mTopSave)
     END IF
  ELSE IF (alphaSnfmax(iset,0).EQ.3) THEN ! maximum of three flavours
     IF (Qalfa.GT.mCharmSave) THEN
        mCharmSave = 2.D0*Qalfa
        mBottomSave = mCharmSave*0.9D0/0.8D0
        mTopSave = mBottomSave/0.9D0
        CALL MSTWINITALPHAS(alphaSorder(iset,0), &
             &     1.D0,1.D0,alphaSQ0(iset,0), &
             &     mCharmSave,mBottomSave,mTopSave)
     END IF
  END IF
  alfas = MSTWALPHAS(Qalfa)
  return
  !
  entry MSTWinit(nset,Eorder,Q2fit)
  return
  !                                                                       
  entry MSTWpdf(mem)
  call getnset(iset)
  call setnmem(iset,mem)

  ! here is the real read!!

  ! have to reopen stream 1 
  call getsetpath(setpath)
  open(1,file=setpath(1:len_trim(setpath)),action='READ')

  line = ''
  do while (line(2:11).ne.'Evolution:')
     read(1,'(a)'),line
  enddo
  read(1,'(a)'),line
  read(1,'(a)'),line

  read(1,*)nmem(iset),ndef(iset)
  ! Dummy read up to the member requested
  do i=0,mem-1
     do j=1,11
        read(1,*)
     enddo
     do n=1,nx-1
        do m=1,nq
           read(1,'(a)')line
        enddo
     enddo
  enddo

  ih=0
  !   Read header containing heavy-quark masses and alphaS values.
  read(1,*)
  read(1,*)
  read(1,*) dummyChar,dummyWord,dummyWord,dummyChar, &
       &        distance(iset,ih),tolerance(iset,ih)
  read(1,*) dummyChar,dummyWord,dummyChar,mCharm(iset,ih)
  read(1,*) dummyChar,dummyWord,dummyChar,mBottom(iset,ih)
  read(1,*) dummyChar,dummyWord,dummyChar,alphaSQ0(iset,ih)
  read(1,*) dummyChar,dummyWord,dummyChar,alphaSMZ(iset,ih)
  read(1,*) dummyChar,dummyWord,dummyWord,dummyChar, &
       &        alphaSorder(iset,ih),alphaSnfmax(iset,ih)
  read(1,*) dummyChar,dummyWord,dummyChar,nExtraFlavours
  read(1,*)
  read(1,*)

  !   Heavy-quark masses and alphaS values
  !   are stored in a COMMON block.
  !  WRITE(6,*) "mCharm = ",mCharm(iset,ih), &
  !       &     ", mBottom = ",mBottom(iset,ih)
  !  WRITE(6,*) "alphaS(Q0) = ",alphaSQ0(iset,ih),", alphaS(MZ) = ", &
  !       &     alphaSMZ(iset,ih),", alphaSorder = ",alphaSorder(iset,ih), &
  !       &     ", alphaSnfmax = ",alphaSnfmax(iset,ih)

  mc2=mCharm(iset,ih)**2
  mb2=mBottom(iset,ih)**2

  !   Check that the heavy-quark masses are sensible.
  !   Redistribute grid points if not in usual range.
  do m=1,nq
     qq(m) = qqorig(m)
  end do
  if (mc2.le.qq(1).or.mc2+eps.ge.qq(8)) then
     print *,"Error in MSTWevolve: invalid mCharm = ",mCharm(iset,ih)
     stop
  else if (mc2.lt.qq(2)) then
     nqc0=2
     qq(4)=qq(2)
     qq(5)=qq(3)
  else if (mc2.lt.qq(3)) then
     nqc0=3
     qq(5)=qq(3)
  else if (mc2.lt.qq(6)) then
     nqc0=4
  else if (mc2.lt.qq(7)) then
     nqc0=5
     qq(4)=qq(6)
  else
     nqc0=6
     qq(4)=qq(6)
     qq(5)=qq(7)
  end if
  if (mb2.le.qq(12).or.mb2+eps.ge.qq(17)) then
     print *,"Error in MSTWevolve: invalid mBottom = ",mBottom(iset,ih)
     stop
  else if (mb2.lt.qq(13)) then
     nqb0=13
     qq(15)=qq(13)
  else if (mb2.lt.qq(16)) then
     nqb0=14
  else
     nqb0=15
     qq(14)=qq(16)
  end if
  qq(nqc0)=mc2
  qq(nqc0+1)=mc2+eps
  qq(nqb0)=mb2
  qq(nqb0+1)=mb2+eps
  
  !   The nExtraFlavours variable is provided to aid compatibility
  !   with future grids where, for example, a photon distribution
  !   might be provided (cf. the MRST2004QED PDFs).
  if (nExtraFlavours.lt.0.or.nExtraFlavours.gt.1) then
     print *,"Error in MSTWevolve: invalid nExtraFlavours = ", &
          &           nExtraFlavours
     stop
  end if
  
  !   Now read in the grids from the grid file.
  do n=1,nx-1
     do m=1,nq
        if (nExtraFlavours.gt.0) then
           if (alphaSorder(iset,ih).eq.2) then ! NNLO
              read(1,'(12(1pe12.4))',iostat=io) &
                   & (ff(ip,n,m),ip=1,12)
           else          ! LO or NLO
              ff(10,n,m) = 0.d0 ! = chm-cbar
              ff(11,n,m) = 0.d0 ! = bot-bbar
              read(1,'(10(1pe12.4))',iostat=io) &
                   & (ff(ip,n,m),ip=1,9),ff(12,n,m)
           end if
        else             ! nExtraFlavours = 0
           if (alphaSorder(iset,ih).eq.2) then ! NNLO
              ff(12,n,m) = 0.d0 ! = photon
              read(1,'(11(1pe12.4))',iostat=io) &
                   & (ff(ip,n,m),ip=1,11)
           else          ! LO or NLO
              ff(10,n,m) = 0.d0 ! = chm-cbar
              ff(11,n,m) = 0.d0 ! = bot-bbar
              ff(12,n,m) = 0.d0 ! = photon
              read(1,'(9(1pe12.4))',iostat=io) &
                   & (ff(ip,n,m),ip=1,9)
           end if
        end if
        if (io.ne.0) then
           print *,"Error in MSTWevolve reading file"
           stop
        end if
     enddo
  enddo

  !   PDFs are identically zero at x = 1.
  do m=1,nq
     do ip=1,np
        ff(ip,nx,m)=0d0
     enddo
  enddo

  do n=1,nx
     xxl(n)=log10(xx(n))
  enddo
  do m=1,nq
     qql(m,iset,ih)=log10(qq(m))
  enddo
  
  !   Initialise all parton flavours.
  do ip=1,np
     call InitialiseMSTWPDF(ip,np,ih,nhess,nx,nq,nqc0,nqb0, &
          & xxl,qql(1,iset,ih),ff,cc(1,0,1,1,1,1,iset))
  enddo
  ! end of section moved from the read routine

  close(1)

  ! Call the initialisation routine with alpha_S(Q_0).
  IF (alphaSnfmax(iset,ih).EQ.5) THEN ! maximum of five flavours
     mCharmSave = mCharm(iset,ih)
     mBottomSave = mBottom(iset,ih)
     mTopSave = 1.D10
  ELSE IF (alphaSnfmax(iset,ih).EQ.4) THEN ! maximum of four flavours
     mCharmSave = mCharm(iset,ih)
     mBottomSave = 0.9D10
     mTopSave = 1.D10
  ELSE IF (alphaSnfmax(iset,ih).EQ.3) THEN ! maximum of three flavours
     mCharmSave = 0.8D10
     mBottomSave = 0.9D10
     mTopSave = 1.D10
  END IF

  ! Update masses stored in common/masses_LHA/.
  cmass(iset) = mCharm(iset,ih)
  bmass(iset) = mBottom(iset,ih)
  tmass(iset) = mTopSave
  
  CALL MSTWINITALPHAS(alphaSorder(iset,ih),1.D0,1.D0,alphaSQ0(iset,ih), &
       &     mCharmSave,mBottomSave,mTopSave)

  !  !   Check calculated value of alpha_S(M_Z) matches stored value.
  !  WRITE(6,'(" alphaS(MZ) = ",F7.5," = ",F7.5)') &
  !       &     MSTWALPHAS(91.1876D0),alphaSMZ(iset,ih)

  return 
  !                                                                       
END subroutine MSTWevolve



!----------------------------------------------------------------------

subroutine InitialiseMSTWPDF(ip,np,ih,nhess,nx,my,myc0,myb0, &
     &     xx,yy,ff,cc)
  implicit none
  integer nhess,ih,nx,my,myc0,myb0,j,k,l,m,n,ip,np
  double precision xx(nx),yy(my),ff(np,nx,my), &
       &     ff1(nx,my),ff2(nx,my),ff12(nx,my),ff21(nx,my), &
       &     yy0(4),yy1(4),yy2(4),yy12(4),z(16), &
       &     cl(16),cc(np,0:nhess,nx,my,4,4),iwt(16,16), &
       &     polderiv1,polderiv2,polderiv3,d1,d2,d1d2,xxd

      data iwt/1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
     &     0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0, &
     &     -3,0,0,3,0,0,0,0,-2,0,0,-1,0,0,0,0, &
     &     2,0,0,-2,0,0,0,0,1,0,0,1,0,0,0,0, &
     &     0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0, &
     &     0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0, &
     &     0,0,0,0,-3,0,0,3,0,0,0,0,-2,0,0,-1, &
     &     0,0,0,0,2,0,0,-2,0,0,0,0,1,0,0,1, &
     &     -3,3,0,0,-2,-1,0,0,0,0,0,0,0,0,0,0, &
     &     0,0,0,0,0,0,0,0,-3,3,0,0,-2,-1,0,0, &
     &     9,-9,9,-9,6,3,-3,-6,6,-6,-3,3,4,2,1,2, &
     &     -6,6,-6,6,-4,-2,2,4,-3,3,3,-3,-2,-1,-1,-2, &
     &     2,-2,0,0,1,1,0,0,0,0,0,0,0,0,0,0, &
     &     0,0,0,0,0,0,0,0,2,-2,0,0,1,1,0,0, &
     &     -6,6,-6,6,-3,-3,3,3,-4,4,2,-2,-2,-2,-1,-1, &
     &     4,-4,4,-4,2,2,-2,-2,2,-2,-2,2,1,1,1,1/

      do m=1,my
         ff1(1,m)=polderiv1(xx(1),xx(2),xx(3), &
     &        ff(ip,1,m),ff(ip,2,m),ff(ip,3,m))
         ff1(nx,m)=polderiv3(xx(nx-2),xx(nx-1),xx(nx), &
     &        ff(ip,nx-2,m),ff(ip,nx-1,m),ff(ip,nx,m))
         do n=2,nx-1
            ff1(n,m)=polderiv2(xx(n-1),xx(n),xx(n+1), &
     &           ff(ip,n-1,m),ff(ip,n,m),ff(ip,n+1,m))
         enddo
      enddo

!--   Calculate the derivatives at qsq=mc2,mc2+eps,mb2,mb2+eps
!--   in a similar way as at the endpoints qsqmin and qsqmax.
      do n=1,nx
         do m=1,my
            if (myc0.eq.2.and.m.eq.1) then
               ff2(n,m)=(ff(ip,n,m+1)-ff(ip,n,m))/(yy(m+1)-yy(m))
            else if (myc0.eq.2.and.m.eq.2) then
               ff2(n,m)=(ff(ip,n,m)-ff(ip,n,m-1))/(yy(m)-yy(m-1))
            else if (m.eq.1.or.m.eq.myc0+1.or.m.eq.myb0+1) then
               ff2(n,m)=polderiv1(yy(m),yy(m+1),yy(m+2), &
     &              ff(ip,n,m),ff(ip,n,m+1),ff(ip,n,m+2))
            else if (m.eq.my.or.m.eq.myc0.or.m.eq.myb0) then
               ff2(n,m)=polderiv3(yy(m-2),yy(m-1),yy(m), &
     &              ff(ip,n,m-2),ff(ip,n,m-1),ff(ip,n,m))
            else
               ff2(n,m)=polderiv2(yy(m-1),yy(m),yy(m+1), &
     &              ff(ip,n,m-1),ff(ip,n,m),ff(ip,n,m+1))
            end if
         end do
      end do

!--   Calculate the cross derivatives (d/dx)(d/dy).
      do m=1,my
         ff12(1,m)=polderiv1(xx(1),xx(2),xx(3), &
     &        ff2(1,m),ff2(2,m),ff2(3,m))
         ff12(nx,m)=polderiv3(xx(nx-2),xx(nx-1),xx(nx), &
     &        ff2(nx-2,m),ff2(nx-1,m),ff2(nx,m))
         do n=2,nx-1
            ff12(n,m)=polderiv2(xx(n-1),xx(n),xx(n+1), &
     &           ff2(n-1,m),ff2(n,m),ff2(n+1,m))
         enddo
      enddo

!--   Calculate the cross derivatives (d/dy)(d/dx).
      do n=1,nx
         do m = 1, my
            if (myc0.eq.2.and.m.eq.1) then
               ff21(n,m)=(ff1(n,m+1)-ff1(n,m))/(yy(m+1)-yy(m))
            else if (myc0.eq.2.and.m.eq.2) then
               ff21(n,m)=(ff1(n,m)-ff1(n,m-1))/(yy(m)-yy(m-1))
            else if (m.eq.1.or.m.eq.myc0+1.or.m.eq.myb0+1) then
               ff21(n,m)=polderiv1(yy(m),yy(m+1),yy(m+2), &
     &              ff1(n,m),ff1(n,m+1),ff1(n,m+2))
            else if (m.eq.my.or.m.eq.myc0.or.m.eq.myb0) then
               ff21(n,m)=polderiv3(yy(m-2),yy(m-1),yy(m), &
     &              ff1(n,m-2),ff1(n,m-1),ff1(n,m))
            else
               ff21(n,m)=polderiv2(yy(m-1),yy(m),yy(m+1), &
     &              ff1(n,m-1),ff1(n,m),ff1(n,m+1))
            end if
         end do
      end do

!--   Take the average of (d/dx)(d/dy) and (d/dy)(d/dx).
      do n=1,nx
         do m = 1, my
            ff12(n,m)=0.5*(ff12(n,m)+ff21(n,m))
         end do
      end do

      do n=1,nx-1
         do m=1,my-1
            d1=xx(n+1)-xx(n)
            d2=yy(m+1)-yy(m)
            d1d2=d1*d2
            
            yy0(1)=ff(ip,n,m)
            yy0(2)=ff(ip,n+1,m)
            yy0(3)=ff(ip,n+1,m+1)
            yy0(4)=ff(ip,n,m+1)
            
            yy1(1)=ff1(n,m)
            yy1(2)=ff1(n+1,m)
            yy1(3)=ff1(n+1,m+1)
            yy1(4)=ff1(n,m+1)
            
            yy2(1)=ff2(n,m)
            yy2(2)=ff2(n+1,m)
            yy2(3)=ff2(n+1,m+1)
            yy2(4)=ff2(n,m+1)
            
            yy12(1)=ff12(n,m)
            yy12(2)=ff12(n+1,m)
            yy12(3)=ff12(n+1,m+1)
            yy12(4)=ff12(n,m+1)
            
            do k=1,4
               z(k)=yy0(k)
               z(k+4)=yy1(k)*d1
               z(k+8)=yy2(k)*d2
               z(k+12)=yy12(k)*d1d2
            enddo
            
            do l=1,16
               xxd=0.d0
               do k=1,16
                  xxd=xxd+iwt(k,l)*z(k)
               enddo
               cl(l)=xxd
            enddo
            l=0
            do k=1,4
               do j=1,4
                  l=l+1
                  cc(ip,ih,n,m,k,j)=cl(l)
               enddo
            enddo
         enddo
      enddo
      return
      end

!----------------------------------------------------------------------

      double precision function InterpolateMSTWPDF(ip,np,ih,nhess,x,y, &
     &     nx,my,xx,yy,cc)
      implicit none
      integer ih,nx,my,nhess,MSTWlocx,l,m,n,ip,np
      double precision xx(nx),yy(my),cc(np,0:nhess,nx,my,4,4), &
     &     x,y,z,t,u

      n=MSTWlocx(xx,nx,x)
      m=MSTWlocx(yy,my,y)
      
      t=(x-xx(n))/(xx(n+1)-xx(n))
      u=(y-yy(m))/(yy(m+1)-yy(m))
      
      z=0.d0
      do l=4,1,-1
         z=t*z+((cc(ip,ih,n,m,l,4)*u+cc(ip,ih,n,m,l,3))*u &
     &        +cc(ip,ih,n,m,l,2))*u+cc(ip,ih,n,m,l,1)
      enddo

      InterpolateMSTWPDF = z

      return
      end

!----------------------------------------------------------------------

      double precision function ExtrapolateMSTWPDF(ip,np,ih,nhess,x,y, &
     &     nx,my,xx,yy,cc)
      implicit none
      integer ih,nx,my,nhess,MSTWlocx,n,m,ip,np
      double precision xx(nx),yy(my),cc(np,0:nhess,nx,my,4,4), &
     &     x,y,z,f0,f1,z0,z1,InterpolateMSTWPDF

      n=MSTWlocx(xx,nx,x)           ! 0: below xmin, nx: above xmax
      m=MSTWlocx(yy,my,y)           ! 0: below qsqmin, my: above qsqmax

!   If extrapolation in small x only:
      if (n.eq.0.and.m.gt.0.and.m.lt.my) then
         f0 = InterpolateMSTWPDF(ip,np,ih,nhess,xx(1),y,nx,my,xx,yy,cc)
         f1 = InterpolateMSTWPDF(ip,np,ih,nhess,xx(2),y,nx,my,xx,yy,cc)
         if (f0.gt.1.d-3.and.f1.gt.1.d-3) then
            z = exp(log(f0)+(log(f1)-log(f0))/(xx(2)-xx(1))*(x-xx(1)))
         else
            z = f0+(f1-f0)/(xx(2)-xx(1))*(x-xx(1))
         end if
!   If extrapolation into large q only:
      else if (n.gt.0.and.m.eq.my) then
         f0 = InterpolateMSTWPDF(ip,np,ih,nhess,x,yy(my),nx,my,xx,yy,cc)
         f1 = InterpolateMSTWPDF(ip,np,ih,nhess,x,yy(my-1),nx,my,xx,yy,cc)
         if (f0.gt.1.d-3.and.f1.gt.1.d-3) then
            z = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))* &
     &           (y-yy(my)))
         else
            z = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my))
         end if
!   If extrapolation into large q AND small x:
      else if (n.eq.0.and.m.eq.my) then
         f0 = InterpolateMSTWPDF(ip,np,ih,nhess,xx(1),yy(my),nx,my,xx,yy,cc)
         f1 = InterpolateMSTWPDF(ip,np,ih,nhess,xx(1),yy(my-1),nx,my,xx,yy, &
     &        cc)
         if (f0.gt.1.d-3.and.f1.gt.1.d-3) then
            z0 = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))* &
     &           (y-yy(my)))
         else
            z0 = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my))
         end if
         f0 = InterpolateMSTWPDF(ip,np,ih,nhess,xx(2),yy(my),nx,my,xx,yy,cc)
         f1 = InterpolateMSTWPDF(ip,np,ih,nhess,xx(2),yy(my-1),nx,my,xx,yy, &
     &        cc)
         if (f0.gt.1.d-3.and.f1.gt.1.d-3) then
            z1 = exp(log(f0)+(log(f0)-log(f1))/(yy(my)-yy(my-1))* &
     &           (y-yy(my)))
         else
            z1 = f0+(f0-f1)/(yy(my)-yy(my-1))*(y-yy(my))
         end if
         if (z0.gt.1.d-3.and.z1.gt.1.d-3) then
            z = exp(log(z0)+(log(z1)-log(z0))/(xx(2)-xx(1))*(x-xx(1)))
         else
            z = z0+(z1-z0)/(xx(2)-xx(1))*(x-xx(1))
         end if
      else
         print *,"Error in ExtrapolateMSTWPDF"
         stop
      end if

      ExtrapolateMSTWPDF = z      

      return
      end

!----------------------------------------------------------------------

      integer function MSTWlocx(xx,nx,x)
!   returns an integer j such that x lies inbetween xx(j) and xx(j+1).
!   nx is the length of the array with xx(nx) the highest element.
      implicit none
      integer nx,jl,ju,jm
      double precision x,xx(nx)
      if(x.eq.xx(1)) then
         MSTWlocx=1
         return
      endif
      if(x.eq.xx(nx)) then
         MSTWlocx=nx-1  
         return
      endif
      ju=nx+1
      jl=0
    1 if((ju-jl).le.1) goto 2
      jm=(ju+jl)/2
      if(x.ge.xx(jm)) then
         jl=jm
      else
         ju=jm
      endif
      goto 1
    2 MSTWlocx=jl
      return
      end

!----------------------------------------------------------------------

      double precision function polderiv1(x1,x2,x3,y1,y2,y3)
!--   returns the estimate of the derivative at x1 obtained by a
!--   polynomial interpolation using the three points (x_i,y_i).
      implicit none
      double precision x1,x2,x3,y1,y2,y3
      polderiv1=(x3*x3*(y1-y2)+2.d0*x1*(x3*(-y1+y2)+x2*(y1-y3)) &
     &     +x2*x2*(-y1+y3)+x1*x1*(-y2+y3))/((x1-x2)*(x1-x3)*(x2-x3))
      return
      end

      double precision function polderiv2(x1,x2,x3,y1,y2,y3)
!--   returns the estimate of the derivative at x2 obtained by a
!--   polynomial interpolation using the three points (x_i,y_i).
      implicit none
      double precision x1,x2,x3,y1,y2,y3
      polderiv2=(x3*x3*(y1-y2)-2.d0*x2*(x3*(y1-y2)+x1*(y2-y3)) &
     &     +x2*x2*(y1-y3)+x1*x1*(y2-y3))/((x1-x2)*(x1-x3)*(x2-x3))
      return
      end

      double precision function polderiv3(x1,x2,x3,y1,y2,y3)
!--   returns the estimate of the derivative at x3 obtained by a
!--   polynomial interpolation using the three points (x_i,y_i).
      implicit none
      double precision x1,x2,x3,y1,y2,y3
      polderiv3=(x3*x3*(-y1+y2)+2.d0*x2*x3*(y1-y3)+x1*x1*(y2-y3) &
     &     +x2*x2*(-y1+y3)+2.d0*x1*x3*(-y2+y3))/ &
     &     ((x1-x2)*(x1-x3)*(x2-x3))
      return
      end

!----------------------------------------------------------------------

!----------------------------------------------------------------------
!--   Stand-alone code for alpha_s cannibalised (with permission)
!--   from Andreas Vogt's QCD-PEGASUS package (hep-ph/0408244).
!--   The running coupling alpha_s is obtained at N^mLO (m = 0,1,2,3)
!--   by solving the renormalisation group equation in the MSbar scheme
!--   by a fourth-order Runge-Kutta integration.  Transitions from
!--   n_f to n_f+1 flavours are made when the factorisation scale
!--   mu_f equals the pole masses m_h (h = c,b,t).  At exactly
!--   the thresholds m_{c,b,t}, the number of flavours n_f = {3,4,5}.
!--   The top quark mass should be set to be very large to evolve with
!--   a maximum of five flavours.  The factorisation scale mu_f may be
!--   a constant multiple of the renormalisation scale mu_r.  The input
!--   factorisation scale mu_(f,0) should be less than or equal to
!--   the charm quark mass.  However, if it is greater than the
!--   charm quark mass, the value of alpha_s at mu_(f,0) = 1 GeV will
!--   be found using a root-finding algorithm.
!--
!--   Example of usage.
!--   First call the initialisation routine (only needed once):
!--
!--    IORD = 2                  ! perturbative order (N^mLO,m=0,1,2,3)
!--    FR2 = 1.D0                ! ratio of mu_f^2 to mu_r^2
!--    MUR = 1.D0                ! input mu_r in GeV
!--    ASMUR = 0.5D0             ! input value of alpha_s at mu_r
!--    MC = 1.4D0                ! charm quark mass
!--    MB = 4.75D0               ! bottom quark mass
!--    MT = 1.D10                ! top quark mass
!--    CALL MSTWINITALPHAS(IORD, FR2, MUR, ASMUR, MC, MB, MT)
!--
!--   Then get alpha_s at a renormalisation scale mu_r with:
!--
!--    MUR = 100.D0              ! renormalisation scale in GeV
!--    ALFAS = MSTWALPHAS(MUR)
!--
!----------------------------------------------------------------------
!--   Comments to Graeme Watt <watt(at)hep.ucl.ac.uk>
!----------------------------------------------------------------------

      SUBROUTINE MSTWINITALPHAS(IORD, FR2, MUR, ASMUR, MC, MB, MT)
!--   IORD = 0 (LO), 1 (NLO), 2 (NNLO), 3 (NNNLO).
!--   FR2 = ratio of mu_f^2 to mu_r^2 (must be a fixed value).
!--   MUR = input renormalisation scale (in GeV) for alpha_s.
!--   ASMUR = input value of alpha_s at the renormalisation scale MUR.
!--   MC,MB,MT = heavy-quark masses in GeV.
      IMPLICIT NONE
      INTEGER IORD,IORDc,MAXF,MODE
      DOUBLE PRECISION FR2,MUR,ASMUR,MC,MB,MT,EPS,A,B,MSTWDZEROX, &
     &     R0c,FR2c,MURc,ASMURc,MCc,MBc,MTc,FINDALPHASR0,R0,ASI
      COMMON / MSTWDZEROXcommon / FR2c,MURc,ASMURc,MCc,MBc,MTc,R0c,IORDc
      PARAMETER(EPS=1.D-10,MAXF=10000,MODE=1)
      EXTERNAL FINDALPHASR0

      IF (MUR*sqrt(FR2).LE.MC) THEN ! Check that MUF <= MC.
         R0 = MUR
         ASI = ASMUR
      ELSE                      ! Solve for alpha_s at R0 = 1 GeV.
!--   Copy variables to common block.
         R0c = 1.D0/sqrt(FR2)
         IORDc = IORD
         FR2c = FR2
         MURc = MUR
         ASMURc = ASMUR
         MCc = MC
         MBc = MB
         MTc = MT
!--   Now get alpha_s(R0) corresponding to alpha_s(MUR).
         A = 0.02D0              ! lower bound for alpha_s(R0)
         B = 2.00D0              ! upper bound for alpha_s(R0)
         R0 = R0c
         ASI = MSTWDZEROX(A,B,EPS,MAXF,FINDALPHASR0,MODE)
      END IF

      CALL MSTWINITALPHASR0(IORD, FR2, R0, ASI, MC, MB, MT)

      RETURN
      END

!----------------------------------------------------------------------

!--   Find the zero of this function using MSTWDZEROX.
      DOUBLE PRECISION FUNCTION FINDALPHASR0(ASI)
      IMPLICIT NONE
      INTEGER IORD
      DOUBLE PRECISION FR2, R0, ASI, MC, MB, MT, MUR, ASMUR, MSTWALPHAS
      COMMON / MSTWDZEROXcommon / FR2, MUR, ASMUR, MC, MB, MT, R0, IORD

      CALL MSTWINITALPHASR0(IORD, FR2, R0, ASI, MC, MB, MT)
      FINDALPHASR0 = MSTWALPHAS(MUR) - ASMUR ! solve equal to zero

      RETURN
      END
      
!----------------------------------------------------------------------

      SUBROUTINE MSTWINITALPHASR0(IORD, FR2, R0, ASI, MC, MB, MT)
!--   IORD = 0 (LO), 1 (NLO), 2 (NNLO), 3 (NNNLO).
!--   FR2 = ratio of mu_f^2 to mu_r^2 (must be a fixed value).
!--   R0 = input renormalisation scale (in GeV) for alphas_s.
!--   ASI = input value of alpha_s at the renormalisation scale R0.
!--   MC,MB,MT = heavy-quark masses in GeV.
!--   Must have R0*sqrt(FR2) <= MC to call this subroutine.
      IMPLICIT NONE
      INTEGER IORD,NAORD,NASTPS,IVFNS,NFF
      DOUBLE PRECISION FR2,R0,ASI,MC,MB,MT,LOGFR,R20, &
     &     PI,ZETA,CF,CA,TR,AS0,M20,MC2,MB2,MT2
      PARAMETER(PI = 3.14159265358979D0)

      COMMON / RZETA  / ZETA(6)
      COMMON / COLOUR / CF, CA, TR
      COMMON / ASINP  / AS0, M20
      COMMON / ASPAR  / NAORD, NASTPS
      COMMON / VARFLV / IVFNS
      COMMON / NFFIX  / NFF
      COMMON / FRRAT  / LOGFR

!
! ..QCD colour factors
!
      CA = 3.D0
      CF = 4./3.D0
      TR = 0.5D0
!
! ..The lowest integer values of the Zeta function
!
      ZETA(1) = 0.57721566490153D0
      ZETA(2) = 1.644934066848226D0
      ZETA(3) = 1.202056903159594D0
      ZETA(4) = 1.082323233711138D0
      ZETA(5) = 1.036927755143370D0
      ZETA(6) = 1.017343061984449D0

      IVFNS = 1                 ! variable flavour-number scheme (VFNS)
!      IVFNS = 0                 ! fixed flavour-number scheme (FFNS)
      NFF = 4                   ! number of flavours for FFNS
      NAORD = IORD              ! perturbative order of alpha_s
      NASTPS = 20               ! num. steps in Runge-Kutta integration
      R20 = R0**2               ! input renormalisation scale
      MC2 = MC**2               ! mu_f^2 for charm threshold
      MB2 = MB**2               ! mu_f^2 for bottom threshold
      MT2 = MT**2               ! mu_f^2 for top threshold
      LOGFR = LOG(FR2)          ! log of ratio of mu_f^2 to mu_r^2
      M20 = R20 * FR2           ! input factorisation scale

!
! ..Stop some nonsense
!
      IF ( (IVFNS .EQ. 0) .AND. (NFF .LT. 3) ) THEN
         WRITE (6,*) 'Wrong flavour number for FFNS evolution. STOP'
         STOP
      END IF
      IF ( (IVFNS .EQ. 0) .AND. (NFF .GT. 5) ) THEN
         WRITE (6,*) 'Wrong flavour number for FFNS evolution. STOP'
         STOP
      END IF
!     
      IF ( NAORD .GT. 3 ) THEN
         WRITE (6,*) 'Specified order in a_s too high. STOP' 
         STOP
      END IF
!
      IF ( (IVFNS .NE. 0) .AND. (FR2 .GT. 4.001D0) ) THEN
         WRITE (6,*) 'Too low mu_r for VFNS evolution. STOP'
         STOP
      END IF
!
      IF ( (IVFNS .EQ. 1) .AND. (M20 .GT. MC2) ) THEN
         WRITE (6,*) 'Too high mu_0 for VFNS evolution. STOP'
         STOP
      END IF
!     
      IF ( (ASI .GT. 2.D0) .OR. (ASI .LT. 2.D-2) ) THEN
         WRITE (6,*) 'alpha_s out of range. STOP'
         STOP
      END IF
!     
      IF ( (IVFNS .EQ. 1) .AND. (MC2 .GT. MB2) ) THEN
         WRITE (6,*) 'Wrong charm-bottom mass hierarchy. STOP'
         STOP
      END IF
      IF ( (IVFNS .EQ. 1) .AND. (MB2 .GT. MT2) ) THEN
         WRITE (6,*) 'Wrong bottom-top mass hierarchy. STOP'
         STOP
      END IF
!

!--   Store the beta function coefficients in a COMMON block.
      CALL BETAFCT

!--   Store a_s = alpha_s(mu_r^2)/(4 pi) at the input scale R0.
      AS0 = ASI / (4.D0* PI)

!--   Store alpha_s at the heavy flavour thresholds in a COMMON block.
       IF (IVFNS .NE. 0) THEN
          CALL EVNFTHR (MC2, MB2, MT2)
       END IF

      RETURN
      END

!----------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION MSTWALPHAS(MUR)
      IMPLICIT NONE
      INTEGER NFF,IVFNS,NF
      DOUBLE PRECISION PI,LOGFR,AS0,M20,ASC,M2C,ASB,M2B,AST,M2T,M2,MUR, &
     &     R2,ASI,ASF,R20,R2T,R2B,R2C,AS
      PARAMETER ( PI = 3.14159265358979D0 )
!
! ..Input common blocks 
! 
       COMMON / NFFIX  / NFF
       COMMON / VARFLV / IVFNS 
       COMMON / FRRAT  / LOGFR
       COMMON / ASINP  / AS0, M20
       COMMON / ASFTHR / ASC, M2C, ASB, M2B, AST, M2T

       R2 = MUR**2
       M2 = R2 * EXP(+LOGFR)
       IF (IVFNS .EQ. 0) THEN
!
!   Fixed number of flavours
!
          NF  = NFF
          R20 = M20 * R2/M2
          ASI = AS0
          ASF = AS (R2, R20, AS0, NF)
!
       ELSE
!
! ..Variable number of flavours
!
          IF (M2 .GT. M2T) THEN
             NF = 6
             R2T = M2T * R2/M2
             ASI = AST
             ASF = AS (R2, R2T, AST, NF)
!
          ELSE IF (M2 .GT. M2B) THEN
             NF = 5
             R2B = M2B * R2/M2
             ASI = ASB
             ASF = AS (R2, R2B, ASB, NF)
!     
          ELSE IF (M2 .GT. M2C) THEN
             NF = 4
             R2C = M2C * R2/M2
             ASI = ASC
             ASF = AS (R2, R2C, ASC, NF)
!     
          ELSE
             NF = 3
             R20 = M20 * R2/M2
             ASI = AS0
             ASF = AS (R2, R20, AS0, NF)
!       
          END IF
!
       END IF
!
! ..Final value of alpha_s
!
       MSTWALPHAS = 4.D0*PI*ASF

       RETURN
       END
!
! =================================================================av==


! =====================================================================
!
! ..The threshold matching of the QCD coupling in the MS(bar) scheme,  
!    a_s = alpha_s(mu_r^2)/(4 pi),  for  NF -> NF + 1  active flavours 
!    up to order a_s^4 (NNNLO).
!
! ..The value  ASNF  of a_s for NF flavours at the matching scale, the 
!    logarithm  LOGRH = ln (mu_r^2/m_H^2) -- where m_H is the pole mass
!    of the heavy quark -- and  NF  are passed as arguments to the 
!    function  ASNF1.  The order of the expansion  NAORD  (defined as 
!    the 'n' in N^nLO) is provided by the common-block  ASPAR.
!
! ..The matching coefficients are inverted from Chetyrkin, Kniehl and
!    Steinhauser, Phys. Rev. Lett. 79 (1997) 2184. The QCD colour
!    factors have been hard-wired in these results. The lowest integer 
!    values of the Zeta function are given by the common-block  RZETA.
!
! =====================================================================
!
!
      DOUBLE PRECISION FUNCTION ASNF1 (ASNF, LOGRH, NF)
!
      IMPLICIT NONE
      INTEGER NF, NAORD, NASTPS, PRVCLL, K1, K2
      DOUBLE PRECISION ASNF,LOGRH,ZETA,CMC,CMCI30,CMCF30,CMCF31, &
     &     CMCI31,ASP,LRHP

      DIMENSION CMC(3,0:3)
!
! ---------------------------------------------------------------------
!
! ..Input common-blocks 
!
      COMMON / ASPAR  / NAORD, NASTPS
      COMMON / RZETA  / ZETA(6)
!
! ..Variables to be saved for the next call
!
      SAVE CMC, CMCI30, CMCF30, CMCF31, CMCI31, PRVCLL
!
! ---------------------------------------------------------------------
!
! ..The coupling-constant matching coefficients (CMC's) up to NNNLO 
!   (calculated and saved in the first call of this routine)
!
       IF (PRVCLL .NE. 1) THEN
!
         CMC(1,0) =  0.D0
         CMC(1,1) =  2./3.D0
!
         CMC(2,0) = 14./3.D0
         CMC(2,1) = 38./3.D0
         CMC(2,2) =  4./9.D0  
!
         CMCI30 = + 80507./432.D0 * ZETA(3) + 58933./1944.D0 &
     &            + 128./3.D0 * ZETA(2) * (1.+ DLOG(2.D0)/3.D0)
         CMCF30 = - 64./9.D0 * (ZETA(2) + 2479./3456.D0)
         CMCI31 =   8941./27.D0
         CMCF31 = - 409./27.D0
         CMC(3,2) = 511./9.D0
         CMC(3,3) = 8./27.D0
!
         PRVCLL = 1
!
       END IF
!
! ---------------------------------------------------------------------
!
! ..The N_f dependent CMC's, and the alpha_s matching at order NAORD 
!
       CMC(3,0) = CMCI30 + NF * CMCF30
       CMC(3,1) = CMCI31 + NF * CMCF31
!
       ASNF1 = ASNF
       IF (NAORD .EQ. 0) GOTO 1
       ASP   = ASNF
!
       DO 11 K1 = 1, NAORD 
         ASP = ASP * ASNF
         LRHP = 1.D0
!
       DO 12 K2 = 0, K1
         ASNF1 = ASNF1 + ASP * CMC(K1,K2) * LRHP
         LRHP = LRHP * LOGRH
!
  12   CONTINUE
  11   CONTINUE
!
! ---------------------------------------------------------------------
!
   1   RETURN
       END

!
! =================================================================av==
!
! ..The subroutine  EVNFTHR  for the evolution of  a_s = alpha_s/(4 pi)
!    from a three-flavour initial scale to the four- to six-flavour
!    thresholds (identified with the squares of the corresponding quark
!    masses).  The results are written to the common-block  ASFTHR.
!
! ..The input scale  M20 = mu_(f,0)^2  and the corresponding value 
!    AS0  of a_s  are provided by  ASINP.  The fixed scale logarithm
!    LOGFR = ln (mu_f^2/mu_r^2) is specified in  FRRAT.  The alpha_s
!    matching is done by the function ASNF1.
!
! =====================================================================
!
!
       SUBROUTINE EVNFTHR (MC2, MB2, MT2)
!
       IMPLICIT NONE
       DOUBLE PRECISION MC2, MB2, MT2, M20, M2C, M2B, M2T, R20, R2C, &
     &                  R2B, R2T, AS, ASNF1, AS0, ASC, ASB, AST, &
     &                  ASC3, ASB4, AST5, LOGFR, SC, SB, ST
!
! ---------------------------------------------------------------------
! 
! ..Input common blocks
!  
       COMMON / ASINP  / AS0, M20
       COMMON / FRRAT  / LOGFR
!
! ..Output common blocks
!
       COMMON / ASFTHR / ASC, M2C, ASB, M2B, AST, M2T

! ---------------------------------------------------------------------
!
! ..Coupling constants at and evolution distances to/between thresholds
! 
       R20 = M20 * EXP(-LOGFR)
!
! ..Charm
!
       M2C  = MC2
       R2C  = M2C * R20/M20
       ASC3 = AS (R2C, R20, AS0, 3)
       SC   = LOG (AS0 / ASC3)
       ASC  = ASNF1 (ASC3, -LOGFR, 3)
!
! ..Bottom 
!
       M2B  = MB2
       R2B  = M2B * R20/M20
       ASB4 = AS (R2B, R2C, ASC, 4)
       SB   = LOG (ASC / ASB4)
       ASB  = ASNF1 (ASB4, -LOGFR, 4)
!
! ..Top
!
       M2T  = MT2
       R2T  = M2T * R20/M20
       AST5 = AS (R2T, R2B, ASB, 5)
       ST   = LOG (ASB / AST5)
       AST  = ASNF1 (AST5, -LOGFR, 5)

       RETURN
       END

!
! =================================================================av==
!
! ..The running coupling of QCD,  
!
!         AS  =  a_s  =  alpha_s(mu_r^2)/(4 pi),
!
!    obtained by integrating the evolution equation for a fixed number
!    of massless flavours  NF.  Except at leading order (LO),  AS  is 
!    obtained using a fourth-order Runge-Kutta integration.
!
! ..The initial and final scales  R20  and  R2,  the value  AS0  at
!    R20, and  NF  are passed as function arguments.  The coefficients 
!    of the beta function up to  a_s^5 (N^3LO)  are provided by the 
!    common-block  BETACOM.  The order of the expansion  NAORD (defined
!    as the 'n' in N^nLO) and the number of steps  NASTPS  for the 
!    integration beyond LO are given by the common-block  ASPAR.
!
! =====================================================================
!
!
      DOUBLE PRECISION FUNCTION AS (R2, R20, AS0, NF)
!
      IMPLICIT NONE
      INTEGER NFMIN, NFMAX, NF, NAORD, NASTPS, K1
      DOUBLE PRECISION R2, R20, AS0, SXTH, BETA0, BETA1, BETA2, BETA3, &
     &     FBETA1,FBETA2,FBETA3,A,LRRAT,DLR,XK0,XK1,XK2,XK3
      PARAMETER (NFMIN = 3, NFMAX = 6)
      PARAMETER ( SXTH = 0.166666666666666D0 )
!
! ---------------------------------------------------------------------
!
! ..Input common-blocks 
!
       COMMON / ASPAR  / NAORD, NASTPS
       COMMON / BETACOM   / BETA0 (NFMIN:NFMAX), BETA1 (NFMIN:NFMAX), &
     &                   BETA2 (NFMIN:NFMAX), BETA3 (NFMIN:NFMAX)
!
! ..The beta functions FBETAn at N^nLO for n = 1, 2, and 3
!
       FBETA1(A) = - A**2 * ( BETA0(NF) + A *   BETA1(NF) )
       FBETA2(A) = - A**2 * ( BETA0(NF) + A * ( BETA1(NF) &
     &                        + A * BETA2(NF) ) )
       FBETA3(A) = - A**2 * ( BETA0(NF) + A * ( BETA1(NF) &
     &                        + A * (BETA2(NF) + A * BETA3(NF)) ) )
!
! ---------------------------------------------------------------------
!
! ..Initial value, evolution distance and step size
!
       AS = AS0
       LRRAT = LOG (R2/R20)
       DLR = LRRAT / NASTPS
!
! ..Solution of the evolution equation depending on  NAORD
!   (fourth-order Runge-Kutta beyond the leading order)
!
       IF (NAORD .EQ. 0) THEN
!
         AS = AS0 / (1.+ BETA0(NF) * AS0 * LRRAT)
!
       ELSE IF (NAORD .EQ. 1) THEN
!
       DO 2 K1 = 1, NASTPS
         XK0 = DLR * FBETA1 (AS)
         XK1 = DLR * FBETA1 (AS + 0.5 * XK0)
         XK2 = DLR * FBETA1 (AS + 0.5 * XK1)
         XK3 = DLR * FBETA1 (AS + XK2)
         AS = AS + SXTH * (XK0 + 2.* XK1 + 2.* XK2 + XK3)
  2    CONTINUE
!
       ELSE IF (NAORD .EQ. 2) THEN
!
       DO 3 K1 = 1, NASTPS
         XK0 = DLR * FBETA2 (AS)
         XK1 = DLR * FBETA2 (AS + 0.5 * XK0)
         XK2 = DLR * FBETA2 (AS + 0.5 * XK1)
         XK3 = DLR * FBETA2 (AS + XK2)
         AS = AS + SXTH * (XK0 + 2.* XK1 + 2.* XK2 + XK3)
  3    CONTINUE
!  
       ELSE IF (NAORD .EQ. 3) THEN
!
       DO 4 K1 = 1, NASTPS
         XK0 = DLR * FBETA3 (AS)
         XK1 = DLR * FBETA3 (AS + 0.5 * XK0)
         XK2 = DLR * FBETA3 (AS + 0.5 * XK1)
         XK3 = DLR * FBETA3 (AS + XK2)
         AS = AS + SXTH * (XK0 + 2.* XK1 + 2.* XK2 + XK3)
  4    CONTINUE
       END IF
!
! ---------------------------------------------------------------------
!
       RETURN
       END

!
! =================================================================av==
!
! ..The subroutine BETAFCT for the coefficients  BETA0...BETA3  of the 
!    beta function of QCD up to order alpha_s^5 (N^3LO), normalized by 
!
!        d a_s / d ln mu_r^2  =  - BETA0 a_s^2 - BETA1 a_s^3 - ... 
!
!    with  a_s = alpha_s/(4*pi). 
!
! ..The MSbar coefficients are written to the common-block BETACOM for 
!   NF = 3...6  (parameters NFMIN, NFMAX) quark flavours.
!
! ..The factors CF, CA and TF  are taken from the common-block  COLOUR.
!    Beyond NLO the QCD colour factors are hard-wired in this routine,
!    and the numerical coefficients are truncated to six digits.
!
! =====================================================================
!
!
       SUBROUTINE BETAFCT
!
       IMPLICIT DOUBLE PRECISION (A - Z)
       INTEGER NFMIN, NFMAX, NF
       PARAMETER (NFMIN = 3, NFMAX = 6)
!
! ---------------------------------------------------------------------
!
! ..Input common-block
!
       COMMON / COLOUR / CF, CA, TR
!
! ..Output common-block
!
       COMMON / BETACOM   / BETA0 (NFMIN:NFMAX), BETA1 (NFMIN:NFMAX), &
     &                   BETA2 (NFMIN:NFMAX), BETA3 (NFMIN:NFMAX)

!
! ---------------------------------------------------------------------
!
! ..The full LO and NLO coefficients 
!
       B00 =  11./3.D0 * CA
       B01 =  -4./3.D0 * TR
       B10 =  34./3.D0 * CA**2
       B11 = -20./3.D0 * CA*TR - 4.* CF*TR
!
! ..Flavour-number loop and output to the array
!
       DO 1 NF = NFMIN, NFMAX
!
       BETA0(NF) = B00 + B01 * NF
       BETA1(NF) = B10 + B11 * NF
!
       BETA2(NF) = 1428.50 - 279.611 * NF + 6.01852 * NF**2
       BETA3(NF) = 29243.0 - 6946.30 * NF + 405.089 * NF**2 &
     &             + 1.49931 * NF**3
!
! ---------------------------------------------------------------------
!
  1    CONTINUE
!
       RETURN
       END
!
! =================================================================av==


!--   G.W. MSTWDZEROX taken from CERNLIB to find the zero of a function.
      DOUBLE PRECISION FUNCTION MSTWDZEROX(A0,B0,EPS,MAXF,F,MODE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
!     Based on
!
!        J.C.P. Bus and T.J. Dekker, Two Efficient Algorithms with
!        Guaranteed Convergence for Finding a Zero of a Function,
!        ACM Trans. Math. Software 1 (1975) 330-345.
!
!        (MODE = 1: Algorithm M;    MODE = 2: Algorithm R)
      CHARACTER*80 ERRTXT
      LOGICAL LMT
      DIMENSION IM1(2),IM2(2),LMT(2)
      PARAMETER (Z1 = 1, HALF = Z1/2)
      DATA IM1 /2,3/, IM2 /-1,3/
      MSTWDZEROX = 0.D0             ! G.W. to prevent compiler warning
      IF(MODE .NE. 1 .AND. MODE .NE. 2) THEN
       C=0
       WRITE(ERRTXT,101) MODE
       WRITE(6,*) ERRTXT
       GOTO 99
      ENDIF
      FA=F(B0)
      FB=F(A0)
      IF(FA*FB .GT. 0) THEN
       C=0
       WRITE(ERRTXT,102) A0,B0
       WRITE(6,*) ERRTXT
       GOTO 99
      ENDIF
      ATL=ABS(EPS)
      B=A0
      A=B0
      LMT(2)=.TRUE.
      MF=2
    1 C=A
      FC=FA
    2 IE=0
    3 IF(ABS(FC) .LT. ABS(FB)) THEN
       IF(C .NE. A) THEN
        D=A
        FD=FA
       END IF
       A=B
       B=C
       C=A
       FA=FB
       FB=FC
       FC=FA
      END IF
      TOL=ATL*(1+ABS(C))
      H=HALF*(C+B)
      HB=H-B
      IF(ABS(HB) .GT. TOL) THEN
       IF(IE .GT. IM1(MODE)) THEN
        W=HB
       ELSE
        TOL=TOL*SIGN(Z1,HB)
        P=(B-A)*FB
        LMT(1)=IE .LE. 1
        IF(LMT(MODE)) THEN
         Q=FA-FB
         LMT(2)=.FALSE.
        ELSE
         FDB=(FD-FB)/(D-B)
         FDA=(FD-FA)/(D-A)
         P=FDA*P
         Q=FDB*FA-FDA*FB
        END IF
        IF(P .LT. 0) THEN
         P=-P
         Q=-Q
        END IF
        IF(IE .EQ. IM2(MODE)) P=P+P
        IF(P .EQ. 0 .OR. P .LE. Q*TOL) THEN
         W=TOL
        ELSEIF(P .LT. HB*Q) THEN
         W=P/Q
        ELSE
         W=HB
        END IF
       END IF
       D=A
       A=B
       FD=FA
       FA=FB
       B=B+W
       MF=MF+1
       IF(MF .GT. MAXF) THEN
        WRITE(6,*) "Error in MSTWDZEROX: TOO MANY FUNCTION CALLS"
        GOTO 99
       ENDIF
       FB=F(B)
       IF(FB .EQ. 0 .OR. SIGN(Z1,FC) .EQ. SIGN(Z1,FB)) GOTO 1
       IF(W .EQ. HB) GOTO 2
       IE=IE+1
       GOTO 3
      END IF
      MSTWDZEROX=C
   99 CONTINUE
      RETURN
  101 FORMAT('Error in MSTWDZEROX: MODE = ',I3,' ILLEGAL')
  102 FORMAT('Error in MSTWDZEROX: F(A) AND F(B) HAVE THE SAME SIGN, A = ', &
     &     1P,D15.8,', B = ',D15.8)
      END

! ---------------------------------------------------------------------

! -*- F90 -*-


      subroutine QCDNUM3evolve(x,Q,pdf) 
      implicit none 
      character*64 gridname 
      character*16 s1,dummy 
      integer Eorder,index 
      real*8 x,Q,Qlam,Q2,Q2fit,alfas0,scale0,alfas 
      real*8 mc,mc2,mb,mb2,mt,mt2,tc,tc2,tb,tb2 
      real*8 singlet,dm,um,dp,up,sp,ub,db,sb,cb,bb,bp,cp,gl,xx 
      real*8 QALFAS,QPDFXQ,XFROMIX 
      real*8 f(-6:6),pdf(-6:6) 
      integer iq0,iqc,iqb,nf,nf0,qnerr,NFLGET,iflag,ix,i,IQFROMQ 
      integer nx,nq 
      integer nset,iset,isetlast 
      data isetlast/-1/ 
      real*8 xmin,xmax,qmin,qmax,S 
      save iq0,iqc,iqb,nf0,mc2,mb2,tc2,tb2,mt2 
      save nx,xmin,xmax,nq,qmin,qmax,gridname 
!                                                                       
      call getnset(iset) 
      if (iset.ne.isetlast) then 
        call get_pdfqcd(iset) 
        isetlast = iset 
      endif 
!                                                                       
      Q2=Q*Q 
      nf=3 
      pdf(0)=QPDFXQ('GLUON'  ,x,Q2,iflag) 
      singlet=QPDFXQ('SINGLET',x,Q2,iflag) 
      dm= QPDFXQ('DM',x,Q2,IFLAG) 
      um= QPDFXQ('UM',x,Q2,IFLAG) 
      dp= QPDFXQ('DP',x,Q2,IFLAG) 
      up= QPDFXQ('UP',x,Q2,IFLAG) 
      sp= QPDFXQ('SP',x,Q2,IFLAG) 
      ub=0.5d0*(up-um+singlet/dble(nf)) 
      db=0.5d0*(dp-dm+singlet/dble(nf)) 
      sb=0.5d0*(sp+singlet/dble(nf)) 
                                                                        
      pdf(1)=dm+db 
      pdf(2)=um+ub 
      pdf(3)=sb 
      pdf(4)=0d0 
      pdf(5)=0d0 
      pdf(6)=0d0 
      pdf(-1)=db 
      pdf(-2)=ub 
      pdf(-3)=sb 
      pdf(-4)=0d0 
      pdf(-5)=0d0 
      pdf(-6)=0d0 
      return 
!                                                                       
      entry QCDNUM3alfa(alfas,Q) 
      Q2=Q*Q 
      nf=3 
      alfas=QALFAS(Q2,Qlam,nf,iflag) 
      return 
!                                                                       
      entry QCDNUM3read(nset) 
!      read(1,*) s1                                                     
!      print *,s1                                                       
!         gridname='large.grid'                                         
!         nx=400                                                        
!         xmin=1d-6                                                     
!         xmax=1d0                                                      
!         nq=112                                                        
!         qmin=1d0                                                      
!         qmax=1d10                                                     
!         read(1,*) dummy                                               
!      else                                                             
         read(1,*) gridname,nx,xmin,xmax,nq,qmin,qmax 
!*      endif                                                           
!      iset = nset                                                      
      return 
!                                                                       
      entry QCDNUM3init(nset,Eorder,Q2fit) 
      call qninit 
      call QNISET('ORDER',Eorder+1) 
      call grxdef(nx,xmin) 
      call grqdef(nq,qmin,qmax) 
      call grqinp(Q2fit,1) 
      iq0=IQFROMQ(Q2fit) 
!      nf0= NFLGET(iq0)                                                 
      nf0=3 
      CALL QNBOOK(2,'dm') 
      CALL QNBOOK(3,'um') 
      CALL QNBOOK(4,'dp') 
      CALL QNBOOK(5,'up') 
      CALL QNBOOK(6,'sp') 
      CALL QNLSET('W1ANA',.TRUE.) 
      CALL QNLSET('W2NUM',.TRUE.) 
      CALL QNLSET('W2STF',.FALSE.) 
      call qthres(1d10,2d10) 
      if (index(gridname,'none').eq.1) then 
         call qnfilw(0,0) 
      else 
         qnerr=-1 
         open(unit=2,status='old',file=gridname,                        &
     &        form='unformatted',err=1)                                 
         call QNREAD(2,1,qnerr) 
    1    close(2) 
         if (qnerr.ne.0) then 
            write(*,*) 'Grid file problem: ',gridname 
            if (qnerr.lt.0) then 
               write(*,*) 'Grid file does not exist' 
               write(*,*) 'Calculating and creating grid file' 
               call qnfilw(0,0) 
               open(unit=2,status='unknown',file=gridname,              &
     &              form='unformatted')                                 
               call QNDUMP(2) 
               close(2) 
            else 
               write(*,*) 'Existing grid file is inconsistent' 
               if (qnerr.eq.1)                                          &
     &              write(*,*) 'Defined grid different'                 
               if (qnerr.eq.2)                                          &
     &              write(*,*) 'Heavy quark weight table different'     
               if (qnerr.eq.3)                                          &
     &              write(*,*) 'Charm mass different'                   
               if (qnerr.eq.4)                                          &
     &              write(*,*) 'Bottom mass different'                  
               stop 
            endif 
         endif 
      endif 
      return 
!                                                                       
      entry QCDNUM3pdf(nset) 
!      print *,'entering QCDNUMpdf',nset                                
      call GetAlfas(nset,alfas0,scale0) 
!      print *,alfas0,scale0                                            
      Q2=scale0*scale0 
      CALL QNRSET('ALFAS',alfas0) 
      CALL QNRSET('ALFQ0',Q2) 
      DO ix = 1,nx 
         xx = XFROMIX(ix) 
!         print *,'calling parmPDF',ix                                  
         call parmPDF(nset,xx,f) 
!         if(ix.lt.6) print *,nset,xx,f                                 
         singlet=0.d0 
         do i=1,nf0 
            singlet=singlet+f(i)+f(-i) 
!            print  *,i,singlet                                         
         end do 
         gl=f(0) 
         dm=f(1)-f(-1) 
         um=f(2)-f(-2) 
         dp=f(1)+f(-1)-singlet/dble(nf0) 
         up=f(2)+f(-2)-singlet/dble(nf0) 
         sp=f(3)+f(-3)-singlet/dble(nf0) 
         CALL QNPSET('SINGLET',ix,iq0,singlet) 
         CALL QNPSET('GLUON',ix,iq0,gl) 
         CALL QNPSET('DM',ix,iq0,DM) 
         CALL QNPSET('UM',ix,iq0,UM) 
         CALL QNPSET('DP',ix,iq0,DP) 
         CALL QNPSET('UP',ix,iq0,UP) 
         CALL QNPSET('SP',ix,iq0,SP) 
      ENDDO 
      CALL EVOLSG(iq0,1,nq) 
      CALL EVOLNM('DM',iq0,1,nq) 
      CALL EVOLNM('UM',iq0,1,nq) 
!                                                                       
!      CALL EVPLUS('DP',iq0,1,nq)                                       
!      CALL EVPLUS('UP',iq0,1,nq)                                       
!      CALL EVPLUS('SP',iq0,1,nq)                                       
      CALL EVOLNP('DP',iq0,1,nq) 
      CALL EVOLNP('UP',iq0,1,nq) 
      CALL EVOLNP('SP',iq0,1,nq) 
!                                                                       
      call getnset(iset) 
      call save_pdfqcd(iset) 
      return 
!                                                                       
      END                                           

! -*- F90 -*-


      subroutine GRVP1evolve(xin,qin,pdf) 
      include 'parmsetup.inc' 
      real*8 xin,qin,pdf(-6:6),xval(45),qcdl4,qcdl5 
      real*8 upv,dnv,usea,dsea,str,chm,bot,top,glu 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
                                                                        
      save 
                                                                        
      call grvpiho(xin,Qin,upv,dnv,usea,str,chm,bot,top,glu) 
                                                                        
      pdf(-6)= top 
      pdf(6)= top 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv+usea 
      pdf(-1)= usea 
      pdf(1 )= dnv+usea 
      pdf(0 )= glu 
                                                                        
      return 
!                                                                       
      entry GRVP0evolve(xin,qin,pdf) 
                                                                        
      call grvpilo(xin,Qin,upv,dnv,usea,str,chm,bot,top,glu) 
                                                                        
      pdf(-6)= top 
      pdf(6)= top 
      pdf(-5)= bot 
      pdf(5 )= bot 
      pdf(-4)= chm 
      pdf(4 )= chm 
      pdf(-3)= str 
      pdf(3 )= str 
      pdf(-2)= usea 
      pdf(2 )= upv+usea 
      pdf(-1)= usea 
      pdf(1 )= dnv+usea 
      pdf(0 )= glu 
                                                                        
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRVPread(nset) 
      read(1,*)nmem(nset),ndef(nset) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRVPalfa(alfas,qalfa) 
        call getnset(iset) 
        call getnmem(iset,imem) 
        call GetOrderAsM(iset,iord) 
        call Getlam4M(iset,imem,qcdl4) 
        call Getlam5M(iset,imem,qcdl5) 
        call aspdflib(alfas,Qalfa,iord,qcdl5) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRVPinit(Eorder,Q2fit) 
      return 
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      entry GRVPpdf(mem) 
!      imem = mem                                                       
      call getnset(iset) 
      call setnmem(iset,mem) 
      return 
!                                                                       
 1000 format(5e13.5) 
      END                                           
!                                                                       
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!                                                                       
! $Id: wrapgrvpi.f 356 2008-08-28 15:58:02Z buckley $                   
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:28:44  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:29:24  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
       SUBROUTINE GRVPIHO (ZX,ZQ,ZUV,ZDV,ZUDB,ZSB,ZCB,ZBB,ZTB,ZGL) 
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *     
!                                                                 *     
!         G R V - P I O N - P A R A M E T R I Z A T I O N S       *     
!                                                                 *     
!                 FOR A DETAILED EXPLANATION SEE :                *     
!              M. GLUECK, E.REYA, A.VOGT: DO-TH 91/16             *     
!                                                                 *     
!   THE PARAMETRIZATIONS ARE FITTED TO THE PARTON DISTRIBUTIONS   *     
!   FOR Q ** 2 BETWEEN MU ** 2 (=  0.25 / 0.30  GEV ** 2  IN LO   *     
!   / HO) AND  1.E8 GEV ** 2  AND FOR X BETWEEN  1.E-5  AND  1.   *     
!   REGIONS, WHERE THE DISTRIBUTION UNDER CONSIDERATION IS NEG-   *     
!   LIGIBLE, I.E. BELOW ABOUT 1.E-4, WERE EXCLUDED FROM THE FIT.  *     
!                                                                 *     
!              HEAVY QUARK THRESHOLDS  Q(H) = M(H) :              *     
!         M(C)  =  1.5,  M(B)  =  4.5,  M(T)  =  100  GEV         *     
!                                                                 *     
!      CORRESPONDING LAMBDA(F) VALUES FOR F ACTIVE FLAVOURS :     *     
!      LO :   LAMBDA(3)  =  0.232,   LAMBDA(4)  =  0.200,         *     
!             LAMBDA(5)  =  0.153,   LAMBDA(6)  =  0.082  GEV     *     
!      HO :   LAMBDA(3)  =  0.248,   LAMBDA(4)  =  0.200,         *     
!             LAMBDA(5)  =  0.131,   LAMBDA(6)  =  0.053  GEV     *     
!                                                                 *     
!   HO DISTRIBUTION REFER TO THE MS-BAR SCHEME OF BARDEEN ET AL.  *     
!                                                                 *     
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *     
!                                                                       
       IMPLICIT REAL (A - Y) 
       double precision                                                 &
     &        ZX,ZQ,ZUV,ZDV,ZUDB,ZSB,ZCB,ZBB,ZTB,ZGL                    
       REAL  X, Q 
       X = ZX 
       Q = ZQ 
       MU2  = 0.3 
       LAM2 = 0.248 * 0.248 
       Q2 = Q*Q 
       S  = ALOG (ALOG(Q2/LAM2) / ALOG(MU2/LAM2)) 
       DS = SQRT (S) 
       S2 = S * S 
!...X * VALENCE :                                                       
       NV  =  0.456 + 0.150 * DS + 0.112 * S - 0.019 * S2 
       AKV =  0.505 - 0.033 * S 
       AGV =  0.748 - 0.669 * DS - 0.133 * S 
       DV  =  0.365 + 0.197 * DS + 0.394 * S 
       VAP =  GRVFVP (X, NV, AKV, AGV, DV) 
       ZUV = VAP 
       ZDV = ZUV 
!...X * GLUON :                                                         
       ALG =  1.096 
       BEG =  1.371 
       AKG =  0.437 - 0.689 * DS 
       BKG = -0.631 
       AGG =  1.324 - 0.441 * DS - 0.130 * S 
       BGG = -0.955 + 0.259 * S 
       CG  =  1.075 - 0.302 * S 
       DG  =  1.158 + 1.229 * S 
       EG  =   0.0  + 2.510 * S 
       ESG =  2.604 + 0.165 * S 
       GLP =  GRVFGP(X,S, ALG, BEG, AKG, BKG, AGG, BGG, CG, DG, EG, ESG) 
       ZGL = GLP 
!...X * QBAR (SU(3)-SYMMETRIC SEA) :                                    
       SL  =   0.0 
       ALS =   0.85 
       BES =   0.96 
       AKS = -0.350 + 0.806 * S 
       AGS = -1.663 
       BS  =  3.148 
       DS  =  2.273 + 1.438 * S 
       EST =  3.214 + 1.545 * S 
       ESS =  1.341 + 1.938 * S 
       QBP =  GRVFQBP (X, S, SL, ALS, BES, AKS, AGS, BS, DS, EST, ESS) 
       ZUDB = QBP 
       ZSB = ZUDB 
!...X * CBAR = X * C :                                                  
       SC  =  0.820 
       ALC =   0.98 
       BEC =   0.0 
       AKC =   0.0  - 0.457 * S 
       AGC =   0.0 
       BC  =  -1.00 +  1.40 * S 
       DC  =  1.318 + 0.584 * S 
       EC  =   4.45 + 1.235 * S 
       ESC =  1.496 + 1.010 * S 
       CBP =  GRVFQBP (X, S, SC, ALC, BEC, AKC, AGC, BC, DC, EC, ESC) 
       ZCB = CBP 
!...X * BBAR = X * B :                                                  
       SBO =  1.297 
       ALB =   0.99 
       BEB =   0.0 
       AKB =   0.0  - 0.172 * S 
       AGB =   0.0 
       BBO =   0.0 
       DB  =  1.447 + 0.485 * S 
       EB  =   4.79 + 1.164 * S 
       ESB =  1.724 + 2.121 * S 
       BBP =  GRVFQBP (X, S, SBO, ALB, BEB, AKB, AGB, BBO, DB, EB, ESB) 
       ZBB = BBP 
!...X * TBAR = X * T :                                                  
       TBP = 0. 
       ZTB = TBP 
       RETURN 
      END                                           
!=================================================================      
!                                                                       
! $Id: wrapgrvpi.f 356 2008-08-28 15:58:02Z buckley $                   
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:28:44  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:29:24  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
       SUBROUTINE GRVPILO (ZX,ZQ,ZUV,ZDV,ZUDB,ZSB,ZCB,ZBB,ZTB,ZGL) 
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *     
!                                                                 *     
!         G R V - P I O N - P A R A M E T R I Z A T I O N S       *     
!                                                                 *     
!                 FOR A DETAILED EXPLANATION SEE :                *     
!              M. GLUECK, E.REYA, A.VOGT: DO-TH 91/16             *     
!                                                                 *     
!   THE PARAMETRIZATIONS ARE FITTED TO THE PARTON DISTRIBUTIONS   *     
!   FOR Q ** 2 BETWEEN MU ** 2 (=  0.25 / 0.30  GEV ** 2  IN LO   *     
!   / HO) AND  1.E8 GEV ** 2  AND FOR X BETWEEN  1.E-5  AND  1.   *     
!   REGIONS, WHERE THE DISTRIBUTION UNDER CONSIDERATION IS NEG-   *     
!   LIGIBLE, I.E. BELOW ABOUT 1.E-4, WERE EXCLUDED FROM THE FIT.  *     
!                                                                 *     
!              HEAVY QUARK THRESHOLDS  Q(H) = M(H) :              *     
!         M(C)  =  1.5,  M(B)  =  4.5,  M(T)  =  100  GEV         *     
!                                                                 *     
!      CORRESPONDING LAMBDA(F) VALUES FOR F ACTIVE FLAVOURS :     *     
!      LO :   LAMBDA(3)  =  0.232,   LAMBDA(4)  =  0.200,         *     
!             LAMBDA(5)  =  0.153,   LAMBDA(6)  =  0.082  GEV     *     
!      HO :   LAMBDA(3)  =  0.248,   LAMBDA(4)  =  0.200,         *     
!             LAMBDA(5)  =  0.131,   LAMBDA(6)  =  0.053  GEV     *     
!                                                                 *     
!   HO DISTRIBUTION REFER TO THE MS-BAR SCHEME OF BARDEEN ET AL.  *     
!                                                                 *     
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *     
!                                                                       
       IMPLICIT REAL (A - Y) 
       double precision                                                 &
     &        ZX,ZQ,ZUV,ZDV,ZUDB,ZSB,ZCB,ZBB,ZTB,ZGL                    
       REAL  X, Q 
       X = ZX 
       Q = ZQ 
       MU2  = 0.25 
       LAM2 = 0.232 * 0.232 
       Q2 = Q*Q 
       S  = ALOG (ALOG(Q2/LAM2) / ALOG(MU2/LAM2)) 
       DS = SQRT (S) 
       S2 = S * S 
!...X * VALENCE :                                                       
       NV  =  0.519 + 0.180 * S - 0.011 * S2 
       AKV =  0.499 - 0.027 * S 
       AGV =  0.381 - 0.419 * S 
       DV  =  0.367 + 0.563 * S 
       VAP =  GRVFVP (X, NV, AKV, AGV, DV) 
       ZUV = VAP 
       ZDV = ZUV 
!...X * GLUON :                                                         
       ALG =  0.599 
       BEG =  1.263 
       AKG =  0.482 + 0.341 * DS 
       BKG =   0.0 
       AGG =  0.678 + 0.877 * S  - 0.175 * S2 
       BGG =  0.338 - 1.597 * S 
       CG  =   0.0  - 0.233 * S  + 0.406 * S2 
       DG  =  0.390 + 1.053 * S 
       EG  =  0.618 + 2.070 * S 
       ESG =  3.676 
       GLP =  GRVFGP(X,S, ALG, BEG, AKG, BKG, AGG, BGG, CG, DG, EG, ESG) 
       ZGL = GLP 
!...X * QBAR (SU(3)-SYMMETRIC SEA) :                                    
       SL  =   0.0 
       ALS =   0.55 
       BES =   0.56 
       AKS =  2.538 - 0.763 * S 
       AGS = -0.748 
       BS  =  0.313 + 0.935 * S 
       DS  =  3.359 
       EST =  4.433 + 1.301 * S 
       ESS =   9.30 - 0.887 * S 
       QBP =  GRVFQBP (X, S, SL, ALS, BES, AKS, AGS, BS, DS, EST, ESS) 
       ZUDB = QBP 
       ZSB = ZUDB 
!...X * CBAR = X * C :                                                  
       SC  =  0.888 
       ALC =   1.02 
       BEC =   0.39 
       AKC =   0.0 
       AGC =   0.0 
       BC  =  1.008 
       DC  =  1.208 + 0.771 * S 
       EC  =   4.40 + 1.493 * S 
       ESC =  2.032 + 1.901 * S 
       CBP =  GRVFQBP (X, S, SC, ALC, BEC, AKC, AGC, BC, DC, EC, ESC) 
       ZCB = CBP 
!...X * BBAR = X * B :                                                  
       SBO =  1.351 
       ALB =   1.03 
       BEB =   0.39 
       AKB =   0.0 
       AGB =   0.0 
       BBO =   0.0 
       DB  =  0.697 + 0.855 * S 
       EB  =   4.51 + 1.490 * S 
       ESB =  3.056 + 1.694 * S 
       BBP =  GRVFQBP (X, S, SBO, ALB, BEB, AKB, AGB, BBO, DB, EB, ESB) 
       ZBB = BBP 
!...X * TBAR = X * T :                                                  
       TBP = 0. 
       ZTB = TBP 
       RETURN 
      END                                           
!====================================================================   
!                                                                       
! $Id: wrapgrvpi.f 356 2008-08-28 15:58:02Z buckley $                   
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:28:38  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:29:23  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
       FUNCTION GRVFVP (X, N, AK, AG, D) 
       IMPLICIT REAL (A - Z) 
       DX = SQRT (X) 
       GRVFVP = N * X**AK * (1.+ AG*DX) * (1.- X)**D 
       RETURN 
      END                                           
!====================================================================   
!                                                                       
! $Id: wrapgrvpi.f 356 2008-08-28 15:58:02Z buckley $                   
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:28:37  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:29:23  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
       FUNCTION GRVFQBP (X, S, ST, AL, BE, AK, AG, B, D, E, ES) 
       IMPLICIT REAL (A - Z) 
       DX = SQRT (X) 
       LX = ALOG (1./X) 
       IF (S .LE. ST) THEN 
          GRVFQBP = 0.0 
       ELSE 
          GRVFQBP = (S-ST)**AL / LX**AK * (1.+ AG*DX + B*X) * (1.- X)**D&
     &           * EXP (-E + SQRT (ES * S**BE * LX))                    
       END IF 
       RETURN 
      END                                           
!====================================================================   
!                                                                       
! $Id: wrapgrvpi.f 356 2008-08-28 15:58:02Z buckley $                   
!                                                                       
! $Log$                                                                 
! Revision 1.2  2005/10/07 15:15:05  whalley                            
! Changes to most files for V5 - multiset initializations               
!                                                                       
! Revision 1.1.1.1  2005/05/06 14:54:43  whalley                        
! Initial CVS import of the LHAPDF code and data sets                   
!                                                                       
! Revision 1.1.1.2  1996/10/30 08:28:36  cernlib                        
! Version 7.04                                                          
!                                                                       
! Revision 1.1.1.1  1996/04/12 15:29:23  plothow                        
! Version 7.01                                                          
!                                                                       
!                                                                       
       FUNCTION GRVFGP (X, S, AL, BE, AK, BK, AG, BG, C, D, E, ES) 
       IMPLICIT REAL (A - Z) 
       DX = SQRT (X) 
       LX = ALOG (1./X) 
       GRVFGP = (X**AK * (AG + BG*DX + C*X) * LX**BK + S**AL            &
     &       * EXP (-E + SQRT (ES * S**BE * LX))) * (1.- X)**D          
       RETURN 
      END                                           

! -*- F90 -*-


!****************************************************************************
!
!                         eps08.f
!
! An interface for calculating the scale dependent nuclear modifications
!                 R_f^A(x,Q) = f_A(x,Q)/f_p(x,Q) 
! where f_A is the distribution of the parton flavour f for a PROTON in a
! nucleus A, and f_p is the corresponding parton distribution in the 
! free proton.
!
! The EPS08 set of modifications R_f^A(x,Q) which we provide here,
! corresponds to the LO DGLAP evolution of the nPDFs f_A(x,Q).
!
! When using this interface, please refer to:
!  
!  K.J. Eskola, H. Paukkunen and C.A. Salgado,
!  "An improved global analysis of nuclear parton distribution functions
!  including RHIC data"
!  arXiv:0802.0139 [hep-ph].
!
! Questions & comments to:
!           hannu.paukkunen@phys.jyu.fi
!           carlos.salgado@cern.ch
!           kari.eskola@phys.jyu.fi
! 
! ***************************************************************************
! Instructions:
!
! To obtain the nuclear corrections for given input
! values of momentum fraction x, scale Q (in GeV),
! and atomic number A (all in double precision), use the command
!
!    Call eps08(x,Q,A,ruv,rdv,ru,rd,rs,rc,rb,rt,rg)
!
! which returns the bound proton nuclear corrections R_f^A(x,Q)
! (in double precision) for
!        
!        ruv = up valence
!        rdv = down valence
!        ru  = up sea
!        rd  = down sea
!        rs  = strange
!        rc  = charm
!        rb  = bottom (=0 for Q < mb=4.64)
!       rt  = top (=1 for all x and Q)
!        rg  = gluons
!
! The nuclear corrections for bound neutrons can be obtained
! by the isospin symmetry (see Sec.2 of article quoted above),
! so that e.g. the total up quark distribution per nucleon in a
! nucleus A with Z protons is
!
!  u_A(x,Q) =    Z/A * [ruv*uV_p(x,Q) + ru*uSea_p(x,Q)] +
!            (A-Z)/A * [rdv*dV_p(x,Q) + rd*dSea_p(x,Q)]
!
! Note that the parametrization should only be applied at the region
!
!             1e-6 <= x < 1
!              1.3 <= Q <= 1000 GeV
!                2 <= A <= 208
!
! No warning message is displayed if these limits are
! exceeded, and outside these boundaries the modifications
! are frozen to the boundary values, i.e
!
!   for Q > 1000, the modifications at Q=1000 are returned,
!   for Q < 1.3,  the modifications at Q=1.3 are returned,
!   for x < 1e-6, the modifications at x=1e-6 are returned,
!   for A > 208,  the modifications at A=208 are returned,
!   for A <= 2 or x >= 1, the function returns 1.
!
! The program uses the data file eps08dta.all,
! which must be located in current working directory.
!
! *********************************************************
! *********************************************************

subroutine eps08(xxx,q,aaa,ruv,rdv,ru,rd,rs,rc,rb,rt,rg)
  
  implicit double precision(a-h,o-z)
  dimension rateps08(8)
  dimension pint08(5), pint082(5)
  common/eps0800/qq0, qqb
  common/eps0803/ kty, ind
  common/eps0810/qq1
  common/eps0811/pp08(5)
  external eps08gv, eps08se
  data readFR/0/
  
  aa = aaa
  xx = xxx
  qq = q**2
  rt = 1.d0   
  
  if (readFR.ne.1) then
     call eps08init
     readFR=1
  endif
  if ((aa.le.2.d0).or.(1.d0.le.xx)) then
     ruv=1.d0
     rdv=1.d0
     ru=1.d0
     rd=1.d0
     rs=1.d0
     rc=1.d0
     rb=1.d0
     rg=1.d0
     return
  endif
  
  if (qq .lt. qq0) then
     qq = qq0
  end if
  
  if (qq .gt. 1.d6) then
     qq = 1.d6
  end if
  
  if (aa .gt. 208.d0) then
     aa = 208.d0
  end if
  
  if (xx .lt. 1.d-6) then
     xx = 1.d-6
  end if
  
  if (xx .gt. 0.964) then
     xx = 0.964
  end if
  
  x2=xx+10.d0**(dlog10(xx)-2.5)
  ind=1+int(20.d0*(dlog10(x2)+6.d0))
  x0=10.d0**(-6.d0+(ind-1)/20.d0)
  x1=10.d0**(-6.d0+ind/20.d0)
  if(x2.gt.0.1d0) then
     ind=int((x2-0.1d0)/0.009d0+101.d0)
     x0=0.1d0+(ind-101)*0.009d0
     x1=0.1d0+(ind-100)*0.009d0
  endif
  do ikty=1,3
     kty=ikty
     if(ikty.eq.3) kty=8
     qq1=qq0 
     ! The xx arg was not used anywhere!
     !call ppeps08(xx,aa,pint08,pint082) 
     call ppeps08(aa,pint08,pint082) 
     do ii=1,5
        pp08(ii)=pint08(ii)
     enddo
     tt1=eps08gv(qq)
     do ii=1,5
        pp08(ii)=pint082(ii)
     enddo
     tt2=eps08gv(qq)
     rateps08(kty)=tt1+(tt2-tt1)/(x1-x0)*(xx-x0)
  enddo
  do ikty=3,7
     kty=ikty
     qq1=qq0 
     
     if(kty.eq.7) then
        qq1=qqb 
        if(qq .lt. qqb) then 
           rateps08(7)=0.d0
           Goto 125
        end if
     end if
     
     ! The xx arg was not used anywhere!
     !call ppeps08(xx,aa,pint08,pint082) 
     call ppeps08(aa,pint08,pint082) 
     do ii=1,5
        pp08(ii)=pint08(ii)
     enddo
     tt1=eps08se(qq)
     do ii=1,5
        pp08(ii)=pint082(ii)
     enddo
     tt2=eps08se(qq)
     rateps08(ikty)=tt1+(tt2-tt1)/(x1-x0)*(xx-x0)
  enddo
  
125 continue  
  
  ruv=rateps08(1)
  rdv=rateps08(2)
  rs=rateps08(3)
  ru=rateps08(4)
  rd=rateps08(5)
  rc=rateps08(6)
  rb=rateps08(7)
  rg=rateps08(8)
  return
end subroutine eps08

subroutine ppeps08(aa,pint08,pint082)
  !subroutine ppeps08(xx,aa,pint08,pint082)
  ! The xx arg was not used anywhere!
  implicit double precision(a-h,o-z)
  dimension pint08(5), pint082(5), paint081(13), paint082(13) 
  common/eps0801/ peps08i(197,13,8,5)
  common/eps0802/ amx(13)
  common/eps0803/ kty, ind
  do ip=1,5
     do ia=1,13
        paint081(ia)=peps08i(ind,ia,kty,ip)
        paint082(ia)=peps08i(ind+1,ia,kty,ip)
        if(ind.eq.197) paint082(ia)=paint081(ia)
     enddo
     pint08(ip)=eps08ddv(paint081,amx,13,aa,1)
     pint082(ip)=eps08ddv(paint082,amx,13,aa,1)
  enddo
end subroutine ppeps08


function eps08gv(qq)
  implicit double precision(a-h,o-z)
  common/eps0810/qq1
  common/eps0811/yy1,p1,p2,p3,p4
  z=dlog(qq/qq1)
  zz=dlog(1.d0+z)
  eps08gv=yy1+p1*zz+p2*zz**2+p3*zz**0.5+p4/(1.d0+zz)**4-p4
  return
end function eps08gv

function eps08se(qq)
  implicit double precision(a-h,o-z)
  common/eps0810/qq1
  common/eps0811/yy1,p1,p2,p3,p4
  z=dlog(qq/qq1)
  zz=dlog(1.d0+z)
  eps08se=yy1+p1*zz+p2*zz**2+p3*zz**3+p4/(1.d0+zz)-p4
  return
end function eps08se

subroutine eps08init
  implicit double precision(a-h,o-z)
  include 'commonlhapdfc.inc'
  include 'commonlhacontrol.inc'
  !
  ! the LHAPDF bits
  !
  character*512 dirpath,setpath
  common/eps0800/qq0, qqb
  common/eps0801/peps08i(197,13,8,5)
  common/eps0802/ amx(13)
  data readFR2/0/
  
  ! Initialise common blocks  
  call commoninit()

  qq0 = 1.69d0
  qqb = 21.516d0
  
  amx(1) = 4.d0
  amx(2) = 6.d0
  amx(3) = 9.d0
  amx(4) = 12.d0
  amx(5) = 27.d0
  amx(6) = 40.d0
  amx(7) = 56.d0
  amx(8) = 64.d0
  amx(9) = 108.d0
  amx(10) = 117.d0
  amx(11) = 184.d0
  amx(12) = 197.d0
  amx(13) = 208.d0
  
  if (readFR2.ne.1) then
     !
     ! sort out the path to the input file
     !
     call getdirpath(dirpath)
     
     setpath=dirpath(:LEN_TRIM(dirpath))//"/"//'eps08dta.LHgrid'
     open(11,file=setpath(:LEN_TRIM(setpath)),status='unknown')
     do ik=1,8
        do ia=1,13
           do ix=1,197
              read(11,137) peps08i(ix,ia,ik,1), peps08i(ix,ia,ik,2), &
                   peps08i(ix,ia,ik,3), peps08i(ix,ia,ik,4), peps08i(ix,ia,ik,5)
           enddo
        enddo
     enddo
     close(11)
     readFR2=1
  endif
  return
137 format(5f15.8)
end subroutine eps08init


!        divdif routine from CERNLIB adapted to double precision
!
! $Id: divdif.F,v 1.1.1.1 1996/02/15 17:48:36 mclareni Exp $
!
! $Log: divdif.F,v $
! Revision 1.1.1.1  1996/02/15 17:48:36  mclareni
! Kernlib
!
!
FUNCTION EPS08ddv(F,A,NN,X,MM)
  implicit double precision (a-h,o-z)
  DIMENSION A(NN),F(NN),T(20),D(20)
  LOGICAL EXTRA
  LOGICAL MFLAG !,RFLAG
  DATA MMAX/10/
  !
  !  TABULAR INTERPOLATION USING SYMMETRICALLY PLACED ARGUMENT POINTS.
  !
  !  START.  FIND SUBSCRIPT IX OF X IN ARRAY A.
  !carlos      IF( (NN.LT.2) .OR. (MM.LT.1) ) GOTO 20
  N=NN
  M=MIN0(MM,MMAX,N-1)
  MPLUS=M+1
  IX=0
  IY=N+1
  IF(A(1).GT.A(N)) GOTO 4
  !     (SEARCH INCREASING ARGUMENTS.)
1 MID=(IX+IY)/2
  IF(X.GE.A(MID)) GOTO 2
  IY=MID
  GOTO 3
  !        (IF TRUE.)
2 IX=MID
3 IF(IY-IX.GT.1) GOTO 1
  GOTO 7
  !     (SEARCH DECREASING ARGUMENTS.)
4 MID=(IX+IY)/2
  IF(X.LE.A(MID)) GOTO 5
  IY=MID
  GOTO 6
  !        (IF TRUE.)
5 IX=MID
6 IF(IY-IX.GT.1) GOTO 4
  !
  !  COPY REORDERED INTERPOLATION POINTS INTO (T(I),D(I)), SETTING
  !  *EXTRA* TO TRUE IF M+2 POINTS TO BE USED.
7 NPTS=M+2-MOD(M,2)
  IP=0
  L=0
  GOTO 9
8 L=-L
  IF(L.GE.0) L=L+1
9 ISUB=IX+L
  IF((1.LE.ISUB).AND.(ISUB.LE.N)) GOTO 10
  !        (SKIP POINT.)
  NPTS=MPLUS
  GOTO 11
  !        (INSERT POINT.)
10 IP=IP+1
  T(IP)=A(ISUB)
  D(IP)=F(ISUB)
11 IF(IP.LT.NPTS) GOTO 8
  EXTRA=NPTS.NE.MPLUS
  !
  !  REPLACE D BY THE LEADING DIAGONAL OF A DIVIDED-DIFFERENCE TABLE, SUP-
  !  PLEMENTED BY AN EXTRA LINE IF *EXTRA* IS TRUE.
  DO L=1,M
     IF(.NOT.EXTRA) GOTO 12
     ISUB=MPLUS-L
     D(M+2)=(D(M+2)-D(M))/(T(M+2)-T(ISUB))
12   I=MPLUS
     DO J=L,M
        ISUB=I-L
        D(I)=(D(I)-D(I-1))/(T(I)-T(ISUB))
        I=I-1
     ENDDO
  ENDDO
  !
  !  EVALUATE THE NEWTON INTERPOLATION FORMULA AT X, AVERAGING TWO VALUES
  !  OF LAST DIFFERENCE IF *EXTRA* IS TRUE.
  SUM=D(MPLUS)
  IF(EXTRA) SUM=0.5*(SUM+D(M+2))
  J=M
  DO L=1,M
     SUM=D(J)+(X-T(J))*SUM
     J=J-1
  ENDDO
  EPS08ddv=SUM
  RETURN
  !
  !carlos   20 CALL KERMTR('E105.1',LGFILE,MFLAG,RFLAG)
  EPS08ddv=0
  IF(MFLAG) THEN
     IF(LGFILE.EQ.0) THEN
        IF(MM.LT.1) WRITE(*,101) MM
        IF(NN.LT.2) WRITE(*,102) NN
     ELSE
        IF(MM.LT.1) WRITE(LGFILE,101) MM
        IF(NN.LT.2) WRITE(LGFILE,102) NN
     ENDIF
  ENDIF
  !carlos      IF(.NOT.RFLAG) CALL ABEND
  RETURN
101 FORMAT( 7X, 'FUNCTION EPS08ddv ... M =',I6,' IS LESS THAN 1')
102 FORMAT( 7X, 'FUNCTION EPS08ddv ... N =',I6,' IS LESS THAN 2')
END FUNCTION EPS08ddv

! -*- F90 -*-


      subroutine CTEQ5evolve(x,Q,pdf) 
      implicit real*8(a-h,o-z) 
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset 
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      real*8 pdf(-6:6) 
      Character Line*80 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPQX = (MXF *2 +2) * MXQ * MXX) 
      PARAMETER (M= 2, M1 = M + 1) 
      Common                                                            &
     & / CtqPar1 /                                                      &
     & Al5(nmxset), XV5(0:MXX,nmxset), QL5(0:MXQ,nmxset),               &
     & UPD5(MXPQX,nmxset)                                               &
     & / CtqPar2 / Nx(nmxset), Nt(nmxset), NfMx(nmxset)                 &
     & / XQrange / Qini(nmxset), Qmax(nmxset), Xmin(nmxset)             &
     & / QCDtable /  Alambda(nmxset), Nfl(nmxset), Iorder(nmxset)       &
     & / Masstbl / Amass(6,nmxset)                                      
      data pi / 3.141592653589793d0 / 
      save 
!                                                                       
      U =         X * CtLhCtq5Pdf(1,X,Q) 
      D =         X * CtLhCtq5Pdf(2,X,Q) 
      USEA =      X * CtLhCtq5Pdf(-1,X,Q) 
      DSEA =      X * CtLhCtq5Pdf(-2,X,Q) 
      STR =       X * CtLhCtq5Pdf(3,X,Q) 
      CHM =       X * CtLhCtq5Pdf(4,X,Q) 
      BOT =       X * CtLhCtq5Pdf(5,X,Q) 
      GLU  =      X * CtLhCtq5Pdf(0,X,Q) 
      UPV=U-USEA 
      DNV=D-DSEA 
!                                                                       
      pdf(0)  = glu 
      pdf(1)  = dnv+dsea 
      pdf(-1) = dsea 
      pdf(2)  = upv+usea 
      pdf(-2) = usea 
      pdf(3)  = str 
      pdf(-3) = str 
      pdf(4)  = chm 
      pdf(-4) = chm 
      pdf(5)  = bot 
      pdf(-5) = bot 
      pdf(6)  = 0.0d0 
      pdf(-6) = 0.0d0 
                                                                        
      return 
!                                                                       
      entry CTEQ5getgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=0,nx(nset)
          gridx(jx+1)=xv5(jx,nset)
      enddo
      do jq=0,nt(nset)
          qtemp = Al5(nset)*exp(ql5(jq,nset))
          gridq(jq+1)=qtemp*qtemp
      enddo
      ngridx=nx(nset)
      ngridq=nt(nset)
      return 
             
      entry CTEQ5read(nset) 
                                                                        
      call CtLhbldat1 
      call CtLhbldat2 
                                                                        
      read(1,*)nmem(nset),ndef(nset) 
      Read  (1, '(A)') Line 
      Read  (1, '(A)') Line 
      Read  (1, *) Dr, Fl, Al5(nset), (Amass(I,nset),I=1,6) 
      Iorder(nset) = Nint(Dr) 
      Nfl(nset) = Nint(Fl) 
      Alambda(nset) = Al5(nset) 
                                                                        
      Read  (1, '(A)') Line 
      Read  (1, *) NX(nset),  NT(nset), NfMx(nset) 
                                                                        
      Read  (1, '(A)') Line 
      Read  (1, *) QINI(nset), QMAX(nset), (QL5(I,nset), I =0, NT(nset)) 
                                                                        
      Read  (1, '(A)') Line 
      Read  (1, *) XMIN(nset), (XV5(I,nset), I =0, NX(nset)) 
                                                                        
      Do 11 Iq = 0, NT(nset) 
         QL5(Iq,nset) = Log (QL5(Iq,nset) /Al5(nset)) 
   11 Continue 
!                                                                       
!                  Since quark = anti-quark for nfl>2 at this stage,    
!                  we Read  out only the non-redundent data points      
!     No of flavors = NfMx (sea) + 1 (gluon) + 2 (valence)              
                                                                        
      Nblk = (NX(nset)+1) * (NT(nset)+1) 
      Npts =  Nblk  * (NfMx(nset)+3) 
                                                                        
      Read  (1, '(A)') Line 
      Read  (1, *, IOSTAT=IRET) (UPD5(I,nset), I=1,Npts) 
      Return 
!                                                                       
                                                                        
      entry CTEQ5alfa(alfas,Qalfa) 
                                                                        
       alfas = pi*CtLhALPI(Qalfa) 
                                                                        
      return 
!                                                                       
      entry CTEQ5init(Eorder,Q2fit) 
                                                                        
      return 
!                                                                       
                                         !error corrected (jcp)         
      entry CTEQ5pdf(mem) 
!        imem = mem                                                     
        call getnset(iset) 
        call setnmem(iset,mem) 
      return 
!                                                                       
      END                                           
                                                                        
      FUNCTION CtLhPartonX5 (IPRTN, X, Q) 
!                                                                       
!   Given the parton distribution function in the array UPD in          
!   COMMON / CtqPar1 / , this routine fetches u(fl, x, q) at any value o
!   x and q using Mth-order polynomial interpolation for x and Ln(Q/Lamb
!                                                                       
      IMPLICIT DOUBLE PRECISION (A-H, O-Z) 
!                                                                       
      include 'parmsetup.inc' 
      PARAMETER (MXX = 105, MXQ = 25, MXF = 6) 
      PARAMETER (MXPQX = (MXF *2 +2) * MXQ * MXX) 
      PARAMETER (M= 2, M1 = M + 1) 
!                                                                       
      Common                                                            &
     & / CtqPar1 / Al5(nmxset), XV5(0:MXX,nmxset), QL5(0:MXQ,nmxset),   &
     & UPD5(MXPQX,nmxset)                                               &
     & / CtqPar2 / Nx(nmxset), Nt(nmxset), NfMx(nmxset)                 &
     & / XQrange / Qini(nmxset), Qmax(nmxset), Xmin(nmxset)             
!                                                                       
      Dimension Fq(M1), Df(M1) 
                                                                        
! note, this routine doesn't have the features of not recalculating     
! the x or q point values if they have not changed since the last call. 
! that makes it slower than cteq6, but since cteq5 is already obsolete, 
! speed is not so important for it.                                     
                                                                        
      call getnset(iset) 
                                                                        
!                                                 Work with Log (Q)     
      QG  = LOG (Q/AL5(iset)) 
                                                                        
!                           Find lower end of interval containing X     
      JL = -1 
      JU = Nx(iset)+1 
   11 If (JU-JL .GT. 1) Then 
         JM = (JU+JL) / 2 
         If (X .GT. XV5(JM,iset)) Then 
            JL = JM 
         Else 
            JU = JM 
         Endif 
         Goto 11 
      Endif 
                                                                        
      Jx = JL - (M-1)/2 
! crude treatment if outside the defined interval.                      
      If (Jx .LT. 0) then 
         Jx = 0 
      Elseif (Jx .GT. Nx(iset)-M) Then 
         Jx = Nx(iset) - M 
      Endif 
!                                    Find the interval where Q lies     
      JL = -1 
      JU = NT(iset)+1 
   12 If (JU-JL .GT. 1) Then 
         JM = (JU+JL) / 2 
         If (QG .GT. QL5(JM,iset)) Then 
            JL = JM 
         Else 
            JU = JM 
         Endif 
         Goto 12 
      Endif 
                                                                        
      Jq = JL - (M-1)/2 
      If (Jq .LT. 0) Then 
         Jq = 0 
!         If (Q .lt. Qini)  Print '(A, 2(1pE12.4))',                    
!     >     ' WARNING: Q << Qini, extrapolation used; Q,Qini=',Q,Qini   
      Elseif (Jq .GT. Nt(iset)-M) Then 
         Jq = Nt(iset) - M 
!         If (Q .gt. Qmax)  Print '(A, 2(1pE12.4))',                    
!     >     ' WARNING: Q > Qmax, extrapolation used; Q, Qmax =', Q, Qmax
      Endif 
                                                                        
      If (Iprtn .GE. 3) Then 
         Ip = - Iprtn 
      Else 
         Ip = Iprtn 
      EndIf 
!                             Find the off-set in the linear array Upd  
      JFL = Ip + NfMx(iset) 
      J0  = (JFL * (NT(iset)+1) + Jq) * (NX(iset)+1) + Jx 
!                                                                       
!                                           Now interpolate in x for M1 
      Do 21 Iq = 1, M1 
         J1 = J0 + (Nx(iset)+1)*(Iq-1) + 1 
         Call CtLhPolint3                                               &
     &   (XV5(Jx,iset), Upd5(J1,iset), M1, X, Fq(Iq), Df(Iq))           
   21 Continue 
!                                          Finish off by interpolating i
      Call CtLhPolint3 (QL5(Jq,iset), Fq(1), M1, QG, Ftmp, Ddf) 
                                                                        
      CtLhPartonX5 = Ftmp 
!                                                                       
      RETURN 
                                                                        
!                        ****************************                   
      END                                           
                                                                        
      Function CtLhCtq5Pdf (Iparton, X, Q) 
      Implicit Double Precision (A-H,O-Z) 
      include 'parmsetup.inc' 
      Logical Warn 
      Common                                                            &
     & / CtqPar2 / Nx(nmxset), Nt(nmxset), NfMx(nmxset)                 &
     & / QCDtable /  Alambda(nmxset), Nfl(nmxset), Iorder(nmxset)       
                                                                        
      Data Warn /.true./ 
      save Warn 
                                                                        
      call getnset(iset) 
                                                                        
      If (X .lt. 0D0 .or. X .gt. 1D0) Then 
        Print *, 'X out of range in CtLhCtq5Pdf: ', X 
        Stop 
      Endif 
      If (Q .lt. Alambda(iset)) Then 
        Print *, 'Q out of range in CtLhCtq5Pdf: ', Q 
        Stop 
      Endif 
      If ((Iparton .lt. -NfMx(iset) .or. Iparton .gt. NfMx(iset))) Then 
         If (Warn) Then 
!        put a warning for calling extra flavor.                        
             Warn = .false. 
             Print *, 'Warning: Iparton out of range in CtLhCtq5Pdf: '  &
     &              , Iparton                                           
         Endif 
         CtLhCtq5Pdf = 0D0 
         Return 
      Endif 
                                                                        
      CtLhCtq5Pdf = CtLhPartonX5 (Iparton, X, Q) 
      if(CtLhCtq5Pdf.lt.0.D0)  CtLhCtq5Pdf = 0.D0 
                                                                        
      Return 
                                                                        
!                             ********************                      
      END                                           

! -*- F90 -*-


      subroutine ZEUSevolve(x,Q,pdf) 
      implicit double precision (a-h,o-z) 
      include 'parmsetup.inc' 
      character*64 gridname 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mem 
      common/NAME/name,nmem,ndef,mem 
      integer nset,iset,isetlast 
      data isetlast/-1/ 
      integer Eorder 
      real*8 mc,mc2,mb,mb2,mt,mt2 
      real*8 f(-6:6),pdf(-6:6) 
      integer qnerr 
      parameter(nstartp=7) 
      DIMENSION QSP(NSTARTP) 
      DATA QSP/10.,20.,30.,40.,50.,80.,100./ 
      real*8 xval(45) 
      logical HEAVY,VFN 
      real*8 pwgt(20) 
      save 
!                                                                       
      call getnset(iset) 
!      print *,'iset=',iset,' now calling get_pdfqcd'                   
      if(iset.ne.isetlast) then 
        call get_pdfqcd(iset) 
        isetlast = iset 
      endif 
!                                                                       
      Q2=Q*Q 
      UCENT=QPDFXQ('UPVAL',X,Q2,IFAIL) 
      DCENT=QPDFXQ('DNVAL',X,Q2,IFAIL) 
      GCENT=QPDFXQ('GLUON',X,Q2,IFAIL) 
      UBCEN=QPDFXQ('UB',X,Q2,IFAIL) 
      DBCEN=QPDFXQ('DB',X,Q2,IFAIL) 
      STCEN=QPDFXQ('SB',X,Q2,IFAIL) 
      IF(Q2.GE.Q2C)THEN 
        CHCEN=QPDFXQ('CB',X,Q2,IFAIL) 
      ELSE 
        CHCEN=0.0 
      ENDIF 
      IF(Q2.GE.Q2B)THEN 
        BTCEN=QPDFXQ('BB',X,Q2,IFAIL) 
      ELSE 
        BTCEN=0.0 
      ENDIF 
      pdf(1)=dcent+dbcen 
      pdf(2)=ucent+ubcen 
      pdf(3)=stcen 
      pdf(4)=chcen 
      pdf(5)=btcen 
      pdf(6)=0d0 
      pdf(0)=gcent 
      pdf(-1)=dbcen 
      pdf(-2)=ubcen 
      pdf(-3)=stcen 
      pdf(-4)=chcen 
      pdf(-5)=btcen 
      pdf(-6)=0d0 
!                                                                       
      return 
!                                                                       
!=======================================================================
      entry ZEUSalfa(alfas,Q) 
      Q2=Q*Q 
      nf=6 
      if (Q2.lt.mt2) nf=5 
      if (Q2.lt.mb2) nf=4 
      if (Q2.lt.mc2) nf=3 
      alfas=QALFAS(Q2,Qlam,nf,iflag) 
!      print *,q2,alfas,qlam,nf,iflag                                   
      return 
!                                                                       
!=======================================================================
      entry ZEUSread(nset) 
         read(1,*) gridname,nx,xmin,xmax,nq,qmin,qmax 
      return 
!                                                                       
!=======================================================================
      entry ZEUSinit(nset,Eorder,Q2fit) 
!      print *,name(nset)                                               
      if(name(nset).eq.'QCDNUM_ZEUS_TR') then 
         HEAVY = .FALSE. 
         VFN = .TRUE. 
      else if(name(nset).eq.'QCDNUM_ZEUS_FF') then 
         HEAVY = .TRUE. 
         VFN = .FALSE. 
      else if(name(nset).eq.'QCDNUM_ZEUS_ZM') then 
         HEAVY = .FALSE. 
         VFN = .FALSE. 
      else 
        print *,'name/scheme not recognized' 
        stop 1 
      endif 
!--try 3 way logic ffn/zm-vfn/rt-vfn                                    
      IF(HEAVY)THEN 
      IVFN=1 
      ELSE 
      IVFN=0 
      ENDIF 
      IF(VFN)THEN 
      IVFN=IVFN+2 
      ELSE 
      IVFN=IVFN 
      ENDIF 
! IVFN=0 IS ZM-VFN, 1 IS FFN,2 IS RT-VFN, 3 IS NOT ALLOWED              
                                                                        
      IF(IVFN.EQ.3)THEN 
      WRITE(*,*)'IVFN=3 SO STOP',IVFN 
      STOP 
      ENDIF 
                                                                        
                                                                        
                                                                        
!--qcdnum initialisation                                                
      CALL QNINIT 
!--se thresholds                                                        
      Q0=Q2fit 
      ZM=91.187D0 
      ZM2=ZM*ZM 
      ALPHAS=QNALFA(ZM2) 
                                                                        
      call getQmassM(nset,4,mc) 
      mc2=mc*mc 
      call getQmassM(nset,5,mb) 
      mb2=mb*mb 
      call getQmassM(nset,6,mt) 
      mt2=mt*mt 
                                                                        
!      Q2C=1.8225                                                       
      Q2C=mc2 
!      Q2B=18.49                                                        
      Q2B=mb2 
!      print  *,q2c,q2b                                                 
                                                                        
      IF (Q0.LT.Q2C) THEN 
        NACT=3 
      ELSE 
        NACT=4 
      ENDIF 
!--this merely defines nact where we startevolution                     
!--namely at q0                                                         
      IF (HEAVY) NACT=3 
                                                                        
      CALL QNRSET('MCSTF',SQRT(Q2C)) 
      CALL QNRSET('MBSTF',SQRT(Q2B)) 
      CALL QNRSET('MCALF',SQRT(Q2C)) 
      CALL QNRSET('MBALF',SQRT(Q2B)) 
                                                                        
      IF (HEAVY) THEN 
        CALL QTHRES(1D10,2D10) 
!        CALL QTHRES(1D6,2D6)                                           
      ELSE 
        CALL QTHRES(Q2C,Q2B) 
      ENDIF 
                                                                        
      DO I=1,NSTARTP 
        CALL GRQINP(QSP(I),1) 
      ENDDO 
      CALL GRQINP(Q0,1) 
      CALL GRQINP(Q2C,1) 
      CALL GRQINP(Q2B,1) 
!      qcdnum grid not my grid                                          
                                                                        
!      CALL GRXLIM(120,97D-8)                                           
      CALL GRXLIM(nx,xmin) 
                                                                        
!      CALL GRQLIM(61,29D-2,200D3)                                      
      CALL GRQLIM(nq,qmin,qmax) 
                                                                        
!--   Get final grid definitions and grid indices of Q0, Q2C and Q2B    
                                                                        
      CALL GRGIVE(NXGRI,XMI,XMA,NQGRI,QMI,QMA) 
!      WRITE(*,*)'NX,XL,XH,NQ,QL,QH',NXGRI,XMI,XMA,NQGRI,QMI,QMA        
      IQ0 = IQFROMQ(Q0) 
      IQC = IQFROMQ(Q2C) 
      IQB = IQFROMQ(Q2B) 
!--   Allow for heavy weights                                           
                                                                        
      IF (HEAVY) THEN 
        CALL QNLSET('WTF2C',.TRUE.) 
        CALL QNLSET('WTF2B',.TRUE.) 
        CALL QNLSET('CLOWQ',.FALSE.) 
        CALL QNLSET('WTFLC',.TRUE.) 
        CALL QNLSET('WTFLB',.TRUE.) 
      ENDIF 
                                                                        
!--   Compute weights and dump, or read in                              
!                                                                       
!      IF (READIN) THEN                                                 
!        OPEN(UNIT=24,FILE='weights.dat',FORM='UNFORMATTED',            
!     .                                  STATUS='UNKNOWN')              
!        CALL QNREAD(24,ISTOP,IERR)                                     
!      ELSE                                                             
!        CALL QNFILW(0,0)                                               
!        IF (HEAVY) THEN                                                
!          OPEN(UNIT=24,FILE='weights.dat',FORM='UNFORMATTED',          
!     .                                    STATUS='UNKNOWN')            
!          CALL QNDUMP(24)                                              
!        ENDIF                                                          
!      ENDIF                                                            
                                                                        
                                                                        
      if (index(gridname,'none').eq.1) then 
         call qnfilw(0,0) 
      else 
         qnerr=-1 
         open(unit=2,status='old',file=gridname,                        &
     &        form='unformatted',err=1)                                 
         call QNREAD(2,1,qnerr) 
    1    close(2) 
         if (qnerr.ne.0) then 
            write(*,*) 'Grid file problem: ',gridname 
            if (qnerr.lt.0) then 
               write(*,*) 'Grid file does not exist' 
               write(*,*) 'Calculating and creating grid file' 
               call qnfilw(0,0) 
               open(unit=2,status='unknown',file=gridname,              &
     &              form='unformatted')                                 
               call QNDUMP(2) 
               close(2) 
            else 
               write(*,*) 'Existing grid file is inconsistent' 
               if (qnerr.eq.1)                                          &
     &              write(*,*) 'Defined grid different'                 
               if (qnerr.eq.2)                                          &
     &              write(*,*) 'Heavy quark weight table different'     
               if (qnerr.eq.3)                                          &
     &              write(*,*) 'Charm mass different'                   
               if (qnerr.eq.4)                                          &
     &              write(*,*) 'Bottom mass different'                  
               stop 
            endif 
         endif 
      endif 
                                                                        
!--   Apply cuts to grid                                                
!--taking away the s cut at 600d0                                       
      CALL GRCUTS(-1D0,-1D0,-1D0,-1D0) 
                                                                        
                                                                        
                                                                        
                                                                        
!--   Choose renormalisation and factorisation scales                   
                                                                        
                                ! renormalisation                       
      CALL QNRSET('AAAR2',1D0) 
      CALL QNRSET('BBBR2',0D0) 
                                ! factorisation (light)                 
      CALL QNRSET('AAM2L',1D0) 
      CALL QNRSET('BBM2L',0D0) 
                                ! factorisation (heavy)                 
      CALL QNRSET('AAM2H',1D0) 
      CALL QNRSET('BBM2H',0D0) 
                                                                        
!       ZM=91.187D0                                                     
      imem=0 
!      print *,imem                                                     
! -- only need call to listPDF here to get alphas                       
      call listPDF(nset,imem,xval) 
!      print *,xval                                                     
        AS=XVAL(1) 
!        AS=0.118d0                                                     
      CALL QNRSET('ALFQ0',ZM*ZM) 
      CALL QNRSET('ALFAS',AS) 
                                                                        
!      ZM2=ZM*ZM                                                        
      ALPHAS=QNALFA(ZM2) 
!      WRITE(*,*)'ALPHAS AT Mz2',ALPHAS                                 
                                                                        
!--   Book non-singlet distributions                                    
                                                                        
      CALL QNBOOK(2,'UPLUS') 
      CALL QNBOOK(3,'DPLUS') 
      CALL QNBOOK(4,'SPLUS') 
      CALL QNBOOK(5,'CPLUS') 
      CALL QNBOOK(6,'BPLUS') 
      CALL QNBOOK(7,'UPVAL') 
      CALL QNBOOK(8,'DNVAL') 
                                                                        
!--   Book linear combinations for proton for f = 3,4,5 flavours        
                                                                        
!--define some quark pdfs                                               
         CALL dVZERO(PWGT,20) 
        PWGT(2) = 0.5 
                                                                        
        PWGT(7) = -0.5 
                                                                        
        PWGT(1) = 0.5/3. 
        CALL QNLINC(17,'UB',3,PWGT) 
        PWGT(1) = 0.5/4. 
        CALL QNLINC(17,'UB',4,PWGT) 
        PWGT(1) = 0.5/5. 
        CALL QNLINC(17,'UB',5,PWGT) 
        CALL dVZERO(PWGT,20) 
                                                                        
        PWGT(4) = 0.5 
        PWGT(1) = 0.5/3. 
        CALL QNLINC(18,'SB',3,PWGT) 
        PWGT(1) = 0.5/4. 
        CALL QNLINC(18,'SB',4,PWGT) 
        PWGT(1) = 0.5/5. 
        CALL QNLINC(18,'SB',5,PWGT) 
         CALL dVZERO(PWGT,20) 
        CALL QNLINC(19,'CB',3,PWGT) 
        PWGT(5) = 0.5 
        PWGT(1) = 0.5/4. 
                                                                        
        CALL QNLINC(19,'CB',4,PWGT) 
        PWGT(1) = 0.5/5. 
        CALL QNLINC(19,'CB',5,PWGT) 
        CALL dVZERO(PWGT,20) 
        PWGT(3) = 0.5 
                                                                        
        PWGT(8) = -0.5 
                                                                        
        PWGT(1) = 0.5/3. 
        CALL QNLINC(20,'DB',3,PWGT) 
        PWGT(1) = 0.5/4. 
        CALL QNLINC(20,'DB',4,PWGT) 
        PWGT(1) = 0.5/5. 
        CALL QNLINC(20,'DB',5,PWGT) 
         CALL dVZERO(PWGT,20) 
        CALL QNLINC(21,'BB',3,PWGT) 
       CALL QNLINC(21,'BB',4,PWGT) 
        PWGT(6) = 0.5 
                                                                        
        PWGT(1) = 0.5/5. 
        CALL QNLINC(21,'BB',5,PWGT) 
!---                                                                    
                                                                        
      return 
!                                                                       
!=======================================================================
      entry ZEUSpdf(nset) 
!      ZM = 91.187d0                                                    
!      zm2 = zm*zm                                                      
                                                                        
!      ALPHAS=QNALFA(ZM2)                                               
                                                                        
                                                                        
!      imem=mem                                                         
      call getnmem(nset,imem) 
      call listPDF(nset,imem,xval) 
!      print *,nset,imem                                                
!      print *,xval                                                     
!      print *,imem,xval                                                
                                                                        
      UA=XVAL(3) 
      UB=XVAL(4) 
      UE=0.0d0 
      UC=XVAL(5) 
                                                                        
      DA=XVAL(7) 
      DB=XVAL(8) 
      DE=0.0d0 
      DC=XVAL(9) 
                                                                        
      GA=XVAL(11) 
      GB=XVAL(12) 
      GE=0.0d0 
      GC=XVAL(13) 
                                                                        
      SN=XVAL(14) 
      SA=XVAL(15) 
      SB=XVAL(16) 
      SE=0.0d0 
      SC=XVAL(17) 
                                                                        
      DLN=XVAL(18) 
      DLA=XVAL(19) 
!      DLB=XVAL(20)                                                     
      DLB=XVAL(16)+2.0d0 
      DLE=0.0d0 
      DLC=XVAL(21) 
      AS=XVAL(1) 
       CALL QNRSET('ALFAS',AS) 
!--   Input quark distributions at Q2 = Q02 GeV2                        
!-- WRITE IN ACTUAL VALUES TO SAVE USING dgamma                         
!       UN=2./AREA(UA-1,UB,UE,UC)                                       
!       DN=1./AREA(DA-1,DB,DE,DC)                                       
      UN = XVAL(2) 
      DN=XVAL(6) 
!       UBDBN=DLN/AREA(DLA-1,DLB,DLE,DLC)                               
!      call grgive(nxgri,xxmin,xxmax,nqgri,qqmin,qqmax)                 
      nxgri=nx 
      DO IX = 1,NXGRI 
        xX = XFROMIX(IX) 
        UPVAL=UN*FF_LHA(Xx,UA,UB,UE,UC) 
                                                                        
                                                                        
        DNVAL=DN*FF_LHA(Xx,DA,DB,DE,DC) 
                                                                        
                                                                        
        SEA=SN*FF_LHA(Xx,SA,SB,SE,SC) 
                                                                        
!        GN=(1-UN*AREA(UA,UB,UE,UC)-                                    
!     .        DN*AREA(DA,DB,DE,DC)-                                    
!     .        SN*AREA(SA,SB,SE,SC))/AREA(GA,GB,GE,GC)                  
        GN=XVAL(10) 
        GLUON=GN*FF_LHA(Xx,GA,GB,GE,GC) 
                                                                        
                                                                        
                                                                        
!        UMD=UBDBN*FF_LHA(X,DLA,DLB,DLE,DLC)                            
        UMD=DLN*FF_LHA(Xx,DLA,DLB,DLE,DLC) 
        SINGL=UPVAL+DNVAL+SEA 
                                                                        
!        print *,un,dn,sn,gn,dln                                        
                                                                        
        CSEA=0.0 
        SSEA=0.2*SEA 
        USEA=(SEA-SSEA-CSEA)/2.-UMD 
        DSEA=(SEA-SSEA-CSEA)/2.+UMD 
        UPLUS=UPVAL+USEA-1./NACT*SINGL 
        DPLUS=DNVAL+DSEA-1./NACT*SINGL 
        SPLUS=SSEA-1./NACT*SINGL 
                                                                        
                                                                        
        CALL QNPSET('GLUON',IX,IQ0,GLUON) 
        CALL QNPSET('SINGL',IX,IQ0,SINGL) 
        CALL QNPSET('UPLUS',IX,IQ0,UPLUS) 
        CALL QNPSET('DPLUS',IX,IQ0,DPLUS) 
        CALL QNPSET('SPLUS',IX,IQ0,SPLUS) 
        CALL QNPSET('UPVAL',IX,IQ0,UPVAL) 
        CALL QNPSET('DNVAL',IX,IQ0,DNVAL) 
      ENDDO 
!--THINGS ARE FINE FOR HEAVY SO DO IT                                   
      IF (HEAVY) THEN 
                                                                        
!--     Evolve over whole grid                                          
                                                                        
        CALL EVOLSG(IQ0,1,NQGRI) 
        CALL EVPLUS('UPLUS',IQ0,1,NQGRI) 
        CALL EVPLUS('DPLUS',IQ0,1,NQGRI) 
        CALL EVPLUS('SPLUS',IQ0,1,NQGRI) 
        CALL EVOLNM('UPVAL',IQ0,1,NQGRI) 
        CALL EVOLNM('DNVAL',IQ0,1,NQGRI) 
                                                                        
      ELSE 
                                                                        
!--     Evolve gluon, singlet and valence over whole grid               
                                                                        
        CALL EVOLSG(IQ0,1,NQGRI) 
        CALL EVOLNM('UPVAL',IQ0,1,NQGRI) 
        CALL EVOLNM('DNVAL',IQ0,1,NQGRI) 
                                                                        
!--     Be more careful with plus distributions                         
                                                                        
        IF (NACT.EQ.3) THEN 
!--THINGS ARE ALSO FINE IF 1Q0 IS BELOW 1QC THEN CLEARLY CSEA=0. IS OK  
!--SITUATION CD BE 1<Q0<Q2C<Q2B ETC                                     
!--GO DOWN QO TO 1 UP Q0 TO  Q2C                                        
          CALL EVPLUS('UPLUS',IQ0,1,IQC) 
          CALL EVPLUS('DPLUS',IQ0,1,IQC) 
          CALL EVPLUS('SPLUS',IQ0,1,IQC) 
!--DEAL WITH CHARM THRESH                                               
          FACTOR=1./3.-1./4. 
          CALL QADDSI('UPLUS',IQC,FACTOR) 
          CALL QADDSI('DPLUS',IQC,FACTOR) 
          CALL QADDSI('SPLUS',IQC,FACTOR) 
          CALL QNPNUL('CPLUS') 
          FACTOR=-1/4. 
          CALL QADDSI('CPLUS',IQC,FACTOR) 
!--GO UP Q2C TO Q2B                                                     
          CALL EVPLUS('UPLUS',IQC,IQC,IQB) 
          CALL EVPLUS('DPLUS',IQC,IQC,IQB) 
          CALL EVPLUS('SPLUS',IQC,IQC,IQB) 
          CALL EVPLUS('CPLUS',IQC,IQC,IQB) 
                                                                        
        ELSEIF(NACT.EQ.4)THEN 
!--1<1QC<1Q0<1QB<ETC                                                    
!--NOW WE NEED A RETHINK OF THE INITIAL CONDITIONS                      
!--FIRST DEAL WITH CPLUS TRUNING ON AT IQC                              
!--AND GOING UP TO IQB (MIDDLE AGAIN)                                   
          CALL QNPNUL('CPLUS') 
          FACTOR=-1/4. 
          CALL QADDSI('CPLUS',IQC,FACTOR) 
          CALL EVPLUS('CPLUS',IQC,IQC,IQB) 
!--REDIFINE THE PLUS DUSTNS TAKING INTO ACCOUNT CPLUS                   
          CALL QNPNUL('SPLUS') 
          CALL QNPNUL('UPLUS') 
          CALL QNPNUL('DPLUS') 
!--NOW YOU NEED A DO LOOP AGAIN                                         
          DO IX = 1,NXGRI 
          Xx = XFROMIX(IX) 
          UPVAL=UN*FF_LHA(Xx,UA,UB,UE,UC) 
                                                                        
          DNVAL=DN*FF_LHA(Xx,DA,DB,DE,DC) 
          SEA=SN*FF_LHA(Xx,SA,SB,SE,SC) 
          SINGL=UPVAL+DNVAL+SEA 
          UMD=DLN*FF_LHA(Xx,DLA,DLB,DLE,DLC) 
          SSEA=0.2*SEA 
          CSEA=QPDFIJ('CPLUS',IX,IQ0,IFL) + 1./NACT*SINGL 
          USEA=(SEA-SSEA-CSEA)/2.-UMD 
          DSEA=(SEA-SSEA-CSEA)/2.+UMD 
          UPLUS=UPVAL+USEA-1./NACT*SINGL 
          DPLUS=DNVAL+DSEA-1./NACT*SINGL 
          SPLUS=SSEA-1./NACT*SINGL 
          CALL QNPSET('UPLUS',IX,IQ0,UPLUS) 
          CALL QNPSET('DPLUS',IX,IQ0,DPLUS) 
          CALL QNPSET('SPLUS',IX,IQ0,SPLUS) 
          ENDDO 
!-NOW DO MIDDLE FOR UPLUS,DPLUS,SPLUS                                   
          CALL EVPLUS('UPLUS',IQ0,IQC,IQB) 
          CALL EVPLUS('DPLUS',IQ0,IQC,IQB) 
          CALL EVPLUS('SPLUS',IQ0,IQC,IQB) 
!--THEN GO DOWN IQC TO 1                                                
             IF(IQC.GT.1)THEN 
             FACTOR=1./4.-1./3. 
             CALL QADDSI('UPLUS',IQC,FACTOR) 
             CALL QADDSI('DPLUS',IQC,FACTOR) 
             CALL QADDSI('SPLUS',IQC,FACTOR) 
             CALL EVPLUS('UPLUS',IQC,1,IQC) 
             CALL EVPLUS('DPLUS',IQC,1,IQC) 
                                                                        
             CALL EVPLUS('SPLUS',IQC,1,IQC) 
             ENDIF 
                                                                        
        ENDIF 
!--THEN DEAL WITH B THRESHOLD FOR ALL4                                  
        FACTOR=1./4.-1./5. 
        CALL QADDSI('UPLUS',IQB,FACTOR) 
        CALL QADDSI('DPLUS',IQB,FACTOR) 
        CALL QADDSI('SPLUS',IQB,FACTOR) 
        CALL QADDSI('CPLUS',IQB,FACTOR) 
!--THEN GO UP                                                           
        IF(IQB.LT.NQGRI)THEN 
       CALL EVPLUS('UPLUS',IQB,IQB,NQGRI) 
        CALL EVPLUS('DPLUS',IQB,IQB,NQGRI) 
        CALL EVPLUS('SPLUS',IQB,IQB,NQGRI) 
        CALL EVPLUS('CPLUS',IQB,IQB,NQGRI) 
        ENDIF 
!C--THEN DEAL WITH B TURNING ON AT IQB AND GO UP                        
        CALL QNPNUL('BPLUS') 
        FACTOR=-1./5. 
       CALL QADDSI('BPLUS',IQB,FACTOR) 
        CALL EVPLUS('BPLUS',IQB,IQB,NQGRI) 
      ENDIF 
!                                                                       
      call getnset(iset) 
      call save_pdfqcd(iset) 
                                                                        
      return 
!                                                                       
      END                                           
!-----------------------------------------------------------------------
!      DOUBLE PRECISION FUNCTION AREA(A,B,E,C)                          
!-----------------------------------------------------------------------
!                                                                       
!      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
!                                                                       
!      IF (A.LE.-0.99.OR.B.LE.-0.99) THEN                               
!        AREA=1D6                                                       
!        RETURN                                                         
!      ENDIF                                                            
!                                                                       
!      AR1=(DGAMMA_LHA(A+1)*DGAMMA_LHA(B+1))/DGAMMA_LHA(A+B+2)          
!      AR2=E*(DGAMMA_LHA(A+1.5)*DGAMMA_LHA(B+1))/DGAMMA_LHA(A+B+2.5)    
!      AR3=C*(DGAMMA_LHA(A+2)*DGAMMA_LHA(B+1))/DGAMMA_LHA(A+B+3)        
!      AREA=AR1+AR2+AR3                                                 
!                                                                       
!      IF (AREA.LE.1D-6) AREA=1D-6                                      
!                                                                       
!      RETURN                                                           
!      END                                                              
!                                                                       
!-----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FF_LHA(X,A,B,E,C) 
!-----------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
                                                                        
      FF_LHA=X**A*(1D0-X)**B*(1+E*SQRT(X)+C*X) 
                                                                        
      RETURN 
      END                                           

      subroutine HERAGRIDevolve(xin,qin,pdf)
      implicit real*8 (a-h,o-z)
      include 'parmsetup.inc'
      double precision parm(nopmax)
      character*16 name(nmxset)
      integer nmem(nmxset),ndef(nmxset),mmem
      common/NAME/name,nmem,ndef,mmem
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
      CHARACTER*80 LINE
      dimension pdf(-6:6)
      integer init,set,i,j,k,l,nset,iset
      parameter(nhess=35)
      double precision fgrid(0:nhess,161,161,0:7),grid(322)
      double precision agrid(161),alfas,Qalfa
      common/fgridz/fgrid
      double precision up,dn,usea,dsea,str,chm,bot,glu
      double precision heragrid
      double precision qq(5),yntmp(5)
      real*8 mc,mc2,mb,mb2,mt,mt2,mz,mz2,alfa0,scale0
      COMMON/QCCONS/                                                    &
     &PI,PROTON,EUTRON,UCLEON,UDSCBT(6),AAM2H,BBM2H,AAM2L,BBM2L,        &
     &AAAR2,BBBR2,FL_FAC,CBMSTF(4:7),CHARGE(4:7),                       &
     &C1S3,C2S3,C4S3,C5S3,C8S3,C11S3,C14S3,C16S3,C20S3,C22S3,C28S3,     &
     &C38S3,C40S3,C44S3,C52S3,C136S3,C11S6,C2S9,C4S9,C10S9,C14S9,C16S9, &
     &C40S9,C44S9,C62S9,C112S9,C182S9,C11S12,C35S18,C61S12,C215S1,      &
     &C29S12,CPI2S3,CPIA,CPIB,CPIC,CPID,CPIE,CPIF,CCA,CCF,CTF,CATF,CFTF 
      save 
      x=xin
      q2=qin*qin 
      call getnset(iset)
      up =   HERAGRID(x,Q2,grid,1)
      dn =   HERAGRID(x,Q2,grid,2)
      usea = HERAGRID(x,Q2,grid,3)
      dsea = HERAGRID(x,Q2,grid,4)
      if(name(iset)(1:9).eq.'HERAGRID1') then
        up = up + usea
        dn = dn + dsea  
      endif
      str =  HERAGRID(x,Q2,grid,5)
      chm =  HERAGRID(x,Q2,grid,6)
      bot =  HERAGRID(x,Q2,grid,7)
      glu =  HERAGRID(x,Q2,grid,0)
      pdf(-6) = 0.0d0
       pdf(6) = 0.0d0
      pdf(-5) = bot
       pdf(5) = bot
      pdf(-4) = chm
       pdf(4) = chm
      pdf(-3) = str
       pdf(3) = str
      pdf(-2) = usea
       pdf(2) = up
      pdf(-1) = dsea
       pdf(1) = dn
       pdf(0) = glu
      return
!      
      entry HERAGRIDgetgrid(nset,ngridx,ngridq,gridx,gridq)

      ngridx=161
      do jx=1,ngridx
          gridx(jx)=grid(jx)
      enddo
      ngridq=161
      do jq=1,ngridq
          gridq(jq)=grid(jq+161)
      enddo
      return        
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry HERAGRIDread(nset)
!     
      call getnmem(nset,imem) 

      read(1,*)nmem(nset),ndef(nset)
      
      do iq=1,23
         read(1,*) (grid(161+(iq-1)*7+ii),ii=1,7)
      enddo

      do jx=1,23
         read(1,*) (grid((jx-1)*7+ii),ii=1,7)
      enddo

    !read in to alphas grid  
      do iq=1,23
         read(1,*) (agrid((iq-1)*7+ii),ii=1,7)
      enddo
   
      
      do ns=0,nmem(nset)
        do k = 0,7
          do IQ=1,161
            do JX=1,23
	      read(1,*)(fgrid(ns,(jx-1)*7+ii,iq,k),ii=1,7)
            enddo
          enddo
        enddo
      enddo
      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry HERAGRIDalfa(alfas,Qalfa)

       call getnset(iset)
       q2 = Qalfa*Qalfa
       nf=6
       if (Q2.lt.mt2) nf=5
       if (Q2.lt.mb2) nf=4
       if (Q2.lt.mc2) nf=3
       call GetOrderAsM(iset,iord)
       iord=iord+1
       call listPDF(iset,imem,parm)
       alfa0=parm(1)
       alfas=A0TOA1(q2,mz2,alfa0,iord,nf,ierr)      

      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry HERAGRIDinit(Eorder,Q2fit)

      call getnset(iset)
      mz = 91.187d0
      mz2=mz*mz
      call getQmassM(iset,4,mc)
      call getQmassM(iset,5,mb)
      call getQmassM(iset,6,mt)
      mc2=mc*mc
      mb2=mb*mb
      mt2=mt*mt
      UDSCBT(1) = 0.005 
      UDSCBT(2) = 0.01 
      UDSCBT(3) = 0.3 
      UDSCBT(4) = mc 
      UDSCBT(5) = mb 
      UDSCBT(6) = mt 

      return
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      entry HERAGRIDpdf(mem)
      imem = mem
      call getnset(iset)
      call setnmem(iset,imem)
      return
!
 1000 format(5e13.5)
      end
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! attempt at polynomial (order 4) interpolation based on  polint
      double precision function HERAGRID(x,Q2,grid,n)
      implicit real*8(a-h,o-z)
      integer iset,imem,nhess
      parameter(nhess=35)
      double precision grid(322),x,Q2
      double precision fgrid(0:nhess,161,161,0:7)
      double precision ya(5,5),yntmp(5),ymtmp(5)
      common/fgridz/fgrid
      
      npt = 5
      call getnset(iset)
      call getnmem(iset,imem)      
      
! find the x bins around x
      nxlow = -1
      nxhi = 162
      do while (nxhi-nxlow.gt.1)
         nxmid = (nxlow+nxhi)/2
	 if(x.ge.grid(nxmid)) then
	    nxlow = nxmid
	 else 
	    nxhi = nxmid
	 endif
      enddo

! find the q2 bins around q2
      nqlow = -1
      nqhi = 162
      do while (nqhi-nqlow.gt.1)
         nqmid = (nqlow+nqhi)/2
	 if(q2.ge.grid(161+nqmid)) then
	    nqlow = nqmid
	 else 
	    nqhi = nqmid
	 endif
      enddo
      
! fill the temp 4x4 funtion array (allowing for endpoints and extrapolation)
	if(nxlow.le.0) nxlow=1
	if(nxlow.ge.161) nxlow=160
        if(nxlow.eq.1) then
	   nxbot = 1
	elseif(nxlow.eq.2) then
	   nxbot = 2
	else
	   if(nxlow.eq.160) then
	      nxbot = 4
	   else
	      nxbot = 3
	   endif
	endif
	if(nqlow.le.0) nqlow=1
	if(nqlow.ge.161) nqlow=160
        if(nqlow.eq.1) then
	   nqbot = 1
	elseif(nqlow.eq.2) then
	   nqbot = 2
	else
	   if(nqlow.eq.160) then
	      nqbot = 4
	   else   
	      nqbot = 3
	   endif
	endif
	
        do nx=1,5
          do nq=1,5 
	      ya(nx,nq) = fgrid(imem,nxlow+nx-nxbot,nqlow+nq-nqbot,n)
	  enddo   
        enddo      
      
      do j=1,5
        do k=1,5
	  yntmp(k)=ya(j,k)
	enddo
	call herapolint(grid(161+nqlow-nqbot+1),yntmp,npt,q2,ymtmp(j),dy)
      enddo 
      call herapolint(grid(nxlow-nxbot+1),ymtmp,npt,x,y,dy)
      
      heragrid=y
      
      return
      end     
!=========================================================
         SUBROUTINE HERAPOLINT (XA,YA,N,X,Y,DY)

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
!                                        Adapted from "Numerical Recipes"
      PARAMETER (NMAX=10)
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)
      NS=1
      DIF=ABS(X-XA(1))
      DO 11 I=1,N
        DIFT=ABS(X-XA(I))
        IF (DIFT.LT.DIF) THEN
          NS=I
          DIF=DIFT
        ENDIF
        C(I)=YA(I)
        D(I)=YA(I)
11    CONTINUE
      Y=YA(NS)
      NS=NS-1
      DO 13 M=1,N-1
        DO 12 I=1,N-M
          HO=XA(I)-X
          HP=XA(I+M)-X
          W=C(I+1)-D(I)
          DEN=HO-HP
          IF(DEN.EQ.0.) RETURN
          DEN=W/DEN
          D(I)=HP*DEN
          C(I)=HO*DEN
12      CONTINUE
        IF (2*NS.LT.N-M)THEN
          DY=C(NS+1)
        ELSE
          DY=D(NS)
          NS=NS-1
        ENDIF
        Y=Y+DY
13    CONTINUE
      RETURN
      END
!=========================================================

program example4
  ! Using LHAglue to do example 1.
  implicit double precision (a-h,o-z)
  character*20 parm(20)
  double precision value(20)

  parm(1)='DEFAULT'
  call SetLHAPARM('SILENT')
  val = 10800
  do i=0,40
     value(1)=val+i
     write(*,*) '---------------------------------------------'
     call pdfset(parm,value)
     if (i.eq.0) call getdesc()
     qmz = 91.18d0
     a = alphasPDF(qmz)
     print *,'Alpha_s(Mz)=',a
     write(*,*) 'x*up'
     write(*,*) '   x     Q2=10 GeV     Q=100 GeV    Q=1000 GeV'
     do ix=10,95,10
        x = dfloat(ix)*1.0d-03
        Q=10.0d0
        call structm(x,q,upv,dnv,usea,dsea,str,chm,bot,top,glu)
        g1=upv+usea
        Q=100d0
        call structm(x,q,upv,dnv,usea,dsea,str,chm,bot,top,glu)
        g2=upv+usea
        Q=1000d0
        call structm(x,q,upv,dnv,usea,dsea,str,chm,bot,top,glu)
        g3=upv+usea
        write(*,*) x,g1,g2,g3
     enddo
  enddo

end program example4

!***********************************************                        
!                                                                       
!                                                                       
!     wrapNNPDF20qedgrid.f                                                   
!     Routine called by LHAPDF package for calculating                  
!     the value of all xpdfs at x and Q from replica KREP               
!     in a (x,Q) point as called by NNPDF.LHgrid file.                  
!                                                                       
!     In 'wrapevolve.f' the package calls:                              
!   IF(NAME(NSET).EQ.'NNPDF20intqed') call NNPDFINT20qedevolve(x,Q,f)           
!   IF(NAME(NSET).EQ.'NNPDF20intqed') call NNPDFINT20qedread(nset)              
!   IF(NAME(NSET).EQ.'NNPDF20intqed') call NNPDFINT20qedalfa(alfas,Q)           
!   IF(NAME(NSET).EQ.'NNPDF20intqed') call NNPDFINT20qedinit(nset,Eorder,Q2fit)
!                                                                       
!***********************************************                                                                                                
                                                                      
      subroutine NNPDFINT20qedevolve(XIN,QIN,XPDF,XPHOTON) 
      IMPLICIT none 
!                                                                       
      include 'parmsetup.inc' 
      character*16 name(nmxset) 
      integer nmem(nmxset),ndef(nmxset),mmem 
      common/NAME/name,nmem,ndef,mmem 
      integer nset,iset,pdfmem 
      real*8 parm(nopmax) 
!                                                                       
      double precision gridx(nmxgridx),gridq(nmxgridq)
      integer ngridx,ngridq,jx,jq
!
      INTEGER order 
      REAL*8 alfas,alphaNNPDF
      REAL*8 Eorder,Q2fit,mass 
!                                                                       
      INTEGER MXREP 
      PARAMETER(MXREP=1e2) 
      INTEGER NREP 
      common/nnpdf20CNREP/NREP 
!                                                                       
      INTEGER NX,NXMAX,NQ2,NPL 
      PARAMETER(NX=100,NXMAX=100,NQ2=50) 
      PARAMETER(NPL=5000) 
      INTEGER NXX,NQQ2 
      REAL*8 Q2MIN,Q2MAX,XPDFMIN,XPDFMAX 
      REAL*8 XG(NXMAX,nmxset),Q2G(NQ2,nmxset),XPDFEV(NXMAX,NQ2,-6:7,0:MXREP) 
      INTEGER IX,IQ2 
!     This common different from NNPDF1.X
!      common/nnpdf20CPDFGR/XPDFEV,XG,Q2G,IX,IQ2 
      common/nnpdfallCPDFGR/XPDFEV,XG,Q2G,IX,IQ2 
!     
      INTEGER ipt,imodev,ivfn,itmc 
!     This common is the same as for NNPDF1.0
      COMMON/nnpdf10EVFLAGS/ipt,imodev,ivfn,itmc 
      REAL*8 q0,alfas0 
      REAL*8 q20,qth(4:6)
!     This common is the same as for NNPDF1.0
      COMMON/nnpdf10EVSCALE/q20,q2 
      REAL*8 q2th(4:6),asref,q2ref 
!     This common is the same as for NNPDF1.0
      COMMON/nnpdf10vfns/q2th,asref,q2ref 
!                                                                       
      INTEGER I,J,K 
      INTEGER IPDF,KREP
      INTEGER IDUM,JDUM 
      REAL*8 X,XIN,Q,QIN,QAS,QQ,Q2,QQ2,XPDF(-6:6),XPHOTON
      REAL*8 XCH 
      PARAMETER(XCH=1D-1) 
!                                                                       
      integer m,n,nmax,mmax,minq,maxq,midq,maxx,minx,midx
!     order of pol. interpolation           
      parameter(m=4,n=2) 
      parameter(nmax=1e3,mmax=1e3) 
      double precision dy,x1,x2,y,x1a(mmax),x2a(nmax),ya(mmax,nmax) 
      integer ix1a(m),ix2a(n)
      integer offset

      double precision XPDFMIN_INTER
      parameter(XPDFMIN_INTER=1d-7)
!                                                                       
      KREP = mmem 
      X=XIN
      Q=QIN
                                                                        
!     Set correct scale                                                 
      Q2=Q**2d0 
                    
      call getnset(iset)
      offset = 101*(iset-1)
                                                                        
!     Check kinematic point is within allowed range                     
                                                                        
      call GetXminM(iset,KREP,XPDFMIN) 
      call GetXmaxM(iset,KREP,XPDFMAX) 
      call GetQ2maxM(iset,KREP,Q2MAX) 
      call GetQ2minM(iset,KREP,Q2MIN) 
!                                                                       
      IF ( X.LT.XPDFMIN_INTER .OR. X.GT.XPDFMAX ) THEN 
         WRITE(6,2000) 
 2000    FORMAT (2X,'PARTON INTERPOLATION: X OUT OF RANGE -- STOP') 
         IF ( X.LT.XPDFMIN_INTER ) X = XPDFMIN_INTER
         IF ( X.GT.XPDFMAX ) X = XPDFMAX
         write(6,*) "X= ",X," XMAX, XMIN = ",XPDFMAX,XPDFMIN 
      ENDIF 
!                                                                       
      IF ( Q2.LT.Q2MIN .OR. Q2.GT.Q2MAX ) THEN 
         WRITE(6,2001) 
 2001    FORMAT (2X,'PARTON INTERPOLATION: Q2 OUT OF RANGE -- STOP') 
         write(6,*) "Q2 ,Q2MIN, Q2MAX = ",Q2,Q2MIN,Q2MAX 
         if( Q2.LT.Q2MIN ) Q2 = Q2MIN
         if( Q2.GT.Q2MAX ) Q2 = Q2MAX
      ENDIF 

!     FIND NEAREST POINTS IN THE GRID        
      MINX = 1
      MAXX = NX+1
 10   CONTINUE
      MIDX = (MINX+MAXX)/2
      IF(X.LT.XG(MIDX,iset)) THEN
         MAXX=MIDX
      ELSE
         MINX=MIDX
      END IF
      IF((MAXX-MINX).GT.1) GO TO 10
      IX = MINX

      MINQ = 1
      MAXQ = NQ2+1
 20   CONTINUE
      MIDQ = (MINQ+MAXQ)/2
      IF(Q2.LT.Q2G(MIDQ,iset)) THEN
         MAXQ=MIDQ
      ELSE
         MINQ=MIDQ
      END IF
      IF((MAXQ-MINQ).GT.1) GO TO 20
      IQ2 = MINQ

!
!     POLYNOMIAL INTERPOLATION
!        
!     uncomment for 3rd order interp.                                                                        
!     IF((IX+(M-1)/2).GT.NX) IX = NX - (M-1)/2                      
!     IF((IX-(M-1)/2).LT.1) IX = (M+1)/2                            
!     IDUM = 0                                                      
!     DO I = -(M-1)/2,(M-1)/2,1                                     
!     IDUM = IDUM +1                                             
!     IX1A(IDUM) = IX + I                                        
!     ENDDO                                                         
!     IF((IQ2+(N-1)/2).GT.NQ2) IQ2 = NQ2 - (N-1)/2                  
!     IF((IQ2-(N-1)/2).LT.1) IQ2 = (N+1)/2                          
!     JDUM = 0                                                      
!     DO J = -(N-1)/2,(N-1)/2,1                                     
!     JDUM = JDUM +1                                             
!     IX2A(JDUM) = IQ2 + J                                       
!     ENDDO                                                         

!     Assign grid for interpolation. M, N -> order of polyN interpolation      
      do I=1,M
         if(IX.ge.M/2.and.IX.le.(NX-M/2)) IX1A(I) = IX - M/2 + I
         if(IX.lt.M/2) IX1A(I) = I
         if(IX.gt.(NX-M/2)) IX1A(I) = (NX - M) + I
         
!     Check grids
         if(IX1A(I).le.0.or.IX1A(I).gt.NX) then
            write(6,*) "Error in grids! "
            write(6,*) "I, IXIA(I) = ",I, IX1A(I)
            call exit(-10)
         endif
      enddo

      do J=1,N
         if(IQ2.ge.N/2.and.IQ2.le.(NQ2-N/2)) IX2A(J) = IQ2 - N/2 + J
         if(IQ2.lt.N/2) IX2A(J) = J
         if(IQ2.gt.(NQ2-N/2)) IX2A(J) = (NQ2 - N) + J
!     Check grids
         if(IX2A(J).le.0.or.IX2A(J).gt.NQ2) then
            write(6,*) "Error in grids! "
            write(6,*) "J, IXIA(J) = ",J,IX2A(J)
            call exit(-10)
         endif
      enddo
            
!     Define points where to evaluate interpolation
!     Choose between linear or logarithmic (x,Q2) interpolation

      IF(X.LT.XCH)THEN
         X1=dlog(X)          
      ELSE
         X1=X
      ENDIF
      X2=dlog(Q2)
      
      DO IPDF = -6,7,1
         
!     Choose between linear or logarithmic (x,Q2) interpolation
         
         DO I=1,M
            IF(X.LT.XCH)THEN
               X1A(I)= dlog(XG(IX1A(I),iset))
            ELSE
               X1A(I)= XG(IX1A(I),iset)
            ENDIF
            DO J=1,N
               X2A(J) = dlog(Q2G(IX2A(J),iset))
               YA(I,J) = XPDFEV(IX1A(I),IX2A(J),IPDF,KREP+offset)
            enddo
         enddo
         
!     2D polynomial interpolation
         call lh_polin2(x1a,x2a,ya,m,n,x1,x2,y,dy)

         IF(IPDF.NE.7)THEN
            XPDF(IPDF) = y
         ELSE            
            XPHOTON = y
         ENDIF

      enddo                 

      RETURN
                                                                        
!********************************************************               
                                                                        
!********************************************************               
      entry NNPDFINT20qedgetgrid(nset,ngridx,ngridq,gridx,gridq)
      do jx=1,nx
          gridx(jx)=xg(jx,nset)
      enddo
      do jq=1,nq2
          gridq(jq)=q2g(jq,nset)
      enddo
      ngridx=nx
      ngridq=nq2        
      return
!********************************************************               

                                                                        
      ENTRY NNPDFINT20qedread(nset) 
!                                                                       
      READ(1,*)nmem(nset),ndef(nset) 
                                                                        
!     Set number of members                                             
      call setnmem(nset,nmem) 
                                                                        
!     Read the grid in x                                                
      READ(1,*) nxx 
      IF(NXX.NE.NX)WRITE(*,*)"WARNING CHANGE NX ACCORDING TO .LHgrid"
      DO ix = 1,nxx 
         READ(1,*) xg(ix,nset) 
      ENDDO 
                                                                        
!     Read the grid in Q2                                               
      READ(1,*) nqq2 
      IF(NQQ2.NE.NQ2)WRITE(*,*)"WARNING CHANGE NQ2 ACCORDING TO .LHgrid"
      READ(1,*) q2min 
      DO iq2 = 1,nqq2 
         READ(1,*) q2g(iq2,nset) 
      ENDDO 
                                                                        
!     Read the number of replicas                                       
      READ(1,*) NREP 
                                                                        
!     Read the evolved xpdf grid for each replica                       
      offset = 101*(nset-1)
      DO K=0,NREP 
         DO IX=1,NX 
            DO IQ2=1,NQ2 
               READ(1,*) ( xpdfev(ix,iq2,ipdf,k+offset), ipdf=-6,7,1 )
            ENDDO 
         ENDDO 
      ENDDO 
!                                                                       
      RETURN 
                                                                        
!********************************************************               
                                                                        
      ENTRY NNPDFINT20qedalfa(alfas,QAS) 
!                                                                       
      QQ = QAS 
      alfas =  alphaNNPDF(QQ) 
!                                                                       
      RETURN 
                                                                        
!********************************************************               
                                                                        
      ENTRY NNPDFINT20qedinit(nset,Eorder,Q2fit) 
!                                                                       
      IMODEV = 0 
      IVFN = 1 
      ITMC = 1 
!                                                                       
      CALL GetOrderPDFM(nset,order) 
      IPT = order 
!                                                                       
      CALL GetQ2fitM(nset,QQ2) 
      Q2fit = QQ2 
      Q20   = QQ2 
!                                                                       
      call GetQmassM(nset,4,mass) 
      QTH(4) = mass 
      call GetQmassM(nset,5,mass) 
      QTH(5) = mass 
      call GetQmassM(nset,6,mass) 
      QTH(6) = mass 
!                                                                       
      DO i = 4,6 
         q2th(i) = qth(i)**2d0 
      ENDDO 
!                                                                       
                                    ! added for filling Fparm->asref    
      call initEVOLVEpdf(nset,mmem) 
      CALL GetAlfas(nset,alfas0,Q0) 
      asref = alfas0 
      q2ref = q0**2d0 
!                                                                       
      RETURN 
                                                                        
!********************************************************               
!                                                                       
      entry NNPDFINT20qedpdf(nset) 
      pdfmem = nset 
      IF (pdfmem.LT.0) THEN 
         WRITE(*,*) 'NNPDF set:' 
         WRITE(*,*) 'PDF member out of range:' 
         WRITE(*,*) 'member = ',pdfmem 
         STOP 
      ENDIF 
      RETURN                                                                        
!
      END                                           
                                                                        

!     THE ROUTINES FOR THE POLYNOMIAL INTERPOLATION ARE INSIDE
!     THE wrapNNPDFgrid.f ROUTINE

! -*- F90 -*-


      subroutine QCDNUMevolve(x,Q,pdf) 
      implicit none 
      character*64 gridname 
      character*16 s1,dummy 
      integer Eorder,index 
      real*8 x,Q,Qlam,Q2,Q2fit,alfas0,scale0,alfas 
      real*8 mc,mc2,mb,mb2,mt,mt2,tc,tc2,tb,tb2 
      real*8 singlet,dm,um,dp,up,sp,ub,db,sb,cb,bb,bp,cp,gl,xx 
      real*8 QALFAS,QPDFXQ,XFROMIX 
      real*8 f(-6:6),pdf(-6:6) 
      integer iq0,iqc,iqb,nf,nf0,qnerr,NFLGET,iflag,ix,i,IQFROMQ 
      integer nx,nq 
      integer nset,iset,isetlast 
      data isetlast/-1/ 
      real*8 xmin,xmax,qmin,qmax,S 
      save iq0,iqc,iqb,nf0,mc2,mb2,tc2,tb2,mt2 
      save nx,xmin,xmax,nq,qmin,qmax,gridname,isetlast 
!                                                                       
      call getnset(iset) 
! fix 14.7.2006 to speed up sue of QCDNUM                               
      if(iset.ne.isetlast) then 
        call get_pdfqcd(iset) 
        isetlast = iset 
      endif 
!                                                                       
      Q2=Q*Q 
      nf=5 
      if (Q2.lt.tb2) nf=4 
      if (Q2.lt.tc2) nf=3 
      pdf(0)=QPDFXQ('GLUON'  ,x,Q2,iflag) 
      singlet=QPDFXQ('SINGLET',x,Q2,iflag) 
      dm= QPDFXQ('DM',x,Q2,IFLAG) 
      um= QPDFXQ('UM',x,Q2,IFLAG) 
      dp= QPDFXQ('DP',x,Q2,IFLAG) 
      up= QPDFXQ('UP',x,Q2,IFLAG) 
      sp= QPDFXQ('SP',x,Q2,IFLAG) 
      ub=0.5d0*(up-um+singlet/dble(nf)) 
      db=0.5d0*(dp-dm+singlet/dble(nf)) 
      sb=0.5d0*(sp+singlet/dble(nf)) 
      cb=0.d0 
      if (nf.ge.4) then 
         cp= QPDFXQ('CP',X,Q2,IFLAG) 
         cb=0.5d0*(cp+singlet/dble(nf)) 
      end if 
      bb=0.d0 
      if (nf.ge.5) then 
         bp= QPDFXQ('BP',X,Q2,IFLAG) 
         bb=0.5d0*(bp+singlet/dble(nf)) 
      end if 
                                                                        
      pdf(1)=dm+db 
      pdf(2)=um+ub 
      pdf(3)=sb 
      pdf(4)=cb 
      pdf(5)=bb 
      pdf(6)=0d0 
      pdf(-1)=db 
      pdf(-2)=ub 
      pdf(-3)=sb 
      pdf(-4)=cb 
      pdf(-5)=bb 
      pdf(-6)=0d0 
      return 
!                                                                       
      entry QCDNUMalfa(alfas,Q) 
      Q2=Q*Q 
      nf=6 
      if (Q2.lt.mt2) nf=5 
      if (Q2.lt.mb2) nf=4 
      if (Q2.lt.mc2) nf=3 
      alfas=QALFAS(Q2,Qlam,nf,iflag) 
      return 
!                                                                       
      entry QCDNUMread(nset) 
!      read(1,*) s1                                                     
!      print *,s1                                                       
!         gridname='large.grid'                                         
!         nx=400                                                        
!         xmin=1d-6                                                     
!         xmax=1d0                                                      
!         nq=112                                                        
!         qmin=1d0                                                      
!         qmax=1d10                                                     
!         read(1,*) dummy                                               
!      else                                                             
         read(1,*) gridname,nx,xmin,xmax,nq,qmin,qmax 
!*      endif                                                           
!      iset = nset                                                      
      return 
!                                                                       
      entry QCDNUMinit(nset,Eorder,Q2fit) 
      call qninit 
      call QNISET('ORDER',Eorder+1) 
      call grxdef(nx,xmin) 
      call grqdef(nq,qmin,qmax) 
      call grqinp(Q2fit,1) 
      call getQMassM(nset,4,mc) 
      mc2=mc*mc 
      CALL QNRSET('CMASS',mc) 
      CALL QNRSET('MCALF',mc) 
      call getThresholdM(nset,4,tc) 
      tc2=tc*tc 
      call GRQINP(tc2,1) 
      CALL GRQINP(tc2-1.0d-4,1) 
      call getQMassM(nset,5,mb) 
      mb2=mb*mb 
      CALL QNRSET('BMASS',mb) 
      CALL QNRSET('MBALF',mb) 
      call getThresholdM(nset,5,tb) 
      tb2=tb*tb 
      call GRQINP(tb2,1) 
      CALL GRQINP(tb2-1.0d-4,1) 
      call getQMassM(nset,6,mt) 
      mt2=mt*mt 
      CALL QNRSET('TMASS',mt) 
      CALL QNRSET('MTALF',mt) 
      call qthres(tc2,tb2) 
      iq0=IQFROMQ(Q2fit) 
      iqc=IQFROMQ(tc2) 
      iqb=IQFROMQ(tb2) 
      nf0= NFLGET(iq0) 
!      print *,nf0                                                      
      CALL QNBOOK(2,'dm') 
      CALL QNBOOK(3,'um') 
      CALL QNBOOK(4,'dp') 
      CALL QNBOOK(5,'up') 
      CALL QNBOOK(6,'sp') 
      CALL QNBOOK(7,'cp') 
      CALL QNBOOK(8,'bp') 
      CALL QNLSET('W1ANA',.TRUE.) 
      CALL QNLSET('W2NUM',.TRUE.) 
      CALL QNLSET('W2STF',.FALSE.) 
      if (index(gridname,'none').eq.1) then 
         call qnfilw(0,0) 
      else 
         qnerr=-1 
         open(unit=2,status='old',file=gridname,                        &
     &        form='unformatted',err=1)                                 
         call QNREAD(2,1,qnerr) 
    1    close(2) 
         if (qnerr.ne.0) then 
            write(*,*) 'Grid file problem: ',gridname 
            if (qnerr.lt.0) then 
               write(*,*) 'Grid file does not exist' 
               write(*,*) 'Calculating and creating grid file' 
               call qnfilw(0,0) 
               open(unit=2,status='unknown',file=gridname,              &
     &              form='unformatted')                                 
               call QNDUMP(2) 
               close(2) 
            else 
               write(*,*) 'Existing grid file is inconsistent' 
               if (qnerr.eq.1)                                          &
     &              write(*,*) 'Defined grid different'                 
               if (qnerr.eq.2)                                          &
     &              write(*,*) 'Heavy quark weight table different'     
               if (qnerr.eq.3)                                          &
     &              write(*,*) 'Charm mass different'                   
               if (qnerr.eq.4)                                          &
     &              write(*,*) 'Bottom mass different'                  
               stop 
            endif 
         endif 
      endif 
      return 
!                                                                       
      entry QCDNUMpdf(nset) 
!      print *,'entering QCDNUMpdf',nset                                
      call GetAlfas(nset,alfas0,scale0) 
!      print *,alfas0,scale0                                            
      Q2=scale0*scale0 
      CALL QNRSET('ALFAS',alfas0) 
      CALL QNRSET('ALFQ0',Q2) 
      DO ix = 1,nx 
         xx = XFROMIX(ix) 
!         print *,'calling parmPDF',ix                                  
         call parmPDF(nset,xx,f) 
!         if(ix.lt.6) print *,nset,xx,f                                 
         singlet=0.d0 
         do i=1,nf0 
            singlet=singlet+f(i)+f(-i) 
!            print  *,i,singlet                                         
         end do 
         gl=f(0) 
         dm=f(1)-f(-1) 
         um=f(2)-f(-2) 
         dp=f(1)+f(-1)-singlet/dble(nf0) 
         up=f(2)+f(-2)-singlet/dble(nf0) 
         sp=f(3)+f(-3)-singlet/dble(nf0) 
!      print *,'calling qpnset sg...',ix,iq0,singlet                    
         CALL QNPSET('SINGLET',ix,iq0,singlet) 
!      print *,'calling qpnset gl...',ix,iq0,gl                         
         CALL QNPSET('GLUON',ix,iq0,gl) 
!      print *,'calling qpnset dm...',ix,iq0,dm                         
         CALL QNPSET('DM',ix,iq0,DM) 
!      print *,'calling qpnset um...',ix,iq0,um                         
         CALL QNPSET('UM',ix,iq0,UM) 
!      print *,'calling qpnset dp...',ix,iq0,dp                         
         CALL QNPSET('DP',ix,iq0,DP) 
!      print *,'calling qpnset up...',ix,iq0,up                         
         CALL QNPSET('UP',ix,iq0,UP) 
!      print *,'calling qpnset sp...',ix,iq0,sp                         
         CALL QNPSET('SP',ix,iq0,SP) 
      ENDDO 
!      print *,'calling evols...'                                       
      CALL EVOLSG(iq0,1,nq) 
!      print *,'calling evols dm...'                                    
      CALL EVOLNM('DM',iq0,1,nq) 
!      print *,'calling evols um...'                                    
      CALL EVOLNM('UM',iq0,1,nq) 
!      print *,'calling evols dp...',iq0,iqc,iqb,nq                     
      CALL EVLSEA('dp',iq0,iqc,iqb,nq) 
!      print *,'calling evols up...'                                    
      CALL EVLSEA('up',iq0,iqc,iqb,nq) 
!      print *,'calling evols sp...'                                    
      CALL EVLSEA('sp',iq0,iqc,iqb,nq) 
                                                                        
!      print *,'calling evols - heavy...'                               
                                                                        
!--   Heavy quark evolution                                             
                                                                        
      CALL EVOLCP('cp',iqc,iqb,nq) 
      CALL EVOLBP('bp',iqb,nq) 
!                                                                       
      call getnset(iset) 
      call save_pdfqcd(iset) 
      return 
!                                                                       
      END                                           
      subroutine EVLSEA(name,IQ0,IQC,IQB,NQGRI) 
      implicit none 
                                                                        
      CHARACTER*(*) name 
      integer iq0,iqc,iqb,nqgri 
      real*8 f34,f45,f43,f54,factor 
      parameter(f34=1.d0/12.d0,f45=1.d0/20.d0,f43=-1.d0/12.d0,          &
     &          f54=-1.d0/20.d0)                                        
                                                                        
                                                                        
      If(IQ0.le.IQC)then 
         CAll EVPLUS(name,IQ0,1,IQC) 
         CALL QADDSI(name,IQC,f34) 
         CAll EVPLUS(name,IQC,IQC,IQB) 
         CALL QADDSI(name,IQB,f45) 
         CAll EVPLUS(name,IQB,IQB,NQGRI) 
      else if(IQ0.gt.IQC.and.IQ0.le.IQB)then 
         CAll EVPLUS(name,IQ0,IQC,IQB) 
         CALL QADDSI(name,IQC,f43) 
         CAll EVPLUS(name,IQC,1,IQC) 
         CALL QADDSI(name,IQC,f34) 
         CALL QADDSI(name,IQB,f45) 
         CAll EVPLUS(name,IQB,IQB,NQGRI) 
      else if(IQ0.gt.IQB)then 
         CAll EVPLUS(name,IQ0,IQB,NQGRI) 
         CALL QADDSI(name,IQB,f54) 
         CAll EVPLUS(name,IQB,IQC,IQB) 
         CALL QADDSI(name,IQB,f45) 
         CALL QADDSI(name,IQC,f43) 
         CAll EVPLUS(name,IQC,1,IQC) 
         CALL QADDSI(name,IQC,f34) 
      end if 
                                                                        
      END                                           
                                                                        
                                                                        
      subroutine EVOLCP(name,IQC,IQB,NQGRI) 
      implicit none 
                                                                        
      CHARACTER*(*) name 
      integer iq0,iqc,iqb,nqgri 
      real*8 f4,f45 
      parameter(f4=-1.d0/4.d0,f45=1.d0/20.d0) 
                                                                        
!                                                                       
!     First set to zero to avoid adding -1/4Singl at each iteration     
!                                                                       
                                                                        
      CAll QNPNUL(name) 
      CALL QADDSI(name,IQC,f4) 
      CAll EVPLUS(name,IQC,IQC,IQB) 
      CALL QADDSI(name,IQB,f45) 
      CAll EVPLUS(name,IQB,IQB,NQGRI) 
                                                                        
      END                                           
                                                                        
      subroutine EVOLBP(name,IQB,NQGRI) 
      implicit none 
                                                                        
      CHARACTER*(*) name 
      integer iqb,nqgri 
      real*8 f5 
      parameter(f5=-1.d0/5.d0) 
                                                                        
!                                                                       
!     First set to zero to avoid adding -1/5Singl at each iteration     
!                                                                       
                                                                        
      CAll QNPNUL(name) 
      CALL QADDSI(name,IQB,f5) 
      CAll EVPLUS(name,IQB,IQB,NQGRI) 
                                                                        
      END                                           
!                                                                       
! routine to swap in/out the array PDFQCD(MXX,MQ2,0:10) in QCDNUM as req
! by nset                                                               
!                                                                       
      subroutine get_pdfqcd(nset) 
!                                                                       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
!                                                                       
      include 'parmsetup.inc' 
!                                                                       
#ifndef HERA                                                                        
      PARAMETER ( MXX = 410 ) 
      PARAMETER ( MQ2 = 120 )
#else
      PARAMETER ( MXX = 410 ) 
      PARAMETER ( MQ2 = 205 )
#endif       
!--   Do not set the following parameter to zero!                       
      PARAMETER ( NDFMAX = 20) 
!                                                                       
      COMMON/QCPASS/                                                    &
     &ALPHA0, Q0ALFA, ASLAST, QALAST,                                   &
     &ALFASQ(MQ2), ALFAPQ(MQ2), ALFA2Q(MQ2),                            &
     &DELUP(MQ2), DELDN(MQ2), PDFQCD(MXX,MQ2,0:10),                     &
     &FNSQCD(MXX,MQ2),DNSQCD(MXX,MQ2),                                  &
     &FSIQCD(MXX,MQ2),DSIQCD(MXX,MQ2),                                  &
     &FGLQCD(MXX,MQ2),DGGQCD(MXX,MQ2),                                  &
     &FSTORE(MXX,MQ2,31:30+NDFMAX),IDFAST(7,30),NDFAST,                 &
     &MARKFF(MXX,MQ2),MARKFH(MXX,MQ2),MARKQQ(MQ2),                      &
     &ISTFID(31:30+NDFMAX),IPDFID(31:30+NDFMAX),IEALFA(MQ2),            &
     &IQL_LAST(10),IQ0_LAST(10),IQH_LAST(10)                            
!                                                                       
      real*8  PDFSAV(MXX,MQ2,0:10,nmxset) 
      save PDFSAV 
!                                                                       
      do k=0,10 
        do j=1,mq2 
          do i=1,mxx 
             PDFQCD(i,j,k)=PDFSAV(i,j,k,nset) 
          enddo 
        enddo 
      enddo 
!                                                                       
      return 
!                                                                       
      entry save_pdfqcd(nset) 
!                                                                       
      do k=0,10 
        do j=1,mq2 
          do i=1,mxx 
             PDFSAV(i,j,k,nset)=PDFQCD(i,j,k) 
          enddo 
        enddo 
      enddo 
!                                                                       
      return 
      END                                           

! -*- F90 -*-


subroutine descriptionPDF(nset,id)
  implicit none
  include 'parmsetup.inc'
  integer nset
  integer id,token,l,nline
  character*64 string
  character*64 desc(nmxset,linemax)
  integer lhasilent
  common/lhasilent/lhasilent
  save nline,desc

  l=0
  if (lhasilent.eq.0) then
     write(*,*) '>>>>>> PDF description: <<<<<<'
  endif
1 read(1,*) string
  id=token(string)
  if (id.eq.0) then
     if(lhasilent.eq.0) then
        write(*,*) string
     endif
     l=l+1
     if (l.gt.linemax) then
        write(*,*) 'Too many lines in PDF description to store.'
        write(*,*) 'Increase linemax variable in parmsetup.inc'
        write(*,*) 'Ignoring additional description lines'
        l=linemax
     else
        desc(nset,l)=string
        goto 1
     endif
  endif
  nline=l
  if (lhasilent.eq.0) then
     write(*,*)'>>>>>>                   <<<<<<'
     write(*,*)
  endif
  return
  
  entry GetDescM(nset)
  do l=1,nline
     write(*,*) desc(nset,l)
  enddo
  return
      
end subroutine descriptionPDF

     
subroutine GetDesc()
  implicit none
  integer nset
  nset = 1
  call GetDescM(nset)
  return
end subroutine GetDesc
